/* ExternalWindow.c generated by valac 0.56.14, the Vala compiler
 * generated from ExternalWindow.vala, do not modify */

/*-
 * Copyright 2021 elementary LLC <https://elementary.io>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor
 * Boston, MA 02110-1335 USA.
 *
 * Authored by: David Hewitt <davidmhewitt@gmail.com>
 */

#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <errno.h>
#include <gdk/gdkx.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#include <X11/Xregion.h>
#include <gdk/gdkwayland.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_EXTERNAL_WINDOW (external_window_get_type ())
#define EXTERNAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXTERNAL_WINDOW, ExternalWindow))
#define IS_EXTERNAL_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXTERNAL_WINDOW))
#define EXTERNAL_WINDOW_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_EXTERNAL_WINDOW, ExternalWindowIface))

typedef struct _ExternalWindow ExternalWindow;
typedef struct _ExternalWindowIface ExternalWindowIface;

#define TYPE_EXTERNAL_WINDOW_X11 (external_window_x11_get_type ())
#define EXTERNAL_WINDOW_X11(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXTERNAL_WINDOW_X11, ExternalWindowX11))
#define EXTERNAL_WINDOW_X11_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXTERNAL_WINDOW_X11, ExternalWindowX11Class))
#define IS_EXTERNAL_WINDOW_X11(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXTERNAL_WINDOW_X11))
#define IS_EXTERNAL_WINDOW_X11_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXTERNAL_WINDOW_X11))
#define EXTERNAL_WINDOW_X11_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXTERNAL_WINDOW_X11, ExternalWindowX11Class))

typedef struct _ExternalWindowX11 ExternalWindowX11;
typedef struct _ExternalWindowX11Class ExternalWindowX11Class;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_EXTERNAL_WINDOW_WAYLAND (external_window_wayland_get_type ())
#define EXTERNAL_WINDOW_WAYLAND(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_EXTERNAL_WINDOW_WAYLAND, ExternalWindowWayland))
#define EXTERNAL_WINDOW_WAYLAND_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_EXTERNAL_WINDOW_WAYLAND, ExternalWindowWaylandClass))
#define IS_EXTERNAL_WINDOW_WAYLAND(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_EXTERNAL_WINDOW_WAYLAND))
#define IS_EXTERNAL_WINDOW_WAYLAND_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_EXTERNAL_WINDOW_WAYLAND))
#define EXTERNAL_WINDOW_WAYLAND_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_EXTERNAL_WINDOW_WAYLAND, ExternalWindowWaylandClass))

typedef struct _ExternalWindowWayland ExternalWindowWayland;
typedef struct _ExternalWindowWaylandClass ExternalWindowWaylandClass;
typedef struct _ExternalWindowX11Private ExternalWindowX11Private;
enum  {
	EXTERNAL_WINDOW_X11_0_PROPERTY,
	EXTERNAL_WINDOW_X11_NUM_PROPERTIES
};
static GParamSpec* external_window_x11_properties[EXTERNAL_WINDOW_X11_NUM_PROPERTIES];
typedef struct _ExternalWindowWaylandPrivate ExternalWindowWaylandPrivate;
enum  {
	EXTERNAL_WINDOW_WAYLAND_0_PROPERTY,
	EXTERNAL_WINDOW_WAYLAND_NUM_PROPERTIES
};
static GParamSpec* external_window_wayland_properties[EXTERNAL_WINDOW_WAYLAND_NUM_PROPERTIES];

struct _ExternalWindowIface {
	GTypeInterface parent_iface;
	void (*set_parent_of) (ExternalWindow* self, GdkWindow* child_window);
};

struct _ExternalWindowX11 {
	GObject parent_instance;
	ExternalWindowX11Private * priv;
};

struct _ExternalWindowX11Class {
	GObjectClass parent_class;
};

struct _ExternalWindowX11Private {
	GdkWindow* foreign_gdk_window;
};

struct _ExternalWindowWayland {
	GObject parent_instance;
	ExternalWindowWaylandPrivate * priv;
};

struct _ExternalWindowWaylandClass {
	GObjectClass parent_class;
};

struct _ExternalWindowWaylandPrivate {
	gchar* handle;
};

static gint ExternalWindowX11_private_offset;
static gpointer external_window_x11_parent_class = NULL;
static GdkDisplay* external_window_x11_x11_display;
static GdkDisplay* external_window_x11_x11_display = NULL;
static ExternalWindowIface * external_window_x11_external_window_parent_iface = NULL;
static gint ExternalWindowWayland_private_offset;
static gpointer external_window_wayland_parent_class = NULL;
static GdkDisplay* external_window_wayland_wayland_display;
static GdkDisplay* external_window_wayland_wayland_display = NULL;
static ExternalWindowIface * external_window_wayland_external_window_parent_iface = NULL;

VALA_EXTERN GType external_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ExternalWindow, g_object_unref)
VALA_EXTERN void external_window_set_parent_of (ExternalWindow* self,
                                    GdkWindow* child_window);
VALA_EXTERN ExternalWindow* external_window_from_handle (const gchar* handle);
VALA_EXTERN GType external_window_x11_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ExternalWindowX11, g_object_unref)
VALA_EXTERN ExternalWindowX11* external_window_x11_new (const gchar* handle,
                                            GError** error);
VALA_EXTERN ExternalWindowX11* external_window_x11_construct (GType object_type,
                                                  const gchar* handle,
                                                  GError** error);
VALA_EXTERN GType external_window_wayland_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (ExternalWindowWayland, g_object_unref)
VALA_EXTERN ExternalWindowWayland* external_window_wayland_new (const gchar* handle,
                                                    GError** error);
VALA_EXTERN ExternalWindowWayland* external_window_wayland_construct (GType object_type,
                                                          const gchar* handle,
                                                          GError** error);
static GType external_window_get_type_once (void);
static GdkDisplay* external_window_x11_get_x11_display (void);
static void external_window_x11_real_set_parent_of (ExternalWindow* base,
                                             GdkWindow* child_window);
static void external_window_x11_finalize (GObject * obj);
static GType external_window_x11_get_type_once (void);
static GdkDisplay* external_window_wayland_get_wayland_display (void);
static void external_window_wayland_real_set_parent_of (ExternalWindow* base,
                                                 GdkWindow* child_window);
static void external_window_wayland_finalize (GObject * obj);
static GType external_window_wayland_get_type_once (void);

void
external_window_set_parent_of (ExternalWindow* self,
                               GdkWindow* child_window)
{
	ExternalWindowIface* _iface_;
#line 23 "../filechooser-portal/ExternalWindow.vala"
	g_return_if_fail (self != NULL);
#line 23 "../filechooser-portal/ExternalWindow.vala"
	_iface_ = EXTERNAL_WINDOW_GET_INTERFACE (self);
#line 23 "../filechooser-portal/ExternalWindow.vala"
	if (_iface_->set_parent_of) {
#line 23 "../filechooser-portal/ExternalWindow.vala"
		_iface_->set_parent_of (self, child_window);
#line 179 "ExternalWindow.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1458 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1458 "glib-2.0.vapi"
	end = _tmp0_;
#line 1459 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1459 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1460 "glib-2.0.vapi"
		result = maxlen;
#line 1460 "glib-2.0.vapi"
		return result;
#line 203 "ExternalWindow.c"
	} else {
		gchar* _tmp2_;
#line 1462 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1462 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1462 "glib-2.0.vapi"
		return result;
#line 212 "ExternalWindow.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1469 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1471 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 231 "ExternalWindow.c"
	} else {
#line 1471 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 235 "ExternalWindow.c"
	}
#line 1471 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1473 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 241 "ExternalWindow.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1475 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1475 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1475 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 251 "ExternalWindow.c"
	}
#line 1478 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1479 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1480 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 259 "ExternalWindow.c"
	} else {
#line 1482 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 263 "ExternalWindow.c"
	}
#line 1484 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1485 "glib-2.0.vapi"
		len = string_length - offset;
#line 269 "ExternalWindow.c"
	}
#line 1487 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1488 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1488 "glib-2.0.vapi"
	result = _tmp3_;
#line 1488 "glib-2.0.vapi"
	return result;
#line 279 "ExternalWindow.c"
}

ExternalWindow*
external_window_from_handle (const gchar* handle)
{
#line 26 "../filechooser-portal/ExternalWindow.vala"
	static const char X11_PREFIX[] = "x11:";
#line 27 "../filechooser-portal/ExternalWindow.vala"
	static const char WAYLAND_PREFIX[] = "wayland:";
#line 289 "ExternalWindow.c"
	ExternalWindow* external_window = NULL;
	GError* _inner_error0_ = NULL;
	ExternalWindow* result;
#line 25 "../filechooser-portal/ExternalWindow.vala"
	g_return_val_if_fail (handle != NULL, NULL);
#line 28 "../filechooser-portal/ExternalWindow.vala"
	external_window = NULL;
#line 30 "../filechooser-portal/ExternalWindow.vala"
	if (g_str_has_prefix (handle, X11_PREFIX)) {
#line 299 "ExternalWindow.c"
		{
			ExternalWindowX11* _tmp0_ = NULL;
			gint _tmp1_;
			gint _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			ExternalWindowX11* _tmp5_;
			ExternalWindowX11* _tmp6_;
			ExternalWindowX11* _tmp7_;
#line 32 "../filechooser-portal/ExternalWindow.vala"
			_tmp1_ = strlen (X11_PREFIX);
#line 32 "../filechooser-portal/ExternalWindow.vala"
			_tmp2_ = _tmp1_;
#line 32 "../filechooser-portal/ExternalWindow.vala"
			_tmp3_ = string_substring (handle, (glong) _tmp2_, (glong) -1);
#line 32 "../filechooser-portal/ExternalWindow.vala"
			_tmp4_ = _tmp3_;
#line 32 "../filechooser-portal/ExternalWindow.vala"
			_tmp5_ = external_window_x11_new (_tmp4_, &_inner_error0_);
#line 32 "../filechooser-portal/ExternalWindow.vala"
			_tmp6_ = _tmp5_;
#line 32 "../filechooser-portal/ExternalWindow.vala"
			_g_free0 (_tmp4_);
#line 32 "../filechooser-portal/ExternalWindow.vala"
			_tmp0_ = _tmp6_;
#line 32 "../filechooser-portal/ExternalWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 327 "ExternalWindow.c"
				goto __catch0_g_error;
			}
#line 32 "../filechooser-portal/ExternalWindow.vala"
			_tmp7_ = _tmp0_;
#line 32 "../filechooser-portal/ExternalWindow.vala"
			_tmp0_ = NULL;
#line 32 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (external_window);
#line 32 "../filechooser-portal/ExternalWindow.vala"
			external_window = (ExternalWindow*) _tmp7_;
#line 31 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (_tmp0_);
#line 340 "ExternalWindow.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
#line 31 "../filechooser-portal/ExternalWindow.vala"
			e = _inner_error0_;
#line 31 "../filechooser-portal/ExternalWindow.vala"
			_inner_error0_ = NULL;
#line 34 "../filechooser-portal/ExternalWindow.vala"
			_tmp8_ = e;
#line 34 "../filechooser-portal/ExternalWindow.vala"
			_tmp9_ = _tmp8_->message;
#line 34 "../filechooser-portal/ExternalWindow.vala"
			g_warning ("ExternalWindow.vala:34: Error getting external X11 window: %s", _tmp9_);
#line 35 "../filechooser-portal/ExternalWindow.vala"
			result = NULL;
#line 35 "../filechooser-portal/ExternalWindow.vala"
			_g_error_free0 (e);
#line 35 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (external_window);
#line 35 "../filechooser-portal/ExternalWindow.vala"
			return result;
#line 366 "ExternalWindow.c"
		}
		__finally0:
#line 31 "../filechooser-portal/ExternalWindow.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 31 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (external_window);
#line 31 "../filechooser-portal/ExternalWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 31 "../filechooser-portal/ExternalWindow.vala"
			g_clear_error (&_inner_error0_);
#line 31 "../filechooser-portal/ExternalWindow.vala"
			return NULL;
#line 379 "ExternalWindow.c"
		}
	} else {
#line 37 "../filechooser-portal/ExternalWindow.vala"
		if (g_str_has_prefix (handle, WAYLAND_PREFIX)) {
#line 384 "ExternalWindow.c"
			{
				ExternalWindowWayland* _tmp10_ = NULL;
				gint _tmp11_;
				gint _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				ExternalWindowWayland* _tmp15_;
				ExternalWindowWayland* _tmp16_;
				ExternalWindowWayland* _tmp17_;
#line 39 "../filechooser-portal/ExternalWindow.vala"
				_tmp11_ = strlen (WAYLAND_PREFIX);
#line 39 "../filechooser-portal/ExternalWindow.vala"
				_tmp12_ = _tmp11_;
#line 39 "../filechooser-portal/ExternalWindow.vala"
				_tmp13_ = string_substring (handle, (glong) _tmp12_, (glong) -1);
#line 39 "../filechooser-portal/ExternalWindow.vala"
				_tmp14_ = _tmp13_;
#line 39 "../filechooser-portal/ExternalWindow.vala"
				_tmp15_ = external_window_wayland_new (_tmp14_, &_inner_error0_);
#line 39 "../filechooser-portal/ExternalWindow.vala"
				_tmp16_ = _tmp15_;
#line 39 "../filechooser-portal/ExternalWindow.vala"
				_g_free0 (_tmp14_);
#line 39 "../filechooser-portal/ExternalWindow.vala"
				_tmp10_ = _tmp16_;
#line 39 "../filechooser-portal/ExternalWindow.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 412 "ExternalWindow.c"
					goto __catch1_g_error;
				}
#line 39 "../filechooser-portal/ExternalWindow.vala"
				_tmp17_ = _tmp10_;
#line 39 "../filechooser-portal/ExternalWindow.vala"
				_tmp10_ = NULL;
#line 39 "../filechooser-portal/ExternalWindow.vala"
				_g_object_unref0 (external_window);
#line 39 "../filechooser-portal/ExternalWindow.vala"
				external_window = (ExternalWindow*) _tmp17_;
#line 38 "../filechooser-portal/ExternalWindow.vala"
				_g_object_unref0 (_tmp10_);
#line 425 "ExternalWindow.c"
			}
			goto __finally1;
			__catch1_g_error:
			{
				GError* e = NULL;
				GError* _tmp18_;
				const gchar* _tmp19_;
#line 38 "../filechooser-portal/ExternalWindow.vala"
				e = _inner_error0_;
#line 38 "../filechooser-portal/ExternalWindow.vala"
				_inner_error0_ = NULL;
#line 41 "../filechooser-portal/ExternalWindow.vala"
				_tmp18_ = e;
#line 41 "../filechooser-portal/ExternalWindow.vala"
				_tmp19_ = _tmp18_->message;
#line 41 "../filechooser-portal/ExternalWindow.vala"
				g_warning ("ExternalWindow.vala:41: Error getting external Wayland window: %s", _tmp19_);
#line 42 "../filechooser-portal/ExternalWindow.vala"
				result = NULL;
#line 42 "../filechooser-portal/ExternalWindow.vala"
				_g_error_free0 (e);
#line 42 "../filechooser-portal/ExternalWindow.vala"
				_g_object_unref0 (external_window);
#line 42 "../filechooser-portal/ExternalWindow.vala"
				return result;
#line 451 "ExternalWindow.c"
			}
			__finally1:
#line 38 "../filechooser-portal/ExternalWindow.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 38 "../filechooser-portal/ExternalWindow.vala"
				_g_object_unref0 (external_window);
#line 38 "../filechooser-portal/ExternalWindow.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 38 "../filechooser-portal/ExternalWindow.vala"
				g_clear_error (&_inner_error0_);
#line 38 "../filechooser-portal/ExternalWindow.vala"
				return NULL;
#line 464 "ExternalWindow.c"
			}
		} else {
#line 45 "../filechooser-portal/ExternalWindow.vala"
			g_warning ("ExternalWindow.vala:45: Unhandled parent window type %s", handle);
#line 469 "ExternalWindow.c"
		}
	}
#line 48 "../filechooser-portal/ExternalWindow.vala"
	result = external_window;
#line 48 "../filechooser-portal/ExternalWindow.vala"
	return result;
#line 476 "ExternalWindow.c"
}

static void
external_window_default_init (ExternalWindowIface * iface,
                              gpointer iface_data)
{
}

 G_GNUC_NO_INLINE static GType
external_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ExternalWindowIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) external_window_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType external_window_type_id;
	external_window_type_id = g_type_register_static (G_TYPE_INTERFACE, "ExternalWindow", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (external_window_type_id, G_TYPE_OBJECT);
	return external_window_type_id;
}

GType
external_window_get_type (void)
{
	static volatile gsize external_window_type_id__once = 0;
	if (g_once_init_enter (&external_window_type_id__once)) {
		GType external_window_type_id;
		external_window_type_id = external_window_get_type_once ();
		g_once_init_leave (&external_window_type_id__once, external_window_type_id);
	}
	return external_window_type_id__once;
}

static inline gpointer
external_window_x11_get_instance_private (ExternalWindowX11* self)
{
	return G_STRUCT_MEMBER_P (self, ExternalWindowX11_private_offset);
}

static gboolean
int_try_parse (const gchar* str,
               gint* _result_,
               const gchar** unparsed,
               guint _base)
{
	gint _vala__result_ = 0;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	glong long_result = 0L;
	gchar* _tmp0_ = NULL;
	glong _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	glong _tmp6_;
	gboolean result;
#line 156 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 158 "glib-2.0.vapi"
	errno = 0;
#line 159 "glib-2.0.vapi"
	_tmp1_ = strtol (str, &_tmp0_, (gint) _base);
#line 159 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 159 "glib-2.0.vapi"
	long_result = _tmp1_;
#line 160 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 160 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 160 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 160 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 161 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 550 "ExternalWindow.c"
	} else {
		gchar* _tmp5_;
#line 163 "glib-2.0.vapi"
		_tmp5_ = endptr;
#line 163 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp5_;
#line 557 "ExternalWindow.c"
	}
#line 165 "glib-2.0.vapi"
	_tmp6_ = long_result;
#line 165 "glib-2.0.vapi"
	if ((((glong) G_MININT) <= _tmp6_) && (_tmp6_ <= ((glong) G_MAXINT))) {
#line 563 "ExternalWindow.c"
		gboolean _tmp7_ = FALSE;
		gboolean _tmp8_ = FALSE;
#line 166 "glib-2.0.vapi"
		_vala__result_ = (gint) long_result;
#line 167 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 167 "glib-2.0.vapi"
			_tmp8_ = errno != EINVAL;
#line 572 "ExternalWindow.c"
		} else {
#line 167 "glib-2.0.vapi"
			_tmp8_ = FALSE;
#line 576 "ExternalWindow.c"
		}
#line 167 "glib-2.0.vapi"
		if (_tmp8_) {
#line 580 "ExternalWindow.c"
			const gchar* _tmp9_;
			gchar* _tmp10_;
#line 167 "glib-2.0.vapi"
			_tmp9_ = _vala_unparsed;
#line 167 "glib-2.0.vapi"
			_tmp10_ = endptr;
#line 167 "glib-2.0.vapi"
			_tmp7_ = _tmp9_ != _tmp10_;
#line 589 "ExternalWindow.c"
		} else {
#line 167 "glib-2.0.vapi"
			_tmp7_ = FALSE;
#line 593 "ExternalWindow.c"
		}
#line 167 "glib-2.0.vapi"
		result = _tmp7_;
#line 167 "glib-2.0.vapi"
		if (_result_) {
#line 167 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 601 "ExternalWindow.c"
		}
#line 167 "glib-2.0.vapi"
		if (unparsed) {
#line 167 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 607 "ExternalWindow.c"
		}
#line 167 "glib-2.0.vapi"
		return result;
#line 611 "ExternalWindow.c"
	} else {
#line 169 "glib-2.0.vapi"
		_vala__result_ = G_MAXINT;
#line 170 "glib-2.0.vapi"
		result = FALSE;
#line 170 "glib-2.0.vapi"
		if (_result_) {
#line 170 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 621 "ExternalWindow.c"
		}
#line 170 "glib-2.0.vapi"
		if (unparsed) {
#line 170 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 627 "ExternalWindow.c"
		}
#line 170 "glib-2.0.vapi"
		return result;
#line 631 "ExternalWindow.c"
	}
}

ExternalWindowX11*
external_window_x11_construct (GType object_type,
                               const gchar* handle,
                               GError** error)
{
	ExternalWindowX11 * self = NULL;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	gint xid = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_;
	GdkDisplay* _tmp6_;
	GdkX11Window* _tmp7_;
	GdkWindow* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 57 "../filechooser-portal/ExternalWindow.vala"
	g_return_val_if_fail (handle != NULL, NULL);
#line 57 "../filechooser-portal/ExternalWindow.vala"
	self = (ExternalWindowX11*) g_object_new (object_type, NULL);
#line 58 "../filechooser-portal/ExternalWindow.vala"
	_tmp0_ = external_window_x11_get_x11_display ();
#line 58 "../filechooser-portal/ExternalWindow.vala"
	display = _tmp0_;
#line 59 "../filechooser-portal/ExternalWindow.vala"
	_tmp1_ = display;
#line 59 "../filechooser-portal/ExternalWindow.vala"
	if (_tmp1_ == NULL) {
#line 663 "ExternalWindow.c"
		GError* _tmp2_;
#line 60 "../filechooser-portal/ExternalWindow.vala"
		_tmp2_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, "No X display connection, ignoring X11 parent");
#line 60 "../filechooser-portal/ExternalWindow.vala"
		_inner_error0_ = _tmp2_;
#line 60 "../filechooser-portal/ExternalWindow.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 60 "../filechooser-portal/ExternalWindow.vala"
			g_propagate_error (error, _inner_error0_);
#line 60 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (display);
#line 60 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (self);
#line 60 "../filechooser-portal/ExternalWindow.vala"
			return NULL;
#line 679 "ExternalWindow.c"
		} else {
#line 60 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (display);
#line 60 "../filechooser-portal/ExternalWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 60 "../filechooser-portal/ExternalWindow.vala"
			g_clear_error (&_inner_error0_);
#line 60 "../filechooser-portal/ExternalWindow.vala"
			return NULL;
#line 689 "ExternalWindow.c"
		}
	}
#line 64 "../filechooser-portal/ExternalWindow.vala"
	_tmp4_ = int_try_parse (handle, &_tmp3_, NULL, (guint) 16);
#line 64 "../filechooser-portal/ExternalWindow.vala"
	xid = _tmp3_;
#line 64 "../filechooser-portal/ExternalWindow.vala"
	if (!_tmp4_) {
#line 698 "ExternalWindow.c"
		GError* _tmp5_;
#line 65 "../filechooser-portal/ExternalWindow.vala"
		_tmp5_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, "Failed to reference external X11 window, invalid XID %s", handle);
#line 65 "../filechooser-portal/ExternalWindow.vala"
		_inner_error0_ = _tmp5_;
#line 65 "../filechooser-portal/ExternalWindow.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 65 "../filechooser-portal/ExternalWindow.vala"
			g_propagate_error (error, _inner_error0_);
#line 65 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (display);
#line 65 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (self);
#line 65 "../filechooser-portal/ExternalWindow.vala"
			return NULL;
#line 714 "ExternalWindow.c"
		} else {
#line 65 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (display);
#line 65 "../filechooser-portal/ExternalWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 65 "../filechooser-portal/ExternalWindow.vala"
			g_clear_error (&_inner_error0_);
#line 65 "../filechooser-portal/ExternalWindow.vala"
			return NULL;
#line 724 "ExternalWindow.c"
		}
	}
#line 68 "../filechooser-portal/ExternalWindow.vala"
	_tmp6_ = display;
#line 68 "../filechooser-portal/ExternalWindow.vala"
	_tmp7_ = (GdkX11Window*) gdk_x11_window_foreign_new_for_display (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gdk_x11_display_get_type (), GdkX11Display), (Window) xid);
#line 68 "../filechooser-portal/ExternalWindow.vala"
	_g_object_unref0 (self->priv->foreign_gdk_window);
#line 68 "../filechooser-portal/ExternalWindow.vala"
	self->priv->foreign_gdk_window = (GdkWindow*) _tmp7_;
#line 69 "../filechooser-portal/ExternalWindow.vala"
	_tmp8_ = self->priv->foreign_gdk_window;
#line 69 "../filechooser-portal/ExternalWindow.vala"
	if (_tmp8_ == NULL) {
#line 739 "ExternalWindow.c"
		GError* _tmp9_;
#line 70 "../filechooser-portal/ExternalWindow.vala"
		_tmp9_ = g_error_new (G_IO_ERROR, G_IO_ERROR_FAILED, "Failed to create foreign window for XID %d", xid);
#line 70 "../filechooser-portal/ExternalWindow.vala"
		_inner_error0_ = _tmp9_;
#line 70 "../filechooser-portal/ExternalWindow.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 70 "../filechooser-portal/ExternalWindow.vala"
			g_propagate_error (error, _inner_error0_);
#line 70 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (display);
#line 70 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (self);
#line 70 "../filechooser-portal/ExternalWindow.vala"
			return NULL;
#line 755 "ExternalWindow.c"
		} else {
#line 70 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (display);
#line 70 "../filechooser-portal/ExternalWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../filechooser-portal/ExternalWindow.vala"
			g_clear_error (&_inner_error0_);
#line 70 "../filechooser-portal/ExternalWindow.vala"
			return NULL;
#line 765 "ExternalWindow.c"
		}
	}
#line 57 "../filechooser-portal/ExternalWindow.vala"
	_g_object_unref0 (display);
#line 57 "../filechooser-portal/ExternalWindow.vala"
	return self;
#line 772 "ExternalWindow.c"
}

ExternalWindowX11*
external_window_x11_new (const gchar* handle,
                         GError** error)
{
#line 57 "../filechooser-portal/ExternalWindow.vala"
	return external_window_x11_construct (TYPE_EXTERNAL_WINDOW_X11, handle, error);
#line 781 "ExternalWindow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 76 "../filechooser-portal/ExternalWindow.vala"
	return self ? g_object_ref (self) : NULL;
#line 789 "ExternalWindow.c"
}

static GdkDisplay*
external_window_x11_get_x11_display (void)
{
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkDisplay* _tmp5_;
	GdkDisplay* _tmp6_;
	GdkDisplay* _tmp7_;
	GdkDisplay* result;
#line 75 "../filechooser-portal/ExternalWindow.vala"
	_tmp0_ = external_window_x11_x11_display;
#line 75 "../filechooser-portal/ExternalWindow.vala"
	if (_tmp0_ != NULL) {
#line 806 "ExternalWindow.c"
		GdkDisplay* _tmp1_;
		GdkDisplay* _tmp2_;
#line 76 "../filechooser-portal/ExternalWindow.vala"
		_tmp1_ = external_window_x11_x11_display;
#line 76 "../filechooser-portal/ExternalWindow.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 76 "../filechooser-portal/ExternalWindow.vala"
		result = _tmp2_;
#line 76 "../filechooser-portal/ExternalWindow.vala"
		return result;
#line 817 "ExternalWindow.c"
	}
#line 79 "../filechooser-portal/ExternalWindow.vala"
	gdk_set_allowed_backends ("x11");
#line 80 "../filechooser-portal/ExternalWindow.vala"
	_tmp3_ = gdk_display_open (NULL);
#line 80 "../filechooser-portal/ExternalWindow.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 80 "../filechooser-portal/ExternalWindow.vala"
	_g_object_unref0 (external_window_x11_x11_display);
#line 80 "../filechooser-portal/ExternalWindow.vala"
	external_window_x11_x11_display = _tmp4_;
#line 81 "../filechooser-portal/ExternalWindow.vala"
	gdk_set_allowed_backends (NULL);
#line 83 "../filechooser-portal/ExternalWindow.vala"
	_tmp5_ = external_window_x11_x11_display;
#line 83 "../filechooser-portal/ExternalWindow.vala"
	if (_tmp5_ == NULL) {
#line 84 "../filechooser-portal/ExternalWindow.vala"
		g_warning ("ExternalWindow.vala:84: Failed to open X11 display");
#line 837 "ExternalWindow.c"
	}
#line 87 "../filechooser-portal/ExternalWindow.vala"
	_tmp6_ = external_window_x11_x11_display;
#line 87 "../filechooser-portal/ExternalWindow.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 87 "../filechooser-portal/ExternalWindow.vala"
	result = _tmp7_;
#line 87 "../filechooser-portal/ExternalWindow.vala"
	return result;
#line 847 "ExternalWindow.c"
}

static void
external_window_x11_real_set_parent_of (ExternalWindow* base,
                                        GdkWindow* child_window)
{
	ExternalWindowX11 * self;
	GdkWindow* _tmp0_;
#line 90 "../filechooser-portal/ExternalWindow.vala"
	self = (ExternalWindowX11*) base;
#line 90 "../filechooser-portal/ExternalWindow.vala"
	g_return_if_fail (child_window != NULL);
#line 91 "../filechooser-portal/ExternalWindow.vala"
	_tmp0_ = self->priv->foreign_gdk_window;
#line 91 "../filechooser-portal/ExternalWindow.vala"
	gdk_window_set_transient_for (child_window, _tmp0_);
#line 864 "ExternalWindow.c"
}

static void
external_window_x11_class_init (ExternalWindowX11Class * klass,
                                gpointer klass_data)
{
#line 52 "../filechooser-portal/ExternalWindow.vala"
	external_window_x11_parent_class = g_type_class_peek_parent (klass);
#line 52 "../filechooser-portal/ExternalWindow.vala"
	g_type_class_adjust_private_offset (klass, &ExternalWindowX11_private_offset);
#line 52 "../filechooser-portal/ExternalWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = external_window_x11_finalize;
#line 877 "ExternalWindow.c"
}

static void
external_window_x11_external_window_interface_init (ExternalWindowIface * iface,
                                                    gpointer iface_data)
{
#line 52 "../filechooser-portal/ExternalWindow.vala"
	external_window_x11_external_window_parent_iface = g_type_interface_peek_parent (iface);
#line 52 "../filechooser-portal/ExternalWindow.vala"
	iface->set_parent_of = (void (*) (ExternalWindow*, GdkWindow*)) external_window_x11_real_set_parent_of;
#line 888 "ExternalWindow.c"
}

static void
external_window_x11_instance_init (ExternalWindowX11 * self,
                                   gpointer klass)
{
#line 52 "../filechooser-portal/ExternalWindow.vala"
	self->priv = external_window_x11_get_instance_private (self);
#line 897 "ExternalWindow.c"
}

static void
external_window_x11_finalize (GObject * obj)
{
	ExternalWindowX11 * self;
#line 52 "../filechooser-portal/ExternalWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXTERNAL_WINDOW_X11, ExternalWindowX11);
#line 55 "../filechooser-portal/ExternalWindow.vala"
	_g_object_unref0 (self->priv->foreign_gdk_window);
#line 52 "../filechooser-portal/ExternalWindow.vala"
	G_OBJECT_CLASS (external_window_x11_parent_class)->finalize (obj);
#line 910 "ExternalWindow.c"
}

 G_GNUC_NO_INLINE static GType
external_window_x11_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ExternalWindowX11Class), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) external_window_x11_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExternalWindowX11), 0, (GInstanceInitFunc) external_window_x11_instance_init, NULL };
	static const GInterfaceInfo external_window_info = { (GInterfaceInitFunc) external_window_x11_external_window_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType external_window_x11_type_id;
	external_window_x11_type_id = g_type_register_static (G_TYPE_OBJECT, "ExternalWindowX11", &g_define_type_info, 0);
	g_type_add_interface_static (external_window_x11_type_id, TYPE_EXTERNAL_WINDOW, &external_window_info);
	ExternalWindowX11_private_offset = g_type_add_instance_private (external_window_x11_type_id, sizeof (ExternalWindowX11Private));
	return external_window_x11_type_id;
}

GType
external_window_x11_get_type (void)
{
	static volatile gsize external_window_x11_type_id__once = 0;
	if (g_once_init_enter (&external_window_x11_type_id__once)) {
		GType external_window_x11_type_id;
		external_window_x11_type_id = external_window_x11_get_type_once ();
		g_once_init_leave (&external_window_x11_type_id__once, external_window_x11_type_id);
	}
	return external_window_x11_type_id__once;
}

static inline gpointer
external_window_wayland_get_instance_private (ExternalWindowWayland* self)
{
	return G_STRUCT_MEMBER_P (self, ExternalWindowWayland_private_offset);
}

ExternalWindowWayland*
external_window_wayland_construct (GType object_type,
                                   const gchar* handle,
                                   GError** error)
{
	ExternalWindowWayland * self = NULL;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp1_;
	gchar* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 100 "../filechooser-portal/ExternalWindow.vala"
	g_return_val_if_fail (handle != NULL, NULL);
#line 100 "../filechooser-portal/ExternalWindow.vala"
	self = (ExternalWindowWayland*) g_object_new (object_type, NULL);
#line 101 "../filechooser-portal/ExternalWindow.vala"
	_tmp0_ = external_window_wayland_get_wayland_display ();
#line 101 "../filechooser-portal/ExternalWindow.vala"
	display = _tmp0_;
#line 102 "../filechooser-portal/ExternalWindow.vala"
	_tmp1_ = display;
#line 102 "../filechooser-portal/ExternalWindow.vala"
	if (_tmp1_ == NULL) {
#line 966 "ExternalWindow.c"
		GError* _tmp2_;
#line 103 "../filechooser-portal/ExternalWindow.vala"
		_tmp2_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_FAILED, "No Wayland display connection, ignoring Wayland parent");
#line 103 "../filechooser-portal/ExternalWindow.vala"
		_inner_error0_ = _tmp2_;
#line 103 "../filechooser-portal/ExternalWindow.vala"
		if (_inner_error0_->domain == G_IO_ERROR) {
#line 103 "../filechooser-portal/ExternalWindow.vala"
			g_propagate_error (error, _inner_error0_);
#line 103 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (display);
#line 103 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (self);
#line 103 "../filechooser-portal/ExternalWindow.vala"
			return NULL;
#line 982 "ExternalWindow.c"
		} else {
#line 103 "../filechooser-portal/ExternalWindow.vala"
			_g_object_unref0 (display);
#line 103 "../filechooser-portal/ExternalWindow.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 103 "../filechooser-portal/ExternalWindow.vala"
			g_clear_error (&_inner_error0_);
#line 103 "../filechooser-portal/ExternalWindow.vala"
			return NULL;
#line 992 "ExternalWindow.c"
		}
	}
#line 106 "../filechooser-portal/ExternalWindow.vala"
	_tmp3_ = g_strdup (handle);
#line 106 "../filechooser-portal/ExternalWindow.vala"
	_g_free0 (self->priv->handle);
#line 106 "../filechooser-portal/ExternalWindow.vala"
	self->priv->handle = _tmp3_;
#line 100 "../filechooser-portal/ExternalWindow.vala"
	_g_object_unref0 (display);
#line 100 "../filechooser-portal/ExternalWindow.vala"
	return self;
#line 1005 "ExternalWindow.c"
}

ExternalWindowWayland*
external_window_wayland_new (const gchar* handle,
                             GError** error)
{
#line 100 "../filechooser-portal/ExternalWindow.vala"
	return external_window_wayland_construct (TYPE_EXTERNAL_WINDOW_WAYLAND, handle, error);
#line 1014 "ExternalWindow.c"
}

static GdkDisplay*
external_window_wayland_get_wayland_display (void)
{
	GdkDisplay* _tmp0_;
	GdkDisplay* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkDisplay* _tmp5_;
	GdkDisplay* _tmp6_;
	GdkDisplay* _tmp7_;
	GdkDisplay* result;
#line 110 "../filechooser-portal/ExternalWindow.vala"
	_tmp0_ = external_window_wayland_wayland_display;
#line 110 "../filechooser-portal/ExternalWindow.vala"
	if (_tmp0_ != NULL) {
#line 1031 "ExternalWindow.c"
		GdkDisplay* _tmp1_;
		GdkDisplay* _tmp2_;
#line 111 "../filechooser-portal/ExternalWindow.vala"
		_tmp1_ = external_window_wayland_wayland_display;
#line 111 "../filechooser-portal/ExternalWindow.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 111 "../filechooser-portal/ExternalWindow.vala"
		result = _tmp2_;
#line 111 "../filechooser-portal/ExternalWindow.vala"
		return result;
#line 1042 "ExternalWindow.c"
	}
#line 114 "../filechooser-portal/ExternalWindow.vala"
	gdk_set_allowed_backends ("wayland");
#line 115 "../filechooser-portal/ExternalWindow.vala"
	_tmp3_ = gdk_display_open (NULL);
#line 115 "../filechooser-portal/ExternalWindow.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 115 "../filechooser-portal/ExternalWindow.vala"
	_g_object_unref0 (external_window_wayland_wayland_display);
#line 115 "../filechooser-portal/ExternalWindow.vala"
	external_window_wayland_wayland_display = _tmp4_;
#line 116 "../filechooser-portal/ExternalWindow.vala"
	gdk_set_allowed_backends (NULL);
#line 118 "../filechooser-portal/ExternalWindow.vala"
	_tmp5_ = external_window_wayland_wayland_display;
#line 118 "../filechooser-portal/ExternalWindow.vala"
	if (_tmp5_ == NULL) {
#line 119 "../filechooser-portal/ExternalWindow.vala"
		g_warning ("ExternalWindow.vala:119: Failed to open Wayland display");
#line 1062 "ExternalWindow.c"
	}
#line 122 "../filechooser-portal/ExternalWindow.vala"
	_tmp6_ = external_window_wayland_wayland_display;
#line 122 "../filechooser-portal/ExternalWindow.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 122 "../filechooser-portal/ExternalWindow.vala"
	result = _tmp7_;
#line 122 "../filechooser-portal/ExternalWindow.vala"
	return result;
#line 1072 "ExternalWindow.c"
}

static void
external_window_wayland_real_set_parent_of (ExternalWindow* base,
                                            GdkWindow* child_window)
{
	ExternalWindowWayland * self;
	const gchar* _tmp0_;
#line 125 "../filechooser-portal/ExternalWindow.vala"
	self = (ExternalWindowWayland*) base;
#line 125 "../filechooser-portal/ExternalWindow.vala"
	g_return_if_fail (child_window != NULL);
#line 126 "../filechooser-portal/ExternalWindow.vala"
	_tmp0_ = self->priv->handle;
#line 126 "../filechooser-portal/ExternalWindow.vala"
	if (!gdk_wayland_window_set_transient_for_exported (G_TYPE_CHECK_INSTANCE_CAST (child_window, GDK_TYPE_WAYLAND_WINDOW, GdkWaylandWindow), _tmp0_)) {
#line 127 "../filechooser-portal/ExternalWindow.vala"
		g_warning ("ExternalWindow.vala:127: Failed to set portal window transient for ext" \
"ernal parent");
#line 1091 "ExternalWindow.c"
	}
}

static void
external_window_wayland_class_init (ExternalWindowWaylandClass * klass,
                                    gpointer klass_data)
{
#line 95 "../filechooser-portal/ExternalWindow.vala"
	external_window_wayland_parent_class = g_type_class_peek_parent (klass);
#line 95 "../filechooser-portal/ExternalWindow.vala"
	g_type_class_adjust_private_offset (klass, &ExternalWindowWayland_private_offset);
#line 95 "../filechooser-portal/ExternalWindow.vala"
	G_OBJECT_CLASS (klass)->finalize = external_window_wayland_finalize;
#line 1105 "ExternalWindow.c"
}

static void
external_window_wayland_external_window_interface_init (ExternalWindowIface * iface,
                                                        gpointer iface_data)
{
#line 95 "../filechooser-portal/ExternalWindow.vala"
	external_window_wayland_external_window_parent_iface = g_type_interface_peek_parent (iface);
#line 95 "../filechooser-portal/ExternalWindow.vala"
	iface->set_parent_of = (void (*) (ExternalWindow*, GdkWindow*)) external_window_wayland_real_set_parent_of;
#line 1116 "ExternalWindow.c"
}

static void
external_window_wayland_instance_init (ExternalWindowWayland * self,
                                       gpointer klass)
{
#line 95 "../filechooser-portal/ExternalWindow.vala"
	self->priv = external_window_wayland_get_instance_private (self);
#line 1125 "ExternalWindow.c"
}

static void
external_window_wayland_finalize (GObject * obj)
{
	ExternalWindowWayland * self;
#line 95 "../filechooser-portal/ExternalWindow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_EXTERNAL_WINDOW_WAYLAND, ExternalWindowWayland);
#line 98 "../filechooser-portal/ExternalWindow.vala"
	_g_free0 (self->priv->handle);
#line 95 "../filechooser-portal/ExternalWindow.vala"
	G_OBJECT_CLASS (external_window_wayland_parent_class)->finalize (obj);
#line 1138 "ExternalWindow.c"
}

 G_GNUC_NO_INLINE static GType
external_window_wayland_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ExternalWindowWaylandClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) external_window_wayland_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ExternalWindowWayland), 0, (GInstanceInitFunc) external_window_wayland_instance_init, NULL };
	static const GInterfaceInfo external_window_info = { (GInterfaceInitFunc) external_window_wayland_external_window_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType external_window_wayland_type_id;
	external_window_wayland_type_id = g_type_register_static (G_TYPE_OBJECT, "ExternalWindowWayland", &g_define_type_info, 0);
	g_type_add_interface_static (external_window_wayland_type_id, TYPE_EXTERNAL_WINDOW, &external_window_info);
	ExternalWindowWayland_private_offset = g_type_add_instance_private (external_window_wayland_type_id, sizeof (ExternalWindowWaylandPrivate));
	return external_window_wayland_type_id;
}

GType
external_window_wayland_get_type (void)
{
	static volatile gsize external_window_wayland_type_id__once = 0;
	if (g_once_init_enter (&external_window_wayland_type_id__once)) {
		GType external_window_wayland_type_id;
		external_window_wayland_type_id = external_window_wayland_get_type_once ();
		g_once_init_leave (&external_window_wayland_type_id__once, external_window_wayland_type_id);
	}
	return external_window_wayland_type_id__once;
}

