/* BookmarkList.c generated by valac 0.56.14, the Vala compiler
 * generated from BookmarkList.vala, do not modify */

#include "pantheon-files-core.h"
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	FILES_BOOKMARK_LIST_JOB_TYPE_LOAD = 1,
	FILES_BOOKMARK_LIST_JOB_TYPE_SAVE = 2
} FilesBookmarkListJobType;

#define FILES_BOOKMARK_LIST_TYPE_JOB_TYPE (files_bookmark_list_job_type_get_type ())
enum  {
	FILES_BOOKMARK_LIST_0_PROPERTY,
	FILES_BOOKMARK_LIST_LIST_PROPERTY,
	FILES_BOOKMARK_LIST_NUM_PROPERTIES
};
static GParamSpec* files_bookmark_list_properties[FILES_BOOKMARK_LIST_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _files_bookmark_unref0(var) ((var == NULL) ? NULL : (var = (files_bookmark_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
typedef struct _Block4Data Block4Data;
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
enum  {
	FILES_BOOKMARK_LIST_CONTENTS_CHANGED_SIGNAL,
	FILES_BOOKMARK_LIST_LOADED_SIGNAL,
	FILES_BOOKMARK_LIST_DELETED_SIGNAL,
	FILES_BOOKMARK_LIST_NUM_SIGNALS
};
static guint files_bookmark_list_signals[FILES_BOOKMARK_LIST_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FilesBookmarkListPrivate {
	GList* _list;
	GFileMonitor* monitor;
	GQueue* pending_ops;
	FilesCallWhenReady* call_when_ready;
};

struct _Block1Data {
	int _ref_count_;
	FilesBookmarkList* self;
	guint index;
};

struct _Block2Data {
	int _ref_count_;
	FilesBookmarkList* self;
	GFile* file;
};

struct _Block3Data {
	int _ref_count_;
	FilesBookmarkList* self;
	GList* files;
};

struct _Block4Data {
	int _ref_count_;
	FilesBookmarkList* self;
	GFile* file;
	GString* sb;
};

static gint FilesBookmarkList_private_offset;
static gpointer files_bookmark_list_parent_class = NULL;
static GFile* files_bookmark_list_bookmarks_file;
static GFile* files_bookmark_list_bookmarks_file = NULL;
static FilesBookmarkList* files_bookmark_list_instance;
static FilesBookmarkList* files_bookmark_list_instance = NULL;

static GType files_bookmark_list_job_type_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static FilesBookmarkList* files_bookmark_list_new (void);
static FilesBookmarkList* files_bookmark_list_construct (GType object_type);
static void files_bookmark_list_set_list (FilesBookmarkList* self,
                                   GList* value);
static void _files_bookmark_unref0_ (gpointer var);
static inline void _g_list_free__files_bookmark_unref0_ (GList* self);
static void files_bookmark_list_load_bookmarks_file (FilesBookmarkList* self);
static void files_bookmark_list_add_special_directories (FilesBookmarkList* self);
static void files_bookmark_list_save_bookmarks_file (FilesBookmarkList* self);
static void files_bookmark_list_append_internal (FilesBookmarkList* self,
                                          FilesBookmark* bookmark);
static void files_bookmark_list_insert_item_internal (FilesBookmarkList* self,
                                               FilesBookmark* bm,
                                               guint index);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void __lambda24_ (Block1Data* _data1_,
                  const gchar* uri);
static void ___lambda24__gfunc (gconstpointer data,
                         gpointer self);
static void files_bookmark_list_stop_monitoring_bookmark (FilesBookmarkList* self,
                                                   FilesBookmark* bookmark);
static void files_bookmark_list_start_monitoring_bookmark (FilesBookmarkList* self,
                                                    FilesBookmark* bookmark);
static void files_bookmark_list_schedule_job (FilesBookmarkList* self,
                                       FilesBookmarkListJobType job);
static void files_bookmark_list_process_next_op (FilesBookmarkList* self);
static void files_bookmark_list_load_bookmarks_file_async (FilesBookmarkList* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static GFile* files_bookmark_list_get_bookmarks_file (void);
static void __lambda20_ (Block2Data* _data2_,
                  GObject* obj,
                  GAsyncResult* res);
static void files_bookmark_list_bookmark_list_from_string (FilesBookmarkList* self,
                                                    const gchar* contents);
static GList* files_bookmark_list_get_gof_file_list (FilesBookmarkList* self);
static void files_bookmark_list_files_ready (FilesBookmarkList* self,
                                      GList* files);
static void _files_bookmark_list_files_ready_filescallwhenreadycall_when_ready_func (GList* files,
                                                                              gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void files_bookmark_list_op_processed_call_back (FilesBookmarkList* self);
static void ___lambda20__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda21_ (Block3Data* _data3_,
                  FilesBookmark* bm);
static void ___lambda21__gfunc (gconstpointer data,
                         gpointer self);
static void _files_bookmark_list_stop_monitoring_bookmark_gfunc (gconstpointer data,
                                                          gpointer self);
static void _files_bookmark_list_start_monitoring_bookmark_gfunc (gconstpointer data,
                                                           gpointer self);
static void files_bookmark_list_save_bookmarks_file_async (FilesBookmarkList* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void __lambda22_ (Block4Data* _data4_,
                  FilesBookmark* bookmark);
static void ___lambda22__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda23_ (Block4Data* _data4_,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda23__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void files_bookmark_list_bookmarks_file_changed_call_back (FilesBookmarkList* self,
                                                           GFile* file,
                                                           GFile* other_file,
                                                           GFileMonitorEvent event_type);
static void files_bookmark_list_bookmark_in_list_changed_callback (FilesBookmarkList* self,
                                                            FilesBookmark* bookmark);
static void files_bookmark_list_bookmark_in_list_to_be_deleted_callback (FilesBookmarkList* self,
                                                                  FilesBookmark* bookmark);
static void files_bookmark_list_start_monitoring_bookmarks_file (FilesBookmarkList* self);
static void _files_bookmark_list_bookmarks_file_changed_call_back_g_file_monitor_changed (GFileMonitor* _sender,
                                                                                   GFile* file,
                                                                                   GFile* other_file,
                                                                                   GFileMonitorEvent event_type,
                                                                                   gpointer self);
static void files_bookmark_list_stop_monitoring_bookmarks_file (FilesBookmarkList* self);
static void _files_bookmark_list_bookmark_in_list_changed_callback_files_bookmark_contents_changed (FilesBookmark* _sender,
                                                                                             gpointer self);
static void _files_bookmark_list_bookmark_in_list_to_be_deleted_callback_files_bookmark_deleted (FilesBookmark* _sender,
                                                                                          gpointer self);
static void files_bookmark_list_finalize (GObject * obj);
static GType files_bookmark_list_get_type_once (void);
static void _vala_files_bookmark_list_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_files_bookmark_list_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
files_bookmark_list_get_instance_private (FilesBookmarkList* self)
{
	return G_STRUCT_MEMBER_P (self, FilesBookmarkList_private_offset);
}

 G_GNUC_NO_INLINE static GType
files_bookmark_list_job_type_get_type_once (void)
{
	static const GEnumValue values[] = {{FILES_BOOKMARK_LIST_JOB_TYPE_LOAD, "FILES_BOOKMARK_LIST_JOB_TYPE_LOAD", "load"}, {FILES_BOOKMARK_LIST_JOB_TYPE_SAVE, "FILES_BOOKMARK_LIST_JOB_TYPE_SAVE", "save"}, {0, NULL, NULL}};
	GType files_bookmark_list_job_type_type_id;
	files_bookmark_list_job_type_type_id = g_enum_register_static ("FilesBookmarkListJobType", values);
	return files_bookmark_list_job_type_type_id;
}

static GType
files_bookmark_list_job_type_get_type (void)
{
	static volatile gsize files_bookmark_list_job_type_type_id__once = 0;
	if (g_once_init_enter (&files_bookmark_list_job_type_type_id__once)) {
		GType files_bookmark_list_job_type_type_id;
		files_bookmark_list_job_type_type_id = files_bookmark_list_job_type_get_type_once ();
		g_once_init_leave (&files_bookmark_list_job_type_type_id__once, files_bookmark_list_job_type_type_id);
	}
	return files_bookmark_list_job_type_type_id__once;
}

static void
_files_bookmark_unref0_ (gpointer var)
{
#line 45 "../libcore/BookmarkList.vala"
	(var == NULL) ? NULL : (var = (files_bookmark_unref (var), NULL));
#line 224 "BookmarkList.c"
}

static inline void
_g_list_free__files_bookmark_unref0_ (GList* self)
{
#line 45 "../libcore/BookmarkList.vala"
	g_list_free_full (self, (GDestroyNotify) _files_bookmark_unref0_);
#line 232 "BookmarkList.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 92 "../libcore/BookmarkList.vala"
	return self ? g_object_ref (self) : NULL;
#line 240 "BookmarkList.c"
}

static FilesBookmarkList*
files_bookmark_list_construct (GType object_type)
{
	FilesBookmarkList * self = NULL;
	GList* _tmp0_;
	GQueue* _tmp1_;
	gchar* user_home = NULL;
	gchar* _tmp2_;
	gchar* config_dir = NULL;
	const gchar* _tmp3_;
	gchar* filename = NULL;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GFile* file = NULL;
	const gchar* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	GError* _inner_error0_ = NULL;
#line 44 "../libcore/BookmarkList.vala"
	self = (FilesBookmarkList*) g_object_new (object_type, NULL);
#line 45 "../libcore/BookmarkList.vala"
	_tmp0_ = NULL;
#line 45 "../libcore/BookmarkList.vala"
	files_bookmark_list_set_list (self, _tmp0_);
#line 45 "../libcore/BookmarkList.vala"
	(_tmp0_ == NULL) ? NULL : (_tmp0_ = (_g_list_free__files_bookmark_unref0_ (_tmp0_), NULL));
#line 46 "../libcore/BookmarkList.vala"
	_tmp1_ = g_queue_new ();
#line 46 "../libcore/BookmarkList.vala"
	(self->priv->pending_ops == NULL) ? NULL : (self->priv->pending_ops = (g_queue_free (self->priv->pending_ops), NULL));
#line 46 "../libcore/BookmarkList.vala"
	self->priv->pending_ops = _tmp1_;
#line 51 "../libcore/BookmarkList.vala"
	_tmp2_ = pf_user_utils_get_real_user_home ();
#line 51 "../libcore/BookmarkList.vala"
	user_home = _tmp2_;
#line 54 "../libcore/BookmarkList.vala"
	_tmp3_ = user_home;
#line 54 "../libcore/BookmarkList.vala"
	if (_tmp3_ != NULL) {
#line 283 "BookmarkList.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 55 "../libcore/BookmarkList.vala"
		_tmp4_ = user_home;
#line 55 "../libcore/BookmarkList.vala"
		_tmp5_ = g_build_filename (_tmp4_, ".config", NULL);
#line 55 "../libcore/BookmarkList.vala"
		_g_free0 (config_dir);
#line 55 "../libcore/BookmarkList.vala"
		config_dir = _tmp5_;
#line 294 "BookmarkList.c"
	} else {
		const gchar* _tmp6_;
		gchar* _tmp7_;
#line 57 "../libcore/BookmarkList.vala"
		_tmp6_ = g_get_user_config_dir ();
#line 57 "../libcore/BookmarkList.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 57 "../libcore/BookmarkList.vala"
		_g_free0 (config_dir);
#line 57 "../libcore/BookmarkList.vala"
		config_dir = _tmp7_;
#line 306 "BookmarkList.c"
	}
#line 61 "../libcore/BookmarkList.vala"
	_tmp8_ = config_dir;
#line 61 "../libcore/BookmarkList.vala"
	_tmp9_ = g_build_filename (_tmp8_, "gtk-3.0", "bookmarks", NULL, NULL);
#line 61 "../libcore/BookmarkList.vala"
	filename = _tmp9_;
#line 66 "../libcore/BookmarkList.vala"
	_tmp10_ = filename;
#line 66 "../libcore/BookmarkList.vala"
	_tmp11_ = g_file_new_for_path (_tmp10_);
#line 66 "../libcore/BookmarkList.vala"
	file = _tmp11_;
#line 67 "../libcore/BookmarkList.vala"
	_tmp12_ = file;
#line 67 "../libcore/BookmarkList.vala"
	if (!g_file_query_exists (_tmp12_, NULL)) {
#line 324 "BookmarkList.c"
		gchar* old_filename = NULL;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		GFile* old_file = NULL;
		const gchar* _tmp25_;
		GFile* _tmp26_;
		GFile* _tmp27_;
		{
			GFile* _tmp13_;
			GFile* _tmp14_;
			GFile* _tmp15_;
#line 70 "../libcore/BookmarkList.vala"
			_tmp13_ = file;
#line 70 "../libcore/BookmarkList.vala"
			_tmp14_ = g_file_get_parent (_tmp13_);
#line 70 "../libcore/BookmarkList.vala"
			_tmp15_ = _tmp14_;
#line 70 "../libcore/BookmarkList.vala"
			g_file_make_directory_with_parents (_tmp15_, NULL, &_inner_error0_);
#line 70 "../libcore/BookmarkList.vala"
			_g_object_unref0 (_tmp15_);
#line 70 "../libcore/BookmarkList.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 348 "BookmarkList.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp16_;
			const gchar* _tmp17_;
#line 69 "../libcore/BookmarkList.vala"
			_error_ = _inner_error0_;
#line 69 "../libcore/BookmarkList.vala"
			_inner_error0_ = NULL;
#line 74 "../libcore/BookmarkList.vala"
			_tmp16_ = _error_;
#line 74 "../libcore/BookmarkList.vala"
			_tmp17_ = _tmp16_->message;
#line 74 "../libcore/BookmarkList.vala"
			g_warning ("BookmarkList.vala:74: Could not create bookmarks directory: %s", _tmp17_);
#line 69 "../libcore/BookmarkList.vala"
			_g_error_free0 (_error_);
#line 370 "BookmarkList.c"
		}
		__finally0:
#line 69 "../libcore/BookmarkList.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../libcore/BookmarkList.vala"
			_g_object_unref0 (file);
#line 69 "../libcore/BookmarkList.vala"
			_g_free0 (filename);
#line 69 "../libcore/BookmarkList.vala"
			_g_free0 (config_dir);
#line 69 "../libcore/BookmarkList.vala"
			_g_free0 (user_home);
#line 69 "../libcore/BookmarkList.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "../libcore/BookmarkList.vala"
			g_clear_error (&_inner_error0_);
#line 69 "../libcore/BookmarkList.vala"
			return NULL;
#line 389 "BookmarkList.c"
		}
		{
			GFile* _tmp18_;
			GFileOutputStream* _tmp19_;
			GFileOutputStream* _tmp20_;
#line 78 "../libcore/BookmarkList.vala"
			_tmp18_ = file;
#line 78 "../libcore/BookmarkList.vala"
			_tmp19_ = g_file_create (_tmp18_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 78 "../libcore/BookmarkList.vala"
			_tmp20_ = _tmp19_;
#line 78 "../libcore/BookmarkList.vala"
			_g_object_unref0 (_tmp20_);
#line 78 "../libcore/BookmarkList.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 405 "BookmarkList.c"
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* _error_ = NULL;
			GError* _tmp21_;
			const gchar* _tmp22_;
#line 77 "../libcore/BookmarkList.vala"
			_error_ = _inner_error0_;
#line 77 "../libcore/BookmarkList.vala"
			_inner_error0_ = NULL;
#line 81 "../libcore/BookmarkList.vala"
			_tmp21_ = _error_;
#line 81 "../libcore/BookmarkList.vala"
			_tmp22_ = _tmp21_->message;
#line 81 "../libcore/BookmarkList.vala"
			g_critical ("BookmarkList.vala:81: Could not create bookmarks file: %s", _tmp22_);
#line 77 "../libcore/BookmarkList.vala"
			_g_error_free0 (_error_);
#line 427 "BookmarkList.c"
		}
		__finally1:
#line 77 "../libcore/BookmarkList.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 77 "../libcore/BookmarkList.vala"
			_g_object_unref0 (file);
#line 77 "../libcore/BookmarkList.vala"
			_g_free0 (filename);
#line 77 "../libcore/BookmarkList.vala"
			_g_free0 (config_dir);
#line 77 "../libcore/BookmarkList.vala"
			_g_free0 (user_home);
#line 77 "../libcore/BookmarkList.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 77 "../libcore/BookmarkList.vala"
			g_clear_error (&_inner_error0_);
#line 77 "../libcore/BookmarkList.vala"
			return NULL;
#line 446 "BookmarkList.c"
		}
#line 85 "../libcore/BookmarkList.vala"
		_tmp23_ = g_get_home_dir ();
#line 85 "../libcore/BookmarkList.vala"
		_tmp24_ = g_build_filename (_tmp23_, ".gtk-bookmarks", NULL, NULL);
#line 85 "../libcore/BookmarkList.vala"
		old_filename = _tmp24_;
#line 89 "../libcore/BookmarkList.vala"
		_tmp25_ = old_filename;
#line 89 "../libcore/BookmarkList.vala"
		_tmp26_ = g_file_new_for_path (_tmp25_);
#line 89 "../libcore/BookmarkList.vala"
		old_file = _tmp26_;
#line 90 "../libcore/BookmarkList.vala"
		_tmp27_ = old_file;
#line 90 "../libcore/BookmarkList.vala"
		if (g_file_query_exists (_tmp27_, NULL)) {
#line 464 "BookmarkList.c"
			GFile* _tmp28_;
			GFile* _tmp29_;
			GFile* _tmp30_;
			GFile* _tmp31_;
#line 92 "../libcore/BookmarkList.vala"
			_tmp28_ = old_file;
#line 92 "../libcore/BookmarkList.vala"
			_tmp29_ = _g_object_ref0 (_tmp28_);
#line 92 "../libcore/BookmarkList.vala"
			_g_object_unref0 (files_bookmark_list_bookmarks_file);
#line 92 "../libcore/BookmarkList.vala"
			files_bookmark_list_bookmarks_file = _tmp29_;
#line 93 "../libcore/BookmarkList.vala"
			files_bookmark_list_load_bookmarks_file (self);
#line 94 "../libcore/BookmarkList.vala"
			_tmp30_ = file;
#line 94 "../libcore/BookmarkList.vala"
			_tmp31_ = _g_object_ref0 (_tmp30_);
#line 94 "../libcore/BookmarkList.vala"
			_g_object_unref0 (files_bookmark_list_bookmarks_file);
#line 94 "../libcore/BookmarkList.vala"
			files_bookmark_list_bookmarks_file = _tmp31_;
#line 487 "BookmarkList.c"
		} else {
			GFile* _tmp32_;
			GFile* _tmp33_;
#line 97 "../libcore/BookmarkList.vala"
			_tmp32_ = file;
#line 97 "../libcore/BookmarkList.vala"
			_tmp33_ = _g_object_ref0 (_tmp32_);
#line 97 "../libcore/BookmarkList.vala"
			_g_object_unref0 (files_bookmark_list_bookmarks_file);
#line 97 "../libcore/BookmarkList.vala"
			files_bookmark_list_bookmarks_file = _tmp33_;
#line 98 "../libcore/BookmarkList.vala"
			files_bookmark_list_add_special_directories (self);
#line 501 "BookmarkList.c"
		}
#line 100 "../libcore/BookmarkList.vala"
		files_bookmark_list_save_bookmarks_file (self);
#line 67 "../libcore/BookmarkList.vala"
		_g_object_unref0 (old_file);
#line 67 "../libcore/BookmarkList.vala"
		_g_free0 (old_filename);
#line 509 "BookmarkList.c"
	} else {
		GFile* _tmp34_;
		GFile* _tmp35_;
#line 102 "../libcore/BookmarkList.vala"
		_tmp34_ = file;
#line 102 "../libcore/BookmarkList.vala"
		_tmp35_ = _g_object_ref0 (_tmp34_);
#line 102 "../libcore/BookmarkList.vala"
		_g_object_unref0 (files_bookmark_list_bookmarks_file);
#line 102 "../libcore/BookmarkList.vala"
		files_bookmark_list_bookmarks_file = _tmp35_;
#line 103 "../libcore/BookmarkList.vala"
		files_bookmark_list_load_bookmarks_file (self);
#line 523 "BookmarkList.c"
	}
#line 44 "../libcore/BookmarkList.vala"
	_g_object_unref0 (file);
#line 44 "../libcore/BookmarkList.vala"
	_g_free0 (filename);
#line 44 "../libcore/BookmarkList.vala"
	_g_free0 (config_dir);
#line 44 "../libcore/BookmarkList.vala"
	_g_free0 (user_home);
#line 44 "../libcore/BookmarkList.vala"
	return self;
#line 535 "BookmarkList.c"
}

static FilesBookmarkList*
files_bookmark_list_new (void)
{
#line 44 "../libcore/BookmarkList.vala"
	return files_bookmark_list_construct (FILES_TYPE_BOOKMARK_LIST);
#line 543 "BookmarkList.c"
}

static void
files_bookmark_list_add_special_directories (FilesBookmarkList* self)
{
#line 108 "../libcore/BookmarkList.vala"
	static const GUserDirectory DIRECTORIES[7] = {G_USER_DIRECTORY_DOCUMENTS, G_USER_DIRECTORY_DOWNLOAD, G_USER_DIRECTORY_MUSIC, G_USER_DIRECTORY_PUBLIC_SHARE, G_USER_DIRECTORY_PICTURES, G_USER_DIRECTORY_TEMPLATES, G_USER_DIRECTORY_VIDEOS};
#line 107 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 553 "BookmarkList.c"
	{
		GUserDirectory* directory_collection = NULL;
		gint directory_collection_length1 = 0;
		gint _directory_collection_size_ = 0;
		gint directory_it = 0;
#line 118 "../libcore/BookmarkList.vala"
		directory_collection = DIRECTORIES;
#line 118 "../libcore/BookmarkList.vala"
		directory_collection_length1 = G_N_ELEMENTS (DIRECTORIES);
#line 118 "../libcore/BookmarkList.vala"
		for (directory_it = 0; directory_it < directory_collection_length1; directory_it = directory_it + 1) {
#line 565 "BookmarkList.c"
			GUserDirectory directory = 0;
#line 118 "../libcore/BookmarkList.vala"
			directory = directory_collection[directory_it];
#line 569 "BookmarkList.c"
			{
				const gchar* dir_s = NULL;
				const gchar* _tmp0_;
				const gchar* _tmp1_;
#line 119 "../libcore/BookmarkList.vala"
				_tmp0_ = g_get_user_special_dir (directory);
#line 119 "../libcore/BookmarkList.vala"
				dir_s = _tmp0_;
#line 120 "../libcore/BookmarkList.vala"
				_tmp1_ = dir_s;
#line 120 "../libcore/BookmarkList.vala"
				if (_tmp1_ != NULL) {
#line 582 "BookmarkList.c"
					FilesFile* gof_file = NULL;
					const gchar* _tmp2_;
					GFile* _tmp3_;
					GFile* _tmp4_;
					FilesFile* _tmp5_;
					FilesFile* _tmp6_;
					FilesBookmark* bookmark = NULL;
					FilesFile* _tmp7_;
					FilesBookmark* _tmp8_;
					FilesBookmark* _tmp9_;
#line 121 "../libcore/BookmarkList.vala"
					_tmp2_ = dir_s;
#line 121 "../libcore/BookmarkList.vala"
					_tmp3_ = g_file_new_for_path (_tmp2_);
#line 121 "../libcore/BookmarkList.vala"
					_tmp4_ = _tmp3_;
#line 121 "../libcore/BookmarkList.vala"
					_tmp5_ = files_file_get (_tmp4_);
#line 121 "../libcore/BookmarkList.vala"
					_tmp6_ = _tmp5_;
#line 121 "../libcore/BookmarkList.vala"
					_g_object_unref0 (_tmp4_);
#line 121 "../libcore/BookmarkList.vala"
					gof_file = _tmp6_;
#line 122 "../libcore/BookmarkList.vala"
					_tmp7_ = gof_file;
#line 122 "../libcore/BookmarkList.vala"
					_tmp8_ = files_bookmark_new (_tmp7_, "");
#line 122 "../libcore/BookmarkList.vala"
					bookmark = _tmp8_;
#line 123 "../libcore/BookmarkList.vala"
					_tmp9_ = bookmark;
#line 123 "../libcore/BookmarkList.vala"
					files_bookmark_list_append_internal (self, _tmp9_);
#line 120 "../libcore/BookmarkList.vala"
					_files_bookmark_unref0 (bookmark);
#line 120 "../libcore/BookmarkList.vala"
					_g_object_unref0 (gof_file);
#line 621 "BookmarkList.c"
				}
			}
		}
	}
#line 127 "../libcore/BookmarkList.vala"
	files_bookmark_list_save_bookmarks_file (self);
#line 628 "BookmarkList.c"
}

FilesBookmarkList*
files_bookmark_list_get_instance (void)
{
	FilesBookmarkList* _tmp0_;
	FilesBookmarkList* _tmp2_;
	FilesBookmarkList* _tmp3_;
	FilesBookmarkList* result;
#line 131 "../libcore/BookmarkList.vala"
	_tmp0_ = files_bookmark_list_instance;
#line 131 "../libcore/BookmarkList.vala"
	if (_tmp0_ == NULL) {
#line 642 "BookmarkList.c"
		FilesBookmarkList* _tmp1_;
#line 132 "../libcore/BookmarkList.vala"
		_tmp1_ = files_bookmark_list_new ();
#line 132 "../libcore/BookmarkList.vala"
		_g_object_unref0 (files_bookmark_list_instance);
#line 132 "../libcore/BookmarkList.vala"
		files_bookmark_list_instance = _tmp1_;
#line 650 "BookmarkList.c"
	}
#line 135 "../libcore/BookmarkList.vala"
	_tmp2_ = files_bookmark_list_instance;
#line 135 "../libcore/BookmarkList.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 135 "../libcore/BookmarkList.vala"
	result = _tmp3_;
#line 135 "../libcore/BookmarkList.vala"
	return result;
#line 660 "BookmarkList.c"
}

FilesBookmark*
files_bookmark_list_insert_uri (FilesBookmarkList* self,
                                const gchar* uri,
                                guint index,
                                const gchar* custom_name)
{
	FilesBookmark* bm = NULL;
	FilesBookmark* _tmp0_;
	FilesBookmark* result;
#line 138 "../libcore/BookmarkList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 138 "../libcore/BookmarkList.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 138 "../libcore/BookmarkList.vala"
	g_return_val_if_fail (custom_name != NULL, NULL);
#line 139 "../libcore/BookmarkList.vala"
	_tmp0_ = files_bookmark_new_from_uri (uri, custom_name);
#line 139 "../libcore/BookmarkList.vala"
	bm = _tmp0_;
#line 140 "../libcore/BookmarkList.vala"
	files_bookmark_list_insert_item_internal (self, bm, index);
#line 141 "../libcore/BookmarkList.vala"
	files_bookmark_list_save_bookmarks_file (self);
#line 142 "../libcore/BookmarkList.vala"
	result = bm;
#line 142 "../libcore/BookmarkList.vala"
	return result;
#line 690 "BookmarkList.c"
}

FilesBookmark*
files_bookmark_list_insert_uri_at_end (FilesBookmarkList* self,
                                       const gchar* uri,
                                       const gchar* custom_name)
{
	FilesBookmark* bm = NULL;
	FilesBookmark* _tmp0_;
	FilesBookmark* result;
#line 145 "../libcore/BookmarkList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 145 "../libcore/BookmarkList.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 145 "../libcore/BookmarkList.vala"
	g_return_val_if_fail (custom_name != NULL, NULL);
#line 146 "../libcore/BookmarkList.vala"
	_tmp0_ = files_bookmark_new_from_uri (uri, custom_name);
#line 146 "../libcore/BookmarkList.vala"
	bm = _tmp0_;
#line 147 "../libcore/BookmarkList.vala"
	files_bookmark_list_append_internal (self, bm);
#line 148 "../libcore/BookmarkList.vala"
	files_bookmark_list_save_bookmarks_file (self);
#line 149 "../libcore/BookmarkList.vala"
	result = bm;
#line 149 "../libcore/BookmarkList.vala"
	return result;
#line 719 "BookmarkList.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 152 "../libcore/BookmarkList.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 152 "../libcore/BookmarkList.vala"
	return _data1_;
#line 729 "BookmarkList.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 152 "../libcore/BookmarkList.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 739 "BookmarkList.c"
		FilesBookmarkList* self;
#line 152 "../libcore/BookmarkList.vala"
		self = _data1_->self;
#line 152 "../libcore/BookmarkList.vala"
		_g_object_unref0 (self);
#line 152 "../libcore/BookmarkList.vala"
		g_slice_free (Block1Data, _data1_);
#line 747 "BookmarkList.c"
	}
}

static void
__lambda24_ (Block1Data* _data1_,
             const gchar* uri)
{
	FilesBookmarkList* self;
	FilesBookmark* _tmp0_;
	FilesBookmark* _tmp1_;
	guint _tmp2_;
#line 157 "../libcore/BookmarkList.vala"
	self = _data1_->self;
#line 157 "../libcore/BookmarkList.vala"
	g_return_if_fail (uri != NULL);
#line 158 "../libcore/BookmarkList.vala"
	_tmp0_ = files_bookmark_new_from_uri (uri, "");
#line 158 "../libcore/BookmarkList.vala"
	_tmp1_ = _tmp0_;
#line 158 "../libcore/BookmarkList.vala"
	files_bookmark_list_insert_item_internal (self, _tmp1_, _data1_->index);
#line 158 "../libcore/BookmarkList.vala"
	_files_bookmark_unref0 (_tmp1_);
#line 159 "../libcore/BookmarkList.vala"
	_tmp2_ = _data1_->index;
#line 159 "../libcore/BookmarkList.vala"
	_data1_->index = _tmp2_ + 1;
#line 775 "BookmarkList.c"
}

static void
___lambda24__gfunc (gconstpointer data,
                    gpointer self)
{
#line 157 "../libcore/BookmarkList.vala"
	__lambda24_ (self, (const gchar*) data);
#line 784 "BookmarkList.c"
}

void
files_bookmark_list_insert_uris (FilesBookmarkList* self,
                                 GList* uris,
                                 guint index)
{
	Block1Data* _data1_;
	GList* _tmp0_;
#line 152 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 152 "../libcore/BookmarkList.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 152 "../libcore/BookmarkList.vala"
	_data1_->_ref_count_ = 1;
#line 152 "../libcore/BookmarkList.vala"
	_data1_->self = g_object_ref (self);
#line 152 "../libcore/BookmarkList.vala"
	_data1_->index = index;
#line 153 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->_list;
#line 153 "../libcore/BookmarkList.vala"
	if (_data1_->index > g_list_length (_tmp0_)) {
#line 154 "../libcore/BookmarkList.vala"
		g_critical ("BookmarkList.vala:154: Bookmarklist: Attempt to insert uri at out of r" \
"ange index");
#line 155 "../libcore/BookmarkList.vala"
		block1_data_unref (_data1_);
#line 155 "../libcore/BookmarkList.vala"
		_data1_ = NULL;
#line 155 "../libcore/BookmarkList.vala"
		return;
#line 816 "BookmarkList.c"
	}
#line 157 "../libcore/BookmarkList.vala"
	g_list_foreach (uris, ___lambda24__gfunc, _data1_);
#line 161 "../libcore/BookmarkList.vala"
	files_bookmark_list_save_bookmarks_file (self);
#line 152 "../libcore/BookmarkList.vala"
	block1_data_unref (_data1_);
#line 152 "../libcore/BookmarkList.vala"
	_data1_ = NULL;
#line 826 "BookmarkList.c"
}

gboolean
files_bookmark_list_contains (FilesBookmarkList* self,
                              FilesBookmark* bm)
{
	GList* _tmp0_;
	GCompareFunc _tmp1_;
	GList* _tmp2_;
	gboolean result;
#line 164 "../libcore/BookmarkList.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 164 "../libcore/BookmarkList.vala"
	g_return_val_if_fail (bm != NULL, FALSE);
#line 165 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->_list;
#line 165 "../libcore/BookmarkList.vala"
	_tmp1_ = files_bookmark_compare_with;
#line 165 "../libcore/BookmarkList.vala"
	_tmp2_ = g_list_find_custom (_tmp0_, bm, _tmp1_);
#line 165 "../libcore/BookmarkList.vala"
	result = _tmp2_ != NULL;
#line 165 "../libcore/BookmarkList.vala"
	return result;
#line 851 "BookmarkList.c"
}

void
files_bookmark_list_delete_item_at (FilesBookmarkList* self,
                                    guint index)
{
	GList* _tmp0_;
	GList* node = NULL;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	gconstpointer _tmp4_;
#line 168 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 169 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->_list;
#line 169 "../libcore/BookmarkList.vala"
	_vala_assert (index < g_list_length (_tmp0_), "index < list.length ()");
#line 170 "../libcore/BookmarkList.vala"
	_tmp1_ = self->priv->_list;
#line 170 "../libcore/BookmarkList.vala"
	_tmp2_ = g_list_nth (_tmp1_, index);
#line 170 "../libcore/BookmarkList.vala"
	node = _tmp2_;
#line 171 "../libcore/BookmarkList.vala"
	_tmp3_ = self->priv->_list;
#line 171 "../libcore/BookmarkList.vala"
	files_bookmark_list_set_list (self, g_list_remove_link (_tmp3_, node));
#line 172 "../libcore/BookmarkList.vala"
	_tmp4_ = node->data;
#line 172 "../libcore/BookmarkList.vala"
	files_bookmark_list_stop_monitoring_bookmark (self, (FilesBookmark*) _tmp4_);
#line 173 "../libcore/BookmarkList.vala"
	files_bookmark_list_save_bookmarks_file (self);
#line 886 "BookmarkList.c"
}

void
files_bookmark_list_rename_item_with_uri (FilesBookmarkList* self,
                                          const gchar* uri,
                                          const gchar* new_name)
{
	GList* _tmp0_;
#line 179 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 179 "../libcore/BookmarkList.vala"
	g_return_if_fail (uri != NULL);
#line 179 "../libcore/BookmarkList.vala"
	g_return_if_fail (new_name != NULL);
#line 180 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->_list;
#line 903 "BookmarkList.c"
	{
		GList* bookmark_collection = NULL;
		GList* bookmark_it = NULL;
#line 180 "../libcore/BookmarkList.vala"
		bookmark_collection = _tmp0_;
#line 180 "../libcore/BookmarkList.vala"
		for (bookmark_it = bookmark_collection; bookmark_it != NULL; bookmark_it = bookmark_it->next) {
#line 911 "BookmarkList.c"
			FilesBookmark* bookmark = NULL;
#line 180 "../libcore/BookmarkList.vala"
			bookmark = (FilesBookmark*) bookmark_it->data;
#line 915 "BookmarkList.c"
			{
				FilesBookmark* _tmp1_;
				const gchar* _tmp2_;
				const gchar* _tmp3_;
#line 181 "../libcore/BookmarkList.vala"
				_tmp1_ = bookmark;
#line 181 "../libcore/BookmarkList.vala"
				_tmp2_ = files_bookmark_get_uri (_tmp1_);
#line 181 "../libcore/BookmarkList.vala"
				_tmp3_ = _tmp2_;
#line 181 "../libcore/BookmarkList.vala"
				if (g_strcmp0 (uri, _tmp3_) == 0) {
#line 928 "BookmarkList.c"
					gchar* _tmp4_;
					gchar* _tmp5_;
					gboolean _tmp6_;
#line 182 "../libcore/BookmarkList.vala"
					_tmp4_ = g_path_get_basename (uri);
#line 182 "../libcore/BookmarkList.vala"
					_tmp5_ = _tmp4_;
#line 182 "../libcore/BookmarkList.vala"
					_tmp6_ = g_strcmp0 (new_name, _tmp5_) == 0;
#line 182 "../libcore/BookmarkList.vala"
					_g_free0 (_tmp5_);
#line 182 "../libcore/BookmarkList.vala"
					if (_tmp6_) {
#line 942 "BookmarkList.c"
						FilesBookmark* _tmp7_;
#line 184 "../libcore/BookmarkList.vala"
						_tmp7_ = bookmark;
#line 184 "../libcore/BookmarkList.vala"
						files_bookmark_set_custom_name (_tmp7_, "");
#line 948 "BookmarkList.c"
					} else {
						FilesBookmark* _tmp8_;
#line 186 "../libcore/BookmarkList.vala"
						_tmp8_ = bookmark;
#line 186 "../libcore/BookmarkList.vala"
						files_bookmark_set_custom_name (_tmp8_, new_name);
#line 955 "BookmarkList.c"
					}
#line 189 "../libcore/BookmarkList.vala"
					files_bookmark_list_save_bookmarks_file (self);
#line 190 "../libcore/BookmarkList.vala"
					return;
#line 961 "BookmarkList.c"
				}
			}
		}
	}
}

void
files_bookmark_list_delete_items_with_uri (FilesBookmarkList* self,
                                           const gchar* uri)
{
	gboolean list_changed = FALSE;
	GList* node = NULL;
	GList* _tmp0_;
	GList* next = NULL;
	GList* _tmp1_;
	GList* _tmp2_;
#line 195 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 195 "../libcore/BookmarkList.vala"
	g_return_if_fail (uri != NULL);
#line 196 "../libcore/BookmarkList.vala"
	list_changed = FALSE;
#line 197 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->_list;
#line 197 "../libcore/BookmarkList.vala"
	node = _tmp0_;
#line 198 "../libcore/BookmarkList.vala"
	_tmp1_ = node;
#line 198 "../libcore/BookmarkList.vala"
	_tmp2_ = _tmp1_->next;
#line 198 "../libcore/BookmarkList.vala"
	next = _tmp2_;
#line 994 "BookmarkList.c"
	{
		GList* _tmp3_;
		gboolean _tmp4_ = FALSE;
#line 200 "../libcore/BookmarkList.vala"
		_tmp3_ = self->priv->_list;
#line 200 "../libcore/BookmarkList.vala"
		node = _tmp3_;
#line 200 "../libcore/BookmarkList.vala"
		_tmp4_ = TRUE;
#line 200 "../libcore/BookmarkList.vala"
		while (TRUE) {
#line 1006 "BookmarkList.c"
			GList* _tmp6_;
			GList* _tmp7_;
			GList* _tmp8_;
			GList* _tmp9_;
			gconstpointer _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 200 "../libcore/BookmarkList.vala"
			if (!_tmp4_) {
#line 1016 "BookmarkList.c"
				GList* _tmp5_;
#line 200 "../libcore/BookmarkList.vala"
				_tmp5_ = next;
#line 200 "../libcore/BookmarkList.vala"
				node = _tmp5_;
#line 1022 "BookmarkList.c"
			}
#line 200 "../libcore/BookmarkList.vala"
			_tmp4_ = FALSE;
#line 200 "../libcore/BookmarkList.vala"
			_tmp6_ = node;
#line 200 "../libcore/BookmarkList.vala"
			if (!(_tmp6_ != NULL)) {
#line 200 "../libcore/BookmarkList.vala"
				break;
#line 1032 "BookmarkList.c"
			}
#line 201 "../libcore/BookmarkList.vala"
			_tmp7_ = node;
#line 201 "../libcore/BookmarkList.vala"
			_tmp8_ = _tmp7_->next;
#line 201 "../libcore/BookmarkList.vala"
			next = _tmp8_;
#line 202 "../libcore/BookmarkList.vala"
			_tmp9_ = node;
#line 202 "../libcore/BookmarkList.vala"
			_tmp10_ = _tmp9_->data;
#line 202 "../libcore/BookmarkList.vala"
			_tmp11_ = files_bookmark_get_uri ((FilesBookmark*) _tmp10_);
#line 202 "../libcore/BookmarkList.vala"
			_tmp12_ = _tmp11_;
#line 202 "../libcore/BookmarkList.vala"
			if (g_strcmp0 (uri, _tmp12_) == 0) {
#line 1050 "BookmarkList.c"
				GList* _tmp13_;
				GList* _tmp14_;
				GList* _tmp15_;
				gconstpointer _tmp16_;
#line 203 "../libcore/BookmarkList.vala"
				_tmp13_ = self->priv->_list;
#line 203 "../libcore/BookmarkList.vala"
				_tmp14_ = node;
#line 203 "../libcore/BookmarkList.vala"
				files_bookmark_list_set_list (self, g_list_remove_link (_tmp13_, _tmp14_));
#line 204 "../libcore/BookmarkList.vala"
				_tmp15_ = node;
#line 204 "../libcore/BookmarkList.vala"
				_tmp16_ = _tmp15_->data;
#line 204 "../libcore/BookmarkList.vala"
				files_bookmark_list_stop_monitoring_bookmark (self, (FilesBookmark*) _tmp16_);
#line 205 "../libcore/BookmarkList.vala"
				list_changed = TRUE;
#line 1069 "BookmarkList.c"
			}
		}
	}
#line 209 "../libcore/BookmarkList.vala"
	if (list_changed) {
#line 210 "../libcore/BookmarkList.vala"
		files_bookmark_list_save_bookmarks_file (self);
#line 1077 "BookmarkList.c"
	}
}

guint
files_bookmark_list_length (FilesBookmarkList* self)
{
	GList* _tmp0_;
	guint result;
#line 214 "../libcore/BookmarkList.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 215 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->_list;
#line 215 "../libcore/BookmarkList.vala"
	result = g_list_length (_tmp0_);
#line 215 "../libcore/BookmarkList.vala"
	return result;
#line 1094 "BookmarkList.c"
}

FilesBookmark*
files_bookmark_list_item_at (FilesBookmarkList* self,
                             guint index)
{
	GList* _tmp0_;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	FilesBookmark* result;
#line 218 "../libcore/BookmarkList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 219 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->_list;
#line 219 "../libcore/BookmarkList.vala"
	_vala_assert (index < g_list_length (_tmp0_), "index < list.length ()");
#line 220 "../libcore/BookmarkList.vala"
	_tmp1_ = self->priv->_list;
#line 220 "../libcore/BookmarkList.vala"
	_tmp2_ = g_list_nth_data (_tmp1_, index);
#line 220 "../libcore/BookmarkList.vala"
	result = (FilesBookmark*) _tmp2_;
#line 220 "../libcore/BookmarkList.vala"
	return result;
#line 1119 "BookmarkList.c"
}

static gpointer
_files_bookmark_ref0 (gpointer self)
{
#line 227 "../libcore/BookmarkList.vala"
	return self ? files_bookmark_ref (self) : NULL;
#line 1127 "BookmarkList.c"
}

static GList*
vala_g_list_remove_full (GList* self,
                         gconstpointer data,
                         GFreeFunc func)
{
	GList* l = NULL;
	GList* result;
#line 5185 "glib-2.0.vapi"
	l = self;
#line 5186 "glib-2.0.vapi"
	while (TRUE) {
#line 1141 "BookmarkList.c"
		GList* _tmp0_;
		GList* _tmp1_;
		gconstpointer _tmp2_;
#line 5186 "glib-2.0.vapi"
		_tmp0_ = l;
#line 5186 "glib-2.0.vapi"
		if (!(_tmp0_ != NULL)) {
#line 5186 "glib-2.0.vapi"
			break;
#line 1151 "BookmarkList.c"
		}
#line 5187 "glib-2.0.vapi"
		_tmp1_ = l;
#line 5187 "glib-2.0.vapi"
		_tmp2_ = ((GList*) _tmp1_)->data;
#line 5187 "glib-2.0.vapi"
		if (_tmp2_ != data) {
#line 1159 "BookmarkList.c"
			GList* _tmp3_;
			GList* _tmp4_;
#line 5188 "glib-2.0.vapi"
			_tmp3_ = l;
#line 5188 "glib-2.0.vapi"
			_tmp4_ = ((GList*) _tmp3_)->next;
#line 5188 "glib-2.0.vapi"
			l = _tmp4_;
#line 1168 "BookmarkList.c"
		} else {
			GList* _tmp5_;
			gconstpointer _tmp6_;
			GList* _tmp7_;
#line 5190 "glib-2.0.vapi"
			_tmp5_ = l;
#line 5190 "glib-2.0.vapi"
			_tmp6_ = ((GList*) _tmp5_)->data;
#line 5190 "glib-2.0.vapi"
			func (_tmp6_);
#line 5191 "glib-2.0.vapi"
			_tmp7_ = l;
#line 5191 "glib-2.0.vapi"
			self = g_list_delete_link (self, (GList*) _tmp7_);
#line 5192 "glib-2.0.vapi"
			break;
#line 1185 "BookmarkList.c"
		}
	}
#line 5195 "glib-2.0.vapi"
	result = self;
#line 5195 "glib-2.0.vapi"
	return result;
#line 1192 "BookmarkList.c"
}

void
files_bookmark_list_move_item_uri (FilesBookmarkList* self,
                                   const gchar* uri,
                                   gint step)
{
	gboolean list_changed = FALSE;
	gint index = 0;
	GList* _tmp0_;
#line 223 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 223 "../libcore/BookmarkList.vala"
	g_return_if_fail (uri != NULL);
#line 224 "../libcore/BookmarkList.vala"
	list_changed = FALSE;
#line 225 "../libcore/BookmarkList.vala"
	index = 0;
#line 227 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->_list;
#line 1213 "BookmarkList.c"
	{
		GList* bm_collection = NULL;
		GList* bm_it = NULL;
#line 227 "../libcore/BookmarkList.vala"
		bm_collection = _tmp0_;
#line 227 "../libcore/BookmarkList.vala"
		for (bm_it = bm_collection; bm_it != NULL; bm_it = bm_it->next) {
#line 1221 "BookmarkList.c"
			FilesBookmark* _tmp1_;
			FilesBookmark* bm = NULL;
#line 227 "../libcore/BookmarkList.vala"
			_tmp1_ = _files_bookmark_ref0 ((FilesBookmark*) bm_it->data);
#line 227 "../libcore/BookmarkList.vala"
			bm = _tmp1_;
#line 1228 "BookmarkList.c"
			{
				FilesBookmark* _tmp2_;
				const gchar* _tmp3_;
				const gchar* _tmp4_;
				gint _tmp10_;
#line 228 "../libcore/BookmarkList.vala"
				_tmp2_ = bm;
#line 228 "../libcore/BookmarkList.vala"
				_tmp3_ = files_bookmark_get_uri (_tmp2_);
#line 228 "../libcore/BookmarkList.vala"
				_tmp4_ = _tmp3_;
#line 228 "../libcore/BookmarkList.vala"
				if (g_strcmp0 (uri, _tmp4_) == 0) {
#line 1242 "BookmarkList.c"
					GList* _tmp5_;
					FilesBookmark* _tmp6_;
					GList* _tmp7_;
					FilesBookmark* _tmp8_;
					FilesBookmark* _tmp9_;
#line 229 "../libcore/BookmarkList.vala"
					_tmp5_ = self->priv->_list;
#line 229 "../libcore/BookmarkList.vala"
					_tmp6_ = bm;
#line 229 "../libcore/BookmarkList.vala"
					files_bookmark_list_set_list (self, vala_g_list_remove_full (_tmp5_, _tmp6_, _files_bookmark_unref0_));
#line 230 "../libcore/BookmarkList.vala"
					_tmp7_ = self->priv->_list;
#line 230 "../libcore/BookmarkList.vala"
					_tmp8_ = bm;
#line 230 "../libcore/BookmarkList.vala"
					_tmp9_ = _files_bookmark_ref0 (_tmp8_);
#line 230 "../libcore/BookmarkList.vala"
					files_bookmark_list_set_list (self, g_list_insert (_tmp7_, _tmp9_, index + step));
#line 231 "../libcore/BookmarkList.vala"
					list_changed = TRUE;
#line 233 "../libcore/BookmarkList.vala"
					_files_bookmark_unref0 (bm);
#line 233 "../libcore/BookmarkList.vala"
					break;
#line 1268 "BookmarkList.c"
				}
#line 236 "../libcore/BookmarkList.vala"
				_tmp10_ = index;
#line 236 "../libcore/BookmarkList.vala"
				index = _tmp10_ + 1;
#line 227 "../libcore/BookmarkList.vala"
				_files_bookmark_unref0 (bm);
#line 1276 "BookmarkList.c"
			}
		}
	}
#line 239 "../libcore/BookmarkList.vala"
	if (list_changed) {
#line 240 "../libcore/BookmarkList.vala"
		files_bookmark_list_save_bookmarks_file (self);
#line 1284 "BookmarkList.c"
	}
}

static void
files_bookmark_list_append_internal (FilesBookmarkList* self,
                                     FilesBookmark* bookmark)
{
#line 244 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 244 "../libcore/BookmarkList.vala"
	g_return_if_fail (bookmark != NULL);
#line 245 "../libcore/BookmarkList.vala"
	files_bookmark_list_insert_item_internal (self, bookmark, (guint) -1);
#line 1298 "BookmarkList.c"
}

static void
files_bookmark_list_insert_item_internal (FilesBookmarkList* self,
                                          FilesBookmark* bm,
                                          guint index)
{
	gchar* path = NULL;
	FilesFile* _tmp0_;
	FilesFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_;
	GList* _tmp11_;
	FilesBookmark* _tmp12_;
#line 248 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 248 "../libcore/BookmarkList.vala"
	g_return_if_fail (bm != NULL);
#line 249 "../libcore/BookmarkList.vala"
	if (files_bookmark_list_contains (self, bm)) {
#line 250 "../libcore/BookmarkList.vala"
		return;
#line 1327 "BookmarkList.c"
	}
#line 253 "../libcore/BookmarkList.vala"
	_tmp0_ = files_bookmark_get_gof_file (bm);
#line 253 "../libcore/BookmarkList.vala"
	_tmp1_ = _tmp0_;
#line 253 "../libcore/BookmarkList.vala"
	_tmp2_ = files_file_get_location (_tmp1_);
#line 253 "../libcore/BookmarkList.vala"
	_tmp3_ = _tmp2_;
#line 253 "../libcore/BookmarkList.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 253 "../libcore/BookmarkList.vala"
	path = _tmp4_;
#line 255 "../libcore/BookmarkList.vala"
	_tmp6_ = path;
#line 255 "../libcore/BookmarkList.vala"
	_tmp7_ = pf_user_utils_get_real_user_home ();
#line 255 "../libcore/BookmarkList.vala"
	_tmp8_ = _tmp7_;
#line 255 "../libcore/BookmarkList.vala"
	_tmp9_ = g_strcmp0 (_tmp6_, _tmp8_) == 0;
#line 255 "../libcore/BookmarkList.vala"
	_g_free0 (_tmp8_);
#line 255 "../libcore/BookmarkList.vala"
	if (_tmp9_) {
#line 255 "../libcore/BookmarkList.vala"
		_tmp5_ = TRUE;
#line 1355 "BookmarkList.c"
	} else {
		const gchar* _tmp10_;
#line 255 "../libcore/BookmarkList.vala"
		_tmp10_ = path;
#line 255 "../libcore/BookmarkList.vala"
		_tmp5_ = g_strcmp0 (_tmp10_, G_DIR_SEPARATOR_S) == 0;
#line 1362 "BookmarkList.c"
	}
#line 255 "../libcore/BookmarkList.vala"
	if (_tmp5_) {
#line 256 "../libcore/BookmarkList.vala"
		_g_free0 (path);
#line 256 "../libcore/BookmarkList.vala"
		return;
#line 1370 "BookmarkList.c"
	}
#line 259 "../libcore/BookmarkList.vala"
	_tmp11_ = self->priv->_list;
#line 259 "../libcore/BookmarkList.vala"
	_tmp12_ = _files_bookmark_ref0 (bm);
#line 259 "../libcore/BookmarkList.vala"
	files_bookmark_list_set_list (self, g_list_insert (_tmp11_, _tmp12_, (gint) index));
#line 260 "../libcore/BookmarkList.vala"
	files_bookmark_list_start_monitoring_bookmark (self, bm);
#line 248 "../libcore/BookmarkList.vala"
	_g_free0 (path);
#line 1382 "BookmarkList.c"
}

static void
files_bookmark_list_load_bookmarks_file (FilesBookmarkList* self)
{
#line 263 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 264 "../libcore/BookmarkList.vala"
	files_bookmark_list_schedule_job (self, FILES_BOOKMARK_LIST_JOB_TYPE_LOAD);
#line 1392 "BookmarkList.c"
}

static void
files_bookmark_list_save_bookmarks_file (FilesBookmarkList* self)
{
#line 267 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 268 "../libcore/BookmarkList.vala"
	files_bookmark_list_schedule_job (self, FILES_BOOKMARK_LIST_JOB_TYPE_SAVE);
#line 1402 "BookmarkList.c"
}

static void
files_bookmark_list_schedule_job (FilesBookmarkList* self,
                                  FilesBookmarkListJobType job)
{
	GQueue* _tmp0_;
	GQueue* _tmp1_;
#line 271 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 272 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->pending_ops;
#line 272 "../libcore/BookmarkList.vala"
	g_queue_push_head (_tmp0_, (gpointer) ((gintptr) job));
#line 273 "../libcore/BookmarkList.vala"
	_tmp1_ = self->priv->pending_ops;
#line 273 "../libcore/BookmarkList.vala"
	if (_tmp1_->length == ((guint) 1)) {
#line 274 "../libcore/BookmarkList.vala"
		files_bookmark_list_process_next_op (self);
#line 1423 "BookmarkList.c"
	}
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 278 "../libcore/BookmarkList.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 278 "../libcore/BookmarkList.vala"
	return _data2_;
#line 1434 "BookmarkList.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 278 "../libcore/BookmarkList.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 1444 "BookmarkList.c"
		FilesBookmarkList* self;
#line 278 "../libcore/BookmarkList.vala"
		self = _data2_->self;
#line 278 "../libcore/BookmarkList.vala"
		_g_object_unref0 (_data2_->file);
#line 278 "../libcore/BookmarkList.vala"
		_g_object_unref0 (self);
#line 278 "../libcore/BookmarkList.vala"
		g_slice_free (Block2Data, _data2_);
#line 1454 "BookmarkList.c"
	}
}

static void
_files_bookmark_list_files_ready_filescallwhenreadycall_when_ready_func (GList* files,
                                                                         gpointer self)
{
#line 286 "../libcore/BookmarkList.vala"
	files_bookmark_list_files_ready ((FilesBookmarkList*) self, files);
#line 1464 "BookmarkList.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 286 "../libcore/BookmarkList.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1472 "BookmarkList.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 286 "../libcore/BookmarkList.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1480 "BookmarkList.c"
}

static void
__lambda20_ (Block2Data* _data2_,
             GObject* obj,
             GAsyncResult* res)
{
	FilesBookmarkList* self;
	GError* _inner_error0_ = NULL;
#line 280 "../libcore/BookmarkList.vala"
	self = _data2_->self;
#line 280 "../libcore/BookmarkList.vala"
	g_return_if_fail (res != NULL);
#line 1494 "BookmarkList.c"
	{
		guint8* contents = NULL;
		gint contents_length1 = 0;
		gint _contents_size_ = 0;
		guint8* _tmp0_ = NULL;
		gsize _tmp1_ = 0;
#line 283 "../libcore/BookmarkList.vala"
		g_file_load_contents_finish (_data2_->file, res, &_tmp0_, &_tmp1_, NULL, &_inner_error0_);
#line 283 "../libcore/BookmarkList.vala"
		contents = (g_free (contents), NULL);
#line 283 "../libcore/BookmarkList.vala"
		contents = _tmp0_;
#line 283 "../libcore/BookmarkList.vala"
		contents_length1 = _tmp1_;
#line 283 "../libcore/BookmarkList.vala"
		_contents_size_ = contents_length1;
#line 283 "../libcore/BookmarkList.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 283 "../libcore/BookmarkList.vala"
			contents = (g_free (contents), NULL);
#line 1515 "BookmarkList.c"
			goto __catch0_g_error;
		}
#line 284 "../libcore/BookmarkList.vala"
		if (contents != NULL) {
#line 1520 "BookmarkList.c"
			GList* _tmp2_;
			GList* _tmp3_;
			FilesCallWhenReady* _tmp4_;
#line 285 "../libcore/BookmarkList.vala"
			files_bookmark_list_bookmark_list_from_string (self, (const gchar*) contents);
#line 286 "../libcore/BookmarkList.vala"
			_tmp2_ = files_bookmark_list_get_gof_file_list (self);
#line 286 "../libcore/BookmarkList.vala"
			_tmp3_ = _tmp2_;
#line 286 "../libcore/BookmarkList.vala"
			_tmp4_ = files_call_when_ready_new (_tmp3_, _files_bookmark_list_files_ready_filescallwhenreadycall_when_ready_func, self);
#line 286 "../libcore/BookmarkList.vala"
			_g_object_unref0 (self->priv->call_when_ready);
#line 286 "../libcore/BookmarkList.vala"
			self->priv->call_when_ready = _tmp4_;
#line 286 "../libcore/BookmarkList.vala"
			(_tmp3_ == NULL) ? NULL : (_tmp3_ = (_g_list_free__g_object_unref0_ (_tmp3_), NULL));
#line 287 "../libcore/BookmarkList.vala"
			g_signal_emit (self, files_bookmark_list_signals[FILES_BOOKMARK_LIST_LOADED_SIGNAL], 0);
#line 1540 "BookmarkList.c"
		}
#line 281 "../libcore/BookmarkList.vala"
		contents = (g_free (contents), NULL);
#line 1544 "BookmarkList.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 281 "../libcore/BookmarkList.vala"
		_error_ = _inner_error0_;
#line 281 "../libcore/BookmarkList.vala"
		_inner_error0_ = NULL;
#line 291 "../libcore/BookmarkList.vala"
		_tmp5_ = _error_;
#line 291 "../libcore/BookmarkList.vala"
		_tmp6_ = _tmp5_->message;
#line 291 "../libcore/BookmarkList.vala"
		g_critical ("BookmarkList.vala:291: Error loadinging bookmark file %s", _tmp6_);
#line 281 "../libcore/BookmarkList.vala"
		_g_error_free0 (_error_);
#line 1564 "BookmarkList.c"
	}
	__finally0:
#line 281 "../libcore/BookmarkList.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 281 "../libcore/BookmarkList.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 281 "../libcore/BookmarkList.vala"
		g_clear_error (&_inner_error0_);
#line 281 "../libcore/BookmarkList.vala"
		return;
#line 1575 "BookmarkList.c"
	}
#line 293 "../libcore/BookmarkList.vala"
	files_bookmark_list_op_processed_call_back (self);
#line 1579 "BookmarkList.c"
}

static void
___lambda20__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 280 "../libcore/BookmarkList.vala"
	__lambda20_ (self, source_object, res);
#line 280 "../libcore/BookmarkList.vala"
	block2_data_unref (self);
#line 1591 "BookmarkList.c"
}

static void
files_bookmark_list_load_bookmarks_file_async (FilesBookmarkList* self)
{
	Block2Data* _data2_;
	GFile* _tmp0_;
#line 278 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 278 "../libcore/BookmarkList.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 278 "../libcore/BookmarkList.vala"
	_data2_->_ref_count_ = 1;
#line 278 "../libcore/BookmarkList.vala"
	_data2_->self = g_object_ref (self);
#line 279 "../libcore/BookmarkList.vala"
	_tmp0_ = files_bookmark_list_get_bookmarks_file ();
#line 279 "../libcore/BookmarkList.vala"
	_data2_->file = _tmp0_;
#line 280 "../libcore/BookmarkList.vala"
	g_file_load_contents_async (_data2_->file, NULL, ___lambda20__gasync_ready_callback, block2_data_ref (_data2_));
#line 278 "../libcore/BookmarkList.vala"
	block2_data_unref (_data2_);
#line 278 "../libcore/BookmarkList.vala"
	_data2_ = NULL;
#line 1617 "BookmarkList.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 297 "../libcore/BookmarkList.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 297 "../libcore/BookmarkList.vala"
	return _data3_;
#line 1627 "BookmarkList.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 297 "../libcore/BookmarkList.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 1637 "BookmarkList.c"
		FilesBookmarkList* self;
#line 297 "../libcore/BookmarkList.vala"
		self = _data3_->self;
#line 297 "../libcore/BookmarkList.vala"
		(_data3_->files == NULL) ? NULL : (_data3_->files = (_g_list_free__g_object_unref0_ (_data3_->files), NULL));
#line 297 "../libcore/BookmarkList.vala"
		_g_object_unref0 (self);
#line 297 "../libcore/BookmarkList.vala"
		g_slice_free (Block3Data, _data3_);
#line 1647 "BookmarkList.c"
	}
}

static void
__lambda21_ (Block3Data* _data3_,
             FilesBookmark* bm)
{
	FilesBookmarkList* self;
	FilesFile* _tmp0_;
	FilesFile* _tmp1_;
	FilesFile* _tmp2_;
#line 299 "../libcore/BookmarkList.vala"
	self = _data3_->self;
#line 299 "../libcore/BookmarkList.vala"
	g_return_if_fail (bm != NULL);
#line 300 "../libcore/BookmarkList.vala"
	_tmp0_ = files_bookmark_get_gof_file (bm);
#line 300 "../libcore/BookmarkList.vala"
	_tmp1_ = _tmp0_;
#line 300 "../libcore/BookmarkList.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 300 "../libcore/BookmarkList.vala"
	_data3_->files = g_list_prepend (_data3_->files, _tmp2_);
#line 1671 "BookmarkList.c"
}

static void
___lambda21__gfunc (gconstpointer data,
                    gpointer self)
{
#line 299 "../libcore/BookmarkList.vala"
	__lambda21_ (self, (FilesBookmark*) data);
#line 1680 "BookmarkList.c"
}

static GList*
files_bookmark_list_get_gof_file_list (FilesBookmarkList* self)
{
	Block3Data* _data3_;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* result;
#line 297 "../libcore/BookmarkList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 297 "../libcore/BookmarkList.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 297 "../libcore/BookmarkList.vala"
	_data3_->_ref_count_ = 1;
#line 297 "../libcore/BookmarkList.vala"
	_data3_->self = g_object_ref (self);
#line 298 "../libcore/BookmarkList.vala"
	_data3_->files = NULL;
#line 299 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->_list;
#line 299 "../libcore/BookmarkList.vala"
	g_list_foreach (_tmp0_, ___lambda21__gfunc, _data3_);
#line 302 "../libcore/BookmarkList.vala"
	_tmp1_ = _data3_->files;
#line 302 "../libcore/BookmarkList.vala"
	_data3_->files = NULL;
#line 302 "../libcore/BookmarkList.vala"
	result = _tmp1_;
#line 302 "../libcore/BookmarkList.vala"
	block3_data_unref (_data3_);
#line 302 "../libcore/BookmarkList.vala"
	_data3_ = NULL;
#line 302 "../libcore/BookmarkList.vala"
	return result;
#line 1716 "BookmarkList.c"
}

static void
files_bookmark_list_files_ready (FilesBookmarkList* self,
                                 GList* files)
{
#line 305 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 307 "../libcore/BookmarkList.vala"
	_g_object_unref0 (self->priv->call_when_ready);
#line 307 "../libcore/BookmarkList.vala"
	self->priv->call_when_ready = NULL;
#line 1729 "BookmarkList.c"
}

static void
_files_bookmark_list_stop_monitoring_bookmark_gfunc (gconstpointer data,
                                                     gpointer self)
{
#line 311 "../libcore/BookmarkList.vala"
	files_bookmark_list_stop_monitoring_bookmark ((FilesBookmarkList*) self, (FilesBookmark*) data);
#line 1738 "BookmarkList.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 1755 "BookmarkList.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 1776 "BookmarkList.c"
}

static void
_files_bookmark_list_start_monitoring_bookmark_gfunc (gconstpointer data,
                                                      gpointer self)
{
#line 337 "../libcore/BookmarkList.vala"
	files_bookmark_list_start_monitoring_bookmark ((FilesBookmarkList*) self, (FilesBookmark*) data);
#line 1785 "BookmarkList.c"
}

static void
files_bookmark_list_bookmark_list_from_string (FilesBookmarkList* self,
                                               const gchar* contents)
{
	GList* _tmp0_;
	guint count = 0U;
	gboolean change_made = FALSE;
	gchar** lines = NULL;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	GList* _tmp36_;
	gboolean _tmp37_ = FALSE;
#line 310 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 310 "../libcore/BookmarkList.vala"
	g_return_if_fail (contents != NULL);
#line 311 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->_list;
#line 311 "../libcore/BookmarkList.vala"
	g_list_foreach (_tmp0_, _files_bookmark_list_stop_monitoring_bookmark_gfunc, self);
#line 313 "../libcore/BookmarkList.vala"
	count = (guint) 0;
#line 314 "../libcore/BookmarkList.vala"
	change_made = FALSE;
#line 315 "../libcore/BookmarkList.vala"
	_tmp2_ = _tmp1_ = g_strsplit (contents, "\n", 0);
#line 315 "../libcore/BookmarkList.vala"
	lines = _tmp2_;
#line 315 "../libcore/BookmarkList.vala"
	lines_length1 = _vala_array_length (_tmp1_);
#line 315 "../libcore/BookmarkList.vala"
	_lines_size_ = lines_length1;
#line 316 "../libcore/BookmarkList.vala"
	_tmp3_ = lines;
#line 316 "../libcore/BookmarkList.vala"
	_tmp3__length1 = lines_length1;
#line 1828 "BookmarkList.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 316 "../libcore/BookmarkList.vala"
		line_collection = _tmp3_;
#line 316 "../libcore/BookmarkList.vala"
		line_collection_length1 = _tmp3__length1;
#line 316 "../libcore/BookmarkList.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1840 "BookmarkList.c"
			gchar* _tmp4_;
			gchar* line = NULL;
#line 316 "../libcore/BookmarkList.vala"
			_tmp4_ = g_strdup (line_collection[line_it]);
#line 316 "../libcore/BookmarkList.vala"
			line = _tmp4_;
#line 1847 "BookmarkList.c"
			{
				gboolean _tmp5_ = FALSE;
				const gchar* _tmp6_;
				gchar** parts = NULL;
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gchar** _tmp10_;
				gint parts_length1;
				gint _parts_size_;
				gchar* uri = NULL;
				gchar** _tmp11_;
				gint _tmp11__length1;
				const gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_ = NULL;
				gchar** _tmp15_;
				gint _tmp15__length1;
				gchar* custom_name = NULL;
				gchar* _tmp18_;
				gboolean _tmp19_ = FALSE;
				const gchar* _tmp20_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				FilesBookmark* _tmp33_;
				FilesBookmark* _tmp34_;
				guint _tmp35_;
#line 317 "../libcore/BookmarkList.vala"
				_tmp6_ = line;
#line 317 "../libcore/BookmarkList.vala"
				if (string_get (_tmp6_, (glong) 0) == '\0') {
#line 317 "../libcore/BookmarkList.vala"
					_tmp5_ = TRUE;
#line 1880 "BookmarkList.c"
				} else {
					const gchar* _tmp7_;
#line 317 "../libcore/BookmarkList.vala"
					_tmp7_ = line;
#line 317 "../libcore/BookmarkList.vala"
					_tmp5_ = string_get (_tmp7_, (glong) 0) == ' ';
#line 1887 "BookmarkList.c"
				}
#line 317 "../libcore/BookmarkList.vala"
				if (_tmp5_) {
#line 318 "../libcore/BookmarkList.vala"
					_g_free0 (line);
#line 318 "../libcore/BookmarkList.vala"
					continue;
#line 1895 "BookmarkList.c"
				}
#line 321 "../libcore/BookmarkList.vala"
				_tmp8_ = line;
#line 321 "../libcore/BookmarkList.vala"
				_tmp10_ = _tmp9_ = g_strsplit (_tmp8_, " ", 2);
#line 321 "../libcore/BookmarkList.vala"
				parts = _tmp10_;
#line 321 "../libcore/BookmarkList.vala"
				parts_length1 = _vala_array_length (_tmp9_);
#line 321 "../libcore/BookmarkList.vala"
				_parts_size_ = parts_length1;
#line 322 "../libcore/BookmarkList.vala"
				_tmp11_ = parts;
#line 322 "../libcore/BookmarkList.vala"
				_tmp11__length1 = parts_length1;
#line 322 "../libcore/BookmarkList.vala"
				_tmp12_ = _tmp11_[0];
#line 322 "../libcore/BookmarkList.vala"
				_tmp13_ = g_strdup (_tmp12_);
#line 322 "../libcore/BookmarkList.vala"
				uri = _tmp13_;
#line 323 "../libcore/BookmarkList.vala"
				_tmp15_ = parts;
#line 323 "../libcore/BookmarkList.vala"
				_tmp15__length1 = parts_length1;
#line 323 "../libcore/BookmarkList.vala"
				if (_tmp15__length1 == 2) {
#line 1923 "BookmarkList.c"
					gchar** _tmp16_;
					gint _tmp16__length1;
					const gchar* _tmp17_;
#line 323 "../libcore/BookmarkList.vala"
					_tmp16_ = parts;
#line 323 "../libcore/BookmarkList.vala"
					_tmp16__length1 = parts_length1;
#line 323 "../libcore/BookmarkList.vala"
					_tmp17_ = _tmp16_[1];
#line 323 "../libcore/BookmarkList.vala"
					_tmp14_ = _tmp17_;
#line 1935 "BookmarkList.c"
				} else {
#line 323 "../libcore/BookmarkList.vala"
					_tmp14_ = "";
#line 1939 "BookmarkList.c"
				}
#line 323 "../libcore/BookmarkList.vala"
				_tmp18_ = g_strdup (_tmp14_);
#line 323 "../libcore/BookmarkList.vala"
				custom_name = _tmp18_;
#line 324 "../libcore/BookmarkList.vala"
				_tmp20_ = custom_name;
#line 324 "../libcore/BookmarkList.vala"
				if (g_strcmp0 (_tmp20_, "") != 0) {
#line 1949 "BookmarkList.c"
					gboolean _tmp21_ = FALSE;
					const gchar* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
					gboolean _tmp25_;
#line 325 "../libcore/BookmarkList.vala"
					_tmp22_ = custom_name;
#line 325 "../libcore/BookmarkList.vala"
					_tmp23_ = string_strip (_tmp22_);
#line 325 "../libcore/BookmarkList.vala"
					_tmp24_ = _tmp23_;
#line 325 "../libcore/BookmarkList.vala"
					_tmp25_ = g_strcmp0 (_tmp24_, "") == 0;
#line 325 "../libcore/BookmarkList.vala"
					_g_free0 (_tmp24_);
#line 325 "../libcore/BookmarkList.vala"
					if (_tmp25_) {
#line 325 "../libcore/BookmarkList.vala"
						_tmp21_ = TRUE;
#line 1969 "BookmarkList.c"
					} else {
						const gchar* _tmp26_;
						const gchar* _tmp27_;
						gchar* _tmp28_;
						gchar* _tmp29_;
#line 326 "../libcore/BookmarkList.vala"
						_tmp26_ = custom_name;
#line 326 "../libcore/BookmarkList.vala"
						_tmp27_ = uri;
#line 326 "../libcore/BookmarkList.vala"
						_tmp28_ = g_path_get_basename (_tmp27_);
#line 326 "../libcore/BookmarkList.vala"
						_tmp29_ = _tmp28_;
#line 326 "../libcore/BookmarkList.vala"
						_tmp21_ = g_strcmp0 (_tmp26_, _tmp29_) == 0;
#line 326 "../libcore/BookmarkList.vala"
						_g_free0 (_tmp29_);
#line 1987 "BookmarkList.c"
					}
#line 325 "../libcore/BookmarkList.vala"
					_tmp19_ = _tmp21_;
#line 1991 "BookmarkList.c"
				} else {
#line 324 "../libcore/BookmarkList.vala"
					_tmp19_ = FALSE;
#line 1995 "BookmarkList.c"
				}
#line 324 "../libcore/BookmarkList.vala"
				if (_tmp19_) {
#line 1999 "BookmarkList.c"
					gchar* _tmp30_;
#line 328 "../libcore/BookmarkList.vala"
					_tmp30_ = g_strdup ("");
#line 328 "../libcore/BookmarkList.vala"
					_g_free0 (custom_name);
#line 328 "../libcore/BookmarkList.vala"
					custom_name = _tmp30_;
#line 329 "../libcore/BookmarkList.vala"
					change_made = TRUE;
#line 2009 "BookmarkList.c"
				}
#line 332 "../libcore/BookmarkList.vala"
				_tmp31_ = uri;
#line 332 "../libcore/BookmarkList.vala"
				_tmp32_ = custom_name;
#line 332 "../libcore/BookmarkList.vala"
				_tmp33_ = files_bookmark_new_from_uri (_tmp31_, _tmp32_);
#line 332 "../libcore/BookmarkList.vala"
				_tmp34_ = _tmp33_;
#line 332 "../libcore/BookmarkList.vala"
				files_bookmark_list_append_internal (self, _tmp34_);
#line 332 "../libcore/BookmarkList.vala"
				_files_bookmark_unref0 (_tmp34_);
#line 334 "../libcore/BookmarkList.vala"
				_tmp35_ = count;
#line 334 "../libcore/BookmarkList.vala"
				count = _tmp35_ + 1;
#line 316 "../libcore/BookmarkList.vala"
				_g_free0 (custom_name);
#line 316 "../libcore/BookmarkList.vala"
				_g_free0 (uri);
#line 316 "../libcore/BookmarkList.vala"
				parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 316 "../libcore/BookmarkList.vala"
				_g_free0 (line);
#line 2035 "BookmarkList.c"
			}
		}
	}
#line 337 "../libcore/BookmarkList.vala"
	_tmp36_ = self->priv->_list;
#line 337 "../libcore/BookmarkList.vala"
	g_list_foreach (_tmp36_, _files_bookmark_list_start_monitoring_bookmark_gfunc, self);
#line 339 "../libcore/BookmarkList.vala"
	if (change_made) {
#line 339 "../libcore/BookmarkList.vala"
		_tmp37_ = TRUE;
#line 2047 "BookmarkList.c"
	} else {
		GList* _tmp38_;
#line 339 "../libcore/BookmarkList.vala"
		_tmp38_ = self->priv->_list;
#line 339 "../libcore/BookmarkList.vala"
		_tmp37_ = g_list_length (_tmp38_) > count;
#line 2054 "BookmarkList.c"
	}
#line 339 "../libcore/BookmarkList.vala"
	if (_tmp37_) {
#line 341 "../libcore/BookmarkList.vala"
		files_bookmark_list_save_bookmarks_file (self);
#line 2060 "BookmarkList.c"
	}
#line 310 "../libcore/BookmarkList.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 2064 "BookmarkList.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 345 "../libcore/BookmarkList.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 345 "../libcore/BookmarkList.vala"
	return _data4_;
#line 2074 "BookmarkList.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 345 "../libcore/BookmarkList.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 2084 "BookmarkList.c"
		FilesBookmarkList* self;
#line 345 "../libcore/BookmarkList.vala"
		self = _data4_->self;
#line 345 "../libcore/BookmarkList.vala"
		_g_string_free0 (_data4_->sb);
#line 345 "../libcore/BookmarkList.vala"
		_g_object_unref0 (_data4_->file);
#line 345 "../libcore/BookmarkList.vala"
		_g_object_unref0 (self);
#line 345 "../libcore/BookmarkList.vala"
		g_slice_free (Block4Data, _data4_);
#line 2096 "BookmarkList.c"
	}
}

static void
__lambda22_ (Block4Data* _data4_,
             FilesBookmark* bookmark)
{
	FilesBookmarkList* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gboolean _tmp6_;
#line 349 "../libcore/BookmarkList.vala"
	self = _data4_->self;
#line 349 "../libcore/BookmarkList.vala"
	g_return_if_fail (bookmark != NULL);
#line 350 "../libcore/BookmarkList.vala"
	_tmp0_ = files_bookmark_get_uri (bookmark);
#line 350 "../libcore/BookmarkList.vala"
	_tmp1_ = _tmp0_;
#line 350 "../libcore/BookmarkList.vala"
	g_string_append (_data4_->sb, _tmp1_);
#line 351 "../libcore/BookmarkList.vala"
	_tmp2_ = files_bookmark_get_custom_name (bookmark);
#line 351 "../libcore/BookmarkList.vala"
	_tmp3_ = _tmp2_;
#line 351 "../libcore/BookmarkList.vala"
	_tmp4_ = string_strip (_tmp3_);
#line 351 "../libcore/BookmarkList.vala"
	_tmp5_ = _tmp4_;
#line 351 "../libcore/BookmarkList.vala"
	_tmp6_ = g_strcmp0 (_tmp5_, "") != 0;
#line 351 "../libcore/BookmarkList.vala"
	_g_free0 (_tmp5_);
#line 351 "../libcore/BookmarkList.vala"
	if (_tmp6_) {
#line 2136 "BookmarkList.c"
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 352 "../libcore/BookmarkList.vala"
		_tmp7_ = files_bookmark_get_custom_name (bookmark);
#line 352 "../libcore/BookmarkList.vala"
		_tmp8_ = _tmp7_;
#line 352 "../libcore/BookmarkList.vala"
		_tmp9_ = g_strconcat (" ", _tmp8_, NULL);
#line 352 "../libcore/BookmarkList.vala"
		_tmp10_ = _tmp9_;
#line 352 "../libcore/BookmarkList.vala"
		g_string_append (_data4_->sb, _tmp10_);
#line 352 "../libcore/BookmarkList.vala"
		_g_free0 (_tmp10_);
#line 2153 "BookmarkList.c"
	}
#line 355 "../libcore/BookmarkList.vala"
	g_string_append (_data4_->sb, "\n");
#line 2157 "BookmarkList.c"
}

static void
___lambda22__gfunc (gconstpointer data,
                    gpointer self)
{
#line 349 "../libcore/BookmarkList.vala"
	__lambda22_ (self, (FilesBookmark*) data);
#line 2166 "BookmarkList.c"
}

static guint8*
g_string_get_data (GString* self,
                   gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	const gchar* _tmp0_;
	gint res_length1;
	gint _res_size_;
	guint8* _tmp1_;
	gint _tmp1__length1;
#line 5776 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5777 "glib-2.0.vapi"
	_tmp0_ = self->str;
#line 5777 "glib-2.0.vapi"
	res = (guint8*) _tmp0_;
#line 5777 "glib-2.0.vapi"
	res_length1 = -1;
#line 5777 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 5778 "glib-2.0.vapi"
	res_length1 = (gint) self->len;
#line 5779 "glib-2.0.vapi"
	_tmp1_ = res;
#line 5779 "glib-2.0.vapi"
	_tmp1__length1 = res_length1;
#line 5779 "glib-2.0.vapi"
	if (result_length1) {
#line 5779 "glib-2.0.vapi"
		*result_length1 = _tmp1__length1;
#line 2200 "BookmarkList.c"
	}
#line 5779 "glib-2.0.vapi"
	result = _tmp1_;
#line 5779 "glib-2.0.vapi"
	return result;
#line 2206 "BookmarkList.c"
}

static void
__lambda23_ (Block4Data* _data4_,
             GObject* obj,
             GAsyncResult* res)
{
	FilesBookmarkList* self;
	GError* _inner_error0_ = NULL;
#line 363 "../libcore/BookmarkList.vala"
	self = _data4_->self;
#line 363 "../libcore/BookmarkList.vala"
	g_return_if_fail (res != NULL);
#line 2220 "BookmarkList.c"
	{
#line 365 "../libcore/BookmarkList.vala"
		g_file_replace_contents_finish (_data4_->file, res, NULL, &_inner_error0_);
#line 365 "../libcore/BookmarkList.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2226 "BookmarkList.c"
			goto __catch0_g_error;
		}
#line 366 "../libcore/BookmarkList.vala"
		g_signal_emit (self, files_bookmark_list_signals[FILES_BOOKMARK_LIST_CONTENTS_CHANGED_SIGNAL], 0);
#line 2231 "BookmarkList.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 364 "../libcore/BookmarkList.vala"
		_error_ = _inner_error0_;
#line 364 "../libcore/BookmarkList.vala"
		_inner_error0_ = NULL;
#line 369 "../libcore/BookmarkList.vala"
		_tmp0_ = _error_;
#line 369 "../libcore/BookmarkList.vala"
		_tmp1_ = _tmp0_->message;
#line 369 "../libcore/BookmarkList.vala"
		g_warning ("BookmarkList.vala:369: Error replacing bookmarks file contents %s", _tmp1_);
#line 364 "../libcore/BookmarkList.vala"
		_g_error_free0 (_error_);
#line 2251 "BookmarkList.c"
	}
	__finally0:
#line 364 "../libcore/BookmarkList.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 364 "../libcore/BookmarkList.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 364 "../libcore/BookmarkList.vala"
		g_clear_error (&_inner_error0_);
#line 364 "../libcore/BookmarkList.vala"
		return;
#line 2262 "BookmarkList.c"
	}
#line 371 "../libcore/BookmarkList.vala"
	files_bookmark_list_op_processed_call_back (self);
#line 2266 "BookmarkList.c"
}

static void
___lambda23__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 358 "../libcore/BookmarkList.vala"
	__lambda23_ (self, source_object, res);
#line 358 "../libcore/BookmarkList.vala"
	block4_data_unref (self);
#line 2278 "BookmarkList.c"
}

static void
files_bookmark_list_save_bookmarks_file_async (FilesBookmarkList* self)
{
	Block4Data* _data4_;
	GFile* _tmp0_;
	GString* _tmp1_;
	GList* _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	gint _tmp4_ = 0;
	guint8* _tmp5_;
	gint _tmp5__length1;
#line 345 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 345 "../libcore/BookmarkList.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 345 "../libcore/BookmarkList.vala"
	_data4_->_ref_count_ = 1;
#line 345 "../libcore/BookmarkList.vala"
	_data4_->self = g_object_ref (self);
#line 346 "../libcore/BookmarkList.vala"
	_tmp0_ = files_bookmark_list_get_bookmarks_file ();
#line 346 "../libcore/BookmarkList.vala"
	_data4_->file = _tmp0_;
#line 347 "../libcore/BookmarkList.vala"
	_tmp1_ = g_string_new ("");
#line 347 "../libcore/BookmarkList.vala"
	_data4_->sb = _tmp1_;
#line 349 "../libcore/BookmarkList.vala"
	_tmp2_ = self->priv->_list;
#line 349 "../libcore/BookmarkList.vala"
	g_list_foreach (_tmp2_, ___lambda22__gfunc, _data4_);
#line 358 "../libcore/BookmarkList.vala"
	_tmp3_ = g_string_get_data (_data4_->sb, &_tmp4_);
#line 358 "../libcore/BookmarkList.vala"
	_tmp3__length1 = _tmp4_;
#line 358 "../libcore/BookmarkList.vala"
	_tmp5_ = _tmp3_;
#line 358 "../libcore/BookmarkList.vala"
	_tmp5__length1 = _tmp3__length1;
#line 358 "../libcore/BookmarkList.vala"
	g_file_replace_contents_async (_data4_->file, _tmp5_, (gsize) _tmp5__length1, NULL, FALSE, G_FILE_CREATE_NONE, NULL, ___lambda23__gasync_ready_callback, block4_data_ref (_data4_));
#line 345 "../libcore/BookmarkList.vala"
	block4_data_unref (_data4_);
#line 345 "../libcore/BookmarkList.vala"
	_data4_ = NULL;
#line 2327 "BookmarkList.c"
}

static GFile*
files_bookmark_list_get_bookmarks_file (void)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* result;
#line 376 "../libcore/BookmarkList.vala"
	_tmp0_ = files_bookmark_list_bookmarks_file;
#line 376 "../libcore/BookmarkList.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 376 "../libcore/BookmarkList.vala"
	result = _tmp1_;
#line 376 "../libcore/BookmarkList.vala"
	return result;
#line 2344 "BookmarkList.c"
}

static void
files_bookmark_list_bookmarks_file_changed_call_back (FilesBookmarkList* self,
                                                      GFile* file,
                                                      GFile* other_file,
                                                      GFileMonitorEvent event_type)
{
	gboolean _tmp0_ = FALSE;
#line 380 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 380 "../libcore/BookmarkList.vala"
	g_return_if_fail (file != NULL);
#line 384 "../libcore/BookmarkList.vala"
	if (event_type == G_FILE_MONITOR_EVENT_CHANGED) {
#line 384 "../libcore/BookmarkList.vala"
		_tmp0_ = TRUE;
#line 2362 "BookmarkList.c"
	} else {
#line 385 "../libcore/BookmarkList.vala"
		_tmp0_ = event_type == G_FILE_MONITOR_EVENT_CREATED;
#line 2366 "BookmarkList.c"
	}
#line 384 "../libcore/BookmarkList.vala"
	if (_tmp0_) {
#line 387 "../libcore/BookmarkList.vala"
		files_bookmark_list_load_bookmarks_file (self);
#line 2372 "BookmarkList.c"
	}
}

static void
files_bookmark_list_bookmark_in_list_changed_callback (FilesBookmarkList* self,
                                                       FilesBookmark* bookmark)
{
#line 391 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 391 "../libcore/BookmarkList.vala"
	g_return_if_fail (bookmark != NULL);
#line 392 "../libcore/BookmarkList.vala"
	files_bookmark_list_save_bookmarks_file (self);
#line 2386 "BookmarkList.c"
}

static void
files_bookmark_list_bookmark_in_list_to_be_deleted_callback (FilesBookmarkList* self,
                                                             FilesBookmark* bookmark)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 395 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 395 "../libcore/BookmarkList.vala"
	g_return_if_fail (bookmark != NULL);
#line 396 "../libcore/BookmarkList.vala"
	_tmp0_ = files_bookmark_get_uri (bookmark);
#line 396 "../libcore/BookmarkList.vala"
	_tmp1_ = _tmp0_;
#line 396 "../libcore/BookmarkList.vala"
	files_bookmark_list_delete_items_with_uri (self, _tmp1_);
#line 2405 "BookmarkList.c"
}

static void
_files_bookmark_list_bookmarks_file_changed_call_back_g_file_monitor_changed (GFileMonitor* _sender,
                                                                              GFile* file,
                                                                              GFile* other_file,
                                                                              GFileMonitorEvent event_type,
                                                                              gpointer self)
{
#line 404 "../libcore/BookmarkList.vala"
	files_bookmark_list_bookmarks_file_changed_call_back ((FilesBookmarkList*) self, file, other_file, event_type);
#line 2417 "BookmarkList.c"
}

static void
files_bookmark_list_start_monitoring_bookmarks_file (FilesBookmarkList* self)
{
	GFile* file = NULL;
	GFile* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 399 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 400 "../libcore/BookmarkList.vala"
	_tmp0_ = files_bookmark_list_get_bookmarks_file ();
#line 400 "../libcore/BookmarkList.vala"
	file = _tmp0_;
#line 2432 "BookmarkList.c"
	{
		GFileMonitor* _tmp1_ = NULL;
		GFileMonitor* _tmp2_;
		GFileMonitor* _tmp3_;
		GFileMonitor* _tmp4_;
		GFileMonitor* _tmp5_;
#line 402 "../libcore/BookmarkList.vala"
		_tmp2_ = g_file_monitor (file, G_FILE_MONITOR_SEND_MOVED, NULL, &_inner_error0_);
#line 402 "../libcore/BookmarkList.vala"
		_tmp1_ = _tmp2_;
#line 402 "../libcore/BookmarkList.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2445 "BookmarkList.c"
			goto __catch0_g_error;
		}
#line 402 "../libcore/BookmarkList.vala"
		_tmp3_ = _tmp1_;
#line 402 "../libcore/BookmarkList.vala"
		_tmp1_ = NULL;
#line 402 "../libcore/BookmarkList.vala"
		_g_object_unref0 (self->priv->monitor);
#line 402 "../libcore/BookmarkList.vala"
		self->priv->monitor = _tmp3_;
#line 403 "../libcore/BookmarkList.vala"
		_tmp4_ = self->priv->monitor;
#line 403 "../libcore/BookmarkList.vala"
		g_file_monitor_set_rate_limit (_tmp4_, 1000);
#line 404 "../libcore/BookmarkList.vala"
		_tmp5_ = self->priv->monitor;
#line 404 "../libcore/BookmarkList.vala"
		g_signal_connect_object (_tmp5_, "changed", (GCallback) _files_bookmark_list_bookmarks_file_changed_call_back_g_file_monitor_changed, self, 0);
#line 401 "../libcore/BookmarkList.vala"
		_g_object_unref0 (_tmp1_);
#line 2466 "BookmarkList.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
#line 401 "../libcore/BookmarkList.vala"
		_error_ = _inner_error0_;
#line 401 "../libcore/BookmarkList.vala"
		_inner_error0_ = NULL;
#line 407 "../libcore/BookmarkList.vala"
		_tmp6_ = _error_;
#line 407 "../libcore/BookmarkList.vala"
		_tmp7_ = _tmp6_->message;
#line 407 "../libcore/BookmarkList.vala"
		g_warning ("BookmarkList.vala:407: Error starting to monitor bookmarks file: %s", _tmp7_);
#line 401 "../libcore/BookmarkList.vala"
		_g_error_free0 (_error_);
#line 2486 "BookmarkList.c"
	}
	__finally0:
#line 401 "../libcore/BookmarkList.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 401 "../libcore/BookmarkList.vala"
		_g_object_unref0 (file);
#line 401 "../libcore/BookmarkList.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 401 "../libcore/BookmarkList.vala"
		g_clear_error (&_inner_error0_);
#line 401 "../libcore/BookmarkList.vala"
		return;
#line 2499 "BookmarkList.c"
	}
#line 399 "../libcore/BookmarkList.vala"
	_g_object_unref0 (file);
#line 2503 "BookmarkList.c"
}

static void
files_bookmark_list_stop_monitoring_bookmarks_file (FilesBookmarkList* self)
{
	GFileMonitor* _tmp0_;
	GFileMonitor* _tmp1_;
	GFileMonitor* _tmp2_;
	guint _tmp3_;
#line 411 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 412 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->monitor;
#line 412 "../libcore/BookmarkList.vala"
	if (_tmp0_ == NULL) {
#line 413 "../libcore/BookmarkList.vala"
		return;
#line 2521 "BookmarkList.c"
	}
#line 416 "../libcore/BookmarkList.vala"
	_tmp1_ = self->priv->monitor;
#line 416 "../libcore/BookmarkList.vala"
	g_file_monitor_cancel (_tmp1_);
#line 417 "../libcore/BookmarkList.vala"
	_tmp2_ = self->priv->monitor;
#line 417 "../libcore/BookmarkList.vala"
	g_signal_parse_name ("changed", g_file_monitor_get_type (), &_tmp3_, NULL, FALSE);
#line 417 "../libcore/BookmarkList.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _files_bookmark_list_bookmarks_file_changed_call_back_g_file_monitor_changed, self);
#line 418 "../libcore/BookmarkList.vala"
	_g_object_unref0 (self->priv->monitor);
#line 418 "../libcore/BookmarkList.vala"
	self->priv->monitor = NULL;
#line 2537 "BookmarkList.c"
}

static void
_files_bookmark_list_bookmark_in_list_changed_callback_files_bookmark_contents_changed (FilesBookmark* _sender,
                                                                                        gpointer self)
{
#line 422 "../libcore/BookmarkList.vala"
	files_bookmark_list_bookmark_in_list_changed_callback ((FilesBookmarkList*) self, _sender);
#line 2546 "BookmarkList.c"
}

static void
_files_bookmark_list_bookmark_in_list_to_be_deleted_callback_files_bookmark_deleted (FilesBookmark* _sender,
                                                                                     gpointer self)
{
#line 423 "../libcore/BookmarkList.vala"
	files_bookmark_list_bookmark_in_list_to_be_deleted_callback ((FilesBookmarkList*) self, _sender);
#line 2555 "BookmarkList.c"
}

static void
files_bookmark_list_start_monitoring_bookmark (FilesBookmarkList* self,
                                               FilesBookmark* bookmark)
{
#line 421 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 421 "../libcore/BookmarkList.vala"
	g_return_if_fail (bookmark != NULL);
#line 422 "../libcore/BookmarkList.vala"
	g_signal_connect_object (bookmark, "contents-changed", (GCallback) _files_bookmark_list_bookmark_in_list_changed_callback_files_bookmark_contents_changed, self, 0);
#line 423 "../libcore/BookmarkList.vala"
	g_signal_connect_object (bookmark, "deleted", (GCallback) _files_bookmark_list_bookmark_in_list_to_be_deleted_callback_files_bookmark_deleted, self, 0);
#line 2570 "BookmarkList.c"
}

static void
files_bookmark_list_stop_monitoring_bookmark (FilesBookmarkList* self,
                                              FilesBookmark* bookmark)
{
	guint _tmp0_;
	guint _tmp1_;
#line 426 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 426 "../libcore/BookmarkList.vala"
	g_return_if_fail (bookmark != NULL);
#line 427 "../libcore/BookmarkList.vala"
	g_signal_parse_name ("contents-changed", FILES_TYPE_BOOKMARK, &_tmp0_, NULL, FALSE);
#line 427 "../libcore/BookmarkList.vala"
	g_signal_handlers_disconnect_matched (bookmark, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _files_bookmark_list_bookmark_in_list_changed_callback_files_bookmark_contents_changed, self);
#line 428 "../libcore/BookmarkList.vala"
	g_signal_parse_name ("deleted", FILES_TYPE_BOOKMARK, &_tmp1_, NULL, FALSE);
#line 428 "../libcore/BookmarkList.vala"
	g_signal_handlers_disconnect_matched (bookmark, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _files_bookmark_list_bookmark_in_list_to_be_deleted_callback_files_bookmark_deleted, self);
#line 2591 "BookmarkList.c"
}

static void
files_bookmark_list_process_next_op (FilesBookmarkList* self)
{
	FilesBookmarkListJobType pending = 0;
	GQueue* _tmp0_;
	gpointer _tmp1_;
	GQueue* _tmp2_;
	GQueue* _tmp3_;
#line 431 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 432 "../libcore/BookmarkList.vala"
	files_bookmark_list_stop_monitoring_bookmarks_file (self);
#line 433 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->pending_ops;
#line 433 "../libcore/BookmarkList.vala"
	_tmp1_ = g_queue_pop_tail (_tmp0_);
#line 433 "../libcore/BookmarkList.vala"
	pending = (FilesBookmarkListJobType) ((gintptr) _tmp1_);
#line 437 "../libcore/BookmarkList.vala"
	_tmp2_ = self->priv->pending_ops;
#line 437 "../libcore/BookmarkList.vala"
	g_queue_clear (_tmp2_);
#line 439 "../libcore/BookmarkList.vala"
	_tmp3_ = self->priv->pending_ops;
#line 439 "../libcore/BookmarkList.vala"
	g_queue_push_head (_tmp3_, (gpointer) ((gintptr) pending));
#line 441 "../libcore/BookmarkList.vala"
	switch (pending) {
#line 441 "../libcore/BookmarkList.vala"
		case FILES_BOOKMARK_LIST_JOB_TYPE_LOAD:
#line 2624 "BookmarkList.c"
		{
#line 443 "../libcore/BookmarkList.vala"
			files_bookmark_list_load_bookmarks_file_async (self);
#line 444 "../libcore/BookmarkList.vala"
			break;
#line 2630 "BookmarkList.c"
		}
#line 441 "../libcore/BookmarkList.vala"
		case FILES_BOOKMARK_LIST_JOB_TYPE_SAVE:
#line 2634 "BookmarkList.c"
		{
#line 446 "../libcore/BookmarkList.vala"
			files_bookmark_list_save_bookmarks_file_async (self);
#line 447 "../libcore/BookmarkList.vala"
			break;
#line 2640 "BookmarkList.c"
		}
		default:
		{
#line 449 "../libcore/BookmarkList.vala"
			g_warning ("BookmarkList.vala:449: Invalid booklist operation");
#line 450 "../libcore/BookmarkList.vala"
			files_bookmark_list_op_processed_call_back (self);
#line 451 "../libcore/BookmarkList.vala"
			break;
#line 2650 "BookmarkList.c"
		}
	}
}

static void
files_bookmark_list_op_processed_call_back (FilesBookmarkList* self)
{
	GQueue* _tmp0_;
	GQueue* _tmp1_;
#line 455 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 456 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->pending_ops;
#line 456 "../libcore/BookmarkList.vala"
	g_queue_pop_tail (_tmp0_);
#line 457 "../libcore/BookmarkList.vala"
	_tmp1_ = self->priv->pending_ops;
#line 457 "../libcore/BookmarkList.vala"
	if (!g_queue_is_empty (_tmp1_)) {
#line 458 "../libcore/BookmarkList.vala"
		files_bookmark_list_process_next_op (self);
#line 2672 "BookmarkList.c"
	} else {
#line 460 "../libcore/BookmarkList.vala"
		files_bookmark_list_start_monitoring_bookmarks_file (self);
#line 2676 "BookmarkList.c"
	}
}

GList*
files_bookmark_list_get_list (FilesBookmarkList* self)
{
	GList* result;
	GList* _tmp0_;
#line 31 "../libcore/BookmarkList.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../libcore/BookmarkList.vala"
	_tmp0_ = self->priv->_list;
#line 31 "../libcore/BookmarkList.vala"
	result = _tmp0_;
#line 31 "../libcore/BookmarkList.vala"
	return result;
#line 2693 "BookmarkList.c"
}

static void
files_bookmark_list_set_list (FilesBookmarkList* self,
                              GList* value)
{
	GList* old_value;
#line 31 "../libcore/BookmarkList.vala"
	g_return_if_fail (self != NULL);
#line 31 "../libcore/BookmarkList.vala"
	old_value = files_bookmark_list_get_list (self);
#line 31 "../libcore/BookmarkList.vala"
	if (old_value != value) {
#line 31 "../libcore/BookmarkList.vala"
		self->priv->_list = value;
#line 31 "../libcore/BookmarkList.vala"
		g_object_notify_by_pspec ((GObject *) self, files_bookmark_list_properties[FILES_BOOKMARK_LIST_LIST_PROPERTY]);
#line 2711 "BookmarkList.c"
	}
}

static void
files_bookmark_list_class_init (FilesBookmarkListClass * klass,
                                gpointer klass_data)
{
#line 24 "../libcore/BookmarkList.vala"
	files_bookmark_list_parent_class = g_type_class_peek_parent (klass);
#line 24 "../libcore/BookmarkList.vala"
	g_type_class_adjust_private_offset (klass, &FilesBookmarkList_private_offset);
#line 24 "../libcore/BookmarkList.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_files_bookmark_list_get_property;
#line 24 "../libcore/BookmarkList.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_files_bookmark_list_set_property;
#line 24 "../libcore/BookmarkList.vala"
	G_OBJECT_CLASS (klass)->finalize = files_bookmark_list_finalize;
#line 24 "../libcore/BookmarkList.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_BOOKMARK_LIST_LIST_PROPERTY, files_bookmark_list_properties[FILES_BOOKMARK_LIST_LIST_PROPERTY] = g_param_spec_pointer ("list", "list", "list", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../libcore/BookmarkList.vala"
	files_bookmark_list_signals[FILES_BOOKMARK_LIST_CONTENTS_CHANGED_SIGNAL] = g_signal_new ("contents-changed", FILES_TYPE_BOOKMARK_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../libcore/BookmarkList.vala"
	files_bookmark_list_signals[FILES_BOOKMARK_LIST_LOADED_SIGNAL] = g_signal_new ("loaded", FILES_TYPE_BOOKMARK_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../libcore/BookmarkList.vala"
	files_bookmark_list_signals[FILES_BOOKMARK_LIST_DELETED_SIGNAL] = g_signal_new ("deleted", FILES_TYPE_BOOKMARK_LIST, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2737 "BookmarkList.c"
}

static void
files_bookmark_list_instance_init (FilesBookmarkList * self,
                                   gpointer klass)
{
#line 24 "../libcore/BookmarkList.vala"
	self->priv = files_bookmark_list_get_instance_private (self);
#line 2746 "BookmarkList.c"
}

static void
files_bookmark_list_finalize (GObject * obj)
{
	FilesBookmarkList * self;
#line 24 "../libcore/BookmarkList.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_TYPE_BOOKMARK_LIST, FilesBookmarkList);
#line 33 "../libcore/BookmarkList.vala"
	_g_object_unref0 (self->priv->monitor);
#line 34 "../libcore/BookmarkList.vala"
	(self->priv->pending_ops == NULL) ? NULL : (self->priv->pending_ops = (g_queue_free (self->priv->pending_ops), NULL));
#line 36 "../libcore/BookmarkList.vala"
	_g_object_unref0 (self->priv->call_when_ready);
#line 24 "../libcore/BookmarkList.vala"
	G_OBJECT_CLASS (files_bookmark_list_parent_class)->finalize (obj);
#line 2763 "BookmarkList.c"
}

 G_GNUC_NO_INLINE static GType
files_bookmark_list_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesBookmarkListClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) files_bookmark_list_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesBookmarkList), 0, (GInstanceInitFunc) files_bookmark_list_instance_init, NULL };
	GType files_bookmark_list_type_id;
	files_bookmark_list_type_id = g_type_register_static (G_TYPE_OBJECT, "FilesBookmarkList", &g_define_type_info, 0);
	FilesBookmarkList_private_offset = g_type_add_instance_private (files_bookmark_list_type_id, sizeof (FilesBookmarkListPrivate));
	return files_bookmark_list_type_id;
}

GType
files_bookmark_list_get_type (void)
{
	static volatile gsize files_bookmark_list_type_id__once = 0;
	if (g_once_init_enter (&files_bookmark_list_type_id__once)) {
		GType files_bookmark_list_type_id;
		files_bookmark_list_type_id = files_bookmark_list_get_type_once ();
		g_once_init_leave (&files_bookmark_list_type_id__once, files_bookmark_list_type_id);
	}
	return files_bookmark_list_type_id__once;
}

static void
_vala_files_bookmark_list_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	FilesBookmarkList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILES_TYPE_BOOKMARK_LIST, FilesBookmarkList);
#line 24 "../libcore/BookmarkList.vala"
	switch (property_id) {
#line 24 "../libcore/BookmarkList.vala"
		case FILES_BOOKMARK_LIST_LIST_PROPERTY:
#line 24 "../libcore/BookmarkList.vala"
		g_value_set_pointer (value, files_bookmark_list_get_list (self));
#line 24 "../libcore/BookmarkList.vala"
		break;
#line 2804 "BookmarkList.c"
		default:
#line 24 "../libcore/BookmarkList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../libcore/BookmarkList.vala"
		break;
#line 2810 "BookmarkList.c"
	}
}

static void
_vala_files_bookmark_list_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	FilesBookmarkList * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILES_TYPE_BOOKMARK_LIST, FilesBookmarkList);
#line 24 "../libcore/BookmarkList.vala"
	switch (property_id) {
#line 24 "../libcore/BookmarkList.vala"
		case FILES_BOOKMARK_LIST_LIST_PROPERTY:
#line 24 "../libcore/BookmarkList.vala"
		files_bookmark_list_set_list (self, g_value_get_pointer (value));
#line 24 "../libcore/BookmarkList.vala"
		break;
#line 2830 "BookmarkList.c"
		default:
#line 24 "../libcore/BookmarkList.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../libcore/BookmarkList.vala"
		break;
#line 2836 "BookmarkList.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

