/* DeleteJob.c generated by valac 0.56.14, the Vala compiler
 * generated from DeleteJob.vala, do not modify */

/* Copyright 2022 elementary LLC (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, Inc.,; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "pantheon-files-core.h"
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define _g_free0(var) (var = (g_free (var), NULL))

static gpointer marlin_file_operations_delete_job_parent_class = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void marlin_file_operations_delete_job_finalize (FilesFileOperationsCommonJob * obj);
static GType marlin_file_operations_delete_job_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static void
_g_object_unref0_ (gpointer var)
{
#line 20 "../libcore/FileOperations/DeleteJob.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 48 "DeleteJob.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 20 "../libcore/FileOperations/DeleteJob.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 56 "DeleteJob.c"
}

gboolean
marlin_file_operations_delete_job_can_delete_without_confirm (GFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 29 "../libcore/FileOperations/DeleteJob.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 30 "../libcore/FileOperations/DeleteJob.vala"
	if (g_file_has_uri_scheme (file, "burn")) {
#line 30 "../libcore/FileOperations/DeleteJob.vala"
		_tmp1_ = TRUE;
#line 71 "DeleteJob.c"
	} else {
#line 31 "../libcore/FileOperations/DeleteJob.vala"
		_tmp1_ = g_file_has_uri_scheme (file, "x-nautilus-desktop");
#line 75 "DeleteJob.c"
	}
#line 30 "../libcore/FileOperations/DeleteJob.vala"
	if (_tmp1_) {
#line 30 "../libcore/FileOperations/DeleteJob.vala"
		_tmp0_ = TRUE;
#line 81 "DeleteJob.c"
	} else {
#line 32 "../libcore/FileOperations/DeleteJob.vala"
		_tmp0_ = g_file_has_uri_scheme (file, "trash");
#line 85 "DeleteJob.c"
	}
#line 30 "../libcore/FileOperations/DeleteJob.vala"
	result = _tmp0_;
#line 30 "../libcore/FileOperations/DeleteJob.vala"
	return result;
#line 91 "DeleteJob.c"
}

FilesFileOperationsDeleteJob*
marlin_file_operations_delete_job_construct (GType object_type,
                                             GtkWindow* parent_window,
                                             GList* files,
                                             gboolean try_trash)
{
	FilesFileOperationsDeleteJob* self = NULL;
	GList* _tmp0_;
#line 36 "../libcore/FileOperations/DeleteJob.vala"
	self = (FilesFileOperationsDeleteJob*) marlin_file_operations_common_job_construct (object_type, parent_window);
#line 37 "../libcore/FileOperations/DeleteJob.vala"
	_tmp0_ = g_list_copy_deep (files, (GCopyFunc) g_object_ref, NULL);
#line 37 "../libcore/FileOperations/DeleteJob.vala"
	(self->files == NULL) ? NULL : (self->files = (_g_list_free__g_object_unref0_ (self->files), NULL));
#line 37 "../libcore/FileOperations/DeleteJob.vala"
	self->files = _tmp0_;
#line 38 "../libcore/FileOperations/DeleteJob.vala"
	self->try_trash = try_trash;
#line 39 "../libcore/FileOperations/DeleteJob.vala"
	self->user_cancel = FALSE;
#line 35 "../libcore/FileOperations/DeleteJob.vala"
	return self;
#line 116 "DeleteJob.c"
}

FilesFileOperationsDeleteJob*
marlin_file_operations_delete_job_new (GtkWindow* parent_window,
                                       GList* files,
                                       gboolean try_trash)
{
#line 35 "../libcore/FileOperations/DeleteJob.vala"
	return marlin_file_operations_delete_job_construct (MARLIN_FILE_OPERATIONS_TYPE_DELETE_JOB, parent_window, files, try_trash);
#line 126 "DeleteJob.c"
}

gboolean
marlin_file_operations_delete_job_confirm_delete_from_trash (FilesFileOperationsDeleteJob* self,
                                                             GList* to_delete_files)
{
	gchar* prompt = NULL;
	guint file_count = 0U;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean result;
#line 42 "../libcore/FileOperations/DeleteJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 46 "../libcore/FileOperations/DeleteJob.vala"
	file_count = g_list_length (to_delete_files);
#line 47 "../libcore/FileOperations/DeleteJob.vala"
	if (file_count == ((guint) 1)) {
#line 145 "DeleteJob.c"
		gchar* basename = NULL;
		gconstpointer _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 48 "../libcore/FileOperations/DeleteJob.vala"
		_tmp0_ = to_delete_files->data;
#line 48 "../libcore/FileOperations/DeleteJob.vala"
		_tmp1_ = files_file_utils_custom_basename_from_file ((GFile*) _tmp0_);
#line 48 "../libcore/FileOperations/DeleteJob.vala"
		basename = _tmp1_;
#line 51 "../libcore/FileOperations/DeleteJob.vala"
		_tmp2_ = basename;
#line 51 "../libcore/FileOperations/DeleteJob.vala"
		_tmp3_ = g_strdup_printf (_ ("Are you sure you want to permanently delete \"%s\" from the trash?"), _tmp2_);
#line 51 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (prompt);
#line 51 "../libcore/FileOperations/DeleteJob.vala"
		prompt = _tmp3_;
#line 47 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (basename);
#line 167 "DeleteJob.c"
	} else {
		gchar* _tmp4_;
#line 53 "../libcore/FileOperations/DeleteJob.vala"
		_tmp4_ = g_strdup_printf (ngettext ("Are you sure you want to permanently delete the %'d selected item from" \
" the trash?", "Are you sure you want to permanently delete the %'d selected items fro" \
"m the trash?", (gulong) file_count), file_count);
#line 53 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (prompt);
#line 53 "../libcore/FileOperations/DeleteJob.vala"
		prompt = _tmp4_;
#line 176 "DeleteJob.c"
	}
#line 58 "../libcore/FileOperations/DeleteJob.vala"
	_tmp5_ = prompt;
#line 58 "../libcore/FileOperations/DeleteJob.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 58 "../libcore/FileOperations/DeleteJob.vala"
	_tmp7_ = g_strdup (_ ("If you delete an item, it will be permanently lost."));
#line 58 "../libcore/FileOperations/DeleteJob.vala"
	result = marlin_file_operations_common_job_run_warning ((FilesFileOperationsCommonJob*) self, _tmp6_, _tmp7_, NULL, FALSE, CANCEL, DELETE, NULL) == 1;
#line 58 "../libcore/FileOperations/DeleteJob.vala"
	_g_free0 (prompt);
#line 58 "../libcore/FileOperations/DeleteJob.vala"
	return result;
#line 190 "DeleteJob.c"
}

gboolean
marlin_file_operations_delete_job_confirm_delete_directly (FilesFileOperationsDeleteJob* self,
                                                           GList* to_delete_files)
{
	gchar* prompt = NULL;
	guint file_count = 0U;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean result;
#line 65 "../libcore/FileOperations/DeleteJob.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 69 "../libcore/FileOperations/DeleteJob.vala"
	file_count = g_list_length (to_delete_files);
#line 70 "../libcore/FileOperations/DeleteJob.vala"
	if (file_count == ((guint) 1)) {
#line 209 "DeleteJob.c"
		gchar* basename = NULL;
		gconstpointer _tmp0_;
		gchar* _tmp1_;
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 71 "../libcore/FileOperations/DeleteJob.vala"
		_tmp0_ = to_delete_files->data;
#line 71 "../libcore/FileOperations/DeleteJob.vala"
		_tmp1_ = files_file_utils_custom_basename_from_file ((GFile*) _tmp0_);
#line 71 "../libcore/FileOperations/DeleteJob.vala"
		basename = _tmp1_;
#line 74 "../libcore/FileOperations/DeleteJob.vala"
		_tmp2_ = basename;
#line 74 "../libcore/FileOperations/DeleteJob.vala"
		_tmp3_ = g_strdup_printf (_ ("Permanently delete “%s”?"), _tmp2_);
#line 74 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (prompt);
#line 74 "../libcore/FileOperations/DeleteJob.vala"
		prompt = _tmp3_;
#line 70 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (basename);
#line 231 "DeleteJob.c"
	} else {
		gchar* _tmp4_;
#line 76 "../libcore/FileOperations/DeleteJob.vala"
		_tmp4_ = g_strdup_printf (ngettext ("Are you sure you want to permanently delete the %'d selected item?", "Are you sure you want to permanently delete the %'d selected items?", (gulong) file_count), file_count);
#line 76 "../libcore/FileOperations/DeleteJob.vala"
		_g_free0 (prompt);
#line 76 "../libcore/FileOperations/DeleteJob.vala"
		prompt = _tmp4_;
#line 240 "DeleteJob.c"
	}
#line 81 "../libcore/FileOperations/DeleteJob.vala"
	_tmp5_ = prompt;
#line 81 "../libcore/FileOperations/DeleteJob.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 81 "../libcore/FileOperations/DeleteJob.vala"
	_tmp7_ = g_strdup (_ ("Deleted items are not sent to Trash and are not recoverable."));
#line 81 "../libcore/FileOperations/DeleteJob.vala"
	result = marlin_file_operations_common_job_run_warning ((FilesFileOperationsCommonJob*) self, _tmp6_, _tmp7_, NULL, FALSE, CANCEL, DELETE, NULL) == 1;
#line 81 "../libcore/FileOperations/DeleteJob.vala"
	_g_free0 (prompt);
#line 81 "../libcore/FileOperations/DeleteJob.vala"
	return result;
#line 254 "DeleteJob.c"
}

static void
marlin_file_operations_delete_job_class_init (FilesFileOperationsDeleteJobClass * klass,
                                              gpointer klass_data)
{
#line 19 "../libcore/FileOperations/DeleteJob.vala"
	marlin_file_operations_delete_job_parent_class = g_type_class_peek_parent (klass);
#line 19 "../libcore/FileOperations/DeleteJob.vala"
	((FilesFileOperationsCommonJobClass *) klass)->finalize = marlin_file_operations_delete_job_finalize;
#line 265 "DeleteJob.c"
}

static void
marlin_file_operations_delete_job_instance_init (FilesFileOperationsDeleteJob * self,
                                                 gpointer klass)
{
}

static void
marlin_file_operations_delete_job_finalize (FilesFileOperationsCommonJob * obj)
{
	FilesFileOperationsDeleteJob * self;
#line 19 "../libcore/FileOperations/DeleteJob.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MARLIN_FILE_OPERATIONS_TYPE_DELETE_JOB, FilesFileOperationsDeleteJob);
#line 26 "../libcore/FileOperations/DeleteJob.vala"
	files_file_changes_consume_changes (TRUE);
#line 20 "../libcore/FileOperations/DeleteJob.vala"
	(self->files == NULL) ? NULL : (self->files = (_g_list_free__g_object_unref0_ (self->files), NULL));
#line 19 "../libcore/FileOperations/DeleteJob.vala"
	MARLIN_FILE_OPERATIONS_COMMON_JOB_CLASS (marlin_file_operations_delete_job_parent_class)->finalize (obj);
#line 286 "DeleteJob.c"
}

 G_GNUC_NO_INLINE static GType
marlin_file_operations_delete_job_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesFileOperationsDeleteJobClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) marlin_file_operations_delete_job_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesFileOperationsDeleteJob), 0, (GInstanceInitFunc) marlin_file_operations_delete_job_instance_init, NULL };
	GType marlin_file_operations_delete_job_type_id;
	marlin_file_operations_delete_job_type_id = g_type_register_static (MARLIN_FILE_OPERATIONS_TYPE_COMMON_JOB, "FilesFileOperationsDeleteJob", &g_define_type_info, 0);
	return marlin_file_operations_delete_job_type_id;
}

GType
marlin_file_operations_delete_job_get_type (void)
{
	static volatile gsize marlin_file_operations_delete_job_type_id__once = 0;
	if (g_once_init_enter (&marlin_file_operations_delete_job_type_id__once)) {
		GType marlin_file_operations_delete_job_type_id;
		marlin_file_operations_delete_job_type_id = marlin_file_operations_delete_job_get_type_once ();
		g_once_init_leave (&marlin_file_operations_delete_job_type_id__once, marlin_file_operations_delete_job_type_id);
	}
	return marlin_file_operations_delete_job_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

