/* SidebarItemInterface.c generated by valac 0.56.14, the Vala compiler
 * generated from SidebarItemInterface.vala, do not modify */

/*
 * SidebarItemInterface.vala
 *
 * Copyright 2020 elementary LLC. <https://elementary.io>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 * Authors : Jeremy Wootten <jeremy@elementaryos.org>
 */

#include "pantheon-files-core.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <string.h>

guint32 sidebar_sidebar_item_interface_row_id = 0U;
GeeHashMap* sidebar_sidebar_item_interface_item_id_map = NULL;
GMutex sidebar_sidebar_item_interface_item_map_lock = {0};

static void sidebar_sidebar_item_interface_real_update_icon (SidebarSidebarItemInterface* self,
                                                      GIcon* icon);
static void sidebar_sidebar_item_interface_real_add_extra_menu_items (SidebarSidebarItemInterface* self,
                                                               PopupMenuBuilder* menu_builder);
static void sidebar_sidebar_item_interface_real_update_plugin_data (SidebarSidebarItemInterface* self,
                                                             FilesSidebarPluginItem* item);
static void sidebar_sidebar_item_interface_real_activated (SidebarSidebarItemInterface* self,
                                                    FilesOpenFlag flag);
static GType sidebar_sidebar_item_interface_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

guint32
sidebar_sidebar_item_interface_get_next_item_id (void)
{
	guint32 _tmp0_;
	guint32 result;
#line 31 "../libcore/Interfaces/SidebarItemInterface.vala"
	sidebar_sidebar_item_interface_row_id = sidebar_sidebar_item_interface_row_id + 1;
#line 31 "../libcore/Interfaces/SidebarItemInterface.vala"
	_tmp0_ = sidebar_sidebar_item_interface_row_id;
#line 31 "../libcore/Interfaces/SidebarItemInterface.vala"
	result = _tmp0_;
#line 31 "../libcore/Interfaces/SidebarItemInterface.vala"
	return result;
#line 64 "SidebarItemInterface.c"
}

SidebarSidebarItemInterface*
sidebar_sidebar_item_interface_get_item (guint32 id)
{
	SidebarSidebarItemInterface* item = NULL;
	GeeHashMap* _tmp0_;
	gpointer _tmp1_;
	SidebarSidebarItemInterface* result;
#line 35 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (id == ((guint32) 0)) {
#line 36 "../libcore/Interfaces/SidebarItemInterface.vala"
		result = NULL;
#line 36 "../libcore/Interfaces/SidebarItemInterface.vala"
		return result;
#line 80 "SidebarItemInterface.c"
	}
#line 39 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_mutex_lock (&sidebar_sidebar_item_interface_item_map_lock);
#line 40 "../libcore/Interfaces/SidebarItemInterface.vala"
	_tmp0_ = sidebar_sidebar_item_interface_item_id_map;
#line 40 "../libcore/Interfaces/SidebarItemInterface.vala"
	_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((guintptr) id));
#line 40 "../libcore/Interfaces/SidebarItemInterface.vala"
	item = (SidebarSidebarItemInterface*) _tmp1_;
#line 41 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_mutex_unlock (&sidebar_sidebar_item_interface_item_map_lock);
#line 42 "../libcore/Interfaces/SidebarItemInterface.vala"
	result = item;
#line 42 "../libcore/Interfaces/SidebarItemInterface.vala"
	return result;
#line 96 "SidebarItemInterface.c"
}

gint
sidebar_sidebar_item_interface_get_index (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 54 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 54 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 54 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_index) {
#line 54 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_index (self);
#line 111 "SidebarItemInterface.c"
	}
#line 54 "../libcore/Interfaces/SidebarItemInterface.vala"
	return -1;
#line 115 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_destroy_bookmark (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 62 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 62 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 62 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->destroy_bookmark) {
#line 62 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->destroy_bookmark (self);
#line 130 "SidebarItemInterface.c"
	}
}

static void
sidebar_sidebar_item_interface_real_update_icon (SidebarSidebarItemInterface* self,
                                                 GIcon* icon)
{
#line 63 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (icon != NULL);
#line 64 "../libcore/Interfaces/SidebarItemInterface.vala"
	sidebar_sidebar_item_interface_set_gicon (self, icon);
#line 142 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_update_icon (SidebarSidebarItemInterface* self,
                                            GIcon* icon)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 63 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 63 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 63 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->update_icon) {
#line 63 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->update_icon (self, icon);
#line 158 "SidebarItemInterface.c"
	}
}

static void
sidebar_sidebar_item_interface_real_add_extra_menu_items (SidebarSidebarItemInterface* self,
                                                          PopupMenuBuilder* menu_builder)
{
#line 67 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (menu_builder != NULL);
#line 168 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_add_extra_menu_items (SidebarSidebarItemInterface* self,
                                                     PopupMenuBuilder* menu_builder)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 67 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 67 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 67 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->add_extra_menu_items) {
#line 67 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->add_extra_menu_items (self, menu_builder);
#line 184 "SidebarItemInterface.c"
	}
}

static void
sidebar_sidebar_item_interface_real_update_plugin_data (SidebarSidebarItemInterface* self,
                                                        FilesSidebarPluginItem* item)
{
#line 68 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (item != NULL);
#line 194 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_update_plugin_data (SidebarSidebarItemInterface* self,
                                                   FilesSidebarPluginItem* item)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 68 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 68 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 68 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->update_plugin_data) {
#line 68 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->update_plugin_data (self, item);
#line 210 "SidebarItemInterface.c"
	}
}

static void
sidebar_sidebar_item_interface_real_activated (SidebarSidebarItemInterface* self,
                                               FilesOpenFlag flag)
{
	SidebarSidebarListInterface* _tmp0_;
	SidebarSidebarListInterface* _tmp1_;
#line 71 "../libcore/Interfaces/SidebarItemInterface.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_list (self);
#line 71 "../libcore/Interfaces/SidebarItemInterface.vala"
	_tmp1_ = _tmp0_;
#line 71 "../libcore/Interfaces/SidebarItemInterface.vala"
	sidebar_sidebar_list_interface_open_item (_tmp1_, self, flag);
#line 226 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_activated (SidebarSidebarItemInterface* self,
                                          FilesOpenFlag flag)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 70 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 70 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 70 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->activated) {
#line 70 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->activated (self, flag);
#line 242 "SidebarItemInterface.c"
	}
}

SidebarSidebarListInterface*
sidebar_sidebar_item_interface_get_list (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 45 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 45 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_list) {
#line 45 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_list (self);
#line 258 "SidebarItemInterface.c"
	}
#line 45 "../libcore/Interfaces/SidebarItemInterface.vala"
	return NULL;
#line 262 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_set_list (SidebarSidebarItemInterface* self,
                                         SidebarSidebarListInterface* value)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 45 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 45 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 45 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->set_list) {
#line 45 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->set_list (self, value);
#line 278 "SidebarItemInterface.c"
	}
}

guint32
sidebar_sidebar_item_interface_get_id (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 46 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 46 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 46 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_id) {
#line 46 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_id (self);
#line 294 "SidebarItemInterface.c"
	}
#line 46 "../libcore/Interfaces/SidebarItemInterface.vala"
	return 0U;
#line 298 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_set_id (SidebarSidebarItemInterface* self,
                                       guint32 value)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 46 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 46 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 46 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->set_id) {
#line 46 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->set_id (self, value);
#line 314 "SidebarItemInterface.c"
	}
}

const gchar*
sidebar_sidebar_item_interface_get_uri (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 47 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 47 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 47 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_uri) {
#line 47 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_uri (self);
#line 330 "SidebarItemInterface.c"
	}
#line 47 "../libcore/Interfaces/SidebarItemInterface.vala"
	return NULL;
#line 334 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_set_uri (SidebarSidebarItemInterface* self,
                                        const gchar* value)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 47 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 47 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 47 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->set_uri) {
#line 47 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->set_uri (self, value);
#line 350 "SidebarItemInterface.c"
	}
}

const gchar*
sidebar_sidebar_item_interface_get_custom_name (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 48 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 48 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_custom_name) {
#line 48 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_custom_name (self);
#line 366 "SidebarItemInterface.c"
	}
#line 48 "../libcore/Interfaces/SidebarItemInterface.vala"
	return NULL;
#line 370 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_set_custom_name (SidebarSidebarItemInterface* self,
                                                const gchar* value)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 48 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 48 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 48 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->set_custom_name) {
#line 48 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->set_custom_name (self, value);
#line 386 "SidebarItemInterface.c"
	}
}

GIcon*
sidebar_sidebar_item_interface_get_gicon (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 49 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 49 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_gicon) {
#line 49 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_gicon (self);
#line 402 "SidebarItemInterface.c"
	}
#line 49 "../libcore/Interfaces/SidebarItemInterface.vala"
	return NULL;
#line 406 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_set_gicon (SidebarSidebarItemInterface* self,
                                          GIcon* value)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 49 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 49 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 49 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->set_gicon) {
#line 49 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->set_gicon (self, value);
#line 422 "SidebarItemInterface.c"
	}
}

gboolean
sidebar_sidebar_item_interface_get_pinned (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 50 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 50 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_pinned) {
#line 50 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_pinned (self);
#line 438 "SidebarItemInterface.c"
	}
#line 50 "../libcore/Interfaces/SidebarItemInterface.vala"
	return FALSE;
#line 442 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_set_pinned (SidebarSidebarItemInterface* self,
                                           gboolean value)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 50 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 50 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 50 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->set_pinned) {
#line 50 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->set_pinned (self, value);
#line 458 "SidebarItemInterface.c"
	}
}

gboolean
sidebar_sidebar_item_interface_get_permanent (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 51 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 51 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 51 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_permanent) {
#line 51 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_permanent (self);
#line 474 "SidebarItemInterface.c"
	}
#line 51 "../libcore/Interfaces/SidebarItemInterface.vala"
	return FALSE;
#line 478 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_set_permanent (SidebarSidebarItemInterface* self,
                                              gboolean value)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 51 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 51 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 51 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->set_permanent) {
#line 51 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->set_permanent (self, value);
#line 494 "SidebarItemInterface.c"
	}
}

gboolean
sidebar_sidebar_item_interface_get_can_insert_before (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 52 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 52 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 52 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_can_insert_before) {
#line 52 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_can_insert_before (self);
#line 510 "SidebarItemInterface.c"
	}
#line 52 "../libcore/Interfaces/SidebarItemInterface.vala"
	return FALSE;
#line 514 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_set_can_insert_before (SidebarSidebarItemInterface* self,
                                                      gboolean value)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 52 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 52 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 52 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->set_can_insert_before) {
#line 52 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->set_can_insert_before (self, value);
#line 530 "SidebarItemInterface.c"
	}
}

gboolean
sidebar_sidebar_item_interface_get_can_insert_after (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 53 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 53 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 53 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_can_insert_after) {
#line 53 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_can_insert_after (self);
#line 546 "SidebarItemInterface.c"
	}
#line 53 "../libcore/Interfaces/SidebarItemInterface.vala"
	return FALSE;
#line 550 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_set_can_insert_after (SidebarSidebarItemInterface* self,
                                                     gboolean value)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 53 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 53 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 53 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->set_can_insert_after) {
#line 53 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->set_can_insert_after (self, value);
#line 566 "SidebarItemInterface.c"
	}
}

GMenuModel*
sidebar_sidebar_item_interface_get_menu_model (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 58 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 58 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_menu_model) {
#line 58 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_menu_model (self);
#line 582 "SidebarItemInterface.c"
	}
#line 58 "../libcore/Interfaces/SidebarItemInterface.vala"
	return NULL;
#line 586 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_set_menu_model (SidebarSidebarItemInterface* self,
                                               GMenuModel* value)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 58 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 58 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 58 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->set_menu_model) {
#line 58 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->set_menu_model (self, value);
#line 602 "SidebarItemInterface.c"
	}
}

GActionGroup*
sidebar_sidebar_item_interface_get_action_group (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 59 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 59 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 59 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_action_group) {
#line 59 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_action_group (self);
#line 618 "SidebarItemInterface.c"
	}
#line 59 "../libcore/Interfaces/SidebarItemInterface.vala"
	return NULL;
#line 622 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_set_action_group (SidebarSidebarItemInterface* self,
                                                 GActionGroup* value)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 59 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 59 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 59 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->set_action_group) {
#line 59 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->set_action_group (self, value);
#line 638 "SidebarItemInterface.c"
	}
}

const gchar*
sidebar_sidebar_item_interface_get_action_group_namespace (SidebarSidebarItemInterface* self)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 60 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 60 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 60 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->get_action_group_namespace) {
#line 60 "../libcore/Interfaces/SidebarItemInterface.vala"
		return _iface_->get_action_group_namespace (self);
#line 654 "SidebarItemInterface.c"
	}
#line 60 "../libcore/Interfaces/SidebarItemInterface.vala"
	return NULL;
#line 658 "SidebarItemInterface.c"
}

void
sidebar_sidebar_item_interface_set_action_group_namespace (SidebarSidebarItemInterface* self,
                                                           const gchar* value)
{
	SidebarSidebarItemInterfaceIface* _iface_;
#line 60 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_return_if_fail (self != NULL);
#line 60 "../libcore/Interfaces/SidebarItemInterface.vala"
	_iface_ = SIDEBAR_SIDEBAR_ITEM_INTERFACE_GET_INTERFACE (self);
#line 60 "../libcore/Interfaces/SidebarItemInterface.vala"
	if (_iface_->set_action_group_namespace) {
#line 60 "../libcore/Interfaces/SidebarItemInterface.vala"
		_iface_->set_action_group_namespace (self, value);
#line 674 "SidebarItemInterface.c"
	}
}

static void
sidebar_sidebar_item_interface_default_init (SidebarSidebarItemInterfaceIface * iface,
                                             gpointer iface_data)
{
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("list", "list", "list", SIDEBAR_TYPE_SIDEBAR_LIST_INTERFACE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_uint ("id", "id", "id", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("uri", "uri", "uri", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("custom-name", "custom-name", "custom-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("gicon", "gicon", "gicon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("pinned", "pinned", "pinned", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("permanent", "permanent", "permanent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("can-insert-before", "can-insert-before", "can-insert-before", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_boolean ("can-insert-after", "can-insert-after", "can-insert-after", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("menu-model", "menu-model", "menu-model", g_menu_model_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_object ("action-group", "action-group", "action-group", g_action_group_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	g_object_interface_install_property (iface, g_param_spec_string ("action-group-namespace", "action-group-namespace", "action-group-namespace", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	iface->update_icon = sidebar_sidebar_item_interface_real_update_icon;
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	iface->add_extra_menu_items = sidebar_sidebar_item_interface_real_add_extra_menu_items;
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	iface->update_plugin_data = sidebar_sidebar_item_interface_real_update_plugin_data;
#line 24 "../libcore/Interfaces/SidebarItemInterface.vala"
	iface->activated = sidebar_sidebar_item_interface_real_activated;
#line 714 "SidebarItemInterface.c"
}

 G_GNUC_NO_INLINE static GType
sidebar_sidebar_item_interface_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SidebarSidebarItemInterfaceIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sidebar_sidebar_item_interface_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType sidebar_sidebar_item_interface_type_id;
	sidebar_sidebar_item_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "SidebarSidebarItemInterface", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (sidebar_sidebar_item_interface_type_id, G_TYPE_OBJECT);
	return sidebar_sidebar_item_interface_type_id;
}

GType
sidebar_sidebar_item_interface_get_type (void)
{
	static volatile gsize sidebar_sidebar_item_interface_type_id__once = 0;
	if (g_once_init_enter (&sidebar_sidebar_item_interface_type_id__once)) {
		GType sidebar_sidebar_item_interface_type_id;
		sidebar_sidebar_item_interface_type_id = sidebar_sidebar_item_interface_get_type_once ();
		g_once_init_leave (&sidebar_sidebar_item_interface_type_id__once, sidebar_sidebar_item_interface_type_id);
	}
	return sidebar_sidebar_item_interface_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

