/* RenamerDialog.c generated by valac 0.56.14, the Vala compiler
 * generated from RenamerDialog.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0
 * SPDX-FileCopyrightText: 2023 elementary, Inc. (https://elementary.io)
 *                         2019-2022 Jeremy Wootten
 *
 * Authored by: Jeremy Wootten <jeremywootten@gmail.com>
 */

#include <granite.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include "pantheon-files-core.h"
#include <gee.h>
#include <gdk/gdk.h>

#define FILES_RENAMER_DIALOG_MAX_PREFIX 1
#define FILES_RENAMER_DIALOG_MAX_SUFFIX 1
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FILES_TYPE_RENAMER_DIALOG (files_renamer_dialog_get_type ())
#define FILES_RENAMER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialog))
#define FILES_RENAMER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialogClass))
#define FILES_IS_RENAMER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_RENAMER_DIALOG))
#define FILES_IS_RENAMER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_RENAMER_DIALOG))
#define FILES_RENAMER_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialogClass))

typedef struct _FilesRenamerDialog FilesRenamerDialog;
typedef struct _FilesRenamerDialogClass FilesRenamerDialogClass;
typedef struct _FilesRenamerDialogPrivate FilesRenamerDialogPrivate;

#define FILES_TYPE_RENAMER (files_renamer_get_type ())
#define FILES_RENAMER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_RENAMER, FilesRenamer))
#define FILES_RENAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_RENAMER, FilesRenamerClass))
#define FILES_IS_RENAMER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_RENAMER))
#define FILES_IS_RENAMER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_RENAMER))
#define FILES_RENAMER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_RENAMER, FilesRenamerClass))

typedef struct _FilesRenamer FilesRenamer;
typedef struct _FilesRenamerClass FilesRenamerClass;
enum  {
	FILES_RENAMER_DIALOG_0_PROPERTY,
	FILES_RENAMER_DIALOG_N_NUMBER_SEQ_PROPERTY,
	FILES_RENAMER_DIALOG_N_PREFIX_PROPERTY,
	FILES_RENAMER_DIALOG_N_SUFFIX_PROPERTY,
	FILES_RENAMER_DIALOG_NUM_PROPERTIES
};
static GParamSpec* files_renamer_dialog_properties[FILES_RENAMER_DIALOG_NUM_PROPERTIES];
typedef enum  {
	FILES_RENAMER_DIALOG_RENAME_BASE_ORIGINAL,
	FILES_RENAMER_DIALOG_RENAME_BASE_REPLACE,
	FILES_RENAMER_DIALOG_RENAME_BASE_CUSTOM
} FilesRenamerDialogRenameBase;

#define FILES_RENAMER_DIALOG_TYPE_RENAME_BASE (files_renamer_dialog_rename_base_get_type ())
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define FILES_TYPE_RENAMER_MODIFIER (files_renamer_modifier_get_type ())
#define FILES_RENAMER_MODIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_RENAMER_MODIFIER, FilesRenamerModifier))
#define FILES_RENAMER_MODIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_RENAMER_MODIFIER, FilesRenamerModifierClass))
#define FILES_IS_RENAMER_MODIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_RENAMER_MODIFIER))
#define FILES_IS_RENAMER_MODIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_RENAMER_MODIFIER))
#define FILES_RENAMER_MODIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_RENAMER_MODIFIER, FilesRenamerModifierClass))

typedef struct _FilesRenamerModifier FilesRenamerModifier;
typedef struct _FilesRenamerModifierClass FilesRenamerModifierClass;
typedef struct _Block12Data Block12Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block13Data Block13Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _FilesRenamerDialog {
	GraniteDialog parent_instance;
	FilesRenamerDialogPrivate * priv;
};

struct _FilesRenamerDialogClass {
	GraniteDialogClass parent_class;
};

struct _FilesRenamerDialogPrivate {
	FilesRenamer* renamer;
	GtkGrid* controls_grid;
	GtkBox* prefix_box;
	GtkBox* suffix_box;
	GtkRevealer* prefix_revealer;
	GtkRevealer* suffix_revealer;
	GtkEntry* basename_entry;
	GtkEntry* replacement_entry;
	GtkRadioButton* modify_basename_toggle;
	GtkRadioButton* new_basename_toggle;
	GtkRadioButton* original_basename_toggle;
	GtkRevealer* sortby_revealer;
	GSimpleActionGroup* actions;
	gint _n_number_seq;
	gint _n_prefix;
	gint _n_suffix;
};

struct _Block12Data {
	int _ref_count_;
	FilesRenamerDialog* self;
	GtkPopover* mod_popover;
	FilesRenamerModifier* mod;
};

struct _Block13Data {
	int _ref_count_;
	FilesRenamerDialog* self;
	GtkRevealer* replacement_entry_revealer;
	GtkRadioButton* name_check;
	GtkRadioButton* created_check;
	GtkRadioButton* modified_check;
	GtkRadioButton* size_check;
};

static gint FilesRenamerDialog_private_offset;
static gpointer files_renamer_dialog_parent_class = NULL;

VALA_EXTERN GType files_renamer_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesRenamerDialog, g_object_unref)
VALA_EXTERN GType files_renamer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesRenamer, g_object_unref)
VALA_EXTERN GType files_renamer_dialog_rename_base_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* files_renamer_dialog_rename_base_to_string (FilesRenamerDialogRenameBase self);
static void files_renamer_dialog_on_action_add_text (FilesRenamerDialog* self,
                                              GSimpleAction* action,
                                              GVariant* target);
static void _files_renamer_dialog_on_action_add_text_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
static void files_renamer_dialog_on_action_add_number (FilesRenamerDialog* self,
                                                GSimpleAction* action,
                                                GVariant* target);
static void _files_renamer_dialog_on_action_add_number_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self);
static void files_renamer_dialog_on_action_add_date (FilesRenamerDialog* self,
                                              GSimpleAction* action,
                                              GVariant* target);
static void _files_renamer_dialog_on_action_add_date_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                GVariant* parameter,
                                                                                gpointer self);
VALA_EXTERN FilesRenamerDialog* files_renamer_dialog_new (GList* files,
                                              const gchar* basename);
VALA_EXTERN FilesRenamerDialog* files_renamer_dialog_construct (GType object_type,
                                                    GList* files,
                                                    const gchar* basename);
VALA_EXTERN void files_renamer_add_files (FilesRenamer* self,
                              GList* files);
VALA_EXTERN void files_renamer_dialog_schedule_view_update (FilesRenamerDialog* self);
VALA_EXTERN GType files_renamer_modifier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesRenamerModifier, g_object_unref)
static void files_renamer_dialog_add_modifier (FilesRenamerDialog* self,
                                        FilesRenamerModifier* mod);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
VALA_EXTERN FilesRenamePosition files_renamer_modifier_get_pos (FilesRenamerModifier* self);
VALA_EXTERN gint files_renamer_dialog_get_n_prefix (FilesRenamerDialog* self);
static void files_renamer_dialog_set_n_prefix (FilesRenamerDialog* self,
                                        gint value);
VALA_EXTERN gint files_renamer_dialog_get_n_suffix (FilesRenamerDialog* self);
static void files_renamer_dialog_set_n_suffix (FilesRenamerDialog* self,
                                        gint value);
VALA_EXTERN FilesRenameMode files_renamer_modifier_get_mode (FilesRenamerModifier* self);
VALA_EXTERN gint files_renamer_dialog_get_n_number_seq (FilesRenamerDialog* self);
static void files_renamer_dialog_set_n_number_seq (FilesRenamerDialog* self,
                                            gint value);
VALA_EXTERN GeeArrayList* files_renamer_get_modifier_chain (FilesRenamer* self);
VALA_EXTERN GtkWidget* files_renamer_modifier_get_modifier_widget (FilesRenamerModifier* self);
static void __lambda50_ (Block12Data* _data12_);
static void ___lambda50__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda51_ (Block12Data* _data12_);
static void files_renamer_dialog_delete_modifier (FilesRenamerDialog* self,
                                           FilesRenamerModifier* mod);
static void ___lambda51__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda52_ (Block12Data* _data12_);
VALA_EXTERN void files_renamer_modifier_cancel_edit (FilesRenamerModifier* self);
static void ___lambda52__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static gboolean __lambda53_ (Block12Data* _data12_,
                      GdkEventKey* event);
static gboolean ___lambda53__gtk_widget_key_press_event (GtkWidget* _sender,
                                                  GdkEventKey* event,
                                                  gpointer self);
static void __lambda54_ (FilesRenamerDialog* self);
static void ___lambda54__gtk_popover_closed (GtkPopover* _sender,
                                      gpointer self);
VALA_EXTERN gchar* files_renamer_modifier_get_button_text (FilesRenamerModifier* self);
VALA_EXTERN void files_renamer_schedule_update (FilesRenamer* self,
                                    const gchar* custom_basename,
                                    const gchar* replacement_text);
VALA_EXTERN FilesRenamerModifier* files_renamer_modifier_new_default_number (FilesRenamePosition pos);
VALA_EXTERN FilesRenamerModifier* files_renamer_modifier_construct_default_number (GType object_type,
                                                                       FilesRenamePosition pos);
VALA_EXTERN FilesRenamerModifier* files_renamer_modifier_new_default_date (FilesRenamePosition pos);
VALA_EXTERN FilesRenamerModifier* files_renamer_modifier_construct_default_date (GType object_type,
                                                                     FilesRenamePosition pos);
VALA_EXTERN FilesRenamerModifier* files_renamer_modifier_new_default_text (FilesRenamePosition pos);
VALA_EXTERN FilesRenamerModifier* files_renamer_modifier_construct_default_text (GType object_type,
                                                                     FilesRenamePosition pos);
static GObject * files_renamer_dialog_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
VALA_EXTERN FilesRenamer* files_renamer_new (void);
VALA_EXTERN FilesRenamer* files_renamer_construct (GType object_type);
VALA_EXTERN GtkListBox* files_renamer_get_listbox (FilesRenamer* self);
static void _files_renamer_dialog___lambda55_ (Block13Data* _data13_);
static void __files_renamer_dialog___lambda55__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                   gpointer self);
static void _files_renamer_dialog___lambda56_ (Block13Data* _data13_);
static void __files_renamer_dialog___lambda56__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                   gpointer self);
static void _files_renamer_dialog___lambda57_ (Block13Data* _data13_);
static void __files_renamer_dialog___lambda57__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                   gpointer self);
static void _files_renamer_dialog___lambda58_ (FilesRenamerDialog* self);
static void __files_renamer_dialog___lambda58__gtk_editable_changed (GtkEditable* _sender,
                                                              gpointer self);
static void _files_renamer_dialog___lambda59_ (FilesRenamerDialog* self);
static void __files_renamer_dialog___lambda59__gtk_editable_changed (GtkEditable* _sender,
                                                              gpointer self);
static void _files_renamer_dialog___lambda60_ (FilesRenamerDialog* self,
                                        gint response_id);
VALA_EXTERN gboolean files_renamer_get_can_rename (FilesRenamer* self);
VALA_EXTERN void files_renamer_rename_files (FilesRenamer* self);
static void _gtk_widget_destroy_gtk_dialog_response (GtkDialog* _sender,
                                              gint response_id,
                                              gpointer self);
static void __files_renamer_dialog___lambda60__gtk_dialog_response (GtkDialog* _sender,
                                                             gint response_id,
                                                             gpointer self);
static void _files_renamer_dialog___lambda61_ (Block13Data* _data13_);
static void __files_renamer_dialog___lambda61__g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void _files_renamer_dialog___lambda62_ (Block13Data* _data13_);
VALA_EXTERN void files_renamer_set_sortby (FilesRenamer* self,
                               FilesSortBy value);
static void __files_renamer_dialog___lambda62__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                   gpointer self);
static void files_renamer_dialog_finalize (GObject * obj);
static GType files_renamer_dialog_get_type_once (void);
static void _vala_files_renamer_dialog_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_files_renamer_dialog_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static const GActionEntry FILES_RENAMER_DIALOG_ACTION_ENTRIES[3] = {{"add-text", _files_renamer_dialog_on_action_add_text_gsimple_action_activate_callback, "u"}, {"add-number", _files_renamer_dialog_on_action_add_number_gsimple_action_activate_callback, "u"}, {"add-date", _files_renamer_dialog_on_action_add_date_gsimple_action_activate_callback, "u"}};

static inline gpointer
files_renamer_dialog_get_instance_private (FilesRenamerDialog* self)
{
	return G_STRUCT_MEMBER_P (self, FilesRenamerDialog_private_offset);
}

gchar*
files_renamer_dialog_rename_base_to_string (FilesRenamerDialogRenameBase self)
{
	gchar* result;
#line 19 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	switch (self) {
#line 19 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		case FILES_RENAMER_DIALOG_RENAME_BASE_ORIGINAL:
#line 291 "RenamerDialog.c"
		{
			gchar* _tmp0_;
#line 21 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp0_ = g_strdup (_ ("Original filename"));
#line 21 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			result = _tmp0_;
#line 21 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			return result;
#line 300 "RenamerDialog.c"
		}
#line 19 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		case FILES_RENAMER_DIALOG_RENAME_BASE_REPLACE:
#line 304 "RenamerDialog.c"
		{
			gchar* _tmp1_;
#line 23 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp1_ = g_strdup (_ ("Modified original"));
#line 23 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			result = _tmp1_;
#line 23 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			return result;
#line 313 "RenamerDialog.c"
		}
#line 19 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		case FILES_RENAMER_DIALOG_RENAME_BASE_CUSTOM:
#line 317 "RenamerDialog.c"
		{
			gchar* _tmp2_;
#line 25 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp2_ = g_strdup (_ ("New basename"));
#line 25 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			result = _tmp2_;
#line 25 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			return result;
#line 326 "RenamerDialog.c"
		}
		default:
		{
#line 27 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			g_assert_not_reached ();
#line 332 "RenamerDialog.c"
		}
	}
}

 G_GNUC_NO_INLINE static GType
files_renamer_dialog_rename_base_get_type_once (void)
{
	static const GEnumValue values[] = {{FILES_RENAMER_DIALOG_RENAME_BASE_ORIGINAL, "FILES_RENAMER_DIALOG_RENAME_BASE_ORIGINAL", "original"}, {FILES_RENAMER_DIALOG_RENAME_BASE_REPLACE, "FILES_RENAMER_DIALOG_RENAME_BASE_REPLACE", "replace"}, {FILES_RENAMER_DIALOG_RENAME_BASE_CUSTOM, "FILES_RENAMER_DIALOG_RENAME_BASE_CUSTOM", "custom"}, {0, NULL, NULL}};
	GType files_renamer_dialog_rename_base_type_id;
	files_renamer_dialog_rename_base_type_id = g_enum_register_static ("FilesRenamerDialogRenameBase", values);
	return files_renamer_dialog_rename_base_type_id;
}

GType
files_renamer_dialog_rename_base_get_type (void)
{
	static volatile gsize files_renamer_dialog_rename_base_type_id__once = 0;
	if (g_once_init_enter (&files_renamer_dialog_rename_base_type_id__once)) {
		GType files_renamer_dialog_rename_base_type_id;
		files_renamer_dialog_rename_base_type_id = files_renamer_dialog_rename_base_get_type_once ();
		g_once_init_leave (&files_renamer_dialog_rename_base_type_id__once, files_renamer_dialog_rename_base_type_id);
	}
	return files_renamer_dialog_rename_base_type_id__once;
}

static void
_files_renamer_dialog_on_action_add_text_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 32 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_on_action_add_text ((FilesRenamerDialog*) self, action, parameter);
#line 365 "RenamerDialog.c"
}

static void
_files_renamer_dialog_on_action_add_number_gsimple_action_activate_callback (GSimpleAction* action,
                                                                             GVariant* parameter,
                                                                             gpointer self)
{
#line 32 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_on_action_add_number ((FilesRenamerDialog*) self, action, parameter);
#line 375 "RenamerDialog.c"
}

static void
_files_renamer_dialog_on_action_add_date_gsimple_action_activate_callback (GSimpleAction* action,
                                                                           GVariant* parameter,
                                                                           gpointer self)
{
#line 32 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_on_action_add_date ((FilesRenamerDialog*) self, action, parameter);
#line 385 "RenamerDialog.c"
}

FilesRenamerDialog*
files_renamer_dialog_construct (GType object_type,
                                GList* files,
                                const gchar* basename)
{
	FilesRenamerDialog * self = NULL;
	FilesRenamer* _tmp0_;
#line 56 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self = (FilesRenamerDialog*) granite_dialog_construct (object_type);
#line 57 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = self->priv->renamer;
#line 57 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_add_files (_tmp0_, files);
#line 58 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_schedule_view_update (self);
#line 56 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	return self;
#line 405 "RenamerDialog.c"
}

FilesRenamerDialog*
files_renamer_dialog_new (GList* files,
                          const gchar* basename)
{
#line 56 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	return files_renamer_dialog_construct (FILES_TYPE_RENAMER_DIALOG, files, basename);
#line 414 "RenamerDialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 422 "RenamerDialog.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	return _data12_;
#line 432 "RenamerDialog.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 442 "RenamerDialog.c"
		FilesRenamerDialog* self;
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		self = _data12_->self;
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_g_object_unref0 (_data12_->mod_popover);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_g_object_unref0 (_data12_->mod);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_g_object_unref0 (self);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		g_slice_free (Block12Data, _data12_);
#line 454 "RenamerDialog.c"
	}
}

static void
__lambda50_ (Block12Data* _data12_)
{
	FilesRenamerDialog* self;
	GtkPopover* _tmp0_;
#line 360 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self = _data12_->self;
#line 361 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = _data12_->mod_popover;
#line 361 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_popover_popdown (_tmp0_);
#line 469 "RenamerDialog.c"
}

static void
___lambda50__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 360 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	__lambda50_ (self);
#line 478 "RenamerDialog.c"
}

static void
__lambda51_ (Block12Data* _data12_)
{
	FilesRenamerDialog* self;
	GtkPopover* _tmp0_;
#line 364 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self = _data12_->self;
#line 365 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = _data12_->mod_popover;
#line 365 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_popover_popdown (_tmp0_);
#line 366 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_delete_modifier (self, _data12_->mod);
#line 494 "RenamerDialog.c"
}

static void
___lambda51__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 364 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	__lambda51_ (self);
#line 503 "RenamerDialog.c"
}

static void
__lambda52_ (Block12Data* _data12_)
{
	FilesRenamerDialog* self;
	GtkPopover* _tmp0_;
#line 369 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self = _data12_->self;
#line 370 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_modifier_cancel_edit (_data12_->mod);
#line 371 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = _data12_->mod_popover;
#line 371 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_popover_popdown (_tmp0_);
#line 519 "RenamerDialog.c"
}

static void
___lambda52__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 369 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	__lambda52_ (self);
#line 528 "RenamerDialog.c"
}

static gboolean
__lambda53_ (Block12Data* _data12_,
             GdkEventKey* event)
{
	FilesRenamerDialog* self;
	gboolean result;
#line 374 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self = _data12_->self;
#line 374 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 375 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	switch (event->keyval) {
#line 375 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		case GDK_KEY_Return:
#line 375 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		case GDK_KEY_KP_Enter:
#line 547 "RenamerDialog.c"
		{
			GtkPopover* _tmp0_;
#line 378 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp0_ = _data12_->mod_popover;
#line 378 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			gtk_popover_popdown (_tmp0_);
#line 380 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			result = TRUE;
#line 380 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			return result;
#line 558 "RenamerDialog.c"
		}
#line 375 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		case GDK_KEY_Escape:
#line 562 "RenamerDialog.c"
		{
			GtkPopover* _tmp1_;
#line 382 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			files_renamer_modifier_cancel_edit (_data12_->mod);
#line 383 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp1_ = _data12_->mod_popover;
#line 383 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			gtk_popover_popdown (_tmp1_);
#line 385 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			result = TRUE;
#line 385 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			return result;
#line 575 "RenamerDialog.c"
		}
		default:
		{
#line 388 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			result = FALSE;
#line 388 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			return result;
#line 583 "RenamerDialog.c"
		}
	}
}

static gboolean
___lambda53__gtk_widget_key_press_event (GtkWidget* _sender,
                                         GdkEventKey* event,
                                         gpointer self)
{
	gboolean result;
	result = __lambda53_ (self, event);
#line 374 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	return result;
#line 597 "RenamerDialog.c"
}

static void
__lambda54_ (FilesRenamerDialog* self)
{
#line 393 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_schedule_view_update (self);
#line 605 "RenamerDialog.c"
}

static void
___lambda54__gtk_popover_closed (GtkPopover* _sender,
                                 gpointer self)
{
#line 392 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	__lambda54_ ((FilesRenamerDialog*) self);
#line 614 "RenamerDialog.c"
}

static void
files_renamer_dialog_add_modifier (FilesRenamerDialog* self,
                                   FilesRenamerModifier* mod)
{
	Block12Data* _data12_;
	FilesRenamerModifier* _tmp0_;
	FilesRenamePosition _tmp1_;
	FilesRenamePosition _tmp2_;
	FilesRenameMode _tmp9_;
	FilesRenameMode _tmp10_;
	FilesRenamer* _tmp12_;
	GeeArrayList* _tmp13_;
	GeeArrayList* _tmp14_;
	GtkButton* apply_button = NULL;
	GtkButton* _tmp15_;
	GtkButton* _tmp16_;
	GtkStyleContext* _tmp17_;
	GtkButton* cancel_button = NULL;
	GtkButton* _tmp18_;
	GtkButton* delete_button = NULL;
	GtkButton* _tmp19_;
	GtkActionBar* button_box = NULL;
	GtkActionBar* _tmp20_;
	GtkActionBar* _tmp21_;
	GtkButton* _tmp22_;
	GtkActionBar* _tmp23_;
	GtkButton* _tmp24_;
	GtkActionBar* _tmp25_;
	GtkButton* _tmp26_;
	GtkActionBar* _tmp27_;
	GtkStyleContext* _tmp28_;
	GtkBox* edit_box = NULL;
	GtkBox* _tmp29_;
	GtkBox* _tmp30_;
	GtkWidget* _tmp31_;
	GtkWidget* _tmp32_;
	GtkBox* _tmp33_;
	GtkActionBar* _tmp34_;
	GtkBox* _tmp35_;
	GtkBox* _tmp36_;
	GtkWidget* _tmp37_;
	GtkPopover* _tmp38_ = NULL;
	GtkMenuButton* mod_button = NULL;
	GtkImage* _tmp39_;
	FilesRenameMode _tmp40_;
	FilesRenameMode _tmp41_;
	gchar* _tmp42_;
	GtkPopover* _tmp43_;
	GtkPopover* _tmp44_;
	GtkMenuButton* _tmp45_ = NULL;
	GtkMenuButton* _tmp46_;
	GtkButton* _tmp47_;
	GtkButton* _tmp48_;
	GtkButton* _tmp49_;
	GtkButton* _tmp50_;
	GtkPopover* _tmp51_;
	GtkPopover* _tmp52_;
	FilesRenamePosition _tmp53_;
	FilesRenamePosition _tmp54_;
	GtkGrid* _tmp61_;
	GtkGrid* _tmp62_;
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (self != NULL);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (mod != NULL);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data12_->_ref_count_ = 1;
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data12_->self = g_object_ref (self);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = _g_object_ref0 (mod);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_data12_->mod);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data12_->mod = _tmp0_;
#line 318 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp1_ = files_renamer_modifier_get_pos (_data12_->mod);
#line 318 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp2_ = _tmp1_;
#line 318 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (_tmp2_ == FILES_RENAME_POSITION_PREFIX) {
#line 700 "RenamerDialog.c"
		GtkRevealer* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
#line 319 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp3_ = self->priv->prefix_revealer;
#line 319 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp4_ = self->priv->_n_prefix;
#line 319 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp4_ = _tmp4_ + 1;
#line 319 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp5_ = _tmp4_;
#line 319 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_dialog_set_n_prefix (self, _tmp5_);
#line 319 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_revealer_set_reveal_child (_tmp3_, _tmp5_ < FILES_RENAMER_DIALOG_MAX_PREFIX);
#line 716 "RenamerDialog.c"
	} else {
		GtkRevealer* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 321 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp6_ = self->priv->suffix_revealer;
#line 321 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp7_ = self->priv->_n_suffix;
#line 321 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp7_ = _tmp7_ + 1;
#line 321 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp8_ = _tmp7_;
#line 321 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_dialog_set_n_suffix (self, _tmp8_);
#line 321 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_revealer_set_reveal_child (_tmp6_, _tmp8_ < FILES_RENAMER_DIALOG_MAX_SUFFIX);
#line 733 "RenamerDialog.c"
	}
#line 323 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp9_ = files_renamer_modifier_get_mode (_data12_->mod);
#line 323 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp10_ = _tmp9_;
#line 323 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (_tmp10_ == FILES_RENAME_MODE_NUMBER_SEQUENCE) {
#line 741 "RenamerDialog.c"
		gint _tmp11_;
#line 324 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp11_ = self->priv->_n_number_seq;
#line 324 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_dialog_set_n_number_seq (self, _tmp11_ + 1);
#line 747 "RenamerDialog.c"
	}
#line 326 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp12_ = self->priv->renamer;
#line 326 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp13_ = files_renamer_get_modifier_chain (_tmp12_);
#line 326 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp14_ = _tmp13_;
#line 326 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp14_, _data12_->mod);
#line 328 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp15_ = (GtkButton*) gtk_button_new_with_label (_ ("Apply"));
#line 328 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp15_);
#line 328 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	apply_button = _tmp15_;
#line 329 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp16_ = apply_button;
#line 329 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp17_ = gtk_widget_get_style_context ((GtkWidget*) _tmp16_);
#line 329 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_style_context_add_class (_tmp17_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 331 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp18_ = (GtkButton*) gtk_button_new_with_label (_ ("Cancel"));
#line 331 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp18_);
#line 331 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	cancel_button = _tmp18_;
#line 333 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp19_ = (GtkButton*) gtk_button_new_with_label (_ ("Delete"));
#line 333 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp19_);
#line 333 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	delete_button = _tmp19_;
#line 335 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp20_ = (GtkActionBar*) gtk_action_bar_new ();
#line 335 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp20_);
#line 335 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	button_box = _tmp20_;
#line 336 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp21_ = button_box;
#line 336 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp22_ = delete_button;
#line 336 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_action_bar_pack_start (_tmp21_, (GtkWidget*) _tmp22_);
#line 337 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp23_ = button_box;
#line 337 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp24_ = apply_button;
#line 337 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_action_bar_pack_end (_tmp23_, (GtkWidget*) _tmp24_);
#line 338 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp25_ = button_box;
#line 338 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp26_ = cancel_button;
#line 338 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_action_bar_pack_end (_tmp25_, (GtkWidget*) _tmp26_);
#line 339 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp27_ = button_box;
#line 339 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp28_ = gtk_widget_get_style_context ((GtkWidget*) _tmp27_);
#line 339 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_style_context_add_class (_tmp28_, GTK_STYLE_CLASS_FLAT);
#line 341 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp29_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
#line 341 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp29_);
#line 341 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	edit_box = _tmp29_;
#line 342 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp30_ = edit_box;
#line 342 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp31_ = files_renamer_modifier_get_modifier_widget (_data12_->mod);
#line 342 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp32_ = _tmp31_;
#line 342 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_box_pack_start (_tmp30_, _tmp32_, TRUE, TRUE, (guint) 0);
#line 342 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp32_);
#line 343 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp33_ = edit_box;
#line 343 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp34_ = button_box;
#line 343 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_box_pack_start (_tmp33_, (GtkWidget*) _tmp34_, TRUE, TRUE, (guint) 0);
#line 344 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp35_ = edit_box;
#line 344 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp35_);
#line 346 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp36_ = edit_box;
#line 346 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp37_ = _g_object_ref0 ((GtkWidget*) _tmp36_);
#line 346 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp38_ = (GtkPopover*) gtk_popover_new (NULL);
#line 346 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_set ((GtkContainer*) _tmp38_, "child", _tmp37_, NULL);
#line 346 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp37_);
#line 346 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp38_);
#line 346 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data12_->mod_popover = _tmp38_;
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp39_ = (GtkImage*) gtk_image_new_from_icon_name ("pan-down-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp39_);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp40_ = files_renamer_modifier_get_mode (_data12_->mod);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp41_ = _tmp40_;
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp42_ = files_rename_mode_to_string (_tmp41_);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp43_ = _data12_->mod_popover;
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp44_ = _g_object_ref0 (_tmp43_);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp45_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_button_set_always_show_image ((GtkButton*) _tmp45_, TRUE);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_button_set_image ((GtkButton*) _tmp45_, (GtkWidget*) _tmp39_);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp39_);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_button_set_image_position ((GtkButton*) _tmp45_, GTK_POS_RIGHT);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_button_set_label ((GtkButton*) _tmp45_, _tmp42_);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (_tmp42_);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_menu_button_set_popover (_tmp45_, _tmp44_);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp44_);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp45_);
#line 350 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	mod_button = _tmp45_;
#line 358 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp46_ = mod_button;
#line 358 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp47_ = _g_object_ref0 ((GtkButton*) _tmp46_);
#line 358 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_set_data_full ((GObject*) _data12_->mod, "button", _tmp47_, g_object_unref);
#line 360 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp48_ = apply_button;
#line 360 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_data (_tmp48_, "clicked", (GCallback) ___lambda50__gtk_button_clicked, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 364 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp49_ = delete_button;
#line 364 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_data (_tmp49_, "clicked", (GCallback) ___lambda51__gtk_button_clicked, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 369 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp50_ = cancel_button;
#line 369 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_data (_tmp50_, "clicked", (GCallback) ___lambda52__gtk_button_clicked, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 374 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp51_ = _data12_->mod_popover;
#line 374 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_data ((GtkWidget*) _tmp51_, "key-press-event", (GCallback) ___lambda53__gtk_widget_key_press_event, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 392 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp52_ = _data12_->mod_popover;
#line 392 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_object (_tmp52_, "closed", (GCallback) ___lambda54__gtk_popover_closed, self, 0);
#line 396 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp53_ = files_renamer_modifier_get_pos (_data12_->mod);
#line 396 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp54_ = _tmp53_;
#line 396 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (_tmp54_ == FILES_RENAME_POSITION_PREFIX) {
#line 919 "RenamerDialog.c"
		GtkBox* _tmp55_;
		GtkMenuButton* _tmp56_;
#line 397 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp55_ = self->priv->prefix_box;
#line 397 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp56_ = mod_button;
#line 397 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
#line 928 "RenamerDialog.c"
	} else {
		GtkBox* _tmp57_;
		GtkMenuButton* _tmp58_;
		GtkBox* _tmp59_;
		GtkRevealer* _tmp60_;
#line 400 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp57_ = self->priv->suffix_box;
#line 400 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp58_ = mod_button;
#line 400 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_container_add ((GtkContainer*) _tmp57_, (GtkWidget*) _tmp58_);
#line 401 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp59_ = self->priv->suffix_box;
#line 401 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp60_ = self->priv->suffix_revealer;
#line 401 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_box_reorder_child (_tmp59_, (GtkWidget*) _tmp60_, -1);
#line 946 "RenamerDialog.c"
	}
#line 404 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp61_ = self->priv->controls_grid;
#line 404 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp61_);
#line 405 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp62_ = self->priv->controls_grid;
#line 405 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_queue_draw ((GtkWidget*) _tmp62_);
#line 406 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_schedule_view_update (self);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (mod_button);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (edit_box);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (button_box);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (delete_button);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (cancel_button);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (apply_button);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	block12_data_unref (_data12_);
#line 317 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data12_ = NULL;
#line 974 "RenamerDialog.c"
}

static void
files_renamer_dialog_delete_modifier (FilesRenamerDialog* self,
                                      FilesRenamerModifier* mod)
{
	FilesRenamePosition _tmp0_;
	FilesRenamePosition _tmp1_;
	FilesRenameMode _tmp8_;
	FilesRenameMode _tmp9_;
	FilesRenamer* _tmp11_;
	GeeArrayList* _tmp12_;
	GeeArrayList* _tmp13_;
	GtkButton* button = NULL;
	gconstpointer _tmp14_;
	GtkButton* _tmp15_;
#line 410 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (self != NULL);
#line 410 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (mod != NULL);
#line 411 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = files_renamer_modifier_get_pos (mod);
#line 411 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp1_ = _tmp0_;
#line 411 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (_tmp1_ == FILES_RENAME_POSITION_PREFIX) {
#line 1001 "RenamerDialog.c"
		GtkRevealer* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 412 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp2_ = self->priv->prefix_revealer;
#line 412 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp3_ = self->priv->_n_prefix;
#line 412 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp3_ = _tmp3_ - 1;
#line 412 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp4_ = _tmp3_;
#line 412 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_dialog_set_n_prefix (self, _tmp4_);
#line 412 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_revealer_set_reveal_child (_tmp2_, _tmp4_ < FILES_RENAMER_DIALOG_MAX_PREFIX);
#line 1017 "RenamerDialog.c"
	} else {
		GtkRevealer* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 414 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp5_ = self->priv->suffix_revealer;
#line 414 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp6_ = self->priv->_n_suffix;
#line 414 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp6_ = _tmp6_ - 1;
#line 414 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp7_ = _tmp6_;
#line 414 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_dialog_set_n_suffix (self, _tmp7_);
#line 414 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_revealer_set_reveal_child (_tmp5_, _tmp7_ < FILES_RENAMER_DIALOG_MAX_SUFFIX);
#line 1034 "RenamerDialog.c"
	}
#line 416 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp8_ = files_renamer_modifier_get_mode (mod);
#line 416 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp9_ = _tmp8_;
#line 416 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (_tmp9_ == FILES_RENAME_MODE_NUMBER_SEQUENCE) {
#line 1042 "RenamerDialog.c"
		gint _tmp10_;
#line 417 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp10_ = self->priv->_n_number_seq;
#line 417 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_dialog_set_n_number_seq (self, _tmp10_ - 1);
#line 1048 "RenamerDialog.c"
	}
#line 419 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp11_ = self->priv->renamer;
#line 419 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp12_ = files_renamer_get_modifier_chain (_tmp11_);
#line 419 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp13_ = _tmp12_;
#line 419 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp13_, mod);
#line 420 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp14_ = g_object_get_data ((GObject*) mod, "button");
#line 420 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp15_ = _g_object_ref0 ((GtkButton*) _tmp14_);
#line 420 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	button = _tmp15_;
#line 421 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_destroy ((GtkWidget*) button);
#line 423 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_schedule_view_update (self);
#line 424 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (button);
#line 424 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	return;
#line 1072 "RenamerDialog.c"
}

void
files_renamer_dialog_schedule_view_update (FilesRenamerDialog* self)
{
	const gchar* _tmp17_ = NULL;
	GtkRadioButton* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	gchar* custom_basename = NULL;
	gchar* _tmp24_;
	const gchar* _tmp25_ = NULL;
	GtkRadioButton* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	gchar* replacement_text = NULL;
	gchar* _tmp32_;
	FilesRenamer* _tmp33_;
	const gchar* _tmp34_;
#line 427 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (self != NULL);
#line 1094 "RenamerDialog.c"
	{
		GeeArrayList* _mod_list = NULL;
		FilesRenamer* _tmp0_;
		GeeArrayList* _tmp1_;
		GeeArrayList* _tmp2_;
		gint _mod_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _mod_index = 0;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp0_ = self->priv->renamer;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp1_ = files_renamer_get_modifier_chain (_tmp0_);
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp2_ = _tmp1_;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_mod_list = _tmp2_;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp3_ = _mod_list;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp5_ = _tmp4_;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_mod_size = _tmp5_;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_mod_index = -1;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		while (TRUE) {
#line 1125 "RenamerDialog.c"
			gint _tmp6_;
			gint _tmp7_;
			FilesRenamerModifier* mod = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			GtkButton* button = NULL;
			FilesRenamerModifier* _tmp10_;
			gconstpointer _tmp11_;
			GtkButton* _tmp12_;
			GtkButton* _tmp13_;
			FilesRenamerModifier* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_mod_index = _mod_index + 1;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp6_ = _mod_index;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp7_ = _mod_size;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				break;
#line 1149 "RenamerDialog.c"
			}
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp8_ = _mod_list;
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _mod_index);
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			mod = (FilesRenamerModifier*) _tmp9_;
#line 429 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp10_ = mod;
#line 429 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp11_ = g_object_get_data ((GObject*) _tmp10_, "button");
#line 429 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp12_ = _g_object_ref0 ((GtkButton*) _tmp11_);
#line 429 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			button = _tmp12_;
#line 430 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp13_ = button;
#line 430 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp14_ = mod;
#line 430 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp15_ = files_renamer_modifier_get_button_text (_tmp14_);
#line 430 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp16_ = _tmp15_;
#line 430 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			gtk_button_set_label (_tmp13_, _tmp16_);
#line 430 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_g_free0 (_tmp16_);
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_g_object_unref0 (button);
#line 428 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_g_object_unref0 (mod);
#line 1181 "RenamerDialog.c"
		}
	}
#line 433 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp18_ = self->priv->original_basename_toggle;
#line 433 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp19_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp18_);
#line 433 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp20_ = _tmp19_;
#line 433 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (_tmp20_) {
#line 433 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp17_ = NULL;
#line 1194 "RenamerDialog.c"
	} else {
		GtkEntry* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
#line 433 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp21_ = self->priv->basename_entry;
#line 433 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp22_ = gtk_entry_get_text (_tmp21_);
#line 433 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp23_ = _tmp22_;
#line 433 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp17_ = _tmp23_;
#line 1207 "RenamerDialog.c"
	}
#line 433 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp24_ = g_strdup (_tmp17_);
#line 433 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	custom_basename = _tmp24_;
#line 434 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp26_ = self->priv->modify_basename_toggle;
#line 434 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp27_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp26_);
#line 434 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp28_ = _tmp27_;
#line 434 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (_tmp28_) {
#line 1221 "RenamerDialog.c"
		GtkEntry* _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
#line 434 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp29_ = self->priv->replacement_entry;
#line 434 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp30_ = gtk_entry_get_text (_tmp29_);
#line 434 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp31_ = _tmp30_;
#line 434 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp25_ = _tmp31_;
#line 1233 "RenamerDialog.c"
	} else {
#line 434 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp25_ = NULL;
#line 1237 "RenamerDialog.c"
	}
#line 434 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp32_ = g_strdup (_tmp25_);
#line 434 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	replacement_text = _tmp32_;
#line 435 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp33_ = self->priv->renamer;
#line 435 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp34_ = custom_basename;
#line 435 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_schedule_update (_tmp33_, _tmp34_, replacement_text);
#line 427 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (replacement_text);
#line 427 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (custom_basename);
#line 1253 "RenamerDialog.c"
}

static void
files_renamer_dialog_on_action_add_number (FilesRenamerDialog* self,
                                           GSimpleAction* action,
                                           GVariant* target)
{
	FilesRenamePosition pos = 0;
	FilesRenamerModifier* mod = NULL;
	FilesRenamerModifier* _tmp0_;
#line 438 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (self != NULL);
#line 438 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (action != NULL);
#line 439 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	pos = (FilesRenamePosition) g_variant_get_uint32 (target);
#line 440 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = files_renamer_modifier_new_default_number (pos);
#line 440 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	mod = _tmp0_;
#line 441 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_add_modifier (self, mod);
#line 438 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (mod);
#line 1278 "RenamerDialog.c"
}

static void
files_renamer_dialog_on_action_add_date (FilesRenamerDialog* self,
                                         GSimpleAction* action,
                                         GVariant* target)
{
	FilesRenamePosition pos = 0;
	FilesRenamerModifier* mod = NULL;
	FilesRenamerModifier* _tmp0_;
#line 444 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (self != NULL);
#line 444 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (action != NULL);
#line 445 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	pos = (FilesRenamePosition) g_variant_get_uint32 (target);
#line 446 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = files_renamer_modifier_new_default_date (pos);
#line 446 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	mod = _tmp0_;
#line 447 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_add_modifier (self, mod);
#line 444 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (mod);
#line 1303 "RenamerDialog.c"
}

static void
files_renamer_dialog_on_action_add_text (FilesRenamerDialog* self,
                                         GSimpleAction* action,
                                         GVariant* target)
{
	FilesRenamePosition pos = 0;
	FilesRenamerModifier* mod = NULL;
	FilesRenamerModifier* _tmp0_;
#line 450 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (self != NULL);
#line 450 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (action != NULL);
#line 451 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	pos = (FilesRenamePosition) g_variant_get_uint32 (target);
#line 452 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = files_renamer_modifier_new_default_text (pos);
#line 452 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	mod = _tmp0_;
#line 453 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_add_modifier (self, mod);
#line 450 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (mod);
#line 1328 "RenamerDialog.c"
}

gint
files_renamer_dialog_get_n_number_seq (FilesRenamerDialog* self)
{
	gint result;
#line 52 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 52 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	result = self->priv->_n_number_seq;
#line 52 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	return result;
#line 1341 "RenamerDialog.c"
}

static void
files_renamer_dialog_set_n_number_seq (FilesRenamerDialog* self,
                                       gint value)
{
	gint old_value;
#line 52 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	old_value = files_renamer_dialog_get_n_number_seq (self);
#line 52 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (old_value != value) {
#line 52 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		self->priv->_n_number_seq = value;
#line 52 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, files_renamer_dialog_properties[FILES_RENAMER_DIALOG_N_NUMBER_SEQ_PROPERTY]);
#line 1359 "RenamerDialog.c"
	}
}

gint
files_renamer_dialog_get_n_prefix (FilesRenamerDialog* self)
{
	gint result;
#line 53 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 53 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	result = self->priv->_n_prefix;
#line 53 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	return result;
#line 1373 "RenamerDialog.c"
}

static void
files_renamer_dialog_set_n_prefix (FilesRenamerDialog* self,
                                   gint value)
{
	gint old_value;
#line 53 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	old_value = files_renamer_dialog_get_n_prefix (self);
#line 53 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (old_value != value) {
#line 53 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		self->priv->_n_prefix = value;
#line 53 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, files_renamer_dialog_properties[FILES_RENAMER_DIALOG_N_PREFIX_PROPERTY]);
#line 1391 "RenamerDialog.c"
	}
}

gint
files_renamer_dialog_get_n_suffix (FilesRenamerDialog* self)
{
	gint result;
#line 54 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 54 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	result = self->priv->_n_suffix;
#line 54 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	return result;
#line 1405 "RenamerDialog.c"
}

static void
files_renamer_dialog_set_n_suffix (FilesRenamerDialog* self,
                                   gint value)
{
	gint old_value;
#line 54 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	old_value = files_renamer_dialog_get_n_suffix (self);
#line 54 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (old_value != value) {
#line 54 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		self->priv->_n_suffix = value;
#line 54 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		g_object_notify_by_pspec ((GObject *) self, files_renamer_dialog_properties[FILES_RENAMER_DIALOG_N_SUFFIX_PROPERTY]);
#line 1423 "RenamerDialog.c"
	}
}

static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	return _data13_;
#line 1434 "RenamerDialog.c"
}

static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 1444 "RenamerDialog.c"
		FilesRenamerDialog* self;
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		self = _data13_->self;
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_g_object_unref0 (_data13_->size_check);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_g_object_unref0 (_data13_->modified_check);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_g_object_unref0 (_data13_->created_check);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_g_object_unref0 (_data13_->name_check);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_g_object_unref0 (_data13_->replacement_entry_revealer);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_g_object_unref0 (self);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		g_slice_free (Block13Data, _data13_);
#line 1462 "RenamerDialog.c"
	}
}

static void
_files_renamer_dialog___lambda55_ (Block13Data* _data13_)
{
	FilesRenamerDialog* self;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 240 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self = _data13_->self;
#line 241 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = self->priv->original_basename_toggle;
#line 241 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 241 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp2_ = _tmp1_;
#line 241 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (_tmp2_) {
#line 1483 "RenamerDialog.c"
		GtkEntry* _tmp3_;
		GtkEntry* _tmp4_;
		GtkRevealer* _tmp5_;
#line 242 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp3_ = self->priv->basename_entry;
#line 242 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, FALSE);
#line 243 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp4_ = self->priv->basename_entry;
#line 243 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_entry_set_text (_tmp4_, _ ("Original Basename"));
#line 244 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp5_ = _data13_->replacement_entry_revealer;
#line 244 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_revealer_set_reveal_child (_tmp5_, FALSE);
#line 245 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_dialog_schedule_view_update (self);
#line 1501 "RenamerDialog.c"
	}
}

static void
__files_renamer_dialog___lambda55__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                              gpointer self)
{
#line 240 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_files_renamer_dialog___lambda55_ (self);
#line 1511 "RenamerDialog.c"
}

static void
_files_renamer_dialog___lambda56_ (Block13Data* _data13_)
{
	FilesRenamerDialog* self;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 248 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self = _data13_->self;
#line 249 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = self->priv->new_basename_toggle;
#line 249 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 249 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp2_ = _tmp1_;
#line 249 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (_tmp2_) {
#line 1531 "RenamerDialog.c"
		GtkEntry* _tmp3_;
		GtkEntry* _tmp4_;
		GtkEntry* _tmp5_;
		GtkRevealer* _tmp6_;
#line 250 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp3_ = self->priv->basename_entry;
#line 250 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, TRUE);
#line 251 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp4_ = self->priv->basename_entry;
#line 251 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_entry_set_text (_tmp4_, "");
#line 252 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp5_ = self->priv->basename_entry;
#line 252 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_entry_set_placeholder_text (_tmp5_, _ ("New basename"));
#line 253 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp6_ = _data13_->replacement_entry_revealer;
#line 253 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_revealer_set_reveal_child (_tmp6_, FALSE);
#line 254 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_dialog_schedule_view_update (self);
#line 1554 "RenamerDialog.c"
	}
}

static void
__files_renamer_dialog___lambda56__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                              gpointer self)
{
#line 248 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_files_renamer_dialog___lambda56_ (self);
#line 1564 "RenamerDialog.c"
}

static void
_files_renamer_dialog___lambda57_ (Block13Data* _data13_)
{
	FilesRenamerDialog* self;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 257 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self = _data13_->self;
#line 258 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = self->priv->modify_basename_toggle;
#line 258 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 258 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp2_ = _tmp1_;
#line 258 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (_tmp2_) {
#line 1584 "RenamerDialog.c"
		GtkEntry* _tmp3_;
		GtkEntry* _tmp4_;
		GtkEntry* _tmp5_;
		GtkRevealer* _tmp6_;
#line 259 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp3_ = self->priv->basename_entry;
#line 259 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, TRUE);
#line 260 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp4_ = self->priv->basename_entry;
#line 260 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_entry_set_text (_tmp4_, "");
#line 261 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp5_ = self->priv->basename_entry;
#line 261 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_entry_set_placeholder_text (_tmp5_, _ ("Text to be replaced"));
#line 262 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp6_ = _data13_->replacement_entry_revealer;
#line 262 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_revealer_set_reveal_child (_tmp6_, TRUE);
#line 263 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_dialog_schedule_view_update (self);
#line 1607 "RenamerDialog.c"
	}
}

static void
__files_renamer_dialog___lambda57__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                              gpointer self)
{
#line 257 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_files_renamer_dialog___lambda57_ (self);
#line 1617 "RenamerDialog.c"
}

static void
_files_renamer_dialog___lambda58_ (FilesRenamerDialog* self)
{
#line 268 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_schedule_view_update (self);
#line 1625 "RenamerDialog.c"
}

static void
__files_renamer_dialog___lambda58__gtk_editable_changed (GtkEditable* _sender,
                                                         gpointer self)
{
#line 267 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_files_renamer_dialog___lambda58_ ((FilesRenamerDialog*) self);
#line 1634 "RenamerDialog.c"
}

static void
_files_renamer_dialog___lambda59_ (FilesRenamerDialog* self)
{
#line 272 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_schedule_view_update (self);
#line 1642 "RenamerDialog.c"
}

static void
__files_renamer_dialog___lambda59__gtk_editable_changed (GtkEditable* _sender,
                                                         gpointer self)
{
#line 271 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_files_renamer_dialog___lambda59_ ((FilesRenamerDialog*) self);
#line 1651 "RenamerDialog.c"
}

static void
_gtk_widget_destroy_gtk_dialog_response (GtkDialog* _sender,
                                         gint response_id,
                                         gpointer self)
{
#line 287 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 1661 "RenamerDialog.c"
}

static void
_files_renamer_dialog___lambda60_ (FilesRenamerDialog* self,
                                   gint response_id)
{
	GError* _inner_error0_ = NULL;
#line 276 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (response_id == ((gint) GTK_RESPONSE_APPLY)) {
#line 1671 "RenamerDialog.c"
		FilesRenamer* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
#line 277 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp0_ = self->priv->renamer;
#line 277 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp1_ = files_renamer_get_can_rename (_tmp0_);
#line 277 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp2_ = _tmp1_;
#line 277 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		if (_tmp2_) {
#line 1683 "RenamerDialog.c"
			{
				FilesRenamer* _tmp3_;
#line 279 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_tmp3_ = self->priv->renamer;
#line 279 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				files_renamer_rename_files (_tmp3_);
#line 1690 "RenamerDialog.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				GraniteMessageDialog* dlg = NULL;
				GError* _tmp4_;
				const gchar* _tmp5_;
				GThemedIcon* _tmp6_;
				GThemedIcon* _tmp7_;
				GraniteMessageDialog* _tmp8_;
				GraniteMessageDialog* _tmp9_;
				GraniteMessageDialog* _tmp10_;
				GraniteMessageDialog* _tmp11_;
				GraniteMessageDialog* _tmp12_;
#line 278 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				e = _inner_error0_;
#line 278 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_inner_error0_ = NULL;
#line 281 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_tmp4_ = e;
#line 281 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_tmp5_ = _tmp4_->message;
#line 281 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_tmp6_ = (GThemedIcon*) g_themed_icon_new ("dialog-error");
#line 281 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_tmp7_ = _tmp6_;
#line 281 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_tmp8_ = granite_message_dialog_new ("Error renaming files", _tmp5_, (GIcon*) _tmp7_, GTK_BUTTONS_CLOSE);
#line 281 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				g_object_ref_sink (_tmp8_);
#line 281 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_tmp9_ = _tmp8_;
#line 281 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_g_object_unref0 (_tmp7_);
#line 281 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				dlg = _tmp9_;
#line 286 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_tmp10_ = dlg;
#line 286 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				gtk_window_present ((GtkWindow*) _tmp10_);
#line 287 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_tmp11_ = dlg;
#line 287 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_tmp12_ = dlg;
#line 287 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				g_signal_connect_object ((GtkDialog*) _tmp11_, "response", (GCallback) _gtk_widget_destroy_gtk_dialog_response, (GtkWidget*) _tmp12_, 0);
#line 278 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_g_object_unref0 (dlg);
#line 278 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_g_error_free0 (e);
#line 1742 "RenamerDialog.c"
			}
			__finally0:
#line 278 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 278 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 278 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				g_clear_error (&_inner_error0_);
#line 278 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				return;
#line 1753 "RenamerDialog.c"
			}
		}
	}
#line 292 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_emit_by_name ((GtkDialog*) self, "close");
#line 1759 "RenamerDialog.c"
}

static void
__files_renamer_dialog___lambda60__gtk_dialog_response (GtkDialog* _sender,
                                                        gint response_id,
                                                        gpointer self)
{
#line 275 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_files_renamer_dialog___lambda60_ ((FilesRenamerDialog*) self, response_id);
#line 1769 "RenamerDialog.c"
}

static void
_files_renamer_dialog___lambda61_ (Block13Data* _data13_)
{
	FilesRenamerDialog* self;
	GtkRevealer* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 295 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self = _data13_->self;
#line 296 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = self->priv->sortby_revealer;
#line 296 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp1_ = self->priv->_n_number_seq;
#line 296 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_revealer_set_reveal_child (_tmp0_, _tmp1_ > 0);
#line 297 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp2_ = self->priv->_n_number_seq;
#line 297 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (_tmp2_ == 0) {
#line 1791 "RenamerDialog.c"
		GtkRadioButton* _tmp3_;
#line 298 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp3_ = _data13_->name_check;
#line 298 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		gtk_toggle_button_set_active ((GtkToggleButton*) _tmp3_, TRUE);
#line 1797 "RenamerDialog.c"
	}
}

static void
__files_renamer_dialog___lambda61__g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 295 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_files_renamer_dialog___lambda61_ (self);
#line 1808 "RenamerDialog.c"
}

static void
_files_renamer_dialog___lambda62_ (Block13Data* _data13_)
{
	FilesRenamerDialog* self;
	GtkRadioButton* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 302 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self = _data13_->self;
#line 303 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = _data13_->size_check;
#line 303 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp1_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp0_);
#line 303 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp2_ = _tmp1_;
#line 303 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	if (_tmp2_) {
#line 1828 "RenamerDialog.c"
		FilesRenamer* _tmp3_;
#line 304 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp3_ = self->priv->renamer;
#line 304 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_set_sortby (_tmp3_, FILES_SORT_BY_SIZE);
#line 1834 "RenamerDialog.c"
	} else {
		GtkRadioButton* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 305 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp4_ = _data13_->created_check;
#line 305 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp5_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp4_);
#line 305 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		_tmp6_ = _tmp5_;
#line 305 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		if (_tmp6_) {
#line 1847 "RenamerDialog.c"
			FilesRenamer* _tmp7_;
#line 306 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp7_ = self->priv->renamer;
#line 306 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			files_renamer_set_sortby (_tmp7_, FILES_SORT_BY_CREATED);
#line 1853 "RenamerDialog.c"
		} else {
			GtkRadioButton* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 307 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp8_ = _data13_->modified_check;
#line 307 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp9_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp8_);
#line 307 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			_tmp10_ = _tmp9_;
#line 307 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
			if (_tmp10_) {
#line 1866 "RenamerDialog.c"
				FilesRenamer* _tmp11_;
#line 308 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_tmp11_ = self->priv->renamer;
#line 308 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				files_renamer_set_sortby (_tmp11_, FILES_SORT_BY_MODIFIED);
#line 1872 "RenamerDialog.c"
			} else {
				FilesRenamer* _tmp12_;
#line 310 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				_tmp12_ = self->priv->renamer;
#line 310 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
				files_renamer_set_sortby (_tmp12_, FILES_SORT_BY_NAME);
#line 1879 "RenamerDialog.c"
			}
		}
	}
}

static void
__files_renamer_dialog___lambda62__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                              gpointer self)
{
#line 302 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_files_renamer_dialog___lambda62_ (self);
#line 1891 "RenamerDialog.c"
}

static GObject *
files_renamer_dialog_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FilesRenamerDialog * self;
	Block13Data* _data13_;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	FilesRenamer* _tmp3_;
	GtkWidget* cancel_button = NULL;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* rename_button = NULL;
	GtkWidget* _tmp6_;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
	GtkStyleContext* _tmp9_;
	FilesRenamer* _tmp10_;
	GtkWidget* _tmp11_;
	GVariant* prefix_var = NULL;
	GVariant* _tmp12_;
	GMenu* prefix_menumodel = NULL;
	GMenu* _tmp13_;
	GMenu* _tmp14_;
	GVariant* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	GMenu* _tmp18_;
	GVariant* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GMenu* _tmp22_;
	GVariant* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GVariant* suffix_var = NULL;
	GVariant* _tmp26_;
	GMenu* suffix_menumodel = NULL;
	GMenu* _tmp27_;
	GMenu* _tmp28_;
	GVariant* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	GMenu* _tmp32_;
	GVariant* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	GMenu* _tmp36_;
	GVariant* _tmp37_;
	gchar* _tmp38_;
	gchar* _tmp39_;
	GtkBox* prefix_button_box = NULL;
	GtkBox* _tmp40_;
	GtkBox* _tmp41_;
	GtkImage* _tmp42_;
	GtkImage* _tmp43_;
	GtkBox* _tmp44_;
	GtkLabel* _tmp45_;
	GtkLabel* _tmp46_;
	GtkMenuButton* prefix_button = NULL;
	GtkBox* _tmp47_;
	GtkWidget* _tmp48_;
	GMenu* _tmp49_;
	GMenuModel* _tmp50_;
	GtkMenuButton* _tmp51_ = NULL;
	GtkMenuButton* _tmp52_;
	GtkWidget* _tmp53_;
	GtkRevealer* _tmp54_ = NULL;
	GtkBox* _tmp55_;
	GtkBox* _tmp56_;
	GtkRevealer* _tmp57_;
	GtkBox* suffix_button_box = NULL;
	GtkBox* _tmp58_;
	GtkBox* _tmp59_;
	GtkImage* _tmp60_;
	GtkImage* _tmp61_;
	GtkBox* _tmp62_;
	GtkLabel* _tmp63_;
	GtkLabel* _tmp64_;
	GtkMenuButton* suffix_button = NULL;
	GtkBox* _tmp65_;
	GtkWidget* _tmp66_;
	GMenu* _tmp67_;
	GMenuModel* _tmp68_;
	GtkMenuButton* _tmp69_ = NULL;
	GtkMenuButton* _tmp70_;
	GtkWidget* _tmp71_;
	GtkRevealer* _tmp72_ = NULL;
	GtkBox* _tmp73_;
	GtkBox* _tmp74_;
	GtkRevealer* _tmp75_;
	GtkLabel* basename_label = NULL;
	GtkLabel* _tmp76_;
	gchar* _tmp77_;
	GtkRadioButton* _tmp78_ = NULL;
	GtkRadioButton* _tmp79_;
	GtkRadioButton* _tmp80_;
	gchar* _tmp81_;
	GtkRadioButton* _tmp82_ = NULL;
	GtkRadioButton* _tmp83_;
	GtkRadioButton* _tmp84_;
	gchar* _tmp85_;
	GtkRadioButton* _tmp86_ = NULL;
	GtkRadioButton* _tmp87_;
	GtkBox* toggle_box = NULL;
	GtkBox* _tmp88_;
	GtkBox* _tmp89_;
	GtkStyleContext* _tmp90_;
	GtkBox* _tmp91_;
	GtkRadioButton* _tmp92_;
	GtkBox* _tmp93_;
	GtkRadioButton* _tmp94_;
	GtkBox* _tmp95_;
	GtkRadioButton* _tmp96_;
	GtkBox* basename_box = NULL;
	GtkBox* _tmp97_ = NULL;
	GtkBox* _tmp98_;
	GtkLabel* _tmp99_;
	GtkBox* _tmp100_;
	GtkBox* _tmp101_;
	gchar* _tmp102_;
	GtkEntry* _tmp103_ = NULL;
	gchar* _tmp104_;
	GtkEntry* _tmp105_ = NULL;
	GtkEntry* _tmp106_;
	GtkWidget* _tmp107_;
	GtkRevealer* _tmp108_ = NULL;
	GtkScrolledWindow* list_scrolled_window = NULL;
	FilesRenamer* _tmp109_;
	GtkListBox* _tmp110_;
	GtkListBox* _tmp111_;
	GtkWidget* _tmp112_;
	GtkScrolledWindow* _tmp113_ = NULL;
	GtkFrame* frame = NULL;
	GtkScrolledWindow* _tmp114_;
	GtkWidget* _tmp115_;
	GtkFrame* _tmp116_ = NULL;
	GtkLabel* sortby_label = NULL;
	GtkLabel* _tmp117_;
	GtkRadioButton* _tmp118_ = NULL;
	GtkRadioButton* _tmp119_;
	GtkRadioButton* _tmp120_ = NULL;
	GtkRadioButton* _tmp121_;
	GtkRadioButton* _tmp122_ = NULL;
	GtkRadioButton* _tmp123_;
	GtkRadioButton* _tmp124_ = NULL;
	GtkBox* sortby_box = NULL;
	GtkBox* _tmp125_ = NULL;
	GtkBox* _tmp126_;
	GtkLabel* _tmp127_;
	GtkBox* _tmp128_;
	GtkRadioButton* _tmp129_;
	GtkBox* _tmp130_;
	GtkRadioButton* _tmp131_;
	GtkBox* _tmp132_;
	GtkRadioButton* _tmp133_;
	GtkBox* _tmp134_;
	GtkRadioButton* _tmp135_;
	GtkBox* _tmp136_;
	GtkWidget* _tmp137_;
	GtkRevealer* _tmp138_ = NULL;
	GtkBox* list_box = NULL;
	GtkBox* _tmp139_;
	GtkBox* _tmp140_;
	GtkRevealer* _tmp141_;
	GtkBox* _tmp142_;
	GtkFrame* _tmp143_;
	GtkGrid* _tmp144_ = NULL;
	GtkGrid* _tmp145_;
	GtkBox* _tmp146_;
	GtkGrid* _tmp147_;
	GtkEntry* _tmp148_;
	GtkGrid* _tmp149_;
	GtkBox* _tmp150_;
	GtkGrid* _tmp151_;
	GtkRevealer* _tmp152_;
	GtkBox* content_box = NULL;
	GtkBox* _tmp153_;
	GtkBox* _tmp154_;
	GtkBox* _tmp155_;
	GtkBox* _tmp156_;
	GtkBox* _tmp157_;
	GtkGrid* _tmp158_;
	GtkBox* _tmp159_;
	GtkBox* _tmp160_;
	GtkBox* _tmp161_;
	GtkBox* _tmp162_;
	GtkBox* _tmp163_;
	GtkBox* _tmp164_;
	GtkRevealer* _tmp165_;
	GtkRadioButton* _tmp166_;
	GtkRadioButton* _tmp167_;
	GtkRadioButton* _tmp168_;
	GtkEntry* _tmp169_;
	GtkEntry* _tmp170_;
	GtkRadioButton* _tmp171_;
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	parent_class = G_OBJECT_CLASS (files_renamer_dialog_parent_class);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialog);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data13_ = g_slice_new0 (Block13Data);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data13_->_ref_count_ = 1;
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data13_->self = g_object_ref (self);
#line 62 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 62 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->actions);
#line 62 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->actions = _tmp0_;
#line 63 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp1_ = self->priv->actions;
#line 63 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp1_, FILES_RENAMER_DIALOG_ACTION_ENTRIES, (gint) G_N_ELEMENTS (FILES_RENAMER_DIALOG_ACTION_ENTRIES), self);
#line 64 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp2_ = self->priv->actions;
#line 64 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "renamer", (GActionGroup*) _tmp2_);
#line 66 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_window_set_title ((GtkWindow*) self, _ ("Bulk Rename"));
#line 67 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp3_ = files_renamer_new ();
#line 67 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->renamer);
#line 67 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->renamer = _tmp3_;
#line 70 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp4_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 70 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 70 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	cancel_button = _tmp5_;
#line 72 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp6_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Rename"), (gint) GTK_RESPONSE_APPLY);
#line 72 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp7_ = _g_object_ref0 (_tmp6_);
#line 72 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	rename_button = _tmp7_;
#line 73 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp8_ = rename_button;
#line 73 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp9_ = gtk_widget_get_style_context (_tmp8_);
#line 73 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_style_context_add_class (_tmp9_, GTK_STYLE_CLASS_SUGGESTED_ACTION);
#line 74 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp10_ = self->priv->renamer;
#line 74 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp11_ = rename_button;
#line 74 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp10_, "can-rename", (GObject*) _tmp11_, "sensitive", G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 79 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp12_ = g_variant_new_uint32 ((guint32) ((guint) FILES_RENAME_POSITION_PREFIX));
#line 79 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_variant_ref_sink (_tmp12_);
#line 79 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	prefix_var = _tmp12_;
#line 80 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp13_ = g_menu_new ();
#line 80 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	prefix_menumodel = _tmp13_;
#line 81 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp14_ = prefix_menumodel;
#line 81 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp15_ = prefix_var;
#line 81 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp16_ = g_action_print_detailed_name ("renamer.add-number", _tmp15_);
#line 81 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp17_ = _tmp16_;
#line 81 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_menu_append (_tmp14_, _ ("Number Sequence"), _tmp17_);
#line 81 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (_tmp17_);
#line 82 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp18_ = prefix_menumodel;
#line 82 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp19_ = prefix_var;
#line 82 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp20_ = g_action_print_detailed_name ("renamer.add-date", _tmp19_);
#line 82 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp21_ = _tmp20_;
#line 82 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_menu_append (_tmp18_, _ ("Creation Date"), _tmp21_);
#line 82 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (_tmp21_);
#line 83 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp22_ = prefix_menumodel;
#line 83 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp23_ = prefix_var;
#line 83 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp24_ = g_action_print_detailed_name ("renamer.add-text", _tmp23_);
#line 83 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp25_ = _tmp24_;
#line 83 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_menu_append (_tmp22_, _ ("Fixed Text"), _tmp25_);
#line 83 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (_tmp25_);
#line 85 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp26_ = g_variant_new_uint32 ((guint32) ((guint) FILES_RENAME_POSITION_SUFFIX));
#line 85 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_variant_ref_sink (_tmp26_);
#line 85 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	suffix_var = _tmp26_;
#line 86 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp27_ = g_menu_new ();
#line 86 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	suffix_menumodel = _tmp27_;
#line 87 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp28_ = suffix_menumodel;
#line 87 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp29_ = suffix_var;
#line 87 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp30_ = g_action_print_detailed_name ("renamer.add-number", _tmp29_);
#line 87 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp31_ = _tmp30_;
#line 87 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_menu_append (_tmp28_, _ ("Number Sequence"), _tmp31_);
#line 87 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (_tmp31_);
#line 88 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp32_ = suffix_menumodel;
#line 88 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp33_ = suffix_var;
#line 88 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp34_ = g_action_print_detailed_name ("renamer.add-date", _tmp33_);
#line 88 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp35_ = _tmp34_;
#line 88 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_menu_append (_tmp32_, _ ("Creation Date"), _tmp35_);
#line 88 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (_tmp35_);
#line 89 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp36_ = suffix_menumodel;
#line 89 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp37_ = suffix_var;
#line 89 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp38_ = g_action_print_detailed_name ("renamer.add-text", _tmp37_);
#line 89 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp39_ = _tmp38_;
#line 89 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_menu_append (_tmp36_, _ ("Fixed Text"), _tmp39_);
#line 89 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (_tmp39_);
#line 91 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp40_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 91 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp40_);
#line 91 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	prefix_button_box = _tmp40_;
#line 92 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp41_ = prefix_button_box;
#line 92 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp42_ = (GtkImage*) gtk_image_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 92 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp42_);
#line 92 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp43_ = _tmp42_;
#line 92 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp41_, (GtkWidget*) _tmp43_);
#line 92 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp43_);
#line 93 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp44_ = prefix_button_box;
#line 93 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp45_ = (GtkLabel*) gtk_label_new (_ ("Add Prefix…"));
#line 93 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp45_);
#line 93 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp46_ = _tmp45_;
#line 93 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp44_, (GtkWidget*) _tmp46_);
#line 93 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp46_);
#line 95 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp47_ = prefix_button_box;
#line 95 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp48_ = _g_object_ref0 ((GtkWidget*) _tmp47_);
#line 95 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp49_ = prefix_menumodel;
#line 95 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp50_ = _g_object_ref0 ((GMenuModel*) _tmp49_);
#line 95 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp51_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 95 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_set ((GtkContainer*) _tmp51_, "child", _tmp48_, NULL);
#line 95 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp48_);
#line 95 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_menu_button_set_menu_model (_tmp51_, _tmp50_);
#line 95 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp50_);
#line 95 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_menu_button_set_use_popover (_tmp51_, FALSE);
#line 95 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp51_);
#line 95 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	prefix_button = _tmp51_;
#line 101 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp52_ = prefix_button;
#line 101 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp53_ = _g_object_ref0 ((GtkWidget*) _tmp52_);
#line 101 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp54_ = (GtkRevealer*) gtk_revealer_new ();
#line 101 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_set ((GtkContainer*) _tmp54_, "child", _tmp53_, NULL);
#line 101 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp53_);
#line 101 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_revealer_set_reveal_child (_tmp54_, TRUE);
#line 101 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_revealer_set_transition_type (_tmp54_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT);
#line 101 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp54_);
#line 101 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->prefix_revealer);
#line 101 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->prefix_revealer = _tmp54_;
#line 107 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp55_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 107 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp55_);
#line 107 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->prefix_box);
#line 107 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->prefix_box = _tmp55_;
#line 108 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp56_ = self->priv->prefix_box;
#line 108 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp57_ = self->priv->prefix_revealer;
#line 108 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp56_, (GtkWidget*) _tmp57_);
#line 110 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp58_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 110 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp58_);
#line 110 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	suffix_button_box = _tmp58_;
#line 111 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp59_ = suffix_button_box;
#line 111 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp60_ = (GtkImage*) gtk_image_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
#line 111 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp60_);
#line 111 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp61_ = _tmp60_;
#line 111 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp59_, (GtkWidget*) _tmp61_);
#line 111 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp61_);
#line 112 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp62_ = suffix_button_box;
#line 112 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp63_ = (GtkLabel*) gtk_label_new (_ ("Add Suffix…"));
#line 112 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp63_);
#line 112 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp64_ = _tmp63_;
#line 112 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp62_, (GtkWidget*) _tmp64_);
#line 112 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp64_);
#line 114 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp65_ = suffix_button_box;
#line 114 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp66_ = _g_object_ref0 ((GtkWidget*) _tmp65_);
#line 114 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp67_ = suffix_menumodel;
#line 114 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp68_ = _g_object_ref0 ((GMenuModel*) _tmp67_);
#line 114 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp69_ = (GtkMenuButton*) gtk_menu_button_new ();
#line 114 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_set ((GtkContainer*) _tmp69_, "child", _tmp66_, NULL);
#line 114 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp66_);
#line 114 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_menu_button_set_menu_model (_tmp69_, _tmp68_);
#line 114 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp68_);
#line 114 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_menu_button_set_use_popover (_tmp69_, FALSE);
#line 114 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp69_);
#line 114 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	suffix_button = _tmp69_;
#line 120 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp70_ = suffix_button;
#line 120 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp71_ = _g_object_ref0 ((GtkWidget*) _tmp70_);
#line 120 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp72_ = (GtkRevealer*) gtk_revealer_new ();
#line 120 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_set ((GtkContainer*) _tmp72_, "child", _tmp71_, NULL);
#line 120 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp71_);
#line 120 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_revealer_set_reveal_child (_tmp72_, TRUE);
#line 120 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_revealer_set_transition_type (_tmp72_, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT);
#line 120 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp72_);
#line 120 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->suffix_revealer);
#line 120 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->suffix_revealer = _tmp72_;
#line 126 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp73_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 126 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp73_);
#line 126 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->suffix_box);
#line 126 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->suffix_box = _tmp73_;
#line 127 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp74_ = self->priv->suffix_box;
#line 127 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp75_ = self->priv->suffix_revealer;
#line 127 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp74_, (GtkWidget*) _tmp75_);
#line 129 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp76_ = (GtkLabel*) gtk_label_new (_ ("Basename:"));
#line 129 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp76_);
#line 129 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	basename_label = _tmp76_;
#line 131 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp77_ = g_strdup (NC_ ("bulk-rename", "Keep"));
#line 131 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp78_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 131 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_button_set_label ((GtkButton*) _tmp78_, _tmp77_);
#line 131 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (_tmp77_);
#line 131 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp78_, TRUE);
#line 131 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp78_);
#line 131 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->original_basename_toggle);
#line 131 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->original_basename_toggle = _tmp78_;
#line 135 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp79_ = self->priv->original_basename_toggle;
#line 135 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_toggle_button_set_mode ((GtkToggleButton*) _tmp79_, FALSE);
#line 137 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp80_ = self->priv->original_basename_toggle;
#line 137 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp81_ = g_strdup (NC_ ("bulk-rename", "Replace"));
#line 137 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp82_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp80_);
#line 137 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_button_set_label ((GtkButton*) _tmp82_, _tmp81_);
#line 137 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (_tmp81_);
#line 137 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp82_);
#line 137 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->new_basename_toggle);
#line 137 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->new_basename_toggle = _tmp82_;
#line 140 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp83_ = self->priv->new_basename_toggle;
#line 140 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_toggle_button_set_mode ((GtkToggleButton*) _tmp83_, FALSE);
#line 142 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp84_ = self->priv->original_basename_toggle;
#line 142 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp85_ = g_strdup (NC_ ("bulk-rename", "Modify"));
#line 142 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp86_ = (GtkRadioButton*) gtk_radio_button_new_from_widget (_tmp84_);
#line 142 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_button_set_label ((GtkButton*) _tmp86_, _tmp85_);
#line 142 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (_tmp85_);
#line 142 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp86_);
#line 142 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->modify_basename_toggle);
#line 142 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->modify_basename_toggle = _tmp86_;
#line 145 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp87_ = self->priv->modify_basename_toggle;
#line 145 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_toggle_button_set_mode ((GtkToggleButton*) _tmp87_, FALSE);
#line 147 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp88_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 147 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp88_);
#line 147 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	toggle_box = _tmp88_;
#line 148 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp89_ = toggle_box;
#line 148 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp90_ = gtk_widget_get_style_context ((GtkWidget*) _tmp89_);
#line 148 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_style_context_add_class (_tmp90_, GTK_STYLE_CLASS_LINKED);
#line 149 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp91_ = toggle_box;
#line 149 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp92_ = self->priv->original_basename_toggle;
#line 149 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp91_, (GtkWidget*) _tmp92_);
#line 150 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp93_ = toggle_box;
#line 150 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp94_ = self->priv->new_basename_toggle;
#line 150 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp93_, (GtkWidget*) _tmp94_);
#line 151 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp95_ = toggle_box;
#line 151 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp96_ = self->priv->modify_basename_toggle;
#line 151 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp95_, (GtkWidget*) _tmp96_);
#line 153 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp97_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 153 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp97_, GTK_ALIGN_CENTER);
#line 153 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp97_, 24);
#line 153 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp97_);
#line 153 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	basename_box = _tmp97_;
#line 157 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp98_ = basename_box;
#line 157 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp99_ = basename_label;
#line 157 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_box_pack_start (_tmp98_, (GtkWidget*) _tmp99_, TRUE, TRUE, (guint) 0);
#line 158 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp100_ = basename_box;
#line 158 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp101_ = toggle_box;
#line 158 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_box_pack_end (_tmp100_, (GtkWidget*) _tmp101_, TRUE, TRUE, (guint) 0);
#line 160 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp102_ = g_strdup (_ ("Original Basename"));
#line 160 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp103_ = (GtkEntry*) gtk_entry_new ();
#line 160 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp103_, TRUE);
#line 160 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp103_, FALSE);
#line 160 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_entry_set_text (_tmp103_, _tmp102_);
#line 160 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (_tmp102_);
#line 160 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp103_);
#line 160 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->basename_entry);
#line 160 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->basename_entry = _tmp103_;
#line 166 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp104_ = g_strdup (_ ("Replacement text"));
#line 166 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp105_ = (GtkEntry*) gtk_entry_new ();
#line 166 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp105_, 6);
#line 166 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_entry_set_placeholder_text (_tmp105_, _tmp104_);
#line 166 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_free0 (_tmp104_);
#line 166 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp105_);
#line 166 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->replacement_entry);
#line 166 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->replacement_entry = _tmp105_;
#line 171 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp106_ = self->priv->replacement_entry;
#line 171 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp107_ = _g_object_ref0 ((GtkWidget*) _tmp106_);
#line 171 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp108_ = (GtkRevealer*) gtk_revealer_new ();
#line 171 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_set ((GtkContainer*) _tmp108_, "child", _tmp107_, NULL);
#line 171 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp107_);
#line 171 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp108_);
#line 171 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data13_->replacement_entry_revealer = _tmp108_;
#line 176 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp109_ = self->priv->renamer;
#line 176 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp110_ = files_renamer_get_listbox (_tmp109_);
#line 176 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp111_ = _tmp110_;
#line 176 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp112_ = _g_object_ref0 ((GtkWidget*) _tmp111_);
#line 176 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp113_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 176 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_set ((GtkContainer*) _tmp113_, "child", _tmp112_, NULL);
#line 176 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp112_);
#line 176 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_set (_tmp113_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 176 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_scrolled_window_set_min_content_height (_tmp113_, 200);
#line 176 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp113_);
#line 176 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	list_scrolled_window = _tmp113_;
#line 182 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp114_ = list_scrolled_window;
#line 182 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp115_ = _g_object_ref0 ((GtkWidget*) _tmp114_);
#line 182 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp116_ = (GtkFrame*) gtk_frame_new (NULL);
#line 182 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_set ((GtkContainer*) _tmp116_, "child", _tmp115_, NULL);
#line 182 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp115_);
#line 182 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp116_);
#line 182 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	frame = _tmp116_;
#line 186 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp117_ = (GtkLabel*) gtk_label_new (_ ("Number in order of:"));
#line 186 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp117_);
#line 186 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	sortby_label = _tmp117_;
#line 190 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp118_ = (GtkRadioButton*) gtk_radio_button_new_with_label (NULL, NC_ ("bulk-rename", "Name"));
#line 190 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp118_, 6);
#line 190 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp118_);
#line 190 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data13_->name_check = _tmp118_;
#line 192 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp119_ = _data13_->name_check;
#line 192 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp120_ = (GtkRadioButton*) gtk_radio_button_new_with_label_from_widget (_tmp119_, NC_ ("bulk-rename", "Date created"));
#line 192 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp120_, 6);
#line 192 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp120_);
#line 192 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data13_->created_check = _tmp120_;
#line 194 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp121_ = _data13_->name_check;
#line 194 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp122_ = (GtkRadioButton*) gtk_radio_button_new_with_label_from_widget (_tmp121_, NC_ ("bulk-rename", "Date modified"));
#line 194 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp122_, 6);
#line 194 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp122_);
#line 194 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data13_->modified_check = _tmp122_;
#line 196 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp123_ = _data13_->name_check;
#line 196 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp124_ = (GtkRadioButton*) gtk_radio_button_new_with_label_from_widget (_tmp123_, NC_ ("bulk-rename", "Size"));
#line 196 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp124_, 6);
#line 196 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp124_);
#line 196 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data13_->size_check = _tmp124_;
#line 198 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp125_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 3);
#line 198 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp125_, 12);
#line 198 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp125_);
#line 198 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	sortby_box = _tmp125_;
#line 201 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp126_ = sortby_box;
#line 201 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp127_ = sortby_label;
#line 201 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_box_pack_start (_tmp126_, (GtkWidget*) _tmp127_, TRUE, TRUE, (guint) 0);
#line 202 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp128_ = sortby_box;
#line 202 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp129_ = _data13_->name_check;
#line 202 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_box_pack_start (_tmp128_, (GtkWidget*) _tmp129_, TRUE, TRUE, (guint) 0);
#line 203 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp130_ = sortby_box;
#line 203 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp131_ = _data13_->created_check;
#line 203 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_box_pack_start (_tmp130_, (GtkWidget*) _tmp131_, TRUE, TRUE, (guint) 0);
#line 204 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp132_ = sortby_box;
#line 204 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp133_ = _data13_->modified_check;
#line 204 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_box_pack_start (_tmp132_, (GtkWidget*) _tmp133_, TRUE, TRUE, (guint) 0);
#line 205 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp134_ = sortby_box;
#line 205 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp135_ = _data13_->size_check;
#line 205 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_box_pack_start (_tmp134_, (GtkWidget*) _tmp135_, TRUE, TRUE, (guint) 0);
#line 207 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp136_ = sortby_box;
#line 207 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp137_ = _g_object_ref0 ((GtkWidget*) _tmp136_);
#line 207 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp138_ = (GtkRevealer*) gtk_revealer_new ();
#line 207 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_set ((GtkContainer*) _tmp138_, "child", _tmp137_, NULL);
#line 207 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (_tmp137_);
#line 207 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_revealer_set_reveal_child (_tmp138_, FALSE);
#line 207 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp138_, GTK_ALIGN_START);
#line 207 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp138_);
#line 207 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->sortby_revealer);
#line 207 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->sortby_revealer = _tmp138_;
#line 213 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp139_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 213 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp139_);
#line 213 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	list_box = _tmp139_;
#line 214 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp140_ = list_box;
#line 214 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp141_ = self->priv->sortby_revealer;
#line 214 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp140_, (GtkWidget*) _tmp141_);
#line 215 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp142_ = list_box;
#line 215 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp143_ = frame;
#line 215 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp142_, (GtkWidget*) _tmp143_);
#line 218 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp144_ = (GtkGrid*) gtk_grid_new ();
#line 218 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_grid_set_column_spacing (_tmp144_, 6);
#line 218 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp144_, 24);
#line 218 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_ref_sink (_tmp144_);
#line 218 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->controls_grid);
#line 218 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->controls_grid = _tmp144_;
#line 223 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp145_ = self->priv->controls_grid;
#line 223 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp146_ = self->priv->prefix_box;
#line 223 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_grid_attach (_tmp145_, (GtkWidget*) _tmp146_, 0, 0, 1, 1);
#line 224 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp147_ = self->priv->controls_grid;
#line 224 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp148_ = self->priv->basename_entry;
#line 224 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_grid_attach (_tmp147_, (GtkWidget*) _tmp148_, 1, 0, 1, 1);
#line 225 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp149_ = self->priv->controls_grid;
#line 225 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp150_ = self->priv->suffix_box;
#line 225 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_grid_attach (_tmp149_, (GtkWidget*) _tmp150_, 2, 0, 1, 1);
#line 226 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp151_ = self->priv->controls_grid;
#line 226 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp152_ = _data13_->replacement_entry_revealer;
#line 226 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_grid_attach (_tmp151_, (GtkWidget*) _tmp152_, 1, 1, 1, 1);
#line 228 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp153_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 228 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp154_ = _g_object_ref0 (_tmp153_);
#line 228 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	content_box = _tmp154_;
#line 229 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp155_ = content_box;
#line 229 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp156_ = basename_box;
#line 229 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp155_, (GtkWidget*) _tmp156_);
#line 230 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp157_ = content_box;
#line 230 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp158_ = self->priv->controls_grid;
#line 230 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp157_, (GtkWidget*) _tmp158_);
#line 231 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp159_ = content_box;
#line 231 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp160_ = list_box;
#line 231 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp159_, (GtkWidget*) _tmp160_);
#line 232 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp161_ = content_box;
#line 232 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp161_, 10);
#line 233 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp162_ = content_box;
#line 233 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp162_, 10);
#line 234 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp163_ = content_box;
#line 234 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp163_, 10);
#line 235 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp164_ = content_box;
#line 235 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp164_);
#line 237 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp165_ = _data13_->replacement_entry_revealer;
#line 237 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	gtk_revealer_set_reveal_child (_tmp165_, FALSE);
#line 240 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp166_ = self->priv->original_basename_toggle;
#line 240 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp166_, "toggled", (GCallback) __files_renamer_dialog___lambda55__gtk_toggle_button_toggled, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 248 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp167_ = self->priv->new_basename_toggle;
#line 248 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp167_, "toggled", (GCallback) __files_renamer_dialog___lambda56__gtk_toggle_button_toggled, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 257 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp168_ = self->priv->modify_basename_toggle;
#line 257 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp168_, "toggled", (GCallback) __files_renamer_dialog___lambda57__gtk_toggle_button_toggled, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 267 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp169_ = self->priv->basename_entry;
#line 267 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_object ((GtkEditable*) _tmp169_, "changed", (GCallback) __files_renamer_dialog___lambda58__gtk_editable_changed, self, 0);
#line 271 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp170_ = self->priv->replacement_entry;
#line 271 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_object ((GtkEditable*) _tmp170_, "changed", (GCallback) __files_renamer_dialog___lambda59__gtk_editable_changed, self, 0);
#line 275 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_object ((GtkDialog*) self, "response", (GCallback) __files_renamer_dialog___lambda60__gtk_dialog_response, self, 0);
#line 295 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_data ((GObject*) self, "notify::n-number-seq", (GCallback) __files_renamer_dialog___lambda61__g_object_notify, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 302 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_tmp171_ = _data13_->name_check;
#line 302 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_signal_connect_data ((GtkToggleButton*) _tmp171_, "toggled", (GCallback) __files_renamer_dialog___lambda62__gtk_toggle_button_toggled, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 314 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_schedule_view_update (self);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (content_box);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (list_box);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (sortby_box);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (sortby_label);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (frame);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (list_scrolled_window);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (basename_box);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (toggle_box);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (basename_label);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (suffix_button);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (suffix_button_box);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (prefix_button);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (prefix_button_box);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (suffix_menumodel);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_variant_unref0 (suffix_var);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (prefix_menumodel);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_variant_unref0 (prefix_var);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (rename_button);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (cancel_button);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	block13_data_unref (_data13_);
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_data13_ = NULL;
#line 61 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	return obj;
#line 2896 "RenamerDialog.c"
}

static void
files_renamer_dialog_class_init (FilesRenamerDialogClass * klass,
                                 gpointer klass_data)
{
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	files_renamer_dialog_parent_class = g_type_class_peek_parent (klass);
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_type_class_adjust_private_offset (klass, &FilesRenamerDialog_private_offset);
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_files_renamer_dialog_get_property;
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_files_renamer_dialog_set_property;
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	G_OBJECT_CLASS (klass)->constructor = files_renamer_dialog_constructor;
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = files_renamer_dialog_finalize;
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_RENAMER_DIALOG_N_NUMBER_SEQ_PROPERTY, files_renamer_dialog_properties[FILES_RENAMER_DIALOG_N_NUMBER_SEQ_PROPERTY] = g_param_spec_int ("n-number-seq", "n-number-seq", "n-number-seq", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_RENAMER_DIALOG_N_PREFIX_PROPERTY, files_renamer_dialog_properties[FILES_RENAMER_DIALOG_N_PREFIX_PROPERTY] = g_param_spec_int ("n-prefix", "n-prefix", "n-prefix", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_RENAMER_DIALOG_N_SUFFIX_PROPERTY, files_renamer_dialog_properties[FILES_RENAMER_DIALOG_N_SUFFIX_PROPERTY] = g_param_spec_int ("n-suffix", "n-suffix", "n-suffix", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 2921 "RenamerDialog.c"
}

static void
files_renamer_dialog_instance_init (FilesRenamerDialog * self,
                                    gpointer klass)
{
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv = files_renamer_dialog_get_instance_private (self);
#line 52 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->_n_number_seq = 0;
#line 53 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->_n_prefix = 0;
#line 54 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self->priv->_n_suffix = 0;
#line 2936 "RenamerDialog.c"
}

static void
files_renamer_dialog_finalize (GObject * obj)
{
	FilesRenamerDialog * self;
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialog);
#line 38 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->renamer);
#line 39 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->controls_grid);
#line 40 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->prefix_box);
#line 41 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->suffix_box);
#line 42 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->prefix_revealer);
#line 43 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->suffix_revealer);
#line 44 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->basename_entry);
#line 45 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->replacement_entry);
#line 46 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->modify_basename_toggle);
#line 47 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->new_basename_toggle);
#line 48 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->original_basename_toggle);
#line 49 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->sortby_revealer);
#line 50 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	_g_object_unref0 (self->priv->actions);
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	G_OBJECT_CLASS (files_renamer_dialog_parent_class)->finalize (obj);
#line 2973 "RenamerDialog.c"
}

 G_GNUC_NO_INLINE static GType
files_renamer_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesRenamerDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) files_renamer_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesRenamerDialog), 0, (GInstanceInitFunc) files_renamer_dialog_instance_init, NULL };
	GType files_renamer_dialog_type_id;
	files_renamer_dialog_type_id = g_type_register_static (GRANITE_TYPE_DIALOG, "FilesRenamerDialog", &g_define_type_info, 0);
	FilesRenamerDialog_private_offset = g_type_add_instance_private (files_renamer_dialog_type_id, sizeof (FilesRenamerDialogPrivate));
	return files_renamer_dialog_type_id;
}

GType
files_renamer_dialog_get_type (void)
{
	static volatile gsize files_renamer_dialog_type_id__once = 0;
	if (g_once_init_enter (&files_renamer_dialog_type_id__once)) {
		GType files_renamer_dialog_type_id;
		files_renamer_dialog_type_id = files_renamer_dialog_get_type_once ();
		g_once_init_leave (&files_renamer_dialog_type_id__once, files_renamer_dialog_type_id);
	}
	return files_renamer_dialog_type_id__once;
}

static void
_vala_files_renamer_dialog_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	FilesRenamerDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialog);
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	switch (property_id) {
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		case FILES_RENAMER_DIALOG_N_NUMBER_SEQ_PROPERTY:
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		g_value_set_int (value, files_renamer_dialog_get_n_number_seq (self));
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		break;
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		case FILES_RENAMER_DIALOG_N_PREFIX_PROPERTY:
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		g_value_set_int (value, files_renamer_dialog_get_n_prefix (self));
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		break;
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		case FILES_RENAMER_DIALOG_N_SUFFIX_PROPERTY:
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		g_value_set_int (value, files_renamer_dialog_get_n_suffix (self));
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		break;
#line 3026 "RenamerDialog.c"
		default:
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		break;
#line 3032 "RenamerDialog.c"
	}
}

static void
_vala_files_renamer_dialog_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	FilesRenamerDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialog);
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
	switch (property_id) {
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		case FILES_RENAMER_DIALOG_N_NUMBER_SEQ_PROPERTY:
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_dialog_set_n_number_seq (self, g_value_get_int (value));
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		break;
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		case FILES_RENAMER_DIALOG_N_PREFIX_PROPERTY:
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_dialog_set_n_prefix (self, g_value_get_int (value));
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		break;
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		case FILES_RENAMER_DIALOG_N_SUFFIX_PROPERTY:
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		files_renamer_dialog_set_n_suffix (self, g_value_get_int (value));
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		break;
#line 3064 "RenamerDialog.c"
		default:
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 9 "../src/Dialogs/BulkRenamer/RenamerDialog.vala"
		break;
#line 3070 "RenamerDialog.c"
	}
}

