/* ProgressUIHandler.c generated by valac 0.56.14, the Vala compiler
 * generated from ProgressUIHandler.vala, do not modify */

/***
    Copyright (c) 2007, 2011 Red Hat, Inc.
    Copyright (c) 2013 Julián Unrrein <junrrein@gmail.com>

    This program is free software: you can redistribute it and/or modify it
    under the terms of the GNU Lesser General Public License version 3, as published
    by the Free Software Foundation.

    This program is distributed in the hope that it will be useful, but
    WITHOUT ANY WARRANTY; without even the implied warranties of
    MERCHANTABILITY, SATISFACTORY QUALITY, or FITNESS FOR A PARTICULAR
    PURPOSE. See the GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program. If not, see <http://www.gnu.org/licenses/>.

    Authors: Alexander Larsson <alexl@redhat.com>
             Cosimo Cecchi <cosimoc@redhat.com>
             Julián Unrrein <junrrein@gmail.com>
             Jeremy Wootten <jeremy@elementaryos.org>
***/

#include <glib-object.h>
#include "pantheon-files-core.h"
#include <granite.h>
#include <gtk/gtk.h>
#include <glib.h>
#include <gee.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FILES_PROGRESS_TYPE_UI_HANDLER (files_progress_ui_handler_get_type ())
#define FILES_PROGRESS_UI_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_PROGRESS_TYPE_UI_HANDLER, FilesProgressUIHandler))
#define FILES_PROGRESS_UI_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_PROGRESS_TYPE_UI_HANDLER, FilesProgressUIHandlerClass))
#define FILES_PROGRESS_IS_UI_HANDLER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_PROGRESS_TYPE_UI_HANDLER))
#define FILES_PROGRESS_IS_UI_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_PROGRESS_TYPE_UI_HANDLER))
#define FILES_PROGRESS_UI_HANDLER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_PROGRESS_TYPE_UI_HANDLER, FilesProgressUIHandlerClass))

typedef struct _FilesProgressUIHandler FilesProgressUIHandler;
typedef struct _FilesProgressUIHandlerClass FilesProgressUIHandlerClass;
typedef struct _FilesProgressUIHandlerPrivate FilesProgressUIHandlerPrivate;
enum  {
	FILES_PROGRESS_UI_HANDLER_0_PROPERTY,
	FILES_PROGRESS_UI_HANDLER_NUM_PROPERTIES
};
static GParamSpec* files_progress_ui_handler_properties[FILES_PROGRESS_UI_HANDLER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block4Data Block4Data;

#define FILES_PROGRESS_TYPE_INFO_WIDGET (files_progress_info_widget_get_type ())
#define FILES_PROGRESS_INFO_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_PROGRESS_TYPE_INFO_WIDGET, FilesProgressInfoWidget))
#define FILES_PROGRESS_INFO_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_PROGRESS_TYPE_INFO_WIDGET, FilesProgressInfoWidgetClass))
#define FILES_PROGRESS_IS_INFO_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_PROGRESS_TYPE_INFO_WIDGET))
#define FILES_PROGRESS_IS_INFO_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_PROGRESS_TYPE_INFO_WIDGET))
#define FILES_PROGRESS_INFO_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_PROGRESS_TYPE_INFO_WIDGET, FilesProgressInfoWidgetClass))

typedef struct _FilesProgressInfoWidget FilesProgressInfoWidget;
typedef struct _FilesProgressInfoWidgetClass FilesProgressInfoWidgetClass;
typedef struct _Block5Data Block5Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block6Data Block6Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _FilesProgressUIHandler {
	GObject parent_instance;
	FilesProgressUIHandlerPrivate * priv;
};

struct _FilesProgressUIHandlerClass {
	GObjectClass parent_class;
};

struct _FilesProgressUIHandlerPrivate {
	PFProgressInfoManager* manager;
	GraniteDialog* progress_window;
	GtkBox* window_vbox;
	guint active_infos;
	GtkApplication* application;
	gboolean launcher_progress_visible;
	gboolean can_show_launcher_progress;
};

struct _Block4Data {
	int _ref_count_;
	FilesProgressUIHandler* self;
	gboolean operation_running;
	PFProgressInfo* info;
};

struct _Block5Data {
	int _ref_count_;
	FilesProgressUIHandler* self;
	FilesProgressInfoWidget* progress_widget;
};

struct _Block6Data {
	int _ref_count_;
	FilesProgressUIHandler* self;
	gchar* title;
};

static gint FilesProgressUIHandler_private_offset;
static gpointer files_progress_ui_handler_parent_class = NULL;

VALA_EXTERN GType files_progress_ui_handler_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesProgressUIHandler, g_object_unref)
static void files_progress_ui_handler_progress_info_started_cb (FilesProgressUIHandler* self,
                                                         PFProgressInfo* info);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static void _files_progress_ui_handler_progress_info_started_cb_pf_progress_info_started (PFProgressInfo* _sender,
                                                                                   gpointer self);
static void files_progress_ui_handler_progress_info_finished_cb (FilesProgressUIHandler* self,
                                                          PFProgressInfo* info);
static void _files_progress_ui_handler_progress_info_finished_cb_pf_progress_info_finished (PFProgressInfo* _sender,
                                                                                     gpointer self);
static gboolean __lambda6_ (Block4Data* _data4_);
static void files_progress_ui_handler_add_progress_info_to_window (FilesProgressUIHandler* self,
                                                            PFProgressInfo* info);
static gboolean ___lambda6__gsource_func (gpointer self);
static void files_progress_ui_handler_add_to_window (FilesProgressUIHandler* self,
                                              PFProgressInfo* info);
static void files_progress_ui_handler_update_launcher (FilesProgressUIHandler* self,
                                                PFProgressInfo* info,
                                                gboolean added);
VALA_EXTERN GType files_progress_info_widget_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesProgressInfoWidget, g_object_unref)
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void files_progress_ui_handler_ensure_window (FilesProgressUIHandler* self);
VALA_EXTERN FilesProgressInfoWidget* files_progress_info_widget_new (PFProgressInfo* info);
VALA_EXTERN FilesProgressInfoWidget* files_progress_info_widget_construct (GType object_type,
                                                               PFProgressInfo* info);
static void __lambda10_ (Block5Data* _data5_,
                  PFProgressInfo* info);
static void ___lambda10__files_progress_info_widget_cancelled (FilesProgressInfoWidget* _sender,
                                                        PFProgressInfo* info,
                                                        gpointer self);
static gboolean ___lambda7_ (FilesProgressUIHandler* self,
                      GtkWidget* widget,
                      GdkEventAny* event);
static gboolean ____lambda7__gtk_widget_delete_event (GtkWidget* _sender,
                                               GdkEventAny* event,
                                               gpointer self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean ____lambda4_ (Block6Data* _data6_);
static void files_progress_ui_handler_show_operation_complete_notification (FilesProgressUIHandler* self,
                                                                     const gchar* title,
                                                                     gboolean all_finished);
static gboolean _____lambda4__gsource_func (gpointer self);
static void files_progress_ui_handler_update_launcher_entry (FilesProgressUIHandler* self,
                                                      PFProgressInfo* info);
static void files_progress_ui_handler_launcher_progress_changed (FilesProgressUIHandler* self);
static void _files_progress_ui_handler_launcher_progress_changed_pf_progress_info_progress_changed (PFProgressInfo* _sender,
                                                                                             gpointer self);
static void ____lambda5_ (FilesProgressUIHandler* self,
                   GObject* obj,
                   GAsyncResult* res);
static void _____lambda5__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
VALA_EXTERN FilesProgressUIHandler* files_progress_ui_handler_new (void);
VALA_EXTERN FilesProgressUIHandler* files_progress_ui_handler_construct (GType object_type);
static GObject * files_progress_ui_handler_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void _files_progress_ui_handler___lambda11_ (FilesProgressUIHandler* self,
                                             PFProgressInfo* info);
static void __files_progress_ui_handler___lambda11__pf_progress_info_manager_new_progress_info (PFProgressInfoManager* _sender,
                                                                                         PFProgressInfo* info,
                                                                                         gpointer self);
static void files_progress_ui_handler_finalize (GObject * obj);
static GType files_progress_ui_handler_get_type_once (void);

static inline gpointer
files_progress_ui_handler_get_instance_private (FilesProgressUIHandler* self)
{
	return G_STRUCT_MEMBER_P (self, FilesProgressUIHandler_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 49 "../src/ProgressUIHandler.vala"
	return self ? g_object_ref (self) : NULL;
#line 206 "ProgressUIHandler.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 56 "../src/ProgressUIHandler.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 56 "../src/ProgressUIHandler.vala"
	return _data4_;
#line 216 "ProgressUIHandler.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 56 "../src/ProgressUIHandler.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 226 "ProgressUIHandler.c"
		FilesProgressUIHandler* self;
#line 56 "../src/ProgressUIHandler.vala"
		self = _data4_->self;
#line 56 "../src/ProgressUIHandler.vala"
		_g_object_unref0 (_data4_->info);
#line 56 "../src/ProgressUIHandler.vala"
		_g_object_unref0 (self);
#line 56 "../src/ProgressUIHandler.vala"
		g_slice_free (Block4Data, _data4_);
#line 236 "ProgressUIHandler.c"
	}
}

static void
_files_progress_ui_handler_progress_info_started_cb_pf_progress_info_started (PFProgressInfo* _sender,
                                                                              gpointer self)
{
#line 62 "../src/ProgressUIHandler.vala"
	files_progress_ui_handler_progress_info_started_cb ((FilesProgressUIHandler*) self, _sender);
#line 246 "ProgressUIHandler.c"
}

static void
_files_progress_ui_handler_progress_info_finished_cb_pf_progress_info_finished (PFProgressInfo* _sender,
                                                                                gpointer self)
{
#line 68 "../src/ProgressUIHandler.vala"
	files_progress_ui_handler_progress_info_finished_cb ((FilesProgressUIHandler*) self, _sender);
#line 255 "ProgressUIHandler.c"
}

static gboolean
__lambda6_ (Block4Data* _data4_)
{
	FilesProgressUIHandler* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp7_;
	gboolean _tmp8_;
	gboolean result;
#line 73 "../src/ProgressUIHandler.vala"
	self = _data4_->self;
#line 74 "../src/ProgressUIHandler.vala"
	if (_data4_->info == NULL) {
#line 74 "../src/ProgressUIHandler.vala"
		_tmp2_ = TRUE;
#line 274 "ProgressUIHandler.c"
	} else {
#line 74 "../src/ProgressUIHandler.vala"
		_tmp2_ = !G_TYPE_CHECK_INSTANCE_TYPE (_data4_->info, PF_PROGRESS_TYPE_INFO);
#line 278 "ProgressUIHandler.c"
	}
#line 74 "../src/ProgressUIHandler.vala"
	if (_tmp2_) {
#line 74 "../src/ProgressUIHandler.vala"
		_tmp1_ = TRUE;
#line 284 "ProgressUIHandler.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 75 "../src/ProgressUIHandler.vala"
		_tmp3_ = pf_progress_info_get_is_finished (_data4_->info);
#line 75 "../src/ProgressUIHandler.vala"
		_tmp4_ = _tmp3_;
#line 75 "../src/ProgressUIHandler.vala"
		_tmp1_ = _tmp4_;
#line 294 "ProgressUIHandler.c"
	}
#line 74 "../src/ProgressUIHandler.vala"
	if (_tmp1_) {
#line 74 "../src/ProgressUIHandler.vala"
		_tmp0_ = TRUE;
#line 300 "ProgressUIHandler.c"
	} else {
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 75 "../src/ProgressUIHandler.vala"
		_tmp5_ = pf_progress_info_get_is_cancelled (_data4_->info);
#line 75 "../src/ProgressUIHandler.vala"
		_tmp6_ = _tmp5_;
#line 75 "../src/ProgressUIHandler.vala"
		_tmp0_ = _tmp6_;
#line 310 "ProgressUIHandler.c"
	}
#line 74 "../src/ProgressUIHandler.vala"
	if (_tmp0_) {
#line 77 "../src/ProgressUIHandler.vala"
		result = G_SOURCE_REMOVE;
#line 77 "../src/ProgressUIHandler.vala"
		return result;
#line 318 "ProgressUIHandler.c"
	}
#line 80 "../src/ProgressUIHandler.vala"
	_tmp7_ = pf_progress_info_get_is_paused (_data4_->info);
#line 80 "../src/ProgressUIHandler.vala"
	_tmp8_ = _tmp7_;
#line 80 "../src/ProgressUIHandler.vala"
	if (_tmp8_) {
#line 81 "../src/ProgressUIHandler.vala"
		result = G_SOURCE_CONTINUE;
#line 81 "../src/ProgressUIHandler.vala"
		return result;
#line 330 "ProgressUIHandler.c"
	} else {
		gboolean _tmp9_ = FALSE;
#line 82 "../src/ProgressUIHandler.vala"
		if (_data4_->operation_running) {
#line 335 "ProgressUIHandler.c"
			gboolean _tmp10_;
			gboolean _tmp11_;
#line 82 "../src/ProgressUIHandler.vala"
			_tmp10_ = pf_progress_info_get_is_finished (_data4_->info);
#line 82 "../src/ProgressUIHandler.vala"
			_tmp11_ = _tmp10_;
#line 82 "../src/ProgressUIHandler.vala"
			_tmp9_ = !_tmp11_;
#line 344 "ProgressUIHandler.c"
		} else {
#line 82 "../src/ProgressUIHandler.vala"
			_tmp9_ = FALSE;
#line 348 "ProgressUIHandler.c"
		}
#line 82 "../src/ProgressUIHandler.vala"
		if (_tmp9_) {
#line 83 "../src/ProgressUIHandler.vala"
			files_progress_ui_handler_add_progress_info_to_window (self, _data4_->info);
#line 84 "../src/ProgressUIHandler.vala"
			result = G_SOURCE_REMOVE;
#line 84 "../src/ProgressUIHandler.vala"
			return result;
#line 358 "ProgressUIHandler.c"
		} else {
#line 86 "../src/ProgressUIHandler.vala"
			_data4_->operation_running = TRUE;
#line 87 "../src/ProgressUIHandler.vala"
			result = G_SOURCE_CONTINUE;
#line 87 "../src/ProgressUIHandler.vala"
			return result;
#line 366 "ProgressUIHandler.c"
		}
	}
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ (self);
#line 73 "../src/ProgressUIHandler.vala"
	return result;
#line 378 "ProgressUIHandler.c"
}

static void
files_progress_ui_handler_progress_info_started_cb (FilesProgressUIHandler* self,
                                                    PFProgressInfo* info)
{
	Block4Data* _data4_;
	PFProgressInfo* _tmp0_;
	guint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	guint _tmp7_;
#line 56 "../src/ProgressUIHandler.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/ProgressUIHandler.vala"
	g_return_if_fail (info != NULL);
#line 56 "../src/ProgressUIHandler.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 56 "../src/ProgressUIHandler.vala"
	_data4_->_ref_count_ = 1;
#line 56 "../src/ProgressUIHandler.vala"
	_data4_->self = g_object_ref (self);
#line 56 "../src/ProgressUIHandler.vala"
	_tmp0_ = _g_object_ref0 (info);
#line 56 "../src/ProgressUIHandler.vala"
	_g_object_unref0 (_data4_->info);
#line 56 "../src/ProgressUIHandler.vala"
	_data4_->info = _tmp0_;
#line 57 "../src/ProgressUIHandler.vala"
	if (_data4_->info == NULL) {
#line 58 "../src/ProgressUIHandler.vala"
		g_critical ("ProgressUIHandler.vala:58: Null progressinfo started");
#line 59 "../src/ProgressUIHandler.vala"
		block4_data_unref (_data4_);
#line 59 "../src/ProgressUIHandler.vala"
		_data4_ = NULL;
#line 59 "../src/ProgressUIHandler.vala"
		return;
#line 418 "ProgressUIHandler.c"
	}
#line 62 "../src/ProgressUIHandler.vala"
	g_signal_parse_name ("started", PF_PROGRESS_TYPE_INFO, &_tmp1_, NULL, FALSE);
#line 62 "../src/ProgressUIHandler.vala"
	g_signal_handlers_disconnect_matched (_data4_->info, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _files_progress_ui_handler_progress_info_started_cb_pf_progress_info_started, self);
#line 63 "../src/ProgressUIHandler.vala"
	_tmp3_ = pf_progress_info_get_is_finished (_data4_->info);
#line 63 "../src/ProgressUIHandler.vala"
	_tmp4_ = _tmp3_;
#line 63 "../src/ProgressUIHandler.vala"
	if (_tmp4_) {
#line 63 "../src/ProgressUIHandler.vala"
		_tmp2_ = TRUE;
#line 432 "ProgressUIHandler.c"
	} else {
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 63 "../src/ProgressUIHandler.vala"
		_tmp5_ = pf_progress_info_get_is_cancelled (_data4_->info);
#line 63 "../src/ProgressUIHandler.vala"
		_tmp6_ = _tmp5_;
#line 63 "../src/ProgressUIHandler.vala"
		_tmp2_ = _tmp6_;
#line 442 "ProgressUIHandler.c"
	}
#line 63 "../src/ProgressUIHandler.vala"
	if (_tmp2_) {
#line 64 "../src/ProgressUIHandler.vala"
		block4_data_unref (_data4_);
#line 64 "../src/ProgressUIHandler.vala"
		_data4_ = NULL;
#line 64 "../src/ProgressUIHandler.vala"
		return;
#line 452 "ProgressUIHandler.c"
	}
#line 68 "../src/ProgressUIHandler.vala"
	g_signal_connect_object (_data4_->info, "finished", (GCallback) _files_progress_ui_handler_progress_info_finished_cb_pf_progress_info_finished, self, 0);
#line 69 "../src/ProgressUIHandler.vala"
	_tmp7_ = self->priv->active_infos;
#line 69 "../src/ProgressUIHandler.vala"
	self->priv->active_infos = _tmp7_ + 1;
#line 72 "../src/ProgressUIHandler.vala"
	_data4_->operation_running = FALSE;
#line 73 "../src/ProgressUIHandler.vala"
	g_timeout_add_full (G_PRIORITY_LOW, (guint) 500, ___lambda6__gsource_func, block4_data_ref (_data4_), block4_data_unref);
#line 56 "../src/ProgressUIHandler.vala"
	block4_data_unref (_data4_);
#line 56 "../src/ProgressUIHandler.vala"
	_data4_ = NULL;
#line 468 "ProgressUIHandler.c"
}

static void
files_progress_ui_handler_add_progress_info_to_window (FilesProgressUIHandler* self,
                                                       PFProgressInfo* info)
{
#line 92 "../src/ProgressUIHandler.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/ProgressUIHandler.vala"
	g_return_if_fail (info != NULL);
#line 93 "../src/ProgressUIHandler.vala"
	if (self->priv->active_infos == ((guint) 1)) {
#line 481 "ProgressUIHandler.c"
		GraniteDialog* _tmp0_;
#line 95 "../src/ProgressUIHandler.vala"
		files_progress_ui_handler_add_to_window (self, info);
#line 96 "../src/ProgressUIHandler.vala"
		_tmp0_ = self->priv->progress_window;
#line 96 "../src/ProgressUIHandler.vala"
		gtk_window_present ((GtkWindow*) _tmp0_);
#line 489 "ProgressUIHandler.c"
	} else {
		GraniteDialog* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 97 "../src/ProgressUIHandler.vala"
		_tmp1_ = self->priv->progress_window;
#line 97 "../src/ProgressUIHandler.vala"
		_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 97 "../src/ProgressUIHandler.vala"
		_tmp3_ = _tmp2_;
#line 97 "../src/ProgressUIHandler.vala"
		if (_tmp3_) {
#line 98 "../src/ProgressUIHandler.vala"
			files_progress_ui_handler_add_to_window (self, info);
#line 504 "ProgressUIHandler.c"
		}
	}
#line 101 "../src/ProgressUIHandler.vala"
	files_progress_ui_handler_update_launcher (self, info, TRUE);
#line 509 "ProgressUIHandler.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 104 "../src/ProgressUIHandler.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 104 "../src/ProgressUIHandler.vala"
	return _data5_;
#line 519 "ProgressUIHandler.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 104 "../src/ProgressUIHandler.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 529 "ProgressUIHandler.c"
		FilesProgressUIHandler* self;
#line 104 "../src/ProgressUIHandler.vala"
		self = _data5_->self;
#line 104 "../src/ProgressUIHandler.vala"
		_g_object_unref0 (_data5_->progress_widget);
#line 104 "../src/ProgressUIHandler.vala"
		_g_object_unref0 (self);
#line 104 "../src/ProgressUIHandler.vala"
		g_slice_free (Block5Data, _data5_);
#line 539 "ProgressUIHandler.c"
	}
}

static void
__lambda10_ (Block5Data* _data5_,
             PFProgressInfo* info)
{
	FilesProgressUIHandler* self;
	FilesProgressInfoWidget* _tmp0_;
#line 110 "../src/ProgressUIHandler.vala"
	self = _data5_->self;
#line 110 "../src/ProgressUIHandler.vala"
	g_return_if_fail (info != NULL);
#line 111 "../src/ProgressUIHandler.vala"
	files_progress_ui_handler_progress_info_finished_cb (self, info);
#line 112 "../src/ProgressUIHandler.vala"
	_tmp0_ = _data5_->progress_widget;
#line 112 "../src/ProgressUIHandler.vala"
	gtk_widget_hide ((GtkWidget*) _tmp0_);
#line 559 "ProgressUIHandler.c"
}

static void
___lambda10__files_progress_info_widget_cancelled (FilesProgressInfoWidget* _sender,
                                                   PFProgressInfo* info,
                                                   gpointer self)
{
#line 110 "../src/ProgressUIHandler.vala"
	__lambda10_ (self, info);
#line 569 "ProgressUIHandler.c"
}

static void
files_progress_ui_handler_add_to_window (FilesProgressUIHandler* self,
                                         PFProgressInfo* info)
{
	Block5Data* _data5_;
	FilesProgressInfoWidget* _tmp0_;
	GtkBox* _tmp1_;
	FilesProgressInfoWidget* _tmp2_;
	FilesProgressInfoWidget* _tmp3_;
	FilesProgressInfoWidget* _tmp4_;
	GraniteDialog* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
#line 104 "../src/ProgressUIHandler.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/ProgressUIHandler.vala"
	g_return_if_fail (info != NULL);
#line 104 "../src/ProgressUIHandler.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 104 "../src/ProgressUIHandler.vala"
	_data5_->_ref_count_ = 1;
#line 104 "../src/ProgressUIHandler.vala"
	_data5_->self = g_object_ref (self);
#line 105 "../src/ProgressUIHandler.vala"
	files_progress_ui_handler_ensure_window (self);
#line 107 "../src/ProgressUIHandler.vala"
	_tmp0_ = files_progress_info_widget_new (info);
#line 107 "../src/ProgressUIHandler.vala"
	g_object_ref_sink (_tmp0_);
#line 107 "../src/ProgressUIHandler.vala"
	_data5_->progress_widget = _tmp0_;
#line 108 "../src/ProgressUIHandler.vala"
	_tmp1_ = self->priv->window_vbox;
#line 108 "../src/ProgressUIHandler.vala"
	_tmp2_ = _data5_->progress_widget;
#line 108 "../src/ProgressUIHandler.vala"
	gtk_container_add ((GtkContainer*) _tmp1_, (GtkWidget*) _tmp2_);
#line 110 "../src/ProgressUIHandler.vala"
	_tmp3_ = _data5_->progress_widget;
#line 110 "../src/ProgressUIHandler.vala"
	g_signal_connect_data (_tmp3_, "cancelled", (GCallback) ___lambda10__files_progress_info_widget_cancelled, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 115 "../src/ProgressUIHandler.vala"
	_tmp4_ = _data5_->progress_widget;
#line 115 "../src/ProgressUIHandler.vala"
	gtk_widget_show ((GtkWidget*) _tmp4_);
#line 116 "../src/ProgressUIHandler.vala"
	_tmp5_ = self->priv->progress_window;
#line 116 "../src/ProgressUIHandler.vala"
	_tmp6_ = gtk_widget_get_visible ((GtkWidget*) _tmp5_);
#line 116 "../src/ProgressUIHandler.vala"
	_tmp7_ = _tmp6_;
#line 116 "../src/ProgressUIHandler.vala"
	if (_tmp7_) {
#line 625 "ProgressUIHandler.c"
		GraniteDialog* _tmp8_;
#line 117 "../src/ProgressUIHandler.vala"
		_tmp8_ = self->priv->progress_window;
#line 117 "../src/ProgressUIHandler.vala"
		gtk_window_present ((GtkWindow*) _tmp8_);
#line 631 "ProgressUIHandler.c"
	}
#line 104 "../src/ProgressUIHandler.vala"
	block5_data_unref (_data5_);
#line 104 "../src/ProgressUIHandler.vala"
	_data5_ = NULL;
#line 637 "ProgressUIHandler.c"
}

static gboolean
___lambda7_ (FilesProgressUIHandler* self,
             GtkWidget* widget,
             GdkEventAny* event)
{
	gboolean result;
#line 138 "../src/ProgressUIHandler.vala"
	g_return_val_if_fail (widget != NULL, FALSE);
#line 138 "../src/ProgressUIHandler.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 139 "../src/ProgressUIHandler.vala"
	gtk_widget_hide (widget);
#line 140 "../src/ProgressUIHandler.vala"
	result = TRUE;
#line 140 "../src/ProgressUIHandler.vala"
	return result;
#line 656 "ProgressUIHandler.c"
}

static gboolean
____lambda7__gtk_widget_delete_event (GtkWidget* _sender,
                                      GdkEventAny* event,
                                      gpointer self)
{
	gboolean result;
	result = ___lambda7_ ((FilesProgressUIHandler*) self, _sender, event);
#line 138 "../src/ProgressUIHandler.vala"
	return result;
#line 668 "ProgressUIHandler.c"
}

static void
files_progress_ui_handler_ensure_window (FilesProgressUIHandler* self)
{
	GraniteDialog* _tmp0_;
#line 121 "../src/ProgressUIHandler.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/ProgressUIHandler.vala"
	_tmp0_ = self->priv->progress_window;
#line 122 "../src/ProgressUIHandler.vala"
	if (_tmp0_ == NULL) {
#line 681 "ProgressUIHandler.c"
		GtkBox* _tmp1_ = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		GtkApplication* _tmp4_;
		GtkWindow* _tmp5_;
		GtkWindow* _tmp6_;
		GraniteDialog* _tmp7_ = NULL;
		GraniteDialog* _tmp8_;
		GtkBox* _tmp9_;
		GtkBox* _tmp10_;
		GtkBox* _tmp11_;
		GraniteDialog* _tmp12_;
#line 123 "../src/ProgressUIHandler.vala"
		_tmp1_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
#line 123 "../src/ProgressUIHandler.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp1_, 10);
#line 123 "../src/ProgressUIHandler.vala"
		gtk_widget_set_margin_start ((GtkWidget*) _tmp1_, 10);
#line 123 "../src/ProgressUIHandler.vala"
		g_object_ref_sink (_tmp1_);
#line 123 "../src/ProgressUIHandler.vala"
		_g_object_unref0 (self->priv->window_vbox);
#line 123 "../src/ProgressUIHandler.vala"
		self->priv->window_vbox = _tmp1_;
#line 129 "../src/ProgressUIHandler.vala"
		_tmp2_ = g_strdup (_ ("File Operations"));
#line 129 "../src/ProgressUIHandler.vala"
		_tmp3_ = g_strdup ("system-file-manager");
#line 129 "../src/ProgressUIHandler.vala"
		_tmp4_ = self->priv->application;
#line 129 "../src/ProgressUIHandler.vala"
		_tmp5_ = gtk_application_get_active_window (_tmp4_);
#line 129 "../src/ProgressUIHandler.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 129 "../src/ProgressUIHandler.vala"
		_tmp7_ = granite_dialog_new ();
#line 129 "../src/ProgressUIHandler.vala"
		gtk_window_set_resizable ((GtkWindow*) _tmp7_, FALSE);
#line 129 "../src/ProgressUIHandler.vala"
		gtk_window_set_title ((GtkWindow*) _tmp7_, _tmp2_);
#line 129 "../src/ProgressUIHandler.vala"
		_g_free0 (_tmp2_);
#line 129 "../src/ProgressUIHandler.vala"
		gtk_window_set_icon_name ((GtkWindow*) _tmp7_, _tmp3_);
#line 129 "../src/ProgressUIHandler.vala"
		_g_free0 (_tmp3_);
#line 129 "../src/ProgressUIHandler.vala"
		gtk_window_set_transient_for ((GtkWindow*) _tmp7_, _tmp6_);
#line 129 "../src/ProgressUIHandler.vala"
		_g_object_unref0 (_tmp6_);
#line 129 "../src/ProgressUIHandler.vala"
		g_object_ref_sink (_tmp7_);
#line 129 "../src/ProgressUIHandler.vala"
		_g_object_unref0 (self->priv->progress_window);
#line 129 "../src/ProgressUIHandler.vala"
		self->priv->progress_window = _tmp7_;
#line 135 "../src/ProgressUIHandler.vala"
		_tmp8_ = self->priv->progress_window;
#line 135 "../src/ProgressUIHandler.vala"
		_tmp9_ = gtk_dialog_get_content_area ((GtkDialog*) _tmp8_);
#line 135 "../src/ProgressUIHandler.vala"
		_tmp10_ = self->priv->window_vbox;
#line 135 "../src/ProgressUIHandler.vala"
		gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp10_);
#line 136 "../src/ProgressUIHandler.vala"
		_tmp11_ = self->priv->window_vbox;
#line 136 "../src/ProgressUIHandler.vala"
		gtk_widget_show ((GtkWidget*) _tmp11_);
#line 138 "../src/ProgressUIHandler.vala"
		_tmp12_ = self->priv->progress_window;
#line 138 "../src/ProgressUIHandler.vala"
		g_signal_connect_object ((GtkWidget*) _tmp12_, "delete-event", (GCallback) ____lambda7__gtk_widget_delete_event, self, 0);
#line 754 "ProgressUIHandler.c"
	}
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 158 "../src/ProgressUIHandler.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 158 "../src/ProgressUIHandler.vala"
	return _data6_;
#line 765 "ProgressUIHandler.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 158 "../src/ProgressUIHandler.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 775 "ProgressUIHandler.c"
		FilesProgressUIHandler* self;
#line 158 "../src/ProgressUIHandler.vala"
		self = _data6_->self;
#line 158 "../src/ProgressUIHandler.vala"
		_g_free0 (_data6_->title);
#line 158 "../src/ProgressUIHandler.vala"
		_g_object_unref0 (self);
#line 158 "../src/ProgressUIHandler.vala"
		g_slice_free (Block6Data, _data6_);
#line 785 "ProgressUIHandler.c"
	}
}

static gboolean
____lambda4_ (Block6Data* _data6_)
{
	FilesProgressUIHandler* self;
	GtkApplication* _tmp0_;
	GtkWindow* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 160 "../src/ProgressUIHandler.vala"
	self = _data6_->self;
#line 161 "../src/ProgressUIHandler.vala"
	_tmp0_ = self->priv->application;
#line 161 "../src/ProgressUIHandler.vala"
	_tmp1_ = gtk_application_get_active_window (_tmp0_);
#line 161 "../src/ProgressUIHandler.vala"
	g_object_get (_tmp1_, "has-toplevel-focus", &_tmp2_, NULL);
#line 161 "../src/ProgressUIHandler.vala"
	_tmp3_ = _tmp2_;
#line 161 "../src/ProgressUIHandler.vala"
	if (!_tmp3_) {
#line 810 "ProgressUIHandler.c"
		const gchar* _tmp4_;
#line 162 "../src/ProgressUIHandler.vala"
		_tmp4_ = _data6_->title;
#line 162 "../src/ProgressUIHandler.vala"
		files_progress_ui_handler_show_operation_complete_notification (self, _tmp4_, self->priv->active_infos < ((guint) 1));
#line 816 "ProgressUIHandler.c"
	}
#line 165 "../src/ProgressUIHandler.vala"
	result = G_SOURCE_REMOVE;
#line 165 "../src/ProgressUIHandler.vala"
	return result;
#line 822 "ProgressUIHandler.c"
}

static gboolean
_____lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda4_ (self);
#line 160 "../src/ProgressUIHandler.vala"
	return result;
#line 832 "ProgressUIHandler.c"
}

static void
files_progress_ui_handler_progress_info_finished_cb (FilesProgressUIHandler* self,
                                                     PFProgressInfo* info)
{
	guint _tmp0_;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
#line 145 "../src/ProgressUIHandler.vala"
	g_return_if_fail (self != NULL);
#line 145 "../src/ProgressUIHandler.vala"
	g_return_if_fail (info != NULL);
#line 147 "../src/ProgressUIHandler.vala"
	g_signal_parse_name ("finished", PF_PROGRESS_TYPE_INFO, &_tmp0_, NULL, FALSE);
#line 147 "../src/ProgressUIHandler.vala"
	g_signal_handlers_disconnect_matched (info, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _files_progress_ui_handler_progress_info_finished_cb_pf_progress_info_finished, self);
#line 149 "../src/ProgressUIHandler.vala"
	if (self->priv->active_infos > ((guint) 0)) {
#line 852 "ProgressUIHandler.c"
		guint _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 150 "../src/ProgressUIHandler.vala"
		_tmp1_ = self->priv->active_infos;
#line 150 "../src/ProgressUIHandler.vala"
		self->priv->active_infos = _tmp1_ - 1;
#line 158 "../src/ProgressUIHandler.vala"
		_tmp2_ = pf_progress_info_get_is_cancelled (info);
#line 158 "../src/ProgressUIHandler.vala"
		_tmp3_ = _tmp2_;
#line 158 "../src/ProgressUIHandler.vala"
		if (!_tmp3_) {
#line 866 "ProgressUIHandler.c"
			Block6Data* _data6_;
			const gchar* _tmp4_;
			const gchar* _tmp5_;
			gchar* _tmp6_;
#line 158 "../src/ProgressUIHandler.vala"
			_data6_ = g_slice_new0 (Block6Data);
#line 158 "../src/ProgressUIHandler.vala"
			_data6_->_ref_count_ = 1;
#line 158 "../src/ProgressUIHandler.vala"
			_data6_->self = g_object_ref (self);
#line 159 "../src/ProgressUIHandler.vala"
			_tmp4_ = pf_progress_info_get_title (info);
#line 159 "../src/ProgressUIHandler.vala"
			_tmp5_ = _tmp4_;
#line 159 "../src/ProgressUIHandler.vala"
			_tmp6_ = g_strdup (_tmp5_);
#line 159 "../src/ProgressUIHandler.vala"
			_data6_->title = _tmp6_;
#line 160 "../src/ProgressUIHandler.vala"
			g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, _____lambda4__gsource_func, block6_data_ref (_data6_), block6_data_unref);
#line 158 "../src/ProgressUIHandler.vala"
			block6_data_unref (_data6_);
#line 158 "../src/ProgressUIHandler.vala"
			_data6_ = NULL;
#line 891 "ProgressUIHandler.c"
		}
	} else {
#line 169 "../src/ProgressUIHandler.vala"
		g_warning ("ProgressUIHandler.vala:169: Attempt to decrement zero active infos");
#line 896 "ProgressUIHandler.c"
	}
#line 172 "../src/ProgressUIHandler.vala"
	if (self->priv->active_infos < ((guint) 1)) {
#line 900 "ProgressUIHandler.c"
		GraniteDialog* _tmp9_;
#line 172 "../src/ProgressUIHandler.vala"
		_tmp9_ = self->priv->progress_window;
#line 172 "../src/ProgressUIHandler.vala"
		_tmp8_ = _tmp9_ != NULL;
#line 906 "ProgressUIHandler.c"
	} else {
#line 172 "../src/ProgressUIHandler.vala"
		_tmp8_ = FALSE;
#line 910 "ProgressUIHandler.c"
	}
#line 172 "../src/ProgressUIHandler.vala"
	if (_tmp8_) {
#line 914 "ProgressUIHandler.c"
		GraniteDialog* _tmp10_;
		gboolean _tmp11_;
		gboolean _tmp12_;
#line 172 "../src/ProgressUIHandler.vala"
		_tmp10_ = self->priv->progress_window;
#line 172 "../src/ProgressUIHandler.vala"
		_tmp11_ = gtk_widget_get_visible ((GtkWidget*) _tmp10_);
#line 172 "../src/ProgressUIHandler.vala"
		_tmp12_ = _tmp11_;
#line 172 "../src/ProgressUIHandler.vala"
		_tmp7_ = _tmp12_;
#line 926 "ProgressUIHandler.c"
	} else {
#line 172 "../src/ProgressUIHandler.vala"
		_tmp7_ = FALSE;
#line 930 "ProgressUIHandler.c"
	}
#line 172 "../src/ProgressUIHandler.vala"
	if (_tmp7_) {
#line 934 "ProgressUIHandler.c"
		GraniteDialog* _tmp13_;
#line 173 "../src/ProgressUIHandler.vala"
		_tmp13_ = self->priv->progress_window;
#line 173 "../src/ProgressUIHandler.vala"
		gtk_widget_hide ((GtkWidget*) _tmp13_);
#line 940 "ProgressUIHandler.c"
	}
#line 176 "../src/ProgressUIHandler.vala"
	files_progress_ui_handler_update_launcher (self, info, FALSE);
#line 944 "ProgressUIHandler.c"
}

static void
files_progress_ui_handler_show_operation_complete_notification (FilesProgressUIHandler* self,
                                                                const gchar* title,
                                                                gboolean all_finished)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	GNotification* complete_notification = NULL;
	GNotification* _tmp5_;
	const gchar* _tmp6_;
	GThemedIcon* _tmp7_;
	GThemedIcon* _tmp8_;
	GtkApplication* _tmp9_;
#line 179 "../src/ProgressUIHandler.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/ProgressUIHandler.vala"
	g_return_if_fail (title != NULL);
#line 181 "../src/ProgressUIHandler.vala"
	_tmp0_ = g_strdup_printf (_ ("Completed %s"), title);
#line 181 "../src/ProgressUIHandler.vala"
	_result_ = _tmp0_;
#line 183 "../src/ProgressUIHandler.vala"
	if (all_finished) {
#line 970 "ProgressUIHandler.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 184 "../src/ProgressUIHandler.vala"
		_tmp1_ = _result_;
#line 184 "../src/ProgressUIHandler.vala"
		_tmp2_ = g_strconcat (_tmp1_, "\n", NULL);
#line 184 "../src/ProgressUIHandler.vala"
		_tmp3_ = _tmp2_;
#line 184 "../src/ProgressUIHandler.vala"
		_tmp4_ = g_strconcat (_tmp3_, _ ("All file operations have ended"), NULL);
#line 184 "../src/ProgressUIHandler.vala"
		_g_free0 (_result_);
#line 184 "../src/ProgressUIHandler.vala"
		_result_ = _tmp4_;
#line 184 "../src/ProgressUIHandler.vala"
		_g_free0 (_tmp3_);
#line 989 "ProgressUIHandler.c"
	}
#line 187 "../src/ProgressUIHandler.vala"
	_tmp5_ = g_notification_new (_ ("File Operations"));
#line 187 "../src/ProgressUIHandler.vala"
	complete_notification = _tmp5_;
#line 188 "../src/ProgressUIHandler.vala"
	_tmp6_ = _result_;
#line 188 "../src/ProgressUIHandler.vala"
	g_notification_set_body (complete_notification, _tmp6_);
#line 189 "../src/ProgressUIHandler.vala"
	_tmp7_ = (GThemedIcon*) g_themed_icon_new (FILES_ICON_APP_LOGO);
#line 189 "../src/ProgressUIHandler.vala"
	_tmp8_ = _tmp7_;
#line 189 "../src/ProgressUIHandler.vala"
	g_notification_set_icon (complete_notification, (GIcon*) _tmp8_);
#line 189 "../src/ProgressUIHandler.vala"
	_g_object_unref0 (_tmp8_);
#line 190 "../src/ProgressUIHandler.vala"
	_tmp9_ = self->priv->application;
#line 190 "../src/ProgressUIHandler.vala"
	g_application_send_notification ((GApplication*) _tmp9_, "Pantheon Files Operation", complete_notification);
#line 179 "../src/ProgressUIHandler.vala"
	_g_object_unref0 (complete_notification);
#line 179 "../src/ProgressUIHandler.vala"
	_g_free0 (_result_);
#line 1015 "ProgressUIHandler.c"
}

static void
_files_progress_ui_handler_launcher_progress_changed_pf_progress_info_progress_changed (PFProgressInfo* _sender,
                                                                                        gpointer self)
{
#line 197 "../src/ProgressUIHandler.vala"
	files_progress_ui_handler_launcher_progress_changed ((FilesProgressUIHandler*) self);
#line 1024 "ProgressUIHandler.c"
}

static void
files_progress_ui_handler_update_launcher (FilesProgressUIHandler* self,
                                           PFProgressInfo* info,
                                           gboolean added)
{
#line 193 "../src/ProgressUIHandler.vala"
	g_return_if_fail (self != NULL);
#line 193 "../src/ProgressUIHandler.vala"
	g_return_if_fail (info != NULL);
#line 194 "../src/ProgressUIHandler.vala"
	files_progress_ui_handler_update_launcher_entry (self, info);
#line 196 "../src/ProgressUIHandler.vala"
	if (added) {
#line 197 "../src/ProgressUIHandler.vala"
		g_signal_connect_object (info, "progress-changed", (GCallback) _files_progress_ui_handler_launcher_progress_changed_pf_progress_info_progress_changed, self, 0);
#line 1042 "ProgressUIHandler.c"
	}
}

static void
____lambda5_ (FilesProgressUIHandler* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 205 "../src/ProgressUIHandler.vala"
	g_return_if_fail (res != NULL);
#line 1054 "ProgressUIHandler.c"
	{
		gboolean _tmp0_ = FALSE;
#line 208 "../src/ProgressUIHandler.vala"
		_tmp0_ = granite_services_application_set_progress_visible_finish (res, &_inner_error0_);
#line 208 "../src/ProgressUIHandler.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1061 "ProgressUIHandler.c"
			goto __catch0_g_error;
		}
#line 208 "../src/ProgressUIHandler.vala"
		if (_tmp0_) {
#line 209 "../src/ProgressUIHandler.vala"
			self->priv->launcher_progress_visible = TRUE;
#line 210 "../src/ProgressUIHandler.vala"
			files_progress_ui_handler_launcher_progress_changed (self);
#line 1070 "ProgressUIHandler.c"
		} else {
#line 212 "../src/ProgressUIHandler.vala"
			self->priv->can_show_launcher_progress = FALSE;
#line 1074 "ProgressUIHandler.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 206 "../src/ProgressUIHandler.vala"
		e = _inner_error0_;
#line 206 "../src/ProgressUIHandler.vala"
		_inner_error0_ = NULL;
#line 215 "../src/ProgressUIHandler.vala"
		self->priv->can_show_launcher_progress = FALSE;
#line 216 "../src/ProgressUIHandler.vala"
		_tmp1_ = e;
#line 216 "../src/ProgressUIHandler.vala"
		_tmp2_ = _tmp1_->message;
#line 216 "../src/ProgressUIHandler.vala"
		g_debug ("ProgressUIHandler.vala:216: Could not set progress visible: %s", _tmp2_);
#line 206 "../src/ProgressUIHandler.vala"
		_g_error_free0 (e);
#line 1097 "ProgressUIHandler.c"
	}
	__finally0:
#line 206 "../src/ProgressUIHandler.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 206 "../src/ProgressUIHandler.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 206 "../src/ProgressUIHandler.vala"
		g_clear_error (&_inner_error0_);
#line 206 "../src/ProgressUIHandler.vala"
		return;
#line 1108 "ProgressUIHandler.c"
	}
}

static void
_____lambda5__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 205 "../src/ProgressUIHandler.vala"
	____lambda5_ ((FilesProgressUIHandler*) self, source_object, res);
#line 205 "../src/ProgressUIHandler.vala"
	g_object_unref (self);
#line 1121 "ProgressUIHandler.c"
}

static void
files_progress_ui_handler_update_launcher_entry (FilesProgressUIHandler* self,
                                                 PFProgressInfo* info)
{
#line 201 "../src/ProgressUIHandler.vala"
	g_return_if_fail (self != NULL);
#line 201 "../src/ProgressUIHandler.vala"
	g_return_if_fail (info != NULL);
#line 202 "../src/ProgressUIHandler.vala"
	if (self->priv->active_infos > ((guint) 0)) {
#line 1134 "ProgressUIHandler.c"
		gboolean _tmp0_ = FALSE;
#line 204 "../src/ProgressUIHandler.vala"
		if (!self->priv->launcher_progress_visible) {
#line 204 "../src/ProgressUIHandler.vala"
			_tmp0_ = self->priv->can_show_launcher_progress;
#line 1140 "ProgressUIHandler.c"
		} else {
#line 204 "../src/ProgressUIHandler.vala"
			_tmp0_ = FALSE;
#line 1144 "ProgressUIHandler.c"
		}
#line 204 "../src/ProgressUIHandler.vala"
		if (_tmp0_) {
#line 205 "../src/ProgressUIHandler.vala"
			granite_services_application_set_progress_visible (TRUE, _____lambda5__gasync_ready_callback, g_object_ref (self));
#line 1150 "ProgressUIHandler.c"
		} else {
#line 219 "../src/ProgressUIHandler.vala"
			if (self->priv->launcher_progress_visible) {
#line 220 "../src/ProgressUIHandler.vala"
				files_progress_ui_handler_launcher_progress_changed (self);
#line 1156 "ProgressUIHandler.c"
			}
		}
	} else {
#line 223 "../src/ProgressUIHandler.vala"
		self->priv->launcher_progress_visible = FALSE;
#line 225 "../src/ProgressUIHandler.vala"
		self->priv->can_show_launcher_progress = TRUE;
#line 226 "../src/ProgressUIHandler.vala"
		granite_services_application_set_progress_visible (FALSE, NULL, NULL);
#line 1166 "ProgressUIHandler.c"
	}
}

static void
files_progress_ui_handler_launcher_progress_changed (FilesProgressUIHandler* self)
{
	gdouble progress = 0.0;
	gdouble current = 0.0;
	gdouble total = 0.0;
	GeeLinkedList* infos = NULL;
	PFProgressInfoManager* _tmp0_;
	GeeLinkedList* _tmp1_;
	GeeLinkedList* _tmp2_;
	gboolean _tmp17_ = FALSE;
#line 230 "../src/ProgressUIHandler.vala"
	g_return_if_fail (self != NULL);
#line 231 "../src/ProgressUIHandler.vala"
	progress = (gdouble) 0;
#line 232 "../src/ProgressUIHandler.vala"
	current = (gdouble) 0;
#line 233 "../src/ProgressUIHandler.vala"
	total = (gdouble) 0;
#line 234 "../src/ProgressUIHandler.vala"
	_tmp0_ = self->priv->manager;
#line 234 "../src/ProgressUIHandler.vala"
	_tmp1_ = pf_progress_info_manager_get_all_infos (_tmp0_);
#line 234 "../src/ProgressUIHandler.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 234 "../src/ProgressUIHandler.vala"
	infos = _tmp2_;
#line 1197 "ProgressUIHandler.c"
	{
		GeeLinkedList* __info_list = NULL;
		GeeLinkedList* _tmp3_;
		gint __info_size = 0;
		GeeLinkedList* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint __info_index = 0;
#line 236 "../src/ProgressUIHandler.vala"
		_tmp3_ = infos;
#line 236 "../src/ProgressUIHandler.vala"
		__info_list = _tmp3_;
#line 236 "../src/ProgressUIHandler.vala"
		_tmp4_ = __info_list;
#line 236 "../src/ProgressUIHandler.vala"
		_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 236 "../src/ProgressUIHandler.vala"
		_tmp6_ = _tmp5_;
#line 236 "../src/ProgressUIHandler.vala"
		__info_size = _tmp6_;
#line 236 "../src/ProgressUIHandler.vala"
		__info_index = -1;
#line 236 "../src/ProgressUIHandler.vala"
		while (TRUE) {
#line 1222 "ProgressUIHandler.c"
			gint _tmp7_;
			gint _tmp8_;
			PFProgressInfo* _info = NULL;
			GeeLinkedList* _tmp9_;
			gpointer _tmp10_;
			gdouble c = 0.0;
			PFProgressInfo* _tmp11_;
			gdouble _tmp12_;
			gdouble _tmp13_;
			gdouble t = 0.0;
			PFProgressInfo* _tmp14_;
			gdouble _tmp15_;
			gdouble _tmp16_;
#line 236 "../src/ProgressUIHandler.vala"
			__info_index = __info_index + 1;
#line 236 "../src/ProgressUIHandler.vala"
			_tmp7_ = __info_index;
#line 236 "../src/ProgressUIHandler.vala"
			_tmp8_ = __info_size;
#line 236 "../src/ProgressUIHandler.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 236 "../src/ProgressUIHandler.vala"
				break;
#line 1246 "ProgressUIHandler.c"
			}
#line 236 "../src/ProgressUIHandler.vala"
			_tmp9_ = __info_list;
#line 236 "../src/ProgressUIHandler.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, __info_index);
#line 236 "../src/ProgressUIHandler.vala"
			_info = (PFProgressInfo*) _tmp10_;
#line 237 "../src/ProgressUIHandler.vala"
			_tmp11_ = _info;
#line 237 "../src/ProgressUIHandler.vala"
			_tmp12_ = pf_progress_info_get_current (_tmp11_);
#line 237 "../src/ProgressUIHandler.vala"
			_tmp13_ = _tmp12_;
#line 237 "../src/ProgressUIHandler.vala"
			c = _tmp13_;
#line 238 "../src/ProgressUIHandler.vala"
			_tmp14_ = _info;
#line 238 "../src/ProgressUIHandler.vala"
			_tmp15_ = pf_progress_info_get_total (_tmp14_);
#line 238 "../src/ProgressUIHandler.vala"
			_tmp16_ = _tmp15_;
#line 238 "../src/ProgressUIHandler.vala"
			t = _tmp16_;
#line 240 "../src/ProgressUIHandler.vala"
			if (c < ((gdouble) 0)) {
#line 241 "../src/ProgressUIHandler.vala"
				c = (gdouble) 0;
#line 1274 "ProgressUIHandler.c"
			}
#line 244 "../src/ProgressUIHandler.vala"
			if (t <= ((gdouble) 0)) {
#line 245 "../src/ProgressUIHandler.vala"
				_g_object_unref0 (_info);
#line 245 "../src/ProgressUIHandler.vala"
				continue;
#line 1282 "ProgressUIHandler.c"
			}
#line 248 "../src/ProgressUIHandler.vala"
			current += c;
#line 249 "../src/ProgressUIHandler.vala"
			total += t;
#line 236 "../src/ProgressUIHandler.vala"
			_g_object_unref0 (_info);
#line 1290 "ProgressUIHandler.c"
		}
	}
#line 252 "../src/ProgressUIHandler.vala"
	if (current >= ((gdouble) 0)) {
#line 252 "../src/ProgressUIHandler.vala"
		_tmp17_ = total > ((gdouble) 0);
#line 1297 "ProgressUIHandler.c"
	} else {
#line 252 "../src/ProgressUIHandler.vala"
		_tmp17_ = FALSE;
#line 1301 "ProgressUIHandler.c"
	}
#line 252 "../src/ProgressUIHandler.vala"
	if (_tmp17_) {
#line 253 "../src/ProgressUIHandler.vala"
		progress = current / total;
#line 1307 "ProgressUIHandler.c"
	}
#line 256 "../src/ProgressUIHandler.vala"
	if (progress > 1.0) {
#line 257 "../src/ProgressUIHandler.vala"
		progress = 1.0;
#line 1313 "ProgressUIHandler.c"
	}
#line 260 "../src/ProgressUIHandler.vala"
	granite_services_application_set_progress (progress, NULL, NULL);
#line 230 "../src/ProgressUIHandler.vala"
	_g_object_unref0 (infos);
#line 1319 "ProgressUIHandler.c"
}

FilesProgressUIHandler*
files_progress_ui_handler_construct (GType object_type)
{
	FilesProgressUIHandler * self = NULL;
#line 28 "../src/ProgressUIHandler.vala"
	self = (FilesProgressUIHandler*) g_object_new (object_type, NULL);
#line 28 "../src/ProgressUIHandler.vala"
	return self;
#line 1330 "ProgressUIHandler.c"
}

FilesProgressUIHandler*
files_progress_ui_handler_new (void)
{
#line 28 "../src/ProgressUIHandler.vala"
	return files_progress_ui_handler_construct (FILES_PROGRESS_TYPE_UI_HANDLER);
#line 1338 "ProgressUIHandler.c"
}

static void
_files_progress_ui_handler___lambda11_ (FilesProgressUIHandler* self,
                                        PFProgressInfo* info)
{
#line 40 "../src/ProgressUIHandler.vala"
	g_return_if_fail (info != NULL);
#line 41 "../src/ProgressUIHandler.vala"
	g_signal_connect_object (info, "started", (GCallback) _files_progress_ui_handler_progress_info_started_cb_pf_progress_info_started, self, 0);
#line 1349 "ProgressUIHandler.c"
}

static void
__files_progress_ui_handler___lambda11__pf_progress_info_manager_new_progress_info (PFProgressInfoManager* _sender,
                                                                                    PFProgressInfo* info,
                                                                                    gpointer self)
{
#line 40 "../src/ProgressUIHandler.vala"
	_files_progress_ui_handler___lambda11_ ((FilesProgressUIHandler*) self, info);
#line 1359 "ProgressUIHandler.c"
}

static GObject *
files_progress_ui_handler_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FilesProgressUIHandler * self;
	GApplication* _tmp0_;
	GtkApplication* _tmp1_;
	PFProgressInfoManager* _tmp2_;
	PFProgressInfoManager* _tmp3_;
#line 37 "../src/ProgressUIHandler.vala"
	parent_class = G_OBJECT_CLASS (files_progress_ui_handler_parent_class);
#line 37 "../src/ProgressUIHandler.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 37 "../src/ProgressUIHandler.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_PROGRESS_TYPE_UI_HANDLER, FilesProgressUIHandler);
#line 38 "../src/ProgressUIHandler.vala"
	_tmp0_ = g_application_get_default ();
#line 38 "../src/ProgressUIHandler.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
#line 38 "../src/ProgressUIHandler.vala"
	_g_object_unref0 (self->priv->application);
#line 38 "../src/ProgressUIHandler.vala"
	self->priv->application = _tmp1_;
#line 39 "../src/ProgressUIHandler.vala"
	_tmp2_ = pf_progress_info_manager_get_instance ();
#line 39 "../src/ProgressUIHandler.vala"
	_g_object_unref0 (self->priv->manager);
#line 39 "../src/ProgressUIHandler.vala"
	self->priv->manager = _tmp2_;
#line 40 "../src/ProgressUIHandler.vala"
	_tmp3_ = self->priv->manager;
#line 40 "../src/ProgressUIHandler.vala"
	g_signal_connect_object (_tmp3_, "new-progress-info", (GCallback) __files_progress_ui_handler___lambda11__pf_progress_info_manager_new_progress_info, self, 0);
#line 37 "../src/ProgressUIHandler.vala"
	return obj;
#line 1400 "ProgressUIHandler.c"
}

static void
files_progress_ui_handler_class_init (FilesProgressUIHandlerClass * klass,
                                      gpointer klass_data)
{
#line 28 "../src/ProgressUIHandler.vala"
	files_progress_ui_handler_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/ProgressUIHandler.vala"
	g_type_class_adjust_private_offset (klass, &FilesProgressUIHandler_private_offset);
#line 28 "../src/ProgressUIHandler.vala"
	G_OBJECT_CLASS (klass)->constructor = files_progress_ui_handler_constructor;
#line 28 "../src/ProgressUIHandler.vala"
	G_OBJECT_CLASS (klass)->finalize = files_progress_ui_handler_finalize;
#line 1415 "ProgressUIHandler.c"
}

static void
files_progress_ui_handler_instance_init (FilesProgressUIHandler * self,
                                         gpointer klass)
{
#line 28 "../src/ProgressUIHandler.vala"
	self->priv = files_progress_ui_handler_get_instance_private (self);
#line 29 "../src/ProgressUIHandler.vala"
	self->priv->manager = NULL;
#line 30 "../src/ProgressUIHandler.vala"
	self->priv->progress_window = NULL;
#line 31 "../src/ProgressUIHandler.vala"
	self->priv->window_vbox = NULL;
#line 32 "../src/ProgressUIHandler.vala"
	self->priv->active_infos = (guint) 0;
#line 34 "../src/ProgressUIHandler.vala"
	self->priv->launcher_progress_visible = FALSE;
#line 35 "../src/ProgressUIHandler.vala"
	self->priv->can_show_launcher_progress = TRUE;
#line 1436 "ProgressUIHandler.c"
}

static void
files_progress_ui_handler_finalize (GObject * obj)
{
	FilesProgressUIHandler * self;
#line 28 "../src/ProgressUIHandler.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_PROGRESS_TYPE_UI_HANDLER, FilesProgressUIHandler);
#line 46 "../src/ProgressUIHandler.vala"
	g_debug ("ProgressUIHandler.vala:46: ProgressUIHandler destruct");
#line 47 "../src/ProgressUIHandler.vala"
	if (self->priv->active_infos > ((guint) 0)) {
#line 1449 "ProgressUIHandler.c"
		GeeLinkedList* infos = NULL;
		PFProgressInfoManager* _tmp0_;
		GeeLinkedList* _tmp1_;
		GeeLinkedList* _tmp2_;
#line 48 "../src/ProgressUIHandler.vala"
		g_warning ("ProgressUIHandler.vala:48: ProgressUIHandler destruct when infos activ" \
"e");
#line 49 "../src/ProgressUIHandler.vala"
		_tmp0_ = self->priv->manager;
#line 49 "../src/ProgressUIHandler.vala"
		_tmp1_ = pf_progress_info_manager_get_all_infos (_tmp0_);
#line 49 "../src/ProgressUIHandler.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 49 "../src/ProgressUIHandler.vala"
		infos = _tmp2_;
#line 1464 "ProgressUIHandler.c"
		{
			GeeLinkedList* _info_list = NULL;
			GeeLinkedList* _tmp3_;
			gint _info_size = 0;
			GeeLinkedList* _tmp4_;
			gint _tmp5_;
			gint _tmp6_;
			gint _info_index = 0;
#line 50 "../src/ProgressUIHandler.vala"
			_tmp3_ = infos;
#line 50 "../src/ProgressUIHandler.vala"
			_info_list = _tmp3_;
#line 50 "../src/ProgressUIHandler.vala"
			_tmp4_ = _info_list;
#line 50 "../src/ProgressUIHandler.vala"
			_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 50 "../src/ProgressUIHandler.vala"
			_tmp6_ = _tmp5_;
#line 50 "../src/ProgressUIHandler.vala"
			_info_size = _tmp6_;
#line 50 "../src/ProgressUIHandler.vala"
			_info_index = -1;
#line 50 "../src/ProgressUIHandler.vala"
			while (TRUE) {
#line 1489 "ProgressUIHandler.c"
				gint _tmp7_;
				gint _tmp8_;
				PFProgressInfo* info = NULL;
				GeeLinkedList* _tmp9_;
				gpointer _tmp10_;
				PFProgressInfo* _tmp11_;
#line 50 "../src/ProgressUIHandler.vala"
				_info_index = _info_index + 1;
#line 50 "../src/ProgressUIHandler.vala"
				_tmp7_ = _info_index;
#line 50 "../src/ProgressUIHandler.vala"
				_tmp8_ = _info_size;
#line 50 "../src/ProgressUIHandler.vala"
				if (!(_tmp7_ < _tmp8_)) {
#line 50 "../src/ProgressUIHandler.vala"
					break;
#line 1506 "ProgressUIHandler.c"
				}
#line 50 "../src/ProgressUIHandler.vala"
				_tmp9_ = _info_list;
#line 50 "../src/ProgressUIHandler.vala"
				_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _info_index);
#line 50 "../src/ProgressUIHandler.vala"
				info = (PFProgressInfo*) _tmp10_;
#line 51 "../src/ProgressUIHandler.vala"
				_tmp11_ = info;
#line 51 "../src/ProgressUIHandler.vala"
				pf_progress_info_cancel (_tmp11_);
#line 50 "../src/ProgressUIHandler.vala"
				_g_object_unref0 (info);
#line 1520 "ProgressUIHandler.c"
			}
		}
#line 47 "../src/ProgressUIHandler.vala"
		_g_object_unref0 (infos);
#line 1525 "ProgressUIHandler.c"
	}
#line 29 "../src/ProgressUIHandler.vala"
	_g_object_unref0 (self->priv->manager);
#line 30 "../src/ProgressUIHandler.vala"
	_g_object_unref0 (self->priv->progress_window);
#line 31 "../src/ProgressUIHandler.vala"
	_g_object_unref0 (self->priv->window_vbox);
#line 33 "../src/ProgressUIHandler.vala"
	_g_object_unref0 (self->priv->application);
#line 28 "../src/ProgressUIHandler.vala"
	G_OBJECT_CLASS (files_progress_ui_handler_parent_class)->finalize (obj);
#line 1537 "ProgressUIHandler.c"
}

/*** One instance of this class is owned by the application and handles UI for file transfers initiated by
 *   of the app windows.  Feedback is provided by a dialog window which appears if a transfer takes longer than
 *   approximately 1 second. The launcher is also updated if present and a notification is sent of the
 *   completion of the operation unless it was cancelled by the user.
***/
 G_GNUC_NO_INLINE static GType
files_progress_ui_handler_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesProgressUIHandlerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) files_progress_ui_handler_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesProgressUIHandler), 0, (GInstanceInitFunc) files_progress_ui_handler_instance_init, NULL };
	GType files_progress_ui_handler_type_id;
	files_progress_ui_handler_type_id = g_type_register_static (G_TYPE_OBJECT, "FilesProgressUIHandler", &g_define_type_info, 0);
	FilesProgressUIHandler_private_offset = g_type_add_instance_private (files_progress_ui_handler_type_id, sizeof (FilesProgressUIHandlerPrivate));
	return files_progress_ui_handler_type_id;
}

GType
files_progress_ui_handler_get_type (void)
{
	static volatile gsize files_progress_ui_handler_type_id__once = 0;
	if (g_once_init_enter (&files_progress_ui_handler_type_id__once)) {
		GType files_progress_ui_handler_type_id;
		files_progress_ui_handler_type_id = files_progress_ui_handler_get_type_once ();
		g_once_init_leave (&files_progress_ui_handler_type_id__once, files_progress_ui_handler_type_id);
	}
	return files_progress_ui_handler_type_id__once;
}

