/* BookmarkListBox.c generated by valac 0.56.14, the Vala compiler
 * generated from BookmarkListBox.vala, do not modify */

/* BookmarkListBox.vala
 *
 * Copyright 2020 elementary, Inc. <https://elementary.io>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 * Authors : Jeremy Wootten <jeremy@elementaryos.org>
 */

#include <gtk/gtk.h>
#include "pantheon-files-core.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <granite.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define SIDEBAR_TYPE_BOOKMARK_LIST_BOX (sidebar_bookmark_list_box_get_type ())
#define SIDEBAR_BOOKMARK_LIST_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SIDEBAR_TYPE_BOOKMARK_LIST_BOX, SidebarBookmarkListBox))
#define SIDEBAR_BOOKMARK_LIST_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SIDEBAR_TYPE_BOOKMARK_LIST_BOX, SidebarBookmarkListBoxClass))
#define SIDEBAR_IS_BOOKMARK_LIST_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SIDEBAR_TYPE_BOOKMARK_LIST_BOX))
#define SIDEBAR_IS_BOOKMARK_LIST_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SIDEBAR_TYPE_BOOKMARK_LIST_BOX))
#define SIDEBAR_BOOKMARK_LIST_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SIDEBAR_TYPE_BOOKMARK_LIST_BOX, SidebarBookmarkListBoxClass))

typedef struct _SidebarBookmarkListBox SidebarBookmarkListBox;
typedef struct _SidebarBookmarkListBoxClass SidebarBookmarkListBoxClass;
typedef struct _SidebarBookmarkListBoxPrivate SidebarBookmarkListBoxPrivate;
enum  {
	SIDEBAR_BOOKMARK_LIST_BOX_0_PROPERTY,
	SIDEBAR_BOOKMARK_LIST_BOX_SIDEBAR_PROPERTY,
	SIDEBAR_BOOKMARK_LIST_BOX_LIST_BOX_PROPERTY,
	SIDEBAR_BOOKMARK_LIST_BOX_NUM_PROPERTIES
};
static GParamSpec* sidebar_bookmark_list_box_properties[SIDEBAR_BOOKMARK_LIST_BOX_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define SIDEBAR_TYPE_BOOKMARK_ROW (sidebar_bookmark_row_get_type ())
#define SIDEBAR_BOOKMARK_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow))
#define SIDEBAR_BOOKMARK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRowClass))
#define SIDEBAR_IS_BOOKMARK_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SIDEBAR_TYPE_BOOKMARK_ROW))
#define SIDEBAR_IS_BOOKMARK_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SIDEBAR_TYPE_BOOKMARK_ROW))
#define SIDEBAR_BOOKMARK_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRowClass))

typedef struct _SidebarBookmarkRow SidebarBookmarkRow;
typedef struct _SidebarBookmarkRowClass SidebarBookmarkRowClass;
typedef struct _Block62Data Block62Data;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block63Data Block63Data;
#define _files_bookmark_unref0(var) ((var == NULL) ? NULL : (var = (files_bookmark_unref (var), NULL)))
typedef struct _Block64Data Block64Data;

struct _SidebarBookmarkListBox {
	GtkBox parent_instance;
	SidebarBookmarkListBoxPrivate * priv;
};

struct _SidebarBookmarkListBoxClass {
	GtkBoxClass parent_class;
	void (*rename_bookmark_by_uri) (SidebarBookmarkListBox* self, const gchar* uri, const gchar* new_name);
	gboolean (*is_drop_target) (SidebarBookmarkListBox* self);
};

struct _SidebarBookmarkListBoxPrivate {
	FilesSidebarInterface* _sidebar;
	GtkListBox* _list_box;
	FilesBookmarkList* bookmark_list;
	FilesTrashMonitor* trash_monitor;
};

struct _Block62Data {
	int _ref_count_;
	SidebarBookmarkListBox* self;
	SidebarBookmarkRow* row;
};

struct _Block63Data {
	int _ref_count_;
	Block62Data * _data62_;
	FilesBookmark* bm;
};

struct _Block64Data {
	int _ref_count_;
	SidebarBookmarkListBox* self;
	gboolean removed;
	guint32 id;
};

static gint SidebarBookmarkListBox_private_offset;
static gpointer sidebar_bookmark_list_box_parent_class = NULL;
static SidebarSidebarListInterfaceIface * sidebar_bookmark_list_box_sidebar_sidebar_list_interface_parent_iface = NULL;

VALA_EXTERN GType sidebar_bookmark_list_box_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SidebarBookmarkListBox, g_object_unref)
VALA_EXTERN void sidebar_bookmark_list_box_rename_bookmark_by_uri (SidebarBookmarkListBox* self,
                                                       const gchar* uri,
                                                       const gchar* new_name);
VALA_EXTERN gboolean sidebar_bookmark_list_box_is_drop_target (SidebarBookmarkListBox* self);
VALA_EXTERN SidebarBookmarkListBox* sidebar_bookmark_list_box_new (FilesSidebarInterface* sidebar);
VALA_EXTERN SidebarBookmarkListBox* sidebar_bookmark_list_box_construct (GType object_type,
                                                             FilesSidebarInterface* sidebar);
VALA_EXTERN GType sidebar_bookmark_row_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SidebarBookmarkRow, g_object_unref)
VALA_EXTERN SidebarBookmarkRow* sidebar_bookmark_list_box_add_bookmark (SidebarBookmarkListBox* self,
                                                            const gchar* label,
                                                            const gchar* uri,
                                                            GIcon* gicon,
                                                            gboolean pinned,
                                                            gboolean permanent);
static SidebarBookmarkRow* sidebar_bookmark_list_box_insert_bookmark (SidebarBookmarkListBox* self,
                                                               const gchar* label,
                                                               const gchar* uri,
                                                               GIcon* gicon,
                                                               gint index,
                                                               gboolean pinned,
                                                               gboolean permanent);
VALA_EXTERN SidebarBookmarkRow* sidebar_bookmark_row_new (const gchar* _custom_name,
                                              const gchar* uri,
                                              GIcon* gicon,
                                              SidebarSidebarListInterface* list,
                                              gboolean pinned,
                                              gboolean permanent);
VALA_EXTERN SidebarBookmarkRow* sidebar_bookmark_row_construct (GType object_type,
                                                    const gchar* _custom_name,
                                                    const gchar* uri,
                                                    GIcon* gicon,
                                                    SidebarSidebarListInterface* list,
                                                    gboolean pinned,
                                                    gboolean permanent);
static guint32 sidebar_bookmark_list_box_real_add_plugin_item (SidebarSidebarListInterface* base,
                                                        FilesSidebarPluginItem* plugin_item);
static void sidebar_bookmark_list_box_real_select_item (SidebarSidebarListInterface* base,
                                                 GtkListBoxRow* item);
static void sidebar_bookmark_list_box_real_unselect_all_items (SidebarSidebarListInterface* base);
static void sidebar_bookmark_list_box_real_refresh (SidebarSidebarListInterface* base);
static Block62Data* block62_data_ref (Block62Data* _data62_);
static void block62_data_unref (void * _userdata_);
static Block63Data* block63_data_ref (Block63Data* _data63_);
static void block63_data_unref (void * _userdata_);
static void ____lambda167_ (Block63Data* _data63_);
static void _____lambda167__g_object_notify (GObject* _sender,
                                      GParamSpec* pspec,
                                      gpointer self);
VALA_EXTERN gboolean files_is_admin (void);
static void ___lambda168_ (Block62Data* _data62_);
static void ____lambda168__g_object_notify (GObject* _sender,
                                     GParamSpec* pspec,
                                     gpointer self);
static void sidebar_bookmark_list_box_real_rename_bookmark_by_uri (SidebarBookmarkListBox* self,
                                                            const gchar* uri,
                                                            const gchar* new_name);
static gboolean sidebar_bookmark_list_box_real_add_favorite (SidebarSidebarListInterface* base,
                                                      const gchar* uri,
                                                      const gchar* custom_name,
                                                      gint pos);
static gboolean sidebar_bookmark_list_box_real_remove_item_by_id (SidebarSidebarListInterface* base,
                                                           guint32 id);
static Block64Data* block64_data_ref (Block64Data* _data64_);
static void block64_data_unref (void * _userdata_);
static void __lambda169_ (Block64Data* _data64_,
                   GtkWidget* child);
static void ___lambda169__gtk_callback (GtkWidget* widget,
                                 gpointer self);
static SidebarSidebarItemInterface* sidebar_bookmark_list_box_real_get_item_at_index (SidebarSidebarListInterface* base,
                                                                               gint index);
static gboolean sidebar_bookmark_list_box_real_move_item_after (SidebarSidebarListInterface* base,
                                                         SidebarSidebarItemInterface* item,
                                                         gint target_index);
static gboolean sidebar_bookmark_list_box_real_is_drop_target (SidebarBookmarkListBox* self);
static GObject * sidebar_bookmark_list_box_constructor (GType type,
                                                 guint n_construct_properties,
                                                 GObjectConstructParam * construct_properties);
static void _sidebar_bookmark_list_box___lambda170_ (SidebarBookmarkListBox* self);
static void __sidebar_bookmark_list_box___lambda170__files_bookmark_list_loaded (FilesBookmarkList* _sender,
                                                                          gpointer self);
static void _sidebar_bookmark_list_box___lambda171_ (SidebarBookmarkListBox* self,
                                              GtkListBoxRow* row);
static void __sidebar_bookmark_list_box___lambda171__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                          GtkListBoxRow* row,
                                                                          gpointer self);
static void _sidebar_bookmark_list_box___lambda172_ (SidebarBookmarkListBox* self,
                                              GtkListBoxRow* row);
static void __sidebar_bookmark_list_box___lambda172__gtk_list_box_row_selected (GtkListBox* _sender,
                                                                         GtkListBoxRow* row,
                                                                         gpointer self);
static void sidebar_bookmark_list_box_finalize (GObject * obj);
static GType sidebar_bookmark_list_box_get_type_once (void);
static void _vala_sidebar_bookmark_list_box_get_property (GObject * object,
                                                   guint property_id,
                                                   GValue * value,
                                                   GParamSpec * pspec);
static void _vala_sidebar_bookmark_list_box_set_property (GObject * object,
                                                   guint property_id,
                                                   const GValue * value,
                                                   GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sidebar_bookmark_list_box_get_instance_private (SidebarBookmarkListBox* self)
{
	return G_STRUCT_MEMBER_P (self, SidebarBookmarkListBox_private_offset);
}

SidebarBookmarkListBox*
sidebar_bookmark_list_box_construct (GType object_type,
                                     FilesSidebarInterface* sidebar)
{
	SidebarBookmarkListBox * self = NULL;
#line 30 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (sidebar != NULL, NULL);
#line 31 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) g_object_new (object_type, "sidebar", sidebar, NULL);
#line 30 "../src/View/Sidebar/BookmarkListBox.vala"
	return self;
#line 249 "BookmarkListBox.c"
}

SidebarBookmarkListBox*
sidebar_bookmark_list_box_new (FilesSidebarInterface* sidebar)
{
#line 30 "../src/View/Sidebar/BookmarkListBox.vala"
	return sidebar_bookmark_list_box_construct (SIDEBAR_TYPE_BOOKMARK_LIST_BOX, sidebar);
#line 257 "BookmarkListBox.c"
}

SidebarBookmarkRow*
sidebar_bookmark_list_box_add_bookmark (SidebarBookmarkListBox* self,
                                        const gchar* label,
                                        const gchar* uri,
                                        GIcon* gicon,
                                        gboolean pinned,
                                        gboolean permanent)
{
	SidebarBookmarkRow* _tmp0_;
	SidebarBookmarkRow* result;
#line 61 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 61 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 61 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (gicon != NULL, NULL);
#line 67 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = sidebar_bookmark_list_box_insert_bookmark (self, label, uri, gicon, -1, pinned, permanent);
#line 67 "../src/View/Sidebar/BookmarkListBox.vala"
	result = _tmp0_;
#line 67 "../src/View/Sidebar/BookmarkListBox.vala"
	return result;
#line 284 "BookmarkListBox.c"
}

static SidebarBookmarkRow*
sidebar_bookmark_list_box_insert_bookmark (SidebarBookmarkListBox* self,
                                           const gchar* label,
                                           const gchar* uri,
                                           GIcon* gicon,
                                           gint index,
                                           gboolean pinned,
                                           gboolean permanent)
{
	SidebarBookmarkRow* row = NULL;
	SidebarBookmarkRow* _tmp0_;
	SidebarBookmarkRow* result;
#line 70 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 70 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 70 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 70 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (gicon != NULL, NULL);
#line 77 "../src/View/Sidebar/BookmarkListBox.vala"
	if (sidebar_sidebar_list_interface_has_uri ((SidebarSidebarListInterface*) self, uri, NULL)) {
#line 78 "../src/View/Sidebar/BookmarkListBox.vala"
		result = NULL;
#line 78 "../src/View/Sidebar/BookmarkListBox.vala"
		return result;
#line 313 "BookmarkListBox.c"
	}
#line 81 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = sidebar_bookmark_row_new (label, uri, gicon, (SidebarSidebarListInterface*) self, pinned, permanent);
#line 81 "../src/View/Sidebar/BookmarkListBox.vala"
	g_object_ref_sink (_tmp0_);
#line 81 "../src/View/Sidebar/BookmarkListBox.vala"
	row = _tmp0_;
#line 82 "../src/View/Sidebar/BookmarkListBox.vala"
	if (index >= 0) {
#line 323 "BookmarkListBox.c"
		GtkListBox* _tmp1_;
		GtkListBox* _tmp2_;
		SidebarBookmarkRow* _tmp3_;
#line 83 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp1_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 83 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp2_ = _tmp1_;
#line 83 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp3_ = row;
#line 83 "../src/View/Sidebar/BookmarkListBox.vala"
		gtk_list_box_insert (_tmp2_, (GtkWidget*) _tmp3_, index);
#line 335 "BookmarkListBox.c"
	} else {
		GtkListBox* _tmp4_;
		GtkListBox* _tmp5_;
		SidebarBookmarkRow* _tmp6_;
#line 85 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp4_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 85 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp5_ = _tmp4_;
#line 85 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp6_ = row;
#line 85 "../src/View/Sidebar/BookmarkListBox.vala"
		gtk_container_add ((GtkContainer*) _tmp5_, (GtkWidget*) _tmp6_);
#line 348 "BookmarkListBox.c"
	}
#line 88 "../src/View/Sidebar/BookmarkListBox.vala"
	result = row;
#line 88 "../src/View/Sidebar/BookmarkListBox.vala"
	return result;
#line 354 "BookmarkListBox.c"
}

static guint32
sidebar_bookmark_list_box_real_add_plugin_item (SidebarSidebarListInterface* base,
                                                FilesSidebarPluginItem* plugin_item)
{
	SidebarBookmarkListBox * self;
	SidebarBookmarkRow* row = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	SidebarBookmarkRow* _tmp6_;
	guint32 _tmp7_;
	guint32 _tmp8_;
	guint32 result;
#line 91 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) base;
#line 91 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (plugin_item != NULL, 0U);
#line 92 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = files_sidebar_plugin_item_get_name (plugin_item);
#line 92 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp1_ = _tmp0_;
#line 92 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp2_ = files_sidebar_plugin_item_get_uri (plugin_item);
#line 92 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp3_ = _tmp2_;
#line 92 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp4_ = files_sidebar_plugin_item_get_icon (plugin_item);
#line 92 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp5_ = _tmp4_;
#line 92 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp6_ = sidebar_bookmark_list_box_add_bookmark (self, _tmp1_, _tmp3_, _tmp5_, TRUE, TRUE);
#line 92 "../src/View/Sidebar/BookmarkListBox.vala"
	row = _tmp6_;
#line 98 "../src/View/Sidebar/BookmarkListBox.vala"
	sidebar_sidebar_item_interface_update_plugin_data ((SidebarSidebarItemInterface*) row, plugin_item);
#line 99 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp7_ = sidebar_sidebar_item_interface_get_id ((SidebarSidebarItemInterface*) row);
#line 99 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp8_ = _tmp7_;
#line 99 "../src/View/Sidebar/BookmarkListBox.vala"
	result = _tmp8_;
#line 99 "../src/View/Sidebar/BookmarkListBox.vala"
	_g_object_unref0 (row);
#line 99 "../src/View/Sidebar/BookmarkListBox.vala"
	return result;
#line 405 "BookmarkListBox.c"
}

static void
sidebar_bookmark_list_box_real_select_item (SidebarSidebarListInterface* base,
                                            GtkListBoxRow* item)
{
	SidebarBookmarkListBox * self;
	gboolean _tmp0_ = FALSE;
#line 103 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) base;
#line 104 "../src/View/Sidebar/BookmarkListBox.vala"
	if (item != NULL) {
#line 104 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp0_ = SIDEBAR_IS_BOOKMARK_ROW (item);
#line 420 "BookmarkListBox.c"
	} else {
#line 104 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp0_ = FALSE;
#line 424 "BookmarkListBox.c"
	}
#line 104 "../src/View/Sidebar/BookmarkListBox.vala"
	if (_tmp0_) {
#line 428 "BookmarkListBox.c"
		GtkListBox* _tmp1_;
		GtkListBox* _tmp2_;
#line 105 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp1_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 105 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp2_ = _tmp1_;
#line 105 "../src/View/Sidebar/BookmarkListBox.vala"
		gtk_list_box_select_row (_tmp2_, item);
#line 437 "BookmarkListBox.c"
	} else {
#line 107 "../src/View/Sidebar/BookmarkListBox.vala"
		sidebar_sidebar_list_interface_unselect_all_items ((SidebarSidebarListInterface*) self);
#line 441 "BookmarkListBox.c"
	}
}

static void
sidebar_bookmark_list_box_real_unselect_all_items (SidebarSidebarListInterface* base)
{
	SidebarBookmarkListBox * self;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
#line 111 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) base;
#line 112 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 112 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp1_ = _tmp0_;
#line 112 "../src/View/Sidebar/BookmarkListBox.vala"
	gtk_list_box_unselect_all (_tmp1_);
#line 459 "BookmarkListBox.c"
}

static Block62Data*
block62_data_ref (Block62Data* _data62_)
{
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
	g_atomic_int_inc (&_data62_->_ref_count_);
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
	return _data62_;
#line 469 "BookmarkListBox.c"
}

static void
block62_data_unref (void * _userdata_)
{
	Block62Data* _data62_;
	_data62_ = (Block62Data*) _userdata_;
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
	if (g_atomic_int_dec_and_test (&_data62_->_ref_count_)) {
#line 479 "BookmarkListBox.c"
		SidebarBookmarkListBox* self;
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
		self = _data62_->self;
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (_data62_->row);
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (self);
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
		g_slice_free (Block62Data, _data62_);
#line 489 "BookmarkListBox.c"
	}
}

static Block63Data*
block63_data_ref (Block63Data* _data63_)
{
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
	g_atomic_int_inc (&_data63_->_ref_count_);
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
	return _data63_;
#line 500 "BookmarkListBox.c"
}

static void
block63_data_unref (void * _userdata_)
{
	Block63Data* _data63_;
	_data63_ = (Block63Data*) _userdata_;
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
	if (g_atomic_int_dec_and_test (&_data63_->_ref_count_)) {
#line 510 "BookmarkListBox.c"
		SidebarBookmarkListBox* self;
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
		self = _data63_->_data62_->self;
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
		block62_data_unref (_data63_->_data62_);
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
		_data63_->_data62_ = NULL;
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
		g_slice_free (Block63Data, _data63_);
#line 520 "BookmarkListBox.c"
	}
}

static void
____lambda167_ (Block63Data* _data63_)
{
	Block62Data* _data62_;
	SidebarBookmarkListBox* self;
	FilesBookmark* _tmp0_;
	SidebarBookmarkRow* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
#line 162 "../src/View/Sidebar/BookmarkListBox.vala"
	_data62_ = _data63_->_data62_;
#line 162 "../src/View/Sidebar/BookmarkListBox.vala"
	self = _data62_->self;
#line 163 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = _data63_->bm;
#line 163 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp1_ = _data62_->row;
#line 163 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp2_ = sidebar_sidebar_item_interface_get_custom_name ((SidebarSidebarItemInterface*) _tmp1_);
#line 163 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp3_ = _tmp2_;
#line 163 "../src/View/Sidebar/BookmarkListBox.vala"
	files_bookmark_set_custom_name (_tmp0_, _tmp3_);
#line 547 "BookmarkListBox.c"
}

static void
_____lambda167__g_object_notify (GObject* _sender,
                                 GParamSpec* pspec,
                                 gpointer self)
{
#line 162 "../src/View/Sidebar/BookmarkListBox.vala"
	____lambda167_ (self);
#line 557 "BookmarkListBox.c"
}

static void
___lambda168_ (Block62Data* _data62_)
{
	SidebarBookmarkListBox* self;
	SidebarBookmarkRow* _tmp0_;
	FilesTrashMonitor* _tmp1_;
	GIcon* _tmp2_;
	GIcon* _tmp3_;
#line 183 "../src/View/Sidebar/BookmarkListBox.vala"
	self = _data62_->self;
#line 184 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = _data62_->row;
#line 184 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp1_ = self->priv->trash_monitor;
#line 184 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp2_ = files_trash_monitor_get_icon (_tmp1_);
#line 184 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp3_ = _tmp2_;
#line 184 "../src/View/Sidebar/BookmarkListBox.vala"
	sidebar_sidebar_item_interface_update_icon ((SidebarSidebarItemInterface*) _tmp0_, _tmp3_);
#line 184 "../src/View/Sidebar/BookmarkListBox.vala"
	_g_object_unref0 (_tmp3_);
#line 582 "BookmarkListBox.c"
}

static void
____lambda168__g_object_notify (GObject* _sender,
                                GParamSpec* pspec,
                                gpointer self)
{
#line 183 "../src/View/Sidebar/BookmarkListBox.vala"
	___lambda168_ (self);
#line 592 "BookmarkListBox.c"
}

static void
sidebar_bookmark_list_box_real_refresh (SidebarSidebarListInterface* base)
{
	SidebarBookmarkListBox * self;
	Block62Data* _data62_;
	gchar* home_uri = NULL;
	gchar* _tmp0_;
	const gchar* _tmp7_;
	FilesBookmarkList* _tmp31_;
	GList* _tmp32_;
	GList* _tmp33_;
	GError* _inner_error0_ = NULL;
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) base;
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
	_data62_ = g_slice_new0 (Block62Data);
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
	_data62_->_ref_count_ = 1;
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
	_data62_->self = g_object_ref (self);
#line 116 "../src/View/Sidebar/BookmarkListBox.vala"
	sidebar_sidebar_list_interface_clear ((SidebarSidebarListInterface*) self);
#line 119 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = g_strdup ("");
#line 119 "../src/View/Sidebar/BookmarkListBox.vala"
	home_uri = _tmp0_;
#line 621 "BookmarkListBox.c"
	{
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp2_ = pf_user_utils_get_real_user_home ();
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp3_ = _tmp2_;
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp4_ = g_filename_to_uri (_tmp3_, NULL, &_inner_error0_);
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp5_ = _tmp4_;
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_free0 (_tmp3_);
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp1_ = _tmp5_;
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
			if (_inner_error0_->domain == G_CONVERT_ERROR) {
#line 645 "BookmarkListBox.c"
				goto __catch0_g_convert_error;
			}
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
			_g_free0 (home_uri);
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
			block62_data_unref (_data62_);
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
			_data62_ = NULL;
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
			g_clear_error (&_inner_error0_);
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
			return;
#line 660 "BookmarkListBox.c"
		}
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp6_ = _tmp1_;
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp1_ = NULL;
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_free0 (home_uri);
#line 121 "../src/View/Sidebar/BookmarkListBox.vala"
		home_uri = _tmp6_;
#line 120 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_free0 (_tmp1_);
#line 672 "BookmarkListBox.c"
	}
	goto __finally0;
	__catch0_g_convert_error:
	{
#line 120 "../src/View/Sidebar/BookmarkListBox.vala"
		g_clear_error (&_inner_error0_);
#line 679 "BookmarkListBox.c"
	}
	__finally0:
#line 120 "../src/View/Sidebar/BookmarkListBox.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_free0 (home_uri);
#line 120 "../src/View/Sidebar/BookmarkListBox.vala"
		block62_data_unref (_data62_);
#line 120 "../src/View/Sidebar/BookmarkListBox.vala"
		_data62_ = NULL;
#line 120 "../src/View/Sidebar/BookmarkListBox.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../src/View/Sidebar/BookmarkListBox.vala"
		g_clear_error (&_inner_error0_);
#line 120 "../src/View/Sidebar/BookmarkListBox.vala"
		return;
#line 696 "BookmarkListBox.c"
	}
#line 125 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp7_ = home_uri;
#line 125 "../src/View/Sidebar/BookmarkListBox.vala"
	if (g_strcmp0 (_tmp7_, "") != 0) {
#line 702 "BookmarkListBox.c"
		const gchar* _tmp8_;
		GThemedIcon* _tmp9_;
		GThemedIcon* _tmp10_;
		SidebarBookmarkRow* _tmp11_;
		SidebarBookmarkRow* _tmp12_;
		gchar* _tmp13_;
		gchar** _tmp14_;
		gchar** _tmp15_;
		gint _tmp15__length1;
		gchar* _tmp16_;
		gchar* _tmp17_;
		SidebarBookmarkRow* _tmp18_;
		SidebarBookmarkRow* _tmp19_;
#line 126 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp8_ = home_uri;
#line 126 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp9_ = (GThemedIcon*) g_themed_icon_new (FILES_ICON_HOME);
#line 126 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp10_ = _tmp9_;
#line 126 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp11_ = sidebar_bookmark_list_box_add_bookmark (self, _ ("Home"), _tmp8_, (GIcon*) _tmp10_, TRUE, TRUE);
#line 126 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (_data62_->row);
#line 126 "../src/View/Sidebar/BookmarkListBox.vala"
		_data62_->row = _tmp11_;
#line 126 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (_tmp10_);
#line 134 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp12_ = _data62_->row;
#line 134 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp13_ = g_strdup ("<Alt>Home");
#line 134 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp14_ = g_new0 (gchar*, 1 + 1);
#line 134 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp14_[0] = _tmp13_;
#line 134 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp15_ = _tmp14_;
#line 134 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp15__length1 = 1;
#line 134 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp16_ = granite_markup_accel_tooltip (_tmp15_, (gint) 1, _ ("View the home folder"));
#line 134 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp17_ = _tmp16_;
#line 134 "../src/View/Sidebar/BookmarkListBox.vala"
		gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp12_, _tmp17_);
#line 134 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_free0 (_tmp17_);
#line 134 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
#line 138 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp18_ = _data62_->row;
#line 138 "../src/View/Sidebar/BookmarkListBox.vala"
		sidebar_sidebar_item_interface_set_can_insert_before ((SidebarSidebarItemInterface*) _tmp18_, FALSE);
#line 139 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp19_ = _data62_->row;
#line 139 "../src/View/Sidebar/BookmarkListBox.vala"
		sidebar_sidebar_item_interface_set_can_insert_after ((SidebarSidebarItemInterface*) _tmp19_, FALSE);
#line 760 "BookmarkListBox.c"
	}
#line 142 "../src/View/Sidebar/BookmarkListBox.vala"
	if (files_file_utils_protocol_is_supported ("recent")) {
#line 764 "BookmarkListBox.c"
		GThemedIcon* _tmp20_;
		GThemedIcon* _tmp21_;
		SidebarBookmarkRow* _tmp22_;
		SidebarBookmarkRow* _tmp23_;
		gchar* _tmp24_;
		gchar** _tmp25_;
		gchar** _tmp26_;
		gint _tmp26__length1;
		gchar* _tmp27_;
		gchar* _tmp28_;
		SidebarBookmarkRow* _tmp29_;
		SidebarBookmarkRow* _tmp30_;
#line 143 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp20_ = (GThemedIcon*) g_themed_icon_new (FILES_ICON_RECENT);
#line 143 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp21_ = _tmp20_;
#line 143 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp22_ = sidebar_bookmark_list_box_add_bookmark (self, _ (FILES_PROTOCOL_NAME_RECENT), FILES_RECENT_URI, (GIcon*) _tmp21_, TRUE, TRUE);
#line 143 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (_data62_->row);
#line 143 "../src/View/Sidebar/BookmarkListBox.vala"
		_data62_->row = _tmp22_;
#line 143 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (_tmp21_);
#line 151 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp23_ = _data62_->row;
#line 151 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp24_ = g_strdup ("<Alt>R");
#line 151 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp25_ = g_new0 (gchar*, 1 + 1);
#line 151 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp25_[0] = _tmp24_;
#line 151 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp26_ = _tmp25_;
#line 151 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp26__length1 = 1;
#line 151 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp27_ = granite_markup_accel_tooltip (_tmp26_, (gint) 1, _ ("View the list of recently used files"));
#line 151 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp28_ = _tmp27_;
#line 151 "../src/View/Sidebar/BookmarkListBox.vala"
		gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp23_, _tmp28_);
#line 151 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_free0 (_tmp28_);
#line 151 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp26_ = (_vala_array_free (_tmp26_, _tmp26__length1, (GDestroyNotify) g_free), NULL);
#line 155 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp29_ = _data62_->row;
#line 155 "../src/View/Sidebar/BookmarkListBox.vala"
		sidebar_sidebar_item_interface_set_can_insert_before ((SidebarSidebarItemInterface*) _tmp29_, FALSE);
#line 156 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp30_ = _data62_->row;
#line 156 "../src/View/Sidebar/BookmarkListBox.vala"
		sidebar_sidebar_item_interface_set_can_insert_after ((SidebarSidebarItemInterface*) _tmp30_, TRUE);
#line 819 "BookmarkListBox.c"
	}
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp31_ = self->priv->bookmark_list;
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp32_ = files_bookmark_list_get_list (_tmp31_);
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp33_ = _tmp32_;
#line 827 "BookmarkListBox.c"
	{
		GList* bm_collection = NULL;
		GList* bm_it = NULL;
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
		bm_collection = _tmp33_;
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
		for (bm_it = bm_collection; bm_it != NULL; bm_it = bm_it->next) {
#line 835 "BookmarkListBox.c"
			FilesBookmark* bm = NULL;
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
			bm = (FilesBookmark*) bm_it->data;
#line 839 "BookmarkListBox.c"
			{
				Block63Data* _data63_;
				FilesBookmark* _tmp34_;
				const gchar* _tmp35_;
				const gchar* _tmp36_;
				FilesBookmark* _tmp37_;
				const gchar* _tmp38_;
				const gchar* _tmp39_;
				FilesBookmark* _tmp40_;
				GIcon* _tmp41_;
				GIcon* _tmp42_;
				SidebarBookmarkRow* _tmp43_;
				SidebarBookmarkRow* _tmp44_;
				FilesBookmark* _tmp45_;
				const gchar* _tmp46_;
				const gchar* _tmp47_;
				gchar* _tmp48_;
				gchar* _tmp49_;
				SidebarBookmarkRow* _tmp50_;
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
				_data63_ = g_slice_new0 (Block63Data);
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
				_data63_->_ref_count_ = 1;
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
				_data63_->_data62_ = block62_data_ref (_data62_);
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
				_data63_->bm = bm;
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp34_ = _data63_->bm;
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp35_ = files_bookmark_get_custom_name (_tmp34_);
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp36_ = _tmp35_;
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp37_ = _data63_->bm;
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp38_ = files_bookmark_get_uri (_tmp37_);
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp39_ = _tmp38_;
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp40_ = _data63_->bm;
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp41_ = files_bookmark_get_icon (_tmp40_);
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp42_ = _tmp41_;
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp43_ = sidebar_bookmark_list_box_add_bookmark (self, _tmp36_, _tmp39_, _tmp42_, FALSE, FALSE);
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_g_object_unref0 (_data62_->row);
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_data62_->row = _tmp43_;
#line 160 "../src/View/Sidebar/BookmarkListBox.vala"
				_g_object_unref0 (_tmp42_);
#line 161 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp44_ = _data62_->row;
#line 161 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp45_ = _data63_->bm;
#line 161 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp46_ = files_bookmark_get_uri (_tmp45_);
#line 161 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp47_ = _tmp46_;
#line 161 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp48_ = files_file_utils_sanitize_path (_tmp47_, NULL, FALSE);
#line 161 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp49_ = _tmp48_;
#line 161 "../src/View/Sidebar/BookmarkListBox.vala"
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp44_, _tmp49_);
#line 161 "../src/View/Sidebar/BookmarkListBox.vala"
				_g_free0 (_tmp49_);
#line 162 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp50_ = _data62_->row;
#line 162 "../src/View/Sidebar/BookmarkListBox.vala"
				g_signal_connect_data ((GObject*) _tmp50_, "notify::custom-name", (GCallback) _____lambda167__g_object_notify, block63_data_ref (_data63_), (GClosureNotify) block63_data_unref, 0);
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
				block63_data_unref (_data63_);
#line 159 "../src/View/Sidebar/BookmarkListBox.vala"
				_data63_ = NULL;
#line 917 "BookmarkListBox.c"
			}
		}
	}
#line 167 "../src/View/Sidebar/BookmarkListBox.vala"
	if (!files_is_admin ()) {
#line 923 "BookmarkListBox.c"
		FilesTrashMonitor* _tmp51_;
		GIcon* _tmp52_;
		GIcon* _tmp53_;
		SidebarBookmarkRow* _tmp54_;
		SidebarBookmarkRow* _tmp55_;
		gchar* _tmp56_;
		gchar** _tmp57_;
		gchar** _tmp58_;
		gint _tmp58__length1;
		gchar* _tmp59_;
		gchar* _tmp60_;
		SidebarBookmarkRow* _tmp61_;
		SidebarBookmarkRow* _tmp62_;
		FilesTrashMonitor* _tmp63_;
#line 168 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp51_ = self->priv->trash_monitor;
#line 168 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp52_ = files_trash_monitor_get_icon (_tmp51_);
#line 168 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp53_ = _tmp52_;
#line 168 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp54_ = sidebar_bookmark_list_box_add_bookmark (self, _ ("Trash"), _ (FILES_TRASH_URI), _tmp53_, TRUE, TRUE);
#line 168 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (_data62_->row);
#line 168 "../src/View/Sidebar/BookmarkListBox.vala"
		_data62_->row = _tmp54_;
#line 168 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (_tmp53_);
#line 176 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp55_ = _data62_->row;
#line 176 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp56_ = g_strdup ("<Alt>T");
#line 176 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp57_ = g_new0 (gchar*, 1 + 1);
#line 176 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp57_[0] = _tmp56_;
#line 176 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp58_ = _tmp57_;
#line 176 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp58__length1 = 1;
#line 176 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp59_ = granite_markup_accel_tooltip (_tmp58_, (gint) 1, _ ("Open the Trash"));
#line 176 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp60_ = _tmp59_;
#line 176 "../src/View/Sidebar/BookmarkListBox.vala"
		gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp55_, _tmp60_);
#line 176 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_free0 (_tmp60_);
#line 176 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp58_ = (_vala_array_free (_tmp58_, _tmp58__length1, (GDestroyNotify) g_free), NULL);
#line 180 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp61_ = _data62_->row;
#line 180 "../src/View/Sidebar/BookmarkListBox.vala"
		sidebar_sidebar_item_interface_set_can_insert_before ((SidebarSidebarItemInterface*) _tmp61_, TRUE);
#line 181 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp62_ = _data62_->row;
#line 181 "../src/View/Sidebar/BookmarkListBox.vala"
		sidebar_sidebar_item_interface_set_can_insert_after ((SidebarSidebarItemInterface*) _tmp62_, FALSE);
#line 183 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp63_ = self->priv->trash_monitor;
#line 183 "../src/View/Sidebar/BookmarkListBox.vala"
		g_signal_connect_data ((GObject*) _tmp63_, "notify::is-empty", (GCallback) ____lambda168__g_object_notify, block62_data_ref (_data62_), (GClosureNotify) block62_data_unref, 0);
#line 986 "BookmarkListBox.c"
	}
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
	_g_free0 (home_uri);
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
	block62_data_unref (_data62_);
#line 115 "../src/View/Sidebar/BookmarkListBox.vala"
	_data62_ = NULL;
#line 994 "BookmarkListBox.c"
}

static void
sidebar_bookmark_list_box_real_rename_bookmark_by_uri (SidebarBookmarkListBox* self,
                                                       const gchar* uri,
                                                       const gchar* new_name)
{
	FilesBookmarkList* _tmp0_;
#line 189 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_if_fail (uri != NULL);
#line 189 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_if_fail (new_name != NULL);
#line 190 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = self->priv->bookmark_list;
#line 190 "../src/View/Sidebar/BookmarkListBox.vala"
	files_bookmark_list_rename_item_with_uri (_tmp0_, uri, new_name);
#line 1011 "BookmarkListBox.c"
}

void
sidebar_bookmark_list_box_rename_bookmark_by_uri (SidebarBookmarkListBox* self,
                                                  const gchar* uri,
                                                  const gchar* new_name)
{
	SidebarBookmarkListBoxClass* _klass_;
#line 189 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_if_fail (self != NULL);
#line 189 "../src/View/Sidebar/BookmarkListBox.vala"
	_klass_ = SIDEBAR_BOOKMARK_LIST_BOX_GET_CLASS (self);
#line 189 "../src/View/Sidebar/BookmarkListBox.vala"
	if (_klass_->rename_bookmark_by_uri) {
#line 189 "../src/View/Sidebar/BookmarkListBox.vala"
		_klass_->rename_bookmark_by_uri (self, uri, new_name);
#line 1028 "BookmarkListBox.c"
	}
}

static gboolean
sidebar_bookmark_list_box_real_add_favorite (SidebarSidebarListInterface* base,
                                             const gchar* uri,
                                             const gchar* custom_name,
                                             gint pos)
{
	SidebarBookmarkListBox * self;
	gint pinned = 0;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GList* _tmp2_;
	FilesBookmark* bm = NULL;
	FilesBookmarkList* _tmp7_;
	FilesBookmark* _tmp8_;
	FilesBookmark* _tmp9_;
	gboolean result;
#line 193 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) base;
#line 193 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 193 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (custom_name != NULL, FALSE);
#line 197 "../src/View/Sidebar/BookmarkListBox.vala"
	pinned = 0;
#line 198 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 198 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp1_ = _tmp0_;
#line 198 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp2_ = gtk_container_get_children ((GtkContainer*) _tmp1_);
#line 1062 "BookmarkListBox.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 198 "../src/View/Sidebar/BookmarkListBox.vala"
		child_collection = _tmp2_;
#line 198 "../src/View/Sidebar/BookmarkListBox.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 1070 "BookmarkListBox.c"
			GtkWidget* child = NULL;
#line 198 "../src/View/Sidebar/BookmarkListBox.vala"
			child = (GtkWidget*) child_it->data;
#line 1074 "BookmarkListBox.c"
			{
				GtkWidget* _tmp3_;
				gboolean _tmp4_;
				gboolean _tmp5_;
#line 199 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp3_ = child;
#line 199 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp4_ = sidebar_sidebar_item_interface_get_pinned ((SidebarSidebarItemInterface*) G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow));
#line 199 "../src/View/Sidebar/BookmarkListBox.vala"
				_tmp5_ = _tmp4_;
#line 199 "../src/View/Sidebar/BookmarkListBox.vala"
				if (_tmp5_) {
#line 1087 "BookmarkListBox.c"
					gint _tmp6_;
#line 200 "../src/View/Sidebar/BookmarkListBox.vala"
					_tmp6_ = pinned;
#line 200 "../src/View/Sidebar/BookmarkListBox.vala"
					pinned = _tmp6_ + 1;
#line 1093 "BookmarkListBox.c"
				} else {
#line 202 "../src/View/Sidebar/BookmarkListBox.vala"
					break;
#line 1097 "BookmarkListBox.c"
				}
			}
		}
#line 198 "../src/View/Sidebar/BookmarkListBox.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 1103 "BookmarkListBox.c"
	}
#line 206 "../src/View/Sidebar/BookmarkListBox.vala"
	if (pos < pinned) {
#line 207 "../src/View/Sidebar/BookmarkListBox.vala"
		pos = pinned;
#line 1109 "BookmarkListBox.c"
	}
#line 210 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp7_ = self->priv->bookmark_list;
#line 210 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp8_ = files_bookmark_list_insert_uri (_tmp7_, uri, (guint) (pos - pinned), custom_name);
#line 210 "../src/View/Sidebar/BookmarkListBox.vala"
	bm = _tmp8_;
#line 211 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp9_ = bm;
#line 211 "../src/View/Sidebar/BookmarkListBox.vala"
	if (_tmp9_ != NULL) {
#line 1121 "BookmarkListBox.c"
		FilesBookmark* _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		FilesBookmark* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		FilesBookmark* _tmp16_;
		GIcon* _tmp17_;
		GIcon* _tmp18_;
		SidebarBookmarkRow* _tmp19_;
		SidebarBookmarkRow* _tmp20_;
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp10_ = bm;
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp11_ = files_bookmark_get_custom_name (_tmp10_);
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp12_ = _tmp11_;
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp13_ = bm;
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp14_ = files_bookmark_get_uri (_tmp13_);
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp15_ = _tmp14_;
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp16_ = bm;
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp17_ = files_bookmark_get_icon (_tmp16_);
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp18_ = _tmp17_;
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp19_ = sidebar_bookmark_list_box_insert_bookmark (self, _tmp12_, _tmp15_, _tmp18_, pos, FALSE, FALSE);
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp20_ = _tmp19_;
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (_tmp20_);
#line 212 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (_tmp18_);
#line 213 "../src/View/Sidebar/BookmarkListBox.vala"
		result = TRUE;
#line 213 "../src/View/Sidebar/BookmarkListBox.vala"
		_files_bookmark_unref0 (bm);
#line 213 "../src/View/Sidebar/BookmarkListBox.vala"
		return result;
#line 1165 "BookmarkListBox.c"
	} else {
#line 215 "../src/View/Sidebar/BookmarkListBox.vala"
		result = FALSE;
#line 215 "../src/View/Sidebar/BookmarkListBox.vala"
		_files_bookmark_unref0 (bm);
#line 215 "../src/View/Sidebar/BookmarkListBox.vala"
		return result;
#line 1173 "BookmarkListBox.c"
	}
}

static Block64Data*
block64_data_ref (Block64Data* _data64_)
{
#line 219 "../src/View/Sidebar/BookmarkListBox.vala"
	g_atomic_int_inc (&_data64_->_ref_count_);
#line 219 "../src/View/Sidebar/BookmarkListBox.vala"
	return _data64_;
#line 1184 "BookmarkListBox.c"
}

static void
block64_data_unref (void * _userdata_)
{
	Block64Data* _data64_;
	_data64_ = (Block64Data*) _userdata_;
#line 219 "../src/View/Sidebar/BookmarkListBox.vala"
	if (g_atomic_int_dec_and_test (&_data64_->_ref_count_)) {
#line 1194 "BookmarkListBox.c"
		SidebarBookmarkListBox* self;
#line 219 "../src/View/Sidebar/BookmarkListBox.vala"
		self = _data64_->self;
#line 219 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (self);
#line 219 "../src/View/Sidebar/BookmarkListBox.vala"
		g_slice_free (Block64Data, _data64_);
#line 1202 "BookmarkListBox.c"
	}
}

static void
__lambda169_ (Block64Data* _data64_,
              GtkWidget* child)
{
	SidebarBookmarkListBox* self;
#line 221 "../src/View/Sidebar/BookmarkListBox.vala"
	self = _data64_->self;
#line 221 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_if_fail (child != NULL);
#line 222 "../src/View/Sidebar/BookmarkListBox.vala"
	if (SIDEBAR_IS_BOOKMARK_ROW (child)) {
#line 1217 "BookmarkListBox.c"
		SidebarBookmarkRow* row = NULL;
		gboolean _tmp0_ = FALSE;
		SidebarBookmarkRow* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 223 "../src/View/Sidebar/BookmarkListBox.vala"
		row = G_TYPE_CHECK_INSTANCE_CAST (child, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow);
#line 224 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp1_ = row;
#line 224 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp2_ = sidebar_sidebar_item_interface_get_permanent ((SidebarSidebarItemInterface*) _tmp1_);
#line 224 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp3_ = _tmp2_;
#line 224 "../src/View/Sidebar/BookmarkListBox.vala"
		if (!_tmp3_) {
#line 1233 "BookmarkListBox.c"
			SidebarBookmarkRow* _tmp4_;
			guint32 _tmp5_;
			guint32 _tmp6_;
#line 224 "../src/View/Sidebar/BookmarkListBox.vala"
			_tmp4_ = row;
#line 224 "../src/View/Sidebar/BookmarkListBox.vala"
			_tmp5_ = sidebar_sidebar_item_interface_get_id ((SidebarSidebarItemInterface*) _tmp4_);
#line 224 "../src/View/Sidebar/BookmarkListBox.vala"
			_tmp6_ = _tmp5_;
#line 224 "../src/View/Sidebar/BookmarkListBox.vala"
			_tmp0_ = _tmp6_ == _data64_->id;
#line 1245 "BookmarkListBox.c"
		} else {
#line 224 "../src/View/Sidebar/BookmarkListBox.vala"
			_tmp0_ = FALSE;
#line 1249 "BookmarkListBox.c"
		}
#line 224 "../src/View/Sidebar/BookmarkListBox.vala"
		if (_tmp0_) {
#line 1253 "BookmarkListBox.c"
			GtkListBox* _tmp7_;
			GtkListBox* _tmp8_;
			SidebarBookmarkRow* _tmp9_;
			FilesBookmarkList* _tmp10_;
			SidebarBookmarkRow* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
#line 225 "../src/View/Sidebar/BookmarkListBox.vala"
			_tmp7_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 225 "../src/View/Sidebar/BookmarkListBox.vala"
			_tmp8_ = _tmp7_;
#line 225 "../src/View/Sidebar/BookmarkListBox.vala"
			_tmp9_ = row;
#line 225 "../src/View/Sidebar/BookmarkListBox.vala"
			gtk_container_remove ((GtkContainer*) _tmp8_, (GtkWidget*) _tmp9_);
#line 226 "../src/View/Sidebar/BookmarkListBox.vala"
			_tmp10_ = self->priv->bookmark_list;
#line 226 "../src/View/Sidebar/BookmarkListBox.vala"
			_tmp11_ = row;
#line 226 "../src/View/Sidebar/BookmarkListBox.vala"
			_tmp12_ = sidebar_sidebar_item_interface_get_uri ((SidebarSidebarItemInterface*) _tmp11_);
#line 226 "../src/View/Sidebar/BookmarkListBox.vala"
			_tmp13_ = _tmp12_;
#line 226 "../src/View/Sidebar/BookmarkListBox.vala"
			files_bookmark_list_delete_items_with_uri (_tmp10_, _tmp13_);
#line 227 "../src/View/Sidebar/BookmarkListBox.vala"
			_data64_->removed = TRUE;
#line 1281 "BookmarkListBox.c"
		}
	}
}

static void
___lambda169__gtk_callback (GtkWidget* widget,
                            gpointer self)
{
#line 221 "../src/View/Sidebar/BookmarkListBox.vala"
	__lambda169_ (self, widget);
#line 1292 "BookmarkListBox.c"
}

static gboolean
sidebar_bookmark_list_box_real_remove_item_by_id (SidebarSidebarListInterface* base,
                                                  guint32 id)
{
	SidebarBookmarkListBox * self;
	Block64Data* _data64_;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	gboolean result;
#line 219 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) base;
#line 219 "../src/View/Sidebar/BookmarkListBox.vala"
	_data64_ = g_slice_new0 (Block64Data);
#line 219 "../src/View/Sidebar/BookmarkListBox.vala"
	_data64_->_ref_count_ = 1;
#line 219 "../src/View/Sidebar/BookmarkListBox.vala"
	_data64_->self = g_object_ref (self);
#line 219 "../src/View/Sidebar/BookmarkListBox.vala"
	_data64_->id = id;
#line 220 "../src/View/Sidebar/BookmarkListBox.vala"
	_data64_->removed = FALSE;
#line 221 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 221 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp1_ = _tmp0_;
#line 221 "../src/View/Sidebar/BookmarkListBox.vala"
	gtk_container_foreach ((GtkContainer*) _tmp1_, ___lambda169__gtk_callback, _data64_);
#line 232 "../src/View/Sidebar/BookmarkListBox.vala"
	result = _data64_->removed;
#line 232 "../src/View/Sidebar/BookmarkListBox.vala"
	block64_data_unref (_data64_);
#line 232 "../src/View/Sidebar/BookmarkListBox.vala"
	_data64_ = NULL;
#line 232 "../src/View/Sidebar/BookmarkListBox.vala"
	return result;
#line 1330 "BookmarkListBox.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 240 "../src/View/Sidebar/BookmarkListBox.vala"
	return self ? g_object_ref (self) : NULL;
#line 1338 "BookmarkListBox.c"
}

static SidebarSidebarItemInterface*
sidebar_bookmark_list_box_real_get_item_at_index (SidebarSidebarListInterface* base,
                                                  gint index)
{
	SidebarBookmarkListBox * self;
	gboolean _tmp0_ = FALSE;
	GtkListBox* _tmp5_;
	GtkListBox* _tmp6_;
	GtkListBoxRow* _tmp7_;
	SidebarSidebarItemInterface* _tmp8_;
	SidebarSidebarItemInterface* result;
#line 235 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) base;
#line 236 "../src/View/Sidebar/BookmarkListBox.vala"
	if (index < 0) {
#line 236 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp0_ = TRUE;
#line 1358 "BookmarkListBox.c"
	} else {
		GtkListBox* _tmp1_;
		GtkListBox* _tmp2_;
		GList* _tmp3_;
		GList* _tmp4_;
#line 236 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp1_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 236 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp2_ = _tmp1_;
#line 236 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp3_ = gtk_container_get_children ((GtkContainer*) _tmp2_);
#line 236 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp4_ = _tmp3_;
#line 236 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp0_ = ((guint) index) > g_list_length (_tmp4_);
#line 236 "../src/View/Sidebar/BookmarkListBox.vala"
		(_tmp4_ == NULL) ? NULL : (_tmp4_ = (g_list_free (_tmp4_), NULL));
#line 1376 "BookmarkListBox.c"
	}
#line 236 "../src/View/Sidebar/BookmarkListBox.vala"
	if (_tmp0_) {
#line 237 "../src/View/Sidebar/BookmarkListBox.vala"
		result = NULL;
#line 237 "../src/View/Sidebar/BookmarkListBox.vala"
		return result;
#line 1384 "BookmarkListBox.c"
	}
#line 240 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp5_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 240 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp6_ = _tmp5_;
#line 240 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp7_ = gtk_list_box_get_row_at_index (_tmp6_, index);
#line 240 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, SIDEBAR_TYPE_SIDEBAR_ITEM_INTERFACE, SidebarSidebarItemInterface));
#line 240 "../src/View/Sidebar/BookmarkListBox.vala"
	result = _tmp8_;
#line 240 "../src/View/Sidebar/BookmarkListBox.vala"
	return result;
#line 1398 "BookmarkListBox.c"
}

static gboolean
sidebar_bookmark_list_box_real_move_item_after (SidebarSidebarListInterface* base,
                                                SidebarSidebarItemInterface* item,
                                                gint target_index)
{
	SidebarBookmarkListBox * self;
	SidebarSidebarListInterface* _tmp0_;
	SidebarSidebarListInterface* _tmp1_;
	gint old_index = 0;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
	FilesBookmarkList* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gboolean result;
#line 243 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) base;
#line 243 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 244 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = sidebar_sidebar_item_interface_get_list (item);
#line 244 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp1_ = _tmp0_;
#line 244 "../src/View/Sidebar/BookmarkListBox.vala"
	if (_tmp1_ != G_TYPE_CHECK_INSTANCE_CAST (self, SIDEBAR_TYPE_SIDEBAR_LIST_INTERFACE, SidebarSidebarListInterface)) {
#line 245 "../src/View/Sidebar/BookmarkListBox.vala"
		result = FALSE;
#line 245 "../src/View/Sidebar/BookmarkListBox.vala"
		return result;
#line 1430 "BookmarkListBox.c"
	}
#line 248 "../src/View/Sidebar/BookmarkListBox.vala"
	old_index = sidebar_sidebar_item_interface_get_index (item);
#line 249 "../src/View/Sidebar/BookmarkListBox.vala"
	if (old_index == target_index) {
#line 250 "../src/View/Sidebar/BookmarkListBox.vala"
		result = FALSE;
#line 250 "../src/View/Sidebar/BookmarkListBox.vala"
		return result;
#line 1440 "BookmarkListBox.c"
	}
#line 253 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp2_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 253 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp3_ = _tmp2_;
#line 253 "../src/View/Sidebar/BookmarkListBox.vala"
	gtk_container_remove ((GtkContainer*) _tmp3_, (GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (item, gtk_list_box_row_get_type (), GtkListBoxRow));
#line 255 "../src/View/Sidebar/BookmarkListBox.vala"
	if (old_index > target_index) {
#line 1450 "BookmarkListBox.c"
		GtkListBox* _tmp4_;
		GtkListBox* _tmp5_;
		SidebarSidebarItemInterface* _tmp6_;
		gint _tmp7_;
#line 256 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp4_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 256 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp5_ = _tmp4_;
#line 256 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp6_ = item;
#line 256 "../src/View/Sidebar/BookmarkListBox.vala"
		target_index = target_index + 1;
#line 256 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp7_ = target_index;
#line 256 "../src/View/Sidebar/BookmarkListBox.vala"
		gtk_list_box_insert (_tmp5_, (GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, gtk_list_box_row_get_type (), GtkListBoxRow), _tmp7_);
#line 1467 "BookmarkListBox.c"
	} else {
		GtkListBox* _tmp8_;
		GtkListBox* _tmp9_;
#line 258 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp8_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 258 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp9_ = _tmp8_;
#line 258 "../src/View/Sidebar/BookmarkListBox.vala"
		gtk_list_box_insert (_tmp9_, (GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (item, gtk_list_box_row_get_type (), GtkListBoxRow), target_index);
#line 1477 "BookmarkListBox.c"
	}
#line 261 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp10_ = self->priv->bookmark_list;
#line 261 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp11_ = sidebar_sidebar_item_interface_get_uri (item);
#line 261 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp12_ = _tmp11_;
#line 261 "../src/View/Sidebar/BookmarkListBox.vala"
	files_bookmark_list_move_item_uri (_tmp10_, _tmp12_, target_index - old_index);
#line 263 "../src/View/Sidebar/BookmarkListBox.vala"
	result = TRUE;
#line 263 "../src/View/Sidebar/BookmarkListBox.vala"
	return result;
#line 1491 "BookmarkListBox.c"
}

static gboolean
sidebar_bookmark_list_box_real_is_drop_target (SidebarBookmarkListBox* self)
{
	gboolean result;
#line 266 "../src/View/Sidebar/BookmarkListBox.vala"
	result = TRUE;
#line 266 "../src/View/Sidebar/BookmarkListBox.vala"
	return result;
#line 1502 "BookmarkListBox.c"
}

gboolean
sidebar_bookmark_list_box_is_drop_target (SidebarBookmarkListBox* self)
{
	SidebarBookmarkListBoxClass* _klass_;
#line 266 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 266 "../src/View/Sidebar/BookmarkListBox.vala"
	_klass_ = SIDEBAR_BOOKMARK_LIST_BOX_GET_CLASS (self);
#line 266 "../src/View/Sidebar/BookmarkListBox.vala"
	if (_klass_->is_drop_target) {
#line 266 "../src/View/Sidebar/BookmarkListBox.vala"
		return _klass_->is_drop_target (self);
#line 1517 "BookmarkListBox.c"
	}
#line 266 "../src/View/Sidebar/BookmarkListBox.vala"
	return FALSE;
#line 1521 "BookmarkListBox.c"
}

static FilesSidebarInterface*
sidebar_bookmark_list_box_real_get_sidebar (SidebarSidebarListInterface* base)
{
	FilesSidebarInterface* result;
	SidebarBookmarkListBox* self;
	FilesSidebarInterface* _tmp0_;
#line 24 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) base;
#line 24 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = self->priv->_sidebar;
#line 24 "../src/View/Sidebar/BookmarkListBox.vala"
	result = _tmp0_;
#line 24 "../src/View/Sidebar/BookmarkListBox.vala"
	return result;
#line 1538 "BookmarkListBox.c"
}

static void
sidebar_bookmark_list_box_real_set_sidebar (SidebarSidebarListInterface* base,
                                            FilesSidebarInterface* value)
{
	SidebarBookmarkListBox* self;
	FilesSidebarInterface* old_value;
#line 24 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) base;
#line 24 "../src/View/Sidebar/BookmarkListBox.vala"
	old_value = sidebar_bookmark_list_box_real_get_sidebar (base);
#line 24 "../src/View/Sidebar/BookmarkListBox.vala"
	if (old_value != value) {
#line 1553 "BookmarkListBox.c"
		FilesSidebarInterface* _tmp0_;
#line 24 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 24 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (self->priv->_sidebar);
#line 24 "../src/View/Sidebar/BookmarkListBox.vala"
		self->priv->_sidebar = _tmp0_;
#line 24 "../src/View/Sidebar/BookmarkListBox.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_list_box_properties[SIDEBAR_BOOKMARK_LIST_BOX_SIDEBAR_PROPERTY]);
#line 1563 "BookmarkListBox.c"
	}
}

static GtkListBox*
sidebar_bookmark_list_box_real_get_list_box (SidebarSidebarListInterface* base)
{
	GtkListBox* result;
	SidebarBookmarkListBox* self;
	GtkListBox* _tmp0_;
#line 25 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) base;
#line 25 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = self->priv->_list_box;
#line 25 "../src/View/Sidebar/BookmarkListBox.vala"
	result = _tmp0_;
#line 25 "../src/View/Sidebar/BookmarkListBox.vala"
	return result;
#line 1581 "BookmarkListBox.c"
}

static void
sidebar_bookmark_list_box_real_set_list_box (SidebarSidebarListInterface* base,
                                             GtkListBox* value)
{
	SidebarBookmarkListBox* self;
	GtkListBox* old_value;
#line 25 "../src/View/Sidebar/BookmarkListBox.vala"
	self = (SidebarBookmarkListBox*) base;
#line 25 "../src/View/Sidebar/BookmarkListBox.vala"
	old_value = sidebar_bookmark_list_box_real_get_list_box (base);
#line 25 "../src/View/Sidebar/BookmarkListBox.vala"
	if (old_value != value) {
#line 1596 "BookmarkListBox.c"
		GtkListBox* _tmp0_;
#line 25 "../src/View/Sidebar/BookmarkListBox.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 25 "../src/View/Sidebar/BookmarkListBox.vala"
		_g_object_unref0 (self->priv->_list_box);
#line 25 "../src/View/Sidebar/BookmarkListBox.vala"
		self->priv->_list_box = _tmp0_;
#line 25 "../src/View/Sidebar/BookmarkListBox.vala"
		g_object_notify_by_pspec ((GObject *) self, sidebar_bookmark_list_box_properties[SIDEBAR_BOOKMARK_LIST_BOX_LIST_BOX_PROPERTY]);
#line 1606 "BookmarkListBox.c"
	}
}

static void
_sidebar_bookmark_list_box___lambda170_ (SidebarBookmarkListBox* self)
{
#line 45 "../src/View/Sidebar/BookmarkListBox.vala"
	sidebar_sidebar_list_interface_refresh ((SidebarSidebarListInterface*) self);
#line 1615 "BookmarkListBox.c"
}

static void
__sidebar_bookmark_list_box___lambda170__files_bookmark_list_loaded (FilesBookmarkList* _sender,
                                                                     gpointer self)
{
#line 44 "../src/View/Sidebar/BookmarkListBox.vala"
	_sidebar_bookmark_list_box___lambda170_ ((SidebarBookmarkListBox*) self);
#line 1624 "BookmarkListBox.c"
}

static void
_sidebar_bookmark_list_box___lambda171_ (SidebarBookmarkListBox* self,
                                         GtkListBoxRow* row)
{
#line 48 "../src/View/Sidebar/BookmarkListBox.vala"
	g_return_if_fail (row != NULL);
#line 49 "../src/View/Sidebar/BookmarkListBox.vala"
	if (SIDEBAR_IS_BOOKMARK_ROW (row)) {
#line 50 "../src/View/Sidebar/BookmarkListBox.vala"
		sidebar_sidebar_item_interface_activated ((SidebarSidebarItemInterface*) G_TYPE_CHECK_INSTANCE_CAST (row, SIDEBAR_TYPE_BOOKMARK_ROW, SidebarBookmarkRow), FILES_OPEN_FLAG_DEFAULT);
#line 1637 "BookmarkListBox.c"
	}
}

static void
__sidebar_bookmark_list_box___lambda171__gtk_list_box_row_activated (GtkListBox* _sender,
                                                                     GtkListBoxRow* row,
                                                                     gpointer self)
{
#line 48 "../src/View/Sidebar/BookmarkListBox.vala"
	_sidebar_bookmark_list_box___lambda171_ ((SidebarBookmarkListBox*) self, row);
#line 1648 "BookmarkListBox.c"
}

static void
_sidebar_bookmark_list_box___lambda172_ (SidebarBookmarkListBox* self,
                                         GtkListBoxRow* row)
{
#line 55 "../src/View/Sidebar/BookmarkListBox.vala"
	if (SIDEBAR_IS_BOOKMARK_ROW (row)) {
#line 56 "../src/View/Sidebar/BookmarkListBox.vala"
		sidebar_sidebar_list_interface_select_item ((SidebarSidebarListInterface*) self, row);
#line 1659 "BookmarkListBox.c"
	}
}

static void
__sidebar_bookmark_list_box___lambda172__gtk_list_box_row_selected (GtkListBox* _sender,
                                                                    GtkListBoxRow* row,
                                                                    gpointer self)
{
#line 54 "../src/View/Sidebar/BookmarkListBox.vala"
	_sidebar_bookmark_list_box___lambda172_ ((SidebarBookmarkListBox*) self, row);
#line 1670 "BookmarkListBox.c"
}

static GObject *
sidebar_bookmark_list_box_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SidebarBookmarkListBox * self;
	GtkListBox* _tmp0_ = NULL;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
	FilesTrashMonitor* _tmp4_;
	FilesBookmarkList* _tmp5_;
	FilesBookmarkList* _tmp6_;
	GtkListBox* _tmp7_;
	GtkListBox* _tmp8_;
	GtkListBox* _tmp9_;
	GtkListBox* _tmp10_;
#line 34 "../src/View/Sidebar/BookmarkListBox.vala"
	parent_class = G_OBJECT_CLASS (sidebar_bookmark_list_box_parent_class);
#line 34 "../src/View/Sidebar/BookmarkListBox.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 34 "../src/View/Sidebar/BookmarkListBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SIDEBAR_TYPE_BOOKMARK_LIST_BOX, SidebarBookmarkListBox);
#line 35 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp0_ = (GtkListBox*) gtk_list_box_new ();
#line 35 "../src/View/Sidebar/BookmarkListBox.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp0_, TRUE);
#line 35 "../src/View/Sidebar/BookmarkListBox.vala"
	gtk_list_box_set_selection_mode (_tmp0_, GTK_SELECTION_SINGLE);
#line 35 "../src/View/Sidebar/BookmarkListBox.vala"
	g_object_ref_sink (_tmp0_);
#line 35 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp1_ = _tmp0_;
#line 35 "../src/View/Sidebar/BookmarkListBox.vala"
	sidebar_sidebar_list_interface_set_list_box ((SidebarSidebarListInterface*) self, _tmp1_);
#line 35 "../src/View/Sidebar/BookmarkListBox.vala"
	_g_object_unref0 (_tmp1_);
#line 40 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp2_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 40 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp3_ = _tmp2_;
#line 40 "../src/View/Sidebar/BookmarkListBox.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp3_);
#line 42 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp4_ = files_trash_monitor_get_default ();
#line 42 "../src/View/Sidebar/BookmarkListBox.vala"
	self->priv->trash_monitor = _tmp4_;
#line 43 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp5_ = files_bookmark_list_get_instance ();
#line 43 "../src/View/Sidebar/BookmarkListBox.vala"
	_g_object_unref0 (self->priv->bookmark_list);
#line 43 "../src/View/Sidebar/BookmarkListBox.vala"
	self->priv->bookmark_list = _tmp5_;
#line 44 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp6_ = self->priv->bookmark_list;
#line 44 "../src/View/Sidebar/BookmarkListBox.vala"
	g_signal_connect_object (_tmp6_, "loaded", (GCallback) __sidebar_bookmark_list_box___lambda170__files_bookmark_list_loaded, self, 0);
#line 48 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp7_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 48 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp8_ = _tmp7_;
#line 48 "../src/View/Sidebar/BookmarkListBox.vala"
	g_signal_connect_object (_tmp8_, "row-activated", (GCallback) __sidebar_bookmark_list_box___lambda171__gtk_list_box_row_activated, self, 0);
#line 54 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp9_ = sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self);
#line 54 "../src/View/Sidebar/BookmarkListBox.vala"
	_tmp10_ = _tmp9_;
#line 54 "../src/View/Sidebar/BookmarkListBox.vala"
	g_signal_connect_object (_tmp10_, "row-selected", (GCallback) __sidebar_bookmark_list_box___lambda172__gtk_list_box_row_selected, self, 0);
#line 34 "../src/View/Sidebar/BookmarkListBox.vala"
	return obj;
#line 1746 "BookmarkListBox.c"
}

static void
sidebar_bookmark_list_box_class_init (SidebarBookmarkListBoxClass * klass,
                                      gpointer klass_data)
{
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	sidebar_bookmark_list_box_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	g_type_class_adjust_private_offset (klass, &SidebarBookmarkListBox_private_offset);
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	((SidebarBookmarkListBoxClass *) klass)->rename_bookmark_by_uri = (void (*) (SidebarBookmarkListBox*, const gchar*, const gchar*)) sidebar_bookmark_list_box_real_rename_bookmark_by_uri;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	((SidebarBookmarkListBoxClass *) klass)->is_drop_target = (gboolean (*) (SidebarBookmarkListBox*)) sidebar_bookmark_list_box_real_is_drop_target;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sidebar_bookmark_list_box_get_property;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sidebar_bookmark_list_box_set_property;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	G_OBJECT_CLASS (klass)->constructor = sidebar_bookmark_list_box_constructor;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	G_OBJECT_CLASS (klass)->finalize = sidebar_bookmark_list_box_finalize;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_LIST_BOX_SIDEBAR_PROPERTY, sidebar_bookmark_list_box_properties[SIDEBAR_BOOKMARK_LIST_BOX_SIDEBAR_PROPERTY] = g_param_spec_object ("sidebar", "sidebar", "sidebar", FILES_TYPE_SIDEBAR_INTERFACE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIDEBAR_BOOKMARK_LIST_BOX_LIST_BOX_PROPERTY, sidebar_bookmark_list_box_properties[SIDEBAR_BOOKMARK_LIST_BOX_LIST_BOX_PROPERTY] = g_param_spec_object ("list-box", "list-box", "list-box", gtk_list_box_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 1773 "BookmarkListBox.c"
}

static void
sidebar_bookmark_list_box_sidebar_sidebar_list_interface_interface_init (SidebarSidebarListInterfaceIface * iface,
                                                                         gpointer iface_data)
{
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	sidebar_bookmark_list_box_sidebar_sidebar_list_interface_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->add_plugin_item = (guint32 (*) (SidebarSidebarListInterface*, FilesSidebarPluginItem*)) sidebar_bookmark_list_box_real_add_plugin_item;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->select_item = (void (*) (SidebarSidebarListInterface*, GtkListBoxRow*)) sidebar_bookmark_list_box_real_select_item;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->unselect_all_items = (void (*) (SidebarSidebarListInterface*)) sidebar_bookmark_list_box_real_unselect_all_items;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->refresh = (void (*) (SidebarSidebarListInterface*)) sidebar_bookmark_list_box_real_refresh;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->rename_bookmark_by_uri = (void (*) (SidebarSidebarListInterface*, const gchar*, const gchar*)) sidebar_bookmark_list_box_rename_bookmark_by_uri;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->add_favorite = (gboolean (*) (SidebarSidebarListInterface*, const gchar*, const gchar*, gint)) sidebar_bookmark_list_box_real_add_favorite;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->remove_item_by_id = (gboolean (*) (SidebarSidebarListInterface*, guint32)) sidebar_bookmark_list_box_real_remove_item_by_id;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->get_item_at_index = (SidebarSidebarItemInterface* (*) (SidebarSidebarListInterface*, gint)) sidebar_bookmark_list_box_real_get_item_at_index;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->move_item_after = (gboolean (*) (SidebarSidebarListInterface*, SidebarSidebarItemInterface*, gint)) sidebar_bookmark_list_box_real_move_item_after;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->is_drop_target = (gboolean (*) (SidebarSidebarListInterface*)) sidebar_bookmark_list_box_is_drop_target;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->get_sidebar = sidebar_bookmark_list_box_real_get_sidebar;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->set_sidebar = sidebar_bookmark_list_box_real_set_sidebar;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->get_list_box = sidebar_bookmark_list_box_real_get_list_box;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	iface->set_list_box = sidebar_bookmark_list_box_real_set_list_box;
#line 1810 "BookmarkListBox.c"
}

static void
sidebar_bookmark_list_box_instance_init (SidebarBookmarkListBox * self,
                                         gpointer klass)
{
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	self->priv = sidebar_bookmark_list_box_get_instance_private (self);
#line 1819 "BookmarkListBox.c"
}

static void
sidebar_bookmark_list_box_finalize (GObject * obj)
{
	SidebarBookmarkListBox * self;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SIDEBAR_TYPE_BOOKMARK_LIST_BOX, SidebarBookmarkListBox);
#line 24 "../src/View/Sidebar/BookmarkListBox.vala"
	_g_object_unref0 (self->priv->_sidebar);
#line 25 "../src/View/Sidebar/BookmarkListBox.vala"
	_g_object_unref0 (self->priv->_list_box);
#line 27 "../src/View/Sidebar/BookmarkListBox.vala"
	_g_object_unref0 (self->priv->bookmark_list);
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	G_OBJECT_CLASS (sidebar_bookmark_list_box_parent_class)->finalize (obj);
#line 1836 "BookmarkListBox.c"
}

 G_GNUC_NO_INLINE static GType
sidebar_bookmark_list_box_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SidebarBookmarkListBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sidebar_bookmark_list_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SidebarBookmarkListBox), 0, (GInstanceInitFunc) sidebar_bookmark_list_box_instance_init, NULL };
	static const GInterfaceInfo sidebar_sidebar_list_interface_info = { (GInterfaceInitFunc) sidebar_bookmark_list_box_sidebar_sidebar_list_interface_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType sidebar_bookmark_list_box_type_id;
	sidebar_bookmark_list_box_type_id = g_type_register_static (gtk_box_get_type (), "SidebarBookmarkListBox", &g_define_type_info, 0);
	g_type_add_interface_static (sidebar_bookmark_list_box_type_id, SIDEBAR_TYPE_SIDEBAR_LIST_INTERFACE, &sidebar_sidebar_list_interface_info);
	SidebarBookmarkListBox_private_offset = g_type_add_instance_private (sidebar_bookmark_list_box_type_id, sizeof (SidebarBookmarkListBoxPrivate));
	return sidebar_bookmark_list_box_type_id;
}

GType
sidebar_bookmark_list_box_get_type (void)
{
	static volatile gsize sidebar_bookmark_list_box_type_id__once = 0;
	if (g_once_init_enter (&sidebar_bookmark_list_box_type_id__once)) {
		GType sidebar_bookmark_list_box_type_id;
		sidebar_bookmark_list_box_type_id = sidebar_bookmark_list_box_get_type_once ();
		g_once_init_leave (&sidebar_bookmark_list_box_type_id__once, sidebar_bookmark_list_box_type_id);
	}
	return sidebar_bookmark_list_box_type_id__once;
}

static void
_vala_sidebar_bookmark_list_box_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec)
{
	SidebarBookmarkListBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SIDEBAR_TYPE_BOOKMARK_LIST_BOX, SidebarBookmarkListBox);
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	switch (property_id) {
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		case SIDEBAR_BOOKMARK_LIST_BOX_SIDEBAR_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		g_value_set_object (value, sidebar_sidebar_list_interface_get_sidebar ((SidebarSidebarListInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		case SIDEBAR_BOOKMARK_LIST_BOX_LIST_BOX_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		g_value_set_object (value, sidebar_sidebar_list_interface_get_list_box ((SidebarSidebarListInterface*) self));
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		break;
#line 1885 "BookmarkListBox.c"
		default:
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		break;
#line 1891 "BookmarkListBox.c"
	}
}

static void
_vala_sidebar_bookmark_list_box_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec)
{
	SidebarBookmarkListBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SIDEBAR_TYPE_BOOKMARK_LIST_BOX, SidebarBookmarkListBox);
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
	switch (property_id) {
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		case SIDEBAR_BOOKMARK_LIST_BOX_SIDEBAR_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		sidebar_sidebar_list_interface_set_sidebar ((SidebarSidebarListInterface*) self, g_value_get_object (value));
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		break;
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		case SIDEBAR_BOOKMARK_LIST_BOX_LIST_BOX_PROPERTY:
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		sidebar_sidebar_list_interface_set_list_box ((SidebarSidebarListInterface*) self, g_value_get_object (value));
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		break;
#line 1917 "BookmarkListBox.c"
		default:
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/View/Sidebar/BookmarkListBox.vala"
		break;
#line 1923 "BookmarkListBox.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

