/* AppMenu.c generated by valac 0.56.14, the Vala compiler
 * generated from AppMenu.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0
 * SPDX-FileCopyrightText: 2020-2023 elementary, Inc. (https://elementary.io)
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "pantheon-files-core.h"
#include <glib/gi18n-lib.h>
#include <granite.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FILES_TYPE_APP_MENU (files_app_menu_get_type ())
#define FILES_APP_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_APP_MENU, FilesAppMenu))
#define FILES_APP_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_APP_MENU, FilesAppMenuClass))
#define FILES_IS_APP_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_APP_MENU))
#define FILES_IS_APP_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_APP_MENU))
#define FILES_APP_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_APP_MENU, FilesAppMenuClass))

typedef struct _FilesAppMenu FilesAppMenu;
typedef struct _FilesAppMenuClass FilesAppMenuClass;
typedef struct _FilesAppMenuPrivate FilesAppMenuPrivate;
enum  {
	FILES_APP_MENU_0_PROPERTY,
	FILES_APP_MENU_NUM_PROPERTIES
};
static GParamSpec* files_app_menu_properties[FILES_APP_MENU_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _FilesAppMenu {
	GtkPopover parent_instance;
	FilesAppMenuPrivate * priv;
};

struct _FilesAppMenuClass {
	GtkPopoverClass parent_class;
};

struct _FilesAppMenuPrivate {
	GtkButton* redo_button;
	GtkButton* undo_button;
	GtkButton* zoom_default_button;
	GtkButton* zoom_in_button;
	GtkButton* zoom_out_button;
	gchar** redo_accels;
	gint redo_accels_length1;
	gint _redo_accels_size_;
	gchar** undo_accels;
	gint undo_accels_length1;
	gint _undo_accels_size_;
	FilesUndoManager* undo_manager;
};

static gint FilesAppMenu_private_offset;
static gpointer files_app_menu_parent_class = NULL;
VALA_EXTERN GSettings* files_icon_view_settings;
VALA_EXTERN GSettings* files_list_view_settings;
VALA_EXTERN GSettings* files_column_view_settings;

VALA_EXTERN GType files_app_menu_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesAppMenu, g_object_unref)
static void files_app_menu_set_undo_redo_tooltips (FilesAppMenu* self);
VALA_EXTERN void files_app_menu_on_zoom_setting_changed (FilesAppMenu* self,
                                             GSettings* settings,
                                             const gchar* key);
VALA_EXTERN FilesAppMenu* files_app_menu_new (void);
VALA_EXTERN FilesAppMenu* files_app_menu_construct (GType object_type);
static GObject * files_app_menu_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static GVariant* _variant_new21 (const gchar* value);
static GVariant* _variant_new22 (const gchar* value);
static GVariant* _variant_new23 (const gchar* value);
static void _files_app_menu_set_undo_redo_tooltips_files_undo_manager_request_menu_update (FilesUndoManager* _sender,
                                                                                    gpointer self);
static void _files_app_menu_on_zoom_setting_changed_g_settings_changed (GSettings* _sender,
                                                                 const gchar* key,
                                                                 gpointer self);
static void files_app_menu_finalize (GObject * obj);
static GType files_app_menu_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
files_app_menu_get_instance_private (FilesAppMenu* self)
{
	return G_STRUCT_MEMBER_P (self, FilesAppMenu_private_offset);
}

static void
files_app_menu_set_undo_redo_tooltips (FilesAppMenu* self)
{
	const gchar* undo_action_s = NULL;
	FilesUndoManager* _tmp0_;
	const gchar* _tmp1_;
	const gchar* redo_action_s = NULL;
	FilesUndoManager* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	GtkButton* _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_ = NULL;
	const gchar* _tmp12_;
	GtkButton* _tmp14_;
	gchar** _tmp15_;
	gint _tmp15__length1;
	gchar* _tmp16_;
	gchar* _tmp17_;
#line 139 "../src/View/Widgets/AppMenu.vala"
	g_return_if_fail (self != NULL);
#line 140 "../src/View/Widgets/AppMenu.vala"
	_tmp0_ = self->priv->undo_manager;
#line 140 "../src/View/Widgets/AppMenu.vala"
	_tmp1_ = files_undo_manager_get_next_undo_description (_tmp0_);
#line 140 "../src/View/Widgets/AppMenu.vala"
	undo_action_s = _tmp1_;
#line 141 "../src/View/Widgets/AppMenu.vala"
	_tmp2_ = self->priv->undo_manager;
#line 141 "../src/View/Widgets/AppMenu.vala"
	_tmp3_ = files_undo_manager_get_next_redo_description (_tmp2_);
#line 141 "../src/View/Widgets/AppMenu.vala"
	redo_action_s = _tmp3_;
#line 145 "../src/View/Widgets/AppMenu.vala"
	_tmp5_ = undo_action_s;
#line 145 "../src/View/Widgets/AppMenu.vala"
	if (_tmp5_ != NULL) {
#line 157 "AppMenu.c"
		const gchar* _tmp6_;
#line 146 "../src/View/Widgets/AppMenu.vala"
		_tmp6_ = undo_action_s;
#line 146 "../src/View/Widgets/AppMenu.vala"
		_tmp4_ = _tmp6_;
#line 163 "AppMenu.c"
	} else {
#line 147 "../src/View/Widgets/AppMenu.vala"
		_tmp4_ = _ ("No operation to undo");
#line 167 "AppMenu.c"
	}
#line 143 "../src/View/Widgets/AppMenu.vala"
	_tmp7_ = self->priv->undo_button;
#line 143 "../src/View/Widgets/AppMenu.vala"
	_tmp8_ = self->priv->undo_accels;
#line 143 "../src/View/Widgets/AppMenu.vala"
	_tmp8__length1 = self->priv->undo_accels_length1;
#line 143 "../src/View/Widgets/AppMenu.vala"
	_tmp9_ = granite_markup_accel_tooltip (_tmp8_, (gint) _tmp8__length1, _tmp4_);
#line 143 "../src/View/Widgets/AppMenu.vala"
	_tmp10_ = _tmp9_;
#line 143 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp7_, _tmp10_);
#line 143 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp10_);
#line 152 "../src/View/Widgets/AppMenu.vala"
	_tmp12_ = redo_action_s;
#line 152 "../src/View/Widgets/AppMenu.vala"
	if (_tmp12_ != NULL) {
#line 187 "AppMenu.c"
		const gchar* _tmp13_;
#line 153 "../src/View/Widgets/AppMenu.vala"
		_tmp13_ = redo_action_s;
#line 153 "../src/View/Widgets/AppMenu.vala"
		_tmp11_ = _tmp13_;
#line 193 "AppMenu.c"
	} else {
#line 154 "../src/View/Widgets/AppMenu.vala"
		_tmp11_ = _ ("No operation to redo");
#line 197 "AppMenu.c"
	}
#line 150 "../src/View/Widgets/AppMenu.vala"
	_tmp14_ = self->priv->redo_button;
#line 150 "../src/View/Widgets/AppMenu.vala"
	_tmp15_ = self->priv->redo_accels;
#line 150 "../src/View/Widgets/AppMenu.vala"
	_tmp15__length1 = self->priv->redo_accels_length1;
#line 150 "../src/View/Widgets/AppMenu.vala"
	_tmp16_ = granite_markup_accel_tooltip (_tmp15_, (gint) _tmp15__length1, _tmp11_);
#line 150 "../src/View/Widgets/AppMenu.vala"
	_tmp17_ = _tmp16_;
#line 150 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp14_, _tmp17_);
#line 150 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp17_);
#line 213 "AppMenu.c"
}

void
files_app_menu_on_zoom_setting_changed (FilesAppMenu* self,
                                        GSettings* settings,
                                        const gchar* key)
{
	FilesZoomLevel default_zoom = 0;
	FilesZoomLevel zoom_level = 0;
	GtkButton* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint max_zoom = 0;
	gint min_zoom = 0;
	GtkButton* _tmp4_;
	GtkButton* _tmp5_;
#line 158 "../src/View/Widgets/AppMenu.vala"
	g_return_if_fail (self != NULL);
#line 158 "../src/View/Widgets/AppMenu.vala"
	g_return_if_fail (settings != NULL);
#line 158 "../src/View/Widgets/AppMenu.vala"
	g_return_if_fail (key != NULL);
#line 159 "../src/View/Widgets/AppMenu.vala"
	if (settings == NULL) {
#line 238 "AppMenu.c"
		GtkButton* _tmp0_;
#line 160 "../src/View/Widgets/AppMenu.vala"
		g_critical ("AppMenu.vala:160: Zoom string from settinggs: Null settings");
#line 161 "../src/View/Widgets/AppMenu.vala"
		_tmp0_ = self->priv->zoom_default_button;
#line 161 "../src/View/Widgets/AppMenu.vala"
		gtk_button_set_label (_tmp0_, "");
#line 162 "../src/View/Widgets/AppMenu.vala"
		return;
#line 248 "AppMenu.c"
	}
#line 165 "../src/View/Widgets/AppMenu.vala"
	default_zoom = (FilesZoomLevel) g_settings_get_enum (settings, "default-zoom-level");
#line 166 "../src/View/Widgets/AppMenu.vala"
	zoom_level = (FilesZoomLevel) g_settings_get_enum (settings, "zoom-level");
#line 167 "../src/View/Widgets/AppMenu.vala"
	_tmp1_ = self->priv->zoom_default_button;
#line 167 "../src/View/Widgets/AppMenu.vala"
	_tmp2_ = g_strdup_printf ("%.0f%%", (((gdouble) files_zoom_level_to_icon_size (zoom_level)) / ((gdouble) files_zoom_level_to_icon_size (default_zoom))) * 100);
#line 167 "../src/View/Widgets/AppMenu.vala"
	_tmp3_ = _tmp2_;
#line 167 "../src/View/Widgets/AppMenu.vala"
	gtk_button_set_label (_tmp1_, _tmp3_);
#line 167 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp3_);
#line 169 "../src/View/Widgets/AppMenu.vala"
	max_zoom = g_settings_get_enum (settings, "maximum-zoom-level");
#line 170 "../src/View/Widgets/AppMenu.vala"
	min_zoom = g_settings_get_enum (settings, "minimum-zoom-level");
#line 172 "../src/View/Widgets/AppMenu.vala"
	_tmp4_ = self->priv->zoom_in_button;
#line 172 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, zoom_level < max_zoom);
#line 173 "../src/View/Widgets/AppMenu.vala"
	_tmp5_ = self->priv->zoom_out_button;
#line 173 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, zoom_level > min_zoom);
#line 276 "AppMenu.c"
}

FilesAppMenu*
files_app_menu_construct (GType object_type)
{
	FilesAppMenu * self = NULL;
#line 6 "../src/View/Widgets/AppMenu.vala"
	self = (FilesAppMenu*) g_object_new (object_type, NULL);
#line 6 "../src/View/Widgets/AppMenu.vala"
	return self;
#line 287 "AppMenu.c"
}

FilesAppMenu*
files_app_menu_new (void)
{
#line 6 "../src/View/Widgets/AppMenu.vala"
	return files_app_menu_construct (FILES_TYPE_APP_MENU);
#line 295 "AppMenu.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 17 "../src/View/Widgets/AppMenu.vala"
	return self ? g_object_ref (self) : NULL;
#line 303 "AppMenu.c"
}

static GVariant*
_variant_new21 (const gchar* value)
{
#line 19 "../src/View/Widgets/AppMenu.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 311 "AppMenu.c"
}

static GVariant*
_variant_new22 (const gchar* value)
{
#line 28 "../src/View/Widgets/AppMenu.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 319 "AppMenu.c"
}

static GVariant*
_variant_new23 (const gchar* value)
{
#line 37 "../src/View/Widgets/AppMenu.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 327 "AppMenu.c"
}

static void
_files_app_menu_set_undo_redo_tooltips_files_undo_manager_request_menu_update (FilesUndoManager* _sender,
                                                                               gpointer self)
{
#line 129 "../src/View/Widgets/AppMenu.vala"
	files_app_menu_set_undo_redo_tooltips ((FilesAppMenu*) self);
#line 336 "AppMenu.c"
}

static void
_files_app_menu_on_zoom_setting_changed_g_settings_changed (GSettings* _sender,
                                                            const gchar* key,
                                                            gpointer self)
{
#line 134 "../src/View/Widgets/AppMenu.vala"
	files_app_menu_on_zoom_setting_changed ((FilesAppMenu*) self, _sender, key);
#line 346 "AppMenu.c"
}

static GObject *
files_app_menu_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FilesAppMenu * self;
	GtkApplication* app_instance = NULL;
	GApplication* _tmp0_;
	GtkApplication* _tmp1_;
	gchar* _tmp2_;
	GVariant* _tmp3_;
	GtkButton* _tmp4_ = NULL;
	GtkButton* _tmp5_;
	GtkApplication* _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GVariant* _tmp13_;
	GtkButton* _tmp14_ = NULL;
	GtkButton* _tmp15_;
	GtkApplication* _tmp16_;
	gchar** _tmp17_;
	gchar** _tmp18_;
	gchar** _tmp19_;
	gint _tmp19__length1;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GVariant* _tmp23_;
	GtkButton* _tmp24_ = NULL;
	GtkButton* _tmp25_;
	GtkApplication* _tmp26_;
	gchar** _tmp27_;
	gchar** _tmp28_;
	gchar** _tmp29_;
	gint _tmp29__length1;
	gchar* _tmp30_;
	gchar* _tmp31_;
	GtkBox* icon_size_box = NULL;
	GtkBox* _tmp32_ = NULL;
	GtkBox* _tmp33_;
	GtkStyleContext* _tmp34_;
	GtkBox* _tmp35_;
	GtkButton* _tmp36_;
	GtkBox* _tmp37_;
	GtkButton* _tmp38_;
	GtkBox* _tmp39_;
	GtkButton* _tmp40_;
	GtkBox* undo_redo_box = NULL;
	GtkBox* _tmp41_ = NULL;
	GtkBox* _tmp42_;
	GtkStyleContext* _tmp43_;
	gchar* _tmp44_;
	GtkButton* _tmp45_ = NULL;
	gchar* _tmp46_;
	GtkButton* _tmp47_ = NULL;
	GtkBox* _tmp48_;
	GtkButton* _tmp49_;
	GtkBox* _tmp50_;
	GtkButton* _tmp51_;
	GtkApplication* _tmp52_;
	gchar** _tmp53_;
	gchar** _tmp54_;
	GtkApplication* _tmp55_;
	gchar** _tmp56_;
	gchar** _tmp57_;
	GraniteSwitchModelButton* double_click_button = NULL;
	gchar* _tmp58_;
	gchar* _tmp59_;
	GraniteSwitchModelButton* _tmp60_ = NULL;
	GraniteSwitchModelButton* foldes_before_files = NULL;
	gchar* _tmp61_;
	GraniteSwitchModelButton* _tmp62_ = NULL;
	GraniteHeaderLabel* show_header = NULL;
	GraniteHeaderLabel* _tmp63_;
	GtkCheckButton* show_hidden_button = NULL;
	gchar* _tmp64_;
	GtkCheckButton* _tmp65_ = NULL;
	GtkCheckButton* _tmp66_;
	GtkStyleContext* _tmp67_;
	GtkCheckButton* _tmp68_;
	GraniteAccelLabel* _tmp69_;
	GraniteAccelLabel* _tmp70_;
	GtkCheckButton* show_local_thumbnails = NULL;
	gchar* _tmp71_;
	GtkCheckButton* _tmp72_ = NULL;
	GtkCheckButton* _tmp73_;
	GtkStyleContext* _tmp74_;
	GtkCheckButton* show_remote_thumbnails = NULL;
	gchar* _tmp75_;
	GtkCheckButton* _tmp76_ = NULL;
	GtkCheckButton* _tmp77_;
	GtkStyleContext* _tmp78_;
	GtkBox* menu_box = NULL;
	GtkBox* _tmp79_ = NULL;
	GtkBox* _tmp80_;
	GtkBox* _tmp81_;
	GtkBox* _tmp82_;
	GtkBox* _tmp83_;
	GtkBox* _tmp84_;
	GtkSeparator* _tmp85_ = NULL;
	GtkSeparator* _tmp86_;
	GtkBox* _tmp87_;
	GraniteSwitchModelButton* _tmp88_;
	GtkBox* _tmp89_;
	GraniteSwitchModelButton* _tmp90_;
	GtkBox* _tmp91_;
	GtkSeparator* _tmp92_ = NULL;
	GtkSeparator* _tmp93_;
	GtkBox* _tmp94_;
	GraniteHeaderLabel* _tmp95_;
	GtkBox* _tmp96_;
	GtkCheckButton* _tmp97_;
	GtkBox* _tmp98_;
	GtkCheckButton* _tmp99_;
	GtkBox* _tmp100_;
	GtkCheckButton* _tmp101_;
	GtkBox* _tmp102_;
	GtkBox* _tmp103_;
	FilesUndoManager* _tmp104_;
	FilesUndoManager* _tmp105_;
	GSettings* _tmp106_;
	GSettings* _tmp107_;
	GSettings* _tmp108_;
#line 16 "../src/View/Widgets/AppMenu.vala"
	parent_class = G_OBJECT_CLASS (files_app_menu_parent_class);
#line 16 "../src/View/Widgets/AppMenu.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 16 "../src/View/Widgets/AppMenu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_TYPE_APP_MENU, FilesAppMenu);
#line 17 "../src/View/Widgets/AppMenu.vala"
	_tmp0_ = g_application_get_default ();
#line 17 "../src/View/Widgets/AppMenu.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_application_get_type (), GtkApplication));
#line 17 "../src/View/Widgets/AppMenu.vala"
	app_instance = _tmp1_;
#line 19 "../src/View/Widgets/AppMenu.vala"
	_tmp2_ = g_strdup ("win.zoom");
#line 19 "../src/View/Widgets/AppMenu.vala"
	_tmp3_ = _variant_new21 ("ZOOM_OUT");
#line 19 "../src/View/Widgets/AppMenu.vala"
	_tmp4_ = (GtkButton*) gtk_button_new_from_icon_name ("zoom-out-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 19 "../src/View/Widgets/AppMenu.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp4_, _tmp2_);
#line 19 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp2_);
#line 19 "../src/View/Widgets/AppMenu.vala"
	g_object_set ((GtkActionable*) _tmp4_, "action-target", _tmp3_, NULL);
#line 19 "../src/View/Widgets/AppMenu.vala"
	_g_variant_unref0 (_tmp3_);
#line 19 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp4_);
#line 19 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (self->priv->zoom_out_button);
#line 19 "../src/View/Widgets/AppMenu.vala"
	self->priv->zoom_out_button = _tmp4_;
#line 23 "../src/View/Widgets/AppMenu.vala"
	_tmp5_ = self->priv->zoom_out_button;
#line 23 "../src/View/Widgets/AppMenu.vala"
	_tmp6_ = app_instance;
#line 23 "../src/View/Widgets/AppMenu.vala"
	_tmp8_ = _tmp7_ = gtk_application_get_accels_for_action (_tmp6_, "win.zoom::ZOOM_OUT");
#line 23 "../src/View/Widgets/AppMenu.vala"
	_tmp9_ = _tmp8_;
#line 23 "../src/View/Widgets/AppMenu.vala"
	_tmp9__length1 = _vala_array_length (_tmp7_);
#line 23 "../src/View/Widgets/AppMenu.vala"
	_tmp10_ = granite_markup_accel_tooltip (_tmp9_, (gint) _vala_array_length (_tmp7_), _ ("Zoom Out"));
#line 23 "../src/View/Widgets/AppMenu.vala"
	_tmp11_ = _tmp10_;
#line 23 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp5_, _tmp11_);
#line 23 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp11_);
#line 23 "../src/View/Widgets/AppMenu.vala"
	_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
#line 28 "../src/View/Widgets/AppMenu.vala"
	_tmp12_ = g_strdup ("win.zoom");
#line 28 "../src/View/Widgets/AppMenu.vala"
	_tmp13_ = _variant_new22 ("ZOOM_NORMAL");
#line 28 "../src/View/Widgets/AppMenu.vala"
	_tmp14_ = (GtkButton*) gtk_button_new_with_label ("100%");
#line 28 "../src/View/Widgets/AppMenu.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp14_, _tmp12_);
#line 28 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp12_);
#line 28 "../src/View/Widgets/AppMenu.vala"
	g_object_set ((GtkActionable*) _tmp14_, "action-target", _tmp13_, NULL);
#line 28 "../src/View/Widgets/AppMenu.vala"
	_g_variant_unref0 (_tmp13_);
#line 28 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp14_);
#line 28 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (self->priv->zoom_default_button);
#line 28 "../src/View/Widgets/AppMenu.vala"
	self->priv->zoom_default_button = _tmp14_;
#line 32 "../src/View/Widgets/AppMenu.vala"
	_tmp15_ = self->priv->zoom_default_button;
#line 32 "../src/View/Widgets/AppMenu.vala"
	_tmp16_ = app_instance;
#line 32 "../src/View/Widgets/AppMenu.vala"
	_tmp18_ = _tmp17_ = gtk_application_get_accels_for_action (_tmp16_, "win.zoom::ZOOM_NORMAL");
#line 32 "../src/View/Widgets/AppMenu.vala"
	_tmp19_ = _tmp18_;
#line 32 "../src/View/Widgets/AppMenu.vala"
	_tmp19__length1 = _vala_array_length (_tmp17_);
#line 32 "../src/View/Widgets/AppMenu.vala"
	_tmp20_ = granite_markup_accel_tooltip (_tmp19_, (gint) _vala_array_length (_tmp17_), _ ("Zoom 1:1"));
#line 32 "../src/View/Widgets/AppMenu.vala"
	_tmp21_ = _tmp20_;
#line 32 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp15_, _tmp21_);
#line 32 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp21_);
#line 32 "../src/View/Widgets/AppMenu.vala"
	_tmp19_ = (_vala_array_free (_tmp19_, _tmp19__length1, (GDestroyNotify) g_free), NULL);
#line 37 "../src/View/Widgets/AppMenu.vala"
	_tmp22_ = g_strdup ("win.zoom");
#line 37 "../src/View/Widgets/AppMenu.vala"
	_tmp23_ = _variant_new23 ("ZOOM_IN");
#line 37 "../src/View/Widgets/AppMenu.vala"
	_tmp24_ = (GtkButton*) gtk_button_new_from_icon_name ("zoom-in-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 37 "../src/View/Widgets/AppMenu.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp24_, _tmp22_);
#line 37 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp22_);
#line 37 "../src/View/Widgets/AppMenu.vala"
	g_object_set ((GtkActionable*) _tmp24_, "action-target", _tmp23_, NULL);
#line 37 "../src/View/Widgets/AppMenu.vala"
	_g_variant_unref0 (_tmp23_);
#line 37 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp24_);
#line 37 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (self->priv->zoom_in_button);
#line 37 "../src/View/Widgets/AppMenu.vala"
	self->priv->zoom_in_button = _tmp24_;
#line 41 "../src/View/Widgets/AppMenu.vala"
	_tmp25_ = self->priv->zoom_in_button;
#line 41 "../src/View/Widgets/AppMenu.vala"
	_tmp26_ = app_instance;
#line 41 "../src/View/Widgets/AppMenu.vala"
	_tmp28_ = _tmp27_ = gtk_application_get_accels_for_action (_tmp26_, "win.zoom::ZOOM_IN");
#line 41 "../src/View/Widgets/AppMenu.vala"
	_tmp29_ = _tmp28_;
#line 41 "../src/View/Widgets/AppMenu.vala"
	_tmp29__length1 = _vala_array_length (_tmp27_);
#line 41 "../src/View/Widgets/AppMenu.vala"
	_tmp30_ = granite_markup_accel_tooltip (_tmp29_, (gint) _vala_array_length (_tmp27_), _ ("Zoom In"));
#line 41 "../src/View/Widgets/AppMenu.vala"
	_tmp31_ = _tmp30_;
#line 41 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp25_, _tmp31_);
#line 41 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp31_);
#line 41 "../src/View/Widgets/AppMenu.vala"
	_tmp29_ = (_vala_array_free (_tmp29_, _tmp29__length1, (GDestroyNotify) g_free), NULL);
#line 46 "../src/View/Widgets/AppMenu.vala"
	_tmp32_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 46 "../src/View/Widgets/AppMenu.vala"
	gtk_box_set_homogeneous (_tmp32_, TRUE);
#line 46 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp32_, TRUE);
#line 46 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp32_, 12);
#line 46 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp32_, 12);
#line 46 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp32_, 6);
#line 46 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp32_, 12);
#line 46 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp32_);
#line 46 "../src/View/Widgets/AppMenu.vala"
	icon_size_box = _tmp32_;
#line 54 "../src/View/Widgets/AppMenu.vala"
	_tmp33_ = icon_size_box;
#line 54 "../src/View/Widgets/AppMenu.vala"
	_tmp34_ = gtk_widget_get_style_context ((GtkWidget*) _tmp33_);
#line 54 "../src/View/Widgets/AppMenu.vala"
	gtk_style_context_add_class (_tmp34_, GTK_STYLE_CLASS_LINKED);
#line 55 "../src/View/Widgets/AppMenu.vala"
	_tmp35_ = icon_size_box;
#line 55 "../src/View/Widgets/AppMenu.vala"
	_tmp36_ = self->priv->zoom_out_button;
#line 55 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) _tmp36_);
#line 56 "../src/View/Widgets/AppMenu.vala"
	_tmp37_ = icon_size_box;
#line 56 "../src/View/Widgets/AppMenu.vala"
	_tmp38_ = self->priv->zoom_default_button;
#line 56 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp37_, (GtkWidget*) _tmp38_);
#line 57 "../src/View/Widgets/AppMenu.vala"
	_tmp39_ = icon_size_box;
#line 57 "../src/View/Widgets/AppMenu.vala"
	_tmp40_ = self->priv->zoom_in_button;
#line 57 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp40_);
#line 59 "../src/View/Widgets/AppMenu.vala"
	_tmp41_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 59 "../src/View/Widgets/AppMenu.vala"
	gtk_box_set_homogeneous (_tmp41_, TRUE);
#line 59 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp41_, 12);
#line 59 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp41_, 12);
#line 59 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp41_, 12);
#line 59 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp41_);
#line 59 "../src/View/Widgets/AppMenu.vala"
	undo_redo_box = _tmp41_;
#line 65 "../src/View/Widgets/AppMenu.vala"
	_tmp42_ = undo_redo_box;
#line 65 "../src/View/Widgets/AppMenu.vala"
	_tmp43_ = gtk_widget_get_style_context ((GtkWidget*) _tmp42_);
#line 65 "../src/View/Widgets/AppMenu.vala"
	gtk_style_context_add_class (_tmp43_, GTK_STYLE_CLASS_LINKED);
#line 67 "../src/View/Widgets/AppMenu.vala"
	_tmp44_ = g_strdup ("win.undo");
#line 67 "../src/View/Widgets/AppMenu.vala"
	_tmp45_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-undo-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 67 "../src/View/Widgets/AppMenu.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp45_, _tmp44_);
#line 67 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp44_);
#line 67 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp45_);
#line 67 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (self->priv->undo_button);
#line 67 "../src/View/Widgets/AppMenu.vala"
	self->priv->undo_button = _tmp45_;
#line 71 "../src/View/Widgets/AppMenu.vala"
	_tmp46_ = g_strdup ("win.redo");
#line 71 "../src/View/Widgets/AppMenu.vala"
	_tmp47_ = (GtkButton*) gtk_button_new_from_icon_name ("edit-redo-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 71 "../src/View/Widgets/AppMenu.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp47_, _tmp46_);
#line 71 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp46_);
#line 71 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp47_);
#line 71 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (self->priv->redo_button);
#line 71 "../src/View/Widgets/AppMenu.vala"
	self->priv->redo_button = _tmp47_;
#line 75 "../src/View/Widgets/AppMenu.vala"
	_tmp48_ = undo_redo_box;
#line 75 "../src/View/Widgets/AppMenu.vala"
	_tmp49_ = self->priv->undo_button;
#line 75 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp48_, (GtkWidget*) _tmp49_);
#line 76 "../src/View/Widgets/AppMenu.vala"
	_tmp50_ = undo_redo_box;
#line 76 "../src/View/Widgets/AppMenu.vala"
	_tmp51_ = self->priv->redo_button;
#line 76 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
#line 78 "../src/View/Widgets/AppMenu.vala"
	_tmp52_ = app_instance;
#line 78 "../src/View/Widgets/AppMenu.vala"
	_tmp54_ = _tmp53_ = gtk_application_get_accels_for_action (_tmp52_, "win.undo");
#line 78 "../src/View/Widgets/AppMenu.vala"
	self->priv->undo_accels = (_vala_array_free (self->priv->undo_accels, self->priv->undo_accels_length1, (GDestroyNotify) g_free), NULL);
#line 78 "../src/View/Widgets/AppMenu.vala"
	self->priv->undo_accels = _tmp54_;
#line 78 "../src/View/Widgets/AppMenu.vala"
	self->priv->undo_accels_length1 = _vala_array_length (_tmp53_);
#line 78 "../src/View/Widgets/AppMenu.vala"
	self->priv->_undo_accels_size_ = self->priv->undo_accels_length1;
#line 79 "../src/View/Widgets/AppMenu.vala"
	_tmp55_ = app_instance;
#line 79 "../src/View/Widgets/AppMenu.vala"
	_tmp57_ = _tmp56_ = gtk_application_get_accels_for_action (_tmp55_, "win.redo");
#line 79 "../src/View/Widgets/AppMenu.vala"
	self->priv->redo_accels = (_vala_array_free (self->priv->redo_accels, self->priv->redo_accels_length1, (GDestroyNotify) g_free), NULL);
#line 79 "../src/View/Widgets/AppMenu.vala"
	self->priv->redo_accels = _tmp57_;
#line 79 "../src/View/Widgets/AppMenu.vala"
	self->priv->redo_accels_length1 = _vala_array_length (_tmp56_);
#line 79 "../src/View/Widgets/AppMenu.vala"
	self->priv->_redo_accels_size_ = self->priv->redo_accels_length1;
#line 81 "../src/View/Widgets/AppMenu.vala"
	_tmp58_ = g_strdup (_ ("Double-click on a folder opens it, single-click selects it"));
#line 81 "../src/View/Widgets/AppMenu.vala"
	_tmp59_ = g_strdup ("win.singleclick-select");
#line 81 "../src/View/Widgets/AppMenu.vala"
	_tmp60_ = granite_switch_model_button_new (_ ("Double-click to Navigate"));
#line 81 "../src/View/Widgets/AppMenu.vala"
	granite_switch_model_button_set_description (_tmp60_, _tmp58_);
#line 81 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp58_);
#line 81 "../src/View/Widgets/AppMenu.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp60_, _tmp59_);
#line 81 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp59_);
#line 81 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp60_);
#line 81 "../src/View/Widgets/AppMenu.vala"
	double_click_button = _tmp60_;
#line 86 "../src/View/Widgets/AppMenu.vala"
	_tmp61_ = g_strdup ("win.folders-before-files");
#line 86 "../src/View/Widgets/AppMenu.vala"
	_tmp62_ = granite_switch_model_button_new (_ ("Sort Folders before Files"));
#line 86 "../src/View/Widgets/AppMenu.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp62_, _tmp61_);
#line 86 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp61_);
#line 86 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp62_);
#line 86 "../src/View/Widgets/AppMenu.vala"
	foldes_before_files = _tmp62_;
#line 90 "../src/View/Widgets/AppMenu.vala"
	_tmp63_ = granite_header_label_new (_ ("Show in View"));
#line 90 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp63_);
#line 90 "../src/View/Widgets/AppMenu.vala"
	show_header = _tmp63_;
#line 92 "../src/View/Widgets/AppMenu.vala"
	_tmp64_ = g_strdup ("win.show-hidden");
#line 92 "../src/View/Widgets/AppMenu.vala"
	_tmp65_ = (GtkCheckButton*) gtk_check_button_new ();
#line 92 "../src/View/Widgets/AppMenu.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp65_, _tmp64_);
#line 92 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp64_);
#line 92 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp65_);
#line 92 "../src/View/Widgets/AppMenu.vala"
	show_hidden_button = _tmp65_;
#line 95 "../src/View/Widgets/AppMenu.vala"
	_tmp66_ = show_hidden_button;
#line 95 "../src/View/Widgets/AppMenu.vala"
	_tmp67_ = gtk_widget_get_style_context ((GtkWidget*) _tmp66_);
#line 95 "../src/View/Widgets/AppMenu.vala"
	gtk_style_context_add_class (_tmp67_, GTK_STYLE_CLASS_MENUITEM);
#line 96 "../src/View/Widgets/AppMenu.vala"
	_tmp68_ = show_hidden_button;
#line 96 "../src/View/Widgets/AppMenu.vala"
	_tmp69_ = granite_accel_label_new (_ ("Hidden Files"), "<Ctrl>h");
#line 96 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp69_);
#line 96 "../src/View/Widgets/AppMenu.vala"
	_tmp70_ = _tmp69_;
#line 96 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp68_, (GtkWidget*) _tmp70_);
#line 96 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (_tmp70_);
#line 101 "../src/View/Widgets/AppMenu.vala"
	_tmp71_ = g_strdup ("win.show-local-thumbnails");
#line 101 "../src/View/Widgets/AppMenu.vala"
	_tmp72_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Local Thumbnails"));
#line 101 "../src/View/Widgets/AppMenu.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp72_, _tmp71_);
#line 101 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp71_);
#line 101 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp72_);
#line 101 "../src/View/Widgets/AppMenu.vala"
	show_local_thumbnails = _tmp72_;
#line 104 "../src/View/Widgets/AppMenu.vala"
	_tmp73_ = show_local_thumbnails;
#line 104 "../src/View/Widgets/AppMenu.vala"
	_tmp74_ = gtk_widget_get_style_context ((GtkWidget*) _tmp73_);
#line 104 "../src/View/Widgets/AppMenu.vala"
	gtk_style_context_add_class (_tmp74_, GTK_STYLE_CLASS_MENUITEM);
#line 106 "../src/View/Widgets/AppMenu.vala"
	_tmp75_ = g_strdup ("win.show-remote-thumbnails");
#line 106 "../src/View/Widgets/AppMenu.vala"
	_tmp76_ = (GtkCheckButton*) gtk_check_button_new_with_label (_ ("Remote Thumbnails"));
#line 106 "../src/View/Widgets/AppMenu.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp76_, _tmp75_);
#line 106 "../src/View/Widgets/AppMenu.vala"
	_g_free0 (_tmp75_);
#line 106 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp76_);
#line 106 "../src/View/Widgets/AppMenu.vala"
	show_remote_thumbnails = _tmp76_;
#line 109 "../src/View/Widgets/AppMenu.vala"
	_tmp77_ = show_remote_thumbnails;
#line 109 "../src/View/Widgets/AppMenu.vala"
	_tmp78_ = gtk_widget_get_style_context ((GtkWidget*) _tmp77_);
#line 109 "../src/View/Widgets/AppMenu.vala"
	gtk_style_context_add_class (_tmp78_, GTK_STYLE_CLASS_MENUITEM);
#line 111 "../src/View/Widgets/AppMenu.vala"
	_tmp79_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 111 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp79_, 6);
#line 111 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp79_);
#line 111 "../src/View/Widgets/AppMenu.vala"
	menu_box = _tmp79_;
#line 114 "../src/View/Widgets/AppMenu.vala"
	_tmp80_ = menu_box;
#line 114 "../src/View/Widgets/AppMenu.vala"
	_tmp81_ = icon_size_box;
#line 114 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp80_, (GtkWidget*) _tmp81_);
#line 115 "../src/View/Widgets/AppMenu.vala"
	_tmp82_ = menu_box;
#line 115 "../src/View/Widgets/AppMenu.vala"
	_tmp83_ = undo_redo_box;
#line 115 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp82_, (GtkWidget*) _tmp83_);
#line 116 "../src/View/Widgets/AppMenu.vala"
	_tmp84_ = menu_box;
#line 116 "../src/View/Widgets/AppMenu.vala"
	_tmp85_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 116 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp85_, 3);
#line 116 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp85_);
#line 116 "../src/View/Widgets/AppMenu.vala"
	_tmp86_ = _tmp85_;
#line 116 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp84_, (GtkWidget*) _tmp86_);
#line 116 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (_tmp86_);
#line 117 "../src/View/Widgets/AppMenu.vala"
	_tmp87_ = menu_box;
#line 117 "../src/View/Widgets/AppMenu.vala"
	_tmp88_ = double_click_button;
#line 117 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp87_, (GtkWidget*) _tmp88_);
#line 118 "../src/View/Widgets/AppMenu.vala"
	_tmp89_ = menu_box;
#line 118 "../src/View/Widgets/AppMenu.vala"
	_tmp90_ = foldes_before_files;
#line 118 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp89_, (GtkWidget*) _tmp90_);
#line 119 "../src/View/Widgets/AppMenu.vala"
	_tmp91_ = menu_box;
#line 119 "../src/View/Widgets/AppMenu.vala"
	_tmp92_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 119 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp92_, 3);
#line 119 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp92_, 3);
#line 119 "../src/View/Widgets/AppMenu.vala"
	g_object_ref_sink (_tmp92_);
#line 119 "../src/View/Widgets/AppMenu.vala"
	_tmp93_ = _tmp92_;
#line 119 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp91_, (GtkWidget*) _tmp93_);
#line 119 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (_tmp93_);
#line 120 "../src/View/Widgets/AppMenu.vala"
	_tmp94_ = menu_box;
#line 120 "../src/View/Widgets/AppMenu.vala"
	_tmp95_ = show_header;
#line 120 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp94_, (GtkWidget*) _tmp95_);
#line 121 "../src/View/Widgets/AppMenu.vala"
	_tmp96_ = menu_box;
#line 121 "../src/View/Widgets/AppMenu.vala"
	_tmp97_ = show_hidden_button;
#line 121 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp96_, (GtkWidget*) _tmp97_);
#line 122 "../src/View/Widgets/AppMenu.vala"
	_tmp98_ = menu_box;
#line 122 "../src/View/Widgets/AppMenu.vala"
	_tmp99_ = show_local_thumbnails;
#line 122 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp98_, (GtkWidget*) _tmp99_);
#line 123 "../src/View/Widgets/AppMenu.vala"
	_tmp100_ = menu_box;
#line 123 "../src/View/Widgets/AppMenu.vala"
	_tmp101_ = show_remote_thumbnails;
#line 123 "../src/View/Widgets/AppMenu.vala"
	gtk_container_add ((GtkContainer*) _tmp100_, (GtkWidget*) _tmp101_);
#line 124 "../src/View/Widgets/AppMenu.vala"
	_tmp102_ = menu_box;
#line 124 "../src/View/Widgets/AppMenu.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp102_);
#line 126 "../src/View/Widgets/AppMenu.vala"
	_tmp103_ = menu_box;
#line 126 "../src/View/Widgets/AppMenu.vala"
	g_object_set ((GtkContainer*) self, "child", (GtkWidget*) _tmp103_, NULL);
#line 128 "../src/View/Widgets/AppMenu.vala"
	_tmp104_ = files_undo_manager_instance ();
#line 128 "../src/View/Widgets/AppMenu.vala"
	self->priv->undo_manager = _tmp104_;
#line 129 "../src/View/Widgets/AppMenu.vala"
	_tmp105_ = self->priv->undo_manager;
#line 129 "../src/View/Widgets/AppMenu.vala"
	g_signal_connect_object (_tmp105_, "request-menu-update", (GCallback) _files_app_menu_set_undo_redo_tooltips_files_undo_manager_request_menu_update, self, 0);
#line 130 "../src/View/Widgets/AppMenu.vala"
	files_app_menu_set_undo_redo_tooltips (self);
#line 134 "../src/View/Widgets/AppMenu.vala"
	_tmp106_ = files_icon_view_settings;
#line 134 "../src/View/Widgets/AppMenu.vala"
	g_signal_connect_object (_tmp106_, "changed::zoom-level", (GCallback) _files_app_menu_on_zoom_setting_changed_g_settings_changed, self, 0);
#line 135 "../src/View/Widgets/AppMenu.vala"
	_tmp107_ = files_list_view_settings;
#line 135 "../src/View/Widgets/AppMenu.vala"
	g_signal_connect_object (_tmp107_, "changed::zoom-level", (GCallback) _files_app_menu_on_zoom_setting_changed_g_settings_changed, self, 0);
#line 136 "../src/View/Widgets/AppMenu.vala"
	_tmp108_ = files_column_view_settings;
#line 136 "../src/View/Widgets/AppMenu.vala"
	g_signal_connect_object (_tmp108_, "changed::zoom-level", (GCallback) _files_app_menu_on_zoom_setting_changed_g_settings_changed, self, 0);
#line 16 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (menu_box);
#line 16 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (show_remote_thumbnails);
#line 16 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (show_local_thumbnails);
#line 16 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (show_hidden_button);
#line 16 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (show_header);
#line 16 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (foldes_before_files);
#line 16 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (double_click_button);
#line 16 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (undo_redo_box);
#line 16 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (icon_size_box);
#line 16 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (app_instance);
#line 16 "../src/View/Widgets/AppMenu.vala"
	return obj;
#line 977 "AppMenu.c"
}

static void
files_app_menu_class_init (FilesAppMenuClass * klass,
                           gpointer klass_data)
{
#line 6 "../src/View/Widgets/AppMenu.vala"
	files_app_menu_parent_class = g_type_class_peek_parent (klass);
#line 6 "../src/View/Widgets/AppMenu.vala"
	g_type_class_adjust_private_offset (klass, &FilesAppMenu_private_offset);
#line 6 "../src/View/Widgets/AppMenu.vala"
	G_OBJECT_CLASS (klass)->constructor = files_app_menu_constructor;
#line 6 "../src/View/Widgets/AppMenu.vala"
	G_OBJECT_CLASS (klass)->finalize = files_app_menu_finalize;
#line 992 "AppMenu.c"
}

static void
files_app_menu_instance_init (FilesAppMenu * self,
                              gpointer klass)
{
#line 6 "../src/View/Widgets/AppMenu.vala"
	self->priv = files_app_menu_get_instance_private (self);
#line 1001 "AppMenu.c"
}

static void
files_app_menu_finalize (GObject * obj)
{
	FilesAppMenu * self;
#line 6 "../src/View/Widgets/AppMenu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_TYPE_APP_MENU, FilesAppMenu);
#line 7 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (self->priv->redo_button);
#line 8 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (self->priv->undo_button);
#line 9 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (self->priv->zoom_default_button);
#line 10 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (self->priv->zoom_in_button);
#line 11 "../src/View/Widgets/AppMenu.vala"
	_g_object_unref0 (self->priv->zoom_out_button);
#line 12 "../src/View/Widgets/AppMenu.vala"
	self->priv->redo_accels = (_vala_array_free (self->priv->redo_accels, self->priv->redo_accels_length1, (GDestroyNotify) g_free), NULL);
#line 13 "../src/View/Widgets/AppMenu.vala"
	self->priv->undo_accels = (_vala_array_free (self->priv->undo_accels, self->priv->undo_accels_length1, (GDestroyNotify) g_free), NULL);
#line 6 "../src/View/Widgets/AppMenu.vala"
	G_OBJECT_CLASS (files_app_menu_parent_class)->finalize (obj);
#line 1026 "AppMenu.c"
}

 G_GNUC_NO_INLINE static GType
files_app_menu_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesAppMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) files_app_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesAppMenu), 0, (GInstanceInitFunc) files_app_menu_instance_init, NULL };
	GType files_app_menu_type_id;
	files_app_menu_type_id = g_type_register_static (gtk_popover_get_type (), "FilesAppMenu", &g_define_type_info, 0);
	FilesAppMenu_private_offset = g_type_add_instance_private (files_app_menu_type_id, sizeof (FilesAppMenuPrivate));
	return files_app_menu_type_id;
}

GType
files_app_menu_get_type (void)
{
	static volatile gsize files_app_menu_type_id__once = 0;
	if (g_once_init_enter (&files_app_menu_type_id__once)) {
		GType files_app_menu_type_id;
		files_app_menu_type_id = files_app_menu_get_type_once ();
		g_once_init_leave (&files_app_menu_type_id__once, files_app_menu_type_id);
	}
	return files_app_menu_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

