/* AbstractDirectoryView.c generated by valac 0.56.14, the Vala compiler
 * generated from AbstractDirectoryView.vala, do not modify */

/*
* Copyright 2015-2020 elementary, Inc. (https://elementary.io)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 3 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Jeremy Wootten <jeremy@elementaryos.org>
*/
/* Implementations of AbstractDirectoryView are
     * IconView
     * ListView
     * ColumnView
*/
/*** Private methods */
/** Signal Handlers */
/** Menu actions */
/** HELPER AND CONVENIENCE FUNCTIONS */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <glib.h>
#include <cairo-gobject.h>
#include "pantheon-files-core.h"
#include <stdlib.h>
#include <string.h>
#include <handy.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gee.h>
#include <granite.h>
#include <glib/gi18n-lib.h>
#include "marlin-file-operations.h"
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "config.h"
#include <pango/pango.h>

#define FILES_ABSTRACT_DIRECTORY_VIEW_MAX_TEMPLATES 32
#define FILES_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS ((GDK_ACTION_COPY | GDK_ACTION_MOVE) | GDK_ACTION_LINK)
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define FILES_TYPE_ABSTRACT_DIRECTORY_VIEW (files_abstract_directory_view_get_type ())
#define FILES_ABSTRACT_DIRECTORY_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, FilesAbstractDirectoryView))
#define FILES_ABSTRACT_DIRECTORY_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, FilesAbstractDirectoryViewClass))
#define FILES_IS_ABSTRACT_DIRECTORY_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_ABSTRACT_DIRECTORY_VIEW))
#define FILES_IS_ABSTRACT_DIRECTORY_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_ABSTRACT_DIRECTORY_VIEW))
#define FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, FilesAbstractDirectoryViewClass))

typedef struct _FilesAbstractDirectoryView FilesAbstractDirectoryView;
typedef struct _FilesAbstractDirectoryViewClass FilesAbstractDirectoryViewClass;
typedef struct _FilesAbstractDirectoryViewPrivate FilesAbstractDirectoryViewPrivate;

#define FILES_TYPE_TEXT_RENDERER (files_text_renderer_get_type ())
#define FILES_TEXT_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_TEXT_RENDERER, FilesTextRenderer))
#define FILES_TEXT_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_TEXT_RENDERER, FilesTextRendererClass))
#define FILES_IS_TEXT_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_TEXT_RENDERER))
#define FILES_IS_TEXT_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_TEXT_RENDERER))
#define FILES_TEXT_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_TEXT_RENDERER, FilesTextRendererClass))

typedef struct _FilesTextRenderer FilesTextRenderer;
typedef struct _FilesTextRendererClass FilesTextRendererClass;

#define FILES_TYPE_ICON_RENDERER (files_icon_renderer_get_type ())
#define FILES_ICON_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_ICON_RENDERER, FilesIconRenderer))
#define FILES_ICON_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_ICON_RENDERER, FilesIconRendererClass))
#define FILES_IS_ICON_RENDERER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_ICON_RENDERER))
#define FILES_IS_ICON_RENDERER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_ICON_RENDERER))
#define FILES_ICON_RENDERER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_ICON_RENDERER, FilesIconRendererClass))

typedef struct _FilesIconRenderer FilesIconRenderer;
typedef struct _FilesIconRendererClass FilesIconRendererClass;

#define FILES_VIEW_TYPE_SLOT (files_view_slot_get_type ())
#define FILES_VIEW_SLOT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_VIEW_TYPE_SLOT, FilesViewSlot))
#define FILES_VIEW_SLOT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_VIEW_TYPE_SLOT, FilesViewSlotClass))
#define FILES_VIEW_IS_SLOT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_VIEW_TYPE_SLOT))
#define FILES_VIEW_IS_SLOT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_VIEW_TYPE_SLOT))
#define FILES_VIEW_SLOT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_VIEW_TYPE_SLOT, FilesViewSlotClass))

typedef struct _FilesViewSlot FilesViewSlot;
typedef struct _FilesViewSlotClass FilesViewSlotClass;

#define FILES_VIEW_TYPE_WINDOW (files_view_window_get_type ())
#define FILES_VIEW_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_VIEW_TYPE_WINDOW, FilesViewWindow))
#define FILES_VIEW_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_VIEW_TYPE_WINDOW, FilesViewWindowClass))
#define FILES_VIEW_IS_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_VIEW_TYPE_WINDOW))
#define FILES_VIEW_IS_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_VIEW_TYPE_WINDOW))
#define FILES_VIEW_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_VIEW_TYPE_WINDOW, FilesViewWindowClass))

typedef struct _FilesViewWindow FilesViewWindow;
typedef struct _FilesViewWindowClass FilesViewWindowClass;

#define FILES_TYPE_CLIPBOARD_MANAGER (files_clipboard_manager_get_type ())
#define FILES_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_CLIPBOARD_MANAGER, FilesClipboardManager))
#define FILES_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_CLIPBOARD_MANAGER, FilesClipboardManagerClass))
#define FILES_IS_CLIPBOARD_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_CLIPBOARD_MANAGER))
#define FILES_IS_CLIPBOARD_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_CLIPBOARD_MANAGER))
#define FILES_CLIPBOARD_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_CLIPBOARD_MANAGER, FilesClipboardManagerClass))

typedef struct _FilesClipboardManager FilesClipboardManager;
typedef struct _FilesClipboardManagerClass FilesClipboardManagerClass;
enum  {
	FILES_ABSTRACT_DIRECTORY_VIEW_0_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_ICON_SIZE_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_SINGLECLICK_SELECT_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_SHOW_REMOTE_THUMBNAILS_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_SHOW_LOCAL_THUMBNAILS_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_NUM_PROPERTIES
};
static GParamSpec* files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_NUM_PROPERTIES];
typedef enum  {
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_EXPANDER,
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER,
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON,
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME,
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH,
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH,
	FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID
} FilesAbstractDirectoryViewClickZone;

#define FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_CLICK_ZONE (files_abstract_directory_view_click_zone_get_type ())
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
typedef void (*GSimpleActionChangeStateCallback) (GSimpleAction* action, GVariant* value, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

#define FILES_TYPE_APPLICATION (files_application_get_type ())
#define FILES_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_APPLICATION, FilesApplication))
#define FILES_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_APPLICATION, FilesApplicationClass))
#define FILES_IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_APPLICATION))
#define FILES_IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_APPLICATION))
#define FILES_APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_APPLICATION, FilesApplicationClass))

typedef struct _FilesApplication FilesApplication;
typedef struct _FilesApplicationClass FilesApplicationClass;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block17Data Block17Data;
typedef struct _Block18Data Block18Data;
#define __vala_GtkTreeIter_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeIter_free (var), NULL)))
typedef struct _Block19Data Block19Data;
typedef struct _Block20Data Block20Data;
typedef struct _Block21Data Block21Data;
typedef struct _Block22Data Block22Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block23Data Block23Data;
typedef struct _Block24Data Block24Data;

#define FILES_TYPE_RENAMER_DIALOG (files_renamer_dialog_get_type ())
#define FILES_RENAMER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialog))
#define FILES_RENAMER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialogClass))
#define FILES_IS_RENAMER_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_RENAMER_DIALOG))
#define FILES_IS_RENAMER_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_RENAMER_DIALOG))
#define FILES_RENAMER_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_RENAMER_DIALOG, FilesRenamerDialogClass))

typedef struct _FilesRenamerDialog FilesRenamerDialog;
typedef struct _FilesRenamerDialogClass FilesRenamerDialogClass;

#define FILES_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG (files_view_abstract_properties_dialog_get_type ())
#define FILES_VIEW_ABSTRACT_PROPERTIES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG, FilesViewAbstractPropertiesDialog))
#define FILES_VIEW_ABSTRACT_PROPERTIES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG, FilesViewAbstractPropertiesDialogClass))
#define FILES_VIEW_IS_ABSTRACT_PROPERTIES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG))
#define FILES_VIEW_IS_ABSTRACT_PROPERTIES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG))
#define FILES_VIEW_ABSTRACT_PROPERTIES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_VIEW_TYPE_ABSTRACT_PROPERTIES_DIALOG, FilesViewAbstractPropertiesDialogClass))

typedef struct _FilesViewAbstractPropertiesDialog FilesViewAbstractPropertiesDialog;
typedef struct _FilesViewAbstractPropertiesDialogClass FilesViewAbstractPropertiesDialogClass;

#define FILES_VIEW_TYPE_PROPERTIES_WINDOW (files_view_properties_window_get_type ())
#define FILES_VIEW_PROPERTIES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_VIEW_TYPE_PROPERTIES_WINDOW, FilesViewPropertiesWindow))
#define FILES_VIEW_PROPERTIES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_VIEW_TYPE_PROPERTIES_WINDOW, FilesViewPropertiesWindowClass))
#define FILES_VIEW_IS_PROPERTIES_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_VIEW_TYPE_PROPERTIES_WINDOW))
#define FILES_VIEW_IS_PROPERTIES_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_VIEW_TYPE_PROPERTIES_WINDOW))
#define FILES_VIEW_PROPERTIES_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_VIEW_TYPE_PROPERTIES_WINDOW, FilesViewPropertiesWindowClass))

typedef struct _FilesViewPropertiesWindow FilesViewPropertiesWindow;
typedef struct _FilesViewPropertiesWindowClass FilesViewPropertiesWindowClass;
typedef struct _Block25Data Block25Data;
typedef struct _Block26Data Block26Data;
typedef struct _Block27Data Block27Data;
typedef struct _Block28Data Block28Data;
#define __vala_GdkEvent_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEvent_free (var), NULL)))
#define _gtk_target_list_unref0(var) ((var == NULL) ? NULL : (var = (gtk_target_list_unref (var), NULL)))
typedef struct _Block29Data Block29Data;

#define FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM (files_abstract_directory_view_sort_sub_menu_item_get_type ())
#define FILES_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM, FilesAbstractDirectoryViewSortSubMenuItem))
#define FILES_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM, FilesAbstractDirectoryViewSortSubMenuItemClass))
#define FILES_ABSTRACT_DIRECTORY_VIEW_IS_SORT_SUB_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM))
#define FILES_ABSTRACT_DIRECTORY_VIEW_IS_SORT_SUB_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM))
#define FILES_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM, FilesAbstractDirectoryViewSortSubMenuItemClass))

typedef struct _FilesAbstractDirectoryViewSortSubMenuItem FilesAbstractDirectoryViewSortSubMenuItem;
typedef struct _FilesAbstractDirectoryViewSortSubMenuItemClass FilesAbstractDirectoryViewSortSubMenuItemClass;

#define FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM (files_abstract_directory_view_new_sub_menu_item_get_type ())
#define FILES_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM, FilesAbstractDirectoryViewNewSubMenuItem))
#define FILES_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM, FilesAbstractDirectoryViewNewSubMenuItemClass))
#define FILES_ABSTRACT_DIRECTORY_VIEW_IS_NEW_SUB_MENU_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM))
#define FILES_ABSTRACT_DIRECTORY_VIEW_IS_NEW_SUB_MENU_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM))
#define FILES_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM, FilesAbstractDirectoryViewNewSubMenuItemClass))

typedef struct _FilesAbstractDirectoryViewNewSubMenuItem FilesAbstractDirectoryViewNewSubMenuItem;
typedef struct _FilesAbstractDirectoryViewNewSubMenuItemClass FilesAbstractDirectoryViewNewSubMenuItemClass;
typedef struct _Block30Data Block30Data;
typedef struct _Block31Data Block31Data;

#define FILES_TYPE_ABSTRACT_EDITABLE_LABEL (files_abstract_editable_label_get_type ())
#define FILES_ABSTRACT_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FILES_TYPE_ABSTRACT_EDITABLE_LABEL, FilesAbstractEditableLabel))
#define FILES_ABSTRACT_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FILES_TYPE_ABSTRACT_EDITABLE_LABEL, FilesAbstractEditableLabelClass))
#define FILES_IS_ABSTRACT_EDITABLE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FILES_TYPE_ABSTRACT_EDITABLE_LABEL))
#define FILES_IS_ABSTRACT_EDITABLE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FILES_TYPE_ABSTRACT_EDITABLE_LABEL))
#define FILES_ABSTRACT_EDITABLE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FILES_TYPE_ABSTRACT_EDITABLE_LABEL, FilesAbstractEditableLabelClass))

typedef struct _FilesAbstractEditableLabel FilesAbstractEditableLabel;
typedef struct _FilesAbstractEditableLabelClass FilesAbstractEditableLabelClass;
typedef struct _FilesAbstractDirectoryViewSetFileDisplayNameData FilesAbstractDirectoryViewSetFileDisplayNameData;
typedef struct _Block32Data Block32Data;
typedef struct _Block33Data Block33Data;
typedef struct _Block34Data Block34Data;
typedef struct _Block35Data Block35Data;
#define __vala_GtkTreeRowReference_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreeRowReference_free (var), NULL)))
typedef struct _FilesIconRendererPrivate FilesIconRendererPrivate;
typedef struct _FilesAbstractDirectoryViewSortSubMenuItemPrivate FilesAbstractDirectoryViewSortSubMenuItemPrivate;
enum  {
	FILES_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_0_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* files_abstract_directory_view_sort_sub_menu_item_properties[FILES_ABSTRACT_DIRECTORY_VIEW_SORT_SUB_MENU_ITEM_NUM_PROPERTIES];
typedef struct _FilesAbstractDirectoryViewNewSubMenuItemPrivate FilesAbstractDirectoryViewNewSubMenuItemPrivate;
enum  {
	FILES_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_0_PROPERTY,
	FILES_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_NUM_PROPERTIES
};
static GParamSpec* files_abstract_directory_view_new_sub_menu_item_properties[FILES_ABSTRACT_DIRECTORY_VIEW_NEW_SUB_MENU_ITEM_NUM_PROPERTIES];
enum  {
	FILES_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL,
	FILES_ABSTRACT_DIRECTORY_VIEW_SELECTION_CHANGED_SIGNAL,
	FILES_ABSTRACT_DIRECTORY_VIEW_NUM_SIGNALS
};
static guint files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FilesAbstractDirectoryView {
	GtkScrolledWindow parent_instance;
	FilesAbstractDirectoryViewPrivate * priv;
	FilesZoomLevel minimum_zoom;
	FilesZoomLevel maximum_zoom;
	gboolean large_thumbnails;
	GList* source_drag_file_list;
	GdkAtom current_target_type;
	gboolean dnd_disabled;
	FilesTextRenderer* name_renderer;
	gchar* original_name;
	gchar* proposed_name;
	gboolean right_margin_unselects_all;
	gboolean on_directory;
	gboolean one_or_less;
	gboolean should_activate;
	gboolean should_scroll;
	gboolean should_deselect;
	gboolean should_select;
	GtkTreePath* click_path;
	guint click_zone;
	guint previous_click_zone;
	GList* selected_files;
	gboolean is_writable;
	gboolean is_loading;
	gboolean helpers_shown;
	FilesListModel* model;
	FilesIconRenderer* icon_renderer;
	FilesViewSlot* slot;
	FilesViewWindow* window;
	GtkRecentManager* recent;
};

struct _FilesAbstractDirectoryViewClass {
	GtkScrolledWindowClass parent_class;
	void (*set_up_name_renderer) (FilesAbstractDirectoryView* self);
	void (*on_row_deleted) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	gboolean (*on_view_key_press_event) (FilesAbstractDirectoryView* self, GdkEventKey* event);
	gboolean (*on_scroll_event) (FilesAbstractDirectoryView* self, GdkEventScroll* event);
	gboolean (*on_view_draw) (FilesAbstractDirectoryView* self, cairo_t* cr);
	gboolean (*handle_primary_button_click) (FilesAbstractDirectoryView* self, GdkEventButton* event, GtkTreePath* path);
	gboolean (*handle_secondary_button_click) (FilesAbstractDirectoryView* self, GdkEventButton* event);
	gboolean (*on_view_button_press_event) (FilesAbstractDirectoryView* self, GdkEventButton* event);
	gboolean (*on_view_button_release_event) (FilesAbstractDirectoryView* self, GdkEventButton* event);
	void (*change_zoom_level) (FilesAbstractDirectoryView* self);
	gboolean (*expand_collapse) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	gboolean (*handle_default_button_click) (FilesAbstractDirectoryView* self, GdkEventButton* event);
	gboolean (*get_next_visible_iter) (FilesAbstractDirectoryView* self, GtkTreeIter* iter, gboolean recurse);
	void (*cancel) (FilesAbstractDirectoryView* self);
	void (*highlight_path) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	GtkTreePath* (*up) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	GtkTreePath* (*down) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	GList* (*get_selected_paths) (FilesAbstractDirectoryView* self);
	GtkTreePath* (*get_path_at_pos) (FilesAbstractDirectoryView* self, gint x, gint win);
	GtkTreePath* (*get_path_at_cursor) (FilesAbstractDirectoryView* self);
	void (*tree_select_all) (FilesAbstractDirectoryView* self);
	void (*tree_unselect_all) (FilesAbstractDirectoryView* self);
	void (*tree_unselect_others) (FilesAbstractDirectoryView* self);
	void (*select_path) (FilesAbstractDirectoryView* self, GtkTreePath* path, gboolean cursor_follows);
	void (*unselect_path) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	gboolean (*path_is_selected) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	gboolean (*get_visible_range) (FilesAbstractDirectoryView* self, GtkTreePath** start_path, GtkTreePath** end_path);
	void (*set_cursor) (FilesAbstractDirectoryView* self, GtkTreePath* path, gboolean start_editing, gboolean select, gboolean scroll_to_top);
	gboolean (*move_cursor) (FilesAbstractDirectoryView* self, guint keyval, gboolean only_shift_pressed, gboolean control_pressed);
	gboolean (*will_handle_button_press) (FilesAbstractDirectoryView* self, gboolean no_mods, gboolean only_control_pressed, gboolean only_shift_pressed);
	gboolean (*handle_multi_select) (FilesAbstractDirectoryView* self, GtkTreePath* path);
	GtkWidget* (*create_view) (FilesAbstractDirectoryView* self);
	void (*set_up_zoom_level) (FilesAbstractDirectoryView* self);
	FilesZoomLevel (*get_normal_zoom_level) (FilesAbstractDirectoryView* self);
	gboolean (*view_has_focus) (FilesAbstractDirectoryView* self);
	guint (*get_selected_files_from_model) (FilesAbstractDirectoryView* self, GList** selected_files);
	guint (*get_event_position_info) (FilesAbstractDirectoryView* self, GdkEventButton* event, GtkTreePath** path, gboolean rubberband);
	void (*scroll_to_cell) (FilesAbstractDirectoryView* self, GtkTreePath* path, gboolean scroll_to_top);
	void (*set_cursor_on_cell) (FilesAbstractDirectoryView* self, GtkTreePath* path, GtkCellRenderer* renderer, gboolean start_editing, gboolean scroll_to_top);
	void (*freeze_tree) (FilesAbstractDirectoryView* self);
	void (*thaw_tree) (FilesAbstractDirectoryView* self);
	void (*freeze_child_notify) (FilesAbstractDirectoryView* self);
	void (*thaw_child_notify) (FilesAbstractDirectoryView* self);
	void (*connect_tree_signals) (FilesAbstractDirectoryView* self);
	void (*disconnect_tree_signals) (FilesAbstractDirectoryView* self);
};

struct _FilesAbstractDirectoryViewPrivate {
	GSimpleActionGroup* common_actions;
	GSimpleActionGroup* selection_actions;
	GSimpleActionGroup* background_actions;
	FilesZoomLevel _zoom_level;
	gdouble drag_x;
	gdouble drag_y;
	gint drag_button;
	guint drag_timer_id;
	guint drag_scroll_timer_id;
	guint drag_enter_timer_id;
	gboolean destination_data_ready;
	gboolean drop_occurred;
	FilesFile* drop_target_file;
	GList* destination_drop_file_list;
	GdkDragAction current_suggested_action;
	GdkDragAction current_actions;
	gboolean _drop_highlight;
	void* drag_data;
	gint thumbnail_request;
	guint thumbnail_source_id;
	guint freeze_source_id;
	FilesThumbnailer* thumbnailer;
	guint add_remove_file_timeout_id;
	gboolean signal_free_space_change;
	gdouble total_delta_y;
	GtkTreePath* deleted_path;
	gboolean _singleclick_select;
	GdkCursor* editable_cursor;
	GdkCursor* activatable_cursor;
	GdkCursor* selectable_cursor;
	GList* open_with_apps;
	gboolean selected_files_invalid;
	GAppInfo* default_app;
	GtkTreePath* hover_path;
	gboolean _renaming;
	gboolean _is_frozen;
	gboolean _in_recent;
	gboolean _tree_frozen;
	gboolean in_trash;
	gboolean in_network_root;
	gboolean _show_remote_thumbnails;
	gboolean _show_local_thumbnails;
	gboolean all_selected;
	GtkWidget* view;
	FilesClipboardManager* clipboard;
	guint set_cursor_timeout_id;
	gulong select_source_handler;
	guint draw_timeout_id;
};

struct _Block17Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	gboolean select;
};

struct _Block18Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GeeLinkedList* files_to_select_list;
	GFile* focus_after_select;
};

struct _Block19Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GdkScreen* screen;
	FilesOpenFlag flag;
};

struct _Block20Data {
	int _ref_count_;
	Block19Data * _data19_;
	FilesFile* file;
};

struct _Block21Data {
	int _ref_count_;
	Block19Data * _data19_;
	GList* files_to_open;
};

struct _Block22Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	gboolean only_folders;
};

struct _Block23Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GList* locations;
};

struct _Block24Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	FilesFile* file_to_rename;
};

struct _Block25Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GFile* target;
};

struct _Block26Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GFile* target;
};

struct _Block27Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	FilesFile* file;
};

struct _Block28Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	FilesFile* file;
};

struct _Block29Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GdkEvent* event;
};

struct _Block30Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GdkDragContext* context;
};

struct _Block31Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GList* action_files;
};

struct _FilesAbstractDirectoryViewSetFileDisplayNameData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FilesAbstractDirectoryView* self;
	GFile* old_location;
	gchar* new_name;
	GCancellable* cancellable;
	GFile* result;
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
	GFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* e;
	GError* _tmp6_;
	GError* _tmp7_;
	GError* _inner_error0_;
};

struct _Block32Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	FilesFile* new_file;
};

struct _Block33Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	guint button;
};

struct _Block34Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	GtkTreePath* path;
	guint count;
	gboolean ok_next_time;
	GtkTreePath* start_path;
};

struct _Block35Data {
	int _ref_count_;
	FilesAbstractDirectoryView* self;
	FilesDirectory* dir;
};

struct _FilesIconRenderer {
	GtkCellRenderer parent_instance;
	FilesIconRendererPrivate * priv;
	GdkRectangle hover_helper_rect;
	GdkRectangle hover_rect;
};

struct _FilesIconRendererClass {
	GtkCellRendererClass parent_class;
};

struct _FilesAbstractDirectoryViewSortSubMenuItem {
	GtkMenuItem parent_instance;
	FilesAbstractDirectoryViewSortSubMenuItemPrivate * priv;
};

struct _FilesAbstractDirectoryViewSortSubMenuItemClass {
	GtkMenuItemClass parent_class;
};

struct _FilesAbstractDirectoryViewNewSubMenuItem {
	GtkMenuItem parent_instance;
	FilesAbstractDirectoryViewNewSubMenuItemPrivate * priv;
};

struct _FilesAbstractDirectoryViewNewSubMenuItemClass {
	GtkMenuItemClass parent_class;
};

static gint FilesAbstractDirectoryView_private_offset;
static gpointer files_abstract_directory_view_parent_class = NULL;
static GList* files_abstract_directory_view_templates;
static GList* files_abstract_directory_view_templates = NULL;
VALA_EXTERN FilesDndHandler* files_abstract_directory_view_dnd_handler;
FilesDndHandler* files_abstract_directory_view_dnd_handler = NULL;
VALA_EXTERN GSettings* files_app_settings;
static gpointer files_abstract_directory_view_sort_sub_menu_item_parent_class = NULL;
static gpointer files_abstract_directory_view_new_sub_menu_item_parent_class = NULL;

VALA_EXTERN GType files_abstract_directory_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesAbstractDirectoryView, g_object_unref)
VALA_EXTERN GType files_text_renderer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesTextRenderer, g_object_unref)
VALA_EXTERN GType files_icon_renderer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesIconRenderer, g_object_unref)
VALA_EXTERN GType files_view_slot_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesViewSlot, g_object_unref)
VALA_EXTERN GType files_view_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesViewWindow, g_object_unref)
VALA_EXTERN GType files_clipboard_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesClipboardManager, g_object_unref)
VALA_EXTERN void files_abstract_directory_view_set_up_name_renderer (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_on_row_deleted (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path);
VALA_EXTERN gboolean files_abstract_directory_view_on_view_key_press_event (FilesAbstractDirectoryView* self,
                                                                GdkEventKey* event);
VALA_EXTERN gboolean files_abstract_directory_view_on_scroll_event (FilesAbstractDirectoryView* self,
                                                        GdkEventScroll* event);
VALA_EXTERN gboolean files_abstract_directory_view_on_view_draw (FilesAbstractDirectoryView* self,
                                                     cairo_t* cr);
VALA_EXTERN gboolean files_abstract_directory_view_handle_primary_button_click (FilesAbstractDirectoryView* self,
                                                                    GdkEventButton* event,
                                                                    GtkTreePath* path);
VALA_EXTERN gboolean files_abstract_directory_view_handle_secondary_button_click (FilesAbstractDirectoryView* self,
                                                                      GdkEventButton* event);
VALA_EXTERN gboolean files_abstract_directory_view_on_view_button_press_event (FilesAbstractDirectoryView* self,
                                                                   GdkEventButton* event);
VALA_EXTERN gboolean files_abstract_directory_view_on_view_button_release_event (FilesAbstractDirectoryView* self,
                                                                     GdkEventButton* event);
VALA_EXTERN void files_abstract_directory_view_change_zoom_level (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_abstract_directory_view_expand_collapse (FilesAbstractDirectoryView* self,
                                                        GtkTreePath* path);
VALA_EXTERN gboolean files_abstract_directory_view_handle_default_button_click (FilesAbstractDirectoryView* self,
                                                                    GdkEventButton* event);
VALA_EXTERN gboolean files_abstract_directory_view_get_next_visible_iter (FilesAbstractDirectoryView* self,
                                                              GtkTreeIter* iter,
                                                              gboolean recurse);
VALA_EXTERN void files_abstract_directory_view_cancel (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_highlight_path (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path);
VALA_EXTERN GtkTreePath* files_abstract_directory_view_up (FilesAbstractDirectoryView* self,
                                               GtkTreePath* path);
VALA_EXTERN GtkTreePath* files_abstract_directory_view_down (FilesAbstractDirectoryView* self,
                                                 GtkTreePath* path);
VALA_EXTERN GList* files_abstract_directory_view_get_selected_paths (FilesAbstractDirectoryView* self);
VALA_EXTERN GtkTreePath* files_abstract_directory_view_get_path_at_pos (FilesAbstractDirectoryView* self,
                                                            gint x,
                                                            gint win);
VALA_EXTERN GtkTreePath* files_abstract_directory_view_get_path_at_cursor (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_tree_select_all (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_tree_unselect_all (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_tree_unselect_others (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_select_path (FilesAbstractDirectoryView* self,
                                                GtkTreePath* path,
                                                gboolean cursor_follows);
VALA_EXTERN void files_abstract_directory_view_unselect_path (FilesAbstractDirectoryView* self,
                                                  GtkTreePath* path);
VALA_EXTERN gboolean files_abstract_directory_view_path_is_selected (FilesAbstractDirectoryView* self,
                                                         GtkTreePath* path);
VALA_EXTERN gboolean files_abstract_directory_view_get_visible_range (FilesAbstractDirectoryView* self,
                                                          GtkTreePath** start_path,
                                                          GtkTreePath** end_path);
VALA_EXTERN void files_abstract_directory_view_set_cursor (FilesAbstractDirectoryView* self,
                                               GtkTreePath* path,
                                               gboolean start_editing,
                                               gboolean select,
                                               gboolean scroll_to_top);
VALA_EXTERN gboolean files_abstract_directory_view_move_cursor (FilesAbstractDirectoryView* self,
                                                    guint keyval,
                                                    gboolean only_shift_pressed,
                                                    gboolean control_pressed);
VALA_EXTERN gboolean files_abstract_directory_view_will_handle_button_press (FilesAbstractDirectoryView* self,
                                                                 gboolean no_mods,
                                                                 gboolean only_control_pressed,
                                                                 gboolean only_shift_pressed);
VALA_EXTERN gboolean files_abstract_directory_view_handle_multi_select (FilesAbstractDirectoryView* self,
                                                            GtkTreePath* path);
VALA_EXTERN GtkWidget* files_abstract_directory_view_create_view (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_set_up_zoom_level (FilesAbstractDirectoryView* self);
VALA_EXTERN FilesZoomLevel files_abstract_directory_view_get_normal_zoom_level (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_abstract_directory_view_view_has_focus (FilesAbstractDirectoryView* self);
VALA_EXTERN guint files_abstract_directory_view_get_selected_files_from_model (FilesAbstractDirectoryView* self,
                                                                   GList** selected_files);
VALA_EXTERN guint files_abstract_directory_view_get_event_position_info (FilesAbstractDirectoryView* self,
                                                             GdkEventButton* event,
                                                             GtkTreePath** path,
                                                             gboolean rubberband);
VALA_EXTERN void files_abstract_directory_view_scroll_to_cell (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path,
                                                   gboolean scroll_to_top);
VALA_EXTERN void files_abstract_directory_view_set_cursor_on_cell (FilesAbstractDirectoryView* self,
                                                       GtkTreePath* path,
                                                       GtkCellRenderer* renderer,
                                                       gboolean start_editing,
                                                       gboolean scroll_to_top);
VALA_EXTERN void files_abstract_directory_view_freeze_tree (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_thaw_tree (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_freeze_child_notify (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_thaw_child_notify (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_connect_tree_signals (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_disconnect_tree_signals (FilesAbstractDirectoryView* self);
VALA_EXTERN GType files_abstract_directory_view_click_zone_get_type (void) G_GNUC_CONST ;
static void files_abstract_directory_view_on_selection_action_open_executable (FilesAbstractDirectoryView* self,
                                                                        GSimpleAction* action,
                                                                        GVariant* param);
static void _files_abstract_directory_view_on_selection_action_open_executable_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                          GVariant* parameter,
                                                                                                          gpointer self);
static void files_abstract_directory_view_on_selection_action_open_with_app (FilesAbstractDirectoryView* self,
                                                                      GSimpleAction* action,
                                                                      GVariant* param);
static void _files_abstract_directory_view_on_selection_action_open_with_app_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                        GVariant* parameter,
                                                                                                        gpointer self);
static void files_abstract_directory_view_on_selection_action_open_with_default (FilesAbstractDirectoryView* self,
                                                                          GSimpleAction* action,
                                                                          GVariant* param);
static void _files_abstract_directory_view_on_selection_action_open_with_default_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                            GVariant* parameter,
                                                                                                            gpointer self);
static void files_abstract_directory_view_on_selection_action_open_with_other_app (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_selection_action_open_with_other_app_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                              GVariant* parameter,
                                                                                                              gpointer self);
static void files_abstract_directory_view_on_selection_action_rename (FilesAbstractDirectoryView* self,
                                                               GSimpleAction* action,
                                                               GVariant* param);
static void _files_abstract_directory_view_on_selection_action_rename_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                 GVariant* parameter,
                                                                                                 gpointer self);
static void files_abstract_directory_view_on_selection_action_view_in_location (FilesAbstractDirectoryView* self,
                                                                         GSimpleAction* action,
                                                                         GVariant* param);
static void _files_abstract_directory_view_on_selection_action_view_in_location_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                           GVariant* parameter,
                                                                                                           gpointer self);
static void files_abstract_directory_view_on_selection_action_forget (FilesAbstractDirectoryView* self,
                                                               GSimpleAction* action,
                                                               GVariant* param);
static void _files_abstract_directory_view_on_selection_action_forget_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                 GVariant* parameter,
                                                                                                 gpointer self);
static void files_abstract_directory_view_on_selection_action_cut (FilesAbstractDirectoryView* self,
                                                            GSimpleAction* action,
                                                            GVariant* param);
static void _files_abstract_directory_view_on_selection_action_cut_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                              GVariant* parameter,
                                                                                              gpointer self);
static void files_abstract_directory_view_on_selection_action_trash (FilesAbstractDirectoryView* self,
                                                              GSimpleAction* action,
                                                              GVariant* param);
static void _files_abstract_directory_view_on_selection_action_trash_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                GVariant* parameter,
                                                                                                gpointer self);
static void files_abstract_directory_view_on_selection_action_delete (FilesAbstractDirectoryView* self,
                                                               GSimpleAction* action,
                                                               GVariant* param);
static void _files_abstract_directory_view_on_selection_action_delete_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                 GVariant* parameter,
                                                                                                 gpointer self);
static void files_abstract_directory_view_on_selection_action_restore (FilesAbstractDirectoryView* self,
                                                                GSimpleAction* action,
                                                                GVariant* param);
static void _files_abstract_directory_view_on_selection_action_restore_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                  GVariant* parameter,
                                                                                                  gpointer self);
VALA_EXTERN void files_abstract_directory_view_invert_selection (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_invert_selection_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self);
static void files_abstract_directory_view_on_background_action_new (FilesAbstractDirectoryView* self,
                                                             GSimpleAction* action,
                                                             GVariant* param);
static void _files_abstract_directory_view_on_background_action_new_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                               GVariant* parameter,
                                                                                               gpointer self);
static void files_abstract_directory_view_on_background_action_create_from (FilesAbstractDirectoryView* self,
                                                                     GSimpleAction* action,
                                                                     GVariant* param);
static void _files_abstract_directory_view_on_background_action_create_from_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                       GVariant* parameter,
                                                                                                       gpointer self);
static void files_abstract_directory_view_on_background_action_sort_by_changed (FilesAbstractDirectoryView* self,
                                                                         GSimpleAction* action,
                                                                         GVariant* val);
static void _files_abstract_directory_view_on_background_action_sort_by_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                           GVariant* parameter,
                                                                                                           gpointer self);
static void files_abstract_directory_view_on_background_action_reverse_changed (FilesAbstractDirectoryView* self,
                                                                         GSimpleAction* action,
                                                                         GVariant* val);
static void _files_abstract_directory_view_on_background_action_reverse_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                           GVariant* parameter,
                                                                                                           gpointer self);
static void files_abstract_directory_view_on_background_action_folders_first_changed (FilesAbstractDirectoryView* self,
                                                                               GSimpleAction* action,
                                                                               GVariant* val);
static void _files_abstract_directory_view_on_background_action_folders_first_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                                 GVariant* parameter,
                                                                                                                 gpointer self);
static void files_abstract_directory_view_change_state_show_hidden (FilesAbstractDirectoryView* self,
                                                             GSimpleAction* action);
static void _files_abstract_directory_view_change_state_show_hidden_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                                   GVariant* value,
                                                                                                   gpointer self);
static void files_abstract_directory_view_change_state_show_remote_thumbnails (FilesAbstractDirectoryView* self,
                                                                        GSimpleAction* action);
static void _files_abstract_directory_view_change_state_show_remote_thumbnails_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                                              GVariant* value,
                                                                                                              gpointer self);
static void files_abstract_directory_view_change_state_show_local_thumbnails (FilesAbstractDirectoryView* self,
                                                                       GSimpleAction* action);
static void _files_abstract_directory_view_change_state_show_local_thumbnails_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                                             GVariant* value,
                                                                                                             gpointer self);
static void files_abstract_directory_view_on_common_action_copy (FilesAbstractDirectoryView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param);
static void _files_abstract_directory_view_on_common_action_copy_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self);
static void files_abstract_directory_view_on_common_action_paste_into (FilesAbstractDirectoryView* self,
                                                                GSimpleAction* action,
                                                                GVariant* param);
static void _files_abstract_directory_view_on_common_action_paste_into_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                  GVariant* parameter,
                                                                                                  gpointer self);
static void files_abstract_directory_view_on_common_action_paste (FilesAbstractDirectoryView* self,
                                                           GSimpleAction* action,
                                                           GVariant* param);
static void _files_abstract_directory_view_on_common_action_paste_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                             GVariant* parameter,
                                                                                             gpointer self);
static void files_abstract_directory_view_on_common_action_open_in (FilesAbstractDirectoryView* self,
                                                             GSimpleAction* action,
                                                             GVariant* param);
static void _files_abstract_directory_view_on_common_action_open_in_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                               GVariant* parameter,
                                                                                               gpointer self);
static void files_abstract_directory_view_on_common_action_bookmark (FilesAbstractDirectoryView* self,
                                                              GSimpleAction* action,
                                                              GVariant* param);
static void _files_abstract_directory_view_on_common_action_bookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                GVariant* parameter,
                                                                                                gpointer self);
static void files_abstract_directory_view_on_common_action_properties (FilesAbstractDirectoryView* self,
                                                                GSimpleAction* action,
                                                                GVariant* param);
static void _files_abstract_directory_view_on_common_action_properties_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                  GVariant* parameter,
                                                                                                  gpointer self);
static void files_abstract_directory_view_on_common_action_copy_link (FilesAbstractDirectoryView* self,
                                                               GSimpleAction* action,
                                                               GVariant* param);
static void _files_abstract_directory_view_on_common_action_copy_link_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                 GVariant* parameter,
                                                                                                 gpointer self);
static void files_abstract_directory_view_toggle_select_all (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_toggle_select_all_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void _vala_GtkTreePath_free (GtkTreePath* self);
VALA_EXTERN FilesAbstractDirectoryView* files_abstract_directory_view_construct (GType object_type,
                                                                     FilesViewSlot* _slot);
VALA_EXTERN FilesViewWindow* files_view_slot_get_window (FilesViewSlot* self);
VALA_EXTERN GType files_application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesApplication, g_object_unref)
VALA_EXTERN FilesClipboardManager* files_application_get_clipboard_manager (FilesApplication* self);
VALA_EXTERN GtkRecentManager* files_application_get_recent_manager (FilesApplication* self);
static void __lambda119_ (FilesAbstractDirectoryView* self,
                   guint req);
static void files_abstract_directory_view_draw_when_idle (FilesAbstractDirectoryView* self);
static void ___lambda119__files_thumbnailer_finished (FilesThumbnailer* _sender,
                                               guint request,
                                               gpointer self);
static void files_abstract_directory_view_set_up__menu_actions (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_set_up_directory_view (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_connect_drag_drop_signals (FilesAbstractDirectoryView* self,
                                                              GtkWidget* widget);
VALA_EXTERN gboolean files_abstract_directory_view_on_motion_notify_event (FilesAbstractDirectoryView* self,
                                                               GdkEventMotion* event);
static gboolean _files_abstract_directory_view_on_motion_notify_event_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                               GdkEventMotion* event,
                                                                                               gpointer self);
VALA_EXTERN gboolean files_abstract_directory_view_on_leave_notify_event (FilesAbstractDirectoryView* self,
                                                              GdkEventCrossing* event);
static gboolean _files_abstract_directory_view_on_leave_notify_event_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                                             GdkEventCrossing* event,
                                                                                             gpointer self);
static gboolean _files_abstract_directory_view_on_view_key_press_event_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                            GdkEventKey* event,
                                                                                            gpointer self);
static gboolean _files_abstract_directory_view_on_view_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                                  GdkEventButton* event,
                                                                                                  gpointer self);
static gboolean _files_abstract_directory_view_on_view_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                                      GdkEventButton* event,
                                                                                                      gpointer self);
static gboolean _files_abstract_directory_view_on_view_draw_gtk_widget_draw (GtkWidget* _sender,
                                                                      cairo_t* cr,
                                                                      gpointer self);
static void ___lambda131_ (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_schedule_thumbnail_color_tag_timeout (FilesAbstractDirectoryView* self);
static void ____lambda131__gtk_widget_realize (GtkWidget* _sender,
                                        gpointer self);
VALA_EXTERN void files_abstract_directory_view_connect_directory_handlers (FilesAbstractDirectoryView* self,
                                                               FilesDirectory* dir);
static void files_abstract_directory_view_real_set_up_name_renderer (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_on_name_edited (FilesAbstractDirectoryView* self,
                                                   const gchar* path_string,
                                                   const gchar* _new_name);
static void _files_abstract_directory_view_on_name_edited_gtk_cell_renderer_text_edited (GtkCellRendererText* _sender,
                                                                                  const gchar* path,
                                                                                  const gchar* new_text,
                                                                                  gpointer self);
VALA_EXTERN void files_abstract_directory_view_on_name_editing_canceled (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_name_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender,
                                                                                                 gpointer self);
VALA_EXTERN void files_abstract_directory_view_on_name_editing_started (FilesAbstractDirectoryView* self,
                                                            GtkCellEditable* editable,
                                                            const gchar* path_string);
static void _files_abstract_directory_view_on_name_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender,
                                                                                               GtkCellEditable* editable,
                                                                                               const gchar* path,
                                                                                               gpointer self);
static gboolean files_abstract_directory_view_on_popup_menu (FilesAbstractDirectoryView* self);
static gboolean _files_abstract_directory_view_on_popup_menu_gtk_widget_popup_menu (GtkWidget* _sender,
                                                                             gpointer self);
static void __lambda120_ (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_on_clipboard_changed (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_clipboard_changed_files_clipboard_manager_changed (FilesClipboardManager* _sender,
                                                                                          gpointer self);
static void ___lambda120__gtk_widget_unrealize (GtkWidget* _sender,
                                         gpointer self);
static void __lambda121_ (FilesAbstractDirectoryView* self);
static void ___lambda121__gtk_widget_realize (GtkWidget* _sender,
                                       gpointer self);
static gboolean _files_abstract_directory_view_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                                 GdkEventScroll* event,
                                                                                 gpointer self);
static void __lambda122_ (FilesAbstractDirectoryView* self);
static void ___lambda122__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                                 gpointer self);
static void __lambda123_ (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_abstract_directory_view_get_renaming (FilesAbstractDirectoryView* self);
static void ___lambda123__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void files_abstract_directory_view_on_show_hidden_files_changed (FilesAbstractDirectoryView* self,
                                                                 GObject* prefs,
                                                                 GParamSpec* pspec);
static void _files_abstract_directory_view_on_show_hidden_files_changed_g_object_notify (GObject* _sender,
                                                                                  GParamSpec* pspec,
                                                                                  gpointer self);
static void files_abstract_directory_view_on_show_remote_thumbnails_changed (FilesAbstractDirectoryView* self,
                                                                      GObject* prefs,
                                                                      GParamSpec* pspec);
static void _files_abstract_directory_view_on_show_remote_thumbnails_changed_g_object_notify (GObject* _sender,
                                                                                       GParamSpec* pspec,
                                                                                       gpointer self);
static void files_abstract_directory_view_on_show_local_thumbnails_changed (FilesAbstractDirectoryView* self,
                                                                     GObject* prefs,
                                                                     GParamSpec* pspec);
static void _files_abstract_directory_view_on_show_local_thumbnails_changed_g_object_notify (GObject* _sender,
                                                                                      GParamSpec* pspec,
                                                                                      gpointer self);
static void files_abstract_directory_view_on_sort_directories_first_changed (FilesAbstractDirectoryView* self,
                                                                      GObject* prefs,
                                                                      GParamSpec* pspec);
static void _files_abstract_directory_view_on_sort_directories_first_changed_g_object_notify (GObject* _sender,
                                                                                       GParamSpec* pspec,
                                                                                       gpointer self);
static void _files_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted (GtkTreeModel* _sender,
                                                                               GtkTreePath* path,
                                                                               gpointer self);
VALA_EXTERN void files_abstract_directory_view_on_sort_column_changed (FilesAbstractDirectoryView* self);
static void _files_abstract_directory_view_on_sort_column_changed_gtk_tree_sortable_sort_column_changed (GtkTreeSortable* _sender,
                                                                                                  gpointer self);
static void files_abstract_directory_view_action_set_state (FilesAbstractDirectoryView* self,
                                                     GSimpleActionGroup* action_group,
                                                     const gchar* name,
                                                     GVariant* val);
static GVariant* _variant_new1 (gboolean value);
static GVariant* _variant_new2 (gboolean value);
static GVariant* _variant_new3 (gboolean value);
VALA_EXTERN void files_abstract_directory_view_zoom_in (FilesAbstractDirectoryView* self);
VALA_EXTERN FilesZoomLevel files_abstract_directory_view_get_zoom_level (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_set_zoom_level (FilesAbstractDirectoryView* self,
                                                   FilesZoomLevel value);
VALA_EXTERN void files_abstract_directory_view_zoom_out (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_zoom_normal (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_focus_first_for_empty_selection (FilesAbstractDirectoryView* self,
                                                                    gboolean select);
static Block17Data* block17_data_ref (Block17Data* _data17_);
static void block17_data_unref (void * _userdata_);
static gboolean ___lambda73_ (Block17Data* _data17_);
VALA_EXTERN gboolean files_abstract_directory_view_get_tree_frozen (FilesAbstractDirectoryView* self);
static gboolean ____lambda73__gsource_func (gpointer self);
VALA_EXTERN void files_abstract_directory_view_select_glib_files_when_thawed (FilesAbstractDirectoryView* self,
                                                                  GList* location_list,
                                                                  GFile* focus_location);
static Block18Data* block18_data_ref (Block18Data* _data18_);
static void block18_data_unref (void * _userdata_);
static void __lambda71_ (Block18Data* _data18_,
                  GFile* loc);
static void ___lambda71__gfunc (gconstpointer data,
                         gpointer self);
static void ___lambda72_ (Block18Data* _data18_);
static void files_abstract_directory_view_select_files_and_update_if_thawed (FilesAbstractDirectoryView* self,
                                                                      GeeLinkedList* files_to_select,
                                                                      GFile* focus_file);
static void ____lambda72__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
VALA_EXTERN void files_abstract_directory_view_unselect_all (FilesAbstractDirectoryView* self);
static void _vala_GtkTreeIter_free (GtkTreeIter* self);
VALA_EXTERN void files_abstract_directory_view_on_view_selection_changed (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_update_selected_files_and_menu (FilesAbstractDirectoryView* self);
VALA_EXTERN GList* files_abstract_directory_view_get_open_with_apps (FilesAbstractDirectoryView* self);
VALA_EXTERN GAppInfo* files_abstract_directory_view_get_default_app (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_grab_focus (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_view_slot_get_is_active (FilesViewSlot* self);
VALA_EXTERN void files_abstract_directory_view_set_active_slot (FilesAbstractDirectoryView* self,
                                                    gboolean scroll);
VALA_EXTERN GList* files_abstract_directory_view_get_selected_files (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_load_location (FilesAbstractDirectoryView* self,
                                                  GFile* location);
VALA_EXTERN void files_abstract_directory_view_load_root_location (FilesAbstractDirectoryView* self,
                                                       GFile* location);
VALA_EXTERN void files_abstract_directory_view_activate_selected_items (FilesAbstractDirectoryView* self,
                                                            FilesOpenFlag flag,
                                                            GList* selection);
static Block19Data* block19_data_ref (Block19Data* _data19_);
static void block19_data_unref (void * _userdata_);
VALA_EXTERN gboolean files_abstract_directory_view_get_is_frozen (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_activate_file (FilesAbstractDirectoryView* self,
                                                  FilesFile* _file,
                                                  GdkScreen* screen,
                                                  FilesOpenFlag flag,
                                                  gboolean only_one_file);
static gboolean files_abstract_directory_view_app_is_this_app (FilesAbstractDirectoryView* self,
                                                        GAppInfo* ai);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
static gboolean _______lambda94_ (Block20Data* _data20_);
static gboolean ________lambda94__gsource_func (gpointer self);
static gboolean _______lambda95_ (Block20Data* _data20_);
static void files_abstract_directory_view_open_file (FilesAbstractDirectoryView* self,
                                              FilesFile* file,
                                              GdkScreen* screen,
                                              GAppInfo* app_info);
static gboolean ________lambda95__gsource_func (gpointer self);
static Block21Data* block21_data_ref (Block21Data* _data21_);
static void block21_data_unref (void * _userdata_);
static gboolean _____lambda96_ (Block21Data* _data21_);
static void files_abstract_directory_view_open_files_with (FilesAbstractDirectoryView* self,
                                                    GAppInfo* app,
                                                    GList* files);
static gboolean ______lambda96__gsource_func (gpointer self);
VALA_EXTERN void files_abstract_directory_view_select_gof_file (FilesAbstractDirectoryView* self,
                                                    FilesFile* file);
VALA_EXTERN void files_abstract_directory_view_select_and_scroll_to_gof_file (FilesAbstractDirectoryView* self,
                                                                  FilesFile* file);
VALA_EXTERN void files_abstract_directory_view_add_gof_file_to_selection (FilesAbstractDirectoryView* self,
                                                              FilesFile* file);
static void files_abstract_directory_view_on_directory_file_added (FilesAbstractDirectoryView* self,
                                                            FilesDirectory* dir,
                                                            FilesFile* file,
                                                            gboolean is_internal);
static void _files_abstract_directory_view_on_directory_file_added_files_directory_file_added (FilesDirectory* _sender,
                                                                                        FilesFile* file,
                                                                                        gboolean is_internal,
                                                                                        gpointer self);
static void files_abstract_directory_view_on_directory_file_changed (FilesAbstractDirectoryView* self,
                                                              FilesDirectory* dir,
                                                              FilesFile* file);
static void _files_abstract_directory_view_on_directory_file_changed_files_directory_file_changed (FilesDirectory* _sender,
                                                                                            FilesFile* file,
                                                                                            gpointer self);
static void files_abstract_directory_view_on_directory_file_deleted (FilesAbstractDirectoryView* self,
                                                              FilesDirectory* dir,
                                                              FilesFile* file);
static void _files_abstract_directory_view_on_directory_file_deleted_files_directory_file_deleted (FilesDirectory* _sender,
                                                                                            FilesFile* file,
                                                                                            gpointer self);
static void files_abstract_directory_view_on_directory_file_icon_changed (FilesAbstractDirectoryView* self,
                                                                   FilesDirectory* dir,
                                                                   FilesFile* file);
static void _files_abstract_directory_view_on_directory_file_icon_changed_files_directory_icon_changed (FilesDirectory* _sender,
                                                                                                 FilesFile* file,
                                                                                                 gpointer self);
VALA_EXTERN void files_abstract_directory_view_connect_directory_loading_handlers (FilesAbstractDirectoryView* self,
                                                                       FilesDirectory* dir);
static void files_abstract_directory_view_on_directory_file_loaded (FilesAbstractDirectoryView* self,
                                                             FilesDirectory* dir,
                                                             FilesFile* file);
static void _files_abstract_directory_view_on_directory_file_loaded_files_directory_file_loaded (FilesDirectory* _sender,
                                                                                          FilesFile* file,
                                                                                          gpointer self);
static void files_abstract_directory_view_on_directory_done_loading (FilesAbstractDirectoryView* self,
                                                              FilesDirectory* dir);
static void _files_abstract_directory_view_on_directory_done_loading_files_directory_done_loading (FilesDirectory* _sender,
                                                                                            gpointer self);
VALA_EXTERN void files_abstract_directory_view_disconnect_directory_loading_handlers (FilesAbstractDirectoryView* self,
                                                                          FilesDirectory* dir);
VALA_EXTERN void files_abstract_directory_view_disconnect_directory_handlers (FilesAbstractDirectoryView* self,
                                                                  FilesDirectory* dir);
VALA_EXTERN void files_abstract_directory_view_change_directory (FilesAbstractDirectoryView* self,
                                                     FilesDirectory* old_dir,
                                                     FilesDirectory* new_dir);
static void files_abstract_directory_view_clear (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_prepare_reload (FilesAbstractDirectoryView* self,
                                                   FilesDirectory* dir);
VALA_EXTERN void files_abstract_directory_view_block_model (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_unblock_model (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_on_drag_drop (FilesAbstractDirectoryView* self,
                                                     GdkDragContext* context,
                                                     gint x,
                                                     gint y,
                                                     guint timestamp);
static gboolean _files_abstract_directory_view_on_drag_drop_gtk_widget_drag_drop (GtkWidget* _sender,
                                                                           GdkDragContext* context,
                                                                           gint x,
                                                                           gint y,
                                                                           guint time_,
                                                                           gpointer self);
static void files_abstract_directory_view_on_drag_data_received (FilesAbstractDirectoryView* self,
                                                          GdkDragContext* context,
                                                          gint x,
                                                          gint y,
                                                          GtkSelectionData* selection_data,
                                                          guint info,
                                                          guint timestamp);
static void _files_abstract_directory_view_on_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                                         GdkDragContext* context,
                                                                                         gint x,
                                                                                         gint y,
                                                                                         GtkSelectionData* selection_data,
                                                                                         guint info,
                                                                                         guint time_,
                                                                                         gpointer self);
static void files_abstract_directory_view_on_drag_leave (FilesAbstractDirectoryView* self,
                                                  GdkDragContext* context,
                                                  guint timestamp);
static void _files_abstract_directory_view_on_drag_leave_gtk_widget_drag_leave (GtkWidget* _sender,
                                                                         GdkDragContext* context,
                                                                         guint time_,
                                                                         gpointer self);
static gboolean files_abstract_directory_view_on_drag_motion (FilesAbstractDirectoryView* self,
                                                       GdkDragContext* context,
                                                       gint x,
                                                       gint y,
                                                       guint timestamp);
static gboolean _files_abstract_directory_view_on_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender,
                                                                               GdkDragContext* context,
                                                                               gint x,
                                                                               gint y,
                                                                               guint time_,
                                                                               gpointer self);
static void files_abstract_directory_view_on_drag_begin (FilesAbstractDirectoryView* self,
                                                  GdkDragContext* context);
static void _files_abstract_directory_view_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                         GdkDragContext* context,
                                                                         gpointer self);
static void files_abstract_directory_view_on_drag_data_get (FilesAbstractDirectoryView* self,
                                                     GdkDragContext* context,
                                                     GtkSelectionData* selection_data,
                                                     guint info,
                                                     guint timestamp);
static void _files_abstract_directory_view_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                               GdkDragContext* context,
                                                                               GtkSelectionData* selection_data,
                                                                               guint info,
                                                                               guint time_,
                                                                               gpointer self);
static void files_abstract_directory_view_on_drag_data_delete (FilesAbstractDirectoryView* self,
                                                        GdkDragContext* context);
static void _files_abstract_directory_view_on_drag_data_delete_gtk_widget_drag_data_delete (GtkWidget* _sender,
                                                                                     GdkDragContext* context,
                                                                                     gpointer self);
static void files_abstract_directory_view_on_drag_end (FilesAbstractDirectoryView* self,
                                                GdkDragContext* context);
static void _files_abstract_directory_view_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                                     GdkDragContext* context,
                                                                     gpointer self);
VALA_EXTERN void files_abstract_directory_view_cancel_drag_timer (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_disconnect_drag_timeout_motion_and_release_events (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_cancel_timeout (FilesAbstractDirectoryView* self,
                                                   guint* id);
VALA_EXTERN void files_abstract_directory_view_cancel_thumbnailing (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_abstract_directory_view_selection_only_contains_folders (FilesAbstractDirectoryView* self,
                                                                        GList* list);
static Block22Data* block22_data_ref (Block22Data* _data22_);
static void block22_data_unref (void * _userdata_);
static void __lambda40_ (Block22Data* _data22_,
                  FilesFile* file);
static void ___lambda40__gfunc (gconstpointer data,
                         gpointer self);
VALA_EXTERN gboolean files_abstract_directory_view_handle_scroll_event (FilesAbstractDirectoryView* self,
                                                            GdkEventScroll* event);
VALA_EXTERN GList* files_abstract_directory_view_get_selected_files_for_transfer (FilesAbstractDirectoryView* self,
                                                                      GList* selection);
VALA_EXTERN gboolean files_abstract_directory_view_get_in_recent (FilesAbstractDirectoryView* self);
VALA_EXTERN GAppInfo* files_mime_actions_get_default_application_for_file (FilesFile* file);
static gboolean files_abstract_directory_view_can_open_file (FilesAbstractDirectoryView* self,
                                                      FilesFile* file,
                                                      gboolean show_error_dialog);
VALA_EXTERN void files_mime_actions_open_glib_file_request (GFile* file_to_open,
                                                GtkWidget* parent,
                                                GAppInfo* app);
static void files_abstract_directory_view_trash_or_delete_files (FilesAbstractDirectoryView* self,
                                                          GList* file_list,
                                                          gboolean delete_if_already_in_trash,
                                                          gboolean delete_immediately);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
static void ___lambda89_ (Block23Data* _data23_,
                   FilesFile* file);
static void ____lambda89__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda90_ (Block23Data* _data23_,
                   FilesFile* file);
static void ____lambda90__gfunc (gconstpointer data,
                          gpointer self);
static void ___lambda91_ (FilesAbstractDirectoryView* self,
                   GObject* obj,
                   GAsyncResult* res);
VALA_EXTERN void files_abstract_directory_view_after_trash_or_delete (FilesAbstractDirectoryView* self);
static void ____lambda91__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void files_abstract_directory_view_add_file (FilesAbstractDirectoryView* self,
                                             FilesFile* file,
                                             FilesDirectory* dir,
                                             gboolean is_internal);
static void files_abstract_directory_view_handle_free_space_change (FilesAbstractDirectoryView* self);
static gboolean ___lambda80_ (FilesAbstractDirectoryView* self);
static gboolean ____lambda80__gsource_func (gpointer self);
static void files_abstract_directory_view_new_empty_file (FilesAbstractDirectoryView* self,
                                                   const gchar* parent_uri);
static void __lambda115_ (FilesAbstractDirectoryView* self,
                   GObject* obj,
                   GAsyncResult* res);
VALA_EXTERN void files_abstract_directory_view_create_file_done (GFile* new_file,
                                                     FilesAbstractDirectoryView* self);
static void ___lambda115__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void files_abstract_directory_view_new_empty_folder (FilesAbstractDirectoryView* self);
static void __lambda97_ (FilesAbstractDirectoryView* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda97__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void files_abstract_directory_view_after_new_file_added (FilesAbstractDirectoryView* self,
                                                         FilesFile* file);
static void _files_abstract_directory_view_after_new_file_added_files_directory_file_added (FilesDirectory* _sender,
                                                                                     FilesFile* file,
                                                                                     gboolean is_internal,
                                                                                     gpointer self);
VALA_EXTERN void files_abstract_directory_view_rename_file (FilesAbstractDirectoryView* self,
                                                FilesFile* file_to_rename);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static gboolean ___lambda87_ (Block24Data* _data24_);
static void files_abstract_directory_view_start_renaming_file (FilesAbstractDirectoryView* self,
                                                        FilesFile* file);
static gboolean ____lambda87__gsource_func (gpointer self);
static void files_abstract_directory_view_unblock_directory_monitor (FilesAbstractDirectoryView* self);
static gboolean __lambda92_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda92__gsource_func (gpointer self);
static gboolean __lambda93_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda93__gsource_func (gpointer self);
static void files_abstract_directory_view_trash_or_delete_selected_files (FilesAbstractDirectoryView* self,
                                                                   gboolean delete_immediately);
static void files_abstract_directory_view_view_selected_file (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_forget_selected_file (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_rename_selection (FilesAbstractDirectoryView* self);
VALA_EXTERN GType files_renamer_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesRenamerDialog, g_object_unref)
VALA_EXTERN FilesRenamerDialog* files_renamer_dialog_new (GList* files,
                                              const gchar* basename);
VALA_EXTERN FilesRenamerDialog* files_renamer_dialog_construct (GType object_type,
                                                    GList* files,
                                                    const gchar* basename);
VALA_EXTERN void files_clipboard_manager_cut_files (FilesClipboardManager* self,
                                        GList* files);
VALA_EXTERN gboolean files_is_admin (void);
static GList* files_abstract_directory_view_get_files_for_action (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_view_window_bookmark_uri (FilesViewWindow* self,
                                     const gchar* uri,
                                     const gchar* custom_name);
VALA_EXTERN void files_view_window_change_state_show_hidden (FilesViewWindow* self,
                                                 GSimpleAction* action);
VALA_EXTERN void files_view_window_change_state_show_remote_thumbnails (FilesViewWindow* self,
                                                            GSimpleAction* action);
VALA_EXTERN void files_view_window_change_state_show_local_thumbnails (FilesViewWindow* self,
                                                           GSimpleAction* action);
static void files_abstract_directory_view_create_from_template (FilesAbstractDirectoryView* self,
                                                         GFile* template);
static void files_abstract_directory_view_set_sort (FilesAbstractDirectoryView* self,
                                             const gchar* col_name,
                                             gboolean reverse);
VALA_EXTERN FilesViewPropertiesWindow* files_view_properties_window_new (GList* _files,
                                                             FilesAbstractDirectoryView* _view,
                                                             GtkWindow* parent);
VALA_EXTERN FilesViewPropertiesWindow* files_view_properties_window_construct (GType object_type,
                                                                   GList* _files,
                                                                   FilesAbstractDirectoryView* _view,
                                                                   GtkWindow* parent);
VALA_EXTERN GType files_view_abstract_properties_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesViewAbstractPropertiesDialog, g_object_unref)
VALA_EXTERN GType files_view_properties_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesViewPropertiesWindow, g_object_unref)
VALA_EXTERN void files_clipboard_manager_copy_link_files (FilesClipboardManager* self,
                                              GList* files);
VALA_EXTERN void files_clipboard_manager_copy_files (FilesClipboardManager* self,
                                         GList* files);
VALA_EXTERN gboolean files_clipboard_manager_get_can_paste (FilesClipboardManager* self);
VALA_EXTERN gboolean files_clipboard_manager_get_files_linked (FilesClipboardManager* self);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
VALA_EXTERN void files_clipboard_manager_paste_files (FilesClipboardManager* self,
                                          GFile* target_file,
                                          GtkWidget* widget,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
VALA_EXTERN void files_clipboard_manager_paste_files_finish (FilesClipboardManager* self,
                                                 GAsyncResult* _res_);
static void ___lambda118_ (Block25Data* _data25_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda118__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block26Data* block26_data_ref (Block26Data* _data26_);
static void block26_data_unref (void * _userdata_);
VALA_EXTERN gboolean files_clipboard_manager_has_file (FilesClipboardManager* self,
                                           FilesFile* file);
static void ___lambda117_ (Block26Data* _data26_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda117__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
VALA_EXTERN void files_abstract_directory_view_select_all (FilesAbstractDirectoryView* self);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
static gboolean ___lambda81_ (Block27Data* _data27_);
static void files_abstract_directory_view_update_thumbnail_info_and_plugins (FilesAbstractDirectoryView* self,
                                                                      FilesFile* file);
static gboolean ____lambda81__gsource_func (gpointer self);
static Block28Data* block28_data_ref (Block28Data* _data28_);
static void block28_data_unref (void * _userdata_);
static void files_abstract_directory_view_remove_marlin_icon_info_cache (FilesAbstractDirectoryView* self,
                                                                  FilesFile* file);
static gboolean __lambda82_ (Block28Data* _data28_);
VALA_EXTERN gboolean files_abstract_directory_view_get_show_local_thumbnails (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_abstract_directory_view_get_show_remote_thumbnails (FilesAbstractDirectoryView* self);
static gboolean ___lambda82__gsource_func (gpointer self);
static void files_abstract_directory_view_set_in_recent (FilesAbstractDirectoryView* self,
                                                  gboolean value);
static gboolean __lambda76_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda76__gsource_func (gpointer self);
static void files_abstract_directory_view_on_zoom_level_changed (FilesAbstractDirectoryView* self,
                                                          FilesZoomLevel zoom);
VALA_EXTERN gint files_abstract_directory_view_get_icon_size (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_view_slot_refresh_files (FilesViewSlot* self);
static void files_abstract_directory_view_directory_hidden_changed (FilesAbstractDirectoryView* self,
                                                             FilesDirectory* dir,
                                                             gboolean show);
static GVariant* _variant_new4 (gboolean value);
VALA_EXTERN void files_abstract_directory_view_set_show_remote_thumbnails (FilesAbstractDirectoryView* self,
                                                               gboolean value);
static GVariant* _variant_new5 (gboolean value);
VALA_EXTERN void files_abstract_directory_view_set_show_local_thumbnails (FilesAbstractDirectoryView* self,
                                                              gboolean value);
static GVariant* _variant_new6 (gboolean value);
VALA_EXTERN void files_abstract_directory_view_show_context_menu (FilesAbstractDirectoryView* self,
                                                      GdkEvent* event);
static void _vala_GdkEvent_free (GdkEvent* self);
static gboolean files_abstract_directory_view_on_drag_timeout_button_release (FilesAbstractDirectoryView* self,
                                                                       GdkEventButton* event);
static gboolean files_abstract_directory_view_on_drag_timeout_motion_notify (FilesAbstractDirectoryView* self,
                                                                      GdkEventMotion* event);
static void files_abstract_directory_view_real_on_row_deleted (FilesAbstractDirectoryView* self,
                                                        GtkTreePath* path);
static void files_abstract_directory_view_check_destination_actions_and_target_file (FilesAbstractDirectoryView* self,
                                                                              GdkDragContext* context,
                                                                              gint x,
                                                                              gint y,
                                                                              guint timestamp);
static void files_abstract_directory_view_get_drag_data (FilesAbstractDirectoryView* self,
                                                  GdkDragContext* context,
                                                  gint x,
                                                  gint y,
                                                  guint timestamp);
static void files_abstract_directory_view_start_drag_scroll_timer (FilesAbstractDirectoryView* self,
                                                            GdkDragContext* context);
static FilesFile* files_abstract_directory_view_get_drop_target_file (FilesAbstractDirectoryView* self,
                                                               gint win_x,
                                                               gint win_y);
VALA_EXTERN GtkWindow* files_get_active_window (void);
static gboolean ____lambda125_ (FilesAbstractDirectoryView* self);
static gboolean _____lambda125__gsource_func (gpointer self);
static void files_abstract_directory_view_clear_destination_drag_data (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_icon_renderer_set_drop_file (FilesIconRenderer* self,
                                        FilesFile* value);
static gboolean files_abstract_directory_view_get_drop_highlight (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_set_drop_highlight (FilesAbstractDirectoryView* self,
                                                       gboolean value);
static void files_abstract_directory_view_highlight_drop_file (FilesAbstractDirectoryView* self,
                                                        FilesFile* drop_file,
                                                        GdkDragAction action,
                                                        GtkTreePath* path);
static gboolean files_abstract_directory_view_is_valid_drop_folder (FilesAbstractDirectoryView* self,
                                                             FilesFile* file);
static gboolean _____lambda126_ (FilesAbstractDirectoryView* self);
static gboolean ______lambda126__gsource_func (gpointer self);
VALA_EXTERN void files_abstract_directory_view_start_drag_timer (FilesAbstractDirectoryView* self,
                                                     GdkEvent* event);
static GdkEvent* _vala_GdkEvent_copy (GdkEvent* self);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
static void files_abstract_directory_view_connect_drag_timeout_motion_and_release_events (FilesAbstractDirectoryView* self);
static gboolean ___lambda128_ (Block29Data* _data29_);
static gboolean ____lambda128__gsource_func (gpointer self);
static void files_abstract_directory_view_update_menu_actions (FilesAbstractDirectoryView* self);
static GVariant* _variant_new7 (const gchar* value);
static GVariant* _variant_new8 (const gchar* value);
VALA_EXTERN GList* files_mime_actions_get_applications_for_files (GList* files);
static void files_abstract_directory_view_filter_default_app_from_open_with_apps (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_filter_this_app_from_open_with_apps (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_valid_selection_for_restore (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_valid_selection_for_edit (FilesAbstractDirectoryView* self);
VALA_EXTERN gboolean files_view_window_can_bookmark_uri (FilesViewWindow* self,
                                             const gchar* uri);
VALA_EXTERN gboolean files_clipboard_manager_has_cutted_file (FilesClipboardManager* self,
                                                  FilesFile* file);
static FilesAbstractDirectoryViewSortSubMenuItem* files_abstract_directory_view_sort_sub_menu_item_new (void);
static FilesAbstractDirectoryViewSortSubMenuItem* files_abstract_directory_view_sort_sub_menu_item_construct (GType object_type);
static GType files_abstract_directory_view_sort_sub_menu_item_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesAbstractDirectoryViewSortSubMenuItem, g_object_unref)
static FilesAbstractDirectoryViewNewSubMenuItem* files_abstract_directory_view_new_sub_menu_item_new (void);
static FilesAbstractDirectoryViewNewSubMenuItem* files_abstract_directory_view_new_sub_menu_item_construct (GType object_type);
static GType files_abstract_directory_view_new_sub_menu_item_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesAbstractDirectoryViewNewSubMenuItem, g_object_unref)
static void files_abstract_directory_view_action_set_enabled (FilesAbstractDirectoryView* self,
                                                       GSimpleActionGroup* action_group,
                                                       const gchar* name,
                                                       gboolean enabled);
static void files_abstract_directory_view_update_default_app (FilesAbstractDirectoryView* self,
                                                       GList* selection);
static void files_abstract_directory_view_update_menu_actions_sort (FilesAbstractDirectoryView* self);
VALA_EXTERN GAppInfo* files_mime_actions_get_default_application_for_files (GList* files);
static void files_abstract_directory_view_load_templates_from_folder (GFile* template_folder);
static gint ___lambda41_ (GFile* a,
                   GFile* b);
static gint ____lambda41__gcompare_func (gconstpointer a,
                                  gconstpointer b);
static void ___lambda42_ (GFile* folder);
static void ____lambda42__gfunc (gconstpointer data,
                          gpointer self);
static void __lambda116_ (FilesAbstractDirectoryView* self,
                   GObject* obj,
                   GAsyncResult* res);
static void ___lambda116__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
VALA_EXTERN void files_mime_actions_open_multiple_gof_files_request (GList* gofs_to_open,
                                                         GtkWidget* parent,
                                                         GAppInfo* app);
static gboolean __lambda77_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda77__gsource_func (gpointer self);
VALA_EXTERN gint files_view_slot_get_displayed_files_count (FilesViewSlot* self);
static gboolean __lambda78_ (FilesAbstractDirectoryView* self);
static GtkTreePath* _vala_GtkTreePath_copy (GtkTreePath* self);
static gboolean ___lambda78__gsource_func (gpointer self);
static gboolean __lambda79_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda79__gsource_func (gpointer self);
static gboolean _files_abstract_directory_view_on_drag_timeout_button_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                                        GdkEventButton* event,
                                                                                                        gpointer self);
static gboolean _files_abstract_directory_view_on_drag_timeout_motion_notify_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                                      GdkEventMotion* event,
                                                                                                      gpointer self);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
static gboolean __lambda127_ (Block30Data* _data30_);
static void files_abstract_directory_view_scroll_if_near_edge (FilesAbstractDirectoryView* self,
                                                        gint pos,
                                                        gint dim,
                                                        gint threshold,
                                                        GtkAdjustment* adj);
static gboolean ___lambda127__gsource_func (gpointer self);
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
static void ____lambda39_ (Block31Data* _data31_,
                    FilesFile* file);
static void _____lambda39__gfunc (gconstpointer data,
                           gpointer self);
VALA_EXTERN void files_abstract_directory_view_on_view_items_activated (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_real_on_view_key_press_event (FilesAbstractDirectoryView* self,
                                                                     GdkEventKey* event);
static void files_abstract_directory_view_cancel_hover (FilesAbstractDirectoryView* self);
VALA_EXTERN guint key_utils_map_key (GdkEventKey* event,
                         GdkModifierType* consumed_mods);
static gboolean __lambda98_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda98__gsource_func (gpointer self);
VALA_EXTERN gboolean files_abstract_directory_view_get_singleclick_select (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_real_on_scroll_event (FilesAbstractDirectoryView* self,
                                                             GdkEventScroll* event);
VALA_EXTERN GType files_abstract_editable_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FilesAbstractEditableLabel, g_object_unref)
VALA_EXTERN gchar* files_abstract_editable_label_get_chars (FilesAbstractEditableLabel* self,
                                                gint start_pos,
                                                gint end_pos);
static GtkTreeIter* _vala_GtkTreeIter_copy (GtkTreeIter* self);
VALA_EXTERN void files_abstract_editable_label_select_region (FilesAbstractEditableLabel* self,
                                                  gint start_pos,
                                                  gint end_pos);
VALA_EXTERN void files_abstract_directory_view_set_is_frozen (FilesAbstractDirectoryView* self,
                                                  gboolean value);
VALA_EXTERN void files_abstract_directory_view_set_renaming (FilesAbstractDirectoryView* self,
                                                 gboolean value);
VALA_EXTERN void files_abstract_directory_view_set_file_display_name (FilesAbstractDirectoryView* self,
                                                          GFile* old_location,
                                                          const gchar* new_name,
                                                          GCancellable* cancellable,
                                                          GAsyncReadyCallback _callback_,
                                                          gpointer _user_data_);
VALA_EXTERN GFile* files_abstract_directory_view_set_file_display_name_finish (FilesAbstractDirectoryView* self,
                                                                   GAsyncResult* _res_,
                                                                   GError** error);
static void ____lambda101_ (FilesAbstractDirectoryView* self,
                     GObject* obj,
                     GAsyncResult* res);
static void _____lambda101__gasync_ready_callback (GObject* source_object,
                                            GAsyncResult* res,
                                            gpointer self);
static void files_abstract_directory_view_set_file_display_name_data_free (gpointer _data);
static gboolean files_abstract_directory_view_set_file_display_name_co (FilesAbstractDirectoryViewSetFileDisplayNameData* _data_);
static void files_abstract_directory_view_after_renamed_file_added (FilesAbstractDirectoryView* self,
                                                             FilesFile* new_file);
static void _files_abstract_directory_view_after_renamed_file_added_files_directory_file_added (FilesDirectory* _sender,
                                                                                         FilesFile* file,
                                                                                         gboolean is_internal,
                                                                                         gpointer self);
static void files_abstract_directory_view_set_file_display_name_ready (GObject* source_object,
                                                                GAsyncResult* _res_,
                                                                gpointer _user_data_);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
static gboolean ___lambda100_ (Block32Data* _data32_);
static gboolean ____lambda100__gsource_func (gpointer self);
static gboolean files_abstract_directory_view_real_on_view_draw (FilesAbstractDirectoryView* self,
                                                          cairo_t* cr);
VALA_EXTERN gchar* files_view_slot_get_empty_message (FilesViewSlot* self);
static PangoRectangle* _pango_rectangle_dup (PangoRectangle* self);
static gboolean files_abstract_directory_view_real_handle_primary_button_click (FilesAbstractDirectoryView* self,
                                                                         GdkEventButton* event,
                                                                         GtkTreePath* path);
static gboolean files_abstract_directory_view_real_handle_secondary_button_click (FilesAbstractDirectoryView* self,
                                                                           GdkEventButton* event);
VALA_EXTERN void files_abstract_directory_view_block_drag_and_drop (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_unblock_drag_and_drop (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_real_on_view_button_press_event (FilesAbstractDirectoryView* self,
                                                                        GdkEventButton* event);
VALA_EXTERN void files_text_renderer_end_editing (FilesTextRenderer* self,
                                      gboolean cancel);
static gboolean files_abstract_directory_view_real_on_view_button_release_event (FilesAbstractDirectoryView* self,
                                                                          GdkEventButton* event);
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
static gboolean ____lambda129_ (Block33Data* _data33_);
static gboolean _____lambda129__gsource_func (gpointer self);
static gboolean __lambda130_ (FilesAbstractDirectoryView* self);
static gboolean ___lambda130__gsource_func (gpointer self);
static void files_abstract_directory_view_real_change_zoom_level (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_icon_renderer_set_zoom_level (FilesIconRenderer* self,
                                         FilesZoomLevel value);
VALA_EXTERN void files_text_renderer_set_zoom_level (FilesTextRenderer* self,
                                         FilesZoomLevel value);
static Block34Data* block34_data_ref (Block34Data* _data34_);
static void block34_data_unref (void * _userdata_);
static gboolean __lambda88_ (Block34Data* _data34_);
static gboolean ___lambda88__gsource_func (gpointer self);
static Block35Data* block35_data_ref (Block35Data* _data35_);
static void block35_data_unref (void * _userdata_);
static void ___lambda124_ (Block35Data* _data35_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda124__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static gboolean files_abstract_directory_view_real_expand_collapse (FilesAbstractDirectoryView* self,
                                                             GtkTreePath* path);
static gboolean files_abstract_directory_view_real_handle_default_button_click (FilesAbstractDirectoryView* self,
                                                                         GdkEventButton* event);
static gboolean files_abstract_directory_view_real_get_next_visible_iter (FilesAbstractDirectoryView* self,
                                                                   GtkTreeIter* iter,
                                                                   gboolean recurse);
static void files_abstract_directory_view_real_cancel (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_close (FilesAbstractDirectoryView* self);
static void __vala_GtkTreePath_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreePath_free0_ (GList* self);
static GtkTreeRowReference* _vala_GtkTreeRowReference_copy (GtkTreeRowReference* self);
static void _vala_GtkTreeRowReference_free (GtkTreeRowReference* self);
static void __vala_GtkTreeRowReference_free0_ (gpointer var);
static inline void _g_list_free___vala_GtkTreeRowReference_free0_ (GList* self);
VALA_EXTERN void files_abstract_directory_view_unselect_others (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_highlight_path (FilesAbstractDirectoryView* self,
                                                        GtkTreePath* path);
static GtkTreePath* files_abstract_directory_view_real_up (FilesAbstractDirectoryView* self,
                                                    GtkTreePath* path);
static GtkTreePath* files_abstract_directory_view_real_down (FilesAbstractDirectoryView* self,
                                                      GtkTreePath* path);
static GList* files_abstract_directory_view_real_get_selected_paths (FilesAbstractDirectoryView* self);
static GtkTreePath* files_abstract_directory_view_real_get_path_at_pos (FilesAbstractDirectoryView* self,
                                                                 gint x,
                                                                 gint win);
static GtkTreePath* files_abstract_directory_view_real_get_path_at_cursor (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_tree_select_all (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_tree_unselect_all (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_tree_unselect_others (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_select_path (FilesAbstractDirectoryView* self,
                                                     GtkTreePath* path,
                                                     gboolean cursor_follows);
static void files_abstract_directory_view_real_unselect_path (FilesAbstractDirectoryView* self,
                                                       GtkTreePath* path);
static gboolean files_abstract_directory_view_real_path_is_selected (FilesAbstractDirectoryView* self,
                                                              GtkTreePath* path);
static gboolean files_abstract_directory_view_real_get_visible_range (FilesAbstractDirectoryView* self,
                                                               GtkTreePath** start_path,
                                                               GtkTreePath** end_path);
static void files_abstract_directory_view_real_set_cursor (FilesAbstractDirectoryView* self,
                                                    GtkTreePath* path,
                                                    gboolean start_editing,
                                                    gboolean select,
                                                    gboolean scroll_to_top);
static gboolean files_abstract_directory_view_real_move_cursor (FilesAbstractDirectoryView* self,
                                                         guint keyval,
                                                         gboolean only_shift_pressed,
                                                         gboolean control_pressed);
static gboolean files_abstract_directory_view_real_will_handle_button_press (FilesAbstractDirectoryView* self,
                                                                      gboolean no_mods,
                                                                      gboolean only_control_pressed,
                                                                      gboolean only_shift_pressed);
VALA_EXTERN gboolean files_abstract_directory_view_is_on_icon (FilesAbstractDirectoryView* self,
                                                   gint x,
                                                   gint y,
                                                   gboolean* on_helper);
static gboolean files_abstract_directory_view_real_handle_multi_select (FilesAbstractDirectoryView* self,
                                                                 GtkTreePath* path);
static GtkWidget* files_abstract_directory_view_real_create_view (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_set_up_zoom_level (FilesAbstractDirectoryView* self);
static FilesZoomLevel files_abstract_directory_view_real_get_normal_zoom_level (FilesAbstractDirectoryView* self);
static gboolean files_abstract_directory_view_real_view_has_focus (FilesAbstractDirectoryView* self);
static guint files_abstract_directory_view_real_get_selected_files_from_model (FilesAbstractDirectoryView* self,
                                                                        GList** selected_files);
static guint files_abstract_directory_view_real_get_event_position_info (FilesAbstractDirectoryView* self,
                                                                  GdkEventButton* event,
                                                                  GtkTreePath** path,
                                                                  gboolean rubberband);
static void files_abstract_directory_view_real_scroll_to_cell (FilesAbstractDirectoryView* self,
                                                        GtkTreePath* path,
                                                        gboolean scroll_to_top);
static void files_abstract_directory_view_real_set_cursor_on_cell (FilesAbstractDirectoryView* self,
                                                            GtkTreePath* path,
                                                            GtkCellRenderer* renderer,
                                                            gboolean start_editing,
                                                            gboolean scroll_to_top);
static void files_abstract_directory_view_real_freeze_tree (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_thaw_tree (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_freeze_child_notify (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_thaw_child_notify (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_connect_tree_signals (FilesAbstractDirectoryView* self);
static void files_abstract_directory_view_real_disconnect_tree_signals (FilesAbstractDirectoryView* self);
VALA_EXTERN void files_abstract_directory_view_set_singleclick_select (FilesAbstractDirectoryView* self,
                                                           gboolean value);
VALA_EXTERN void files_abstract_directory_view_set_tree_frozen (FilesAbstractDirectoryView* self,
                                                    gboolean value);
static void g_cclosure_user_marshal_VOID__OBJECT_ENUM_BOOLEAN (GClosure * closure,
                                                        GValue * return_value,
                                                        guint n_param_values,
                                                        const GValue * param_values,
                                                        gpointer invocation_hint,
                                                        gpointer marshal_data);
static GObject * files_abstract_directory_view_sort_sub_menu_item_constructor (GType type,
                                                                        guint n_construct_properties,
                                                                        GObjectConstructParam * construct_properties);
static GVariant* _variant_new9 (const gchar* value);
static GVariant* _variant_new10 (const gchar* value);
static GVariant* _variant_new11 (const gchar* value);
static GVariant* _variant_new12 (const gchar* value);
static GType files_abstract_directory_view_sort_sub_menu_item_get_type_once (void);
static GObject * files_abstract_directory_view_new_sub_menu_item_constructor (GType type,
                                                                       guint n_construct_properties,
                                                                       GObjectConstructParam * construct_properties);
static GVariant* _variant_new13 (const gchar* value);
static GVariant* _variant_new14 (const gchar* value);
static GType files_abstract_directory_view_new_sub_menu_item_get_type_once (void);
static void files_abstract_directory_view_finalize (GObject * obj);
static GType files_abstract_directory_view_get_type_once (void);
static void _vala_files_abstract_directory_view_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec);
static void _vala_files_abstract_directory_view_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static const GtkTargetEntry FILES_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS[2] = {{"text/plain", (guint) GTK_TARGET_SAME_APP, (guint) FILES_TARGET_TYPE_STRING}, {"text/uri-list", (guint) GTK_TARGET_SAME_APP, (guint) FILES_TARGET_TYPE_TEXT_URI_LIST}};
static const GtkTargetEntry FILES_ABSTRACT_DIRECTORY_VIEW_DROP_TARGETS[4] = {{"text/uri-list", (guint) GTK_TARGET_SAME_APP, (guint) FILES_TARGET_TYPE_TEXT_URI_LIST}, {"text/uri-list", (guint) GTK_TARGET_OTHER_APP, (guint) FILES_TARGET_TYPE_TEXT_URI_LIST}, {"XdndDirectSave0", (guint) GTK_TARGET_OTHER_APP, (guint) FILES_TARGET_TYPE_XDND_DIRECT_SAVE0}, {"_NETSCAPE_URL", (guint) GTK_TARGET_OTHER_APP, (guint) FILES_TARGET_TYPE_NETSCAPE_URL}};
static const GActionEntry FILES_ABSTRACT_DIRECTORY_VIEW_SELECTION_ENTRIES[12] = {{"open", _files_abstract_directory_view_on_selection_action_open_executable_gsimple_action_activate_callback}, {"open-with-app", _files_abstract_directory_view_on_selection_action_open_with_app_gsimple_action_activate_callback, "u"}, {"open-with-default", _files_abstract_directory_view_on_selection_action_open_with_default_gsimple_action_activate_callback}, {"open-with-other-app", _files_abstract_directory_view_on_selection_action_open_with_other_app_gsimple_action_activate_callback}, {"rename", _files_abstract_directory_view_on_selection_action_rename_gsimple_action_activate_callback}, {"view-in-location", _files_abstract_directory_view_on_selection_action_view_in_location_gsimple_action_activate_callback}, {"forget", _files_abstract_directory_view_on_selection_action_forget_gsimple_action_activate_callback}, {"cut", _files_abstract_directory_view_on_selection_action_cut_gsimple_action_activate_callback}, {"trash", _files_abstract_directory_view_on_selection_action_trash_gsimple_action_activate_callback}, {"delete", _files_abstract_directory_view_on_selection_action_delete_gsimple_action_activate_callback}, {"restore", _files_abstract_directory_view_on_selection_action_restore_gsimple_action_activate_callback}, {"invert-selection", _files_abstract_directory_view_invert_selection_gsimple_action_activate_callback}};
static const GActionEntry FILES_ABSTRACT_DIRECTORY_VIEW_BACKGROUND_ENTRIES[8] = {{"new", _files_abstract_directory_view_on_background_action_new_gsimple_action_activate_callback, "s"}, {"create-from", _files_abstract_directory_view_on_background_action_create_from_gsimple_action_activate_callback, "s"}, {"sort-by", _files_abstract_directory_view_on_background_action_sort_by_changed_gsimple_action_activate_callback, "s", "'name'"}, {"reverse", _files_abstract_directory_view_on_background_action_reverse_changed_gsimple_action_activate_callback, NULL, "false"}, {"folders-first", _files_abstract_directory_view_on_background_action_folders_first_changed_gsimple_action_activate_callback, NULL, "true"}, {"show-hidden", NULL, NULL, "false", _files_abstract_directory_view_change_state_show_hidden_gsimple_action_change_state_callback}, {"show-remote-thumbnails", NULL, NULL, "true", _files_abstract_directory_view_change_state_show_remote_thumbnails_gsimple_action_change_state_callback}, {"show-local-thumbnails", NULL, NULL, "true", _files_abstract_directory_view_change_state_show_local_thumbnails_gsimple_action_change_state_callback}};
static const GActionEntry FILES_ABSTRACT_DIRECTORY_VIEW_COMMON_ENTRIES[8] = {{"copy", _files_abstract_directory_view_on_common_action_copy_gsimple_action_activate_callback}, {"paste-into", _files_abstract_directory_view_on_common_action_paste_into_gsimple_action_activate_callback}, {"paste", _files_abstract_directory_view_on_common_action_paste_gsimple_action_activate_callback}, {"open-in", _files_abstract_directory_view_on_common_action_open_in_gsimple_action_activate_callback, "s"}, {"bookmark", _files_abstract_directory_view_on_common_action_bookmark_gsimple_action_activate_callback}, {"properties", _files_abstract_directory_view_on_common_action_properties_gsimple_action_activate_callback}, {"copy-link", _files_abstract_directory_view_on_common_action_copy_link_gsimple_action_activate_callback}, {"select-all", _files_abstract_directory_view_toggle_select_all_gsimple_action_activate_callback}};

static inline gpointer
files_abstract_directory_view_get_instance_private (FilesAbstractDirectoryView* self)
{
	return G_STRUCT_MEMBER_P (self, FilesAbstractDirectoryView_private_offset);
}

 G_GNUC_NO_INLINE static GType
files_abstract_directory_view_click_zone_get_type_once (void)
{
	static const GEnumValue values[] = {{FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_EXPANDER, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_EXPANDER", "expander"}, {FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER", "helper"}, {FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON", "icon"}, {FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME", "name"}, {FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH", "blank-path"}, {FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH", "blank-no-path"}, {FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID, "FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID", "invalid"}, {0, NULL, NULL}};
	GType files_abstract_directory_view_click_zone_type_id;
	files_abstract_directory_view_click_zone_type_id = g_enum_register_static ("FilesAbstractDirectoryViewClickZone", values);
	return files_abstract_directory_view_click_zone_type_id;
}

GType
files_abstract_directory_view_click_zone_get_type (void)
{
	static volatile gsize files_abstract_directory_view_click_zone_type_id__once = 0;
	if (g_once_init_enter (&files_abstract_directory_view_click_zone_type_id__once)) {
		GType files_abstract_directory_view_click_zone_type_id;
		files_abstract_directory_view_click_zone_type_id = files_abstract_directory_view_click_zone_get_type_once ();
		g_once_init_leave (&files_abstract_directory_view_click_zone_type_id__once, files_abstract_directory_view_click_zone_type_id);
	}
	return files_abstract_directory_view_click_zone_type_id__once;
}

static void
_files_abstract_directory_view_on_selection_action_open_executable_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                     GVariant* parameter,
                                                                                                     gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_open_executable ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1754 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_open_with_app_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                   GVariant* parameter,
                                                                                                   gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_open_with_app ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1764 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_open_with_default_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                       GVariant* parameter,
                                                                                                       gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_open_with_default ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1774 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_open_with_other_app_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                         GVariant* parameter,
                                                                                                         gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_open_with_other_app ((FilesAbstractDirectoryView*) self);
#line 1784 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_rename_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_rename ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1794 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_view_in_location_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                      GVariant* parameter,
                                                                                                      gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_view_in_location ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1804 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_forget_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_forget ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1814 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_cut_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                         GVariant* parameter,
                                                                                         gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_cut ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1824 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_trash_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                           GVariant* parameter,
                                                                                           gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_trash ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1834 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_delete_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_delete ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1844 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_selection_action_restore_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                             GVariant* parameter,
                                                                                             gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_selection_action_restore ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1854 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_invert_selection_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                  GVariant* parameter,
                                                                                  gpointer self)
{
#line 58 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_invert_selection ((FilesAbstractDirectoryView*) self);
#line 1864 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_background_action_new_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_background_action_new ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1874 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_background_action_create_from_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                  GVariant* parameter,
                                                                                                  gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_background_action_create_from ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1884 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_background_action_sort_by_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                      GVariant* parameter,
                                                                                                      gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_background_action_sort_by_changed ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1894 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_background_action_reverse_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                      GVariant* parameter,
                                                                                                      gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_background_action_reverse_changed ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1904 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_background_action_folders_first_changed_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                                            GVariant* parameter,
                                                                                                            gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_background_action_folders_first_changed ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1914 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_change_state_show_hidden_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                              GVariant* value,
                                                                                              gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_change_state_show_hidden ((FilesAbstractDirectoryView*) self, action);
#line 1924 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_change_state_show_remote_thumbnails_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                                         GVariant* value,
                                                                                                         gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_change_state_show_remote_thumbnails ((FilesAbstractDirectoryView*) self, action);
#line 1934 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_change_state_show_local_thumbnails_gsimple_action_change_state_callback (GSimpleAction* action,
                                                                                                        GVariant* value,
                                                                                                        gpointer self)
{
#line 73 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_change_state_show_local_thumbnails ((FilesAbstractDirectoryView*) self, action);
#line 1944 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_copy_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                       GVariant* parameter,
                                                                                       gpointer self)
{
#line 84 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_copy ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1954 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_paste_into_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                             GVariant* parameter,
                                                                                             gpointer self)
{
#line 84 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_paste_into ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1964 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_paste_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                        GVariant* parameter,
                                                                                        gpointer self)
{
#line 84 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_paste ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1974 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_open_in_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                          GVariant* parameter,
                                                                                          gpointer self)
{
#line 84 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_open_in ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1984 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_bookmark_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                           GVariant* parameter,
                                                                                           gpointer self)
{
#line 84 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_bookmark ((FilesAbstractDirectoryView*) self, action, parameter);
#line 1994 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_properties_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                             GVariant* parameter,
                                                                                             gpointer self)
{
#line 84 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_properties ((FilesAbstractDirectoryView*) self, action, parameter);
#line 2004 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_common_action_copy_link_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                            GVariant* parameter,
                                                                                            gpointer self)
{
#line 84 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_common_action_copy_link ((FilesAbstractDirectoryView*) self, action, parameter);
#line 2014 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_toggle_select_all_gsimple_action_activate_callback (GSimpleAction* action,
                                                                                   GVariant* parameter,
                                                                                   gpointer self)
{
#line 84 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_toggle_select_all ((FilesAbstractDirectoryView*) self);
#line 2024 "AbstractDirectoryView.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 133 "../src/View/AbstractDirectoryView.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2032 "AbstractDirectoryView.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 133 "../src/View/AbstractDirectoryView.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2040 "AbstractDirectoryView.c"
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 187 "../src/View/AbstractDirectoryView.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 2048 "AbstractDirectoryView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 287 "../src/View/AbstractDirectoryView.vala"
	return self ? g_object_ref (self) : NULL;
#line 2056 "AbstractDirectoryView.c"
}

static void
__lambda119_ (FilesAbstractDirectoryView* self,
              guint req)
{
#line 294 "../src/View/AbstractDirectoryView.vala"
	if (req == ((guint) self->priv->thumbnail_request)) {
#line 295 "../src/View/AbstractDirectoryView.vala"
		self->priv->thumbnail_request = -1;
#line 2067 "AbstractDirectoryView.c"
	}
#line 298 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_draw_when_idle (self);
#line 2071 "AbstractDirectoryView.c"
}

static void
___lambda119__files_thumbnailer_finished (FilesThumbnailer* _sender,
                                          guint request,
                                          gpointer self)
{
#line 293 "../src/View/AbstractDirectoryView.vala"
	__lambda119_ ((FilesAbstractDirectoryView*) self, request);
#line 2081 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_motion_notify_event_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                      GdkEventMotion* event,
                                                                                      gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_motion_notify_event ((FilesAbstractDirectoryView*) self, event);
#line 324 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2093 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_leave_notify_event_gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                                    GdkEventCrossing* event,
                                                                                    gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_leave_notify_event ((FilesAbstractDirectoryView*) self, event);
#line 325 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2105 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_view_key_press_event_gtk_widget_key_press_event (GtkWidget* _sender,
                                                                                   GdkEventKey* event,
                                                                                   gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_view_key_press_event ((FilesAbstractDirectoryView*) self, event);
#line 326 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2117 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_view_button_press_event_gtk_widget_button_press_event (GtkWidget* _sender,
                                                                                         GdkEventButton* event,
                                                                                         gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_view_button_press_event ((FilesAbstractDirectoryView*) self, event);
#line 327 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2129 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_view_button_release_event_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                             GdkEventButton* event,
                                                                                             gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_view_button_release_event ((FilesAbstractDirectoryView*) self, event);
#line 328 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2141 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_view_draw_gtk_widget_draw (GtkWidget* _sender,
                                                             cairo_t* cr,
                                                             gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_view_draw ((FilesAbstractDirectoryView*) self, cr);
#line 329 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2153 "AbstractDirectoryView.c"
}

static void
___lambda131_ (FilesAbstractDirectoryView* self)
{
#line 331 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_schedule_thumbnail_color_tag_timeout (self);
#line 2161 "AbstractDirectoryView.c"
}

static void
____lambda131__gtk_widget_realize (GtkWidget* _sender,
                                   gpointer self)
{
#line 330 "../src/View/AbstractDirectoryView.vala"
	___lambda131_ ((FilesAbstractDirectoryView*) self);
#line 2170 "AbstractDirectoryView.c"
}

FilesAbstractDirectoryView*
files_abstract_directory_view_construct (GType object_type,
                                         FilesViewSlot* _slot)
{
	FilesAbstractDirectoryView * self = NULL;
	FilesViewWindow* _tmp0_;
	FilesViewWindow* _tmp1_;
	GdkDisplay* _tmp2_;
	GdkCursor* _tmp3_;
	GdkDisplay* _tmp4_;
	GdkCursor* _tmp5_;
	GdkDisplay* _tmp6_;
	GdkCursor* _tmp7_;
	FilesApplication* app = NULL;
	GApplication* _tmp8_;
	FilesApplication* _tmp9_;
	FilesApplication* _tmp10_;
	FilesClipboardManager* _tmp11_;
	FilesApplication* _tmp12_;
	GtkRecentManager* _tmp13_;
	FilesApplication* _tmp14_;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	FilesApplication* _tmp18_;
	gchar* _tmp19_;
	gchar** _tmp20_;
	gchar** _tmp21_;
	gint _tmp21__length1;
	FilesThumbnailer* _tmp22_;
	FilesThumbnailer* _tmp23_;
	FilesListModel* _tmp24_;
	GSettings* _tmp25_;
	GSettings* _tmp26_;
	GtkWidget* _tmp27_;
	GtkWidget* _tmp28_;
	FilesViewSlot* _tmp39_;
	FilesDirectory* _tmp40_;
	FilesDirectory* _tmp41_;
#line 280 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (_slot != NULL, NULL);
#line 280 "../src/View/AbstractDirectoryView.vala"
	self = (FilesAbstractDirectoryView*) g_object_new (object_type, NULL);
#line 281 "../src/View/AbstractDirectoryView.vala"
	self->slot = _slot;
#line 282 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_view_slot_get_window (_slot);
#line 282 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 282 "../src/View/AbstractDirectoryView.vala"
	self->window = _tmp1_;
#line 283 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = gdk_display_get_default ();
#line 283 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = gdk_cursor_new_from_name (_tmp2_, "text");
#line 283 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->editable_cursor);
#line 283 "../src/View/AbstractDirectoryView.vala"
	self->priv->editable_cursor = _tmp3_;
#line 284 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = gdk_display_get_default ();
#line 284 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = gdk_cursor_new_from_name (_tmp4_, "pointer");
#line 284 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->activatable_cursor);
#line 284 "../src/View/AbstractDirectoryView.vala"
	self->priv->activatable_cursor = _tmp5_;
#line 285 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = gdk_display_get_default ();
#line 285 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = gdk_cursor_new_from_name (_tmp6_, "default");
#line 285 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->selectable_cursor);
#line 285 "../src/View/AbstractDirectoryView.vala"
	self->priv->selectable_cursor = _tmp7_;
#line 287 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = g_application_get_default ();
#line 287 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, FILES_TYPE_APPLICATION, FilesApplication));
#line 287 "../src/View/AbstractDirectoryView.vala"
	app = _tmp9_;
#line 288 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = app;
#line 288 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = files_application_get_clipboard_manager (_tmp10_);
#line 288 "../src/View/AbstractDirectoryView.vala"
	self->priv->clipboard = _tmp11_;
#line 289 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = app;
#line 289 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = files_application_get_recent_manager (_tmp12_);
#line 289 "../src/View/AbstractDirectoryView.vala"
	self->recent = _tmp13_;
#line 290 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = app;
#line 290 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = g_strdup ("<Ctrl>A");
#line 290 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 290 "../src/View/AbstractDirectoryView.vala"
	_tmp16_[0] = _tmp15_;
#line 290 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = _tmp16_;
#line 290 "../src/View/AbstractDirectoryView.vala"
	_tmp17__length1 = 1;
#line 290 "../src/View/AbstractDirectoryView.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp14_, "common.select-all", _tmp17_);
#line 290 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 291 "../src/View/AbstractDirectoryView.vala"
	_tmp18_ = app;
#line 291 "../src/View/AbstractDirectoryView.vala"
	_tmp19_ = g_strdup ("<Shift><Ctrl>A");
#line 291 "../src/View/AbstractDirectoryView.vala"
	_tmp20_ = g_new0 (gchar*, 1 + 1);
#line 291 "../src/View/AbstractDirectoryView.vala"
	_tmp20_[0] = _tmp19_;
#line 291 "../src/View/AbstractDirectoryView.vala"
	_tmp21_ = _tmp20_;
#line 291 "../src/View/AbstractDirectoryView.vala"
	_tmp21__length1 = 1;
#line 291 "../src/View/AbstractDirectoryView.vala"
	gtk_application_set_accels_for_action ((GtkApplication*) _tmp18_, "selection.invert-selection", _tmp21_);
#line 291 "../src/View/AbstractDirectoryView.vala"
	_tmp21_ = (_vala_array_free (_tmp21_, _tmp21__length1, (GDestroyNotify) g_free), NULL);
#line 292 "../src/View/AbstractDirectoryView.vala"
	_tmp22_ = files_thumbnailer_get ();
#line 292 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->thumbnailer);
#line 292 "../src/View/AbstractDirectoryView.vala"
	self->priv->thumbnailer = _tmp22_;
#line 293 "../src/View/AbstractDirectoryView.vala"
	_tmp23_ = self->priv->thumbnailer;
#line 293 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (_tmp23_, "finished", (GCallback) ___lambda119__files_thumbnailer_finished, self, 0);
#line 301 "../src/View/AbstractDirectoryView.vala"
	_tmp24_ = files_list_model_new ();
#line 301 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->model);
#line 301 "../src/View/AbstractDirectoryView.vala"
	self->model = _tmp24_;
#line 303 "../src/View/AbstractDirectoryView.vala"
	_tmp25_ = files_app_settings;
#line 303 "../src/View/AbstractDirectoryView.vala"
	g_settings_bind (_tmp25_, "show-remote-thumbnails", (GObject*) self, "show_remote_thumbnails", G_SETTINGS_BIND_GET);
#line 305 "../src/View/AbstractDirectoryView.vala"
	_tmp26_ = files_app_settings;
#line 305 "../src/View/AbstractDirectoryView.vala"
	g_settings_bind (_tmp26_, "show-local-thumbnails", (GObject*) self, "show_local_thumbnails", G_SETTINGS_BIND_GET);
#line 312 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_up__menu_actions (self);
#line 313 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_up_directory_view (self);
#line 314 "../src/View/AbstractDirectoryView.vala"
	_tmp27_ = files_abstract_directory_view_create_view (self);
#line 314 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->view);
#line 314 "../src/View/AbstractDirectoryView.vala"
	self->priv->view = _tmp27_;
#line 316 "../src/View/AbstractDirectoryView.vala"
	_tmp28_ = self->priv->view;
#line 316 "../src/View/AbstractDirectoryView.vala"
	if (_tmp28_ != NULL) {
#line 2337 "AbstractDirectoryView.c"
		GtkWidget* _tmp29_;
		GtkWidget* _tmp30_;
		GtkWidget* _tmp31_;
		GtkWidget* _tmp32_;
		GtkWidget* _tmp33_;
		GtkWidget* _tmp34_;
		GtkWidget* _tmp35_;
		GtkWidget* _tmp36_;
		GtkWidget* _tmp37_;
		GtkWidget* _tmp38_;
#line 317 "../src/View/AbstractDirectoryView.vala"
		_tmp29_ = self->priv->view;
#line 317 "../src/View/AbstractDirectoryView.vala"
		g_object_set ((GtkContainer*) self, "child", _tmp29_, NULL);
#line 318 "../src/View/AbstractDirectoryView.vala"
		gtk_widget_show_all ((GtkWidget*) self);
#line 319 "../src/View/AbstractDirectoryView.vala"
		_tmp30_ = self->priv->view;
#line 319 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_connect_drag_drop_signals (self, _tmp30_);
#line 320 "../src/View/AbstractDirectoryView.vala"
		_tmp31_ = self->priv->view;
#line 320 "../src/View/AbstractDirectoryView.vala"
		gtk_widget_add_events (_tmp31_, (gint) ((GDK_POINTER_MOTION_MASK | GDK_ENTER_NOTIFY_MASK) | GDK_LEAVE_NOTIFY_MASK));
#line 324 "../src/View/AbstractDirectoryView.vala"
		_tmp32_ = self->priv->view;
#line 324 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp32_, "motion-notify-event", (GCallback) _files_abstract_directory_view_on_motion_notify_event_gtk_widget_motion_notify_event, self, 0);
#line 325 "../src/View/AbstractDirectoryView.vala"
		_tmp33_ = self->priv->view;
#line 325 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp33_, "leave-notify-event", (GCallback) _files_abstract_directory_view_on_leave_notify_event_gtk_widget_leave_notify_event, self, 0);
#line 326 "../src/View/AbstractDirectoryView.vala"
		_tmp34_ = self->priv->view;
#line 326 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp34_, "key-press-event", (GCallback) _files_abstract_directory_view_on_view_key_press_event_gtk_widget_key_press_event, self, 0);
#line 327 "../src/View/AbstractDirectoryView.vala"
		_tmp35_ = self->priv->view;
#line 327 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp35_, "button-press-event", (GCallback) _files_abstract_directory_view_on_view_button_press_event_gtk_widget_button_press_event, self, 0);
#line 328 "../src/View/AbstractDirectoryView.vala"
		_tmp36_ = self->priv->view;
#line 328 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp36_, "button-release-event", (GCallback) _files_abstract_directory_view_on_view_button_release_event_gtk_widget_button_release_event, self, 0);
#line 329 "../src/View/AbstractDirectoryView.vala"
		_tmp37_ = self->priv->view;
#line 329 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp37_, "draw", (GCallback) _files_abstract_directory_view_on_view_draw_gtk_widget_draw, self, 0);
#line 330 "../src/View/AbstractDirectoryView.vala"
		_tmp38_ = self->priv->view;
#line 330 "../src/View/AbstractDirectoryView.vala"
		g_signal_connect_object (_tmp38_, "realize", (GCallback) ____lambda131__gtk_widget_realize, self, 0);
#line 2390 "AbstractDirectoryView.c"
	}
#line 335 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_freeze_tree (self);
#line 336 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_up_zoom_level (self);
#line 338 "../src/View/AbstractDirectoryView.vala"
	_tmp39_ = self->slot;
#line 338 "../src/View/AbstractDirectoryView.vala"
	_tmp40_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp39_);
#line 338 "../src/View/AbstractDirectoryView.vala"
	_tmp41_ = _tmp40_;
#line 338 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_directory_handlers (self, _tmp41_);
#line 280 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (app);
#line 280 "../src/View/AbstractDirectoryView.vala"
	return self;
#line 2408 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_name_edited_gtk_cell_renderer_text_edited (GtkCellRendererText* _sender,
                                                                             const gchar* path,
                                                                             const gchar* new_text,
                                                                             gpointer self)
{
#line 347 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_name_edited ((FilesAbstractDirectoryView*) self, path, new_text);
#line 2419 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_name_editing_canceled_gtk_cell_renderer_editing_canceled (GtkCellRenderer* _sender,
                                                                                            gpointer self)
{
#line 348 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_name_editing_canceled ((FilesAbstractDirectoryView*) self);
#line 2428 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_name_editing_started_gtk_cell_renderer_editing_started (GtkCellRenderer* _sender,
                                                                                          GtkCellEditable* editable,
                                                                                          const gchar* path,
                                                                                          gpointer self)
{
#line 349 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_name_editing_started ((FilesAbstractDirectoryView*) self, editable, path);
#line 2439 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_set_up_name_renderer (FilesAbstractDirectoryView* self)
{
	FilesTextRenderer* _tmp0_;
	FilesTextRenderer* _tmp1_;
	FilesTextRenderer* _tmp2_;
	FilesTextRenderer* _tmp3_;
#line 346 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->name_renderer;
#line 346 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkCellRendererText*) _tmp0_, "editable", FALSE, NULL);
#line 347 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->name_renderer;
#line 347 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkCellRendererText*) _tmp1_, "edited", (GCallback) _files_abstract_directory_view_on_name_edited_gtk_cell_renderer_text_edited, self, 0);
#line 348 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->name_renderer;
#line 348 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkCellRenderer*) _tmp2_, "editing-canceled", (GCallback) _files_abstract_directory_view_on_name_editing_canceled_gtk_cell_renderer_editing_canceled, self, 0);
#line 349 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->name_renderer;
#line 349 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkCellRenderer*) _tmp3_, "editing-started", (GCallback) _files_abstract_directory_view_on_name_editing_started_gtk_cell_renderer_editing_started, self, 0);
#line 2465 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_up_name_renderer (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 345 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 345 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 345 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->set_up_name_renderer) {
#line 345 "../src/View/AbstractDirectoryView.vala"
		_klass_->set_up_name_renderer (self);
#line 2480 "AbstractDirectoryView.c"
	}
}

static gboolean
_files_abstract_directory_view_on_popup_menu_gtk_widget_popup_menu (GtkWidget* _sender,
                                                                    gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_popup_menu ((FilesAbstractDirectoryView*) self);
#line 356 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2492 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_clipboard_changed_files_clipboard_manager_changed (FilesClipboardManager* _sender,
                                                                                     gpointer self)
{
#line 359 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_clipboard_changed ((FilesAbstractDirectoryView*) self);
#line 2501 "AbstractDirectoryView.c"
}

static void
__lambda120_ (FilesAbstractDirectoryView* self)
{
	FilesClipboardManager* _tmp0_;
	guint _tmp1_;
#line 359 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->clipboard;
#line 359 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("changed", FILES_TYPE_CLIPBOARD_MANAGER, &_tmp1_, NULL, FALSE);
#line 359 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _files_abstract_directory_view_on_clipboard_changed_files_clipboard_manager_changed, self);
#line 2515 "AbstractDirectoryView.c"
}

static void
___lambda120__gtk_widget_unrealize (GtkWidget* _sender,
                                    gpointer self)
{
#line 358 "../src/View/AbstractDirectoryView.vala"
	__lambda120_ ((FilesAbstractDirectoryView*) self);
#line 2524 "AbstractDirectoryView.c"
}

static void
__lambda121_ (FilesAbstractDirectoryView* self)
{
	FilesClipboardManager* _tmp0_;
#line 363 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->clipboard;
#line 363 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (_tmp0_, "changed", (GCallback) _files_abstract_directory_view_on_clipboard_changed_files_clipboard_manager_changed, self, 0);
#line 364 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_clipboard_changed (self);
#line 2537 "AbstractDirectoryView.c"
}

static void
___lambda121__gtk_widget_realize (GtkWidget* _sender,
                                  gpointer self)
{
#line 362 "../src/View/AbstractDirectoryView.vala"
	__lambda121_ ((FilesAbstractDirectoryView*) self);
#line 2546 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_scroll_event_gtk_widget_scroll_event (GtkWidget* _sender,
                                                                        GdkEventScroll* event,
                                                                        gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_scroll_event ((FilesAbstractDirectoryView*) self, event);
#line 367 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2558 "AbstractDirectoryView.c"
}

static void
__lambda122_ (FilesAbstractDirectoryView* self)
{
#line 370 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_schedule_thumbnail_color_tag_timeout (self);
#line 2566 "AbstractDirectoryView.c"
}

static void
___lambda122__gtk_adjustment_value_changed (GtkAdjustment* _sender,
                                            gpointer self)
{
#line 369 "../src/View/AbstractDirectoryView.vala"
	__lambda122_ ((FilesAbstractDirectoryView*) self);
#line 2575 "AbstractDirectoryView.c"
}

static void
__lambda123_ (FilesAbstractDirectoryView* self)
{
	GtkWidget* vscroll_bar = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	gboolean _tmp2_;
#line 376 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_scrolled_window_get_vscrollbar ((GtkScrolledWindow*) self);
#line 376 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 376 "../src/View/AbstractDirectoryView.vala"
	vscroll_bar = _tmp1_;
#line 377 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->priv->_renaming;
#line 377 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_set_visible (vscroll_bar, !_tmp2_);
#line 373 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (vscroll_bar);
#line 2597 "AbstractDirectoryView.c"
}

static void
___lambda123__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 373 "../src/View/AbstractDirectoryView.vala"
	__lambda123_ ((FilesAbstractDirectoryView*) self);
#line 2607 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_show_hidden_files_changed_g_object_notify (GObject* _sender,
                                                                             GParamSpec* pspec,
                                                                             gpointer self)
{
#line 382 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_show_hidden_files_changed ((FilesAbstractDirectoryView*) self, _sender, pspec);
#line 2617 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_show_remote_thumbnails_changed_g_object_notify (GObject* _sender,
                                                                                  GParamSpec* pspec,
                                                                                  gpointer self)
{
#line 383 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_show_remote_thumbnails_changed ((FilesAbstractDirectoryView*) self, _sender, pspec);
#line 2627 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_show_local_thumbnails_changed_g_object_notify (GObject* _sender,
                                                                                 GParamSpec* pspec,
                                                                                 gpointer self)
{
#line 384 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_show_local_thumbnails_changed ((FilesAbstractDirectoryView*) self, _sender, pspec);
#line 2637 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_sort_directories_first_changed_g_object_notify (GObject* _sender,
                                                                                  GParamSpec* pspec,
                                                                                  gpointer self)
{
#line 385 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_sort_directories_first_changed ((FilesAbstractDirectoryView*) self, _sender, pspec);
#line 2647 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted (GtkTreeModel* _sender,
                                                                          GtkTreePath* path,
                                                                          gpointer self)
{
#line 391 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_row_deleted ((FilesAbstractDirectoryView*) self, path);
#line 2657 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_sort_column_changed_gtk_tree_sortable_sort_column_changed (GtkTreeSortable* _sender,
                                                                                             gpointer self)
{
#line 393 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_sort_column_changed ((FilesAbstractDirectoryView*) self);
#line 2666 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_up_directory_view (FilesAbstractDirectoryView* self)
{
	GtkAdjustment* _tmp0_;
	FilesPreferences* prefs = NULL;
	FilesPreferences* _tmp1_;
	FilesListModel* _tmp2_;
	FilesPreferences* _tmp3_;
	FilesPreferences* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	FilesListModel* _tmp7_;
	FilesListModel* _tmp8_;
#line 352 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 353 "../src/View/AbstractDirectoryView.vala"
	gtk_scrolled_window_set_policy ((GtkScrolledWindow*) self, GTK_POLICY_NEVER, GTK_POLICY_AUTOMATIC);
#line 354 "../src/View/AbstractDirectoryView.vala"
	gtk_scrolled_window_set_shadow_type ((GtkScrolledWindow*) self, GTK_SHADOW_NONE);
#line 356 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkWidget*) self, "popup-menu", (GCallback) _files_abstract_directory_view_on_popup_menu_gtk_widget_popup_menu, self, 0);
#line 358 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkWidget*) self, "unrealize", (GCallback) ___lambda120__gtk_widget_unrealize, self, 0);
#line 362 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkWidget*) self, "realize", (GCallback) ___lambda121__gtk_widget_realize, self, 0);
#line 367 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkWidget*) self, "scroll-event", (GCallback) _files_abstract_directory_view_on_scroll_event_gtk_widget_scroll_event, self, 0);
#line 369 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 369 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (_tmp0_, "value-changed", (GCallback) ___lambda122__gtk_adjustment_value_changed, self, G_CONNECT_AFTER);
#line 373 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GObject*) self, "notify::renaming", (GCallback) ___lambda123__g_object_notify, self, 0);
#line 381 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_preferences_get_default ();
#line 381 "../src/View/AbstractDirectoryView.vala"
	prefs = _tmp1_;
#line 382 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GObject*) prefs, "notify::show-hidden-files", (GCallback) _files_abstract_directory_view_on_show_hidden_files_changed_g_object_notify, self, 0);
#line 383 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GObject*) prefs, "notify::show-remote-thumbnails", (GCallback) _files_abstract_directory_view_on_show_remote_thumbnails_changed_g_object_notify, self, 0);
#line 384 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GObject*) prefs, "notify::show-local-thumbnails", (GCallback) _files_abstract_directory_view_on_show_local_thumbnails_changed_g_object_notify, self, 0);
#line 385 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GObject*) prefs, "notify::sort-directories-first", (GCallback) _files_abstract_directory_view_on_sort_directories_first_changed_g_object_notify, self, 0);
#line 386 "../src/View/AbstractDirectoryView.vala"
	g_object_bind_property_with_closures ((GObject*) prefs, "singleclick-select", (GObject*) self, "singleclick_select", G_BINDING_DEFAULT | G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 390 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->model;
#line 390 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_preferences_get_default ();
#line 390 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 390 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = files_preferences_get_sort_directories_first (_tmp4_);
#line 390 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_;
#line 390 "../src/View/AbstractDirectoryView.vala"
	files_list_model_set_should_sort_directories_first (_tmp2_, _tmp6_);
#line 390 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp4_);
#line 391 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->model;
#line 391 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkTreeModel*) _tmp7_, "row-deleted", (GCallback) _files_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted, self, 0);
#line 393 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = self->model;
#line 393 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkTreeSortable*) _tmp8_, "sort-column-changed", (GCallback) _files_abstract_directory_view_on_sort_column_changed_gtk_tree_sortable_sort_column_changed, self, 0);
#line 352 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (prefs);
#line 2740 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new1 (gboolean value)
{
#line 409 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 2748 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new2 (gboolean value)
{
#line 412 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 2756 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new3 (gboolean value)
{
#line 415 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 2764 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_up__menu_actions (FilesAbstractDirectoryView* self)
{
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
	GSimpleActionGroup* _tmp2_;
	GSimpleActionGroup* _tmp3_;
	GSimpleActionGroup* _tmp4_;
	GSimpleActionGroup* _tmp5_;
	GSimpleActionGroup* _tmp6_;
	GSimpleActionGroup* _tmp7_;
	GSimpleActionGroup* _tmp8_;
	GSimpleActionGroup* _tmp9_;
	GSettings* _tmp10_;
	GVariant* _tmp11_;
	GSimpleActionGroup* _tmp12_;
	GSettings* _tmp13_;
	GVariant* _tmp14_;
	GSimpleActionGroup* _tmp15_;
	GSettings* _tmp16_;
	GVariant* _tmp17_;
#line 396 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 397 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_simple_action_group_new ();
#line 397 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->selection_actions);
#line 397 "../src/View/AbstractDirectoryView.vala"
	self->priv->selection_actions = _tmp0_;
#line 398 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->selection_actions;
#line 398 "../src/View/AbstractDirectoryView.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp1_, FILES_ABSTRACT_DIRECTORY_VIEW_SELECTION_ENTRIES, (gint) G_N_ELEMENTS (FILES_ABSTRACT_DIRECTORY_VIEW_SELECTION_ENTRIES), self);
#line 399 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->priv->selection_actions;
#line 399 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "selection", (GActionGroup*) _tmp2_);
#line 401 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = g_simple_action_group_new ();
#line 401 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->background_actions);
#line 401 "../src/View/AbstractDirectoryView.vala"
	self->priv->background_actions = _tmp3_;
#line 402 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = self->priv->background_actions;
#line 402 "../src/View/AbstractDirectoryView.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp4_, FILES_ABSTRACT_DIRECTORY_VIEW_BACKGROUND_ENTRIES, (gint) G_N_ELEMENTS (FILES_ABSTRACT_DIRECTORY_VIEW_BACKGROUND_ENTRIES), self);
#line 403 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = self->priv->background_actions;
#line 403 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "background", (GActionGroup*) _tmp5_);
#line 405 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = g_simple_action_group_new ();
#line 405 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->common_actions);
#line 405 "../src/View/AbstractDirectoryView.vala"
	self->priv->common_actions = _tmp6_;
#line 406 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->priv->common_actions;
#line 406 "../src/View/AbstractDirectoryView.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp7_, FILES_ABSTRACT_DIRECTORY_VIEW_COMMON_ENTRIES, (gint) G_N_ELEMENTS (FILES_ABSTRACT_DIRECTORY_VIEW_COMMON_ENTRIES), self);
#line 407 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = self->priv->common_actions;
#line 407 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "common", (GActionGroup*) _tmp8_);
#line 409 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = self->priv->background_actions;
#line 409 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = files_app_settings;
#line 409 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = _variant_new1 (g_settings_get_boolean (_tmp10_, "show-hiddenfiles"));
#line 409 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_state (self, _tmp9_, "show-hidden", _tmp11_);
#line 409 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp11_);
#line 412 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = self->priv->background_actions;
#line 412 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = files_app_settings;
#line 412 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = _variant_new2 (g_settings_get_boolean (_tmp13_, "show-remote-thumbnails"));
#line 412 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_state (self, _tmp12_, "show-remote-thumbnails", _tmp14_);
#line 412 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp14_);
#line 415 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = self->priv->background_actions;
#line 415 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = files_app_settings;
#line 415 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = _variant_new3 (g_settings_get_boolean (_tmp16_, "show-local-thumbnails"));
#line 415 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_state (self, _tmp15_, "show-local-thumbnails", _tmp17_);
#line 415 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp17_);
#line 2862 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_zoom_in (FilesAbstractDirectoryView* self)
{
	FilesZoomLevel _tmp0_;
	FilesZoomLevel _tmp1_;
#line 419 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 420 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_zoom_level (self);
#line 420 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 420 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_zoom_level (self, _tmp1_ + 1);
#line 2878 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_zoom_out (FilesAbstractDirectoryView* self)
{
	FilesZoomLevel _tmp0_;
	FilesZoomLevel _tmp1_;
#line 423 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 424 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_zoom_level (self);
#line 424 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 424 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ > 0) {
#line 2894 "AbstractDirectoryView.c"
		FilesZoomLevel _tmp2_;
		FilesZoomLevel _tmp3_;
#line 425 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_abstract_directory_view_get_zoom_level (self);
#line 425 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 425 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_zoom_level (self, _tmp3_ - 1);
#line 2903 "AbstractDirectoryView.c"
	}
}

void
files_abstract_directory_view_zoom_normal (FilesAbstractDirectoryView* self)
{
#line 429 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 430 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_zoom_level (self, files_abstract_directory_view_get_normal_zoom_level (self));
#line 2914 "AbstractDirectoryView.c"
}

static Block17Data*
block17_data_ref (Block17Data* _data17_)
{
#line 434 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data17_->_ref_count_);
#line 434 "../src/View/AbstractDirectoryView.vala"
	return _data17_;
#line 2924 "AbstractDirectoryView.c"
}

static void
block17_data_unref (void * _userdata_)
{
	Block17Data* _data17_;
	_data17_ = (Block17Data*) _userdata_;
#line 434 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data17_->_ref_count_)) {
#line 2934 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 434 "../src/View/AbstractDirectoryView.vala"
		self = _data17_->self;
#line 434 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 434 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block17Data, _data17_);
#line 2942 "AbstractDirectoryView.c"
	}
}

static gboolean
___lambda73_ (Block17Data* _data17_)
{
	FilesAbstractDirectoryView* self;
	gboolean _tmp0_;
	gboolean result;
#line 436 "../src/View/AbstractDirectoryView.vala"
	self = _data17_->self;
#line 437 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->_tree_frozen;
#line 437 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp0_) {
#line 2958 "AbstractDirectoryView.c"
		GtkTreePath* _tmp1_;
		GtkTreePath* _tmp2_;
#line 438 "../src/View/AbstractDirectoryView.vala"
		self->priv->set_cursor_timeout_id = (guint) 0;
#line 439 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = gtk_tree_path_new_from_indices (0, -1);
#line 439 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_;
#line 439 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_cursor (self, _tmp2_, FALSE, _data17_->select, TRUE);
#line 439 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (_tmp2_);
#line 440 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_REMOVE;
#line 440 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 2975 "AbstractDirectoryView.c"
	} else {
#line 442 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 442 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 2981 "AbstractDirectoryView.c"
	}
}

static gboolean
____lambda73__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda73_ (self);
#line 436 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 2992 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_focus_first_for_empty_selection (FilesAbstractDirectoryView* self,
                                                               gboolean select)
{
	Block17Data* _data17_;
	GList* _tmp0_;
#line 434 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 434 "../src/View/AbstractDirectoryView.vala"
	_data17_ = g_slice_new0 (Block17Data);
#line 434 "../src/View/AbstractDirectoryView.vala"
	_data17_->_ref_count_ = 1;
#line 434 "../src/View/AbstractDirectoryView.vala"
	_data17_->self = g_object_ref (self);
#line 434 "../src/View/AbstractDirectoryView.vala"
	_data17_->select = select;
#line 435 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 435 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 436 "../src/View/AbstractDirectoryView.vala"
		self->priv->set_cursor_timeout_id = g_idle_add_full (G_PRIORITY_LOW, ____lambda73__gsource_func, block17_data_ref (_data17_), block17_data_unref);
#line 3017 "AbstractDirectoryView.c"
	}
#line 434 "../src/View/AbstractDirectoryView.vala"
	block17_data_unref (_data17_);
#line 434 "../src/View/AbstractDirectoryView.vala"
	_data17_ = NULL;
#line 3023 "AbstractDirectoryView.c"
}

static Block18Data*
block18_data_ref (Block18Data* _data18_)
{
#line 453 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data18_->_ref_count_);
#line 453 "../src/View/AbstractDirectoryView.vala"
	return _data18_;
#line 3033 "AbstractDirectoryView.c"
}

static void
block18_data_unref (void * _userdata_)
{
	Block18Data* _data18_;
	_data18_ = (Block18Data*) _userdata_;
#line 453 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data18_->_ref_count_)) {
#line 3043 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 453 "../src/View/AbstractDirectoryView.vala"
		self = _data18_->self;
#line 453 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data18_->focus_after_select);
#line 453 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data18_->files_to_select_list);
#line 453 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 453 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block18Data, _data18_);
#line 3055 "AbstractDirectoryView.c"
	}
}

static void
__lambda71_ (Block18Data* _data18_,
             GFile* loc)
{
	FilesAbstractDirectoryView* self;
	GeeLinkedList* _tmp0_;
	FilesFile* _tmp1_;
	FilesFile* _tmp2_;
#line 455 "../src/View/AbstractDirectoryView.vala"
	self = _data18_->self;
#line 455 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (loc != NULL);
#line 456 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _data18_->files_to_select_list;
#line 456 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_file_get (loc);
#line 456 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 456 "../src/View/AbstractDirectoryView.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, _tmp2_);
#line 456 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp2_);
#line 3081 "AbstractDirectoryView.c"
}

static void
___lambda71__gfunc (gconstpointer data,
                    gpointer self)
{
#line 455 "../src/View/AbstractDirectoryView.vala"
	__lambda71_ (self, (GFile*) data);
#line 3090 "AbstractDirectoryView.c"
}

static void
___lambda72_ (Block18Data* _data18_)
{
	FilesAbstractDirectoryView* self;
	GeeLinkedList* _tmp0_;
	GFile* _tmp1_;
#line 466 "../src/View/AbstractDirectoryView.vala"
	self = _data18_->self;
#line 467 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _data18_->files_to_select_list;
#line 467 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _data18_->focus_after_select;
#line 467 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_select_files_and_update_if_thawed (self, _tmp0_, _tmp1_);
#line 3107 "AbstractDirectoryView.c"
}

static void
____lambda72__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 466 "../src/View/AbstractDirectoryView.vala"
	___lambda72_ (self);
#line 3117 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_select_glib_files_when_thawed (FilesAbstractDirectoryView* self,
                                                             GList* location_list,
                                                             GFile* focus_location)
{
	Block18Data* _data18_;
	GeeLinkedList* _tmp0_;
	GFile* _tmp1_ = NULL;
	GFile* _tmp3_;
	gboolean _tmp4_;
#line 453 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 453 "../src/View/AbstractDirectoryView.vala"
	_data18_ = g_slice_new0 (Block18Data);
#line 453 "../src/View/AbstractDirectoryView.vala"
	_data18_->_ref_count_ = 1;
#line 453 "../src/View/AbstractDirectoryView.vala"
	_data18_->self = g_object_ref (self);
#line 454 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gee_linked_list_new (FILES_TYPE_FILE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 454 "../src/View/AbstractDirectoryView.vala"
	_data18_->files_to_select_list = _tmp0_;
#line 455 "../src/View/AbstractDirectoryView.vala"
	g_list_foreach (location_list, ___lambda71__gfunc, _data18_);
#line 459 "../src/View/AbstractDirectoryView.vala"
	if (focus_location != NULL) {
#line 3146 "AbstractDirectoryView.c"
		GFile* _tmp2_;
#line 459 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = g_file_dup (focus_location);
#line 459 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp1_);
#line 459 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp2_;
#line 3154 "AbstractDirectoryView.c"
	} else {
#line 459 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp1_);
#line 459 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = NULL;
#line 3160 "AbstractDirectoryView.c"
	}
#line 459 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _g_object_ref0 (_tmp1_);
#line 459 "../src/View/AbstractDirectoryView.vala"
	_data18_->focus_after_select = _tmp3_;
#line 465 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = self->priv->_tree_frozen;
#line 465 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_) {
#line 3170 "AbstractDirectoryView.c"
		gulong _tmp5_;
#line 466 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = g_signal_connect_data ((GObject*) self, "notify::tree-frozen", (GCallback) ____lambda72__g_object_notify, block18_data_ref (_data18_), (GClosureNotify) block18_data_unref, 0);
#line 466 "../src/View/AbstractDirectoryView.vala"
		self->priv->select_source_handler = _tmp5_;
#line 3176 "AbstractDirectoryView.c"
	} else {
		GeeLinkedList* _tmp6_;
		GFile* _tmp7_;
#line 470 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _data18_->files_to_select_list;
#line 470 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _data18_->focus_after_select;
#line 470 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_select_files_and_update_if_thawed (self, _tmp6_, _tmp7_);
#line 3186 "AbstractDirectoryView.c"
	}
#line 453 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp1_);
#line 453 "../src/View/AbstractDirectoryView.vala"
	block18_data_unref (_data18_);
#line 453 "../src/View/AbstractDirectoryView.vala"
	_data18_ = NULL;
#line 3194 "AbstractDirectoryView.c"
}

static void
_vala_GtkTreeIter_free (GtkTreeIter* self)
{
#line 493 "../src/View/AbstractDirectoryView.vala"
	g_boxed_free (gtk_tree_iter_get_type (), self);
#line 3202 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_select_files_and_update_if_thawed (FilesAbstractDirectoryView* self,
                                                                 GeeLinkedList* files_to_select,
                                                                 GFile* focus_file)
{
	gboolean _tmp0_;
	guint count = 0U;
	GtkTreeIter* iter = NULL;
#line 474 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 474 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (files_to_select != NULL);
#line 476 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->_tree_frozen;
#line 476 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 477 "../src/View/AbstractDirectoryView.vala"
		return;
#line 3223 "AbstractDirectoryView.c"
	}
#line 480 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->select_source_handler > ((gulong) 0)) {
#line 481 "../src/View/AbstractDirectoryView.vala"
		g_signal_handler_disconnect ((GObject*) self, self->priv->select_source_handler);
#line 482 "../src/View/AbstractDirectoryView.vala"
		self->priv->select_source_handler = (gulong) 0;
#line 3231 "AbstractDirectoryView.c"
	}
#line 485 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_disconnect_tree_signals (self);
#line 486 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unselect_all (self);
#line 488 "../src/View/AbstractDirectoryView.vala"
	count = (guint) 0;
#line 3239 "AbstractDirectoryView.c"
	{
		GeeLinkedList* _f_list = NULL;
		gint _f_size = 0;
		GeeLinkedList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _f_index = 0;
#line 491 "../src/View/AbstractDirectoryView.vala"
		_f_list = files_to_select;
#line 491 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _f_list;
#line 491 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp1_);
#line 491 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 491 "../src/View/AbstractDirectoryView.vala"
		_f_size = _tmp3_;
#line 491 "../src/View/AbstractDirectoryView.vala"
		_f_index = -1;
#line 491 "../src/View/AbstractDirectoryView.vala"
		while (TRUE) {
#line 3261 "AbstractDirectoryView.c"
			gint _tmp4_;
			gint _tmp5_;
			FilesFile* f = NULL;
			GeeLinkedList* _tmp6_;
			gpointer _tmp7_;
			FilesListModel* _tmp8_;
			FilesFile* _tmp9_;
			GtkTreeIter* _tmp10_ = NULL;
			gboolean _tmp11_;
#line 491 "../src/View/AbstractDirectoryView.vala"
			_f_index = _f_index + 1;
#line 491 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = _f_index;
#line 491 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = _f_size;
#line 491 "../src/View/AbstractDirectoryView.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 491 "../src/View/AbstractDirectoryView.vala"
				break;
#line 3281 "AbstractDirectoryView.c"
			}
#line 491 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = _f_list;
#line 491 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, _f_index);
#line 491 "../src/View/AbstractDirectoryView.vala"
			f = (FilesFile*) _tmp7_;
#line 493 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = self->model;
#line 493 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = f;
#line 493 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = files_list_model_get_first_iter_for_file (_tmp8_, _tmp9_, &_tmp10_);
#line 493 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreeIter_free0 (iter);
#line 493 "../src/View/AbstractDirectoryView.vala"
			iter = _tmp10_;
#line 493 "../src/View/AbstractDirectoryView.vala"
			if (_tmp11_) {
#line 3301 "AbstractDirectoryView.c"
				guint _tmp12_;
				GtkTreePath* path = NULL;
				FilesListModel* _tmp13_;
				GtkTreeIter* _tmp14_;
				GtkTreeIter _tmp15_;
				GtkTreePath* _tmp16_;
				gboolean _tmp17_ = FALSE;
				GtkTreePath* _tmp21_;
#line 494 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = count;
#line 494 "../src/View/AbstractDirectoryView.vala"
				count = _tmp12_ + 1;
#line 495 "../src/View/AbstractDirectoryView.vala"
				_tmp13_ = self->model;
#line 495 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = iter;
#line 495 "../src/View/AbstractDirectoryView.vala"
				_tmp15_ = *_tmp14_;
#line 495 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp13_, &_tmp15_);
#line 495 "../src/View/AbstractDirectoryView.vala"
				path = _tmp16_;
#line 497 "../src/View/AbstractDirectoryView.vala"
				if (focus_file != NULL) {
#line 3326 "AbstractDirectoryView.c"
					FilesFile* _tmp18_;
					GFile* _tmp19_;
					GFile* _tmp20_;
#line 497 "../src/View/AbstractDirectoryView.vala"
					_tmp18_ = f;
#line 497 "../src/View/AbstractDirectoryView.vala"
					_tmp19_ = files_file_get_location (_tmp18_);
#line 497 "../src/View/AbstractDirectoryView.vala"
					_tmp20_ = _tmp19_;
#line 497 "../src/View/AbstractDirectoryView.vala"
					_tmp17_ = g_file_equal (focus_file, _tmp20_);
#line 3338 "AbstractDirectoryView.c"
				} else {
#line 497 "../src/View/AbstractDirectoryView.vala"
					_tmp17_ = FALSE;
#line 3342 "AbstractDirectoryView.c"
				}
#line 497 "../src/View/AbstractDirectoryView.vala"
				_tmp21_ = path;
#line 497 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_select_path (self, _tmp21_, _tmp17_);
#line 493 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (path);
#line 3350 "AbstractDirectoryView.c"
			}
#line 491 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (f);
#line 3354 "AbstractDirectoryView.c"
		}
	}
#line 501 "../src/View/AbstractDirectoryView.vala"
	if (count == ((guint) 0)) {
#line 502 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_focus_first_for_empty_selection (self, FALSE);
#line 3361 "AbstractDirectoryView.c"
	}
#line 505 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_tree_signals (self);
#line 506 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_view_selection_changed (self);
#line 508 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 474 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 3371 "AbstractDirectoryView.c"
}

GList*
files_abstract_directory_view_get_open_with_apps (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GList* result;
#line 511 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 512 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->open_with_apps;
#line 512 "../src/View/AbstractDirectoryView.vala"
	result = _tmp0_;
#line 512 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3387 "AbstractDirectoryView.c"
}

GAppInfo*
files_abstract_directory_view_get_default_app (FilesAbstractDirectoryView* self)
{
	GAppInfo* _tmp0_;
	GAppInfo* _tmp1_;
	GAppInfo* result;
#line 515 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 516 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->default_app;
#line 516 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 516 "../src/View/AbstractDirectoryView.vala"
	result = _tmp1_;
#line 516 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3406 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_grab_focus (FilesAbstractDirectoryView* self)
{
	GtkWidget* _tmp0_;
#line 519 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 520 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->view;
#line 520 "../src/View/AbstractDirectoryView.vala"
	if (gtk_widget_get_realized (_tmp0_)) {
#line 3419 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp1_;
		gboolean _tmp2_;
		gboolean _tmp3_;
		GtkWidget* _tmp4_;
#line 522 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->slot;
#line 522 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_view_slot_get_is_active (_tmp1_);
#line 522 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 522 "../src/View/AbstractDirectoryView.vala"
		if (!_tmp3_) {
#line 523 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_set_active_slot (self, TRUE);
#line 3434 "AbstractDirectoryView.c"
		}
#line 526 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = self->priv->view;
#line 526 "../src/View/AbstractDirectoryView.vala"
		gtk_widget_grab_focus (_tmp4_);
#line 3440 "AbstractDirectoryView.c"
	}
}

GList*
files_abstract_directory_view_get_selected_files (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GList* result;
#line 530 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 531 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 532 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 532 "../src/View/AbstractDirectoryView.vala"
	result = _tmp0_;
#line 532 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3459 "AbstractDirectoryView.c"
}

/*** Protected Methods */
void
files_abstract_directory_view_set_active_slot (FilesAbstractDirectoryView* self,
                                               gboolean scroll)
{
	FilesViewSlot* _tmp0_;
#line 536 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 537 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 537 "../src/View/AbstractDirectoryView.vala"
	g_signal_emit_by_name ((FilesAbstractSlot*) _tmp0_, "active", scroll, TRUE);
#line 3474 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_load_location (FilesAbstractDirectoryView* self,
                                             GFile* location)
{
#line 540 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 540 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (location != NULL);
#line 541 "../src/View/AbstractDirectoryView.vala"
	g_signal_emit (self, files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL], 0, location, FILES_OPEN_FLAG_DEFAULT, FALSE);
#line 3487 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_load_root_location (FilesAbstractDirectoryView* self,
                                                  GFile* location)
{
#line 544 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 544 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (location != NULL);
#line 545 "../src/View/AbstractDirectoryView.vala"
	g_signal_emit (self, files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL], 0, location, FILES_OPEN_FLAG_DEFAULT, TRUE);
#line 3500 "AbstractDirectoryView.c"
}

/** Operations on selections */
static Block19Data*
block19_data_ref (Block19Data* _data19_)
{
#line 549 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data19_->_ref_count_);
#line 549 "../src/View/AbstractDirectoryView.vala"
	return _data19_;
#line 3511 "AbstractDirectoryView.c"
}

static void
block19_data_unref (void * _userdata_)
{
	Block19Data* _data19_;
	_data19_ = (Block19Data*) _userdata_;
#line 549 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data19_->_ref_count_)) {
#line 3521 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 549 "../src/View/AbstractDirectoryView.vala"
		self = _data19_->self;
#line 549 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 549 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block19Data, _data19_);
#line 3529 "AbstractDirectoryView.c"
	}
}

static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
#line 570 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data20_->_ref_count_);
#line 570 "../src/View/AbstractDirectoryView.vala"
	return _data20_;
#line 3540 "AbstractDirectoryView.c"
}

static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
#line 570 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
#line 3550 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 570 "../src/View/AbstractDirectoryView.vala"
		self = _data20_->_data19_->self;
#line 570 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data20_->file);
#line 570 "../src/View/AbstractDirectoryView.vala"
		block19_data_unref (_data20_->_data19_);
#line 570 "../src/View/AbstractDirectoryView.vala"
		_data20_->_data19_ = NULL;
#line 570 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block20Data, _data20_);
#line 3562 "AbstractDirectoryView.c"
	}
}

static gboolean
_______lambda94_ (Block20Data* _data20_)
{
	Block19Data* _data19_;
	FilesAbstractDirectoryView* self;
	FilesFile* _tmp0_;
	GdkScreen* _tmp1_;
	gboolean result;
#line 578 "../src/View/AbstractDirectoryView.vala"
	_data19_ = _data20_->_data19_;
#line 578 "../src/View/AbstractDirectoryView.vala"
	self = _data19_->self;
#line 579 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _data20_->file;
#line 579 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _data19_->screen;
#line 579 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_activate_file (self, _tmp0_, _tmp1_, _data19_->flag, FALSE);
#line 580 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 580 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3588 "AbstractDirectoryView.c"
}

static gboolean
________lambda94__gsource_func (gpointer self)
{
	gboolean result;
	result = _______lambda94_ (self);
#line 578 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3598 "AbstractDirectoryView.c"
}

static gboolean
_______lambda95_ (Block20Data* _data20_)
{
	Block19Data* _data19_;
	FilesAbstractDirectoryView* self;
	FilesFile* _tmp0_;
	GdkScreen* _tmp1_;
	gboolean result;
#line 583 "../src/View/AbstractDirectoryView.vala"
	_data19_ = _data20_->_data19_;
#line 583 "../src/View/AbstractDirectoryView.vala"
	self = _data19_->self;
#line 584 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _data20_->file;
#line 584 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _data19_->screen;
#line 584 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_open_file (self, _tmp0_, _tmp1_, NULL);
#line 585 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 585 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3623 "AbstractDirectoryView.c"
}

static gboolean
________lambda95__gsource_func (gpointer self)
{
	gboolean result;
	result = _______lambda95_ (self);
#line 583 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3633 "AbstractDirectoryView.c"
}

static Block21Data*
block21_data_ref (Block21Data* _data21_)
{
#line 589 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data21_->_ref_count_);
#line 589 "../src/View/AbstractDirectoryView.vala"
	return _data21_;
#line 3643 "AbstractDirectoryView.c"
}

static void
block21_data_unref (void * _userdata_)
{
	Block21Data* _data21_;
	_data21_ = (Block21Data*) _userdata_;
#line 589 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data21_->_ref_count_)) {
#line 3653 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 589 "../src/View/AbstractDirectoryView.vala"
		self = _data21_->_data19_->self;
#line 589 "../src/View/AbstractDirectoryView.vala"
		(_data21_->files_to_open == NULL) ? NULL : (_data21_->files_to_open = (_g_list_free__g_object_unref0_ (_data21_->files_to_open), NULL));
#line 589 "../src/View/AbstractDirectoryView.vala"
		block19_data_unref (_data21_->_data19_);
#line 589 "../src/View/AbstractDirectoryView.vala"
		_data21_->_data19_ = NULL;
#line 589 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block21Data, _data21_);
#line 3665 "AbstractDirectoryView.c"
	}
}

static gboolean
_____lambda96_ (Block21Data* _data21_)
{
	Block19Data* _data19_;
	FilesAbstractDirectoryView* self;
	GAppInfo* _tmp0_;
	GList* _tmp1_;
	gboolean result;
#line 592 "../src/View/AbstractDirectoryView.vala"
	_data19_ = _data21_->_data19_;
#line 592 "../src/View/AbstractDirectoryView.vala"
	self = _data19_->self;
#line 593 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->default_app;
#line 593 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _data21_->files_to_open;
#line 593 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_open_files_with (self, _tmp0_, _tmp1_);
#line 594 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 594 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3691 "AbstractDirectoryView.c"
}

static gboolean
______lambda96__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda96_ (self);
#line 592 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 3701 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_activate_selected_items (FilesAbstractDirectoryView* self,
                                                       FilesOpenFlag flag,
                                                       GList* selection)
{
	Block19Data* _data19_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GdkScreen* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
#line 549 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 549 "../src/View/AbstractDirectoryView.vala"
	_data19_ = g_slice_new0 (Block19Data);
#line 549 "../src/View/AbstractDirectoryView.vala"
	_data19_->_ref_count_ = 1;
#line 549 "../src/View/AbstractDirectoryView.vala"
	_data19_->self = g_object_ref (self);
#line 549 "../src/View/AbstractDirectoryView.vala"
	_data19_->flag = flag;
#line 552 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_is_frozen (self);
#line 552 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 552 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 552 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 3734 "AbstractDirectoryView.c"
	} else {
#line 552 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = selection == NULL;
#line 3738 "AbstractDirectoryView.c"
	}
#line 552 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 553 "../src/View/AbstractDirectoryView.vala"
		block19_data_unref (_data19_);
#line 553 "../src/View/AbstractDirectoryView.vala"
		_data19_ = NULL;
#line 553 "../src/View/AbstractDirectoryView.vala"
		return;
#line 3748 "AbstractDirectoryView.c"
	}
#line 556 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 556 "../src/View/AbstractDirectoryView.vala"
	_data19_->screen = _tmp3_;
#line 558 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = g_list_first (selection);
#line 558 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _tmp4_->next;
#line 558 "../src/View/AbstractDirectoryView.vala"
	if (_tmp5_ == NULL) {
#line 3760 "AbstractDirectoryView.c"
		gconstpointer _tmp6_;
		GdkScreen* _tmp7_;
#line 559 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = selection->data;
#line 559 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _data19_->screen;
#line 559 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_activate_file (self, (FilesFile*) _tmp6_, _tmp7_, _data19_->flag, TRUE);
#line 560 "../src/View/AbstractDirectoryView.vala"
		block19_data_unref (_data19_);
#line 560 "../src/View/AbstractDirectoryView.vala"
		_data19_ = NULL;
#line 560 "../src/View/AbstractDirectoryView.vala"
		return;
#line 3775 "AbstractDirectoryView.c"
	}
#line 563 "../src/View/AbstractDirectoryView.vala"
	if (!self->priv->in_trash) {
#line 3779 "AbstractDirectoryView.c"
		gboolean _tmp8_ = FALSE;
		gconstpointer _tmp9_;
#line 567 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = g_list_nth_data (selection, (guint) 11);
#line 567 "../src/View/AbstractDirectoryView.vala"
		if (((FilesFile*) _tmp9_) == NULL) {
#line 3786 "AbstractDirectoryView.c"
			gboolean _tmp10_ = FALSE;
			GAppInfo* _tmp11_;
#line 568 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = self->priv->default_app;
#line 568 "../src/View/AbstractDirectoryView.vala"
			if (_tmp11_ == NULL) {
#line 568 "../src/View/AbstractDirectoryView.vala"
				_tmp10_ = TRUE;
#line 3795 "AbstractDirectoryView.c"
			} else {
				GAppInfo* _tmp12_;
#line 568 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = self->priv->default_app;
#line 568 "../src/View/AbstractDirectoryView.vala"
				_tmp10_ = files_abstract_directory_view_app_is_this_app (self, _tmp12_);
#line 3802 "AbstractDirectoryView.c"
			}
#line 568 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = _tmp10_;
#line 3806 "AbstractDirectoryView.c"
		} else {
#line 567 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = FALSE;
#line 3810 "AbstractDirectoryView.c"
		}
#line 567 "../src/View/AbstractDirectoryView.vala"
		if (_tmp8_) {
#line 3814 "AbstractDirectoryView.c"
			{
				GList* file_collection = NULL;
				GList* file_it = NULL;
#line 570 "../src/View/AbstractDirectoryView.vala"
				file_collection = selection;
#line 570 "../src/View/AbstractDirectoryView.vala"
				for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 3822 "AbstractDirectoryView.c"
					FilesFile* _tmp13_;
					FilesFile* file = NULL;
#line 570 "../src/View/AbstractDirectoryView.vala"
					_tmp13_ = _g_object_ref0 ((FilesFile*) file_it->data);
#line 570 "../src/View/AbstractDirectoryView.vala"
					file = _tmp13_;
#line 3829 "AbstractDirectoryView.c"
					{
						Block20Data* _data20_;
						FilesFile* _tmp14_;
#line 570 "../src/View/AbstractDirectoryView.vala"
						_data20_ = g_slice_new0 (Block20Data);
#line 570 "../src/View/AbstractDirectoryView.vala"
						_data20_->_ref_count_ = 1;
#line 570 "../src/View/AbstractDirectoryView.vala"
						_data20_->_data19_ = block19_data_ref (_data19_);
#line 570 "../src/View/AbstractDirectoryView.vala"
						_data20_->file = file;
#line 572 "../src/View/AbstractDirectoryView.vala"
						_tmp14_ = _data20_->file;
#line 572 "../src/View/AbstractDirectoryView.vala"
						if (files_file_is_folder (_tmp14_)) {
#line 574 "../src/View/AbstractDirectoryView.vala"
							if (_data19_->flag == FILES_OPEN_FLAG_DEFAULT) {
#line 575 "../src/View/AbstractDirectoryView.vala"
								_data19_->flag = FILES_OPEN_FLAG_NEW_TAB;
#line 3849 "AbstractDirectoryView.c"
							}
#line 578 "../src/View/AbstractDirectoryView.vala"
							g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ________lambda94__gsource_func, block20_data_ref (_data20_), block20_data_unref);
#line 3853 "AbstractDirectoryView.c"
						} else {
#line 583 "../src/View/AbstractDirectoryView.vala"
							g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ________lambda95__gsource_func, block20_data_ref (_data20_), block20_data_unref);
#line 3857 "AbstractDirectoryView.c"
						}
#line 570 "../src/View/AbstractDirectoryView.vala"
						block20_data_unref (_data20_);
#line 570 "../src/View/AbstractDirectoryView.vala"
						_data20_ = NULL;
#line 3863 "AbstractDirectoryView.c"
					}
				}
			}
		} else {
			GAppInfo* _tmp15_;
#line 589 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = self->priv->default_app;
#line 589 "../src/View/AbstractDirectoryView.vala"
			if (_tmp15_ != NULL) {
#line 3873 "AbstractDirectoryView.c"
				Block21Data* _data21_;
				GList* _tmp16_;
#line 589 "../src/View/AbstractDirectoryView.vala"
				_data21_ = g_slice_new0 (Block21Data);
#line 589 "../src/View/AbstractDirectoryView.vala"
				_data21_->_ref_count_ = 1;
#line 589 "../src/View/AbstractDirectoryView.vala"
				_data21_->_data19_ = block19_data_ref (_data19_);
#line 591 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = g_list_copy_deep (selection, (GCopyFunc) g_object_ref, NULL);
#line 591 "../src/View/AbstractDirectoryView.vala"
				_data21_->files_to_open = _tmp16_;
#line 592 "../src/View/AbstractDirectoryView.vala"
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ______lambda96__gsource_func, block21_data_ref (_data21_), block21_data_unref);
#line 589 "../src/View/AbstractDirectoryView.vala"
				block21_data_unref (_data21_);
#line 589 "../src/View/AbstractDirectoryView.vala"
				_data21_ = NULL;
#line 3892 "AbstractDirectoryView.c"
			}
		}
	} else {
#line 598 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:598: Cannot open files in trash");
#line 3898 "AbstractDirectoryView.c"
	}
#line 549 "../src/View/AbstractDirectoryView.vala"
	block19_data_unref (_data19_);
#line 549 "../src/View/AbstractDirectoryView.vala"
	_data19_ = NULL;
#line 3904 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_select_gof_file (FilesAbstractDirectoryView* self,
                                               FilesFile* file)
{
	GtkTreeIter* iter = NULL;
	FilesListModel* _tmp0_;
	GtkTreeIter* _tmp1_ = NULL;
	gboolean _tmp2_;
	GtkTreePath* path = NULL;
	FilesListModel* _tmp3_;
	GtkTreeIter* _tmp4_;
	GtkTreeIter _tmp5_;
	GtkTreePath* _tmp6_;
	GtkTreePath* _tmp7_;
#line 602 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 602 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 604 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 604 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_list_model_get_first_iter_for_file (_tmp0_, file, &_tmp1_);
#line 604 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 604 "../src/View/AbstractDirectoryView.vala"
	iter = _tmp1_;
#line 604 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp2_) {
#line 605 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreeIter_free0 (iter);
#line 605 "../src/View/AbstractDirectoryView.vala"
		return;
#line 3939 "AbstractDirectoryView.c"
	}
#line 608 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->model;
#line 608 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = iter;
#line 608 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = *_tmp4_;
#line 608 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp3_, &_tmp5_);
#line 608 "../src/View/AbstractDirectoryView.vala"
	path = _tmp6_;
#line 609 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = path;
#line 609 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_cursor (self, _tmp7_, FALSE, TRUE, FALSE);
#line 602 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 602 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 3959 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_select_and_scroll_to_gof_file (FilesAbstractDirectoryView* self,
                                                             FilesFile* file)
{
	GtkTreeIter iter = {0};
	FilesListModel* _tmp0_;
	GtkTreeIter* _tmp1_ = NULL;
	gboolean _tmp2_;
	GtkTreeIter* _tmp3_;
	gboolean _tmp4_;
	GtkTreePath* path = NULL;
	FilesListModel* _tmp5_;
	GtkTreeIter _tmp6_;
	GtkTreePath* _tmp7_;
	GtkTreePath* _tmp8_;
#line 612 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 612 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 614 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 614 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_list_model_get_first_iter_for_file (_tmp0_, file, &_tmp1_);
#line 614 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp1_;
#line 614 "../src/View/AbstractDirectoryView.vala"
	iter = *_tmp3_;
#line 614 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = !_tmp2_;
#line 614 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreeIter_free0 (_tmp3_);
#line 614 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_) {
#line 615 "../src/View/AbstractDirectoryView.vala"
		return;
#line 3997 "AbstractDirectoryView.c"
	}
#line 618 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = self->model;
#line 618 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = iter;
#line 618 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp5_, &_tmp6_);
#line 618 "../src/View/AbstractDirectoryView.vala"
	path = _tmp7_;
#line 619 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = path;
#line 619 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_cursor (self, _tmp8_, FALSE, TRUE, TRUE);
#line 612 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 4013 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_add_gof_file_to_selection (FilesAbstractDirectoryView* self,
                                                         FilesFile* file)
{
	GtkTreeIter iter = {0};
	FilesListModel* _tmp0_;
	GtkTreeIter* _tmp1_ = NULL;
	gboolean _tmp2_;
	GtkTreeIter* _tmp3_;
	gboolean _tmp4_;
	GtkTreePath* path = NULL;
	FilesListModel* _tmp5_;
	GtkTreeIter _tmp6_;
	GtkTreePath* _tmp7_;
	GtkTreePath* _tmp8_;
#line 622 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 622 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 624 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 624 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_list_model_get_first_iter_for_file (_tmp0_, file, &_tmp1_);
#line 624 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp1_;
#line 624 "../src/View/AbstractDirectoryView.vala"
	iter = *_tmp3_;
#line 624 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = !_tmp2_;
#line 624 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreeIter_free0 (_tmp3_);
#line 624 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_) {
#line 625 "../src/View/AbstractDirectoryView.vala"
		return;
#line 4051 "AbstractDirectoryView.c"
	}
#line 628 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = self->model;
#line 628 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = iter;
#line 628 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp5_, &_tmp6_);
#line 628 "../src/View/AbstractDirectoryView.vala"
	path = _tmp7_;
#line 629 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = path;
#line 629 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_select_path (self, _tmp8_, FALSE);
#line 622 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 4067 "AbstractDirectoryView.c"
}

/** Directory signal handlers. */
static void
_files_abstract_directory_view_on_directory_file_added_files_directory_file_added (FilesDirectory* _sender,
                                                                                   FilesFile* file,
                                                                                   gboolean is_internal,
                                                                                   gpointer self)
{
#line 635 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_directory_file_added ((FilesAbstractDirectoryView*) self, _sender, file, is_internal);
#line 4079 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_directory_file_changed_files_directory_file_changed (FilesDirectory* _sender,
                                                                                       FilesFile* file,
                                                                                       gpointer self)
{
#line 636 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_directory_file_changed ((FilesAbstractDirectoryView*) self, _sender, file);
#line 4089 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_directory_file_deleted_files_directory_file_deleted (FilesDirectory* _sender,
                                                                                       FilesFile* file,
                                                                                       gpointer self)
{
#line 637 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_directory_file_deleted ((FilesAbstractDirectoryView*) self, _sender, file);
#line 4099 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_directory_file_icon_changed_files_directory_icon_changed (FilesDirectory* _sender,
                                                                                            FilesFile* file,
                                                                                            gpointer self)
{
#line 638 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_directory_file_icon_changed ((FilesAbstractDirectoryView*) self, _sender, file);
#line 4109 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_connect_directory_handlers (FilesAbstractDirectoryView* self,
                                                          FilesDirectory* dir)
{
#line 634 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 634 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 635 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (dir, "file-added", (GCallback) _files_abstract_directory_view_on_directory_file_added_files_directory_file_added, self, 0);
#line 636 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (dir, "file-changed", (GCallback) _files_abstract_directory_view_on_directory_file_changed_files_directory_file_changed, self, 0);
#line 637 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (dir, "file-deleted", (GCallback) _files_abstract_directory_view_on_directory_file_deleted_files_directory_file_deleted, self, 0);
#line 638 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (dir, "icon-changed", (GCallback) _files_abstract_directory_view_on_directory_file_icon_changed_files_directory_icon_changed, self, 0);
#line 639 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_directory_loading_handlers (self, dir);
#line 4130 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_directory_file_loaded_files_directory_file_loaded (FilesDirectory* _sender,
                                                                                     FilesFile* file,
                                                                                     gpointer self)
{
#line 644 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_directory_file_loaded ((FilesAbstractDirectoryView*) self, _sender, file);
#line 4140 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_directory_done_loading_files_directory_done_loading (FilesDirectory* _sender,
                                                                                       gpointer self)
{
#line 645 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_directory_done_loading ((FilesAbstractDirectoryView*) self, _sender);
#line 4149 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_connect_directory_loading_handlers (FilesAbstractDirectoryView* self,
                                                                  FilesDirectory* dir)
{
	FilesListModel* _tmp0_;
#line 642 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 642 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 643 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 643 "../src/View/AbstractDirectoryView.vala"
	files_list_model_set_sorting_off (_tmp0_);
#line 644 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (dir, "file-loaded", (GCallback) _files_abstract_directory_view_on_directory_file_loaded_files_directory_file_loaded, self, 0);
#line 645 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (dir, "done-loading", (GCallback) _files_abstract_directory_view_on_directory_done_loading_files_directory_done_loading, self, 0);
#line 4169 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_disconnect_directory_loading_handlers (FilesAbstractDirectoryView* self,
                                                                     FilesDirectory* dir)
{
	FilesListModel* _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
#line 648 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 648 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 649 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 649 "../src/View/AbstractDirectoryView.vala"
	files_list_model_set_sorting_on (_tmp0_);
#line 650 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("file-loaded", FILES_TYPE_DIRECTORY, &_tmp1_, NULL, FALSE);
#line 650 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_file_loaded_files_directory_file_loaded, self);
#line 651 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("done-loading", FILES_TYPE_DIRECTORY, &_tmp2_, NULL, FALSE);
#line 651 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_done_loading_files_directory_done_loading, self);
#line 4195 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_disconnect_directory_handlers (FilesAbstractDirectoryView* self,
                                                             FilesDirectory* dir)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
#line 654 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 654 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 657 "../src/View/AbstractDirectoryView.vala"
	if (files_directory_is_loading (dir)) {
#line 658 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_disconnect_directory_loading_handlers (self, dir);
#line 4215 "AbstractDirectoryView.c"
	}
#line 661 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("file-added", FILES_TYPE_DIRECTORY, &_tmp0_, NULL, FALSE);
#line 661 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_file_added_files_directory_file_added, self);
#line 662 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("file-changed", FILES_TYPE_DIRECTORY, &_tmp1_, NULL, FALSE);
#line 662 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_file_changed_files_directory_file_changed, self);
#line 663 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("file-deleted", FILES_TYPE_DIRECTORY, &_tmp2_, NULL, FALSE);
#line 663 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_file_deleted_files_directory_file_deleted, self);
#line 664 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("icon-changed", FILES_TYPE_DIRECTORY, &_tmp3_, NULL, FALSE);
#line 664 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_file_icon_changed_files_directory_icon_changed, self);
#line 665 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("done-loading", FILES_TYPE_DIRECTORY, &_tmp4_, NULL, FALSE);
#line 665 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (dir, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _files_abstract_directory_view_on_directory_done_loading_files_directory_done_loading, self);
#line 4237 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_change_directory (FilesAbstractDirectoryView* self,
                                                FilesDirectory* old_dir,
                                                FilesDirectory* new_dir)
{
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
#line 668 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 668 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (old_dir != NULL);
#line 668 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (new_dir != NULL);
#line 669 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 669 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 669 "../src/View/AbstractDirectoryView.vala"
	style_context = _tmp1_;
#line 670 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = style_context;
#line 670 "../src/View/AbstractDirectoryView.vala"
	if (gtk_style_context_has_class (_tmp2_, GRANITE_STYLE_CLASS_H2_LABEL)) {
#line 4265 "AbstractDirectoryView.c"
		GtkStyleContext* _tmp3_;
		GtkStyleContext* _tmp4_;
#line 671 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = style_context;
#line 671 "../src/View/AbstractDirectoryView.vala"
		gtk_style_context_remove_class (_tmp3_, GRANITE_STYLE_CLASS_H2_LABEL);
#line 672 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = style_context;
#line 672 "../src/View/AbstractDirectoryView.vala"
		gtk_style_context_remove_class (_tmp4_, GTK_STYLE_CLASS_VIEW);
#line 4276 "AbstractDirectoryView.c"
	}
#line 675 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel (self);
#line 676 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_clear (self);
#line 677 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_disconnect_directory_handlers (self, old_dir);
#line 678 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_directory_handlers (self, new_dir);
#line 668 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (style_context);
#line 4288 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_prepare_reload (FilesAbstractDirectoryView* self,
                                              FilesDirectory* dir)
{
#line 681 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 681 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 682 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel (self);
#line 683 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_clear (self);
#line 684 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_directory_loading_handlers (self, dir);
#line 4305 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_clear (FilesAbstractDirectoryView* self)
{
	FilesListModel* _tmp0_;
#line 687 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 690 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_freeze_tree (self);
#line 691 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_block_model (self);
#line 692 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 692 "../src/View/AbstractDirectoryView.vala"
	files_list_model_clear (_tmp0_);
#line 693 "../src/View/AbstractDirectoryView.vala"
	self->priv->all_selected = FALSE;
#line 695 "../src/View/AbstractDirectoryView.vala"
	self->on_directory = FALSE;
#line 696 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unblock_model (self);
#line 4328 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_drag_drop_gtk_widget_drag_drop (GtkWidget* _sender,
                                                                  GdkDragContext* context,
                                                                  gint x,
                                                                  gint y,
                                                                  guint time_,
                                                                  gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_drag_drop ((FilesAbstractDirectoryView*) self, context, x, y, time_);
#line 702 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 4343 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_drag_data_received_gtk_widget_drag_data_received (GtkWidget* _sender,
                                                                                    GdkDragContext* context,
                                                                                    gint x,
                                                                                    gint y,
                                                                                    GtkSelectionData* selection_data,
                                                                                    guint info,
                                                                                    guint time_,
                                                                                    gpointer self)
{
#line 703 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_data_received ((FilesAbstractDirectoryView*) self, context, x, y, selection_data, info, time_);
#line 4358 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_drag_leave_gtk_widget_drag_leave (GtkWidget* _sender,
                                                                    GdkDragContext* context,
                                                                    guint time_,
                                                                    gpointer self)
{
#line 704 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_leave ((FilesAbstractDirectoryView*) self, context, time_);
#line 4369 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender,
                                                                      GdkDragContext* context,
                                                                      gint x,
                                                                      gint y,
                                                                      guint time_,
                                                                      gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_drag_motion ((FilesAbstractDirectoryView*) self, context, x, y, time_);
#line 705 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 4384 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender,
                                                                    GdkDragContext* context,
                                                                    gpointer self)
{
#line 714 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_begin ((FilesAbstractDirectoryView*) self, context);
#line 4394 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_drag_data_get_gtk_widget_drag_data_get (GtkWidget* _sender,
                                                                          GdkDragContext* context,
                                                                          GtkSelectionData* selection_data,
                                                                          guint info,
                                                                          guint time_,
                                                                          gpointer self)
{
#line 715 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_data_get ((FilesAbstractDirectoryView*) self, context, selection_data, info, time_);
#line 4407 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_drag_data_delete_gtk_widget_drag_data_delete (GtkWidget* _sender,
                                                                                GdkDragContext* context,
                                                                                gpointer self)
{
#line 716 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_data_delete ((FilesAbstractDirectoryView*) self, context);
#line 4417 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender,
                                                                GdkDragContext* context,
                                                                gpointer self)
{
#line 717 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_end ((FilesAbstractDirectoryView*) self, context);
#line 4427 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_connect_drag_drop_signals (FilesAbstractDirectoryView* self,
                                                         GtkWidget* widget)
{
#line 699 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 699 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (widget != NULL);
#line 701 "../src/View/AbstractDirectoryView.vala"
	gtk_drag_dest_set (widget, GTK_DEST_DEFAULT_MOTION, FILES_ABSTRACT_DIRECTORY_VIEW_DROP_TARGETS, (gint) G_N_ELEMENTS (FILES_ABSTRACT_DIRECTORY_VIEW_DROP_TARGETS), GDK_ACTION_ASK | FILES_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS);
#line 702 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-drop", (GCallback) _files_abstract_directory_view_on_drag_drop_gtk_widget_drag_drop, self, 0);
#line 703 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-data-received", (GCallback) _files_abstract_directory_view_on_drag_data_received_gtk_widget_drag_data_received, self, 0);
#line 704 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-leave", (GCallback) _files_abstract_directory_view_on_drag_leave_gtk_widget_drag_leave, self, 0);
#line 705 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-motion", (GCallback) _files_abstract_directory_view_on_drag_motion_gtk_widget_drag_motion, self, 0);
#line 708 "../src/View/AbstractDirectoryView.vala"
	gtk_drag_source_set (widget, (GDK_BUTTON1_MASK | GDK_BUTTON3_MASK) | GDK_CONTROL_MASK, FILES_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS, (gint) G_N_ELEMENTS (FILES_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS), FILES_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS);
#line 714 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-begin", (GCallback) _files_abstract_directory_view_on_drag_begin_gtk_widget_drag_begin, self, 0);
#line 715 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-data-get", (GCallback) _files_abstract_directory_view_on_drag_data_get_gtk_widget_drag_data_get, self, 0);
#line 716 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-data-delete", (GCallback) _files_abstract_directory_view_on_drag_data_delete_gtk_widget_drag_data_delete, self, 0);
#line 717 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (widget, "drag-end", (GCallback) _files_abstract_directory_view_on_drag_end_gtk_widget_drag_end, self, 0);
#line 4458 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_cancel_drag_timer (FilesAbstractDirectoryView* self)
{
#line 720 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 721 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_disconnect_drag_timeout_motion_and_release_events (self);
#line 722 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->drag_timer_id);
#line 4470 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_cancel_thumbnailing (FilesAbstractDirectoryView* self)
{
#line 725 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 726 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->thumbnail_request >= 0) {
#line 4480 "AbstractDirectoryView.c"
		FilesThumbnailer* _tmp0_;
#line 727 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = self->priv->thumbnailer;
#line 727 "../src/View/AbstractDirectoryView.vala"
		files_thumbnailer_dequeue (_tmp0_, self->priv->thumbnail_request);
#line 728 "../src/View/AbstractDirectoryView.vala"
		self->priv->thumbnail_request = -1;
#line 4488 "AbstractDirectoryView.c"
	}
#line 731 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->thumbnail_source_id);
#line 4492 "AbstractDirectoryView.c"
}

static Block22Data*
block22_data_ref (Block22Data* _data22_)
{
#line 734 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data22_->_ref_count_);
#line 734 "../src/View/AbstractDirectoryView.vala"
	return _data22_;
#line 4502 "AbstractDirectoryView.c"
}

static void
block22_data_unref (void * _userdata_)
{
	Block22Data* _data22_;
	_data22_ = (Block22Data*) _userdata_;
#line 734 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data22_->_ref_count_)) {
#line 4512 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 734 "../src/View/AbstractDirectoryView.vala"
		self = _data22_->self;
#line 734 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 734 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block22Data, _data22_);
#line 4520 "AbstractDirectoryView.c"
	}
}

static void
__lambda40_ (Block22Data* _data22_,
             FilesFile* file)
{
	FilesAbstractDirectoryView* self;
	gboolean _tmp0_ = FALSE;
#line 737 "../src/View/AbstractDirectoryView.vala"
	self = _data22_->self;
#line 737 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 738 "../src/View/AbstractDirectoryView.vala"
	if (files_file_is_folder (file)) {
#line 738 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 4538 "AbstractDirectoryView.c"
	} else {
#line 738 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = files_file_is_root_network_folder (file);
#line 4542 "AbstractDirectoryView.c"
	}
#line 738 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp0_) {
#line 739 "../src/View/AbstractDirectoryView.vala"
		_data22_->only_folders = FALSE;
#line 4548 "AbstractDirectoryView.c"
	}
}

static void
___lambda40__gfunc (gconstpointer data,
                    gpointer self)
{
#line 737 "../src/View/AbstractDirectoryView.vala"
	__lambda40_ (self, (FilesFile*) data);
#line 4558 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_selection_only_contains_folders (FilesAbstractDirectoryView* self,
                                                               GList* list)
{
	Block22Data* _data22_;
	gboolean result;
#line 734 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 734 "../src/View/AbstractDirectoryView.vala"
	_data22_ = g_slice_new0 (Block22Data);
#line 734 "../src/View/AbstractDirectoryView.vala"
	_data22_->_ref_count_ = 1;
#line 734 "../src/View/AbstractDirectoryView.vala"
	_data22_->self = g_object_ref (self);
#line 735 "../src/View/AbstractDirectoryView.vala"
	_data22_->only_folders = TRUE;
#line 737 "../src/View/AbstractDirectoryView.vala"
	g_list_foreach (list, ___lambda40__gfunc, _data22_);
#line 743 "../src/View/AbstractDirectoryView.vala"
	result = _data22_->only_folders;
#line 743 "../src/View/AbstractDirectoryView.vala"
	block22_data_unref (_data22_);
#line 743 "../src/View/AbstractDirectoryView.vala"
	_data22_ = NULL;
#line 743 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 4587 "AbstractDirectoryView.c"
}

/** Handle scroll events */
gboolean
files_abstract_directory_view_handle_scroll_event (FilesAbstractDirectoryView* self,
                                                   GdkEventScroll* event)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GdkModifierType state = 0U;
	GdkModifierType _tmp2_ = 0U;
	gboolean result;
#line 747 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 747 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 748 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_is_frozen (self);
#line 748 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 748 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 749 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 749 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 4614 "AbstractDirectoryView.c"
	}
#line 753 "../src/View/AbstractDirectoryView.vala"
	gdk_event_get_state ((GdkEvent*) event, &_tmp2_);
#line 753 "../src/View/AbstractDirectoryView.vala"
	state = _tmp2_;
#line 755 "../src/View/AbstractDirectoryView.vala"
	if ((state & GDK_CONTROL_MASK) > 0) {
#line 4622 "AbstractDirectoryView.c"
		GdkScrollDirection direction = 0;
		gdouble delta_x = 0.0;
		gdouble delta_y = 0.0;
		GdkScrollDirection _tmp3_ = 0;
		gboolean _tmp4_;
#line 758 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = gdk_event_get_scroll_direction ((GdkEvent*) event, &_tmp3_);
#line 758 "../src/View/AbstractDirectoryView.vala"
		direction = _tmp3_;
#line 758 "../src/View/AbstractDirectoryView.vala"
		if (_tmp4_) {
#line 759 "../src/View/AbstractDirectoryView.vala"
			if (direction == GDK_SCROLL_UP) {
#line 760 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_zoom_in (self);
#line 761 "../src/View/AbstractDirectoryView.vala"
				result = TRUE;
#line 761 "../src/View/AbstractDirectoryView.vala"
				return result;
#line 4642 "AbstractDirectoryView.c"
			} else {
#line 763 "../src/View/AbstractDirectoryView.vala"
				if (direction == GDK_SCROLL_DOWN) {
#line 764 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_zoom_out (self);
#line 765 "../src/View/AbstractDirectoryView.vala"
					result = TRUE;
#line 765 "../src/View/AbstractDirectoryView.vala"
					return result;
#line 4652 "AbstractDirectoryView.c"
				}
			}
#line 768 "../src/View/AbstractDirectoryView.vala"
			result = FALSE;
#line 768 "../src/View/AbstractDirectoryView.vala"
			return result;
#line 4659 "AbstractDirectoryView.c"
		} else {
			gdouble _tmp5_ = 0.0;
			gdouble _tmp6_ = 0.0;
			gboolean _tmp7_;
#line 769 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = gdk_event_get_scroll_deltas ((GdkEvent*) event, &_tmp5_, &_tmp6_);
#line 769 "../src/View/AbstractDirectoryView.vala"
			delta_x = _tmp5_;
#line 769 "../src/View/AbstractDirectoryView.vala"
			delta_y = _tmp6_;
#line 769 "../src/View/AbstractDirectoryView.vala"
			if (_tmp7_) {
#line 772 "../src/View/AbstractDirectoryView.vala"
				self->priv->total_delta_y = self->priv->total_delta_y + delta_y;
#line 774 "../src/View/AbstractDirectoryView.vala"
				if (self->priv->total_delta_y >= 0.5) {
#line 775 "../src/View/AbstractDirectoryView.vala"
					self->priv->total_delta_y = (gdouble) 0;
#line 776 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_zoom_out (self);
#line 4680 "AbstractDirectoryView.c"
				} else {
#line 777 "../src/View/AbstractDirectoryView.vala"
					if (self->priv->total_delta_y <= (-0.5)) {
#line 778 "../src/View/AbstractDirectoryView.vala"
						self->priv->total_delta_y = (gdouble) 0;
#line 779 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_zoom_in (self);
#line 4688 "AbstractDirectoryView.c"
					}
				}
#line 782 "../src/View/AbstractDirectoryView.vala"
				result = TRUE;
#line 782 "../src/View/AbstractDirectoryView.vala"
				return result;
#line 4695 "AbstractDirectoryView.c"
			}
		}
	}
#line 786 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 786 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 4703 "AbstractDirectoryView.c"
}

GList*
files_abstract_directory_view_get_selected_files_for_transfer (FilesAbstractDirectoryView* self,
                                                               GList* selection)
{
	GList* _tmp0_;
	GList* result;
#line 789 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 791 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_list_copy_deep (selection, (GCopyFunc) g_object_ref, NULL);
#line 791 "../src/View/AbstractDirectoryView.vala"
	result = _tmp0_;
#line 791 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 4720 "AbstractDirectoryView.c"
}

/** File operations */
static void
files_abstract_directory_view_activate_file (FilesAbstractDirectoryView* self,
                                             FilesFile* _file,
                                             GdkScreen* screen,
                                             FilesOpenFlag flag,
                                             gboolean only_one_file)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	FilesFile* file = NULL;
	FilesFile* _tmp2_;
	gboolean _tmp3_;
	FilesFile* _tmp8_;
	GAppInfo* _tmp9_;
	GFile* location = NULL;
	FilesFile* _tmp10_;
	GFile* _tmp11_;
	GFile* _tmp12_;
	gboolean _tmp14_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 797 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 797 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (_file != NULL);
#line 798 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_is_frozen (self);
#line 798 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 798 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 799 "../src/View/AbstractDirectoryView.vala"
		return;
#line 4756 "AbstractDirectoryView.c"
	}
#line 802 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _g_object_ref0 (_file);
#line 802 "../src/View/AbstractDirectoryView.vala"
	file = _tmp2_;
#line 803 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->priv->_in_recent;
#line 803 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 4766 "AbstractDirectoryView.c"
		FilesFile* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		FilesFile* _tmp7_;
#line 804 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = file;
#line 804 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_file_get_display_target_uri (_tmp4_);
#line 804 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp5_;
#line 804 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = files_file_get_by_uri (_tmp6_);
#line 804 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 804 "../src/View/AbstractDirectoryView.vala"
		file = _tmp7_;
#line 804 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (_tmp6_);
#line 4785 "AbstractDirectoryView.c"
	}
#line 807 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = file;
#line 807 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = files_mime_actions_get_default_application_for_file (_tmp8_);
#line 807 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->default_app);
#line 807 "../src/View/AbstractDirectoryView.vala"
	self->priv->default_app = _tmp9_;
#line 808 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = file;
#line 808 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = files_file_get_target_location (_tmp10_);
#line 808 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 808 "../src/View/AbstractDirectoryView.vala"
	location = _tmp12_;
#line 810 "../src/View/AbstractDirectoryView.vala"
	if (screen == NULL) {
#line 4805 "AbstractDirectoryView.c"
		GdkScreen* _tmp13_;
#line 811 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = gtk_widget_get_screen ((GtkWidget*) self);
#line 811 "../src/View/AbstractDirectoryView.vala"
		screen = _tmp13_;
#line 4811 "AbstractDirectoryView.c"
	}
#line 814 "../src/View/AbstractDirectoryView.vala"
	if (flag != FILES_OPEN_FLAG_APP) {
#line 4815 "AbstractDirectoryView.c"
		gboolean _tmp15_ = FALSE;
		gboolean _tmp16_ = FALSE;
		FilesFile* _tmp17_;
#line 814 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = file;
#line 814 "../src/View/AbstractDirectoryView.vala"
		if (files_file_is_folder (_tmp17_)) {
#line 814 "../src/View/AbstractDirectoryView.vala"
			_tmp16_ = TRUE;
#line 4825 "AbstractDirectoryView.c"
		} else {
			FilesFile* _tmp18_;
			const gchar* _tmp19_;
#line 815 "../src/View/AbstractDirectoryView.vala"
			_tmp18_ = file;
#line 815 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = files_file_get_ftype (_tmp18_);
#line 815 "../src/View/AbstractDirectoryView.vala"
			_tmp16_ = g_strcmp0 (_tmp19_, "inode/directory") == 0;
#line 4835 "AbstractDirectoryView.c"
		}
#line 814 "../src/View/AbstractDirectoryView.vala"
		if (_tmp16_) {
#line 814 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = TRUE;
#line 4841 "AbstractDirectoryView.c"
		} else {
			FilesFile* _tmp20_;
#line 816 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = file;
#line 816 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = files_file_is_root_network_folder (_tmp20_);
#line 4848 "AbstractDirectoryView.c"
		}
#line 814 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = _tmp15_;
#line 4852 "AbstractDirectoryView.c"
	} else {
#line 814 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = FALSE;
#line 4856 "AbstractDirectoryView.c"
	}
#line 814 "../src/View/AbstractDirectoryView.vala"
	if (_tmp14_) {
#line 818 "../src/View/AbstractDirectoryView.vala"
		switch (flag) {
#line 818 "../src/View/AbstractDirectoryView.vala"
			case FILES_OPEN_FLAG_NEW_TAB:
#line 818 "../src/View/AbstractDirectoryView.vala"
			case FILES_OPEN_FLAG_NEW_WINDOW:
#line 4866 "AbstractDirectoryView.c"
			{
				GFile* _tmp21_;
#line 821 "../src/View/AbstractDirectoryView.vala"
				_tmp21_ = location;
#line 821 "../src/View/AbstractDirectoryView.vala"
				g_signal_emit (self, files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL], 0, _tmp21_, flag, TRUE);
#line 822 "../src/View/AbstractDirectoryView.vala"
				break;
#line 4875 "AbstractDirectoryView.c"
			}
			default:
			{
#line 825 "../src/View/AbstractDirectoryView.vala"
				if (only_one_file) {
#line 4881 "AbstractDirectoryView.c"
					GFile* _tmp22_;
#line 826 "../src/View/AbstractDirectoryView.vala"
					_tmp22_ = location;
#line 826 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_load_location (self, _tmp22_);
#line 4887 "AbstractDirectoryView.c"
				}
#line 829 "../src/View/AbstractDirectoryView.vala"
				break;
#line 4891 "AbstractDirectoryView.c"
			}
		}
	} else {
#line 831 "../src/View/AbstractDirectoryView.vala"
		if (!self->priv->in_trash) {
#line 832 "../src/View/AbstractDirectoryView.vala"
			if (only_one_file) {
#line 4899 "AbstractDirectoryView.c"
				FilesFile* _tmp23_;
#line 833 "../src/View/AbstractDirectoryView.vala"
				_tmp23_ = file;
#line 833 "../src/View/AbstractDirectoryView.vala"
				if (files_file_is_executable (_tmp23_)) {
#line 4905 "AbstractDirectoryView.c"
					gchar* content_type = NULL;
					FilesFile* _tmp24_;
					const gchar* _tmp25_;
					gchar* _tmp26_;
					const gchar* _tmp27_;
#line 834 "../src/View/AbstractDirectoryView.vala"
					_tmp24_ = file;
#line 834 "../src/View/AbstractDirectoryView.vala"
					_tmp25_ = files_file_get_ftype (_tmp24_);
#line 834 "../src/View/AbstractDirectoryView.vala"
					_tmp26_ = g_strdup (_tmp25_);
#line 834 "../src/View/AbstractDirectoryView.vala"
					content_type = _tmp26_;
#line 836 "../src/View/AbstractDirectoryView.vala"
					_tmp27_ = content_type;
#line 836 "../src/View/AbstractDirectoryView.vala"
					if (g_content_type_is_a (_tmp27_, "text/plain")) {
#line 4923 "AbstractDirectoryView.c"
						FilesFile* _tmp28_;
						GAppInfo* _tmp29_;
#line 837 "../src/View/AbstractDirectoryView.vala"
						_tmp28_ = file;
#line 837 "../src/View/AbstractDirectoryView.vala"
						_tmp29_ = self->priv->default_app;
#line 837 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_open_file (self, _tmp28_, screen, _tmp29_);
#line 4932 "AbstractDirectoryView.c"
					} else {
						{
							FilesFile* _tmp30_;
#line 840 "../src/View/AbstractDirectoryView.vala"
							_tmp30_ = file;
#line 840 "../src/View/AbstractDirectoryView.vala"
							files_file_execute (_tmp30_, NULL, &_inner_error0_);
#line 840 "../src/View/AbstractDirectoryView.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4942 "AbstractDirectoryView.c"
								goto __catch0_g_error;
							}
						}
						goto __finally0;
						__catch0_g_error:
						{
							GError* e = NULL;
							GError* _tmp31_;
							const gchar* _tmp32_;
							FilesViewWindow* _tmp33_;
							GraniteMessageDialog* _tmp34_;
							GraniteMessageDialog* _tmp35_;
#line 839 "../src/View/AbstractDirectoryView.vala"
							e = _inner_error0_;
#line 839 "../src/View/AbstractDirectoryView.vala"
							_inner_error0_ = NULL;
#line 842 "../src/View/AbstractDirectoryView.vala"
							_tmp31_ = e;
#line 842 "../src/View/AbstractDirectoryView.vala"
							_tmp32_ = _tmp31_->message;
#line 842 "../src/View/AbstractDirectoryView.vala"
							_tmp33_ = self->window;
#line 842 "../src/View/AbstractDirectoryView.vala"
							_tmp34_ = pf_dialogs_show_warning_dialog (_ ("Cannot execute this file"), _tmp32_, (GtkWindow*) _tmp33_);
#line 842 "../src/View/AbstractDirectoryView.vala"
							_tmp35_ = _tmp34_;
#line 842 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp35_);
#line 839 "../src/View/AbstractDirectoryView.vala"
							_g_error_free0 (e);
#line 4973 "AbstractDirectoryView.c"
						}
						__finally0:
#line 839 "../src/View/AbstractDirectoryView.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 839 "../src/View/AbstractDirectoryView.vala"
							_g_free0 (content_type);
#line 839 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (location);
#line 839 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (file);
#line 839 "../src/View/AbstractDirectoryView.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 839 "../src/View/AbstractDirectoryView.vala"
							g_clear_error (&_inner_error0_);
#line 839 "../src/View/AbstractDirectoryView.vala"
							return;
#line 4990 "AbstractDirectoryView.c"
						}
					}
#line 833 "../src/View/AbstractDirectoryView.vala"
					_g_free0 (content_type);
#line 4995 "AbstractDirectoryView.c"
				} else {
					FilesFile* _tmp36_;
					GAppInfo* _tmp37_;
#line 846 "../src/View/AbstractDirectoryView.vala"
					_tmp36_ = file;
#line 846 "../src/View/AbstractDirectoryView.vala"
					_tmp37_ = self->priv->default_app;
#line 846 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_open_file (self, _tmp36_, screen, _tmp37_);
#line 5005 "AbstractDirectoryView.c"
				}
			}
		} else {
			FilesFile* _tmp38_;
			const gchar* _tmp39_;
			const gchar* _tmp40_;
			gchar* _tmp41_;
			gchar* _tmp42_;
			FilesViewWindow* _tmp43_;
			GraniteMessageDialog* _tmp44_;
			GraniteMessageDialog* _tmp45_;
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp38_ = file;
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp39_ = files_file_get_basename (_tmp38_);
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp40_ = _tmp39_;
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp41_ = g_strdup_printf (_ ("“%s” must be moved from Trash before opening"), _tmp40_);
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp42_ = _tmp41_;
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp43_ = self->window;
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp44_ = pf_dialogs_show_error_dialog (_tmp42_, _ ("Files inside Trash cannot be opened. To open this file, it must be mov" \
"ed elsewhere."), (GtkWindow*) _tmp43_);
#line 850 "../src/View/AbstractDirectoryView.vala"
			_tmp45_ = _tmp44_;
#line 850 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp45_);
#line 850 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (_tmp42_);
#line 5037 "AbstractDirectoryView.c"
		}
	}
#line 797 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (location);
#line 797 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 5044 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_open_file (FilesAbstractDirectoryView* self,
                                         FilesFile* file,
                                         GdkScreen* screen,
                                         GAppInfo* app_info)
{
#line 860 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 860 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 861 "../src/View/AbstractDirectoryView.vala"
	if (files_abstract_directory_view_can_open_file (self, file, TRUE)) {
#line 5059 "AbstractDirectoryView.c"
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 862 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = files_file_get_location (file);
#line 862 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp0_;
#line 862 "../src/View/AbstractDirectoryView.vala"
		files_mime_actions_open_glib_file_request (_tmp1_, (GtkWidget*) self, app_info);
#line 5068 "AbstractDirectoryView.c"
	}
}

static gchar*
bool_to_string (gboolean self)
{
	gchar* result;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 5078 "AbstractDirectoryView.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 5086 "AbstractDirectoryView.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 5095 "AbstractDirectoryView.c"
	}
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1541 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1542 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1542 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1542 "glib-2.0.vapi"
	return result;
#line 5115 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_can_open_file (FilesAbstractDirectoryView* self,
                                             FilesFile* file,
                                             gboolean show_error_dialog)
{
	gchar* err_msg1 = NULL;
	gchar* _tmp0_;
	gchar* err_msg2 = NULL;
	gchar* _tmp1_;
	gchar* content_type = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp12_;
	gboolean success = FALSE;
	const gchar* _tmp40_;
	gint _tmp41_;
	gint _tmp42_;
	gboolean _tmp43_ = FALSE;
	gboolean result;
#line 867 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 867 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 868 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_strdup (_ ("Cannot open this file"));
#line 868 "../src/View/AbstractDirectoryView.vala"
	err_msg1 = _tmp0_;
#line 869 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_strdup ("");
#line 869 "../src/View/AbstractDirectoryView.vala"
	err_msg2 = _tmp1_;
#line 870 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_file_get_ftype (file);
#line 870 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 870 "../src/View/AbstractDirectoryView.vala"
	content_type = _tmp3_;
#line 872 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = content_type;
#line 872 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_ == NULL) {
#line 5160 "AbstractDirectoryView.c"
		gboolean result_uncertain = FALSE;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gboolean _tmp7_ = FALSE;
		gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 873 "../src/View/AbstractDirectoryView.vala"
		result_uncertain = TRUE;
#line 874 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_file_get_basename (file);
#line 874 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp5_;
#line 874 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = g_content_type_guess (_tmp6_, NULL, (gsize) 0, &_tmp7_);
#line 874 "../src/View/AbstractDirectoryView.vala"
		result_uncertain = _tmp7_;
#line 874 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (content_type);
#line 874 "../src/View/AbstractDirectoryView.vala"
		content_type = _tmp8_;
#line 875 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = content_type;
#line 875 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = bool_to_string (result_uncertain);
#line 875 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_;
#line 875 "../src/View/AbstractDirectoryView.vala"
		g_debug ("AbstractDirectoryView.vala:875: Guessed content type to be %s from nam" \
"e - result_uncertain %s", _tmp9_, _tmp11_);
#line 875 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (_tmp11_);
#line 5193 "AbstractDirectoryView.c"
	}
#line 880 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = content_type;
#line 880 "../src/View/AbstractDirectoryView.vala"
	if (_tmp12_ == NULL) {
#line 5199 "AbstractDirectoryView.c"
		gchar* _tmp13_;
#line 881 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = g_strdup (_ ("Cannot identify file type to open"));
#line 881 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (err_msg2);
#line 881 "../src/View/AbstractDirectoryView.vala"
		err_msg2 = _tmp13_;
#line 5207 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp14_;
		FilesDirectory* _tmp15_;
		FilesDirectory* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
#line 882 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = self->slot;
#line 882 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp14_);
#line 882 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = _tmp15_;
#line 882 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = files_directory_get_can_open_files (_tmp16_);
#line 882 "../src/View/AbstractDirectoryView.vala"
		_tmp18_ = _tmp17_;
#line 882 "../src/View/AbstractDirectoryView.vala"
		if (!_tmp18_) {
#line 5226 "AbstractDirectoryView.c"
			FilesViewSlot* _tmp19_;
			FilesDirectory* _tmp20_;
			FilesDirectory* _tmp21_;
			const gchar* _tmp22_;
			const gchar* _tmp23_;
			gchar* _tmp24_;
#line 883 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = self->slot;
#line 883 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp19_);
#line 883 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = _tmp20_;
#line 883 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = files_directory_get_scheme (_tmp21_);
#line 883 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = _tmp22_;
#line 883 "../src/View/AbstractDirectoryView.vala"
			_tmp24_ = g_strdup_printf ("Cannot open files with this protocol (%s)", _tmp23_);
#line 883 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (err_msg2);
#line 883 "../src/View/AbstractDirectoryView.vala"
			err_msg2 = _tmp24_;
#line 5249 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp25_ = FALSE;
			FilesViewSlot* _tmp26_;
			FilesDirectory* _tmp27_;
			FilesDirectory* _tmp28_;
			gboolean _tmp29_;
			gboolean _tmp30_;
#line 884 "../src/View/AbstractDirectoryView.vala"
			_tmp26_ = self->slot;
#line 884 "../src/View/AbstractDirectoryView.vala"
			_tmp27_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp26_);
#line 884 "../src/View/AbstractDirectoryView.vala"
			_tmp28_ = _tmp27_;
#line 884 "../src/View/AbstractDirectoryView.vala"
			_tmp29_ = files_directory_get_can_stream_files (_tmp28_);
#line 884 "../src/View/AbstractDirectoryView.vala"
			_tmp30_ = _tmp29_;
#line 884 "../src/View/AbstractDirectoryView.vala"
			if (!_tmp30_) {
#line 5269 "AbstractDirectoryView.c"
				gboolean _tmp31_ = FALSE;
				const gchar* _tmp32_;
#line 885 "../src/View/AbstractDirectoryView.vala"
				_tmp32_ = content_type;
#line 885 "../src/View/AbstractDirectoryView.vala"
				if (string_contains (_tmp32_, "video")) {
#line 885 "../src/View/AbstractDirectoryView.vala"
					_tmp31_ = TRUE;
#line 5278 "AbstractDirectoryView.c"
				} else {
					const gchar* _tmp33_;
#line 885 "../src/View/AbstractDirectoryView.vala"
					_tmp33_ = content_type;
#line 885 "../src/View/AbstractDirectoryView.vala"
					_tmp31_ = string_contains (_tmp33_, "audio");
#line 5285 "AbstractDirectoryView.c"
				}
#line 885 "../src/View/AbstractDirectoryView.vala"
				_tmp25_ = _tmp31_;
#line 5289 "AbstractDirectoryView.c"
			} else {
#line 884 "../src/View/AbstractDirectoryView.vala"
				_tmp25_ = FALSE;
#line 5293 "AbstractDirectoryView.c"
			}
#line 884 "../src/View/AbstractDirectoryView.vala"
			if (_tmp25_) {
#line 5297 "AbstractDirectoryView.c"
				FilesViewSlot* _tmp34_;
				FilesDirectory* _tmp35_;
				FilesDirectory* _tmp36_;
				const gchar* _tmp37_;
				const gchar* _tmp38_;
				gchar* _tmp39_;
#line 887 "../src/View/AbstractDirectoryView.vala"
				_tmp34_ = self->slot;
#line 887 "../src/View/AbstractDirectoryView.vala"
				_tmp35_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp34_);
#line 887 "../src/View/AbstractDirectoryView.vala"
				_tmp36_ = _tmp35_;
#line 887 "../src/View/AbstractDirectoryView.vala"
				_tmp37_ = files_directory_get_scheme (_tmp36_);
#line 887 "../src/View/AbstractDirectoryView.vala"
				_tmp38_ = _tmp37_;
#line 887 "../src/View/AbstractDirectoryView.vala"
				_tmp39_ = g_strdup_printf ("Cannot stream from this protocol (%s)", _tmp38_);
#line 887 "../src/View/AbstractDirectoryView.vala"
				_g_free0 (err_msg2);
#line 887 "../src/View/AbstractDirectoryView.vala"
				err_msg2 = _tmp39_;
#line 5320 "AbstractDirectoryView.c"
			}
		}
	}
#line 890 "../src/View/AbstractDirectoryView.vala"
	_tmp40_ = err_msg2;
#line 890 "../src/View/AbstractDirectoryView.vala"
	_tmp41_ = strlen (_tmp40_);
#line 890 "../src/View/AbstractDirectoryView.vala"
	_tmp42_ = _tmp41_;
#line 890 "../src/View/AbstractDirectoryView.vala"
	success = _tmp42_ < 1;
#line 891 "../src/View/AbstractDirectoryView.vala"
	if (!success) {
#line 891 "../src/View/AbstractDirectoryView.vala"
		_tmp43_ = show_error_dialog;
#line 5336 "AbstractDirectoryView.c"
	} else {
#line 891 "../src/View/AbstractDirectoryView.vala"
		_tmp43_ = FALSE;
#line 5340 "AbstractDirectoryView.c"
	}
#line 891 "../src/View/AbstractDirectoryView.vala"
	if (_tmp43_) {
#line 5344 "AbstractDirectoryView.c"
		const gchar* _tmp44_;
		const gchar* _tmp45_;
		FilesViewWindow* _tmp46_;
		GraniteMessageDialog* _tmp47_;
		GraniteMessageDialog* _tmp48_;
#line 892 "../src/View/AbstractDirectoryView.vala"
		_tmp44_ = err_msg1;
#line 892 "../src/View/AbstractDirectoryView.vala"
		_tmp45_ = err_msg2;
#line 892 "../src/View/AbstractDirectoryView.vala"
		_tmp46_ = self->window;
#line 892 "../src/View/AbstractDirectoryView.vala"
		_tmp47_ = pf_dialogs_show_warning_dialog (_tmp44_, _tmp45_, (GtkWindow*) _tmp46_);
#line 892 "../src/View/AbstractDirectoryView.vala"
		_tmp48_ = _tmp47_;
#line 892 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp48_);
#line 5362 "AbstractDirectoryView.c"
	}
#line 895 "../src/View/AbstractDirectoryView.vala"
	result = success;
#line 895 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (content_type);
#line 895 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (err_msg2);
#line 895 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (err_msg1);
#line 895 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 5374 "AbstractDirectoryView.c"
}

static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 898 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 898 "../src/View/AbstractDirectoryView.vala"
	return _data23_;
#line 5384 "AbstractDirectoryView.c"
}

static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 898 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 5394 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 898 "../src/View/AbstractDirectoryView.vala"
		self = _data23_->self;
#line 898 "../src/View/AbstractDirectoryView.vala"
		(_data23_->locations == NULL) ? NULL : (_data23_->locations = (_g_list_free__g_object_unref0_ (_data23_->locations), NULL));
#line 898 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 898 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block23Data, _data23_);
#line 5404 "AbstractDirectoryView.c"
	}
}

static void
___lambda89_ (Block23Data* _data23_,
              FilesFile* file)
{
	FilesAbstractDirectoryView* self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GFile* _tmp2_;
#line 904 "../src/View/AbstractDirectoryView.vala"
	self = _data23_->self;
#line 904 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 905 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_file_get_display_target_uri (file);
#line 905 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 905 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_file_new_for_uri (_tmp1_);
#line 905 "../src/View/AbstractDirectoryView.vala"
	_data23_->locations = g_list_prepend (_data23_->locations, _tmp2_);
#line 905 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp1_);
#line 5430 "AbstractDirectoryView.c"
}

static void
____lambda89__gfunc (gconstpointer data,
                     gpointer self)
{
#line 904 "../src/View/AbstractDirectoryView.vala"
	___lambda89_ (self, (FilesFile*) data);
#line 5439 "AbstractDirectoryView.c"
}

static void
___lambda90_ (Block23Data* _data23_,
              FilesFile* file)
{
	FilesAbstractDirectoryView* self;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
#line 908 "../src/View/AbstractDirectoryView.vala"
	self = _data23_->self;
#line 908 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 909 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_file_get_location (file);
#line 909 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 909 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 909 "../src/View/AbstractDirectoryView.vala"
	_data23_->locations = g_list_prepend (_data23_->locations, _tmp2_);
#line 5462 "AbstractDirectoryView.c"
}

static void
____lambda90__gfunc (gconstpointer data,
                     gpointer self)
{
#line 908 "../src/View/AbstractDirectoryView.vala"
	___lambda90_ (self, (FilesFile*) data);
#line 5471 "AbstractDirectoryView.c"
}

static void
___lambda91_ (FilesAbstractDirectoryView* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 926 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 5482 "AbstractDirectoryView.c"
	{
#line 928 "../src/View/AbstractDirectoryView.vala"
		marlin_file_operations_delete_finish (res, &_inner_error0_);
#line 928 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5488 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp0_;
		const gchar* _tmp1_;
#line 927 "../src/View/AbstractDirectoryView.vala"
		e = _inner_error0_;
#line 927 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 930 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = e;
#line 930 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp0_->message;
#line 930 "../src/View/AbstractDirectoryView.vala"
		g_debug ("AbstractDirectoryView.vala:930: %s", _tmp1_);
#line 927 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (e);
#line 5510 "AbstractDirectoryView.c"
	}
	__finally0:
#line 927 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 927 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 927 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 927 "../src/View/AbstractDirectoryView.vala"
		return;
#line 5521 "AbstractDirectoryView.c"
	}
#line 933 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_after_trash_or_delete (self);
#line 5525 "AbstractDirectoryView.c"
}

static void
____lambda91__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 921 "../src/View/AbstractDirectoryView.vala"
	___lambda91_ ((FilesAbstractDirectoryView*) self, source_object, res);
#line 921 "../src/View/AbstractDirectoryView.vala"
	g_object_unref (self);
#line 5537 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_trash_or_delete_files (FilesAbstractDirectoryView* self,
                                                     GList* file_list,
                                                     gboolean delete_if_already_in_trash,
                                                     gboolean delete_immediately)
{
	Block23Data* _data23_;
	gboolean _tmp0_;
	GtkTreeIter* iter = NULL;
	FilesListModel* _tmp1_;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	GtkTreeIter* _tmp4_ = NULL;
	FilesListModel* _tmp5_;
	GtkTreeIter* _tmp6_;
	GtkTreeIter _tmp7_;
	GtkTreePath* _tmp8_;
	GList* _tmp9_;
	gboolean _tmp15_;
#line 898 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 898 "../src/View/AbstractDirectoryView.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 898 "../src/View/AbstractDirectoryView.vala"
	_data23_->_ref_count_ = 1;
#line 898 "../src/View/AbstractDirectoryView.vala"
	_data23_->self = g_object_ref (self);
#line 902 "../src/View/AbstractDirectoryView.vala"
	_data23_->locations = NULL;
#line 903 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->_in_recent;
#line 903 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 904 "../src/View/AbstractDirectoryView.vala"
		g_list_foreach (file_list, ____lambda89__gfunc, _data23_);
#line 5575 "AbstractDirectoryView.c"
	} else {
#line 908 "../src/View/AbstractDirectoryView.vala"
		g_list_foreach (file_list, ____lambda90__gfunc, _data23_);
#line 5579 "AbstractDirectoryView.c"
	}
#line 913 "../src/View/AbstractDirectoryView.vala"
	iter = NULL;
#line 914 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->model;
#line 914 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_list_first (file_list);
#line 914 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_->data;
#line 914 "../src/View/AbstractDirectoryView.vala"
	files_list_model_get_first_iter_for_file (_tmp1_, (FilesFile*) _tmp3_, &_tmp4_);
#line 914 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 914 "../src/View/AbstractDirectoryView.vala"
	iter = _tmp4_;
#line 915 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = self->model;
#line 915 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = iter;
#line 915 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = *_tmp6_;
#line 915 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp5_, &_tmp7_);
#line 915 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->priv->deleted_path);
#line 915 "../src/View/AbstractDirectoryView.vala"
	self->priv->deleted_path = _tmp8_;
#line 917 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _data23_->locations;
#line 917 "../src/View/AbstractDirectoryView.vala"
	if (_tmp9_ != NULL) {
#line 5611 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp10_;
		FilesDirectory* _tmp11_;
		FilesDirectory* _tmp12_;
		GList* _tmp13_;
		FilesViewWindow* _tmp14_;
#line 918 "../src/View/AbstractDirectoryView.vala"
		_data23_->locations = g_list_reverse (_data23_->locations);
#line 920 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->slot;
#line 920 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp10_);
#line 920 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = _tmp11_;
#line 920 "../src/View/AbstractDirectoryView.vala"
		files_directory_block_monitor (_tmp12_);
#line 921 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = _data23_->locations;
#line 921 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = self->window;
#line 921 "../src/View/AbstractDirectoryView.vala"
		marlin_file_operations_delete (_tmp13_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp14_) : NULL, !delete_immediately, NULL, ____lambda91__gasync_ready_callback, g_object_ref (self));
#line 5633 "AbstractDirectoryView.c"
	}
#line 939 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = self->priv->_in_recent;
#line 939 "../src/View/AbstractDirectoryView.vala"
	if (_tmp15_) {
#line 5639 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp16_;
#line 940 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = self->slot;
#line 940 "../src/View/AbstractDirectoryView.vala"
		files_abstract_slot_reload ((FilesAbstractSlot*) _tmp16_, FALSE);
#line 5645 "AbstractDirectoryView.c"
	}
#line 898 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 898 "../src/View/AbstractDirectoryView.vala"
	block23_data_unref (_data23_);
#line 898 "../src/View/AbstractDirectoryView.vala"
	_data23_ = NULL;
#line 5653 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_add_file (FilesAbstractDirectoryView* self,
                                        FilesFile* file,
                                        FilesDirectory* dir,
                                        gboolean is_internal)
{
	FilesListModel* _tmp0_;
#line 946 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 946 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 946 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 947 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 947 "../src/View/AbstractDirectoryView.vala"
	files_list_model_insert_sorted (_tmp0_, file, dir);
#line 949 "../src/View/AbstractDirectoryView.vala"
	if (is_internal) {
#line 950 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_add_gof_file_to_selection (self, file);
#line 5677 "AbstractDirectoryView.c"
	}
}

static gboolean
___lambda80_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 959 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->signal_free_space_change) {
#line 5687 "AbstractDirectoryView.c"
		FilesViewWindow* _tmp0_;
#line 960 "../src/View/AbstractDirectoryView.vala"
		self->priv->add_remove_file_timeout_id = (guint) 0;
#line 961 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = self->window;
#line 961 "../src/View/AbstractDirectoryView.vala"
		g_signal_emit_by_name (_tmp0_, "free-space-change");
#line 962 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_REMOVE;
#line 962 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 5699 "AbstractDirectoryView.c"
	} else {
#line 964 "../src/View/AbstractDirectoryView.vala"
		self->priv->signal_free_space_change = TRUE;
#line 965 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 965 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 5707 "AbstractDirectoryView.c"
	}
}

static gboolean
____lambda80__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda80_ ((FilesAbstractDirectoryView*) self);
#line 958 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 5718 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_handle_free_space_change (FilesAbstractDirectoryView* self)
{
#line 954 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 956 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->add_remove_file_timeout_id == ((guint) 0)) {
#line 957 "../src/View/AbstractDirectoryView.vala"
		self->priv->signal_free_space_change = FALSE;
#line 958 "../src/View/AbstractDirectoryView.vala"
		self->priv->add_remove_file_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 250, ____lambda80__gsource_func, g_object_ref (self), g_object_unref);
#line 5732 "AbstractDirectoryView.c"
	} else {
#line 969 "../src/View/AbstractDirectoryView.vala"
		self->priv->signal_free_space_change = FALSE;
#line 5736 "AbstractDirectoryView.c"
	}
}

static void
__lambda115_ (FilesAbstractDirectoryView* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 987 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 5748 "AbstractDirectoryView.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
#line 989 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = marlin_file_operations_new_file_finish (res, &_inner_error0_);
#line 989 "../src/View/AbstractDirectoryView.vala"
		file = _tmp0_;
#line 989 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5758 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 990 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_create_file_done (file, self);
#line 988 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 5765 "AbstractDirectoryView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 988 "../src/View/AbstractDirectoryView.vala"
		e = _inner_error0_;
#line 988 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 992 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = e;
#line 992 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_->message;
#line 992 "../src/View/AbstractDirectoryView.vala"
		g_critical ("AbstractDirectoryView.vala:992: %s", _tmp2_);
#line 988 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (e);
#line 5785 "AbstractDirectoryView.c"
	}
	__finally0:
#line 988 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 988 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 988 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 988 "../src/View/AbstractDirectoryView.vala"
		return;
#line 5796 "AbstractDirectoryView.c"
	}
}

static void
___lambda115__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 980 "../src/View/AbstractDirectoryView.vala"
	__lambda115_ ((FilesAbstractDirectoryView*) self, source_object, res);
#line 980 "../src/View/AbstractDirectoryView.vala"
	g_object_unref (self);
#line 5809 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_new_empty_file (FilesAbstractDirectoryView* self,
                                              const gchar* parent_uri)
{
	FilesViewSlot* _tmp7_;
	FilesDirectory* _tmp8_;
	FilesDirectory* _tmp9_;
#line 973 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 974 "../src/View/AbstractDirectoryView.vala"
	if (parent_uri == NULL) {
#line 5823 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp0_;
		FilesDirectory* _tmp1_;
		FilesDirectory* _tmp2_;
		FilesFile* _tmp3_;
		FilesFile* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 975 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = self->slot;
#line 975 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 975 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_;
#line 975 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_directory_get_file (_tmp2_);
#line 975 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = _tmp3_;
#line 975 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_file_get_uri (_tmp4_);
#line 975 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp5_;
#line 975 "../src/View/AbstractDirectoryView.vala"
		parent_uri = _tmp6_;
#line 5847 "AbstractDirectoryView.c"
	}
#line 979 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->slot;
#line 979 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp7_);
#line 979 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _tmp8_;
#line 979 "../src/View/AbstractDirectoryView.vala"
	files_directory_block_monitor (_tmp9_);
#line 980 "../src/View/AbstractDirectoryView.vala"
	marlin_file_operations_new_file ((GtkWidget*) self, parent_uri, NULL, NULL, 0, NULL, ___lambda115__gasync_ready_callback, g_object_ref (self));
#line 5859 "AbstractDirectoryView.c"
}

static void
__lambda97_ (FilesAbstractDirectoryView* self,
             GObject* obj,
             GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 1001 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 5870 "AbstractDirectoryView.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
#line 1003 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = marlin_file_operations_new_folder_finish (res, &_inner_error0_);
#line 1003 "../src/View/AbstractDirectoryView.vala"
		file = _tmp0_;
#line 1003 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5880 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 1004 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_create_file_done (file, self);
#line 1002 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 5887 "AbstractDirectoryView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 1002 "../src/View/AbstractDirectoryView.vala"
		e = _inner_error0_;
#line 1002 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 1006 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = e;
#line 1006 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_->message;
#line 1006 "../src/View/AbstractDirectoryView.vala"
		g_critical ("AbstractDirectoryView.vala:1006: %s", _tmp2_);
#line 1002 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (e);
#line 5907 "AbstractDirectoryView.c"
	}
	__finally0:
#line 1002 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1002 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1002 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 1002 "../src/View/AbstractDirectoryView.vala"
		return;
#line 5918 "AbstractDirectoryView.c"
	}
}

static void
___lambda97__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 1001 "../src/View/AbstractDirectoryView.vala"
	__lambda97_ ((FilesAbstractDirectoryView*) self, source_object, res);
#line 1001 "../src/View/AbstractDirectoryView.vala"
	g_object_unref (self);
#line 5931 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_new_empty_folder (FilesAbstractDirectoryView* self)
{
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
	FilesViewSlot* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
#line 998 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1000 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 1000 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 1000 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1000 "../src/View/AbstractDirectoryView.vala"
	files_directory_block_monitor (_tmp2_);
#line 1001 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->slot;
#line 1001 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = files_abstract_slot_get_location ((FilesAbstractSlot*) _tmp3_);
#line 1001 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _tmp4_;
#line 1001 "../src/View/AbstractDirectoryView.vala"
	marlin_file_operations_new_folder ((GtkWidget*) self, _tmp5_, NULL, ___lambda97__gasync_ready_callback, g_object_ref (self));
#line 5961 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_after_new_file_added_files_directory_file_added (FilesDirectory* _sender,
                                                                                FilesFile* file,
                                                                                gboolean is_internal,
                                                                                gpointer self)
{
#line 1012 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_after_new_file_added ((FilesAbstractDirectoryView*) self, file);
#line 5972 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_after_new_file_added (FilesAbstractDirectoryView* self,
                                                    FilesFile* file)
{
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
	guint _tmp3_;
#line 1011 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1012 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 1012 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 1012 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1012 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("file-added", FILES_TYPE_DIRECTORY, &_tmp3_, NULL, FALSE);
#line 1012 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _files_abstract_directory_view_after_new_file_added_files_directory_file_added, self);
#line 1013 "../src/View/AbstractDirectoryView.vala"
	if (file != NULL) {
#line 1014 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_rename_file (self, file);
#line 5999 "AbstractDirectoryView.c"
	}
}

static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 1018 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 1018 "../src/View/AbstractDirectoryView.vala"
	return _data24_;
#line 6010 "AbstractDirectoryView.c"
}

static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 1018 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 6020 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 1018 "../src/View/AbstractDirectoryView.vala"
		self = _data24_->self;
#line 1018 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data24_->file_to_rename);
#line 1018 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 1018 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block24Data, _data24_);
#line 6030 "AbstractDirectoryView.c"
	}
}

static gboolean
___lambda87_ (Block24Data* _data24_)
{
	FilesAbstractDirectoryView* self;
	FilesListModel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 1027 "../src/View/AbstractDirectoryView.vala"
	self = _data24_->self;
#line 1028 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 1028 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_list_model_get_sort_pending (_tmp0_);
#line 1028 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1028 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 1029 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 1029 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 6056 "AbstractDirectoryView.c"
	} else {
#line 1031 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_start_renaming_file (self, _data24_->file_to_rename);
#line 1032 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_REMOVE;
#line 1032 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 6064 "AbstractDirectoryView.c"
	}
}

static gboolean
____lambda87__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda87_ (self);
#line 1027 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 6075 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_rename_file (FilesAbstractDirectoryView* self,
                                           FilesFile* file_to_rename)
{
	Block24Data* _data24_;
	FilesFile* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp4_ = FALSE;
#line 1018 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1018 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file_to_rename != NULL);
#line 1018 "../src/View/AbstractDirectoryView.vala"
	_data24_ = g_slice_new0 (Block24Data);
#line 1018 "../src/View/AbstractDirectoryView.vala"
	_data24_->_ref_count_ = 1;
#line 1018 "../src/View/AbstractDirectoryView.vala"
	_data24_->self = g_object_ref (self);
#line 1018 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (file_to_rename);
#line 1018 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data24_->file_to_rename);
#line 1018 "../src/View/AbstractDirectoryView.vala"
	_data24_->file_to_rename = _tmp0_;
#line 1019 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->_renaming;
#line 1019 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 6106 "AbstractDirectoryView.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 1020 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_file_get_basename (_data24_->file_to_rename);
#line 1020 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 1020 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:1020: already renaming %s", _tmp3_);
#line 1021 "../src/View/AbstractDirectoryView.vala"
		block24_data_unref (_data24_);
#line 1021 "../src/View/AbstractDirectoryView.vala"
		_data24_ = NULL;
#line 1021 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6121 "AbstractDirectoryView.c"
	}
#line 1025 "../src/View/AbstractDirectoryView.vala"
	if (self->is_writable) {
#line 1025 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = TRUE;
#line 6127 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp5_;
		FilesDirectory* _tmp6_;
		FilesDirectory* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 1025 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->slot;
#line 1025 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp5_);
#line 1025 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp6_;
#line 1025 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = files_directory_get_is_local (_tmp7_);
#line 1025 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = _tmp8_;
#line 1025 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = !_tmp9_;
#line 6146 "AbstractDirectoryView.c"
	}
#line 1025 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_) {
#line 1027 "../src/View/AbstractDirectoryView.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 50, ____lambda87__gsource_func, block24_data_ref (_data24_), block24_data_unref);
#line 6152 "AbstractDirectoryView.c"
	} else {
#line 1037 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:1037: You do not have permission to rename " \
"this file");
#line 6156 "AbstractDirectoryView.c"
	}
#line 1018 "../src/View/AbstractDirectoryView.vala"
	block24_data_unref (_data24_);
#line 1018 "../src/View/AbstractDirectoryView.vala"
	_data24_ = NULL;
#line 6162 "AbstractDirectoryView.c"
}

/** File operation callbacks */
void
files_abstract_directory_view_create_file_done (GFile* new_file,
                                                FilesAbstractDirectoryView* self)
{
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
#line 1043 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1044 "../src/View/AbstractDirectoryView.vala"
	if (new_file == NULL) {
#line 1045 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6179 "AbstractDirectoryView.c"
	}
#line 1049 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 1049 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 1049 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1049 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (_tmp2_, "file-added", (GCallback) _files_abstract_directory_view_after_new_file_added_files_directory_file_added, self, G_CONNECT_AFTER);
#line 1050 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unblock_directory_monitor (self);
#line 6191 "AbstractDirectoryView.c"
}

static gboolean
__lambda92_ (FilesAbstractDirectoryView* self)
{
	GtkTreePath* _tmp0_;
	gboolean result;
#line 1056 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->deleted_path;
#line 1056 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_cursor (self, _tmp0_, FALSE, FALSE, FALSE);
#line 1057 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unblock_directory_monitor (self);
#line 1058 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1058 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 6209 "AbstractDirectoryView.c"
}

static gboolean
___lambda92__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda92_ ((FilesAbstractDirectoryView*) self);
#line 1055 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 6219 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_after_trash_or_delete (FilesAbstractDirectoryView* self)
{
#line 1053 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1055 "../src/View/AbstractDirectoryView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda92__gsource_func, g_object_ref (self), g_object_unref);
#line 6229 "AbstractDirectoryView.c"
}

static gboolean
__lambda93_ (FilesAbstractDirectoryView* self)
{
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
	gboolean result;
#line 1067 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 1067 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 1067 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1067 "../src/View/AbstractDirectoryView.vala"
	files_directory_unblock_monitor (_tmp2_);
#line 1068 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1068 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 6251 "AbstractDirectoryView.c"
}

static gboolean
___lambda93__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda93_ ((FilesAbstractDirectoryView*) self);
#line 1066 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 6261 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_unblock_directory_monitor (FilesAbstractDirectoryView* self)
{
#line 1063 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1066 "../src/View/AbstractDirectoryView.vala"
	g_idle_add_full (G_PRIORITY_LOW, ___lambda93__gsource_func, g_object_ref (self), g_object_unref);
#line 6271 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_trash_or_delete_selected_files (FilesAbstractDirectoryView* self,
                                                              gboolean delete_immediately)
{
	GList* selection = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 1072 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1077 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_files (self);
#line 1077 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_selected_files_for_transfer (self, _tmp0_);
#line 1077 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp1_;
#line 1078 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = selection;
#line 1078 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_ != NULL) {
#line 6294 "AbstractDirectoryView.c"
		GList* _tmp3_;
#line 1079 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = selection;
#line 1079 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_trash_or_delete_files (self, _tmp3_, TRUE, delete_immediately);
#line 6300 "AbstractDirectoryView.c"
	}
#line 1072 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 6304 "AbstractDirectoryView.c"
}

/** Selection actions */
static void
files_abstract_directory_view_on_selection_action_view_in_location (FilesAbstractDirectoryView* self,
                                                                    GSimpleAction* action,
                                                                    GVariant* param)
{
#line 1088 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1088 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1089 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_view_selected_file (self);
#line 6319 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_view_selected_file (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 1092 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1093 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 1093 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 1094 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6335 "AbstractDirectoryView.c"
	}
#line 1097 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->selected_files;
#line 6339 "AbstractDirectoryView.c"
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
#line 1097 "../src/View/AbstractDirectoryView.vala"
		file_collection = _tmp1_;
#line 1097 "../src/View/AbstractDirectoryView.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 6347 "AbstractDirectoryView.c"
			FilesFile* _tmp2_;
			FilesFile* file = NULL;
#line 1097 "../src/View/AbstractDirectoryView.vala"
			_tmp2_ = _g_object_ref0 ((FilesFile*) file_it->data);
#line 1097 "../src/View/AbstractDirectoryView.vala"
			file = _tmp2_;
#line 6354 "AbstractDirectoryView.c"
			{
				GFile* loc = NULL;
				FilesFile* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				GFile* _tmp6_;
				GFile* _tmp7_;
				GFile* _tmp8_;
#line 1098 "../src/View/AbstractDirectoryView.vala"
				_tmp3_ = file;
#line 1098 "../src/View/AbstractDirectoryView.vala"
				_tmp4_ = files_file_get_display_target_uri (_tmp3_);
#line 1098 "../src/View/AbstractDirectoryView.vala"
				_tmp5_ = _tmp4_;
#line 1098 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = g_file_new_for_uri (_tmp5_);
#line 1098 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = _tmp6_;
#line 1098 "../src/View/AbstractDirectoryView.vala"
				_g_free0 (_tmp5_);
#line 1098 "../src/View/AbstractDirectoryView.vala"
				loc = _tmp7_;
#line 1099 "../src/View/AbstractDirectoryView.vala"
				_tmp8_ = loc;
#line 1099 "../src/View/AbstractDirectoryView.vala"
				g_signal_emit (self, files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL], 0, _tmp8_, FILES_OPEN_FLAG_NEW_TAB, TRUE);
#line 1097 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (loc);
#line 1097 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (file);
#line 6385 "AbstractDirectoryView.c"
			}
		}
	}
}

static void
files_abstract_directory_view_on_selection_action_forget (FilesAbstractDirectoryView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param)
{
#line 1103 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1103 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1104 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_forget_selected_file (self);
#line 6402 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_forget_selected_file (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 1107 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1108 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 1108 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 1109 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6418 "AbstractDirectoryView.c"
	}
	{
		GList* _tmp1_;
#line 1113 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->selected_files;
#line 6424 "AbstractDirectoryView.c"
		{
			GList* file_collection = NULL;
			GList* file_it = NULL;
#line 1113 "../src/View/AbstractDirectoryView.vala"
			file_collection = _tmp1_;
#line 1113 "../src/View/AbstractDirectoryView.vala"
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 6432 "AbstractDirectoryView.c"
				FilesFile* _tmp2_;
				FilesFile* file = NULL;
#line 1113 "../src/View/AbstractDirectoryView.vala"
				_tmp2_ = _g_object_ref0 ((FilesFile*) file_it->data);
#line 1113 "../src/View/AbstractDirectoryView.vala"
				file = _tmp2_;
#line 6439 "AbstractDirectoryView.c"
				{
					GtkRecentManager* _tmp3_;
					FilesFile* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
#line 1114 "../src/View/AbstractDirectoryView.vala"
					_tmp3_ = self->recent;
#line 1114 "../src/View/AbstractDirectoryView.vala"
					_tmp4_ = file;
#line 1114 "../src/View/AbstractDirectoryView.vala"
					_tmp5_ = files_file_get_display_target_uri (_tmp4_);
#line 1114 "../src/View/AbstractDirectoryView.vala"
					_tmp6_ = _tmp5_;
#line 1114 "../src/View/AbstractDirectoryView.vala"
					gtk_recent_manager_remove_item (_tmp3_, _tmp6_, &_inner_error0_);
#line 1114 "../src/View/AbstractDirectoryView.vala"
					_g_free0 (_tmp6_);
#line 1114 "../src/View/AbstractDirectoryView.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1114 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (file);
#line 6461 "AbstractDirectoryView.c"
						goto __catch0_g_error;
					}
#line 1113 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (file);
#line 6466 "AbstractDirectoryView.c"
				}
			}
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 1112 "../src/View/AbstractDirectoryView.vala"
		err = _inner_error0_;
#line 1112 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 1117 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = err;
#line 1117 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = _tmp7_->message;
#line 1117 "../src/View/AbstractDirectoryView.vala"
		g_critical ("AbstractDirectoryView.vala:1117: %s", _tmp8_);
#line 1112 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (err);
#line 6489 "AbstractDirectoryView.c"
	}
	__finally0:
#line 1112 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1112 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1112 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 1112 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6500 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_on_selection_action_rename (FilesAbstractDirectoryView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param)
{
#line 1121 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1121 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1122 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_rename_selection (self);
#line 6515 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_rename_selection (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 1125 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1126 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 1126 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 1127 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6532 "AbstractDirectoryView.c"
	}
#line 1130 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->selected_files;
#line 1130 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_->next;
#line 1130 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_ != NULL) {
#line 6540 "AbstractDirectoryView.c"
		FilesRenamerDialog* rename_dialog = NULL;
		GList* _tmp3_;
		FilesViewSlot* _tmp4_;
		FilesViewWindow* _tmp5_;
		FilesViewWindow* _tmp6_;
		GtkWindow* _tmp7_;
		FilesRenamerDialog* _tmp8_ = NULL;
		FilesRenamerDialog* _tmp9_;
#line 1131 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = self->selected_files;
#line 1131 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = self->slot;
#line 1131 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_view_slot_get_window (_tmp4_);
#line 1131 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp5_;
#line 1131 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _g_object_ref0 ((GtkWindow*) _tmp6_);
#line 1131 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = files_renamer_dialog_new (_tmp3_, NULL);
#line 1131 "../src/View/AbstractDirectoryView.vala"
		gtk_window_set_transient_for ((GtkWindow*) _tmp8_, _tmp7_);
#line 1131 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp7_);
#line 1131 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp8_);
#line 1131 "../src/View/AbstractDirectoryView.vala"
		rename_dialog = _tmp8_;
#line 1134 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = rename_dialog;
#line 1134 "../src/View/AbstractDirectoryView.vala"
		gtk_window_present ((GtkWindow*) _tmp9_);
#line 1130 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (rename_dialog);
#line 6575 "AbstractDirectoryView.c"
	} else {
		GList* _tmp10_;
		gconstpointer _tmp11_;
#line 1136 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->selected_files;
#line 1136 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_->data;
#line 1136 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_rename_file (self, (FilesFile*) _tmp11_);
#line 6585 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_on_selection_action_cut (FilesAbstractDirectoryView* self,
                                                       GSimpleAction* action,
                                                       GVariant* param)
{
	GList* selection = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	FilesClipboardManager* _tmp2_;
#line 1140 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1140 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1141 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_files (self);
#line 1141 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_selected_files_for_transfer (self, _tmp0_);
#line 1141 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp1_;
#line 1142 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->priv->clipboard;
#line 1142 "../src/View/AbstractDirectoryView.vala"
	files_clipboard_manager_cut_files (_tmp2_, selection);
#line 1140 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 6614 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_trash (FilesAbstractDirectoryView* self,
                                                         GSimpleAction* action,
                                                         GVariant* param)
{
#line 1145 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1145 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1146 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_trash_or_delete_selected_files (self, files_is_admin ());
#line 6628 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_delete (FilesAbstractDirectoryView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param)
{
#line 1149 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1149 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1150 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_trash_or_delete_selected_files (self, TRUE);
#line 6642 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_restore (FilesAbstractDirectoryView* self,
                                                           GSimpleAction* action,
                                                           GVariant* param)
{
	GList* selection = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	FilesViewWindow* _tmp2_;
#line 1153 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1153 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1154 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_files (self);
#line 1154 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_selected_files_for_transfer (self, _tmp0_);
#line 1154 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp1_;
#line 1155 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->window;
#line 1155 "../src/View/AbstractDirectoryView.vala"
	files_file_utils_restore_files_from_trash (selection, (GtkWidget*) _tmp2_);
#line 1153 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 6670 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_open_executable (FilesAbstractDirectoryView* self,
                                                                   GSimpleAction* action,
                                                                   GVariant* param)
{
	GList* selection = NULL;
	GList* _tmp0_;
	FilesFile* file = NULL;
	gconstpointer _tmp1_;
	FilesFile* _tmp2_;
	FilesFile* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 1159 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1159 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1160 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_files_for_action (self);
#line 1160 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp0_;
#line 1161 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = selection->data;
#line 1161 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = (FilesFile*) _tmp1_;
#line 1161 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, FILES_TYPE_FILE) ? ((FilesFile*) _tmp2_) : NULL);
#line 1161 "../src/View/AbstractDirectoryView.vala"
	file = _tmp3_;
#line 6701 "AbstractDirectoryView.c"
	{
#line 1163 "../src/View/AbstractDirectoryView.vala"
		files_file_execute (file, NULL, &_inner_error0_);
#line 1163 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6707 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		FilesViewWindow* _tmp6_;
		GraniteMessageDialog* _tmp7_;
		GraniteMessageDialog* _tmp8_;
#line 1162 "../src/View/AbstractDirectoryView.vala"
		e = _inner_error0_;
#line 1162 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 1165 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = e;
#line 1165 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = _tmp4_->message;
#line 1165 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = self->window;
#line 1165 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = pf_dialogs_show_warning_dialog (_ ("Cannot execute this file"), _tmp5_, (GtkWindow*) _tmp6_);
#line 1165 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = _tmp7_;
#line 1165 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp8_);
#line 1162 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (e);
#line 6738 "AbstractDirectoryView.c"
	}
	__finally0:
#line 1162 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1162 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 1162 "../src/View/AbstractDirectoryView.vala"
		(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 1162 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1162 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 1162 "../src/View/AbstractDirectoryView.vala"
		return;
#line 6753 "AbstractDirectoryView.c"
	}
#line 1159 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 1159 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 6759 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_open_with_default (FilesAbstractDirectoryView* self,
                                                                     GSimpleAction* action,
                                                                     GVariant* param)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 1169 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1169 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1170 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_files_for_action (self);
#line 1170 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1170 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_APP, _tmp1_);
#line 1170 "../src/View/AbstractDirectoryView.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
#line 6781 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_open_with_app (FilesAbstractDirectoryView* self,
                                                                 GSimpleAction* action,
                                                                 GVariant* param)
{
	GList* _tmp0_;
	gconstpointer _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
#line 1173 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1173 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1174 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->open_with_apps;
#line 1174 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_list_nth_data (_tmp0_, (guint) g_variant_get_uint32 (param));
#line 1174 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_abstract_directory_view_get_files_for_action (self);
#line 1174 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 1174 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_open_files_with (self, (GAppInfo*) _tmp1_, _tmp3_);
#line 1174 "../src/View/AbstractDirectoryView.vala"
	(_tmp3_ == NULL) ? NULL : (_tmp3_ = (_g_list_free__g_object_unref0_ (_tmp3_), NULL));
#line 6809 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_selection_action_open_with_other_app (FilesAbstractDirectoryView* self)
{
	GList* selection = NULL;
	GList* _tmp0_;
	FilesFile* file = NULL;
	gconstpointer _tmp1_;
	FilesFile* _tmp2_;
	FilesFile* _tmp3_;
#line 1177 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1178 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_files_for_action (self);
#line 1178 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp0_;
#line 1179 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = selection->data;
#line 1179 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = (FilesFile*) _tmp1_;
#line 1179 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, FILES_TYPE_FILE) ? ((FilesFile*) _tmp2_) : NULL);
#line 1179 "../src/View/AbstractDirectoryView.vala"
	file = _tmp3_;
#line 1180 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_open_file (self, file, NULL, NULL);
#line 1177 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 1177 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 6841 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_common_action_bookmark (FilesAbstractDirectoryView* self,
                                                         GSimpleAction* action,
                                                         GVariant* param)
{
	GFile* location = NULL;
	GList* _tmp0_;
	FilesViewWindow* _tmp12_;
	GFile* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
#line 1183 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1183 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1185 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 1185 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ != NULL) {
#line 6863 "AbstractDirectoryView.c"
		GList* _tmp1_;
		gconstpointer _tmp2_;
		GFile* _tmp3_;
		GFile* _tmp4_;
#line 1186 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->selected_files;
#line 1186 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_->data;
#line 1186 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_file_get_target_location ((FilesFile*) _tmp2_);
#line 1186 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 1186 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (location);
#line 1186 "../src/View/AbstractDirectoryView.vala"
		location = _tmp4_;
#line 6880 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp5_;
		FilesDirectory* _tmp6_;
		FilesDirectory* _tmp7_;
		FilesFile* _tmp8_;
		FilesFile* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
#line 1188 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->slot;
#line 1188 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp5_);
#line 1188 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp6_;
#line 1188 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = files_directory_get_file (_tmp7_);
#line 1188 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = _tmp8_;
#line 1188 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = files_file_get_target_location (_tmp9_);
#line 1188 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 1188 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (location);
#line 1188 "../src/View/AbstractDirectoryView.vala"
		location = _tmp11_;
#line 6907 "AbstractDirectoryView.c"
	}
#line 1191 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = self->window;
#line 1191 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = location;
#line 1191 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = g_file_get_uri (_tmp13_);
#line 1191 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = _tmp14_;
#line 1191 "../src/View/AbstractDirectoryView.vala"
	files_view_window_bookmark_uri (_tmp12_, _tmp15_, "");
#line 1191 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp15_);
#line 1183 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (location);
#line 6923 "AbstractDirectoryView.c"
}

/** Background actions */
static void
files_abstract_directory_view_change_state_show_hidden (FilesAbstractDirectoryView* self,
                                                        GSimpleAction* action)
{
	FilesViewWindow* _tmp0_;
#line 1196 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1196 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1197 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->window;
#line 1197 "../src/View/AbstractDirectoryView.vala"
	files_view_window_change_state_show_hidden (_tmp0_, action);
#line 6940 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_change_state_show_remote_thumbnails (FilesAbstractDirectoryView* self,
                                                                   GSimpleAction* action)
{
	FilesViewWindow* _tmp0_;
#line 1200 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1200 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1201 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->window;
#line 1201 "../src/View/AbstractDirectoryView.vala"
	files_view_window_change_state_show_remote_thumbnails (_tmp0_, action);
#line 6956 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_change_state_show_local_thumbnails (FilesAbstractDirectoryView* self,
                                                                  GSimpleAction* action)
{
	FilesViewWindow* _tmp0_;
#line 1204 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1204 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1205 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->window;
#line 1205 "../src/View/AbstractDirectoryView.vala"
	files_view_window_change_state_show_local_thumbnails (_tmp0_, action);
#line 6972 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_background_action_new (FilesAbstractDirectoryView* self,
                                                        GSimpleAction* action,
                                                        GVariant* param)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 1209 "../src/View/AbstractDirectoryView.vala"
	static GQuark _tmp2_label0 = 0;
#line 1209 "../src/View/AbstractDirectoryView.vala"
	static GQuark _tmp2_label1 = 0;
#line 1208 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1208 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1209 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 1209 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1209 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 1209 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("FOLDER")))) {
#line 1209 "../src/View/AbstractDirectoryView.vala"
		switch (0) {
#line 7001 "AbstractDirectoryView.c"
			default:
			{
#line 1211 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_new_empty_folder (self);
#line 1212 "../src/View/AbstractDirectoryView.vala"
				break;
#line 7008 "AbstractDirectoryView.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("FILE")))) {
#line 1209 "../src/View/AbstractDirectoryView.vala"
		switch (0) {
#line 7014 "AbstractDirectoryView.c"
			default:
			{
#line 1215 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_new_empty_file (self, NULL);
#line 1216 "../src/View/AbstractDirectoryView.vala"
				break;
#line 7021 "AbstractDirectoryView.c"
			}
		}
	} else {
#line 1209 "../src/View/AbstractDirectoryView.vala"
		switch (0) {
#line 7027 "AbstractDirectoryView.c"
			default:
			{
#line 1219 "../src/View/AbstractDirectoryView.vala"
				break;
#line 7032 "AbstractDirectoryView.c"
			}
		}
	}
}

static void
files_abstract_directory_view_on_background_action_create_from (FilesAbstractDirectoryView* self,
                                                                GSimpleAction* action,
                                                                GVariant* param)
{
	gint index = 0;
	const gchar* _tmp0_;
	GList* _tmp1_;
	gconstpointer _tmp2_;
#line 1223 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1223 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1224 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 1224 "../src/View/AbstractDirectoryView.vala"
	index = atoi (_tmp0_);
#line 1225 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_templates;
#line 1225 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_list_nth_data (_tmp1_, (guint) index);
#line 1225 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_create_from_template (self, (GFile*) _tmp2_);
#line 7061 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_background_action_sort_by_changed (FilesAbstractDirectoryView* self,
                                                                    GSimpleAction* action,
                                                                    GVariant* val)
{
	const gchar* _tmp0_ = NULL;
#line 1228 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1228 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1229 "../src/View/AbstractDirectoryView.vala"
	if (val != NULL) {
#line 7076 "AbstractDirectoryView.c"
		const gchar* _tmp1_;
#line 1229 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = g_variant_get_string (val, NULL);
#line 1229 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp1_;
#line 7082 "AbstractDirectoryView.c"
	} else {
#line 1229 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = NULL;
#line 7086 "AbstractDirectoryView.c"
	}
#line 1229 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_sort (self, _tmp0_, FALSE);
#line 7090 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_background_action_reverse_changed (FilesAbstractDirectoryView* self,
                                                                    GSimpleAction* action,
                                                                    GVariant* val)
{
#line 1232 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1232 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1233 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_sort (self, NULL, TRUE);
#line 7104 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_background_action_folders_first_changed (FilesAbstractDirectoryView* self,
                                                                          GSimpleAction* action,
                                                                          GVariant* val)
{
	FilesPreferences* prefs = NULL;
	FilesPreferences* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1236 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1236 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1237 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_preferences_get_default ();
#line 1237 "../src/View/AbstractDirectoryView.vala"
	prefs = _tmp0_;
#line 1238 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_preferences_get_sort_directories_first (prefs);
#line 1238 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1238 "../src/View/AbstractDirectoryView.vala"
	files_preferences_set_sort_directories_first (prefs, !_tmp2_);
#line 1236 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (prefs);
#line 7132 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_sort (FilesAbstractDirectoryView* self,
                                        const gchar* col_name,
                                        gboolean reverse)
{
	gint sort_column_id = 0;
	GtkSortType sort_order = 0;
	FilesListModel* _tmp0_;
	gint _tmp1_ = 0;
	GtkSortType _tmp2_ = 0;
	gboolean _tmp3_;
#line 1241 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1245 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 1245 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) _tmp0_, &_tmp1_, &_tmp2_);
#line 1245 "../src/View/AbstractDirectoryView.vala"
	sort_column_id = _tmp1_;
#line 1245 "../src/View/AbstractDirectoryView.vala"
	sort_order = _tmp2_;
#line 1245 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 7158 "AbstractDirectoryView.c"
		FilesListModel* _tmp4_;
#line 1246 "../src/View/AbstractDirectoryView.vala"
		if (col_name != NULL) {
#line 1247 "../src/View/AbstractDirectoryView.vala"
			sort_column_id = (gint) files_list_model_column_id_from_string (col_name);
#line 7164 "AbstractDirectoryView.c"
		}
#line 1250 "../src/View/AbstractDirectoryView.vala"
		if (reverse) {
#line 1251 "../src/View/AbstractDirectoryView.vala"
			if (sort_order == GTK_SORT_ASCENDING) {
#line 1252 "../src/View/AbstractDirectoryView.vala"
				sort_order = GTK_SORT_DESCENDING;
#line 7172 "AbstractDirectoryView.c"
			} else {
#line 1254 "../src/View/AbstractDirectoryView.vala"
				sort_order = GTK_SORT_ASCENDING;
#line 7176 "AbstractDirectoryView.c"
			}
		}
#line 1258 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = self->model;
#line 1258 "../src/View/AbstractDirectoryView.vala"
		gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp4_, sort_column_id, sort_order);
#line 7183 "AbstractDirectoryView.c"
	} else {
#line 1260 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:1260: Set Sort: The model is unsorted - thi" \
"s should not happen");
#line 7187 "AbstractDirectoryView.c"
	}
}

/** Common actions */
static void
files_abstract_directory_view_on_common_action_open_in (FilesAbstractDirectoryView* self,
                                                        GSimpleAction* action,
                                                        GVariant* param)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 1269 "../src/View/AbstractDirectoryView.vala"
	static GQuark _tmp2_label0 = 0;
#line 1269 "../src/View/AbstractDirectoryView.vala"
	static GQuark _tmp2_label1 = 0;
#line 1266 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1266 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1267 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->default_app);
#line 1267 "../src/View/AbstractDirectoryView.vala"
	self->priv->default_app = NULL;
#line 1269 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_variant_get_string (param, NULL);
#line 1269 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1269 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 1269 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("TAB")))) {
#line 1269 "../src/View/AbstractDirectoryView.vala"
		switch (0) {
#line 7222 "AbstractDirectoryView.c"
			default:
			{
				GList* _tmp4_;
				GList* _tmp5_;
#line 1271 "../src/View/AbstractDirectoryView.vala"
				_tmp4_ = files_abstract_directory_view_get_files_for_action (self);
#line 1271 "../src/View/AbstractDirectoryView.vala"
				_tmp5_ = _tmp4_;
#line 1271 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_NEW_TAB, _tmp5_);
#line 1271 "../src/View/AbstractDirectoryView.vala"
				(_tmp5_ == NULL) ? NULL : (_tmp5_ = (_g_list_free__g_object_unref0_ (_tmp5_), NULL));
#line 1272 "../src/View/AbstractDirectoryView.vala"
				break;
#line 7237 "AbstractDirectoryView.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("WINDOW")))) {
#line 1269 "../src/View/AbstractDirectoryView.vala"
		switch (0) {
#line 7243 "AbstractDirectoryView.c"
			default:
			{
				GList* _tmp6_;
				GList* _tmp7_;
#line 1275 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = files_abstract_directory_view_get_files_for_action (self);
#line 1275 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = _tmp6_;
#line 1275 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_NEW_WINDOW, _tmp7_);
#line 1275 "../src/View/AbstractDirectoryView.vala"
				(_tmp7_ == NULL) ? NULL : (_tmp7_ = (_g_list_free__g_object_unref0_ (_tmp7_), NULL));
#line 1276 "../src/View/AbstractDirectoryView.vala"
				break;
#line 7258 "AbstractDirectoryView.c"
			}
		}
	} else {
#line 1269 "../src/View/AbstractDirectoryView.vala"
		switch (0) {
#line 7264 "AbstractDirectoryView.c"
			default:
			{
#line 1279 "../src/View/AbstractDirectoryView.vala"
				break;
#line 7269 "AbstractDirectoryView.c"
			}
		}
	}
}

static void
files_abstract_directory_view_on_common_action_properties (FilesAbstractDirectoryView* self,
                                                           GSimpleAction* action,
                                                           GVariant* param)
{
	GList* _tmp0_;
	GList* _tmp1_;
	FilesViewWindow* _tmp2_;
	FilesViewPropertiesWindow* _tmp3_;
	FilesViewPropertiesWindow* _tmp4_;
#line 1283 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1283 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1284 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_files_for_action (self);
#line 1284 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1284 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->window;
#line 1284 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_view_properties_window_new (_tmp1_, self, (GtkWindow*) _tmp2_);
#line 1284 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp3_);
#line 1284 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 1284 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp4_);
#line 1284 "../src/View/AbstractDirectoryView.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
#line 7305 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_common_action_copy_link (FilesAbstractDirectoryView* self,
                                                          GSimpleAction* action,
                                                          GVariant* param)
{
	FilesClipboardManager* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
#line 1287 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1287 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1288 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->clipboard;
#line 1288 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_files_for_action (self);
#line 1288 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1288 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_abstract_directory_view_get_selected_files_for_transfer (self, _tmp2_);
#line 1288 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 1288 "../src/View/AbstractDirectoryView.vala"
	files_clipboard_manager_copy_link_files (_tmp0_, _tmp4_);
#line 1288 "../src/View/AbstractDirectoryView.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (_g_list_free__g_object_unref0_ (_tmp4_), NULL));
#line 1288 "../src/View/AbstractDirectoryView.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 7338 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_common_action_copy (FilesAbstractDirectoryView* self,
                                                     GSimpleAction* action,
                                                     GVariant* param)
{
	FilesClipboardManager* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
#line 1291 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1291 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1292 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->clipboard;
#line 1292 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_files_for_action (self);
#line 1292 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1292 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_abstract_directory_view_get_selected_files_for_transfer (self, _tmp2_);
#line 1292 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 1292 "../src/View/AbstractDirectoryView.vala"
	files_clipboard_manager_copy_files (_tmp0_, _tmp4_);
#line 1292 "../src/View/AbstractDirectoryView.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (_g_list_free__g_object_unref0_ (_tmp4_), NULL));
#line 1292 "../src/View/AbstractDirectoryView.vala"
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (_g_list_free__g_object_unref0_ (_tmp2_), NULL));
#line 7371 "AbstractDirectoryView.c"
}

static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 1296 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 1296 "../src/View/AbstractDirectoryView.vala"
	return _data25_;
#line 7381 "AbstractDirectoryView.c"
}

static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 1296 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 7391 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 1296 "../src/View/AbstractDirectoryView.vala"
		self = _data25_->self;
#line 1296 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data25_->target);
#line 1296 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 1296 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block25Data, _data25_);
#line 7401 "AbstractDirectoryView.c"
	}
}

static void
___lambda118_ (Block25Data* _data25_,
               GObject* obj,
               GAsyncResult* res)
{
	FilesAbstractDirectoryView* self;
	FilesClipboardManager* _tmp0_;
	GFile* _tmp1_;
#line 1298 "../src/View/AbstractDirectoryView.vala"
	self = _data25_->self;
#line 1298 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 1299 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->clipboard;
#line 1299 "../src/View/AbstractDirectoryView.vala"
	files_clipboard_manager_paste_files_finish (_tmp0_, res);
#line 1300 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _data25_->target;
#line 1300 "../src/View/AbstractDirectoryView.vala"
	if (g_file_has_uri_scheme (_tmp1_, "trash")) {
#line 1302 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_after_trash_or_delete (self);
#line 7427 "AbstractDirectoryView.c"
	}
}

static void
____lambda118__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 1298 "../src/View/AbstractDirectoryView.vala"
	___lambda118_ (self, source_object, res);
#line 1298 "../src/View/AbstractDirectoryView.vala"
	block25_data_unref (self);
#line 7440 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_common_action_paste (FilesAbstractDirectoryView* self,
                                                      GSimpleAction* action,
                                                      GVariant* param)
{
	gboolean _tmp0_ = FALSE;
	FilesClipboardManager* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 1295 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1295 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1296 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->clipboard;
#line 1296 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_clipboard_manager_get_can_paste (_tmp1_);
#line 1296 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 1296 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 7464 "AbstractDirectoryView.c"
		gboolean _tmp4_ = FALSE;
		FilesClipboardManager* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 1296 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->priv->clipboard;
#line 1296 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = files_clipboard_manager_get_files_linked (_tmp5_);
#line 1296 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp6_;
#line 1296 "../src/View/AbstractDirectoryView.vala"
		if (_tmp7_) {
#line 1296 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = self->priv->in_trash;
#line 7479 "AbstractDirectoryView.c"
		} else {
#line 1296 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = FALSE;
#line 7483 "AbstractDirectoryView.c"
		}
#line 1296 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = !_tmp4_;
#line 7487 "AbstractDirectoryView.c"
	} else {
#line 1296 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FALSE;
#line 7491 "AbstractDirectoryView.c"
	}
#line 1296 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 7495 "AbstractDirectoryView.c"
		Block25Data* _data25_;
		FilesViewSlot* _tmp8_;
		GFile* _tmp9_;
		GFile* _tmp10_;
		GFile* _tmp11_;
		FilesClipboardManager* _tmp12_;
		GFile* _tmp13_;
#line 1296 "../src/View/AbstractDirectoryView.vala"
		_data25_ = g_slice_new0 (Block25Data);
#line 1296 "../src/View/AbstractDirectoryView.vala"
		_data25_->_ref_count_ = 1;
#line 1296 "../src/View/AbstractDirectoryView.vala"
		_data25_->self = g_object_ref (self);
#line 1297 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = self->slot;
#line 1297 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = files_abstract_slot_get_location ((FilesAbstractSlot*) _tmp8_);
#line 1297 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = _tmp9_;
#line 1297 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _g_object_ref0 (_tmp10_);
#line 1297 "../src/View/AbstractDirectoryView.vala"
		_data25_->target = _tmp11_;
#line 1298 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = self->priv->clipboard;
#line 1298 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = _data25_->target;
#line 1298 "../src/View/AbstractDirectoryView.vala"
		files_clipboard_manager_paste_files (_tmp12_, _tmp13_, G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL, ____lambda118__gasync_ready_callback, block25_data_ref (_data25_));
#line 1296 "../src/View/AbstractDirectoryView.vala"
		block25_data_unref (_data25_);
#line 1296 "../src/View/AbstractDirectoryView.vala"
		_data25_ = NULL;
#line 7529 "AbstractDirectoryView.c"
	}
}

static Block26Data*
block26_data_ref (Block26Data* _data26_)
{
#line 1311 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data26_->_ref_count_);
#line 1311 "../src/View/AbstractDirectoryView.vala"
	return _data26_;
#line 7540 "AbstractDirectoryView.c"
}

static void
block26_data_unref (void * _userdata_)
{
	Block26Data* _data26_;
	_data26_ = (Block26Data*) _userdata_;
#line 1311 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data26_->_ref_count_)) {
#line 7550 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 1311 "../src/View/AbstractDirectoryView.vala"
		self = _data26_->self;
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data26_->target);
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 1311 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block26Data, _data26_);
#line 7560 "AbstractDirectoryView.c"
	}
}

static void
___lambda117_ (Block26Data* _data26_,
               GObject* obj,
               GAsyncResult* res)
{
	FilesAbstractDirectoryView* self;
	FilesClipboardManager* _tmp0_;
	GFile* _tmp1_;
#line 1320 "../src/View/AbstractDirectoryView.vala"
	self = _data26_->self;
#line 1320 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 1321 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->clipboard;
#line 1321 "../src/View/AbstractDirectoryView.vala"
	files_clipboard_manager_paste_files_finish (_tmp0_, res);
#line 1322 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _data26_->target;
#line 1322 "../src/View/AbstractDirectoryView.vala"
	if (g_file_has_uri_scheme (_tmp1_, "trash")) {
#line 1324 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_after_trash_or_delete (self);
#line 7586 "AbstractDirectoryView.c"
	}
}

static void
____lambda117__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 1320 "../src/View/AbstractDirectoryView.vala"
	___lambda117_ (self, source_object, res);
#line 1320 "../src/View/AbstractDirectoryView.vala"
	block26_data_unref (self);
#line 7599 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_common_action_paste_into (FilesAbstractDirectoryView* self,
                                                           GSimpleAction* action,
                                                           GVariant* param)
{
	FilesFile* file = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	gconstpointer _tmp2_;
	FilesFile* _tmp3_;
	FilesFile* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	FilesFile* _tmp7_;
#line 1308 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1308 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (action != NULL);
#line 1309 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_files_for_action (self);
#line 1309 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1309 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_list_nth_data (_tmp1_, (guint) 0);
#line 1309 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _g_object_ref0 ((FilesFile*) _tmp2_);
#line 1309 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 1309 "../src/View/AbstractDirectoryView.vala"
	(_tmp1_ == NULL) ? NULL : (_tmp1_ = (_g_list_free__g_object_unref0_ (_tmp1_), NULL));
#line 1309 "../src/View/AbstractDirectoryView.vala"
	file = _tmp4_;
#line 1311 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = file;
#line 1311 "../src/View/AbstractDirectoryView.vala"
	if (_tmp7_ != NULL) {
#line 7638 "AbstractDirectoryView.c"
		FilesClipboardManager* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = self->priv->clipboard;
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = files_clipboard_manager_get_can_paste (_tmp8_);
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = _tmp9_;
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp10_;
#line 7650 "AbstractDirectoryView.c"
	} else {
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = FALSE;
#line 7654 "AbstractDirectoryView.c"
	}
#line 1311 "../src/View/AbstractDirectoryView.vala"
	if (_tmp6_) {
#line 7658 "AbstractDirectoryView.c"
		gboolean _tmp11_ = FALSE;
		FilesClipboardManager* _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = self->priv->clipboard;
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = files_clipboard_manager_get_files_linked (_tmp12_);
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = _tmp13_;
#line 1311 "../src/View/AbstractDirectoryView.vala"
		if (_tmp14_) {
#line 1311 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = self->priv->in_trash;
#line 7673 "AbstractDirectoryView.c"
		} else {
#line 1311 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = FALSE;
#line 7677 "AbstractDirectoryView.c"
		}
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = !_tmp11_;
#line 7681 "AbstractDirectoryView.c"
	} else {
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = FALSE;
#line 7685 "AbstractDirectoryView.c"
	}
#line 1311 "../src/View/AbstractDirectoryView.vala"
	if (_tmp5_) {
#line 7689 "AbstractDirectoryView.c"
		Block26Data* _data26_;
		gboolean _tmp15_ = FALSE;
		FilesFile* _tmp16_;
		FilesClipboardManager* _tmp26_;
		GFile* _tmp27_;
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_data26_ = g_slice_new0 (Block26Data);
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_data26_->_ref_count_ = 1;
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_data26_->self = g_object_ref (self);
#line 1314 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = file;
#line 1314 "../src/View/AbstractDirectoryView.vala"
		if (files_file_is_folder (_tmp16_)) {
#line 7705 "AbstractDirectoryView.c"
			FilesClipboardManager* _tmp17_;
			FilesFile* _tmp18_;
#line 1314 "../src/View/AbstractDirectoryView.vala"
			_tmp17_ = self->priv->clipboard;
#line 1314 "../src/View/AbstractDirectoryView.vala"
			_tmp18_ = file;
#line 1314 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = !files_clipboard_manager_has_file (_tmp17_, _tmp18_);
#line 7714 "AbstractDirectoryView.c"
		} else {
#line 1314 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = FALSE;
#line 7718 "AbstractDirectoryView.c"
		}
#line 1314 "../src/View/AbstractDirectoryView.vala"
		if (_tmp15_) {
#line 7722 "AbstractDirectoryView.c"
			FilesFile* _tmp19_;
			GFile* _tmp20_;
			GFile* _tmp21_;
#line 1315 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = file;
#line 1315 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = files_file_get_target_location (_tmp19_);
#line 1315 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1315 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_data26_->target);
#line 1315 "../src/View/AbstractDirectoryView.vala"
			_data26_->target = _tmp21_;
#line 7736 "AbstractDirectoryView.c"
		} else {
			FilesViewSlot* _tmp22_;
			GFile* _tmp23_;
			GFile* _tmp24_;
			GFile* _tmp25_;
#line 1317 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = self->slot;
#line 1317 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = files_abstract_slot_get_location ((FilesAbstractSlot*) _tmp22_);
#line 1317 "../src/View/AbstractDirectoryView.vala"
			_tmp24_ = _tmp23_;
#line 1317 "../src/View/AbstractDirectoryView.vala"
			_tmp25_ = _g_object_ref0 (_tmp24_);
#line 1317 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_data26_->target);
#line 1317 "../src/View/AbstractDirectoryView.vala"
			_data26_->target = _tmp25_;
#line 7754 "AbstractDirectoryView.c"
		}
#line 1320 "../src/View/AbstractDirectoryView.vala"
		_tmp26_ = self->priv->clipboard;
#line 1320 "../src/View/AbstractDirectoryView.vala"
		_tmp27_ = _data26_->target;
#line 1320 "../src/View/AbstractDirectoryView.vala"
		files_clipboard_manager_paste_files (_tmp26_, _tmp27_, G_TYPE_CHECK_INSTANCE_TYPE (self, gtk_widget_get_type ()) ? ((GtkWidget*) self) : NULL, ____lambda117__gasync_ready_callback, block26_data_ref (_data26_));
#line 1311 "../src/View/AbstractDirectoryView.vala"
		block26_data_unref (_data26_);
#line 1311 "../src/View/AbstractDirectoryView.vala"
		_data26_ = NULL;
#line 7766 "AbstractDirectoryView.c"
	}
#line 1308 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 7770 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_toggle_select_all (FilesAbstractDirectoryView* self)
{
#line 1330 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1331 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 1332 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->all_selected) {
#line 1333 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_unselect_all (self);
#line 7784 "AbstractDirectoryView.c"
	} else {
#line 1335 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_select_all (self);
#line 7788 "AbstractDirectoryView.c"
	}
}

static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
#line 1339 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data27_->_ref_count_);
#line 1339 "../src/View/AbstractDirectoryView.vala"
	return _data27_;
#line 7799 "AbstractDirectoryView.c"
}

static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
#line 1339 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
#line 7809 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 1339 "../src/View/AbstractDirectoryView.vala"
		self = _data27_->self;
#line 1339 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data27_->file);
#line 1339 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 1339 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block27Data, _data27_);
#line 7819 "AbstractDirectoryView.c"
	}
}

static gboolean
___lambda81_ (Block27Data* _data27_)
{
	FilesAbstractDirectoryView* self;
	gboolean result;
#line 1343 "../src/View/AbstractDirectoryView.vala"
	self = _data27_->self;
#line 1344 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_thumbnail_info_and_plugins (self, _data27_->file);
#line 1345 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1345 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 7836 "AbstractDirectoryView.c"
}

static gboolean
____lambda81__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda81_ (self);
#line 1343 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 7846 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_directory_file_added (FilesAbstractDirectoryView* self,
                                                       FilesDirectory* dir,
                                                       FilesFile* file,
                                                       gboolean is_internal)
{
	Block27Data* _data27_;
	FilesFile* _tmp0_;
#line 1339 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1339 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1339 "../src/View/AbstractDirectoryView.vala"
	_data27_ = g_slice_new0 (Block27Data);
#line 1339 "../src/View/AbstractDirectoryView.vala"
	_data27_->_ref_count_ = 1;
#line 1339 "../src/View/AbstractDirectoryView.vala"
	_data27_->self = g_object_ref (self);
#line 1339 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 1339 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data27_->file);
#line 1339 "../src/View/AbstractDirectoryView.vala"
	_data27_->file = _tmp0_;
#line 1340 "../src/View/AbstractDirectoryView.vala"
	if (_data27_->file != NULL) {
#line 1341 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_add_file (self, _data27_->file, dir, is_internal);
#line 1342 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_handle_free_space_change (self);
#line 1343 "../src/View/AbstractDirectoryView.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda81__gsource_func, block27_data_ref (_data27_), block27_data_unref);
#line 7881 "AbstractDirectoryView.c"
	} else {
#line 1348 "../src/View/AbstractDirectoryView.vala"
		g_critical ("AbstractDirectoryView.vala:1348: Null file added");
#line 7885 "AbstractDirectoryView.c"
	}
#line 1339 "../src/View/AbstractDirectoryView.vala"
	block27_data_unref (_data27_);
#line 1339 "../src/View/AbstractDirectoryView.vala"
	_data27_ = NULL;
#line 7891 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_directory_file_loaded (FilesAbstractDirectoryView* self,
                                                        FilesDirectory* dir,
                                                        FilesFile* file)
{
	FilesListModel* _tmp0_;
#line 1352 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1352 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1352 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 1354 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 1354 "../src/View/AbstractDirectoryView.vala"
	files_list_model_add_file (_tmp0_, file, dir);
#line 7910 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_directory_file_changed (FilesAbstractDirectoryView* self,
                                                         FilesDirectory* dir,
                                                         FilesFile* file)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	FilesFile* _tmp2_;
	FilesFile* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
#line 1357 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1357 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1357 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 1358 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_file_get_location (file);
#line 1358 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1358 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_directory_get_file (dir);
#line 1358 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 1358 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = files_file_get_location (_tmp3_);
#line 1358 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _tmp4_;
#line 1358 "../src/View/AbstractDirectoryView.vala"
	if (g_file_equal (_tmp1_, _tmp5_)) {
#line 7944 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp6_;
		FilesDirectory* _tmp7_;
		FilesDirectory* _tmp8_;
		FilesFile* _tmp9_;
		FilesFile* _tmp10_;
#line 1360 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = self->slot;
#line 1360 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp6_);
#line 1360 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = _tmp7_;
#line 1360 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = files_directory_get_file (_tmp8_);
#line 1360 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = _tmp9_;
#line 1360 "../src/View/AbstractDirectoryView.vala"
		self->is_writable = files_file_is_writable (_tmp10_);
#line 7962 "AbstractDirectoryView.c"
	} else {
#line 1362 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_on_directory_file_icon_changed (self, dir, file);
#line 7966 "AbstractDirectoryView.c"
	}
}

static Block28Data*
block28_data_ref (Block28Data* _data28_)
{
#line 1366 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data28_->_ref_count_);
#line 1366 "../src/View/AbstractDirectoryView.vala"
	return _data28_;
#line 7977 "AbstractDirectoryView.c"
}

static void
block28_data_unref (void * _userdata_)
{
	Block28Data* _data28_;
	_data28_ = (Block28Data*) _userdata_;
#line 1366 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data28_->_ref_count_)) {
#line 7987 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 1366 "../src/View/AbstractDirectoryView.vala"
		self = _data28_->self;
#line 1366 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data28_->file);
#line 1366 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 1366 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block28Data, _data28_);
#line 7997 "AbstractDirectoryView.c"
	}
}

static gboolean
__lambda82_ (Block28Data* _data28_)
{
	FilesAbstractDirectoryView* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	FilesViewSlot* _tmp2_;
	FilesDirectory* _tmp3_;
	FilesDirectory* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	gboolean result;
#line 1373 "../src/View/AbstractDirectoryView.vala"
	self = _data28_->self;
#line 1374 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_thumbnail_info_and_plugins (self, _data28_->file);
#line 1375 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->slot;
#line 1375 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp2_);
#line 1375 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 1375 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = files_directory_get_is_network (_tmp4_);
#line 1375 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_;
#line 1375 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp6_) {
#line 8029 "AbstractDirectoryView.c"
		gboolean _tmp7_;
#line 1375 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = self->priv->_show_local_thumbnails;
#line 1375 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp7_;
#line 8035 "AbstractDirectoryView.c"
	} else {
#line 1375 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = FALSE;
#line 8039 "AbstractDirectoryView.c"
	}
#line 1375 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 1375 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 8045 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_;
#line 1376 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = self->priv->_show_remote_thumbnails;
#line 1376 "../src/View/AbstractDirectoryView.vala"
		if (_tmp9_) {
#line 8053 "AbstractDirectoryView.c"
			FilesViewSlot* _tmp10_;
			FilesDirectory* _tmp11_;
			FilesDirectory* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 1376 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = self->slot;
#line 1376 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp10_);
#line 1376 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = _tmp11_;
#line 1376 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = files_directory_get_can_open_files (_tmp12_);
#line 1376 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = _tmp13_;
#line 1376 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = _tmp14_;
#line 8071 "AbstractDirectoryView.c"
		} else {
#line 1376 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = FALSE;
#line 8075 "AbstractDirectoryView.c"
		}
#line 1376 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp8_;
#line 8079 "AbstractDirectoryView.c"
	}
#line 1375 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 8083 "AbstractDirectoryView.c"
		FilesThumbnailer* _tmp15_;
#line 1378 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = self->priv->thumbnailer;
#line 1378 "../src/View/AbstractDirectoryView.vala"
		files_thumbnailer_queue_file (_tmp15_, _data28_->file, NULL, self->large_thumbnails);
#line 8089 "AbstractDirectoryView.c"
	}
#line 1381 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1381 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 8095 "AbstractDirectoryView.c"
}

static gboolean
___lambda82__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda82_ (self);
#line 1373 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 8105 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_directory_file_icon_changed (FilesAbstractDirectoryView* self,
                                                              FilesDirectory* dir,
                                                              FilesFile* file)
{
	Block28Data* _data28_;
	FilesFile* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	FilesListModel* _tmp3_;
#line 1366 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1366 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1366 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 1366 "../src/View/AbstractDirectoryView.vala"
	_data28_ = g_slice_new0 (Block28Data);
#line 1366 "../src/View/AbstractDirectoryView.vala"
	_data28_->_ref_count_ = 1;
#line 1366 "../src/View/AbstractDirectoryView.vala"
	_data28_->self = g_object_ref (self);
#line 1366 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (file);
#line 1366 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data28_->file);
#line 1366 "../src/View/AbstractDirectoryView.vala"
	_data28_->file = _tmp0_;
#line 1367 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_is_frozen (self);
#line 1367 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1367 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 1368 "../src/View/AbstractDirectoryView.vala"
		block28_data_unref (_data28_);
#line 1368 "../src/View/AbstractDirectoryView.vala"
		_data28_ = NULL;
#line 1368 "../src/View/AbstractDirectoryView.vala"
		return;
#line 8148 "AbstractDirectoryView.c"
	}
#line 1371 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_remove_marlin_icon_info_cache (self, _data28_->file);
#line 1372 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->model;
#line 1372 "../src/View/AbstractDirectoryView.vala"
	files_list_model_file_changed (_tmp3_, _data28_->file, dir);
#line 1373 "../src/View/AbstractDirectoryView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda82__gsource_func, block28_data_ref (_data28_), block28_data_unref);
#line 1384 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_draw_when_idle (self);
#line 1366 "../src/View/AbstractDirectoryView.vala"
	block28_data_unref (_data28_);
#line 1366 "../src/View/AbstractDirectoryView.vala"
	_data28_ = NULL;
#line 8164 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_directory_file_deleted (FilesAbstractDirectoryView* self,
                                                         FilesDirectory* dir,
                                                         FilesFile* file)
{
	FilesListModel* _tmp0_;
	const gchar* _tmp1_;
	FilesPluginManager* _tmp4_;
#line 1387 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1387 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1387 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 1390 "../src/View/AbstractDirectoryView.vala"
	file->exists = FALSE;
#line 1391 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 1391 "../src/View/AbstractDirectoryView.vala"
	files_list_model_remove_file (_tmp0_, file, dir);
#line 1393 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_remove_marlin_icon_info_cache (self, file);
#line 1395 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_file_get_thumbnail_path (file);
#line 1395 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ != NULL) {
#line 8193 "AbstractDirectoryView.c"
		const gchar* _tmp2_;
		const gchar* _tmp3_;
#line 1396 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_file_get_uri (file);
#line 1396 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 1396 "../src/View/AbstractDirectoryView.vala"
		files_file_utils_remove_thumbnail_paths_for_uri (_tmp3_);
#line 8202 "AbstractDirectoryView.c"
	}
#line 1399 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = plugins;
#line 1399 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_ != NULL) {
#line 8208 "AbstractDirectoryView.c"
		FilesPluginManager* _tmp5_;
#line 1400 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = plugins;
#line 1400 "../src/View/AbstractDirectoryView.vala"
		files_plugin_manager_update_file_info (_tmp5_, file);
#line 8214 "AbstractDirectoryView.c"
	}
#line 1403 "../src/View/AbstractDirectoryView.vala"
	if (files_file_is_folder (file)) {
#line 8218 "AbstractDirectoryView.c"
		FilesDirectory* file_dir = NULL;
		GFile* _tmp6_;
		GFile* _tmp7_;
		FilesDirectory* _tmp8_;
		FilesDirectory* _tmp9_;
#line 1405 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = files_file_get_location (file);
#line 1405 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp6_;
#line 1405 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = files_directory_cache_lookup (_tmp7_);
#line 1405 "../src/View/AbstractDirectoryView.vala"
		file_dir = _tmp8_;
#line 1406 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = file_dir;
#line 1406 "../src/View/AbstractDirectoryView.vala"
		if (_tmp9_ != NULL) {
#line 8236 "AbstractDirectoryView.c"
			FilesDirectory* _tmp10_;
			FilesViewSlot* _tmp11_;
			FilesDirectory* _tmp12_;
#line 1407 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = file_dir;
#line 1407 "../src/View/AbstractDirectoryView.vala"
			files_directory_purge_dir_from_cache (_tmp10_);
#line 1408 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = self->slot;
#line 1408 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = file_dir;
#line 1408 "../src/View/AbstractDirectoryView.vala"
			g_signal_emit_by_name (_tmp11_, "folder-deleted", file, _tmp12_);
#line 8250 "AbstractDirectoryView.c"
		}
#line 1403 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file_dir);
#line 8254 "AbstractDirectoryView.c"
	}
#line 1412 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_handle_free_space_change (self);
#line 8258 "AbstractDirectoryView.c"
}

static gboolean
__lambda76_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 1435 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_thaw_tree (self);
#line 1436 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_schedule_thumbnail_color_tag_timeout (self);
#line 1437 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1437 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 8273 "AbstractDirectoryView.c"
}

static gboolean
___lambda76__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda76_ ((FilesAbstractDirectoryView*) self);
#line 1434 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 8283 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_directory_done_loading (FilesAbstractDirectoryView* self,
                                                         FilesDirectory* dir)
{
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	FilesViewSlot* _tmp5_;
	FilesDirectory* _tmp6_;
	FilesDirectory* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	FilesViewSlot* _tmp10_;
	FilesDirectory* _tmp11_;
	FilesDirectory* _tmp12_;
	FilesFile* _tmp13_;
	FilesFile* _tmp14_;
	FilesViewSlot* _tmp15_;
	FilesDirectory* _tmp16_;
	FilesDirectory* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
#line 1415 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1415 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1417 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_disconnect_directory_loading_handlers (self, dir);
#line 1418 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 1418 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 1418 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1418 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_directory_get_is_trash (_tmp2_);
#line 1418 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 1418 "../src/View/AbstractDirectoryView.vala"
	self->priv->in_trash = _tmp4_;
#line 1419 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = self->slot;
#line 1419 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp5_);
#line 1419 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = _tmp6_;
#line 1419 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = files_directory_get_is_recent (_tmp7_);
#line 1419 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _tmp8_;
#line 1419 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_in_recent (self, _tmp9_);
#line 1420 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = self->slot;
#line 1420 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp10_);
#line 1420 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = _tmp11_;
#line 1420 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = files_directory_get_file (_tmp12_);
#line 1420 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = _tmp13_;
#line 1420 "../src/View/AbstractDirectoryView.vala"
	self->priv->in_network_root = files_file_is_root_network_folder (_tmp14_);
#line 1422 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = self->slot;
#line 1422 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp15_);
#line 1422 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = _tmp16_;
#line 1422 "../src/View/AbstractDirectoryView.vala"
	_tmp18_ = files_directory_get_can_load (_tmp17_);
#line 1422 "../src/View/AbstractDirectoryView.vala"
	_tmp19_ = _tmp18_;
#line 1422 "../src/View/AbstractDirectoryView.vala"
	if (_tmp19_) {
#line 8364 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp20_;
		FilesDirectory* _tmp21_;
		FilesDirectory* _tmp22_;
		FilesFile* _tmp23_;
		FilesFile* _tmp24_;
		gboolean _tmp25_;
#line 1423 "../src/View/AbstractDirectoryView.vala"
		_tmp20_ = self->slot;
#line 1423 "../src/View/AbstractDirectoryView.vala"
		_tmp21_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp20_);
#line 1423 "../src/View/AbstractDirectoryView.vala"
		_tmp22_ = _tmp21_;
#line 1423 "../src/View/AbstractDirectoryView.vala"
		_tmp23_ = files_directory_get_file (_tmp22_);
#line 1423 "../src/View/AbstractDirectoryView.vala"
		_tmp24_ = _tmp23_;
#line 1423 "../src/View/AbstractDirectoryView.vala"
		self->is_writable = files_file_is_writable (_tmp24_);
#line 1424 "../src/View/AbstractDirectoryView.vala"
		_tmp25_ = self->priv->_in_recent;
#line 1424 "../src/View/AbstractDirectoryView.vala"
		if (_tmp25_) {
#line 8387 "AbstractDirectoryView.c"
			FilesListModel* _tmp26_;
#line 1425 "../src/View/AbstractDirectoryView.vala"
			_tmp26_ = self->model;
#line 1425 "../src/View/AbstractDirectoryView.vala"
			gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp26_, (gint) FILES_LIST_MODEL_COLUMN_ID_MODIFIED, GTK_SORT_DESCENDING);
#line 8393 "AbstractDirectoryView.c"
		} else {
			FilesViewSlot* _tmp27_;
			FilesDirectory* _tmp28_;
			FilesDirectory* _tmp29_;
			FilesFile* _tmp30_;
			FilesFile* _tmp31_;
			GFileInfo* _tmp32_;
#line 1426 "../src/View/AbstractDirectoryView.vala"
			_tmp27_ = self->slot;
#line 1426 "../src/View/AbstractDirectoryView.vala"
			_tmp28_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp27_);
#line 1426 "../src/View/AbstractDirectoryView.vala"
			_tmp29_ = _tmp28_;
#line 1426 "../src/View/AbstractDirectoryView.vala"
			_tmp30_ = files_directory_get_file (_tmp29_);
#line 1426 "../src/View/AbstractDirectoryView.vala"
			_tmp31_ = _tmp30_;
#line 1426 "../src/View/AbstractDirectoryView.vala"
			_tmp32_ = _tmp31_->info;
#line 1426 "../src/View/AbstractDirectoryView.vala"
			if (_tmp32_ != NULL) {
#line 8415 "AbstractDirectoryView.c"
				FilesListModel* _tmp33_;
				FilesViewSlot* _tmp34_;
				FilesDirectory* _tmp35_;
				FilesDirectory* _tmp36_;
				FilesFile* _tmp37_;
				FilesFile* _tmp38_;
				FilesViewSlot* _tmp39_;
				FilesDirectory* _tmp40_;
				FilesDirectory* _tmp41_;
				FilesFile* _tmp42_;
				FilesFile* _tmp43_;
#line 1427 "../src/View/AbstractDirectoryView.vala"
				_tmp33_ = self->model;
#line 1427 "../src/View/AbstractDirectoryView.vala"
				_tmp34_ = self->slot;
#line 1427 "../src/View/AbstractDirectoryView.vala"
				_tmp35_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp34_);
#line 1427 "../src/View/AbstractDirectoryView.vala"
				_tmp36_ = _tmp35_;
#line 1427 "../src/View/AbstractDirectoryView.vala"
				_tmp37_ = files_directory_get_file (_tmp36_);
#line 1427 "../src/View/AbstractDirectoryView.vala"
				_tmp38_ = _tmp37_;
#line 1427 "../src/View/AbstractDirectoryView.vala"
				_tmp39_ = self->slot;
#line 1427 "../src/View/AbstractDirectoryView.vala"
				_tmp40_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp39_);
#line 1427 "../src/View/AbstractDirectoryView.vala"
				_tmp41_ = _tmp40_;
#line 1427 "../src/View/AbstractDirectoryView.vala"
				_tmp42_ = files_directory_get_file (_tmp41_);
#line 1427 "../src/View/AbstractDirectoryView.vala"
				_tmp43_ = _tmp42_;
#line 1427 "../src/View/AbstractDirectoryView.vala"
				gtk_tree_sortable_set_sort_column_id ((GtkTreeSortable*) _tmp33_, _tmp38_->sort_column_id, _tmp43_->sort_order);
#line 8451 "AbstractDirectoryView.c"
			}
		}
	} else {
#line 1430 "../src/View/AbstractDirectoryView.vala"
		self->is_writable = FALSE;
#line 8457 "AbstractDirectoryView.c"
	}
#line 1434 "../src/View/AbstractDirectoryView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda76__gsource_func, g_object_ref (self), g_object_unref);
#line 8461 "AbstractDirectoryView.c"
}

/** Handle zoom level change */
static void
files_abstract_directory_view_on_zoom_level_changed (FilesAbstractDirectoryView* self,
                                                     FilesZoomLevel zoom)
{
	gint size = 0;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	FilesListModel* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
#line 1442 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1443 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_icon_size (self);
#line 1443 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1443 "../src/View/AbstractDirectoryView.vala"
	size = _tmp1_ * gtk_widget_get_scale_factor ((GtkWidget*) self);
#line 1445 "../src/View/AbstractDirectoryView.vala"
	if (!self->large_thumbnails) {
#line 1445 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = size > 128;
#line 8489 "AbstractDirectoryView.c"
	} else {
#line 1445 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = FALSE;
#line 8493 "AbstractDirectoryView.c"
	}
#line 1445 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 1445 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = TRUE;
#line 8499 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 1445 "../src/View/AbstractDirectoryView.vala"
		if (self->large_thumbnails) {
#line 1445 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = size <= 128;
#line 8506 "AbstractDirectoryView.c"
		} else {
#line 1445 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = FALSE;
#line 8510 "AbstractDirectoryView.c"
		}
#line 1445 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp4_;
#line 8514 "AbstractDirectoryView.c"
	}
#line 1445 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 8518 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp5_;
#line 1446 "../src/View/AbstractDirectoryView.vala"
		self->large_thumbnails = size > 128;
#line 1447 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->slot;
#line 1447 "../src/View/AbstractDirectoryView.vala"
		files_view_slot_refresh_files (_tmp5_);
#line 1448 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_schedule_thumbnail_color_tag_timeout (self);
#line 8528 "AbstractDirectoryView.c"
	}
#line 1451 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = self->model;
#line 1451 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = files_abstract_directory_view_get_icon_size (self);
#line 1451 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = _tmp7_;
#line 1451 "../src/View/AbstractDirectoryView.vala"
	files_list_model_set_icon_size (_tmp6_, _tmp8_);
#line 1452 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_change_zoom_level (self);
#line 8540 "AbstractDirectoryView.c"
}

/** Handle Preference changes */
static GVariant*
_variant_new4 (gboolean value)
{
#line 1480 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 8549 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_show_hidden_files_changed (FilesAbstractDirectoryView* self,
                                                            GObject* prefs,
                                                            GParamSpec* pspec)
{
	gboolean show = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	FilesListModel* _tmp2_;
	FilesViewSlot* _tmp4_;
	FilesDirectory* _tmp5_;
	FilesDirectory* _tmp6_;
	FilesViewSlot* _tmp7_;
	FilesDirectory* _tmp8_;
	FilesDirectory* _tmp9_;
	GList* _tmp10_;
	GSimpleActionGroup* _tmp14_;
	GVariant* _tmp15_;
#line 1456 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1456 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (prefs != NULL);
#line 1456 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (pspec != NULL);
#line 1457 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_preferences_get_show_hidden_files (G_TYPE_CHECK_INSTANCE_CAST (prefs, FILES_TYPE_PREFERENCES, FilesPreferences));
#line 1457 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1457 "../src/View/AbstractDirectoryView.vala"
	show = _tmp1_;
#line 1458 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->model;
#line 1458 "../src/View/AbstractDirectoryView.vala"
	files_list_model_set_show_hidden_files (_tmp2_, show);
#line 1459 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel (self);
#line 1461 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unselect_all (self);
#line 1463 "../src/View/AbstractDirectoryView.vala"
	if (!show) {
#line 8592 "AbstractDirectoryView.c"
		FilesListModel* _tmp3_;
#line 1464 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_block_model (self);
#line 1465 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = self->model;
#line 1465 "../src/View/AbstractDirectoryView.vala"
		files_list_model_clear (_tmp3_);
#line 8600 "AbstractDirectoryView.c"
	}
#line 1468 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = self->slot;
#line 1468 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp4_);
#line 1468 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_;
#line 1468 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_directory_hidden_changed (self, _tmp6_, show);
#line 1470 "../src/View/AbstractDirectoryView.vala"
	if (!show) {
#line 1471 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_unblock_model (self);
#line 8614 "AbstractDirectoryView.c"
	}
#line 1474 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->slot;
#line 1474 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp7_);
#line 1474 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _tmp8_;
#line 1474 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = files_directory_get_files (_tmp9_);
#line 8624 "AbstractDirectoryView.c"
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
#line 1474 "../src/View/AbstractDirectoryView.vala"
		file_collection = _tmp10_;
#line 1474 "../src/View/AbstractDirectoryView.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 8632 "AbstractDirectoryView.c"
			FilesFile* _tmp11_;
			FilesFile* file = NULL;
#line 1474 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = _g_object_ref0 ((FilesFile*) file_it->data);
#line 1474 "../src/View/AbstractDirectoryView.vala"
			file = _tmp11_;
#line 8639 "AbstractDirectoryView.c"
			{
				FilesFile* _tmp12_;
#line 1475 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = file;
#line 1475 "../src/View/AbstractDirectoryView.vala"
				if (files_file_is_folder (_tmp12_)) {
#line 8646 "AbstractDirectoryView.c"
					FilesFile* _tmp13_;
#line 1476 "../src/View/AbstractDirectoryView.vala"
					_tmp13_ = file;
#line 1476 "../src/View/AbstractDirectoryView.vala"
					files_file_ensure_size (_tmp13_);
#line 8652 "AbstractDirectoryView.c"
				}
#line 1474 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (file);
#line 8656 "AbstractDirectoryView.c"
			}
		}
#line 1474 "../src/View/AbstractDirectoryView.vala"
		(file_collection == NULL) ? NULL : (file_collection = (g_list_free (file_collection), NULL));
#line 8661 "AbstractDirectoryView.c"
	}
#line 1480 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = self->priv->background_actions;
#line 1480 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = _variant_new4 (show);
#line 1480 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_state (self, _tmp14_, "show-hidden", _tmp15_);
#line 1480 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp15_);
#line 8671 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new5 (gboolean value)
{
#line 1485 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 8679 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_show_remote_thumbnails_changed (FilesAbstractDirectoryView* self,
                                                                 GObject* prefs,
                                                                 GParamSpec* pspec)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GSimpleActionGroup* _tmp2_;
	gboolean _tmp3_;
	GVariant* _tmp4_;
	FilesViewSlot* _tmp5_;
#line 1483 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1483 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (prefs != NULL);
#line 1483 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (pspec != NULL);
#line 1484 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_preferences_get_show_remote_thumbnails (G_TYPE_CHECK_INSTANCE_CAST (prefs, FILES_TYPE_PREFERENCES, FilesPreferences));
#line 1484 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1484 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_show_remote_thumbnails (self, _tmp1_);
#line 1485 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->priv->background_actions;
#line 1485 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->priv->_show_remote_thumbnails;
#line 1485 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _variant_new5 (_tmp3_);
#line 1485 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_state (self, _tmp2_, "show-remote-thumbnails", _tmp4_);
#line 1485 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp4_);
#line 1486 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = self->slot;
#line 1486 "../src/View/AbstractDirectoryView.vala"
	files_abstract_slot_reload ((FilesAbstractSlot*) _tmp5_, FALSE);
#line 8719 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new6 (gboolean value)
{
#line 1491 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_boolean (value));
#line 8727 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_show_local_thumbnails_changed (FilesAbstractDirectoryView* self,
                                                                GObject* prefs,
                                                                GParamSpec* pspec)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GSimpleActionGroup* _tmp2_;
	gboolean _tmp3_;
	GVariant* _tmp4_;
	FilesViewSlot* _tmp5_;
#line 1489 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1489 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (prefs != NULL);
#line 1489 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (pspec != NULL);
#line 1490 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_preferences_get_show_local_thumbnails (G_TYPE_CHECK_INSTANCE_CAST (prefs, FILES_TYPE_PREFERENCES, FilesPreferences));
#line 1490 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1490 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_show_local_thumbnails (self, _tmp1_);
#line 1491 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->priv->background_actions;
#line 1491 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->priv->_show_local_thumbnails;
#line 1491 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _variant_new6 (_tmp3_);
#line 1491 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_state (self, _tmp2_, "show-local-thumbnails", _tmp4_);
#line 1491 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp4_);
#line 1492 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = self->slot;
#line 1492 "../src/View/AbstractDirectoryView.vala"
	files_abstract_slot_reload ((FilesAbstractSlot*) _tmp5_, FALSE);
#line 8767 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_sort_directories_first_changed (FilesAbstractDirectoryView* self,
                                                                 GObject* prefs,
                                                                 GParamSpec* pspec)
{
	gboolean sort_directories_first = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	FilesListModel* _tmp2_;
#line 1495 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1495 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (prefs != NULL);
#line 1495 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (pspec != NULL);
#line 1496 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_preferences_get_sort_directories_first (G_TYPE_CHECK_INSTANCE_CAST (prefs, FILES_TYPE_PREFERENCES, FilesPreferences));
#line 1496 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1496 "../src/View/AbstractDirectoryView.vala"
	sort_directories_first = _tmp1_;
#line 1497 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->model;
#line 1497 "../src/View/AbstractDirectoryView.vala"
	files_list_model_set_should_sort_directories_first (_tmp2_, sort_directories_first);
#line 8795 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_directory_hidden_changed (FilesAbstractDirectoryView* self,
                                                        FilesDirectory* dir,
                                                        gboolean show)
{
#line 1500 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1500 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (dir != NULL);
#line 1502 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_directory_loading_handlers (self, dir);
#line 1503 "../src/View/AbstractDirectoryView.vala"
	files_directory_load_hiddens (dir);
#line 8811 "AbstractDirectoryView.c"
}

/** Handle popup menu events */
static void
_vala_GdkEvent_free (GdkEvent* self)
{
#line 1510 "../src/View/AbstractDirectoryView.vala"
	g_boxed_free (gdk_event_get_type (), self);
#line 8820 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_on_popup_menu (FilesAbstractDirectoryView* self)
{
	GdkEvent* event = NULL;
	GdkEvent* _tmp0_;
	gboolean result;
#line 1507 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1508 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_get_current_event ();
#line 1508 "../src/View/AbstractDirectoryView.vala"
	event = _tmp0_;
#line 1509 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_show_context_menu (self, event);
#line 1510 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 1510 "../src/View/AbstractDirectoryView.vala"
	__vala_GdkEvent_free0 (event);
#line 1510 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 8843 "AbstractDirectoryView.c"
}

/** Handle Button events */
static gboolean
files_abstract_directory_view_on_drag_timeout_button_release (FilesAbstractDirectoryView* self,
                                                              GdkEventButton* event)
{
	gboolean result;
#line 1514 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1514 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1516 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_drag_timer (self);
#line 1517 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 1517 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 8862 "AbstractDirectoryView.c"
}

/** Handle Motion events */
static gboolean
files_abstract_directory_view_on_drag_timeout_motion_notify (FilesAbstractDirectoryView* self,
                                                             GdkEventMotion* event)
{
	GdkDragContext* context = NULL;
	GtkWidget* widget = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	GtkWidget* _tmp4_;
	gboolean result;
#line 1521 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1521 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 1524 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
#line 1524 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1524 "../src/View/AbstractDirectoryView.vala"
	widget = _tmp1_;
#line 1526 "../src/View/AbstractDirectoryView.vala"
	gdk_event_get_coords ((GdkEvent*) event, &_tmp2_, &_tmp3_);
#line 1526 "../src/View/AbstractDirectoryView.vala"
	x = _tmp2_;
#line 1526 "../src/View/AbstractDirectoryView.vala"
	y = _tmp3_;
#line 1528 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = widget;
#line 1528 "../src/View/AbstractDirectoryView.vala"
	if (gtk_drag_check_threshold (_tmp4_, (gint) self->priv->drag_x, (gint) self->priv->drag_y, (gint) x, (gint) y)) {
#line 8900 "AbstractDirectoryView.c"
		GtkTargetList* target_list = NULL;
		GtkTargetList* _tmp5_;
		GdkDragAction actions = 0U;
		GtkWidget* _tmp6_;
		GtkTargetList* _tmp7_;
		GdkDragContext* _tmp8_;
		GdkDragContext* _tmp9_;
#line 1529 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_cancel_drag_timer (self);
#line 1530 "../src/View/AbstractDirectoryView.vala"
		self->should_activate = FALSE;
#line 1531 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = gtk_target_list_new (FILES_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS, G_N_ELEMENTS (FILES_ABSTRACT_DIRECTORY_VIEW_DRAG_TARGETS));
#line 1531 "../src/View/AbstractDirectoryView.vala"
		target_list = _tmp5_;
#line 1532 "../src/View/AbstractDirectoryView.vala"
		actions = FILES_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS;
#line 1534 "../src/View/AbstractDirectoryView.vala"
		if (self->priv->drag_button == GDK_BUTTON_SECONDARY) {
#line 1535 "../src/View/AbstractDirectoryView.vala"
			actions |= GDK_ACTION_ASK;
#line 8922 "AbstractDirectoryView.c"
		}
#line 1538 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = widget;
#line 1538 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = target_list;
#line 1538 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = gtk_drag_begin_with_coordinates (_tmp6_, _tmp7_, actions, self->priv->drag_button, (GdkEvent*) event, (gint) x, (gint) y);
#line 1538 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 1538 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (context);
#line 1538 "../src/View/AbstractDirectoryView.vala"
		context = _tmp9_;
#line 1544 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 1544 "../src/View/AbstractDirectoryView.vala"
		_gtk_target_list_unref0 (target_list);
#line 1544 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (widget);
#line 1544 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (context);
#line 1544 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 8946 "AbstractDirectoryView.c"
	} else {
#line 1546 "../src/View/AbstractDirectoryView.vala"
		result = FALSE;
#line 1546 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (widget);
#line 1546 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (context);
#line 1546 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 8956 "AbstractDirectoryView.c"
	}
}

/** Handle TreeModel events */
static void
files_abstract_directory_view_real_on_row_deleted (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path)
{
#line 1551 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (path != NULL);
#line 1552 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unselect_all (self);
#line 8969 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_row_deleted (FilesAbstractDirectoryView* self,
                                              GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 1551 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1551 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 1551 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->on_row_deleted) {
#line 1551 "../src/View/AbstractDirectoryView.vala"
		_klass_->on_row_deleted (self, path);
#line 8985 "AbstractDirectoryView.c"
	}
}

/** Handle clipboard signal */
static void
files_abstract_directory_view_on_clipboard_changed (FilesAbstractDirectoryView* self)
{
#line 1556 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1558 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_queue_draw ((GtkWidget*) self);
#line 8997 "AbstractDirectoryView.c"
}

/** DRAG AND DROP SOURCE */
static void
files_abstract_directory_view_on_drag_begin (FilesAbstractDirectoryView* self,
                                             GdkDragContext* context)
{
#line 1564 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1564 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 1565 "../src/View/AbstractDirectoryView.vala"
	self->should_activate = FALSE;
#line 9011 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_drag_data_get (FilesAbstractDirectoryView* self,
                                                GdkDragContext* context,
                                                GtkSelectionData* selection_data,
                                                guint info,
                                                guint timestamp)
{
	GList* _tmp0_;
	GList* _tmp3_;
	FilesFile* file = NULL;
	GList* _tmp4_;
	GList* _tmp5_;
	gconstpointer _tmp6_;
	FilesFile* _tmp7_;
	gboolean _tmp8_ = FALSE;
	FilesFile* _tmp9_;
	GList* _tmp14_;
#line 1570 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1570 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 1570 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (selection_data != NULL);
#line 1575 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->source_drag_file_list;
#line 1575 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 9041 "AbstractDirectoryView.c"
		GList* _tmp1_;
		GList* _tmp2_;
#line 1576 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = files_abstract_directory_view_get_selected_files (self);
#line 1576 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_abstract_directory_view_get_selected_files_for_transfer (self, _tmp1_);
#line 1576 "../src/View/AbstractDirectoryView.vala"
		(self->source_drag_file_list == NULL) ? NULL : (self->source_drag_file_list = (_g_list_free__g_object_unref0_ (self->source_drag_file_list), NULL));
#line 1576 "../src/View/AbstractDirectoryView.vala"
		self->source_drag_file_list = _tmp2_;
#line 9052 "AbstractDirectoryView.c"
	}
#line 1579 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->source_drag_file_list;
#line 1579 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_ == NULL) {
#line 1580 "../src/View/AbstractDirectoryView.vala"
		return;
#line 9060 "AbstractDirectoryView.c"
	}
#line 1583 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = self->source_drag_file_list;
#line 1583 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = g_list_first (_tmp4_);
#line 1583 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_->data;
#line 1583 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = _g_object_ref0 ((FilesFile*) _tmp6_);
#line 1583 "../src/View/AbstractDirectoryView.vala"
	file = _tmp7_;
#line 1585 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = file;
#line 1585 "../src/View/AbstractDirectoryView.vala"
	if (_tmp9_ != NULL) {
#line 9076 "AbstractDirectoryView.c"
		FilesFile* _tmp10_;
		GdkPixbuf* _tmp11_;
#line 1585 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = file;
#line 1585 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_->pix;
#line 1585 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = _tmp11_ != NULL;
#line 9085 "AbstractDirectoryView.c"
	} else {
#line 1585 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = FALSE;
#line 9089 "AbstractDirectoryView.c"
	}
#line 1585 "../src/View/AbstractDirectoryView.vala"
	if (_tmp8_) {
#line 9093 "AbstractDirectoryView.c"
		FilesFile* _tmp12_;
		GdkPixbuf* _tmp13_;
#line 1586 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = file;
#line 1586 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = _tmp12_->pix;
#line 1586 "../src/View/AbstractDirectoryView.vala"
		gtk_drag_set_icon_gicon (context, (GIcon*) _tmp13_, 0, 0);
#line 9102 "AbstractDirectoryView.c"
	} else {
#line 1588 "../src/View/AbstractDirectoryView.vala"
		gtk_drag_set_icon_name (context, "stock-file", 0, 0);
#line 9106 "AbstractDirectoryView.c"
	}
#line 1591 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = self->source_drag_file_list;
#line 1591 "../src/View/AbstractDirectoryView.vala"
	files_dnd_handler_set_selection_data_from_file_list (selection_data, _tmp14_, "");
#line 1570 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 9114 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_drag_data_delete (FilesAbstractDirectoryView* self,
                                                   GdkDragContext* context)
{
	GtkWidget* _tmp0_;
#line 1595 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1595 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 1597 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
#line 1597 "../src/View/AbstractDirectoryView.vala"
	g_signal_stop_emission_by_name (_tmp0_, "drag-data-delete");
#line 9130 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_drag_end (FilesAbstractDirectoryView* self,
                                           GdkDragContext* context)
{
#line 1601 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1601 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 1602 "../src/View/AbstractDirectoryView.vala"
	(self->source_drag_file_list == NULL) ? NULL : (self->source_drag_file_list = (_g_list_free__g_object_unref0_ (self->source_drag_file_list), NULL));
#line 1602 "../src/View/AbstractDirectoryView.vala"
	self->source_drag_file_list = NULL;
#line 9145 "AbstractDirectoryView.c"
}

/** DRAG AND DROP DESTINATION */
static gboolean
files_abstract_directory_view_on_drag_motion (FilesAbstractDirectoryView* self,
                                              GdkDragContext* context,
                                              gint x,
                                              gint y,
                                              guint timestamp)
{
	gboolean result;
#line 1608 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1608 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 1613 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->destination_data_ready) {
#line 1615 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_check_destination_actions_and_target_file (self, context, x, y, timestamp);
#line 9165 "AbstractDirectoryView.c"
	} else {
#line 1618 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_get_drag_data (self, context, x, y, timestamp);
#line 1619 "../src/View/AbstractDirectoryView.vala"
		result = FALSE;
#line 1619 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 9173 "AbstractDirectoryView.c"
	}
#line 1622 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->drag_scroll_timer_id == ((guint) 0)) {
#line 1623 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_start_drag_scroll_timer (self, context);
#line 9179 "AbstractDirectoryView.c"
	}
#line 1626 "../src/View/AbstractDirectoryView.vala"
	gdk_drag_status (context, self->priv->current_suggested_action, (guint32) timestamp);
#line 1627 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 1627 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9187 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_on_drag_drop (FilesAbstractDirectoryView* self,
                                            GdkDragContext* context,
                                            gint x,
                                            gint y,
                                            guint timestamp)
{
	GtkTargetList* list = NULL;
	gchar* uri = NULL;
	GdkAtom target = (GdkAtom) 0U;
	GtkWidget* _tmp0_;
	GtkTargetList* _tmp1_;
	GtkWidget* _tmp19_;
	gboolean result;
#line 1631 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1631 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (context != NULL, FALSE);
#line 1636 "../src/View/AbstractDirectoryView.vala"
	list = NULL;
#line 1637 "../src/View/AbstractDirectoryView.vala"
	uri = NULL;
#line 1638 "../src/View/AbstractDirectoryView.vala"
	self->priv->drop_occurred = TRUE;
#line 1640 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
#line 1640 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = list;
#line 1640 "../src/View/AbstractDirectoryView.vala"
	target = gtk_drag_dest_find_target (_tmp0_, context, _tmp1_);
#line 1641 "../src/View/AbstractDirectoryView.vala"
	if (target == gdk_atom_intern_static_string ("XdndDirectSave0")) {
#line 9222 "AbstractDirectoryView.c"
		FilesFile* target_file = NULL;
		FilesFile* _tmp2_;
		gchar* filename = NULL;
		FilesDndHandler* _tmp3_;
		gchar* _tmp4_;
		gboolean _tmp5_ = FALSE;
		FilesFile* _tmp6_;
#line 1642 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_abstract_directory_view_get_drop_target_file (self, x, y);
#line 1642 "../src/View/AbstractDirectoryView.vala"
		target_file = _tmp2_;
#line 1644 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_abstract_directory_view_dnd_handler;
#line 1644 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = files_dnd_handler_get_source_filename (_tmp3_, context);
#line 1644 "../src/View/AbstractDirectoryView.vala"
		filename = _tmp4_;
#line 1645 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = target_file;
#line 1645 "../src/View/AbstractDirectoryView.vala"
		if (_tmp6_ != NULL) {
#line 9244 "AbstractDirectoryView.c"
			const gchar* _tmp7_;
#line 1645 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = filename;
#line 1645 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = _tmp7_ != NULL;
#line 9250 "AbstractDirectoryView.c"
		} else {
#line 1645 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = FALSE;
#line 9254 "AbstractDirectoryView.c"
		}
#line 1645 "../src/View/AbstractDirectoryView.vala"
		if (_tmp5_) {
#line 9258 "AbstractDirectoryView.c"
			FilesFile* _tmp8_;
			GFile* _tmp9_;
			const gchar* _tmp10_;
			GFile* _tmp11_;
			GFile* _tmp12_;
			gchar* _tmp13_;
			FilesDndHandler* _tmp14_;
			const gchar* _tmp15_;
#line 1647 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = target_file;
#line 1647 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = files_file_get_target_location (_tmp8_);
#line 1647 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = filename;
#line 1647 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = g_file_resolve_relative_path (_tmp9_, _tmp10_);
#line 1647 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = _tmp11_;
#line 1647 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = g_file_get_uri (_tmp12_);
#line 1647 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (uri);
#line 1647 "../src/View/AbstractDirectoryView.vala"
			uri = _tmp13_;
#line 1647 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp12_);
#line 1649 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = files_abstract_directory_view_dnd_handler;
#line 1649 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = uri;
#line 1649 "../src/View/AbstractDirectoryView.vala"
			files_dnd_handler_set_source_uri (_tmp14_, context, _tmp15_);
#line 9291 "AbstractDirectoryView.c"
		} else {
			FilesViewWindow* _tmp16_;
			GraniteMessageDialog* _tmp17_;
			GraniteMessageDialog* _tmp18_;
#line 1651 "../src/View/AbstractDirectoryView.vala"
			_tmp16_ = self->window;
#line 1651 "../src/View/AbstractDirectoryView.vala"
			_tmp17_ = pf_dialogs_show_error_dialog (_ ("Cannot drop this file"), _ ("Invalid file name provided"), (GtkWindow*) _tmp16_);
#line 1651 "../src/View/AbstractDirectoryView.vala"
			_tmp18_ = _tmp17_;
#line 1651 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp18_);
#line 1654 "../src/View/AbstractDirectoryView.vala"
			result = FALSE;
#line 1654 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (filename);
#line 1654 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (target_file);
#line 1654 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (uri);
#line 1654 "../src/View/AbstractDirectoryView.vala"
			_gtk_target_list_unref0 (list);
#line 1654 "../src/View/AbstractDirectoryView.vala"
			return result;
#line 9316 "AbstractDirectoryView.c"
		}
#line 1641 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (filename);
#line 1641 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (target_file);
#line 9322 "AbstractDirectoryView.c"
	}
#line 1660 "../src/View/AbstractDirectoryView.vala"
	_tmp19_ = gtk_bin_get_child ((GtkBin*) self);
#line 1660 "../src/View/AbstractDirectoryView.vala"
	gtk_drag_get_data (_tmp19_, context, target, (guint32) timestamp);
#line 1662 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 1662 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (uri);
#line 1662 "../src/View/AbstractDirectoryView.vala"
	_gtk_target_list_unref0 (list);
#line 1662 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9336 "AbstractDirectoryView.c"
}

static gboolean
____lambda125_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 1723 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 1724 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1724 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9349 "AbstractDirectoryView.c"
}

static gboolean
_____lambda125__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda125_ ((FilesAbstractDirectoryView*) self);
#line 1722 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9359 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_on_drag_data_received (FilesAbstractDirectoryView* self,
                                                     GdkDragContext* context,
                                                     gint x,
                                                     gint y,
                                                     GtkSelectionData* selection_data,
                                                     guint info,
                                                     guint timestamp)
{
	gboolean _tmp0_ = FALSE;
#line 1668 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1668 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 1668 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (selection_data != NULL);
#line 1677 "../src/View/AbstractDirectoryView.vala"
	if (info == ((guint) FILES_TARGET_TYPE_TEXT_URI_LIST)) {
#line 9380 "AbstractDirectoryView.c"
		GList* _tmp1_;
#line 1677 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->priv->destination_drop_file_list;
#line 1677 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp1_ == NULL;
#line 9386 "AbstractDirectoryView.c"
	} else {
#line 1677 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FALSE;
#line 9390 "AbstractDirectoryView.c"
	}
#line 1677 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 9394 "AbstractDirectoryView.c"
		gchar* text = NULL;
		gchar* _tmp2_ = NULL;
		gboolean _tmp3_;
#line 1679 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_dnd_handler_selection_data_is_uri_list (selection_data, info, &_tmp2_);
#line 1679 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (text);
#line 1679 "../src/View/AbstractDirectoryView.vala"
		text = _tmp2_;
#line 1679 "../src/View/AbstractDirectoryView.vala"
		if (_tmp3_) {
#line 9406 "AbstractDirectoryView.c"
			const gchar* _tmp4_;
			GList* _tmp5_;
#line 1680 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = text;
#line 1680 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = files_file_utils_files_from_uris (_tmp4_);
#line 1680 "../src/View/AbstractDirectoryView.vala"
			(self->priv->destination_drop_file_list == NULL) ? NULL : (self->priv->destination_drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->destination_drop_file_list), NULL));
#line 1680 "../src/View/AbstractDirectoryView.vala"
			self->priv->destination_drop_file_list = _tmp5_;
#line 1681 "../src/View/AbstractDirectoryView.vala"
			self->priv->destination_data_ready = TRUE;
#line 9419 "AbstractDirectoryView.c"
		}
#line 1677 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (text);
#line 9423 "AbstractDirectoryView.c"
	}
#line 1685 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->drop_occurred) {
#line 9427 "AbstractDirectoryView.c"
		gboolean success = FALSE;
#line 1686 "../src/View/AbstractDirectoryView.vala"
		success = FALSE;
#line 1687 "../src/View/AbstractDirectoryView.vala"
		self->priv->drop_occurred = FALSE;
#line 1689 "../src/View/AbstractDirectoryView.vala"
		switch (info) {
#line 1689 "../src/View/AbstractDirectoryView.vala"
			case FILES_TARGET_TYPE_XDND_DIRECT_SAVE0:
#line 9437 "AbstractDirectoryView.c"
			{
				FilesDndHandler* _tmp6_;
				FilesFile* _tmp7_;
#line 1691 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = files_abstract_directory_view_dnd_handler;
#line 1691 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = self->priv->drop_target_file;
#line 1691 "../src/View/AbstractDirectoryView.vala"
				success = files_dnd_handler_handle_xdnddirectsave (_tmp6_, context, _tmp7_, selection_data);
#line 1694 "../src/View/AbstractDirectoryView.vala"
				break;
#line 9449 "AbstractDirectoryView.c"
			}
#line 1689 "../src/View/AbstractDirectoryView.vala"
			case FILES_TARGET_TYPE_NETSCAPE_URL:
#line 9453 "AbstractDirectoryView.c"
			{
				FilesDndHandler* _tmp8_;
				FilesFile* _tmp9_;
#line 1697 "../src/View/AbstractDirectoryView.vala"
				_tmp8_ = files_abstract_directory_view_dnd_handler;
#line 1697 "../src/View/AbstractDirectoryView.vala"
				_tmp9_ = self->priv->drop_target_file;
#line 1697 "../src/View/AbstractDirectoryView.vala"
				success = files_dnd_handler_handle_netscape_url (_tmp8_, context, _tmp9_, selection_data);
#line 1700 "../src/View/AbstractDirectoryView.vala"
				break;
#line 9465 "AbstractDirectoryView.c"
			}
#line 1689 "../src/View/AbstractDirectoryView.vala"
			case FILES_TARGET_TYPE_TEXT_URI_LIST:
#line 9469 "AbstractDirectoryView.c"
			{
				GList* _tmp10_;
				FilesDndHandler* _tmp11_;
				GtkWidget* _tmp12_;
				FilesFile* _tmp13_;
				GList* _tmp14_;
				GtkWindow* _tmp15_;
				GtkApplicationWindow* _tmp16_;
#line 1703 "../src/View/AbstractDirectoryView.vala"
				if ((self->priv->current_actions & FILES_ABSTRACT_DIRECTORY_VIEW_FILE_DRAG_ACTIONS) == 0) {
#line 1704 "../src/View/AbstractDirectoryView.vala"
					break;
#line 9482 "AbstractDirectoryView.c"
				}
#line 1707 "../src/View/AbstractDirectoryView.vala"
				_tmp10_ = self->selected_files;
#line 1707 "../src/View/AbstractDirectoryView.vala"
				if (_tmp10_ != NULL) {
#line 1708 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_unselect_all (self);
#line 9490 "AbstractDirectoryView.c"
				}
#line 1711 "../src/View/AbstractDirectoryView.vala"
				_tmp11_ = files_abstract_directory_view_dnd_handler;
#line 1711 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = gtk_bin_get_child ((GtkBin*) self);
#line 1711 "../src/View/AbstractDirectoryView.vala"
				_tmp13_ = self->priv->drop_target_file;
#line 1711 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = self->priv->destination_drop_file_list;
#line 1711 "../src/View/AbstractDirectoryView.vala"
				_tmp15_ = files_get_active_window ();
#line 1711 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_application_window_get_type (), GtkApplicationWindow);
#line 1711 "../src/View/AbstractDirectoryView.vala"
				success = files_dnd_handler_handle_file_drag_actions (_tmp11_, _tmp12_, context, _tmp13_, _tmp14_, self->priv->current_actions, self->priv->current_suggested_action, _tmp16_, (guint32) timestamp);
#line 1711 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp16_);
#line 1722 "../src/View/AbstractDirectoryView.vala"
				g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda125__gsource_func, g_object_ref (self), g_object_unref);
#line 1727 "../src/View/AbstractDirectoryView.vala"
				break;
#line 9512 "AbstractDirectoryView.c"
			}
			default:
			{
#line 1730 "../src/View/AbstractDirectoryView.vala"
				break;
#line 9518 "AbstractDirectoryView.c"
			}
		}
#line 1734 "../src/View/AbstractDirectoryView.vala"
		gtk_drag_finish (context, success, FALSE, (guint32) timestamp);
#line 1735 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_clear_destination_drag_data (self);
#line 9525 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_on_drag_leave (FilesAbstractDirectoryView* self,
                                             GdkDragContext* context,
                                             guint timestamp)
{
	FilesIconRenderer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 1740 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1740 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 1742 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->icon_renderer;
#line 1742 "../src/View/AbstractDirectoryView.vala"
	files_icon_renderer_set_drop_file (_tmp0_, NULL);
#line 1744 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->drag_scroll_timer_id);
#line 1745 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->drag_enter_timer_id);
#line 1748 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_drop_highlight (self);
#line 1748 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 1748 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 1749 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_drop_highlight (self, FALSE);
#line 1750 "../src/View/AbstractDirectoryView.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 9559 "AbstractDirectoryView.c"
	}
#line 1754 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_highlight_path (self, NULL);
#line 1757 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_clear_destination_drag_data (self);
#line 9565 "AbstractDirectoryView.c"
}

/** DnD destination helpers */
static void
files_abstract_directory_view_clear_destination_drag_data (FilesAbstractDirectoryView* self)
{
#line 1762 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1763 "../src/View/AbstractDirectoryView.vala"
	self->priv->destination_data_ready = FALSE;
#line 1764 "../src/View/AbstractDirectoryView.vala"
	self->current_target_type = GDK_NONE;
#line 1765 "../src/View/AbstractDirectoryView.vala"
	(self->priv->destination_drop_file_list == NULL) ? NULL : (self->priv->destination_drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->destination_drop_file_list), NULL));
#line 1765 "../src/View/AbstractDirectoryView.vala"
	self->priv->destination_drop_file_list = NULL;
#line 1766 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->drag_scroll_timer_id);
#line 9584 "AbstractDirectoryView.c"
}

static FilesFile*
files_abstract_directory_view_get_drop_target_file (FilesAbstractDirectoryView* self,
                                                    gint win_x,
                                                    gint win_y)
{
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp0_;
	FilesFile* file = NULL;
	GtkTreePath* _tmp1_;
	GtkTreePath* _tmp15_;
	FilesFile* result;
#line 1769 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1770 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_path_at_pos (self, win_x, win_y);
#line 1770 "../src/View/AbstractDirectoryView.vala"
	path = _tmp0_;
#line 1771 "../src/View/AbstractDirectoryView.vala"
	file = NULL;
#line 1773 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = path;
#line 1773 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ != NULL) {
#line 9610 "AbstractDirectoryView.c"
		FilesListModel* _tmp2_;
		GtkTreePath* _tmp3_;
		FilesFile* _tmp4_;
		FilesFile* _tmp5_;
#line 1774 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->model;
#line 1774 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = path;
#line 1774 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = files_list_model_file_for_path (_tmp2_, _tmp3_);
#line 1774 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 1774 "../src/View/AbstractDirectoryView.vala"
		file = _tmp4_;
#line 1775 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = file;
#line 1775 "../src/View/AbstractDirectoryView.vala"
		if (_tmp5_ == NULL) {
#line 9629 "AbstractDirectoryView.c"
			GtkTreePath* folder_path = NULL;
			GtkTreePath* _tmp6_;
			GtkTreePath* _tmp7_;
			GtkTreePath* _tmp8_;
			FilesListModel* _tmp9_;
			GtkTreePath* _tmp10_;
			FilesFile* _tmp11_;
#line 1777 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = path;
#line 1777 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = gtk_tree_path_copy (_tmp6_);
#line 1777 "../src/View/AbstractDirectoryView.vala"
			folder_path = _tmp7_;
#line 1778 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = folder_path;
#line 1778 "../src/View/AbstractDirectoryView.vala"
			gtk_tree_path_up (_tmp8_);
#line 1779 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = self->model;
#line 1779 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = folder_path;
#line 1779 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = files_list_model_file_for_path (_tmp9_, _tmp10_);
#line 1779 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (file);
#line 1779 "../src/View/AbstractDirectoryView.vala"
			file = _tmp11_;
#line 1775 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (folder_path);
#line 9659 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp12_ = FALSE;
			FilesFile* _tmp13_;
#line 1782 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = file;
#line 1782 "../src/View/AbstractDirectoryView.vala"
			if (!files_file_is_folder (_tmp13_)) {
#line 9667 "AbstractDirectoryView.c"
				FilesFile* _tmp14_;
#line 1782 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = file;
#line 1782 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = !files_file_is_executable (_tmp14_);
#line 9673 "AbstractDirectoryView.c"
			} else {
#line 1782 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = FALSE;
#line 9677 "AbstractDirectoryView.c"
			}
#line 1782 "../src/View/AbstractDirectoryView.vala"
			if (_tmp12_) {
#line 1783 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (file);
#line 1783 "../src/View/AbstractDirectoryView.vala"
				file = NULL;
#line 1784 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (path);
#line 1784 "../src/View/AbstractDirectoryView.vala"
				path = NULL;
#line 9689 "AbstractDirectoryView.c"
			}
		}
	}
#line 1789 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = path;
#line 1789 "../src/View/AbstractDirectoryView.vala"
	if (_tmp15_ == NULL) {
#line 9697 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp16_;
		FilesDirectory* _tmp17_;
		FilesDirectory* _tmp18_;
		FilesFile* _tmp19_;
		FilesFile* _tmp20_;
		FilesFile* _tmp21_;
#line 1791 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = self->slot;
#line 1791 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp16_);
#line 1791 "../src/View/AbstractDirectoryView.vala"
		_tmp18_ = _tmp17_;
#line 1791 "../src/View/AbstractDirectoryView.vala"
		_tmp19_ = files_directory_get_file (_tmp18_);
#line 1791 "../src/View/AbstractDirectoryView.vala"
		_tmp20_ = _tmp19_;
#line 1791 "../src/View/AbstractDirectoryView.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 1791 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 1791 "../src/View/AbstractDirectoryView.vala"
		file = _tmp21_;
#line 9720 "AbstractDirectoryView.c"
	}
#line 1794 "../src/View/AbstractDirectoryView.vala"
	result = file;
#line 1794 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 1794 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9728 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_get_drag_data (FilesAbstractDirectoryView* self,
                                             GdkDragContext* context,
                                             gint x,
                                             gint y,
                                             guint timestamp)
{
	GtkTargetList* list = NULL;
	GdkAtom target = (GdkAtom) 0U;
	GtkWidget* _tmp0_;
	GtkTargetList* _tmp1_;
	gboolean _tmp2_ = FALSE;
#line 1798 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1798 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 1799 "../src/View/AbstractDirectoryView.vala"
	list = NULL;
#line 1800 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
#line 1800 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = list;
#line 1800 "../src/View/AbstractDirectoryView.vala"
	target = gtk_drag_dest_find_target (_tmp0_, context, _tmp1_);
#line 1801 "../src/View/AbstractDirectoryView.vala"
	self->current_target_type = target;
#line 1804 "../src/View/AbstractDirectoryView.vala"
	if (target == gdk_atom_intern_static_string ("XdndDirectSave0")) {
#line 1804 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = TRUE;
#line 9761 "AbstractDirectoryView.c"
	} else {
#line 1805 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = target == gdk_atom_intern_static_string ("_NETSCAPE_URL");
#line 9765 "AbstractDirectoryView.c"
	}
#line 1804 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 9769 "AbstractDirectoryView.c"
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		FilesFile* _tmp5_;
#line 1807 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->priv->drop_target_file;
#line 1807 "../src/View/AbstractDirectoryView.vala"
		if (_tmp5_ != NULL) {
#line 9777 "AbstractDirectoryView.c"
			FilesFile* _tmp6_;
#line 1808 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = self->priv->drop_target_file;
#line 1808 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = files_file_is_folder (_tmp6_);
#line 9783 "AbstractDirectoryView.c"
		} else {
#line 1807 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = FALSE;
#line 9787 "AbstractDirectoryView.c"
		}
#line 1807 "../src/View/AbstractDirectoryView.vala"
		if (_tmp4_) {
#line 9791 "AbstractDirectoryView.c"
			FilesFile* _tmp7_;
#line 1809 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = self->priv->drop_target_file;
#line 1809 "../src/View/AbstractDirectoryView.vala"
			_tmp3_ = files_file_is_writable (_tmp7_);
#line 9797 "AbstractDirectoryView.c"
		} else {
#line 1807 "../src/View/AbstractDirectoryView.vala"
			_tmp3_ = FALSE;
#line 9801 "AbstractDirectoryView.c"
		}
#line 1807 "../src/View/AbstractDirectoryView.vala"
		if (_tmp3_) {
#line 9805 "AbstractDirectoryView.c"
			FilesIconRenderer* _tmp8_;
			FilesFile* _tmp9_;
			GtkTreePath* _tmp10_;
			GtkTreePath* _tmp11_;
#line 1811 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = self->icon_renderer;
#line 1811 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = self->priv->drop_target_file;
#line 1811 "../src/View/AbstractDirectoryView.vala"
			g_object_set ((GObject*) _tmp8_, "drop-file", _tmp9_, NULL);
#line 1812 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = files_abstract_directory_view_get_path_at_pos (self, x, y);
#line 1812 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = _tmp10_;
#line 1812 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_highlight_path (self, _tmp11_);
#line 1812 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (_tmp11_);
#line 9824 "AbstractDirectoryView.c"
		}
#line 1815 "../src/View/AbstractDirectoryView.vala"
		self->priv->destination_data_ready = TRUE;
#line 9828 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp12_ = FALSE;
#line 1816 "../src/View/AbstractDirectoryView.vala"
		if (target != GDK_NONE) {
#line 9833 "AbstractDirectoryView.c"
			GList* _tmp13_;
#line 1816 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = self->priv->destination_drop_file_list;
#line 1816 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = _tmp13_ == NULL;
#line 9839 "AbstractDirectoryView.c"
		} else {
#line 1816 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = FALSE;
#line 9843 "AbstractDirectoryView.c"
		}
#line 1816 "../src/View/AbstractDirectoryView.vala"
		if (_tmp12_) {
#line 9847 "AbstractDirectoryView.c"
			GtkWidget* _tmp14_;
#line 1819 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = gtk_bin_get_child ((GtkBin*) self);
#line 1819 "../src/View/AbstractDirectoryView.vala"
			gtk_drag_get_data (_tmp14_, context, target, (guint32) timestamp);
#line 9853 "AbstractDirectoryView.c"
		}
	}
#line 1798 "../src/View/AbstractDirectoryView.vala"
	_gtk_target_list_unref0 (list);
#line 9858 "AbstractDirectoryView.c"
}

static gboolean
_____lambda126_ (FilesAbstractDirectoryView* self)
{
	FilesFile* _tmp0_;
	GFile* _tmp1_;
	gboolean result;
#line 1853 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->drop_target_file;
#line 1853 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_file_get_target_location (_tmp0_);
#line 1853 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_load_location (self, _tmp1_);
#line 1854 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_enter_timer_id = (guint) 0;
#line 1855 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1855 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9879 "AbstractDirectoryView.c"
}

static gboolean
______lambda126__gsource_func (gpointer self)
{
	gboolean result;
	result = _____lambda126_ ((FilesAbstractDirectoryView*) self);
#line 1849 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 9889 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_check_destination_actions_and_target_file (FilesAbstractDirectoryView* self,
                                                                         GdkDragContext* context,
                                                                         gint x,
                                                                         gint y,
                                                                         guint timestamp)
{
	const gchar* _tmp0_ = NULL;
	FilesFile* _tmp1_;
	gchar* current_uri = NULL;
	gchar* _tmp5_;
	FilesFile* _tmp6_;
	const gchar* _tmp7_ = NULL;
	FilesFile* _tmp8_;
	gchar* uri = NULL;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
#line 1824 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1824 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 1825 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->drop_target_file;
#line 1825 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ != NULL) {
#line 9918 "AbstractDirectoryView.c"
		FilesFile* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 1825 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->priv->drop_target_file;
#line 1825 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_file_get_uri (_tmp2_);
#line 1825 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = _tmp3_;
#line 1825 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp4_;
#line 9930 "AbstractDirectoryView.c"
	} else {
#line 1825 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = "";
#line 9934 "AbstractDirectoryView.c"
	}
#line 1825 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = g_strdup (_tmp0_);
#line 1825 "../src/View/AbstractDirectoryView.vala"
	current_uri = _tmp5_;
#line 1826 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = files_abstract_directory_view_get_drop_target_file (self, x, y);
#line 1826 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->drop_target_file);
#line 1826 "../src/View/AbstractDirectoryView.vala"
	self->priv->drop_target_file = _tmp6_;
#line 1827 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = self->priv->drop_target_file;
#line 1827 "../src/View/AbstractDirectoryView.vala"
	if (_tmp8_ != NULL) {
#line 9950 "AbstractDirectoryView.c"
		FilesFile* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 1827 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = self->priv->drop_target_file;
#line 1827 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = files_file_get_uri (_tmp9_);
#line 1827 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_;
#line 1827 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp11_;
#line 9962 "AbstractDirectoryView.c"
	} else {
#line 1827 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = "";
#line 9966 "AbstractDirectoryView.c"
	}
#line 1827 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = g_strdup (_tmp7_);
#line 1827 "../src/View/AbstractDirectoryView.vala"
	uri = _tmp12_;
#line 1829 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = uri;
#line 1829 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = current_uri;
#line 1829 "../src/View/AbstractDirectoryView.vala"
	if (g_strcmp0 (_tmp13_, _tmp14_) != 0) {
#line 9978 "AbstractDirectoryView.c"
		FilesFile* _tmp15_;
#line 1830 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_cancel_timeout (self, &self->priv->drag_enter_timer_id);
#line 1831 "../src/View/AbstractDirectoryView.vala"
		self->priv->current_actions = GDK_ACTION_DEFAULT;
#line 1832 "../src/View/AbstractDirectoryView.vala"
		self->priv->current_suggested_action = GDK_ACTION_DEFAULT;
#line 1834 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = self->priv->drop_target_file;
#line 1834 "../src/View/AbstractDirectoryView.vala"
		if (_tmp15_ != NULL) {
#line 9990 "AbstractDirectoryView.c"
			FilesFile* _tmp20_;
			GtkTreePath* _tmp21_;
			GtkTreePath* _tmp22_;
			gboolean _tmp23_ = FALSE;
			FilesFile* _tmp24_;
#line 1835 "../src/View/AbstractDirectoryView.vala"
			if (self->current_target_type == gdk_atom_intern_static_string ("XdndDirectSave0")) {
#line 1836 "../src/View/AbstractDirectoryView.vala"
				self->priv->current_suggested_action = GDK_ACTION_COPY;
#line 1837 "../src/View/AbstractDirectoryView.vala"
				self->priv->current_actions = self->priv->current_suggested_action;
#line 10002 "AbstractDirectoryView.c"
			} else {
				FilesFile* _tmp16_;
				GList* _tmp17_;
				GdkDragAction _tmp18_ = 0U;
				GdkDragAction _tmp19_;
#line 1840 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = self->priv->drop_target_file;
#line 1840 "../src/View/AbstractDirectoryView.vala"
				_tmp17_ = self->priv->destination_drop_file_list;
#line 1840 "../src/View/AbstractDirectoryView.vala"
				_tmp19_ = files_file_utils_file_accepts_drop (_tmp16_, _tmp17_, context, &_tmp18_);
#line 1840 "../src/View/AbstractDirectoryView.vala"
				self->priv->current_suggested_action = _tmp18_;
#line 1840 "../src/View/AbstractDirectoryView.vala"
				self->priv->current_actions = _tmp19_;
#line 10018 "AbstractDirectoryView.c"
			}
#line 1845 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = self->priv->drop_target_file;
#line 1845 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = files_abstract_directory_view_get_path_at_pos (self, x, y);
#line 1845 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = _tmp21_;
#line 1845 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_highlight_drop_file (self, _tmp20_, self->priv->current_actions, _tmp22_);
#line 1845 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (_tmp22_);
#line 1847 "../src/View/AbstractDirectoryView.vala"
			_tmp24_ = self->priv->drop_target_file;
#line 1847 "../src/View/AbstractDirectoryView.vala"
			if (files_file_is_folder (_tmp24_)) {
#line 10034 "AbstractDirectoryView.c"
				FilesFile* _tmp25_;
#line 1847 "../src/View/AbstractDirectoryView.vala"
				_tmp25_ = self->priv->drop_target_file;
#line 1847 "../src/View/AbstractDirectoryView.vala"
				_tmp23_ = files_abstract_directory_view_is_valid_drop_folder (self, _tmp25_);
#line 10040 "AbstractDirectoryView.c"
			} else {
#line 1847 "../src/View/AbstractDirectoryView.vala"
				_tmp23_ = FALSE;
#line 10044 "AbstractDirectoryView.c"
			}
#line 1847 "../src/View/AbstractDirectoryView.vala"
			if (_tmp23_) {
#line 1849 "../src/View/AbstractDirectoryView.vala"
				self->priv->drag_enter_timer_id = g_timeout_add_full (G_PRIORITY_LOW, (guint) 1000, ______lambda126__gsource_func, g_object_ref (self), g_object_unref);
#line 10050 "AbstractDirectoryView.c"
			}
		}
	}
#line 1824 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (uri);
#line 1824 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (current_uri);
#line 10058 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_is_valid_drop_folder (FilesAbstractDirectoryView* self,
                                                    FilesFile* file)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	FilesViewSlot* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean result;
#line 1862 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1862 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (file != NULL, FALSE);
#line 1864 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_file_get_uri (file);
#line 1864 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 1864 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = self->slot;
#line 1864 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = files_abstract_slot_get_uri ((FilesAbstractSlot*) _tmp4_);
#line 1864 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_;
#line 1864 "../src/View/AbstractDirectoryView.vala"
	if (g_strcmp0 (_tmp3_, _tmp6_) != 0) {
#line 10089 "AbstractDirectoryView.c"
		GList* _tmp7_;
#line 1865 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = self->source_drag_file_list;
#line 1865 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp7_ != NULL;
#line 10095 "AbstractDirectoryView.c"
	} else {
#line 1864 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = FALSE;
#line 10099 "AbstractDirectoryView.c"
	}
#line 1864 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 10103 "AbstractDirectoryView.c"
		GList* _tmp8_;
#line 1866 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = self->source_drag_file_list;
#line 1866 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = g_list_index (_tmp8_, file) < 0;
#line 10109 "AbstractDirectoryView.c"
	} else {
#line 1864 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FALSE;
#line 10113 "AbstractDirectoryView.c"
	}
#line 1864 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 1868 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 1868 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 10121 "AbstractDirectoryView.c"
	} else {
#line 1870 "../src/View/AbstractDirectoryView.vala"
		result = FALSE;
#line 1870 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 10127 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_highlight_drop_file (FilesAbstractDirectoryView* self,
                                                   FilesFile* drop_file,
                                                   GdkDragAction action,
                                                   GtkTreePath* path)
{
	gboolean can_drop = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	FilesFile* _tmp2_ = NULL;
	FilesIconRenderer* _tmp3_;
	GtkTreePath* _tmp4_ = NULL;
#line 1874 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1874 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (drop_file != NULL);
#line 1875 "../src/View/AbstractDirectoryView.vala"
	can_drop = action > GDK_ACTION_DEFAULT;
#line 1877 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_drop_highlight (self);
#line 1877 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 1877 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ != can_drop) {
#line 1878 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_drop_highlight (self, can_drop);
#line 1879 "../src/View/AbstractDirectoryView.vala"
		gtk_widget_queue_draw ((GtkWidget*) self);
#line 10159 "AbstractDirectoryView.c"
	}
#line 1883 "../src/View/AbstractDirectoryView.vala"
	if (can_drop) {
#line 1883 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = drop_file;
#line 10165 "AbstractDirectoryView.c"
	} else {
#line 1883 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = NULL;
#line 10169 "AbstractDirectoryView.c"
	}
#line 1883 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->icon_renderer;
#line 1883 "../src/View/AbstractDirectoryView.vala"
	files_icon_renderer_set_drop_file (_tmp3_, _tmp2_);
#line 1885 "../src/View/AbstractDirectoryView.vala"
	if (can_drop) {
#line 1885 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = path;
#line 10179 "AbstractDirectoryView.c"
	} else {
#line 1885 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = NULL;
#line 10183 "AbstractDirectoryView.c"
	}
#line 1885 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_highlight_path (self, _tmp4_);
#line 10187 "AbstractDirectoryView.c"
}

/** MENU FUNCTIONS */
static GdkEvent*
_vala_GdkEvent_copy (GdkEvent* self)
{
#line 1905 "../src/View/AbstractDirectoryView.vala"
	return g_boxed_copy (gdk_event_get_type (), self);
#line 10196 "AbstractDirectoryView.c"
}

static gpointer
__vala_GdkEvent_copy0 (gpointer self)
{
#line 1905 "../src/View/AbstractDirectoryView.vala"
	return self ? _vala_GdkEvent_copy (self) : NULL;
#line 10204 "AbstractDirectoryView.c"
}

static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
#line 1905 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data29_->_ref_count_);
#line 1905 "../src/View/AbstractDirectoryView.vala"
	return _data29_;
#line 10214 "AbstractDirectoryView.c"
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
#line 1905 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
#line 10224 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 1905 "../src/View/AbstractDirectoryView.vala"
		self = _data29_->self;
#line 1905 "../src/View/AbstractDirectoryView.vala"
		__vala_GdkEvent_free0 (_data29_->event);
#line 1905 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 1905 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block29Data, _data29_);
#line 10234 "AbstractDirectoryView.c"
	}
}

static gboolean
___lambda128_ (Block29Data* _data29_)
{
	FilesAbstractDirectoryView* self;
	gboolean result;
#line 1913 "../src/View/AbstractDirectoryView.vala"
	self = _data29_->self;
#line 1914 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_drag_timeout_button_release (self, (GdkEventButton*) _data29_->event);
#line 1915 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 1915 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 10251 "AbstractDirectoryView.c"
}

static gboolean
____lambda128__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda128_ (self);
#line 1911 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 10261 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_start_drag_timer (FilesAbstractDirectoryView* self,
                                                GdkEvent* event)
{
	Block29Data* _data29_;
	GdkEvent* _tmp0_;
	guint button = 0U;
	guint _tmp1_ = 0U;
	gboolean _tmp2_;
#line 1905 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1905 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (event != NULL);
#line 1905 "../src/View/AbstractDirectoryView.vala"
	_data29_ = g_slice_new0 (Block29Data);
#line 1905 "../src/View/AbstractDirectoryView.vala"
	_data29_->_ref_count_ = 1;
#line 1905 "../src/View/AbstractDirectoryView.vala"
	_data29_->self = g_object_ref (self);
#line 1905 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = __vala_GdkEvent_copy0 (event);
#line 1905 "../src/View/AbstractDirectoryView.vala"
	__vala_GdkEvent_free0 (_data29_->event);
#line 1905 "../src/View/AbstractDirectoryView.vala"
	_data29_->event = _tmp0_;
#line 1906 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_connect_drag_timeout_motion_and_release_events (self);
#line 1908 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = gdk_event_get_button (_data29_->event, &_tmp1_);
#line 1908 "../src/View/AbstractDirectoryView.vala"
	button = _tmp1_;
#line 1908 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 1909 "../src/View/AbstractDirectoryView.vala"
		self->priv->drag_button = (gint) button;
#line 1911 "../src/View/AbstractDirectoryView.vala"
		self->priv->drag_timer_id = g_timeout_add_full (G_PRIORITY_LOW, (guint) 300, ____lambda128__gsource_func, block29_data_ref (_data29_), block29_data_unref);
#line 10301 "AbstractDirectoryView.c"
	}
#line 1905 "../src/View/AbstractDirectoryView.vala"
	block29_data_unref (_data29_);
#line 1905 "../src/View/AbstractDirectoryView.vala"
	_data29_ = NULL;
#line 10307 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new7 (const gchar* value)
{
#line 1948 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 10315 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new8 (const gchar* value)
{
#line 1964 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 10323 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_show_context_menu (FilesAbstractDirectoryView* self,
                                                 GdkEvent* event)
{
	GtkMenu* menu = NULL;
	GtkMenu* _tmp0_;
	GList* selection = NULL;
	GList* _tmp1_;
	FilesFile* selected_file = NULL;
	GList* _tmp2_;
	gconstpointer _tmp3_;
	FilesFile* _tmp4_;
	GtkMenu* open_submenu = NULL;
	GtkMenu* _tmp5_;
	GSimpleActionGroup* _tmp6_;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	FilesFile* _tmp40_;
	GtkMenuItem* open_submenu_item = NULL;
	GtkMenuItem* _tmp123_;
	GtkMenu* _tmp124_;
	GList* _tmp125_;
	GList* _tmp126_;
	gboolean _tmp127_;
	GtkMenuItem* paste_menuitem = NULL;
	GtkMenuItem* _tmp137_;
	GtkMenuItem* _tmp138_;
	GtkMenuItem* bookmark_menuitem = NULL;
	GtkMenuItem* _tmp139_;
	GtkMenuItem* _tmp140_;
	GraniteAccelLabel* _tmp141_;
	GraniteAccelLabel* _tmp142_;
	GtkMenuItem* _tmp143_;
	GtkMenuItem* properties_menuitem = NULL;
	GtkMenuItem* _tmp144_;
	GtkMenuItem* _tmp145_;
	GraniteAccelLabel* _tmp146_;
	GraniteAccelLabel* _tmp147_;
	GtkMenuItem* _tmp148_;
	GtkMenuItem* select_all_menuitem = NULL;
	GtkMenuItem* deselect_all_menuitem = NULL;
	GtkMenuItem* invert_selection_menuitem = NULL;
	GList* _tmp174_;
	GtkMenu* _tmp420_;
	GtkMenu* _tmp421_;
	FilesViewSlot* _tmp422_;
	FilesDirectory* _tmp423_;
	FilesDirectory* _tmp424_;
	GtkMenu* _tmp427_;
	GtkMenu* _tmp428_;
#line 1920 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 1920 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (event != NULL);
#line 1921 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_drag_timer (self);
#line 1923 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_menu_actions (self);
#line 1925 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
#line 1925 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp0_);
#line 1925 "../src/View/AbstractDirectoryView.vala"
	menu = _tmp0_;
#line 1927 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_files_for_action (self);
#line 1927 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp1_;
#line 1928 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = selection;
#line 1928 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_->data;
#line 1928 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _g_object_ref0 ((FilesFile*) _tmp3_);
#line 1928 "../src/View/AbstractDirectoryView.vala"
	selected_file = _tmp4_;
#line 1930 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = (GtkMenu*) gtk_menu_new ();
#line 1930 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp5_);
#line 1930 "../src/View/AbstractDirectoryView.vala"
	open_submenu = _tmp5_;
#line 1932 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = self->priv->common_actions;
#line 1932 "../src/View/AbstractDirectoryView.vala"
	if (g_action_group_get_action_enabled ((GActionGroup*) _tmp6_, "open-in")) {
#line 10412 "AbstractDirectoryView.c"
		GtkMenuItem* new_tab_menuitem = NULL;
		GtkMenuItem* _tmp7_;
		GList* _tmp8_;
		GtkMenuItem* _tmp17_;
		GVariant* _tmp18_;
		GtkMenuItem* new_window_menuitem = NULL;
		GtkMenuItem* _tmp19_;
		GList* _tmp20_;
		GtkMenuItem* _tmp29_;
		GVariant* _tmp30_;
		GtkMenu* _tmp31_;
		GtkMenuItem* _tmp32_;
		GtkMenu* _tmp33_;
		GtkMenuItem* _tmp34_;
		GtkMenu* _tmp35_;
		GtkSeparatorMenuItem* _tmp36_;
		GtkSeparatorMenuItem* _tmp37_;
#line 1933 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1933 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp7_);
#line 1933 "../src/View/AbstractDirectoryView.vala"
		new_tab_menuitem = _tmp7_;
#line 1934 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = self->selected_files;
#line 1934 "../src/View/AbstractDirectoryView.vala"
		if (_tmp8_ != NULL) {
#line 10440 "AbstractDirectoryView.c"
			GtkMenuItem* _tmp9_;
			GraniteAccelLabel* _tmp10_;
			GraniteAccelLabel* _tmp11_;
			GtkMenuItem* _tmp12_;
#line 1935 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = new_tab_menuitem;
#line 1935 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = granite_accel_label_new (_ ("New Tab"), "<Shift>Return");
#line 1935 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp10_);
#line 1935 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = _tmp10_;
#line 1935 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp9_, (GtkWidget*) _tmp11_);
#line 1935 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp11_);
#line 1939 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = new_tab_menuitem;
#line 1939 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp12_, "common.open-in");
#line 10461 "AbstractDirectoryView.c"
		} else {
			GtkMenuItem* _tmp13_;
			GraniteAccelLabel* _tmp14_;
			GraniteAccelLabel* _tmp15_;
			GtkMenuItem* _tmp16_;
#line 1941 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = new_tab_menuitem;
#line 1941 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = granite_accel_label_new_from_action_name (_ ("New Tab"), "win.tab::TAB");
#line 1941 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp14_);
#line 1941 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = _tmp14_;
#line 1941 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp13_, (GtkWidget*) _tmp15_);
#line 1941 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp15_);
#line 1945 "../src/View/AbstractDirectoryView.vala"
			_tmp16_ = new_tab_menuitem;
#line 1945 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp16_, "win.tab");
#line 10483 "AbstractDirectoryView.c"
		}
#line 1948 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = new_tab_menuitem;
#line 1948 "../src/View/AbstractDirectoryView.vala"
		_tmp18_ = _variant_new7 ("TAB");
#line 1948 "../src/View/AbstractDirectoryView.vala"
		g_object_set ((GtkActionable*) _tmp17_, "action-target", _tmp18_, NULL);
#line 1948 "../src/View/AbstractDirectoryView.vala"
		_g_variant_unref0 (_tmp18_);
#line 1950 "../src/View/AbstractDirectoryView.vala"
		_tmp19_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1950 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp19_);
#line 1950 "../src/View/AbstractDirectoryView.vala"
		new_window_menuitem = _tmp19_;
#line 1951 "../src/View/AbstractDirectoryView.vala"
		_tmp20_ = self->selected_files;
#line 1951 "../src/View/AbstractDirectoryView.vala"
		if (_tmp20_ != NULL) {
#line 10503 "AbstractDirectoryView.c"
			GtkMenuItem* _tmp21_;
			GraniteAccelLabel* _tmp22_;
			GraniteAccelLabel* _tmp23_;
			GtkMenuItem* _tmp24_;
#line 1952 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = new_window_menuitem;
#line 1952 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = granite_accel_label_new (_ ("New Window"), "<Shift><Ctrl>Return");
#line 1952 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp22_);
#line 1952 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = _tmp22_;
#line 1952 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp21_, (GtkWidget*) _tmp23_);
#line 1952 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp23_);
#line 1956 "../src/View/AbstractDirectoryView.vala"
			_tmp24_ = new_window_menuitem;
#line 1956 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp24_, "common.open-in");
#line 10524 "AbstractDirectoryView.c"
		} else {
			GtkMenuItem* _tmp25_;
			GraniteAccelLabel* _tmp26_;
			GraniteAccelLabel* _tmp27_;
			GtkMenuItem* _tmp28_;
#line 1958 "../src/View/AbstractDirectoryView.vala"
			_tmp25_ = new_window_menuitem;
#line 1958 "../src/View/AbstractDirectoryView.vala"
			_tmp26_ = granite_accel_label_new_from_action_name (_ ("New Window"), "win.tab::WINDOW");
#line 1958 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp26_);
#line 1958 "../src/View/AbstractDirectoryView.vala"
			_tmp27_ = _tmp26_;
#line 1958 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp25_, (GtkWidget*) _tmp27_);
#line 1958 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp27_);
#line 1962 "../src/View/AbstractDirectoryView.vala"
			_tmp28_ = new_window_menuitem;
#line 1962 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp28_, "win.tab");
#line 10546 "AbstractDirectoryView.c"
		}
#line 1964 "../src/View/AbstractDirectoryView.vala"
		_tmp29_ = new_window_menuitem;
#line 1964 "../src/View/AbstractDirectoryView.vala"
		_tmp30_ = _variant_new8 ("WINDOW");
#line 1964 "../src/View/AbstractDirectoryView.vala"
		g_object_set ((GtkActionable*) _tmp29_, "action-target", _tmp30_, NULL);
#line 1964 "../src/View/AbstractDirectoryView.vala"
		_g_variant_unref0 (_tmp30_);
#line 1966 "../src/View/AbstractDirectoryView.vala"
		_tmp31_ = open_submenu;
#line 1966 "../src/View/AbstractDirectoryView.vala"
		_tmp32_ = new_tab_menuitem;
#line 1966 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp31_, (GtkWidget*) _tmp32_);
#line 1967 "../src/View/AbstractDirectoryView.vala"
		_tmp33_ = open_submenu;
#line 1967 "../src/View/AbstractDirectoryView.vala"
		_tmp34_ = new_window_menuitem;
#line 1967 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp34_);
#line 1968 "../src/View/AbstractDirectoryView.vala"
		_tmp35_ = open_submenu;
#line 1968 "../src/View/AbstractDirectoryView.vala"
		_tmp36_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 1968 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp36_);
#line 1968 "../src/View/AbstractDirectoryView.vala"
		_tmp37_ = _tmp36_;
#line 1968 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) _tmp37_);
#line 1968 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp37_);
#line 1932 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (new_window_menuitem);
#line 1932 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (new_tab_menuitem);
#line 10584 "AbstractDirectoryView.c"
	}
#line 1971 "../src/View/AbstractDirectoryView.vala"
	_tmp40_ = selected_file;
#line 1971 "../src/View/AbstractDirectoryView.vala"
	if (!files_file_is_mountable (_tmp40_)) {
#line 10590 "AbstractDirectoryView.c"
		FilesFile* _tmp41_;
#line 1972 "../src/View/AbstractDirectoryView.vala"
		_tmp41_ = selected_file;
#line 1972 "../src/View/AbstractDirectoryView.vala"
		_tmp39_ = !files_file_is_root_network_folder (_tmp41_);
#line 10596 "AbstractDirectoryView.c"
	} else {
#line 1971 "../src/View/AbstractDirectoryView.vala"
		_tmp39_ = FALSE;
#line 10600 "AbstractDirectoryView.c"
	}
#line 1971 "../src/View/AbstractDirectoryView.vala"
	if (_tmp39_) {
#line 10604 "AbstractDirectoryView.c"
		FilesFile* _tmp42_;
#line 1973 "../src/View/AbstractDirectoryView.vala"
		_tmp42_ = selected_file;
#line 1973 "../src/View/AbstractDirectoryView.vala"
		_tmp38_ = files_abstract_directory_view_can_open_file (self, _tmp42_, FALSE);
#line 10610 "AbstractDirectoryView.c"
	} else {
#line 1971 "../src/View/AbstractDirectoryView.vala"
		_tmp38_ = FALSE;
#line 10614 "AbstractDirectoryView.c"
	}
#line 1971 "../src/View/AbstractDirectoryView.vala"
	if (_tmp38_) {
#line 10618 "AbstractDirectoryView.c"
		gboolean _tmp43_ = FALSE;
		FilesFile* _tmp44_;
		GList* _tmp65_;
		GList* _tmp66_;
		FilesFile* _tmp67_;
		gboolean _tmp68_ = FALSE;
		GList* _tmp69_;
		gboolean _tmp114_ = FALSE;
		GList* _tmp115_;
#line 1975 "../src/View/AbstractDirectoryView.vala"
		_tmp44_ = selected_file;
#line 1975 "../src/View/AbstractDirectoryView.vala"
		if (!files_file_is_folder (_tmp44_)) {
#line 10632 "AbstractDirectoryView.c"
			FilesFile* _tmp45_;
#line 1975 "../src/View/AbstractDirectoryView.vala"
			_tmp45_ = selected_file;
#line 1975 "../src/View/AbstractDirectoryView.vala"
			_tmp43_ = files_file_is_executable (_tmp45_);
#line 10638 "AbstractDirectoryView.c"
		} else {
#line 1975 "../src/View/AbstractDirectoryView.vala"
			_tmp43_ = FALSE;
#line 10642 "AbstractDirectoryView.c"
		}
#line 1975 "../src/View/AbstractDirectoryView.vala"
		if (_tmp43_) {
#line 10646 "AbstractDirectoryView.c"
			GtkMenuItem* run_menuitem = NULL;
			GtkMenuItem* _tmp46_;
			GtkMenuItem* _tmp47_;
			GtkMenu* _tmp48_;
			GtkMenuItem* _tmp49_;
#line 1976 "../src/View/AbstractDirectoryView.vala"
			_tmp46_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Run"));
#line 1976 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp46_);
#line 1976 "../src/View/AbstractDirectoryView.vala"
			run_menuitem = _tmp46_;
#line 1977 "../src/View/AbstractDirectoryView.vala"
			_tmp47_ = run_menuitem;
#line 1977 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp47_, "selection.open");
#line 1979 "../src/View/AbstractDirectoryView.vala"
			_tmp48_ = menu;
#line 1979 "../src/View/AbstractDirectoryView.vala"
			_tmp49_ = run_menuitem;
#line 1979 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp48_, (GtkWidget*) _tmp49_);
#line 1975 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (run_menuitem);
#line 10670 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp50_ = FALSE;
			GAppInfo* _tmp51_;
#line 1980 "../src/View/AbstractDirectoryView.vala"
			_tmp51_ = self->priv->default_app;
#line 1980 "../src/View/AbstractDirectoryView.vala"
			if (_tmp51_ != NULL) {
#line 10678 "AbstractDirectoryView.c"
				GAppInfo* _tmp52_;
				const gchar* _tmp53_;
#line 1980 "../src/View/AbstractDirectoryView.vala"
				_tmp52_ = self->priv->default_app;
#line 1980 "../src/View/AbstractDirectoryView.vala"
				_tmp53_ = g_app_info_get_id (_tmp52_);
#line 1980 "../src/View/AbstractDirectoryView.vala"
				_tmp50_ = g_strcmp0 (_tmp53_, FILES_APP_ID ".desktop") != 0;
#line 10687 "AbstractDirectoryView.c"
			} else {
#line 1980 "../src/View/AbstractDirectoryView.vala"
				_tmp50_ = FALSE;
#line 10691 "AbstractDirectoryView.c"
			}
#line 1980 "../src/View/AbstractDirectoryView.vala"
			if (_tmp50_) {
#line 10695 "AbstractDirectoryView.c"
				GtkMenuItem* open_menuitem = NULL;
				GtkMenuItem* _tmp54_;
				GtkMenuItem* _tmp55_;
				GAppInfo* _tmp56_;
				const gchar* _tmp57_;
				gchar* _tmp58_;
				gchar* _tmp59_;
				GraniteAccelLabel* _tmp60_;
				GraniteAccelLabel* _tmp61_;
				GtkMenuItem* _tmp62_;
				GtkMenu* _tmp63_;
				GtkMenuItem* _tmp64_;
#line 1981 "../src/View/AbstractDirectoryView.vala"
				_tmp54_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 1981 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp54_);
#line 1981 "../src/View/AbstractDirectoryView.vala"
				open_menuitem = _tmp54_;
#line 1982 "../src/View/AbstractDirectoryView.vala"
				_tmp55_ = open_menuitem;
#line 1982 "../src/View/AbstractDirectoryView.vala"
				_tmp56_ = self->priv->default_app;
#line 1982 "../src/View/AbstractDirectoryView.vala"
				_tmp57_ = g_app_info_get_display_name (_tmp56_);
#line 1982 "../src/View/AbstractDirectoryView.vala"
				_tmp58_ = g_strdup_printf (_ ("Open in %s"), _tmp57_);
#line 1982 "../src/View/AbstractDirectoryView.vala"
				_tmp59_ = _tmp58_;
#line 1982 "../src/View/AbstractDirectoryView.vala"
				_tmp60_ = granite_accel_label_new (_tmp59_, "Return");
#line 1982 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp60_);
#line 1982 "../src/View/AbstractDirectoryView.vala"
				_tmp61_ = _tmp60_;
#line 1982 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp61_);
#line 1982 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp61_);
#line 1982 "../src/View/AbstractDirectoryView.vala"
				_g_free0 (_tmp59_);
#line 1986 "../src/View/AbstractDirectoryView.vala"
				_tmp62_ = open_menuitem;
#line 1986 "../src/View/AbstractDirectoryView.vala"
				gtk_actionable_set_action_name ((GtkActionable*) _tmp62_, "selection.open-with-default");
#line 1988 "../src/View/AbstractDirectoryView.vala"
				_tmp63_ = menu;
#line 1988 "../src/View/AbstractDirectoryView.vala"
				_tmp64_ = open_menuitem;
#line 1988 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp63_, (GtkWidget*) _tmp64_);
#line 1980 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (open_menuitem);
#line 10748 "AbstractDirectoryView.c"
			}
		}
#line 1991 "../src/View/AbstractDirectoryView.vala"
		_tmp65_ = selection;
#line 1991 "../src/View/AbstractDirectoryView.vala"
		_tmp66_ = files_mime_actions_get_applications_for_files (_tmp65_);
#line 1991 "../src/View/AbstractDirectoryView.vala"
		(self->priv->open_with_apps == NULL) ? NULL : (self->priv->open_with_apps = (_g_list_free__g_object_unref0_ (self->priv->open_with_apps), NULL));
#line 1991 "../src/View/AbstractDirectoryView.vala"
		self->priv->open_with_apps = _tmp66_;
#line 1993 "../src/View/AbstractDirectoryView.vala"
		_tmp67_ = selected_file;
#line 1993 "../src/View/AbstractDirectoryView.vala"
		if (files_file_is_executable (_tmp67_) == FALSE) {
#line 1994 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_filter_default_app_from_open_with_apps (self);
#line 10765 "AbstractDirectoryView.c"
		}
#line 1997 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_filter_this_app_from_open_with_apps (self);
#line 1999 "../src/View/AbstractDirectoryView.vala"
		_tmp69_ = self->priv->open_with_apps;
#line 1999 "../src/View/AbstractDirectoryView.vala"
		if (_tmp69_ != NULL) {
#line 10773 "AbstractDirectoryView.c"
			GList* _tmp70_;
			gconstpointer _tmp71_;
#line 1999 "../src/View/AbstractDirectoryView.vala"
			_tmp70_ = self->priv->open_with_apps;
#line 1999 "../src/View/AbstractDirectoryView.vala"
			_tmp71_ = _tmp70_->data;
#line 1999 "../src/View/AbstractDirectoryView.vala"
			_tmp68_ = ((GAppInfo*) _tmp71_) != NULL;
#line 10782 "AbstractDirectoryView.c"
		} else {
#line 1999 "../src/View/AbstractDirectoryView.vala"
			_tmp68_ = FALSE;
#line 10786 "AbstractDirectoryView.c"
		}
#line 1999 "../src/View/AbstractDirectoryView.vala"
		if (_tmp68_) {
#line 10790 "AbstractDirectoryView.c"
			const gchar* last_label = NULL;
			const gchar* last_exec = NULL;
			guint count = 0U;
			GList* _tmp72_;
#line 2000 "../src/View/AbstractDirectoryView.vala"
			last_label = "";
#line 2001 "../src/View/AbstractDirectoryView.vala"
			last_exec = "";
#line 2002 "../src/View/AbstractDirectoryView.vala"
			count = (guint) 0;
#line 2004 "../src/View/AbstractDirectoryView.vala"
			_tmp72_ = self->priv->open_with_apps;
#line 10803 "AbstractDirectoryView.c"
			{
				GList* app_info_collection = NULL;
				GList* app_info_it = NULL;
#line 2004 "../src/View/AbstractDirectoryView.vala"
				app_info_collection = _tmp72_;
#line 2004 "../src/View/AbstractDirectoryView.vala"
				for (app_info_it = app_info_collection; app_info_it != NULL; app_info_it = app_info_it->next) {
#line 10811 "AbstractDirectoryView.c"
					GAppInfo* app_info = NULL;
#line 2004 "../src/View/AbstractDirectoryView.vala"
					app_info = (GAppInfo*) app_info_it->data;
#line 10815 "AbstractDirectoryView.c"
					{
						const gchar* label = NULL;
						GAppInfo* _tmp73_;
						const gchar* _tmp74_;
						const gchar* exec = NULL;
						GAppInfo* _tmp75_;
						const gchar* _tmp76_;
						gchar** _tmp77_;
						gchar** _tmp78_;
						gchar** _tmp79_;
						gint _tmp79__length1;
						const gchar* _tmp80_;
						const gchar* _tmp81_;
						gboolean _tmp82_ = FALSE;
						const gchar* _tmp83_;
						const gchar* _tmp84_;
						const gchar* _tmp108_;
						const gchar* _tmp109_;
						guint _tmp110_;
#line 2006 "../src/View/AbstractDirectoryView.vala"
						_tmp73_ = app_info;
#line 2006 "../src/View/AbstractDirectoryView.vala"
						_tmp74_ = g_app_info_get_display_name (_tmp73_);
#line 2006 "../src/View/AbstractDirectoryView.vala"
						label = _tmp74_;
#line 2007 "../src/View/AbstractDirectoryView.vala"
						_tmp75_ = app_info;
#line 2007 "../src/View/AbstractDirectoryView.vala"
						_tmp76_ = g_app_info_get_executable (_tmp75_);
#line 2007 "../src/View/AbstractDirectoryView.vala"
						_tmp78_ = _tmp77_ = g_strsplit (_tmp76_, " ", 0);
#line 2007 "../src/View/AbstractDirectoryView.vala"
						_tmp79_ = _tmp78_;
#line 2007 "../src/View/AbstractDirectoryView.vala"
						_tmp79__length1 = _vala_array_length (_tmp77_);
#line 2007 "../src/View/AbstractDirectoryView.vala"
						_tmp80_ = _tmp79_[0];
#line 2007 "../src/View/AbstractDirectoryView.vala"
						_tmp81_ = _tmp80_;
#line 2007 "../src/View/AbstractDirectoryView.vala"
						_tmp79_ = (_vala_array_free (_tmp79_, _tmp79__length1, (GDestroyNotify) g_free), NULL);
#line 2007 "../src/View/AbstractDirectoryView.vala"
						exec = _tmp81_;
#line 2008 "../src/View/AbstractDirectoryView.vala"
						_tmp83_ = label;
#line 2008 "../src/View/AbstractDirectoryView.vala"
						_tmp84_ = last_label;
#line 2008 "../src/View/AbstractDirectoryView.vala"
						if (g_strcmp0 (_tmp83_, _tmp84_) != 0) {
#line 2008 "../src/View/AbstractDirectoryView.vala"
							_tmp82_ = TRUE;
#line 10867 "AbstractDirectoryView.c"
						} else {
							const gchar* _tmp85_;
							const gchar* _tmp86_;
#line 2008 "../src/View/AbstractDirectoryView.vala"
							_tmp85_ = exec;
#line 2008 "../src/View/AbstractDirectoryView.vala"
							_tmp86_ = last_exec;
#line 2008 "../src/View/AbstractDirectoryView.vala"
							_tmp82_ = g_strcmp0 (_tmp85_, _tmp86_) != 0;
#line 10877 "AbstractDirectoryView.c"
						}
#line 2008 "../src/View/AbstractDirectoryView.vala"
						if (_tmp82_) {
#line 10881 "AbstractDirectoryView.c"
							GtkImage* app_image = NULL;
							GAppInfo* _tmp87_;
							GIcon* _tmp88_;
							GtkImage* _tmp89_;
							GtkImage* _tmp90_;
							GtkGrid* label_grid = NULL;
							GtkGrid* _tmp91_;
							GtkGrid* _tmp92_;
							GtkImage* _tmp93_;
							GtkGrid* _tmp94_;
							const gchar* _tmp95_;
							GtkLabel* _tmp96_;
							GtkLabel* _tmp97_;
							GtkMenuItem* menuitem = NULL;
							GtkMenuItem* _tmp98_;
							GtkMenuItem* _tmp99_;
							GtkGrid* _tmp100_;
							GtkMenuItem* _tmp101_;
							GVariant* _tmp102_;
							GVariant* _tmp103_;
							gchar* _tmp104_;
							gchar* _tmp105_;
							GtkMenu* _tmp106_;
							GtkMenuItem* _tmp107_;
#line 2009 "../src/View/AbstractDirectoryView.vala"
							_tmp87_ = app_info;
#line 2009 "../src/View/AbstractDirectoryView.vala"
							_tmp88_ = g_app_info_get_icon (_tmp87_);
#line 2009 "../src/View/AbstractDirectoryView.vala"
							_tmp89_ = (GtkImage*) gtk_image_new_from_gicon (_tmp88_, (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 2009 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp89_);
#line 2009 "../src/View/AbstractDirectoryView.vala"
							app_image = _tmp89_;
#line 2013 "../src/View/AbstractDirectoryView.vala"
							_tmp90_ = app_image;
#line 2013 "../src/View/AbstractDirectoryView.vala"
							gtk_image_set_pixel_size (_tmp90_, 16);
#line 2015 "../src/View/AbstractDirectoryView.vala"
							_tmp91_ = (GtkGrid*) gtk_grid_new ();
#line 2015 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp91_);
#line 2015 "../src/View/AbstractDirectoryView.vala"
							label_grid = _tmp91_;
#line 2016 "../src/View/AbstractDirectoryView.vala"
							_tmp92_ = label_grid;
#line 2016 "../src/View/AbstractDirectoryView.vala"
							_tmp93_ = app_image;
#line 2016 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp92_, (GtkWidget*) _tmp93_);
#line 2017 "../src/View/AbstractDirectoryView.vala"
							_tmp94_ = label_grid;
#line 2017 "../src/View/AbstractDirectoryView.vala"
							_tmp95_ = label;
#line 2017 "../src/View/AbstractDirectoryView.vala"
							_tmp96_ = (GtkLabel*) gtk_label_new (_tmp95_);
#line 2017 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp96_);
#line 2017 "../src/View/AbstractDirectoryView.vala"
							_tmp97_ = _tmp96_;
#line 2017 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp94_, (GtkWidget*) _tmp97_);
#line 2017 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp97_);
#line 2019 "../src/View/AbstractDirectoryView.vala"
							_tmp98_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2019 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp98_);
#line 2019 "../src/View/AbstractDirectoryView.vala"
							menuitem = _tmp98_;
#line 2020 "../src/View/AbstractDirectoryView.vala"
							_tmp99_ = menuitem;
#line 2020 "../src/View/AbstractDirectoryView.vala"
							_tmp100_ = label_grid;
#line 2020 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp99_, (GtkWidget*) _tmp100_);
#line 2021 "../src/View/AbstractDirectoryView.vala"
							_tmp101_ = menuitem;
#line 2021 "../src/View/AbstractDirectoryView.vala"
							_tmp102_ = g_variant_new_uint32 ((guint32) count);
#line 2021 "../src/View/AbstractDirectoryView.vala"
							g_variant_ref_sink (_tmp102_);
#line 2021 "../src/View/AbstractDirectoryView.vala"
							_tmp103_ = _tmp102_;
#line 2021 "../src/View/AbstractDirectoryView.vala"
							_tmp104_ = g_action_print_detailed_name ("selection.open-with-app", _tmp103_);
#line 2021 "../src/View/AbstractDirectoryView.vala"
							_tmp105_ = _tmp104_;
#line 2021 "../src/View/AbstractDirectoryView.vala"
							gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp101_, _tmp105_);
#line 2021 "../src/View/AbstractDirectoryView.vala"
							_g_free0 (_tmp105_);
#line 2021 "../src/View/AbstractDirectoryView.vala"
							_g_variant_unref0 (_tmp103_);
#line 2026 "../src/View/AbstractDirectoryView.vala"
							_tmp106_ = open_submenu;
#line 2026 "../src/View/AbstractDirectoryView.vala"
							_tmp107_ = menuitem;
#line 2026 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp106_, (GtkWidget*) _tmp107_);
#line 2008 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (menuitem);
#line 2008 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (label_grid);
#line 2008 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (app_image);
#line 10988 "AbstractDirectoryView.c"
						}
#line 2029 "../src/View/AbstractDirectoryView.vala"
						_tmp108_ = label;
#line 2029 "../src/View/AbstractDirectoryView.vala"
						last_label = _tmp108_;
#line 2030 "../src/View/AbstractDirectoryView.vala"
						_tmp109_ = exec;
#line 2030 "../src/View/AbstractDirectoryView.vala"
						last_exec = _tmp109_;
#line 2031 "../src/View/AbstractDirectoryView.vala"
						_tmp110_ = count;
#line 2031 "../src/View/AbstractDirectoryView.vala"
						count = _tmp110_ + 1;
#line 11002 "AbstractDirectoryView.c"
					}
				}
			}
#line 2034 "../src/View/AbstractDirectoryView.vala"
			if (count > ((guint) 0)) {
#line 11008 "AbstractDirectoryView.c"
				GtkMenu* _tmp111_;
				GtkSeparatorMenuItem* _tmp112_;
				GtkSeparatorMenuItem* _tmp113_;
#line 2035 "../src/View/AbstractDirectoryView.vala"
				_tmp111_ = open_submenu;
#line 2035 "../src/View/AbstractDirectoryView.vala"
				_tmp112_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2035 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp112_);
#line 2035 "../src/View/AbstractDirectoryView.vala"
				_tmp113_ = _tmp112_;
#line 2035 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp111_, (GtkWidget*) _tmp113_);
#line 2035 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp113_);
#line 11024 "AbstractDirectoryView.c"
			}
		}
#line 2039 "../src/View/AbstractDirectoryView.vala"
		_tmp115_ = selection;
#line 2039 "../src/View/AbstractDirectoryView.vala"
		if (_tmp115_ != NULL) {
#line 11031 "AbstractDirectoryView.c"
			GList* _tmp116_;
			GList* _tmp117_;
			GList* _tmp118_;
#line 2039 "../src/View/AbstractDirectoryView.vala"
			_tmp116_ = selection;
#line 2039 "../src/View/AbstractDirectoryView.vala"
			_tmp117_ = g_list_first (_tmp116_);
#line 2039 "../src/View/AbstractDirectoryView.vala"
			_tmp118_ = _tmp117_->next;
#line 2039 "../src/View/AbstractDirectoryView.vala"
			_tmp114_ = _tmp118_ == NULL;
#line 11043 "AbstractDirectoryView.c"
		} else {
#line 2039 "../src/View/AbstractDirectoryView.vala"
			_tmp114_ = FALSE;
#line 11047 "AbstractDirectoryView.c"
		}
#line 2039 "../src/View/AbstractDirectoryView.vala"
		if (_tmp114_) {
#line 11051 "AbstractDirectoryView.c"
			GtkMenuItem* other_apps_menuitem = NULL;
			GtkMenuItem* _tmp119_;
			GtkMenuItem* _tmp120_;
			GtkMenu* _tmp121_;
			GtkMenuItem* _tmp122_;
#line 2040 "../src/View/AbstractDirectoryView.vala"
			_tmp119_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Other Application…"));
#line 2040 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp119_);
#line 2040 "../src/View/AbstractDirectoryView.vala"
			other_apps_menuitem = _tmp119_;
#line 2041 "../src/View/AbstractDirectoryView.vala"
			_tmp120_ = other_apps_menuitem;
#line 2041 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp120_, "selection.open-with-other-app");
#line 2043 "../src/View/AbstractDirectoryView.vala"
			_tmp121_ = open_submenu;
#line 2043 "../src/View/AbstractDirectoryView.vala"
			_tmp122_ = other_apps_menuitem;
#line 2043 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp121_, (GtkWidget*) _tmp122_);
#line 2039 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (other_apps_menuitem);
#line 11075 "AbstractDirectoryView.c"
		}
	}
#line 2047 "../src/View/AbstractDirectoryView.vala"
	_tmp123_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2047 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp123_);
#line 2047 "../src/View/AbstractDirectoryView.vala"
	open_submenu_item = _tmp123_;
#line 2048 "../src/View/AbstractDirectoryView.vala"
	_tmp124_ = open_submenu;
#line 2048 "../src/View/AbstractDirectoryView.vala"
	_tmp125_ = gtk_container_get_children ((GtkContainer*) _tmp124_);
#line 2048 "../src/View/AbstractDirectoryView.vala"
	_tmp126_ = _tmp125_;
#line 2048 "../src/View/AbstractDirectoryView.vala"
	_tmp127_ = g_list_length (_tmp126_) > ((guint) 0);
#line 2048 "../src/View/AbstractDirectoryView.vala"
	(_tmp126_ == NULL) ? NULL : (_tmp126_ = (g_list_free (_tmp126_), NULL));
#line 2048 "../src/View/AbstractDirectoryView.vala"
	if (_tmp127_) {
#line 11096 "AbstractDirectoryView.c"
		GtkMenuItem* _tmp128_;
		GtkMenu* _tmp129_;
		gboolean _tmp130_ = FALSE;
		FilesFile* _tmp131_;
		GtkMenu* _tmp135_;
		GtkMenuItem* _tmp136_;
#line 2049 "../src/View/AbstractDirectoryView.vala"
		_tmp128_ = open_submenu_item;
#line 2049 "../src/View/AbstractDirectoryView.vala"
		_tmp129_ = open_submenu;
#line 2049 "../src/View/AbstractDirectoryView.vala"
		gtk_menu_item_set_submenu (_tmp128_, _tmp129_);
#line 2051 "../src/View/AbstractDirectoryView.vala"
		_tmp131_ = selected_file;
#line 2051 "../src/View/AbstractDirectoryView.vala"
		if (files_file_is_folder (_tmp131_)) {
#line 2051 "../src/View/AbstractDirectoryView.vala"
			_tmp130_ = TRUE;
#line 11115 "AbstractDirectoryView.c"
		} else {
			FilesFile* _tmp132_;
#line 2051 "../src/View/AbstractDirectoryView.vala"
			_tmp132_ = selected_file;
#line 2051 "../src/View/AbstractDirectoryView.vala"
			_tmp130_ = files_file_is_root_network_folder (_tmp132_);
#line 11122 "AbstractDirectoryView.c"
		}
#line 2051 "../src/View/AbstractDirectoryView.vala"
		if (_tmp130_) {
#line 11126 "AbstractDirectoryView.c"
			GtkMenuItem* _tmp133_;
#line 2052 "../src/View/AbstractDirectoryView.vala"
			_tmp133_ = open_submenu_item;
#line 2052 "../src/View/AbstractDirectoryView.vala"
			gtk_menu_item_set_label (_tmp133_, _ ("Open in"));
#line 11132 "AbstractDirectoryView.c"
		} else {
			GtkMenuItem* _tmp134_;
#line 2054 "../src/View/AbstractDirectoryView.vala"
			_tmp134_ = open_submenu_item;
#line 2054 "../src/View/AbstractDirectoryView.vala"
			gtk_menu_item_set_label (_tmp134_, _ ("Open with"));
#line 11139 "AbstractDirectoryView.c"
		}
#line 2057 "../src/View/AbstractDirectoryView.vala"
		_tmp135_ = menu;
#line 2057 "../src/View/AbstractDirectoryView.vala"
		_tmp136_ = open_submenu_item;
#line 2057 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp135_, (GtkWidget*) _tmp136_);
#line 11147 "AbstractDirectoryView.c"
	}
#line 2060 "../src/View/AbstractDirectoryView.vala"
	_tmp137_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2060 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp137_);
#line 2060 "../src/View/AbstractDirectoryView.vala"
	paste_menuitem = _tmp137_;
#line 2061 "../src/View/AbstractDirectoryView.vala"
	_tmp138_ = paste_menuitem;
#line 2061 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp138_, "common.paste");
#line 2063 "../src/View/AbstractDirectoryView.vala"
	_tmp139_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2063 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp139_);
#line 2063 "../src/View/AbstractDirectoryView.vala"
	bookmark_menuitem = _tmp139_;
#line 2064 "../src/View/AbstractDirectoryView.vala"
	_tmp140_ = bookmark_menuitem;
#line 2064 "../src/View/AbstractDirectoryView.vala"
	_tmp141_ = granite_accel_label_new (_ ("Add to Bookmarks"), "<Ctrl>d");
#line 2064 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp141_);
#line 2064 "../src/View/AbstractDirectoryView.vala"
	_tmp142_ = _tmp141_;
#line 2064 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp140_, (GtkWidget*) _tmp142_);
#line 2064 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp142_);
#line 2068 "../src/View/AbstractDirectoryView.vala"
	_tmp143_ = bookmark_menuitem;
#line 2068 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp143_, "common.bookmark");
#line 2070 "../src/View/AbstractDirectoryView.vala"
	_tmp144_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2070 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp144_);
#line 2070 "../src/View/AbstractDirectoryView.vala"
	properties_menuitem = _tmp144_;
#line 2071 "../src/View/AbstractDirectoryView.vala"
	_tmp145_ = properties_menuitem;
#line 2071 "../src/View/AbstractDirectoryView.vala"
	_tmp146_ = granite_accel_label_new (_ ("Properties"), "<Alt>Return");
#line 2071 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp146_);
#line 2071 "../src/View/AbstractDirectoryView.vala"
	_tmp147_ = _tmp146_;
#line 2071 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp145_, (GtkWidget*) _tmp147_);
#line 2071 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp147_);
#line 2075 "../src/View/AbstractDirectoryView.vala"
	_tmp148_ = properties_menuitem;
#line 2075 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp148_, "common.properties");
#line 2077 "../src/View/AbstractDirectoryView.vala"
	select_all_menuitem = NULL;
#line 2078 "../src/View/AbstractDirectoryView.vala"
	deselect_all_menuitem = NULL;
#line 2079 "../src/View/AbstractDirectoryView.vala"
	invert_selection_menuitem = NULL;
#line 2080 "../src/View/AbstractDirectoryView.vala"
	if (!self->priv->all_selected) {
#line 11211 "AbstractDirectoryView.c"
		gchar* _tmp149_;
		GtkMenuItem* _tmp150_ = NULL;
		GtkMenuItem* _tmp151_;
		GtkMenuItem* _tmp152_;
		const gchar* _tmp153_;
		const gchar* _tmp154_;
		GraniteAccelLabel* _tmp155_;
		GraniteAccelLabel* _tmp156_;
		GList* _tmp157_;
#line 2081 "../src/View/AbstractDirectoryView.vala"
		_tmp149_ = g_strdup ("common.select-all");
#line 2081 "../src/View/AbstractDirectoryView.vala"
		_tmp150_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2081 "../src/View/AbstractDirectoryView.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp150_, _tmp149_);
#line 2081 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (_tmp149_);
#line 2081 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp150_);
#line 2081 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (select_all_menuitem);
#line 2081 "../src/View/AbstractDirectoryView.vala"
		select_all_menuitem = _tmp150_;
#line 2084 "../src/View/AbstractDirectoryView.vala"
		_tmp151_ = select_all_menuitem;
#line 2084 "../src/View/AbstractDirectoryView.vala"
		_tmp152_ = select_all_menuitem;
#line 2084 "../src/View/AbstractDirectoryView.vala"
		_tmp153_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp152_);
#line 2084 "../src/View/AbstractDirectoryView.vala"
		_tmp154_ = _tmp153_;
#line 2084 "../src/View/AbstractDirectoryView.vala"
		_tmp155_ = granite_accel_label_new_from_action_name (_ ("Select All"), _tmp154_);
#line 2084 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp155_);
#line 2084 "../src/View/AbstractDirectoryView.vala"
		_tmp156_ = _tmp155_;
#line 2084 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp151_, (GtkWidget*) _tmp156_);
#line 2084 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp156_);
#line 2089 "../src/View/AbstractDirectoryView.vala"
		_tmp157_ = files_abstract_directory_view_get_selected_files (self);
#line 2089 "../src/View/AbstractDirectoryView.vala"
		if (_tmp157_ != NULL) {
#line 11257 "AbstractDirectoryView.c"
			gchar* _tmp158_;
			GtkMenuItem* _tmp159_ = NULL;
			GtkMenuItem* _tmp160_;
			GtkMenuItem* _tmp161_;
			const gchar* _tmp162_;
			const gchar* _tmp163_;
			GraniteAccelLabel* _tmp164_;
			GraniteAccelLabel* _tmp165_;
#line 2090 "../src/View/AbstractDirectoryView.vala"
			_tmp158_ = g_strdup ("selection.invert-selection");
#line 2090 "../src/View/AbstractDirectoryView.vala"
			_tmp159_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2090 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp159_, _tmp158_);
#line 2090 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (_tmp158_);
#line 2090 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp159_);
#line 2090 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (invert_selection_menuitem);
#line 2090 "../src/View/AbstractDirectoryView.vala"
			invert_selection_menuitem = _tmp159_;
#line 2093 "../src/View/AbstractDirectoryView.vala"
			_tmp160_ = invert_selection_menuitem;
#line 2093 "../src/View/AbstractDirectoryView.vala"
			_tmp161_ = invert_selection_menuitem;
#line 2093 "../src/View/AbstractDirectoryView.vala"
			_tmp162_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp161_);
#line 2093 "../src/View/AbstractDirectoryView.vala"
			_tmp163_ = _tmp162_;
#line 2093 "../src/View/AbstractDirectoryView.vala"
			_tmp164_ = granite_accel_label_new_from_action_name (_ ("Invert Selection"), _tmp163_);
#line 2093 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp164_);
#line 2093 "../src/View/AbstractDirectoryView.vala"
			_tmp165_ = _tmp164_;
#line 2093 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp160_, (GtkWidget*) _tmp165_);
#line 2093 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp165_);
#line 11298 "AbstractDirectoryView.c"
		}
	} else {
		gchar* _tmp166_;
		GtkMenuItem* _tmp167_ = NULL;
		GtkMenuItem* _tmp168_;
		GtkMenuItem* _tmp169_;
		const gchar* _tmp170_;
		const gchar* _tmp171_;
		GraniteAccelLabel* _tmp172_;
		GraniteAccelLabel* _tmp173_;
#line 2099 "../src/View/AbstractDirectoryView.vala"
		_tmp166_ = g_strdup ("common.select-all");
#line 2099 "../src/View/AbstractDirectoryView.vala"
		_tmp167_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2099 "../src/View/AbstractDirectoryView.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp167_, _tmp166_);
#line 2099 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (_tmp166_);
#line 2099 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp167_);
#line 2099 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (deselect_all_menuitem);
#line 2099 "../src/View/AbstractDirectoryView.vala"
		deselect_all_menuitem = _tmp167_;
#line 2102 "../src/View/AbstractDirectoryView.vala"
		_tmp168_ = deselect_all_menuitem;
#line 2102 "../src/View/AbstractDirectoryView.vala"
		_tmp169_ = deselect_all_menuitem;
#line 2102 "../src/View/AbstractDirectoryView.vala"
		_tmp170_ = gtk_actionable_get_action_name ((GtkActionable*) _tmp169_);
#line 2102 "../src/View/AbstractDirectoryView.vala"
		_tmp171_ = _tmp170_;
#line 2102 "../src/View/AbstractDirectoryView.vala"
		_tmp172_ = granite_accel_label_new_from_action_name (_ ("Deselect All"), _tmp171_);
#line 2102 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp172_);
#line 2102 "../src/View/AbstractDirectoryView.vala"
		_tmp173_ = _tmp172_;
#line 2102 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp168_, (GtkWidget*) _tmp173_);
#line 2102 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp173_);
#line 11341 "AbstractDirectoryView.c"
	}
#line 2108 "../src/View/AbstractDirectoryView.vala"
	_tmp174_ = files_abstract_directory_view_get_selected_files (self);
#line 2108 "../src/View/AbstractDirectoryView.vala"
	if (_tmp174_ != NULL) {
#line 11347 "AbstractDirectoryView.c"
		GtkMenuItem* cut_menuitem = NULL;
		GtkMenuItem* _tmp175_;
		GtkMenuItem* _tmp176_;
		GraniteAccelLabel* _tmp177_;
		GraniteAccelLabel* _tmp178_;
		GtkMenuItem* _tmp179_;
		GtkMenuItem* copy_menuitem = NULL;
		GtkMenuItem* _tmp180_;
		GtkMenuItem* _tmp181_;
		GraniteAccelLabel* _tmp182_;
		GraniteAccelLabel* _tmp183_;
		GtkMenuItem* _tmp184_;
		GtkMenuItem* trash_menuitem = NULL;
		GtkMenuItem* _tmp185_;
		GtkMenuItem* _tmp186_;
		GraniteAccelLabel* _tmp187_;
		GraniteAccelLabel* _tmp188_;
		GtkMenuItem* _tmp189_;
		GtkMenuItem* delete_menuitem = NULL;
		gchar* _tmp190_;
		GtkMenuItem* _tmp191_ = NULL;
		GtkMenuItem* _tmp192_;
		GtkStyleContext* _tmp193_;
		gboolean _tmp194_ = FALSE;
#line 2109 "../src/View/AbstractDirectoryView.vala"
		_tmp175_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2109 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp175_);
#line 2109 "../src/View/AbstractDirectoryView.vala"
		cut_menuitem = _tmp175_;
#line 2110 "../src/View/AbstractDirectoryView.vala"
		_tmp176_ = cut_menuitem;
#line 2110 "../src/View/AbstractDirectoryView.vala"
		_tmp177_ = granite_accel_label_new (_ ("Cut"), "<Ctrl>x");
#line 2110 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp177_);
#line 2110 "../src/View/AbstractDirectoryView.vala"
		_tmp178_ = _tmp177_;
#line 2110 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp176_, (GtkWidget*) _tmp178_);
#line 2110 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp178_);
#line 2114 "../src/View/AbstractDirectoryView.vala"
		_tmp179_ = cut_menuitem;
#line 2114 "../src/View/AbstractDirectoryView.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp179_, "selection.cut");
#line 2116 "../src/View/AbstractDirectoryView.vala"
		_tmp180_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2116 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp180_);
#line 2116 "../src/View/AbstractDirectoryView.vala"
		copy_menuitem = _tmp180_;
#line 2118 "../src/View/AbstractDirectoryView.vala"
		_tmp181_ = copy_menuitem;
#line 2118 "../src/View/AbstractDirectoryView.vala"
		_tmp182_ = granite_accel_label_new (_ ("Copy"), "<Ctrl>c");
#line 2118 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp182_);
#line 2118 "../src/View/AbstractDirectoryView.vala"
		_tmp183_ = _tmp182_;
#line 2118 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp181_, (GtkWidget*) _tmp183_);
#line 2118 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp183_);
#line 2122 "../src/View/AbstractDirectoryView.vala"
		_tmp184_ = copy_menuitem;
#line 2122 "../src/View/AbstractDirectoryView.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp184_, "common.copy");
#line 2124 "../src/View/AbstractDirectoryView.vala"
		_tmp185_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2124 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp185_);
#line 2124 "../src/View/AbstractDirectoryView.vala"
		trash_menuitem = _tmp185_;
#line 2125 "../src/View/AbstractDirectoryView.vala"
		_tmp186_ = trash_menuitem;
#line 2125 "../src/View/AbstractDirectoryView.vala"
		_tmp187_ = granite_accel_label_new (_ ("Move to Trash"), "Delete");
#line 2125 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp187_);
#line 2125 "../src/View/AbstractDirectoryView.vala"
		_tmp188_ = _tmp187_;
#line 2125 "../src/View/AbstractDirectoryView.vala"
		gtk_container_add ((GtkContainer*) _tmp186_, (GtkWidget*) _tmp188_);
#line 2125 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp188_);
#line 2129 "../src/View/AbstractDirectoryView.vala"
		_tmp189_ = trash_menuitem;
#line 2129 "../src/View/AbstractDirectoryView.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp189_, "selection.trash");
#line 2131 "../src/View/AbstractDirectoryView.vala"
		_tmp190_ = g_strdup ("selection.delete");
#line 2131 "../src/View/AbstractDirectoryView.vala"
		_tmp191_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Delete Permanently"));
#line 2131 "../src/View/AbstractDirectoryView.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp191_, _tmp190_);
#line 2131 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (_tmp190_);
#line 2131 "../src/View/AbstractDirectoryView.vala"
		g_object_ref_sink (_tmp191_);
#line 2131 "../src/View/AbstractDirectoryView.vala"
		delete_menuitem = _tmp191_;
#line 2134 "../src/View/AbstractDirectoryView.vala"
		_tmp192_ = delete_menuitem;
#line 2134 "../src/View/AbstractDirectoryView.vala"
		_tmp193_ = gtk_widget_get_style_context ((GtkWidget*) _tmp192_);
#line 2134 "../src/View/AbstractDirectoryView.vala"
		gtk_style_context_add_class (_tmp193_, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION);
#line 2137 "../src/View/AbstractDirectoryView.vala"
		if (self->priv->in_trash) {
#line 2137 "../src/View/AbstractDirectoryView.vala"
			_tmp194_ = files_abstract_directory_view_valid_selection_for_restore (self);
#line 11460 "AbstractDirectoryView.c"
		} else {
#line 2137 "../src/View/AbstractDirectoryView.vala"
			_tmp194_ = FALSE;
#line 11464 "AbstractDirectoryView.c"
		}
#line 2137 "../src/View/AbstractDirectoryView.vala"
		if (_tmp194_) {
#line 11468 "AbstractDirectoryView.c"
			GtkMenuItem* restore_menuitem = NULL;
			GtkMenuItem* _tmp195_;
			GtkMenuItem* _tmp196_;
			GtkMenu* _tmp197_;
			GtkSeparatorMenuItem* _tmp198_;
			GtkSeparatorMenuItem* _tmp199_;
			GtkMenu* _tmp200_;
			GtkMenuItem* _tmp201_;
			GtkMenu* _tmp202_;
			GtkMenuItem* _tmp203_;
			GtkMenu* _tmp204_;
			GtkSeparatorMenuItem* _tmp205_;
			GtkSeparatorMenuItem* _tmp206_;
			GtkMenu* _tmp207_;
			GtkMenuItem* _tmp208_;
			GtkMenuItem* _tmp209_;
			GtkMenuItem* _tmp212_;
			GtkMenuItem* _tmp215_;
			GtkMenu* _tmp218_;
			GtkSeparatorMenuItem* _tmp219_;
			GtkSeparatorMenuItem* _tmp220_;
			GtkMenu* _tmp221_;
			GtkMenuItem* _tmp222_;
#line 2138 "../src/View/AbstractDirectoryView.vala"
			_tmp195_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Restore from Trash"));
#line 2138 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp195_);
#line 2138 "../src/View/AbstractDirectoryView.vala"
			restore_menuitem = _tmp195_;
#line 2139 "../src/View/AbstractDirectoryView.vala"
			_tmp196_ = restore_menuitem;
#line 2139 "../src/View/AbstractDirectoryView.vala"
			gtk_actionable_set_action_name ((GtkActionable*) _tmp196_, "selection.restore");
#line 2141 "../src/View/AbstractDirectoryView.vala"
			_tmp197_ = menu;
#line 2141 "../src/View/AbstractDirectoryView.vala"
			_tmp198_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2141 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp198_);
#line 2141 "../src/View/AbstractDirectoryView.vala"
			_tmp199_ = _tmp198_;
#line 2141 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp197_, (GtkWidget*) _tmp199_);
#line 2141 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp199_);
#line 2142 "../src/View/AbstractDirectoryView.vala"
			_tmp200_ = menu;
#line 2142 "../src/View/AbstractDirectoryView.vala"
			_tmp201_ = restore_menuitem;
#line 2142 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp200_, (GtkWidget*) _tmp201_);
#line 2143 "../src/View/AbstractDirectoryView.vala"
			_tmp202_ = menu;
#line 2143 "../src/View/AbstractDirectoryView.vala"
			_tmp203_ = delete_menuitem;
#line 2143 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp202_, (GtkWidget*) _tmp203_);
#line 2144 "../src/View/AbstractDirectoryView.vala"
			_tmp204_ = menu;
#line 2144 "../src/View/AbstractDirectoryView.vala"
			_tmp205_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2144 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp205_);
#line 2144 "../src/View/AbstractDirectoryView.vala"
			_tmp206_ = _tmp205_;
#line 2144 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp204_, (GtkWidget*) _tmp206_);
#line 2144 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp206_);
#line 2145 "../src/View/AbstractDirectoryView.vala"
			_tmp207_ = menu;
#line 2145 "../src/View/AbstractDirectoryView.vala"
			_tmp208_ = cut_menuitem;
#line 2145 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp207_, (GtkWidget*) _tmp208_);
#line 2146 "../src/View/AbstractDirectoryView.vala"
			_tmp209_ = select_all_menuitem;
#line 2146 "../src/View/AbstractDirectoryView.vala"
			if (_tmp209_ != NULL) {
#line 11548 "AbstractDirectoryView.c"
				GtkMenu* _tmp210_;
				GtkMenuItem* _tmp211_;
#line 2147 "../src/View/AbstractDirectoryView.vala"
				_tmp210_ = menu;
#line 2147 "../src/View/AbstractDirectoryView.vala"
				_tmp211_ = select_all_menuitem;
#line 2147 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp210_, (GtkWidget*) _tmp211_);
#line 11557 "AbstractDirectoryView.c"
			}
#line 2150 "../src/View/AbstractDirectoryView.vala"
			_tmp212_ = deselect_all_menuitem;
#line 2150 "../src/View/AbstractDirectoryView.vala"
			if (_tmp212_ != NULL) {
#line 11563 "AbstractDirectoryView.c"
				GtkMenu* _tmp213_;
				GtkMenuItem* _tmp214_;
#line 2151 "../src/View/AbstractDirectoryView.vala"
				_tmp213_ = menu;
#line 2151 "../src/View/AbstractDirectoryView.vala"
				_tmp214_ = deselect_all_menuitem;
#line 2151 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp213_, (GtkWidget*) _tmp214_);
#line 11572 "AbstractDirectoryView.c"
			}
#line 2154 "../src/View/AbstractDirectoryView.vala"
			_tmp215_ = invert_selection_menuitem;
#line 2154 "../src/View/AbstractDirectoryView.vala"
			if (_tmp215_ != NULL) {
#line 11578 "AbstractDirectoryView.c"
				GtkMenu* _tmp216_;
				GtkMenuItem* _tmp217_;
#line 2155 "../src/View/AbstractDirectoryView.vala"
				_tmp216_ = menu;
#line 2155 "../src/View/AbstractDirectoryView.vala"
				_tmp217_ = invert_selection_menuitem;
#line 2155 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp216_, (GtkWidget*) _tmp217_);
#line 11587 "AbstractDirectoryView.c"
			}
#line 2158 "../src/View/AbstractDirectoryView.vala"
			_tmp218_ = menu;
#line 2158 "../src/View/AbstractDirectoryView.vala"
			_tmp219_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2158 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp219_);
#line 2158 "../src/View/AbstractDirectoryView.vala"
			_tmp220_ = _tmp219_;
#line 2158 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp218_, (GtkWidget*) _tmp220_);
#line 2158 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp220_);
#line 2159 "../src/View/AbstractDirectoryView.vala"
			_tmp221_ = menu;
#line 2159 "../src/View/AbstractDirectoryView.vala"
			_tmp222_ = properties_menuitem;
#line 2159 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp221_, (GtkWidget*) _tmp222_);
#line 2137 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (restore_menuitem);
#line 11609 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp223_;
#line 2160 "../src/View/AbstractDirectoryView.vala"
			_tmp223_ = self->priv->_in_recent;
#line 2160 "../src/View/AbstractDirectoryView.vala"
			if (_tmp223_) {
#line 11616 "AbstractDirectoryView.c"
				GtkMenuItem* open_parent_menuitem = NULL;
				GtkMenuItem* _tmp224_;
				GtkMenuItem* _tmp225_;
				GtkMenuItem* forget_menuitem = NULL;
				GtkMenuItem* _tmp226_;
				GtkMenuItem* _tmp227_;
				GtkMenu* _tmp228_;
				GtkMenuItem* _tmp229_;
				GtkMenu* _tmp230_;
				GtkSeparatorMenuItem* _tmp231_;
				GtkSeparatorMenuItem* _tmp232_;
				GtkMenu* _tmp233_;
				GtkMenuItem* _tmp234_;
				GtkMenu* _tmp235_;
				GtkMenuItem* _tmp236_;
				GtkMenuItem* _tmp237_;
				GtkMenuItem* _tmp240_;
				GtkMenuItem* _tmp243_;
				GtkMenu* _tmp246_;
				GtkMenuItem* _tmp247_;
				GtkMenu* _tmp248_;
				GtkSeparatorMenuItem* _tmp249_;
				GtkSeparatorMenuItem* _tmp250_;
				GtkMenu* _tmp251_;
				GtkMenuItem* _tmp252_;
#line 2161 "../src/View/AbstractDirectoryView.vala"
				_tmp224_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Open Parent Folder"));
#line 2161 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp224_);
#line 2161 "../src/View/AbstractDirectoryView.vala"
				open_parent_menuitem = _tmp224_;
#line 2162 "../src/View/AbstractDirectoryView.vala"
				_tmp225_ = open_parent_menuitem;
#line 2162 "../src/View/AbstractDirectoryView.vala"
				gtk_actionable_set_action_name ((GtkActionable*) _tmp225_, "selection.view-in-location");
#line 2164 "../src/View/AbstractDirectoryView.vala"
				_tmp226_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Remove from History"));
#line 2164 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp226_);
#line 2164 "../src/View/AbstractDirectoryView.vala"
				forget_menuitem = _tmp226_;
#line 2165 "../src/View/AbstractDirectoryView.vala"
				_tmp227_ = forget_menuitem;
#line 2165 "../src/View/AbstractDirectoryView.vala"
				gtk_actionable_set_action_name ((GtkActionable*) _tmp227_, "selection.forget");
#line 2167 "../src/View/AbstractDirectoryView.vala"
				_tmp228_ = menu;
#line 2167 "../src/View/AbstractDirectoryView.vala"
				_tmp229_ = open_parent_menuitem;
#line 2167 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp228_, (GtkWidget*) _tmp229_);
#line 2168 "../src/View/AbstractDirectoryView.vala"
				_tmp230_ = menu;
#line 2168 "../src/View/AbstractDirectoryView.vala"
				_tmp231_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2168 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp231_);
#line 2168 "../src/View/AbstractDirectoryView.vala"
				_tmp232_ = _tmp231_;
#line 2168 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp230_, (GtkWidget*) _tmp232_);
#line 2168 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp232_);
#line 2169 "../src/View/AbstractDirectoryView.vala"
				_tmp233_ = menu;
#line 2169 "../src/View/AbstractDirectoryView.vala"
				_tmp234_ = forget_menuitem;
#line 2169 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp233_, (GtkWidget*) _tmp234_);
#line 2170 "../src/View/AbstractDirectoryView.vala"
				_tmp235_ = menu;
#line 2170 "../src/View/AbstractDirectoryView.vala"
				_tmp236_ = copy_menuitem;
#line 2170 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp235_, (GtkWidget*) _tmp236_);
#line 2171 "../src/View/AbstractDirectoryView.vala"
				_tmp237_ = select_all_menuitem;
#line 2171 "../src/View/AbstractDirectoryView.vala"
				if (_tmp237_ != NULL) {
#line 11696 "AbstractDirectoryView.c"
					GtkMenu* _tmp238_;
					GtkMenuItem* _tmp239_;
#line 2172 "../src/View/AbstractDirectoryView.vala"
					_tmp238_ = menu;
#line 2172 "../src/View/AbstractDirectoryView.vala"
					_tmp239_ = select_all_menuitem;
#line 2172 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp238_, (GtkWidget*) _tmp239_);
#line 11705 "AbstractDirectoryView.c"
				}
#line 2175 "../src/View/AbstractDirectoryView.vala"
				_tmp240_ = deselect_all_menuitem;
#line 2175 "../src/View/AbstractDirectoryView.vala"
				if (_tmp240_ != NULL) {
#line 11711 "AbstractDirectoryView.c"
					GtkMenu* _tmp241_;
					GtkMenuItem* _tmp242_;
#line 2176 "../src/View/AbstractDirectoryView.vala"
					_tmp241_ = menu;
#line 2176 "../src/View/AbstractDirectoryView.vala"
					_tmp242_ = deselect_all_menuitem;
#line 2176 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp241_, (GtkWidget*) _tmp242_);
#line 11720 "AbstractDirectoryView.c"
				}
#line 2179 "../src/View/AbstractDirectoryView.vala"
				_tmp243_ = invert_selection_menuitem;
#line 2179 "../src/View/AbstractDirectoryView.vala"
				if (_tmp243_ != NULL) {
#line 11726 "AbstractDirectoryView.c"
					GtkMenu* _tmp244_;
					GtkMenuItem* _tmp245_;
#line 2180 "../src/View/AbstractDirectoryView.vala"
					_tmp244_ = menu;
#line 2180 "../src/View/AbstractDirectoryView.vala"
					_tmp245_ = invert_selection_menuitem;
#line 2180 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp244_, (GtkWidget*) _tmp245_);
#line 11735 "AbstractDirectoryView.c"
				}
#line 2183 "../src/View/AbstractDirectoryView.vala"
				_tmp246_ = menu;
#line 2183 "../src/View/AbstractDirectoryView.vala"
				_tmp247_ = trash_menuitem;
#line 2183 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp246_, (GtkWidget*) _tmp247_);
#line 2184 "../src/View/AbstractDirectoryView.vala"
				_tmp248_ = menu;
#line 2184 "../src/View/AbstractDirectoryView.vala"
				_tmp249_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2184 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp249_);
#line 2184 "../src/View/AbstractDirectoryView.vala"
				_tmp250_ = _tmp249_;
#line 2184 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp248_, (GtkWidget*) _tmp250_);
#line 2184 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp250_);
#line 2185 "../src/View/AbstractDirectoryView.vala"
				_tmp251_ = menu;
#line 2185 "../src/View/AbstractDirectoryView.vala"
				_tmp252_ = properties_menuitem;
#line 2185 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp251_, (GtkWidget*) _tmp252_);
#line 2160 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (forget_menuitem);
#line 2160 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (open_parent_menuitem);
#line 11765 "AbstractDirectoryView.c"
			} else {
				gboolean _tmp334_ = FALSE;
				GSimpleActionGroup* _tmp335_;
				GtkMenu* _tmp343_;
				GtkSeparatorMenuItem* _tmp344_;
				GtkSeparatorMenuItem* _tmp345_;
				GtkMenu* _tmp346_;
				GtkMenuItem* _tmp347_;
#line 2187 "../src/View/AbstractDirectoryView.vala"
				if (files_abstract_directory_view_valid_selection_for_edit (self)) {
#line 11776 "AbstractDirectoryView.c"
					GtkMenuItem* rename_menuitem = NULL;
					GtkMenuItem* _tmp253_;
					GtkMenuItem* _tmp254_;
					GraniteAccelLabel* _tmp255_;
					GraniteAccelLabel* _tmp256_;
					GtkMenuItem* _tmp257_;
					GtkMenuItem* copy_link_menuitem = NULL;
					GtkMenuItem* _tmp258_;
					GtkMenuItem* _tmp259_;
					GraniteAccelLabel* _tmp260_;
					GraniteAccelLabel* _tmp261_;
					GtkMenuItem* _tmp262_;
					GtkMenu* _tmp263_;
					GList* _tmp264_;
					GList* _tmp265_;
					GtkMenuItem* _tmp266_;
					GList* _tmp267_;
					gboolean _tmp268_;
					GtkMenu* _tmp272_;
					GtkMenuItem* _tmp273_;
					GtkMenu* _tmp274_;
					GtkMenuItem* _tmp275_;
					GtkMenu* _tmp276_;
					GtkMenuItem* _tmp277_;
					gboolean _tmp278_ = FALSE;
					gboolean _tmp279_ = FALSE;
					GSimpleActionGroup* _tmp280_;
					GtkMenuItem* _tmp310_;
					GtkMenuItem* _tmp313_;
					GtkMenuItem* _tmp316_;
					GtkMenu* _tmp319_;
					GtkSeparatorMenuItem* _tmp320_;
					GtkSeparatorMenuItem* _tmp321_;
					gboolean _tmp322_ = FALSE;
					FilesViewSlot* _tmp323_;
					FilesDirectory* _tmp324_;
					FilesDirectory* _tmp325_;
					gboolean _tmp326_;
					gboolean _tmp327_;
					GtkMenu* _tmp332_;
					GtkMenuItem* _tmp333_;
#line 2188 "../src/View/AbstractDirectoryView.vala"
					_tmp253_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2188 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp253_);
#line 2188 "../src/View/AbstractDirectoryView.vala"
					rename_menuitem = _tmp253_;
#line 2189 "../src/View/AbstractDirectoryView.vala"
					_tmp254_ = rename_menuitem;
#line 2189 "../src/View/AbstractDirectoryView.vala"
					_tmp255_ = granite_accel_label_new (_ ("Rename…"), "F2");
#line 2189 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp255_);
#line 2189 "../src/View/AbstractDirectoryView.vala"
					_tmp256_ = _tmp255_;
#line 2189 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp254_, (GtkWidget*) _tmp256_);
#line 2189 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp256_);
#line 2193 "../src/View/AbstractDirectoryView.vala"
					_tmp257_ = rename_menuitem;
#line 2193 "../src/View/AbstractDirectoryView.vala"
					gtk_actionable_set_action_name ((GtkActionable*) _tmp257_, "selection.rename");
#line 2195 "../src/View/AbstractDirectoryView.vala"
					_tmp258_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2195 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp258_);
#line 2195 "../src/View/AbstractDirectoryView.vala"
					copy_link_menuitem = _tmp258_;
#line 2196 "../src/View/AbstractDirectoryView.vala"
					_tmp259_ = copy_link_menuitem;
#line 2196 "../src/View/AbstractDirectoryView.vala"
					_tmp260_ = granite_accel_label_new (_ ("Copy as Link"), "<Shift><Ctrl>c");
#line 2196 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp260_);
#line 2196 "../src/View/AbstractDirectoryView.vala"
					_tmp261_ = _tmp260_;
#line 2196 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp259_, (GtkWidget*) _tmp261_);
#line 2196 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp261_);
#line 2200 "../src/View/AbstractDirectoryView.vala"
					_tmp262_ = copy_link_menuitem;
#line 2200 "../src/View/AbstractDirectoryView.vala"
					gtk_actionable_set_action_name ((GtkActionable*) _tmp262_, "common.copy-link");
#line 2202 "../src/View/AbstractDirectoryView.vala"
					_tmp263_ = menu;
#line 2202 "../src/View/AbstractDirectoryView.vala"
					_tmp264_ = gtk_container_get_children ((GtkContainer*) _tmp263_);
#line 2202 "../src/View/AbstractDirectoryView.vala"
					_tmp265_ = _tmp264_;
#line 2202 "../src/View/AbstractDirectoryView.vala"
					_tmp266_ = open_submenu_item;
#line 2202 "../src/View/AbstractDirectoryView.vala"
					_tmp267_ = g_list_find (_tmp265_, (GtkWidget*) _tmp266_);
#line 2202 "../src/View/AbstractDirectoryView.vala"
					_tmp268_ = _tmp267_ != NULL;
#line 2202 "../src/View/AbstractDirectoryView.vala"
					(_tmp265_ == NULL) ? NULL : (_tmp265_ = (g_list_free (_tmp265_), NULL));
#line 2202 "../src/View/AbstractDirectoryView.vala"
					if (_tmp268_) {
#line 11878 "AbstractDirectoryView.c"
						GtkMenu* _tmp269_;
						GtkSeparatorMenuItem* _tmp270_;
						GtkSeparatorMenuItem* _tmp271_;
#line 2203 "../src/View/AbstractDirectoryView.vala"
						_tmp269_ = menu;
#line 2203 "../src/View/AbstractDirectoryView.vala"
						_tmp270_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2203 "../src/View/AbstractDirectoryView.vala"
						g_object_ref_sink (_tmp270_);
#line 2203 "../src/View/AbstractDirectoryView.vala"
						_tmp271_ = _tmp270_;
#line 2203 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp269_, (GtkWidget*) _tmp271_);
#line 2203 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (_tmp271_);
#line 11894 "AbstractDirectoryView.c"
					}
#line 2206 "../src/View/AbstractDirectoryView.vala"
					_tmp272_ = menu;
#line 2206 "../src/View/AbstractDirectoryView.vala"
					_tmp273_ = cut_menuitem;
#line 2206 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp272_, (GtkWidget*) _tmp273_);
#line 2207 "../src/View/AbstractDirectoryView.vala"
					_tmp274_ = menu;
#line 2207 "../src/View/AbstractDirectoryView.vala"
					_tmp275_ = copy_menuitem;
#line 2207 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp274_, (GtkWidget*) _tmp275_);
#line 2208 "../src/View/AbstractDirectoryView.vala"
					_tmp276_ = menu;
#line 2208 "../src/View/AbstractDirectoryView.vala"
					_tmp277_ = copy_link_menuitem;
#line 2208 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp276_, (GtkWidget*) _tmp277_);
#line 2212 "../src/View/AbstractDirectoryView.vala"
					_tmp280_ = self->priv->common_actions;
#line 2212 "../src/View/AbstractDirectoryView.vala"
					if (g_action_group_get_action_enabled ((GActionGroup*) _tmp280_, "paste-into")) {
#line 11918 "AbstractDirectoryView.c"
						FilesClipboardManager* _tmp281_;
#line 2213 "../src/View/AbstractDirectoryView.vala"
						_tmp281_ = self->priv->clipboard;
#line 2213 "../src/View/AbstractDirectoryView.vala"
						_tmp279_ = _tmp281_ != NULL;
#line 11924 "AbstractDirectoryView.c"
					} else {
#line 2212 "../src/View/AbstractDirectoryView.vala"
						_tmp279_ = FALSE;
#line 11928 "AbstractDirectoryView.c"
					}
#line 2212 "../src/View/AbstractDirectoryView.vala"
					if (_tmp279_) {
#line 11932 "AbstractDirectoryView.c"
						FilesClipboardManager* _tmp282_;
						gboolean _tmp283_;
						gboolean _tmp284_;
#line 2213 "../src/View/AbstractDirectoryView.vala"
						_tmp282_ = self->priv->clipboard;
#line 2213 "../src/View/AbstractDirectoryView.vala"
						_tmp283_ = files_clipboard_manager_get_can_paste (_tmp282_);
#line 2213 "../src/View/AbstractDirectoryView.vala"
						_tmp284_ = _tmp283_;
#line 2213 "../src/View/AbstractDirectoryView.vala"
						_tmp278_ = _tmp284_;
#line 11944 "AbstractDirectoryView.c"
					} else {
#line 2212 "../src/View/AbstractDirectoryView.vala"
						_tmp278_ = FALSE;
#line 11948 "AbstractDirectoryView.c"
					}
#line 2212 "../src/View/AbstractDirectoryView.vala"
					if (_tmp278_) {
#line 11952 "AbstractDirectoryView.c"
						GtkMenuItem* paste_into_menuitem = NULL;
						gchar* _tmp285_;
						GtkMenuItem* _tmp286_ = NULL;
						FilesClipboardManager* _tmp287_;
						gboolean _tmp288_;
						gboolean _tmp289_;
						GtkMenu* _tmp296_;
						GtkMenuItem* _tmp297_;
#line 2214 "../src/View/AbstractDirectoryView.vala"
						_tmp285_ = g_strdup ("common.paste-into");
#line 2214 "../src/View/AbstractDirectoryView.vala"
						_tmp286_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2214 "../src/View/AbstractDirectoryView.vala"
						gtk_actionable_set_action_name ((GtkActionable*) _tmp286_, _tmp285_);
#line 2214 "../src/View/AbstractDirectoryView.vala"
						_g_free0 (_tmp285_);
#line 2214 "../src/View/AbstractDirectoryView.vala"
						g_object_ref_sink (_tmp286_);
#line 2214 "../src/View/AbstractDirectoryView.vala"
						paste_into_menuitem = _tmp286_;
#line 2218 "../src/View/AbstractDirectoryView.vala"
						_tmp287_ = self->priv->clipboard;
#line 2218 "../src/View/AbstractDirectoryView.vala"
						_tmp288_ = files_clipboard_manager_get_files_linked (_tmp287_);
#line 2218 "../src/View/AbstractDirectoryView.vala"
						_tmp289_ = _tmp288_;
#line 2218 "../src/View/AbstractDirectoryView.vala"
						if (_tmp289_) {
#line 11981 "AbstractDirectoryView.c"
							GtkMenuItem* _tmp290_;
							GraniteAccelLabel* _tmp291_;
							GraniteAccelLabel* _tmp292_;
#line 2219 "../src/View/AbstractDirectoryView.vala"
							_tmp290_ = paste_into_menuitem;
#line 2219 "../src/View/AbstractDirectoryView.vala"
							_tmp291_ = granite_accel_label_new (_ ("Paste Link into Folder"), "<Shift><Ctrl>v");
#line 2219 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp291_);
#line 2219 "../src/View/AbstractDirectoryView.vala"
							_tmp292_ = _tmp291_;
#line 2219 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp290_, (GtkWidget*) _tmp292_);
#line 2219 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp292_);
#line 11997 "AbstractDirectoryView.c"
						} else {
							GtkMenuItem* _tmp293_;
							GraniteAccelLabel* _tmp294_;
							GraniteAccelLabel* _tmp295_;
#line 2224 "../src/View/AbstractDirectoryView.vala"
							_tmp293_ = paste_into_menuitem;
#line 2224 "../src/View/AbstractDirectoryView.vala"
							_tmp294_ = granite_accel_label_new (_ ("Paste into Folder"), "<Shift><Ctrl>v");
#line 2224 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp294_);
#line 2224 "../src/View/AbstractDirectoryView.vala"
							_tmp295_ = _tmp294_;
#line 2224 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp293_, (GtkWidget*) _tmp295_);
#line 2224 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp295_);
#line 12014 "AbstractDirectoryView.c"
						}
#line 2230 "../src/View/AbstractDirectoryView.vala"
						_tmp296_ = menu;
#line 2230 "../src/View/AbstractDirectoryView.vala"
						_tmp297_ = paste_into_menuitem;
#line 2230 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp296_, (GtkWidget*) _tmp297_);
#line 2212 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (paste_into_menuitem);
#line 12024 "AbstractDirectoryView.c"
					} else {
						gboolean _tmp298_ = FALSE;
						gboolean _tmp299_ = FALSE;
						GSimpleActionGroup* _tmp300_;
#line 2231 "../src/View/AbstractDirectoryView.vala"
						_tmp300_ = self->priv->common_actions;
#line 2231 "../src/View/AbstractDirectoryView.vala"
						if (g_action_group_get_action_enabled ((GActionGroup*) _tmp300_, "paste")) {
#line 12033 "AbstractDirectoryView.c"
							FilesClipboardManager* _tmp301_;
#line 2232 "../src/View/AbstractDirectoryView.vala"
							_tmp301_ = self->priv->clipboard;
#line 2232 "../src/View/AbstractDirectoryView.vala"
							_tmp299_ = _tmp301_ != NULL;
#line 12039 "AbstractDirectoryView.c"
						} else {
#line 2231 "../src/View/AbstractDirectoryView.vala"
							_tmp299_ = FALSE;
#line 12043 "AbstractDirectoryView.c"
						}
#line 2231 "../src/View/AbstractDirectoryView.vala"
						if (_tmp299_) {
#line 12047 "AbstractDirectoryView.c"
							FilesClipboardManager* _tmp302_;
							gboolean _tmp303_;
							gboolean _tmp304_;
#line 2232 "../src/View/AbstractDirectoryView.vala"
							_tmp302_ = self->priv->clipboard;
#line 2232 "../src/View/AbstractDirectoryView.vala"
							_tmp303_ = files_clipboard_manager_get_can_paste (_tmp302_);
#line 2232 "../src/View/AbstractDirectoryView.vala"
							_tmp304_ = _tmp303_;
#line 2232 "../src/View/AbstractDirectoryView.vala"
							_tmp298_ = _tmp304_;
#line 12059 "AbstractDirectoryView.c"
						} else {
#line 2231 "../src/View/AbstractDirectoryView.vala"
							_tmp298_ = FALSE;
#line 12063 "AbstractDirectoryView.c"
						}
#line 2231 "../src/View/AbstractDirectoryView.vala"
						if (_tmp298_) {
#line 12067 "AbstractDirectoryView.c"
							GtkMenuItem* _tmp305_;
							GraniteAccelLabel* _tmp306_;
							GraniteAccelLabel* _tmp307_;
							GtkMenu* _tmp308_;
							GtkMenuItem* _tmp309_;
#line 2234 "../src/View/AbstractDirectoryView.vala"
							_tmp305_ = paste_menuitem;
#line 2234 "../src/View/AbstractDirectoryView.vala"
							_tmp306_ = granite_accel_label_new (_ ("Paste"), "<Ctrl>v");
#line 2234 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp306_);
#line 2234 "../src/View/AbstractDirectoryView.vala"
							_tmp307_ = _tmp306_;
#line 2234 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp305_, (GtkWidget*) _tmp307_);
#line 2234 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp307_);
#line 2238 "../src/View/AbstractDirectoryView.vala"
							_tmp308_ = menu;
#line 2238 "../src/View/AbstractDirectoryView.vala"
							_tmp309_ = paste_menuitem;
#line 2238 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp308_, (GtkWidget*) _tmp309_);
#line 12091 "AbstractDirectoryView.c"
						}
					}
#line 2241 "../src/View/AbstractDirectoryView.vala"
					_tmp310_ = select_all_menuitem;
#line 2241 "../src/View/AbstractDirectoryView.vala"
					if (_tmp310_ != NULL) {
#line 12098 "AbstractDirectoryView.c"
						GtkMenu* _tmp311_;
						GtkMenuItem* _tmp312_;
#line 2242 "../src/View/AbstractDirectoryView.vala"
						_tmp311_ = menu;
#line 2242 "../src/View/AbstractDirectoryView.vala"
						_tmp312_ = select_all_menuitem;
#line 2242 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp311_, (GtkWidget*) _tmp312_);
#line 12107 "AbstractDirectoryView.c"
					}
#line 2245 "../src/View/AbstractDirectoryView.vala"
					_tmp313_ = deselect_all_menuitem;
#line 2245 "../src/View/AbstractDirectoryView.vala"
					if (_tmp313_ != NULL) {
#line 12113 "AbstractDirectoryView.c"
						GtkMenu* _tmp314_;
						GtkMenuItem* _tmp315_;
#line 2246 "../src/View/AbstractDirectoryView.vala"
						_tmp314_ = menu;
#line 2246 "../src/View/AbstractDirectoryView.vala"
						_tmp315_ = deselect_all_menuitem;
#line 2246 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp314_, (GtkWidget*) _tmp315_);
#line 12122 "AbstractDirectoryView.c"
					}
#line 2249 "../src/View/AbstractDirectoryView.vala"
					_tmp316_ = invert_selection_menuitem;
#line 2249 "../src/View/AbstractDirectoryView.vala"
					if (_tmp316_ != NULL) {
#line 12128 "AbstractDirectoryView.c"
						GtkMenu* _tmp317_;
						GtkMenuItem* _tmp318_;
#line 2250 "../src/View/AbstractDirectoryView.vala"
						_tmp317_ = menu;
#line 2250 "../src/View/AbstractDirectoryView.vala"
						_tmp318_ = invert_selection_menuitem;
#line 2250 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp317_, (GtkWidget*) _tmp318_);
#line 12137 "AbstractDirectoryView.c"
					}
#line 2253 "../src/View/AbstractDirectoryView.vala"
					_tmp319_ = menu;
#line 2253 "../src/View/AbstractDirectoryView.vala"
					_tmp320_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2253 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp320_);
#line 2253 "../src/View/AbstractDirectoryView.vala"
					_tmp321_ = _tmp320_;
#line 2253 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp319_, (GtkWidget*) _tmp321_);
#line 2253 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp321_);
#line 2254 "../src/View/AbstractDirectoryView.vala"
					_tmp323_ = self->slot;
#line 2254 "../src/View/AbstractDirectoryView.vala"
					_tmp324_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp323_);
#line 2254 "../src/View/AbstractDirectoryView.vala"
					_tmp325_ = _tmp324_;
#line 2254 "../src/View/AbstractDirectoryView.vala"
					_tmp326_ = files_directory_get_has_trash_dirs (_tmp325_);
#line 2254 "../src/View/AbstractDirectoryView.vala"
					_tmp327_ = _tmp326_;
#line 2254 "../src/View/AbstractDirectoryView.vala"
					if (_tmp327_) {
#line 2254 "../src/View/AbstractDirectoryView.vala"
						_tmp322_ = !files_is_admin ();
#line 12165 "AbstractDirectoryView.c"
					} else {
#line 2254 "../src/View/AbstractDirectoryView.vala"
						_tmp322_ = FALSE;
#line 12169 "AbstractDirectoryView.c"
					}
#line 2254 "../src/View/AbstractDirectoryView.vala"
					if (_tmp322_) {
#line 12173 "AbstractDirectoryView.c"
						GtkMenu* _tmp328_;
						GtkMenuItem* _tmp329_;
#line 2255 "../src/View/AbstractDirectoryView.vala"
						_tmp328_ = menu;
#line 2255 "../src/View/AbstractDirectoryView.vala"
						_tmp329_ = trash_menuitem;
#line 2255 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp328_, (GtkWidget*) _tmp329_);
#line 12182 "AbstractDirectoryView.c"
					} else {
						GtkMenu* _tmp330_;
						GtkMenuItem* _tmp331_;
#line 2257 "../src/View/AbstractDirectoryView.vala"
						_tmp330_ = menu;
#line 2257 "../src/View/AbstractDirectoryView.vala"
						_tmp331_ = delete_menuitem;
#line 2257 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp330_, (GtkWidget*) _tmp331_);
#line 12192 "AbstractDirectoryView.c"
					}
#line 2260 "../src/View/AbstractDirectoryView.vala"
					_tmp332_ = menu;
#line 2260 "../src/View/AbstractDirectoryView.vala"
					_tmp333_ = rename_menuitem;
#line 2260 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp332_, (GtkWidget*) _tmp333_);
#line 2187 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (copy_link_menuitem);
#line 2187 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (rename_menuitem);
#line 12204 "AbstractDirectoryView.c"
				}
#line 2264 "../src/View/AbstractDirectoryView.vala"
				_tmp335_ = self->priv->common_actions;
#line 2264 "../src/View/AbstractDirectoryView.vala"
				if (g_action_group_get_action_enabled ((GActionGroup*) _tmp335_, "bookmark")) {
#line 12210 "AbstractDirectoryView.c"
					FilesViewWindow* _tmp336_;
					GList* _tmp337_;
					gconstpointer _tmp338_;
					const gchar* _tmp339_;
					const gchar* _tmp340_;
#line 2265 "../src/View/AbstractDirectoryView.vala"
					_tmp336_ = self->window;
#line 2265 "../src/View/AbstractDirectoryView.vala"
					_tmp337_ = self->selected_files;
#line 2265 "../src/View/AbstractDirectoryView.vala"
					_tmp338_ = _tmp337_->data;
#line 2265 "../src/View/AbstractDirectoryView.vala"
					_tmp339_ = files_file_get_uri ((FilesFile*) _tmp338_);
#line 2265 "../src/View/AbstractDirectoryView.vala"
					_tmp340_ = _tmp339_;
#line 2265 "../src/View/AbstractDirectoryView.vala"
					_tmp334_ = files_view_window_can_bookmark_uri (_tmp336_, _tmp340_);
#line 12228 "AbstractDirectoryView.c"
				} else {
#line 2264 "../src/View/AbstractDirectoryView.vala"
					_tmp334_ = FALSE;
#line 12232 "AbstractDirectoryView.c"
				}
#line 2264 "../src/View/AbstractDirectoryView.vala"
				if (_tmp334_) {
#line 12236 "AbstractDirectoryView.c"
					GtkMenu* _tmp341_;
					GtkMenuItem* _tmp342_;
#line 2267 "../src/View/AbstractDirectoryView.vala"
					_tmp341_ = menu;
#line 2267 "../src/View/AbstractDirectoryView.vala"
					_tmp342_ = bookmark_menuitem;
#line 2267 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp341_, (GtkWidget*) _tmp342_);
#line 12245 "AbstractDirectoryView.c"
				}
#line 2270 "../src/View/AbstractDirectoryView.vala"
				_tmp343_ = menu;
#line 2270 "../src/View/AbstractDirectoryView.vala"
				_tmp344_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2270 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp344_);
#line 2270 "../src/View/AbstractDirectoryView.vala"
				_tmp345_ = _tmp344_;
#line 2270 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp343_, (GtkWidget*) _tmp345_);
#line 2270 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp345_);
#line 2271 "../src/View/AbstractDirectoryView.vala"
				_tmp346_ = menu;
#line 2271 "../src/View/AbstractDirectoryView.vala"
				_tmp347_ = properties_menuitem;
#line 2271 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp346_, (GtkWidget*) _tmp347_);
#line 12265 "AbstractDirectoryView.c"
			}
		}
#line 2108 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (delete_menuitem);
#line 2108 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (trash_menuitem);
#line 2108 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (copy_menuitem);
#line 2108 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (cut_menuitem);
#line 12276 "AbstractDirectoryView.c"
	} else {
#line 2274 "../src/View/AbstractDirectoryView.vala"
		if (self->priv->in_trash) {
#line 12280 "AbstractDirectoryView.c"
			gboolean _tmp348_ = FALSE;
			FilesClipboardManager* _tmp349_;
#line 2275 "../src/View/AbstractDirectoryView.vala"
			_tmp349_ = self->priv->clipboard;
#line 2275 "../src/View/AbstractDirectoryView.vala"
			if (_tmp349_ != NULL) {
#line 12287 "AbstractDirectoryView.c"
				FilesClipboardManager* _tmp350_;
#line 2275 "../src/View/AbstractDirectoryView.vala"
				_tmp350_ = self->priv->clipboard;
#line 2275 "../src/View/AbstractDirectoryView.vala"
				_tmp348_ = files_clipboard_manager_has_cutted_file (_tmp350_, NULL);
#line 12293 "AbstractDirectoryView.c"
			} else {
#line 2275 "../src/View/AbstractDirectoryView.vala"
				_tmp348_ = FALSE;
#line 12297 "AbstractDirectoryView.c"
			}
#line 2275 "../src/View/AbstractDirectoryView.vala"
			if (_tmp348_) {
#line 12301 "AbstractDirectoryView.c"
				GtkMenuItem* _tmp351_;
				GraniteAccelLabel* _tmp352_;
				GraniteAccelLabel* _tmp353_;
				GtkMenu* _tmp354_;
				GtkMenuItem* _tmp355_;
				GtkMenuItem* _tmp356_;
#line 2276 "../src/View/AbstractDirectoryView.vala"
				_tmp351_ = paste_menuitem;
#line 2276 "../src/View/AbstractDirectoryView.vala"
				_tmp352_ = granite_accel_label_new (_ ("Paste into Folder"), "<Ctrl>v");
#line 2276 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp352_);
#line 2276 "../src/View/AbstractDirectoryView.vala"
				_tmp353_ = _tmp352_;
#line 2276 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp351_, (GtkWidget*) _tmp353_);
#line 2276 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp353_);
#line 2280 "../src/View/AbstractDirectoryView.vala"
				_tmp354_ = menu;
#line 2280 "../src/View/AbstractDirectoryView.vala"
				_tmp355_ = paste_menuitem;
#line 2280 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp354_, (GtkWidget*) _tmp355_);
#line 2281 "../src/View/AbstractDirectoryView.vala"
				_tmp356_ = select_all_menuitem;
#line 2281 "../src/View/AbstractDirectoryView.vala"
				if (_tmp356_ != NULL) {
#line 12330 "AbstractDirectoryView.c"
					GtkMenu* _tmp357_;
					GtkMenuItem* _tmp358_;
#line 2282 "../src/View/AbstractDirectoryView.vala"
					_tmp357_ = menu;
#line 2282 "../src/View/AbstractDirectoryView.vala"
					_tmp358_ = select_all_menuitem;
#line 2282 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp357_, (GtkWidget*) _tmp358_);
#line 12339 "AbstractDirectoryView.c"
				}
			}
		} else {
			gboolean _tmp359_;
#line 2285 "../src/View/AbstractDirectoryView.vala"
			_tmp359_ = self->priv->_in_recent;
#line 2285 "../src/View/AbstractDirectoryView.vala"
			if (_tmp359_) {
#line 12348 "AbstractDirectoryView.c"
				GtkMenuItem* _tmp360_;
				GtkMenu* _tmp363_;
				GtkSeparatorMenuItem* _tmp364_;
				GtkSeparatorMenuItem* _tmp365_;
				GtkMenu* _tmp366_;
				FilesAbstractDirectoryViewSortSubMenuItem* _tmp367_;
				FilesAbstractDirectoryViewSortSubMenuItem* _tmp368_;
				GtkMenu* _tmp369_;
				GtkSeparatorMenuItem* _tmp370_;
				GtkSeparatorMenuItem* _tmp371_;
#line 2286 "../src/View/AbstractDirectoryView.vala"
				_tmp360_ = select_all_menuitem;
#line 2286 "../src/View/AbstractDirectoryView.vala"
				if (_tmp360_ != NULL) {
#line 12363 "AbstractDirectoryView.c"
					GtkMenu* _tmp361_;
					GtkMenuItem* _tmp362_;
#line 2287 "../src/View/AbstractDirectoryView.vala"
					_tmp361_ = menu;
#line 2287 "../src/View/AbstractDirectoryView.vala"
					_tmp362_ = select_all_menuitem;
#line 2287 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp361_, (GtkWidget*) _tmp362_);
#line 12372 "AbstractDirectoryView.c"
				}
#line 2290 "../src/View/AbstractDirectoryView.vala"
				_tmp363_ = menu;
#line 2290 "../src/View/AbstractDirectoryView.vala"
				_tmp364_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2290 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp364_);
#line 2290 "../src/View/AbstractDirectoryView.vala"
				_tmp365_ = _tmp364_;
#line 2290 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp363_, (GtkWidget*) _tmp365_);
#line 2290 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp365_);
#line 2291 "../src/View/AbstractDirectoryView.vala"
				_tmp366_ = menu;
#line 2291 "../src/View/AbstractDirectoryView.vala"
				_tmp367_ = files_abstract_directory_view_sort_sub_menu_item_new ();
#line 2291 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp367_);
#line 2291 "../src/View/AbstractDirectoryView.vala"
				_tmp368_ = _tmp367_;
#line 2291 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp366_, (GtkWidget*) _tmp368_);
#line 2291 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp368_);
#line 2292 "../src/View/AbstractDirectoryView.vala"
				_tmp369_ = menu;
#line 2292 "../src/View/AbstractDirectoryView.vala"
				_tmp370_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2292 "../src/View/AbstractDirectoryView.vala"
				g_object_ref_sink (_tmp370_);
#line 2292 "../src/View/AbstractDirectoryView.vala"
				_tmp371_ = _tmp370_;
#line 2292 "../src/View/AbstractDirectoryView.vala"
				gtk_container_add ((GtkContainer*) _tmp369_, (GtkWidget*) _tmp371_);
#line 2292 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp371_);
#line 12410 "AbstractDirectoryView.c"
			} else {
				gboolean _tmp400_ = FALSE;
				GSimpleActionGroup* _tmp401_;
#line 2294 "../src/View/AbstractDirectoryView.vala"
				if (!self->priv->in_network_root) {
#line 12416 "AbstractDirectoryView.c"
					GtkMenu* _tmp372_;
					GtkSeparatorMenuItem* _tmp373_;
					GtkSeparatorMenuItem* _tmp374_;
					gboolean _tmp375_ = FALSE;
					FilesClipboardManager* _tmp376_;
					GtkMenu* _tmp389_;
					GtkMenuItem* _tmp390_;
					GtkMenuItem* _tmp391_;
					GtkMenu* _tmp397_;
					FilesAbstractDirectoryViewSortSubMenuItem* _tmp398_;
					FilesAbstractDirectoryViewSortSubMenuItem* _tmp399_;
#line 2295 "../src/View/AbstractDirectoryView.vala"
					_tmp372_ = menu;
#line 2295 "../src/View/AbstractDirectoryView.vala"
					_tmp373_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2295 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp373_);
#line 2295 "../src/View/AbstractDirectoryView.vala"
					_tmp374_ = _tmp373_;
#line 2295 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp372_, (GtkWidget*) _tmp374_);
#line 2295 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp374_);
#line 2297 "../src/View/AbstractDirectoryView.vala"
					_tmp376_ = self->priv->clipboard;
#line 2297 "../src/View/AbstractDirectoryView.vala"
					if (_tmp376_ != NULL) {
#line 12444 "AbstractDirectoryView.c"
						FilesClipboardManager* _tmp377_;
						gboolean _tmp378_;
						gboolean _tmp379_;
#line 2297 "../src/View/AbstractDirectoryView.vala"
						_tmp377_ = self->priv->clipboard;
#line 2297 "../src/View/AbstractDirectoryView.vala"
						_tmp378_ = files_clipboard_manager_get_can_paste (_tmp377_);
#line 2297 "../src/View/AbstractDirectoryView.vala"
						_tmp379_ = _tmp378_;
#line 2297 "../src/View/AbstractDirectoryView.vala"
						_tmp375_ = _tmp379_;
#line 12456 "AbstractDirectoryView.c"
					} else {
#line 2297 "../src/View/AbstractDirectoryView.vala"
						_tmp375_ = FALSE;
#line 12460 "AbstractDirectoryView.c"
					}
#line 2297 "../src/View/AbstractDirectoryView.vala"
					if (_tmp375_) {
#line 12464 "AbstractDirectoryView.c"
						FilesClipboardManager* _tmp380_;
						gboolean _tmp381_;
						gboolean _tmp382_;
#line 2298 "../src/View/AbstractDirectoryView.vala"
						_tmp380_ = self->priv->clipboard;
#line 2298 "../src/View/AbstractDirectoryView.vala"
						_tmp381_ = files_clipboard_manager_get_files_linked (_tmp380_);
#line 2298 "../src/View/AbstractDirectoryView.vala"
						_tmp382_ = _tmp381_;
#line 2298 "../src/View/AbstractDirectoryView.vala"
						if (_tmp382_) {
#line 12476 "AbstractDirectoryView.c"
							GtkMenuItem* _tmp383_;
							GraniteAccelLabel* _tmp384_;
							GraniteAccelLabel* _tmp385_;
#line 2299 "../src/View/AbstractDirectoryView.vala"
							_tmp383_ = paste_menuitem;
#line 2299 "../src/View/AbstractDirectoryView.vala"
							_tmp384_ = granite_accel_label_new (_ ("Paste Link into Folder"), "<Ctrl>v");
#line 2299 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp384_);
#line 2299 "../src/View/AbstractDirectoryView.vala"
							_tmp385_ = _tmp384_;
#line 2299 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp383_, (GtkWidget*) _tmp385_);
#line 2299 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp385_);
#line 12492 "AbstractDirectoryView.c"
						} else {
							GtkMenuItem* _tmp386_;
							GraniteAccelLabel* _tmp387_;
							GraniteAccelLabel* _tmp388_;
#line 2304 "../src/View/AbstractDirectoryView.vala"
							_tmp386_ = paste_menuitem;
#line 2304 "../src/View/AbstractDirectoryView.vala"
							_tmp387_ = granite_accel_label_new (_ ("Paste"), "<Ctrl>v");
#line 2304 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp387_);
#line 2304 "../src/View/AbstractDirectoryView.vala"
							_tmp388_ = _tmp387_;
#line 2304 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp386_, (GtkWidget*) _tmp388_);
#line 2304 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (_tmp388_);
#line 12509 "AbstractDirectoryView.c"
						}
					}
#line 2311 "../src/View/AbstractDirectoryView.vala"
					_tmp389_ = menu;
#line 2311 "../src/View/AbstractDirectoryView.vala"
					_tmp390_ = paste_menuitem;
#line 2311 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp389_, (GtkWidget*) _tmp390_);
#line 2312 "../src/View/AbstractDirectoryView.vala"
					_tmp391_ = select_all_menuitem;
#line 2312 "../src/View/AbstractDirectoryView.vala"
					if (_tmp391_ != NULL) {
#line 12522 "AbstractDirectoryView.c"
						GtkMenu* _tmp392_;
						GtkMenuItem* _tmp393_;
#line 2313 "../src/View/AbstractDirectoryView.vala"
						_tmp392_ = menu;
#line 2313 "../src/View/AbstractDirectoryView.vala"
						_tmp393_ = select_all_menuitem;
#line 2313 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp392_, (GtkWidget*) _tmp393_);
#line 12531 "AbstractDirectoryView.c"
					}
#line 2316 "../src/View/AbstractDirectoryView.vala"
					if (self->is_writable) {
#line 12535 "AbstractDirectoryView.c"
						GtkMenu* _tmp394_;
						FilesAbstractDirectoryViewNewSubMenuItem* _tmp395_;
						FilesAbstractDirectoryViewNewSubMenuItem* _tmp396_;
#line 2317 "../src/View/AbstractDirectoryView.vala"
						_tmp394_ = menu;
#line 2317 "../src/View/AbstractDirectoryView.vala"
						_tmp395_ = files_abstract_directory_view_new_sub_menu_item_new ();
#line 2317 "../src/View/AbstractDirectoryView.vala"
						g_object_ref_sink (_tmp395_);
#line 2317 "../src/View/AbstractDirectoryView.vala"
						_tmp396_ = _tmp395_;
#line 2317 "../src/View/AbstractDirectoryView.vala"
						gtk_container_add ((GtkContainer*) _tmp394_, (GtkWidget*) _tmp396_);
#line 2317 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (_tmp396_);
#line 12551 "AbstractDirectoryView.c"
					}
#line 2320 "../src/View/AbstractDirectoryView.vala"
					_tmp397_ = menu;
#line 2320 "../src/View/AbstractDirectoryView.vala"
					_tmp398_ = files_abstract_directory_view_sort_sub_menu_item_new ();
#line 2320 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp398_);
#line 2320 "../src/View/AbstractDirectoryView.vala"
					_tmp399_ = _tmp398_;
#line 2320 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp397_, (GtkWidget*) _tmp399_);
#line 2320 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp399_);
#line 12565 "AbstractDirectoryView.c"
				}
#line 2324 "../src/View/AbstractDirectoryView.vala"
				_tmp401_ = self->priv->common_actions;
#line 2324 "../src/View/AbstractDirectoryView.vala"
				if (g_action_group_get_action_enabled ((GActionGroup*) _tmp401_, "bookmark")) {
#line 12571 "AbstractDirectoryView.c"
					FilesViewWindow* _tmp402_;
					FilesViewSlot* _tmp403_;
					FilesDirectory* _tmp404_;
					FilesDirectory* _tmp405_;
					FilesFile* _tmp406_;
					FilesFile* _tmp407_;
					const gchar* _tmp408_;
					const gchar* _tmp409_;
#line 2325 "../src/View/AbstractDirectoryView.vala"
					_tmp402_ = self->window;
#line 2325 "../src/View/AbstractDirectoryView.vala"
					_tmp403_ = self->slot;
#line 2325 "../src/View/AbstractDirectoryView.vala"
					_tmp404_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp403_);
#line 2325 "../src/View/AbstractDirectoryView.vala"
					_tmp405_ = _tmp404_;
#line 2325 "../src/View/AbstractDirectoryView.vala"
					_tmp406_ = files_directory_get_file (_tmp405_);
#line 2325 "../src/View/AbstractDirectoryView.vala"
					_tmp407_ = _tmp406_;
#line 2325 "../src/View/AbstractDirectoryView.vala"
					_tmp408_ = files_file_get_uri (_tmp407_);
#line 2325 "../src/View/AbstractDirectoryView.vala"
					_tmp409_ = _tmp408_;
#line 2325 "../src/View/AbstractDirectoryView.vala"
					_tmp400_ = files_view_window_can_bookmark_uri (_tmp402_, _tmp409_);
#line 12598 "AbstractDirectoryView.c"
				} else {
#line 2324 "../src/View/AbstractDirectoryView.vala"
					_tmp400_ = FALSE;
#line 12602 "AbstractDirectoryView.c"
				}
#line 2324 "../src/View/AbstractDirectoryView.vala"
				if (_tmp400_) {
#line 12606 "AbstractDirectoryView.c"
					GtkMenu* _tmp410_;
					GtkMenuItem* _tmp411_;
#line 2327 "../src/View/AbstractDirectoryView.vala"
					_tmp410_ = menu;
#line 2327 "../src/View/AbstractDirectoryView.vala"
					_tmp411_ = bookmark_menuitem;
#line 2327 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp410_, (GtkWidget*) _tmp411_);
#line 12615 "AbstractDirectoryView.c"
				}
#line 2330 "../src/View/AbstractDirectoryView.vala"
				if (!self->priv->in_network_root) {
#line 12619 "AbstractDirectoryView.c"
					GtkMenu* _tmp412_;
					GtkSeparatorMenuItem* _tmp413_;
					GtkSeparatorMenuItem* _tmp414_;
					GtkMenu* _tmp415_;
					GtkMenuItem* _tmp416_;
#line 2331 "../src/View/AbstractDirectoryView.vala"
					_tmp412_ = menu;
#line 2331 "../src/View/AbstractDirectoryView.vala"
					_tmp413_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2331 "../src/View/AbstractDirectoryView.vala"
					g_object_ref_sink (_tmp413_);
#line 2331 "../src/View/AbstractDirectoryView.vala"
					_tmp414_ = _tmp413_;
#line 2331 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp412_, (GtkWidget*) _tmp414_);
#line 2331 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp414_);
#line 2332 "../src/View/AbstractDirectoryView.vala"
					_tmp415_ = menu;
#line 2332 "../src/View/AbstractDirectoryView.vala"
					_tmp416_ = properties_menuitem;
#line 2332 "../src/View/AbstractDirectoryView.vala"
					gtk_container_add ((GtkContainer*) _tmp415_, (GtkWidget*) _tmp416_);
#line 12643 "AbstractDirectoryView.c"
				}
			}
		}
	}
#line 2337 "../src/View/AbstractDirectoryView.vala"
	if (!self->priv->in_trash) {
#line 12650 "AbstractDirectoryView.c"
		FilesPluginManager* _tmp417_;
		GtkMenu* _tmp418_;
		GList* _tmp419_;
#line 2340 "../src/View/AbstractDirectoryView.vala"
		_tmp417_ = plugins;
#line 2340 "../src/View/AbstractDirectoryView.vala"
		_tmp418_ = menu;
#line 2340 "../src/View/AbstractDirectoryView.vala"
		_tmp419_ = files_abstract_directory_view_get_selected_files (self);
#line 2340 "../src/View/AbstractDirectoryView.vala"
		files_plugin_manager_hook_context_menu (_tmp417_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp418_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp418_) : NULL, _tmp419_);
#line 12662 "AbstractDirectoryView.c"
	}
#line 2343 "../src/View/AbstractDirectoryView.vala"
	_tmp420_ = menu;
#line 2343 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_set_screen (_tmp420_, NULL);
#line 2344 "../src/View/AbstractDirectoryView.vala"
	_tmp421_ = menu;
#line 2344 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_attach_to_widget (_tmp421_, (GtkWidget*) self, NULL);
#line 2347 "../src/View/AbstractDirectoryView.vala"
	_tmp422_ = self->slot;
#line 2347 "../src/View/AbstractDirectoryView.vala"
	_tmp423_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp422_);
#line 2347 "../src/View/AbstractDirectoryView.vala"
	_tmp424_ = _tmp423_;
#line 2347 "../src/View/AbstractDirectoryView.vala"
	if (files_directory_is_empty (_tmp424_)) {
#line 12680 "AbstractDirectoryView.c"
		GtkMenu* _tmp425_;
		GtkStyleContext* _tmp426_;
#line 2348 "../src/View/AbstractDirectoryView.vala"
		_tmp425_ = menu;
#line 2348 "../src/View/AbstractDirectoryView.vala"
		_tmp426_ = gtk_widget_get_style_context ((GtkWidget*) _tmp425_);
#line 2348 "../src/View/AbstractDirectoryView.vala"
		gtk_style_context_add_class (_tmp426_, GTK_STYLE_CLASS_CONTEXT_MENU);
#line 12689 "AbstractDirectoryView.c"
	}
#line 2351 "../src/View/AbstractDirectoryView.vala"
	_tmp427_ = menu;
#line 2351 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp427_);
#line 2352 "../src/View/AbstractDirectoryView.vala"
	_tmp428_ = menu;
#line 2352 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_popup_at_pointer (_tmp428_, event);
#line 1920 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (invert_selection_menuitem);
#line 1920 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (deselect_all_menuitem);
#line 1920 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (select_all_menuitem);
#line 1920 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (properties_menuitem);
#line 1920 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (bookmark_menuitem);
#line 1920 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (paste_menuitem);
#line 1920 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (open_submenu_item);
#line 1920 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (open_submenu);
#line 1920 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (selected_file);
#line 1920 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 1920 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (menu);
#line 12721 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_valid_selection_for_edit (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	gboolean result;
#line 2461 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2462 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_files (self);
#line 12733 "AbstractDirectoryView.c"
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
#line 2462 "../src/View/AbstractDirectoryView.vala"
		file_collection = _tmp0_;
#line 2462 "../src/View/AbstractDirectoryView.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 12741 "AbstractDirectoryView.c"
			FilesFile* file = NULL;
#line 2462 "../src/View/AbstractDirectoryView.vala"
			file = (FilesFile*) file_it->data;
#line 12745 "AbstractDirectoryView.c"
			{
				FilesFile* _tmp1_;
#line 2463 "../src/View/AbstractDirectoryView.vala"
				_tmp1_ = file;
#line 2463 "../src/View/AbstractDirectoryView.vala"
				if (files_file_is_root_network_folder (_tmp1_)) {
#line 2464 "../src/View/AbstractDirectoryView.vala"
					result = FALSE;
#line 2464 "../src/View/AbstractDirectoryView.vala"
					return result;
#line 12756 "AbstractDirectoryView.c"
				}
			}
		}
	}
#line 2468 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 2468 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 12765 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_valid_selection_for_restore (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
	gboolean result;
#line 2471 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2472 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_files (self);
#line 12777 "AbstractDirectoryView.c"
	{
		GList* file_collection = NULL;
		GList* file_it = NULL;
#line 2472 "../src/View/AbstractDirectoryView.vala"
		file_collection = _tmp0_;
#line 2472 "../src/View/AbstractDirectoryView.vala"
		for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 12785 "AbstractDirectoryView.c"
			FilesFile* file = NULL;
#line 2472 "../src/View/AbstractDirectoryView.vala"
			file = (FilesFile*) file_it->data;
#line 12789 "AbstractDirectoryView.c"
			{
				FilesFile* _tmp1_;
				GFile* _tmp2_;
				GFile* _tmp3_;
				gchar* _tmp4_;
				gchar* _tmp5_;
				gboolean _tmp6_;
#line 2473 "../src/View/AbstractDirectoryView.vala"
				_tmp1_ = file;
#line 2473 "../src/View/AbstractDirectoryView.vala"
				_tmp2_ = files_file_get_directory (_tmp1_);
#line 2473 "../src/View/AbstractDirectoryView.vala"
				_tmp3_ = _tmp2_;
#line 2473 "../src/View/AbstractDirectoryView.vala"
				_tmp4_ = g_file_get_basename (_tmp3_);
#line 2473 "../src/View/AbstractDirectoryView.vala"
				_tmp5_ = _tmp4_;
#line 2473 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = !(g_strcmp0 (_tmp5_, "/") == 0);
#line 2473 "../src/View/AbstractDirectoryView.vala"
				_g_free0 (_tmp5_);
#line 2473 "../src/View/AbstractDirectoryView.vala"
				if (_tmp6_) {
#line 2474 "../src/View/AbstractDirectoryView.vala"
					result = FALSE;
#line 2474 "../src/View/AbstractDirectoryView.vala"
					return result;
#line 12817 "AbstractDirectoryView.c"
				}
			}
		}
	}
#line 2478 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 2478 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 12826 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_update_menu_actions (FilesAbstractDirectoryView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GList* selection = NULL;
	GList* _tmp8_;
	FilesFile* file = NULL;
	gboolean is_selected = FALSE;
	GList* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean more_than_one_selected = FALSE;
	gboolean single_folder = FALSE;
	gboolean only_folders = FALSE;
	GList* _tmp14_;
	gboolean can_rename = FALSE;
	gboolean can_show_properties = FALSE;
	gboolean can_copy = FALSE;
	gboolean can_open = FALSE;
	gboolean can_paste_into = FALSE;
	gboolean can_bookmark = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	FilesFile* _tmp46_;
	FilesFile* _tmp47_;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_;
	gboolean _tmp50_ = FALSE;
	gboolean _tmp51_;
	GSimpleActionGroup* _tmp52_;
	GSimpleActionGroup* _tmp53_;
	gboolean _tmp54_;
	GSimpleActionGroup* _tmp55_;
	gboolean _tmp56_;
	gboolean _tmp57_ = FALSE;
	gboolean _tmp58_;
	GSimpleActionGroup* _tmp59_;
	GSimpleActionGroup* _tmp60_;
	gboolean _tmp61_;
	gboolean _tmp62_ = FALSE;
	gboolean _tmp63_ = FALSE;
	gboolean _tmp64_ = FALSE;
	gboolean _tmp65_;
	GSimpleActionGroup* _tmp66_;
	gboolean _tmp67_ = FALSE;
	gboolean _tmp68_;
	GSimpleActionGroup* _tmp69_;
	gboolean _tmp70_ = FALSE;
	gboolean _tmp71_;
	GSimpleActionGroup* _tmp72_;
	gboolean _tmp73_ = FALSE;
	gboolean _tmp74_;
	GSimpleActionGroup* _tmp75_;
	gboolean _tmp76_ = FALSE;
	gboolean _tmp77_ = FALSE;
	gboolean _tmp78_;
	GSimpleActionGroup* _tmp79_;
	gboolean _tmp80_ = FALSE;
	gboolean _tmp81_ = FALSE;
	gboolean _tmp82_;
	GSimpleActionGroup* _tmp88_;
	gboolean _tmp89_ = FALSE;
	gboolean _tmp90_;
	GSimpleActionGroup* _tmp91_;
	gboolean _tmp92_ = FALSE;
	gboolean _tmp93_;
	GSimpleActionGroup* _tmp94_;
	gboolean _tmp95_ = FALSE;
	gboolean _tmp96_;
	GSimpleActionGroup* _tmp97_;
	gboolean _tmp98_ = FALSE;
	gboolean _tmp99_;
	GSimpleActionGroup* _tmp100_;
	gboolean _tmp101_ = FALSE;
	gboolean _tmp102_;
	GSimpleActionGroup* _tmp103_;
	gboolean _tmp104_ = FALSE;
	gboolean _tmp105_ = FALSE;
	gboolean _tmp106_;
	GSimpleActionGroup* _tmp107_;
	gboolean _tmp108_ = FALSE;
	gboolean _tmp109_ = FALSE;
	gboolean _tmp110_ = FALSE;
	gboolean _tmp111_;
	GSimpleActionGroup* _tmp113_;
	gboolean _tmp114_ = FALSE;
	gboolean _tmp115_;
	GSimpleActionGroup* _tmp116_;
	GList* _tmp117_;
#line 2481 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2482 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_is_frozen (self);
#line 2482 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 2482 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 2482 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 12929 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp3_;
		FilesDirectory* _tmp4_;
		FilesDirectory* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 2482 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = self->slot;
#line 2482 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp3_);
#line 2482 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = _tmp4_;
#line 2482 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = files_directory_get_can_load (_tmp5_);
#line 2482 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp6_;
#line 2482 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = !_tmp7_;
#line 12948 "AbstractDirectoryView.c"
	}
#line 2482 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 2483 "../src/View/AbstractDirectoryView.vala"
		return;
#line 12954 "AbstractDirectoryView.c"
	}
#line 2486 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = files_abstract_directory_view_get_files_for_action (self);
#line 2486 "../src/View/AbstractDirectoryView.vala"
	selection = _tmp8_;
#line 2489 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = selection;
#line 2489 "../src/View/AbstractDirectoryView.vala"
	is_selected = _tmp9_ != NULL;
#line 2490 "../src/View/AbstractDirectoryView.vala"
	if (is_selected) {
#line 12966 "AbstractDirectoryView.c"
		GList* _tmp11_;
		GList* _tmp12_;
		GList* _tmp13_;
#line 2490 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = selection;
#line 2490 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = g_list_first (_tmp11_);
#line 2490 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = _tmp12_->next;
#line 2490 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = _tmp13_ != NULL;
#line 12978 "AbstractDirectoryView.c"
	} else {
#line 2490 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = FALSE;
#line 12982 "AbstractDirectoryView.c"
	}
#line 2490 "../src/View/AbstractDirectoryView.vala"
	more_than_one_selected = _tmp10_;
#line 2491 "../src/View/AbstractDirectoryView.vala"
	single_folder = FALSE;
#line 2492 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = selection;
#line 2492 "../src/View/AbstractDirectoryView.vala"
	only_folders = files_abstract_directory_view_selection_only_contains_folders (self, _tmp14_);
#line 2493 "../src/View/AbstractDirectoryView.vala"
	can_rename = FALSE;
#line 2494 "../src/View/AbstractDirectoryView.vala"
	can_show_properties = FALSE;
#line 2495 "../src/View/AbstractDirectoryView.vala"
	can_copy = FALSE;
#line 2496 "../src/View/AbstractDirectoryView.vala"
	can_open = FALSE;
#line 2497 "../src/View/AbstractDirectoryView.vala"
	can_paste_into = FALSE;
#line 2498 "../src/View/AbstractDirectoryView.vala"
	can_bookmark = FALSE;
#line 2500 "../src/View/AbstractDirectoryView.vala"
	if (is_selected) {
#line 13006 "AbstractDirectoryView.c"
		GList* _tmp15_;
		gconstpointer _tmp16_;
		FilesFile* _tmp17_;
		FilesFile* _tmp18_;
#line 2501 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = selection;
#line 2501 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = _tmp15_->data;
#line 2501 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = _g_object_ref0 ((FilesFile*) _tmp16_);
#line 2501 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 2501 "../src/View/AbstractDirectoryView.vala"
		file = _tmp17_;
#line 2502 "../src/View/AbstractDirectoryView.vala"
		_tmp18_ = file;
#line 2502 "../src/View/AbstractDirectoryView.vala"
		if (_tmp18_ != NULL) {
#line 13025 "AbstractDirectoryView.c"
			gboolean _tmp19_ = FALSE;
			gboolean _tmp21_ = FALSE;
#line 2503 "../src/View/AbstractDirectoryView.vala"
			if (!more_than_one_selected) {
#line 13030 "AbstractDirectoryView.c"
				FilesFile* _tmp20_;
#line 2503 "../src/View/AbstractDirectoryView.vala"
				_tmp20_ = file;
#line 2503 "../src/View/AbstractDirectoryView.vala"
				_tmp19_ = files_file_is_folder (_tmp20_);
#line 13036 "AbstractDirectoryView.c"
			} else {
#line 2503 "../src/View/AbstractDirectoryView.vala"
				_tmp19_ = FALSE;
#line 13040 "AbstractDirectoryView.c"
			}
#line 2503 "../src/View/AbstractDirectoryView.vala"
			single_folder = _tmp19_;
#line 2504 "../src/View/AbstractDirectoryView.vala"
			can_rename = self->is_writable;
#line 2505 "../src/View/AbstractDirectoryView.vala"
			if (single_folder) {
#line 13048 "AbstractDirectoryView.c"
				FilesFile* _tmp22_;
#line 2505 "../src/View/AbstractDirectoryView.vala"
				_tmp22_ = file;
#line 2505 "../src/View/AbstractDirectoryView.vala"
				_tmp21_ = files_file_is_writable (_tmp22_);
#line 13054 "AbstractDirectoryView.c"
			} else {
#line 2505 "../src/View/AbstractDirectoryView.vala"
				_tmp21_ = FALSE;
#line 13058 "AbstractDirectoryView.c"
			}
#line 2505 "../src/View/AbstractDirectoryView.vala"
			can_paste_into = _tmp21_;
#line 13062 "AbstractDirectoryView.c"
		} else {
#line 2507 "../src/View/AbstractDirectoryView.vala"
			g_critical ("AbstractDirectoryView.vala:2507: File in selection is null");
#line 13066 "AbstractDirectoryView.c"
		}
	} else {
		FilesViewSlot* _tmp23_;
		FilesDirectory* _tmp24_;
		FilesDirectory* _tmp25_;
		FilesFile* _tmp26_;
		FilesFile* _tmp27_;
		FilesFile* _tmp28_;
		gboolean _tmp29_ = FALSE;
#line 2510 "../src/View/AbstractDirectoryView.vala"
		_tmp23_ = self->slot;
#line 2510 "../src/View/AbstractDirectoryView.vala"
		_tmp24_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp23_);
#line 2510 "../src/View/AbstractDirectoryView.vala"
		_tmp25_ = _tmp24_;
#line 2510 "../src/View/AbstractDirectoryView.vala"
		_tmp26_ = files_directory_get_file (_tmp25_);
#line 2510 "../src/View/AbstractDirectoryView.vala"
		_tmp27_ = _tmp26_;
#line 2510 "../src/View/AbstractDirectoryView.vala"
		_tmp28_ = _g_object_ref0 (_tmp27_);
#line 2510 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 2510 "../src/View/AbstractDirectoryView.vala"
		file = _tmp28_;
#line 2511 "../src/View/AbstractDirectoryView.vala"
		if (!more_than_one_selected) {
#line 13094 "AbstractDirectoryView.c"
			FilesFile* _tmp30_;
#line 2511 "../src/View/AbstractDirectoryView.vala"
			_tmp30_ = file;
#line 2511 "../src/View/AbstractDirectoryView.vala"
			_tmp29_ = files_file_is_folder (_tmp30_);
#line 13100 "AbstractDirectoryView.c"
		} else {
#line 2511 "../src/View/AbstractDirectoryView.vala"
			_tmp29_ = FALSE;
#line 13104 "AbstractDirectoryView.c"
		}
#line 2511 "../src/View/AbstractDirectoryView.vala"
		single_folder = _tmp29_;
#line 2512 "../src/View/AbstractDirectoryView.vala"
		can_paste_into = self->is_writable;
#line 13110 "AbstractDirectoryView.c"
	}
#line 2517 "../src/View/AbstractDirectoryView.vala"
	if (!more_than_one_selected) {
#line 2517 "../src/View/AbstractDirectoryView.vala"
		_tmp32_ = TRUE;
#line 13116 "AbstractDirectoryView.c"
	} else {
#line 2517 "../src/View/AbstractDirectoryView.vala"
		_tmp32_ = single_folder;
#line 13120 "AbstractDirectoryView.c"
	}
#line 2517 "../src/View/AbstractDirectoryView.vala"
	if (_tmp32_) {
#line 13124 "AbstractDirectoryView.c"
		gboolean _tmp33_ = FALSE;
		gboolean _tmp34_ = FALSE;
		FilesViewSlot* _tmp35_;
		FilesDirectory* _tmp36_;
		FilesDirectory* _tmp37_;
		gboolean _tmp38_;
		gboolean _tmp39_;
#line 2518 "../src/View/AbstractDirectoryView.vala"
		_tmp35_ = self->slot;
#line 2518 "../src/View/AbstractDirectoryView.vala"
		_tmp36_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp35_);
#line 2518 "../src/View/AbstractDirectoryView.vala"
		_tmp37_ = _tmp36_;
#line 2518 "../src/View/AbstractDirectoryView.vala"
		_tmp38_ = files_directory_get_is_local (_tmp37_);
#line 2518 "../src/View/AbstractDirectoryView.vala"
		_tmp39_ = _tmp38_;
#line 2518 "../src/View/AbstractDirectoryView.vala"
		if (_tmp39_) {
#line 2518 "../src/View/AbstractDirectoryView.vala"
			_tmp34_ = TRUE;
#line 13146 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp40_ = FALSE;
			FilesFile* _tmp41_;
			const gchar* _tmp42_;
#line 2519 "../src/View/AbstractDirectoryView.vala"
			_tmp41_ = file;
#line 2519 "../src/View/AbstractDirectoryView.vala"
			_tmp42_ = files_file_get_ftype (_tmp41_);
#line 2519 "../src/View/AbstractDirectoryView.vala"
			if (_tmp42_ != NULL) {
#line 13157 "AbstractDirectoryView.c"
				FilesFile* _tmp43_;
				const gchar* _tmp44_;
#line 2519 "../src/View/AbstractDirectoryView.vala"
				_tmp43_ = file;
#line 2519 "../src/View/AbstractDirectoryView.vala"
				_tmp44_ = files_file_get_ftype (_tmp43_);
#line 2519 "../src/View/AbstractDirectoryView.vala"
				_tmp40_ = g_strcmp0 (_tmp44_, "inode/directory") == 0;
#line 13166 "AbstractDirectoryView.c"
			} else {
#line 2519 "../src/View/AbstractDirectoryView.vala"
				_tmp40_ = FALSE;
#line 13170 "AbstractDirectoryView.c"
			}
#line 2519 "../src/View/AbstractDirectoryView.vala"
			_tmp34_ = _tmp40_;
#line 13174 "AbstractDirectoryView.c"
		}
#line 2518 "../src/View/AbstractDirectoryView.vala"
		if (_tmp34_) {
#line 2518 "../src/View/AbstractDirectoryView.vala"
			_tmp33_ = TRUE;
#line 13180 "AbstractDirectoryView.c"
		} else {
			FilesFile* _tmp45_;
#line 2520 "../src/View/AbstractDirectoryView.vala"
			_tmp45_ = file;
#line 2520 "../src/View/AbstractDirectoryView.vala"
			_tmp33_ = files_file_is_smb_server (_tmp45_);
#line 13187 "AbstractDirectoryView.c"
		}
#line 2518 "../src/View/AbstractDirectoryView.vala"
		_tmp31_ = _tmp33_;
#line 13191 "AbstractDirectoryView.c"
	} else {
#line 2517 "../src/View/AbstractDirectoryView.vala"
		_tmp31_ = FALSE;
#line 13195 "AbstractDirectoryView.c"
	}
#line 2517 "../src/View/AbstractDirectoryView.vala"
	can_bookmark = _tmp31_;
#line 2522 "../src/View/AbstractDirectoryView.vala"
	_tmp46_ = file;
#line 2522 "../src/View/AbstractDirectoryView.vala"
	can_copy = files_file_is_readable (_tmp46_);
#line 2523 "../src/View/AbstractDirectoryView.vala"
	_tmp47_ = file;
#line 2523 "../src/View/AbstractDirectoryView.vala"
	can_open = files_abstract_directory_view_can_open_file (self, _tmp47_, FALSE);
#line 2524 "../src/View/AbstractDirectoryView.vala"
	_tmp49_ = self->priv->_in_recent;
#line 2524 "../src/View/AbstractDirectoryView.vala"
	if (_tmp49_) {
#line 2524 "../src/View/AbstractDirectoryView.vala"
		_tmp48_ = more_than_one_selected;
#line 13213 "AbstractDirectoryView.c"
	} else {
#line 2524 "../src/View/AbstractDirectoryView.vala"
		_tmp48_ = FALSE;
#line 13217 "AbstractDirectoryView.c"
	}
#line 2524 "../src/View/AbstractDirectoryView.vala"
	can_show_properties = !_tmp48_;
#line 2526 "../src/View/AbstractDirectoryView.vala"
	_tmp51_ = self->priv->_in_recent;
#line 2526 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp51_) {
#line 2526 "../src/View/AbstractDirectoryView.vala"
		_tmp50_ = self->is_writable;
#line 13227 "AbstractDirectoryView.c"
	} else {
#line 2526 "../src/View/AbstractDirectoryView.vala"
		_tmp50_ = FALSE;
#line 13231 "AbstractDirectoryView.c"
	}
#line 2526 "../src/View/AbstractDirectoryView.vala"
	_tmp52_ = self->priv->common_actions;
#line 2526 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp52_, "paste", _tmp50_);
#line 2527 "../src/View/AbstractDirectoryView.vala"
	_tmp53_ = self->priv->common_actions;
#line 2527 "../src/View/AbstractDirectoryView.vala"
	_tmp54_ = self->priv->_renaming;
#line 2527 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp53_, "paste-into", (!_tmp54_) & can_paste_into);
#line 2528 "../src/View/AbstractDirectoryView.vala"
	_tmp55_ = self->priv->common_actions;
#line 2528 "../src/View/AbstractDirectoryView.vala"
	_tmp56_ = self->priv->_renaming;
#line 2528 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp55_, "open-in", (!_tmp56_) & only_folders);
#line 2529 "../src/View/AbstractDirectoryView.vala"
	_tmp58_ = self->priv->_renaming;
#line 2529 "../src/View/AbstractDirectoryView.vala"
	if ((!_tmp58_) & is_selected) {
#line 2529 "../src/View/AbstractDirectoryView.vala"
		_tmp57_ = can_rename;
#line 13255 "AbstractDirectoryView.c"
	} else {
#line 2529 "../src/View/AbstractDirectoryView.vala"
		_tmp57_ = FALSE;
#line 13259 "AbstractDirectoryView.c"
	}
#line 2529 "../src/View/AbstractDirectoryView.vala"
	_tmp59_ = self->priv->selection_actions;
#line 2529 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp59_, "rename", _tmp57_);
#line 2530 "../src/View/AbstractDirectoryView.vala"
	_tmp60_ = self->priv->selection_actions;
#line 2530 "../src/View/AbstractDirectoryView.vala"
	_tmp61_ = self->priv->_renaming;
#line 2530 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp60_, "view-in-location", (!_tmp61_) & is_selected);
#line 2531 "../src/View/AbstractDirectoryView.vala"
	_tmp65_ = self->priv->_renaming;
#line 2531 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp65_) {
#line 2531 "../src/View/AbstractDirectoryView.vala"
		_tmp64_ = is_selected;
#line 13277 "AbstractDirectoryView.c"
	} else {
#line 2531 "../src/View/AbstractDirectoryView.vala"
		_tmp64_ = FALSE;
#line 13281 "AbstractDirectoryView.c"
	}
#line 2531 "../src/View/AbstractDirectoryView.vala"
	if (_tmp64_) {
#line 2531 "../src/View/AbstractDirectoryView.vala"
		_tmp63_ = !more_than_one_selected;
#line 13287 "AbstractDirectoryView.c"
	} else {
#line 2531 "../src/View/AbstractDirectoryView.vala"
		_tmp63_ = FALSE;
#line 13291 "AbstractDirectoryView.c"
	}
#line 2531 "../src/View/AbstractDirectoryView.vala"
	if (_tmp63_) {
#line 2531 "../src/View/AbstractDirectoryView.vala"
		_tmp62_ = can_open;
#line 13297 "AbstractDirectoryView.c"
	} else {
#line 2531 "../src/View/AbstractDirectoryView.vala"
		_tmp62_ = FALSE;
#line 13301 "AbstractDirectoryView.c"
	}
#line 2531 "../src/View/AbstractDirectoryView.vala"
	_tmp66_ = self->priv->selection_actions;
#line 2531 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp66_, "open", _tmp62_);
#line 2532 "../src/View/AbstractDirectoryView.vala"
	_tmp68_ = self->priv->_renaming;
#line 2532 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp68_) {
#line 2532 "../src/View/AbstractDirectoryView.vala"
		_tmp67_ = can_open;
#line 13313 "AbstractDirectoryView.c"
	} else {
#line 2532 "../src/View/AbstractDirectoryView.vala"
		_tmp67_ = FALSE;
#line 13317 "AbstractDirectoryView.c"
	}
#line 2532 "../src/View/AbstractDirectoryView.vala"
	_tmp69_ = self->priv->selection_actions;
#line 2532 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp69_, "open-with-app", _tmp67_);
#line 2533 "../src/View/AbstractDirectoryView.vala"
	_tmp71_ = self->priv->_renaming;
#line 2533 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp71_) {
#line 2533 "../src/View/AbstractDirectoryView.vala"
		_tmp70_ = can_open;
#line 13329 "AbstractDirectoryView.c"
	} else {
#line 2533 "../src/View/AbstractDirectoryView.vala"
		_tmp70_ = FALSE;
#line 13333 "AbstractDirectoryView.c"
	}
#line 2533 "../src/View/AbstractDirectoryView.vala"
	_tmp72_ = self->priv->selection_actions;
#line 2533 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp72_, "open-with-default", _tmp70_);
#line 2534 "../src/View/AbstractDirectoryView.vala"
	_tmp74_ = self->priv->_renaming;
#line 2534 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp74_) {
#line 2534 "../src/View/AbstractDirectoryView.vala"
		_tmp73_ = can_open;
#line 13345 "AbstractDirectoryView.c"
	} else {
#line 2534 "../src/View/AbstractDirectoryView.vala"
		_tmp73_ = FALSE;
#line 13349 "AbstractDirectoryView.c"
	}
#line 2534 "../src/View/AbstractDirectoryView.vala"
	_tmp75_ = self->priv->selection_actions;
#line 2534 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp75_, "open-with-other-app", _tmp73_);
#line 2535 "../src/View/AbstractDirectoryView.vala"
	_tmp78_ = self->priv->_renaming;
#line 2535 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp78_) {
#line 2535 "../src/View/AbstractDirectoryView.vala"
		_tmp77_ = self->is_writable;
#line 13361 "AbstractDirectoryView.c"
	} else {
#line 2535 "../src/View/AbstractDirectoryView.vala"
		_tmp77_ = FALSE;
#line 13365 "AbstractDirectoryView.c"
	}
#line 2535 "../src/View/AbstractDirectoryView.vala"
	if (_tmp77_) {
#line 2535 "../src/View/AbstractDirectoryView.vala"
		_tmp76_ = is_selected;
#line 13371 "AbstractDirectoryView.c"
	} else {
#line 2535 "../src/View/AbstractDirectoryView.vala"
		_tmp76_ = FALSE;
#line 13375 "AbstractDirectoryView.c"
	}
#line 2535 "../src/View/AbstractDirectoryView.vala"
	_tmp79_ = self->priv->selection_actions;
#line 2535 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp79_, "cut", _tmp76_);
#line 2536 "../src/View/AbstractDirectoryView.vala"
	_tmp82_ = self->priv->_renaming;
#line 2536 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp82_) {
#line 2536 "../src/View/AbstractDirectoryView.vala"
		_tmp81_ = self->is_writable;
#line 13387 "AbstractDirectoryView.c"
	} else {
#line 2536 "../src/View/AbstractDirectoryView.vala"
		_tmp81_ = FALSE;
#line 13391 "AbstractDirectoryView.c"
	}
#line 2536 "../src/View/AbstractDirectoryView.vala"
	if (_tmp81_) {
#line 13395 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp83_;
		FilesDirectory* _tmp84_;
		FilesDirectory* _tmp85_;
		gboolean _tmp86_;
		gboolean _tmp87_;
#line 2536 "../src/View/AbstractDirectoryView.vala"
		_tmp83_ = self->slot;
#line 2536 "../src/View/AbstractDirectoryView.vala"
		_tmp84_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp83_);
#line 2536 "../src/View/AbstractDirectoryView.vala"
		_tmp85_ = _tmp84_;
#line 2536 "../src/View/AbstractDirectoryView.vala"
		_tmp86_ = files_directory_get_has_trash_dirs (_tmp85_);
#line 2536 "../src/View/AbstractDirectoryView.vala"
		_tmp87_ = _tmp86_;
#line 2536 "../src/View/AbstractDirectoryView.vala"
		_tmp80_ = _tmp87_;
#line 13413 "AbstractDirectoryView.c"
	} else {
#line 2536 "../src/View/AbstractDirectoryView.vala"
		_tmp80_ = FALSE;
#line 13417 "AbstractDirectoryView.c"
	}
#line 2536 "../src/View/AbstractDirectoryView.vala"
	_tmp88_ = self->priv->selection_actions;
#line 2536 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp88_, "trash", _tmp80_);
#line 2537 "../src/View/AbstractDirectoryView.vala"
	_tmp90_ = self->priv->_renaming;
#line 2537 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp90_) {
#line 2537 "../src/View/AbstractDirectoryView.vala"
		_tmp89_ = self->is_writable;
#line 13429 "AbstractDirectoryView.c"
	} else {
#line 2537 "../src/View/AbstractDirectoryView.vala"
		_tmp89_ = FALSE;
#line 13433 "AbstractDirectoryView.c"
	}
#line 2537 "../src/View/AbstractDirectoryView.vala"
	_tmp91_ = self->priv->selection_actions;
#line 2537 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp91_, "delete", _tmp89_);
#line 2538 "../src/View/AbstractDirectoryView.vala"
	_tmp93_ = self->priv->_renaming;
#line 2538 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp93_) {
#line 2538 "../src/View/AbstractDirectoryView.vala"
		_tmp92_ = is_selected;
#line 13445 "AbstractDirectoryView.c"
	} else {
#line 2538 "../src/View/AbstractDirectoryView.vala"
		_tmp92_ = FALSE;
#line 13449 "AbstractDirectoryView.c"
	}
#line 2538 "../src/View/AbstractDirectoryView.vala"
	_tmp94_ = self->priv->selection_actions;
#line 2538 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp94_, "invert-selection", _tmp92_);
#line 2539 "../src/View/AbstractDirectoryView.vala"
	_tmp96_ = self->priv->_renaming;
#line 2539 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp96_) {
#line 2539 "../src/View/AbstractDirectoryView.vala"
		_tmp95_ = is_selected;
#line 13461 "AbstractDirectoryView.c"
	} else {
#line 2539 "../src/View/AbstractDirectoryView.vala"
		_tmp95_ = FALSE;
#line 13465 "AbstractDirectoryView.c"
	}
#line 2539 "../src/View/AbstractDirectoryView.vala"
	_tmp97_ = self->priv->common_actions;
#line 2539 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp97_, "select-all", _tmp95_);
#line 2540 "../src/View/AbstractDirectoryView.vala"
	_tmp99_ = self->priv->_renaming;
#line 2540 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp99_) {
#line 2540 "../src/View/AbstractDirectoryView.vala"
		_tmp98_ = can_show_properties;
#line 13477 "AbstractDirectoryView.c"
	} else {
#line 2540 "../src/View/AbstractDirectoryView.vala"
		_tmp98_ = FALSE;
#line 13481 "AbstractDirectoryView.c"
	}
#line 2540 "../src/View/AbstractDirectoryView.vala"
	_tmp100_ = self->priv->common_actions;
#line 2540 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp100_, "properties", _tmp98_);
#line 2541 "../src/View/AbstractDirectoryView.vala"
	_tmp102_ = self->priv->_renaming;
#line 2541 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp102_) {
#line 2541 "../src/View/AbstractDirectoryView.vala"
		_tmp101_ = can_bookmark;
#line 13493 "AbstractDirectoryView.c"
	} else {
#line 2541 "../src/View/AbstractDirectoryView.vala"
		_tmp101_ = FALSE;
#line 13497 "AbstractDirectoryView.c"
	}
#line 2541 "../src/View/AbstractDirectoryView.vala"
	_tmp103_ = self->priv->common_actions;
#line 2541 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp103_, "bookmark", _tmp101_);
#line 2542 "../src/View/AbstractDirectoryView.vala"
	_tmp106_ = self->priv->_renaming;
#line 2542 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp106_) {
#line 2542 "../src/View/AbstractDirectoryView.vala"
		_tmp105_ = !self->priv->in_trash;
#line 13509 "AbstractDirectoryView.c"
	} else {
#line 2542 "../src/View/AbstractDirectoryView.vala"
		_tmp105_ = FALSE;
#line 13513 "AbstractDirectoryView.c"
	}
#line 2542 "../src/View/AbstractDirectoryView.vala"
	if (_tmp105_) {
#line 2542 "../src/View/AbstractDirectoryView.vala"
		_tmp104_ = can_copy;
#line 13519 "AbstractDirectoryView.c"
	} else {
#line 2542 "../src/View/AbstractDirectoryView.vala"
		_tmp104_ = FALSE;
#line 13523 "AbstractDirectoryView.c"
	}
#line 2542 "../src/View/AbstractDirectoryView.vala"
	_tmp107_ = self->priv->common_actions;
#line 2542 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp107_, "copy", _tmp104_);
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_tmp111_ = self->priv->_renaming;
#line 2543 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp111_) {
#line 2543 "../src/View/AbstractDirectoryView.vala"
		_tmp110_ = !self->priv->in_trash;
#line 13535 "AbstractDirectoryView.c"
	} else {
#line 2543 "../src/View/AbstractDirectoryView.vala"
		_tmp110_ = FALSE;
#line 13539 "AbstractDirectoryView.c"
	}
#line 2543 "../src/View/AbstractDirectoryView.vala"
	if (_tmp110_) {
#line 13543 "AbstractDirectoryView.c"
		gboolean _tmp112_;
#line 2543 "../src/View/AbstractDirectoryView.vala"
		_tmp112_ = self->priv->_in_recent;
#line 2543 "../src/View/AbstractDirectoryView.vala"
		_tmp109_ = !_tmp112_;
#line 13549 "AbstractDirectoryView.c"
	} else {
#line 2543 "../src/View/AbstractDirectoryView.vala"
		_tmp109_ = FALSE;
#line 13553 "AbstractDirectoryView.c"
	}
#line 2543 "../src/View/AbstractDirectoryView.vala"
	if (_tmp109_) {
#line 2543 "../src/View/AbstractDirectoryView.vala"
		_tmp108_ = can_copy;
#line 13559 "AbstractDirectoryView.c"
	} else {
#line 2543 "../src/View/AbstractDirectoryView.vala"
		_tmp108_ = FALSE;
#line 13563 "AbstractDirectoryView.c"
	}
#line 2543 "../src/View/AbstractDirectoryView.vala"
	_tmp113_ = self->priv->common_actions;
#line 2543 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp113_, "copy-link", _tmp108_);
#line 2544 "../src/View/AbstractDirectoryView.vala"
	_tmp115_ = self->priv->_renaming;
#line 2544 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp115_) {
#line 2544 "../src/View/AbstractDirectoryView.vala"
		_tmp114_ = !more_than_one_selected;
#line 13575 "AbstractDirectoryView.c"
	} else {
#line 2544 "../src/View/AbstractDirectoryView.vala"
		_tmp114_ = FALSE;
#line 13579 "AbstractDirectoryView.c"
	}
#line 2544 "../src/View/AbstractDirectoryView.vala"
	_tmp116_ = self->priv->common_actions;
#line 2544 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_action_set_enabled (self, _tmp116_, "bookmark", _tmp114_);
#line 2546 "../src/View/AbstractDirectoryView.vala"
	_tmp117_ = selection;
#line 2546 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_default_app (self, _tmp117_);
#line 2547 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_menu_actions_sort (self);
#line 2481 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 2481 "../src/View/AbstractDirectoryView.vala"
	(selection == NULL) ? NULL : (selection = (_g_list_free__g_object_unref0_ (selection), NULL));
#line 13595 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_update_menu_actions_sort (FilesAbstractDirectoryView* self)
{
	gint sort_column_id = 0;
	GtkSortType sort_order = 0;
	FilesListModel* _tmp0_;
	gint _tmp1_ = 0;
	GtkSortType _tmp2_ = 0;
	gboolean _tmp3_;
#line 2550 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2554 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 2554 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) _tmp0_, &_tmp1_, &_tmp2_);
#line 2554 "../src/View/AbstractDirectoryView.vala"
	sort_column_id = _tmp1_;
#line 2554 "../src/View/AbstractDirectoryView.vala"
	sort_order = _tmp2_;
#line 2554 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 13619 "AbstractDirectoryView.c"
		GVariant* val = NULL;
		const gchar* _tmp4_;
		GVariant* _tmp5_;
		GSimpleActionGroup* _tmp6_;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
		GSimpleActionGroup* _tmp9_;
		GVariant* _tmp10_;
		FilesPreferences* _tmp11_;
		FilesPreferences* _tmp12_;
		gboolean _tmp13_;
		gboolean _tmp14_;
		GVariant* _tmp15_;
		GSimpleActionGroup* _tmp16_;
		GVariant* _tmp17_;
#line 2555 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = files_list_model_column_id_to_string ((FilesListModelColumnID) sort_column_id);
#line 2555 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = g_variant_new_string (_tmp4_);
#line 2555 "../src/View/AbstractDirectoryView.vala"
		g_variant_ref_sink (_tmp5_);
#line 2555 "../src/View/AbstractDirectoryView.vala"
		val = _tmp5_;
#line 2556 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = self->priv->background_actions;
#line 2556 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = val;
#line 2556 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_action_set_state (self, _tmp6_, "sort-by", _tmp7_);
#line 2557 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = g_variant_new_boolean (sort_order == GTK_SORT_DESCENDING);
#line 2557 "../src/View/AbstractDirectoryView.vala"
		g_variant_ref_sink (_tmp8_);
#line 2557 "../src/View/AbstractDirectoryView.vala"
		_g_variant_unref0 (val);
#line 2557 "../src/View/AbstractDirectoryView.vala"
		val = _tmp8_;
#line 2558 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = self->priv->background_actions;
#line 2558 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = val;
#line 2558 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_action_set_state (self, _tmp9_, "reverse", _tmp10_);
#line 2559 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = files_preferences_get_default ();
#line 2559 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = _tmp11_;
#line 2559 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = files_preferences_get_sort_directories_first (_tmp12_);
#line 2559 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = _tmp13_;
#line 2559 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = g_variant_new_boolean (_tmp14_);
#line 2559 "../src/View/AbstractDirectoryView.vala"
		g_variant_ref_sink (_tmp15_);
#line 2559 "../src/View/AbstractDirectoryView.vala"
		_g_variant_unref0 (val);
#line 2559 "../src/View/AbstractDirectoryView.vala"
		val = _tmp15_;
#line 2559 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp12_);
#line 2560 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = self->priv->background_actions;
#line 2560 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = val;
#line 2560 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_action_set_state (self, _tmp16_, "folders-first", _tmp17_);
#line 2554 "../src/View/AbstractDirectoryView.vala"
		_g_variant_unref0 (val);
#line 13689 "AbstractDirectoryView.c"
	} else {
#line 2562 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:2562: Update menu actions sort: The model i" \
"s unsorted - this should not happen");
#line 13693 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_update_default_app (FilesAbstractDirectoryView* self,
                                                  GList* selection)
{
	GAppInfo* _tmp0_;
#line 2566 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2567 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_mime_actions_get_default_application_for_files (selection);
#line 2567 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->default_app);
#line 2567 "../src/View/AbstractDirectoryView.vala"
	self->priv->default_app = _tmp0_;
#line 2568 "../src/View/AbstractDirectoryView.vala"
	return;
#line 13712 "AbstractDirectoryView.c"
}

/** Menu helpers */
static void
files_abstract_directory_view_action_set_enabled (FilesAbstractDirectoryView* self,
                                                  GSimpleActionGroup* action_group,
                                                  const gchar* name,
                                                  gboolean enabled)
{
#line 2573 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2573 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (name != NULL);
#line 2574 "../src/View/AbstractDirectoryView.vala"
	if (action_group != NULL) {
#line 13728 "AbstractDirectoryView.c"
		GSimpleAction* action = NULL;
		GAction* _tmp0_;
		GSimpleAction* _tmp1_;
		GSimpleAction* _tmp2_;
#line 2575 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = g_action_map_lookup_action ((GActionMap*) action_group, name);
#line 2575 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp0_) : NULL);
#line 2575 "../src/View/AbstractDirectoryView.vala"
		action = _tmp1_;
#line 2576 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = action;
#line 2576 "../src/View/AbstractDirectoryView.vala"
		if (_tmp2_ != NULL) {
#line 13743 "AbstractDirectoryView.c"
			GSimpleAction* _tmp3_;
#line 2577 "../src/View/AbstractDirectoryView.vala"
			_tmp3_ = action;
#line 2577 "../src/View/AbstractDirectoryView.vala"
			g_simple_action_set_enabled (_tmp3_, enabled);
#line 2578 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (action);
#line 2578 "../src/View/AbstractDirectoryView.vala"
			return;
#line 13753 "AbstractDirectoryView.c"
		}
#line 2574 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (action);
#line 13757 "AbstractDirectoryView.c"
	}
#line 2581 "../src/View/AbstractDirectoryView.vala"
	g_critical ("AbstractDirectoryView.vala:2581: Action name not found: %s - cannot en" \
"able", name);
#line 13761 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_action_set_state (FilesAbstractDirectoryView* self,
                                                GSimpleActionGroup* action_group,
                                                const gchar* name,
                                                GVariant* val)
{
#line 2584 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2584 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (name != NULL);
#line 2584 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (val != NULL);
#line 2585 "../src/View/AbstractDirectoryView.vala"
	if (action_group != NULL) {
#line 13778 "AbstractDirectoryView.c"
		GSimpleAction* action = NULL;
		GAction* _tmp0_;
		GSimpleAction* _tmp1_;
		GSimpleAction* _tmp2_;
#line 2586 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = g_action_map_lookup_action ((GActionMap*) action_group, name);
#line 2586 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_simple_action_get_type ()) ? ((GSimpleAction*) _tmp0_) : NULL);
#line 2586 "../src/View/AbstractDirectoryView.vala"
		action = _tmp1_;
#line 2587 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = action;
#line 2587 "../src/View/AbstractDirectoryView.vala"
		if (_tmp2_ != NULL) {
#line 13793 "AbstractDirectoryView.c"
			GSimpleAction* _tmp3_;
#line 2588 "../src/View/AbstractDirectoryView.vala"
			_tmp3_ = action;
#line 2588 "../src/View/AbstractDirectoryView.vala"
			g_simple_action_set_state (_tmp3_, val);
#line 2589 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (action);
#line 2589 "../src/View/AbstractDirectoryView.vala"
			return;
#line 13803 "AbstractDirectoryView.c"
		}
#line 2585 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (action);
#line 13807 "AbstractDirectoryView.c"
	}
#line 2592 "../src/View/AbstractDirectoryView.vala"
	g_critical ("AbstractDirectoryView.vala:2592: Action name not found: %s - cannot se" \
"t state", name);
#line 13811 "AbstractDirectoryView.c"
}

static gint
___lambda41_ (GFile* a,
              GFile* b)
{
	GCompareFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gint _tmp9_;
	gint result;
#line 2626 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 2626 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_file_get_basename (a);
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = g_utf8_strdown (_tmp2_, (gssize) -1);
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = g_file_get_basename (b);
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_;
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = g_utf8_strdown (_tmp6_, (gssize) -1);
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = _tmp7_;
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _tmp0_ (_tmp4_, _tmp8_);
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp8_);
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp6_);
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp4_);
#line 2627 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp2_);
#line 2627 "../src/View/AbstractDirectoryView.vala"
	result = _tmp9_;
#line 2627 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 13865 "AbstractDirectoryView.c"
}

static gint
____lambda41__gcompare_func (gconstpointer a,
                             gconstpointer b)
{
	gint result;
	result = ___lambda41_ ((GFile*) a, (GFile*) b);
#line 2626 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 13876 "AbstractDirectoryView.c"
}

static void
___lambda42_ (GFile* folder)
{
#line 2639 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (folder != NULL);
#line 2640 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_load_templates_from_folder (folder);
#line 13886 "AbstractDirectoryView.c"
}

static void
____lambda42__gfunc (gconstpointer data,
                     gpointer self)
{
#line 2639 "../src/View/AbstractDirectoryView.vala"
	___lambda42_ ((GFile*) data);
#line 13895 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_load_templates_from_folder (GFile* template_folder)
{
	GList* file_list = NULL;
	GList* folder_list = NULL;
	GFileEnumerator* enumerator = NULL;
	GFileQueryInfoFlags flags = 0U;
	GList* _tmp24_;
	GList* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 2595 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (template_folder != NULL);
#line 2596 "../src/View/AbstractDirectoryView.vala"
	file_list = NULL;
#line 2597 "../src/View/AbstractDirectoryView.vala"
	folder_list = NULL;
#line 2600 "../src/View/AbstractDirectoryView.vala"
	flags = G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS;
#line 13916 "AbstractDirectoryView.c"
	{
		GFileEnumerator* _tmp0_ = NULL;
		GFileEnumerator* _tmp1_;
		GFileEnumerator* _tmp2_;
		guint count = 0U;
		GList* _tmp3_;
		GFile* location = NULL;
		GFileInfo* info = NULL;
		GFileEnumerator* _tmp4_;
		GFileInfo* _tmp5_;
#line 2602 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = g_file_enumerate_children (template_folder, "standard::*", flags, NULL, &_inner_error0_);
#line 2602 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp1_;
#line 2602 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13933 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 2602 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp0_;
#line 2602 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = NULL;
#line 2602 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (enumerator);
#line 2602 "../src/View/AbstractDirectoryView.vala"
		enumerator = _tmp2_;
#line 2603 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_abstract_directory_view_templates;
#line 2603 "../src/View/AbstractDirectoryView.vala"
		count = g_list_length (_tmp3_);
#line 2605 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = enumerator;
#line 2605 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = g_file_enumerator_next_file (_tmp4_, NULL, &_inner_error0_);
#line 2605 "../src/View/AbstractDirectoryView.vala"
		info = _tmp5_;
#line 2605 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2605 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (location);
#line 2605 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp0_);
#line 13960 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 2607 "../src/View/AbstractDirectoryView.vala"
		while (TRUE) {
#line 13965 "AbstractDirectoryView.c"
			gboolean _tmp6_ = FALSE;
			gboolean _tmp8_ = FALSE;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp20_ = NULL;
			GFileEnumerator* _tmp21_;
			GFileInfo* _tmp22_;
			GFileInfo* _tmp23_;
#line 2607 "../src/View/AbstractDirectoryView.vala"
			if (count < ((guint) FILES_ABSTRACT_DIRECTORY_VIEW_MAX_TEMPLATES)) {
#line 13975 "AbstractDirectoryView.c"
				GFileInfo* _tmp7_;
#line 2607 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = info;
#line 2607 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = _tmp7_ != NULL;
#line 13981 "AbstractDirectoryView.c"
			} else {
#line 2607 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = FALSE;
#line 13985 "AbstractDirectoryView.c"
			}
#line 2607 "../src/View/AbstractDirectoryView.vala"
			if (!_tmp6_) {
#line 2607 "../src/View/AbstractDirectoryView.vala"
				break;
#line 13991 "AbstractDirectoryView.c"
			}
#line 2608 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = info;
#line 2608 "../src/View/AbstractDirectoryView.vala"
			if (!g_file_info_get_attribute_boolean (_tmp9_, G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN)) {
#line 13997 "AbstractDirectoryView.c"
				GFileInfo* _tmp10_;
#line 2609 "../src/View/AbstractDirectoryView.vala"
				_tmp10_ = info;
#line 2609 "../src/View/AbstractDirectoryView.vala"
				_tmp8_ = !g_file_info_get_attribute_boolean (_tmp10_, G_FILE_ATTRIBUTE_STANDARD_IS_BACKUP);
#line 14003 "AbstractDirectoryView.c"
			} else {
#line 2608 "../src/View/AbstractDirectoryView.vala"
				_tmp8_ = FALSE;
#line 14007 "AbstractDirectoryView.c"
			}
#line 2608 "../src/View/AbstractDirectoryView.vala"
			if (_tmp8_) {
#line 14011 "AbstractDirectoryView.c"
				GFileInfo* _tmp11_;
				const gchar* _tmp12_;
				GFile* _tmp13_;
				GFileInfo* _tmp14_;
#line 2610 "../src/View/AbstractDirectoryView.vala"
				_tmp11_ = info;
#line 2610 "../src/View/AbstractDirectoryView.vala"
				_tmp12_ = g_file_info_get_name (_tmp11_);
#line 2610 "../src/View/AbstractDirectoryView.vala"
				_tmp13_ = g_file_get_child (template_folder, _tmp12_);
#line 2610 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (location);
#line 2610 "../src/View/AbstractDirectoryView.vala"
				location = _tmp13_;
#line 2611 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = info;
#line 2611 "../src/View/AbstractDirectoryView.vala"
				if (g_file_info_get_file_type (_tmp14_) == G_FILE_TYPE_DIRECTORY) {
#line 14030 "AbstractDirectoryView.c"
					GFile* _tmp15_;
					GFile* _tmp16_;
#line 2612 "../src/View/AbstractDirectoryView.vala"
					_tmp15_ = location;
#line 2612 "../src/View/AbstractDirectoryView.vala"
					_tmp16_ = _g_object_ref0 (_tmp15_);
#line 2612 "../src/View/AbstractDirectoryView.vala"
					folder_list = g_list_prepend (folder_list, _tmp16_);
#line 14039 "AbstractDirectoryView.c"
				} else {
					GFile* _tmp17_;
					GFile* _tmp18_;
					guint _tmp19_;
#line 2614 "../src/View/AbstractDirectoryView.vala"
					_tmp17_ = location;
#line 2614 "../src/View/AbstractDirectoryView.vala"
					_tmp18_ = _g_object_ref0 (_tmp17_);
#line 2614 "../src/View/AbstractDirectoryView.vala"
					file_list = g_list_prepend (file_list, _tmp18_);
#line 2615 "../src/View/AbstractDirectoryView.vala"
					_tmp19_ = count;
#line 2615 "../src/View/AbstractDirectoryView.vala"
					count = _tmp19_ + 1;
#line 14054 "AbstractDirectoryView.c"
				}
			}
#line 2619 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = enumerator;
#line 2619 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = g_file_enumerator_next_file (_tmp21_, NULL, &_inner_error0_);
#line 2619 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = _tmp22_;
#line 2619 "../src/View/AbstractDirectoryView.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2619 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (info);
#line 2619 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (location);
#line 2619 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp0_);
#line 14071 "AbstractDirectoryView.c"
				goto __catch0_g_error;
			}
#line 2619 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = _tmp20_;
#line 2619 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = NULL;
#line 2619 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (info);
#line 2619 "../src/View/AbstractDirectoryView.vala"
			info = _tmp23_;
#line 2607 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp20_);
#line 14084 "AbstractDirectoryView.c"
		}
#line 2601 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (info);
#line 2601 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (location);
#line 2601 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp0_);
#line 14092 "AbstractDirectoryView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 2601 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 2622 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (enumerator);
#line 2622 "../src/View/AbstractDirectoryView.vala"
		(folder_list == NULL) ? NULL : (folder_list = (_g_list_free__g_object_unref0_ (folder_list), NULL));
#line 2622 "../src/View/AbstractDirectoryView.vala"
		(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 2622 "../src/View/AbstractDirectoryView.vala"
		return;
#line 14107 "AbstractDirectoryView.c"
	}
	__finally0:
#line 2601 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2601 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (enumerator);
#line 2601 "../src/View/AbstractDirectoryView.vala"
		(folder_list == NULL) ? NULL : (folder_list = (_g_list_free__g_object_unref0_ (folder_list), NULL));
#line 2601 "../src/View/AbstractDirectoryView.vala"
		(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 2601 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2601 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 2601 "../src/View/AbstractDirectoryView.vala"
		return;
#line 14124 "AbstractDirectoryView.c"
	}
#line 2625 "../src/View/AbstractDirectoryView.vala"
	_tmp24_ = file_list;
#line 2625 "../src/View/AbstractDirectoryView.vala"
	if (g_list_length (_tmp24_) > ((guint) 0)) {
#line 14130 "AbstractDirectoryView.c"
		GList* _tmp25_;
		GFile* _tmp29_;
#line 2626 "../src/View/AbstractDirectoryView.vala"
		file_list = g_list_sort (file_list, ____lambda41__gcompare_func);
#line 2630 "../src/View/AbstractDirectoryView.vala"
		_tmp25_ = file_list;
#line 14137 "AbstractDirectoryView.c"
		{
			GList* file_collection = NULL;
			GList* file_it = NULL;
#line 2630 "../src/View/AbstractDirectoryView.vala"
			file_collection = _tmp25_;
#line 2630 "../src/View/AbstractDirectoryView.vala"
			for (file_it = file_collection; file_it != NULL; file_it = file_it->next) {
#line 14145 "AbstractDirectoryView.c"
				GFile* _tmp26_;
				GFile* file = NULL;
#line 2630 "../src/View/AbstractDirectoryView.vala"
				_tmp26_ = _g_object_ref0 ((GFile*) file_it->data);
#line 2630 "../src/View/AbstractDirectoryView.vala"
				file = _tmp26_;
#line 14152 "AbstractDirectoryView.c"
				{
					GFile* _tmp27_;
					GFile* _tmp28_;
#line 2631 "../src/View/AbstractDirectoryView.vala"
					_tmp27_ = file;
#line 2631 "../src/View/AbstractDirectoryView.vala"
					_tmp28_ = _g_object_ref0 (_tmp27_);
#line 2631 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_templates = g_list_append (files_abstract_directory_view_templates, _tmp28_);
#line 2630 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (file);
#line 14164 "AbstractDirectoryView.c"
				}
			}
		}
#line 2634 "../src/View/AbstractDirectoryView.vala"
		_tmp29_ = _g_object_ref0 (template_folder);
#line 2634 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_templates = g_list_append (files_abstract_directory_view_templates, _tmp29_);
#line 14172 "AbstractDirectoryView.c"
	}
#line 2637 "../src/View/AbstractDirectoryView.vala"
	_tmp30_ = folder_list;
#line 2637 "../src/View/AbstractDirectoryView.vala"
	if (g_list_length (_tmp30_) > ((guint) 0)) {
#line 14178 "AbstractDirectoryView.c"
		GList* _tmp31_;
#line 2639 "../src/View/AbstractDirectoryView.vala"
		_tmp31_ = folder_list;
#line 2639 "../src/View/AbstractDirectoryView.vala"
		g_list_foreach (_tmp31_, ____lambda42__gfunc, NULL);
#line 14184 "AbstractDirectoryView.c"
	}
#line 2595 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (enumerator);
#line 2595 "../src/View/AbstractDirectoryView.vala"
	(folder_list == NULL) ? NULL : (folder_list = (_g_list_free__g_object_unref0_ (folder_list), NULL));
#line 2595 "../src/View/AbstractDirectoryView.vala"
	(file_list == NULL) ? NULL : (file_list = (_g_list_free__g_object_unref0_ (file_list), NULL));
#line 14192 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_filter_this_app_from_open_with_apps (FilesAbstractDirectoryView* self)
{
	GList* l = NULL;
	GList* _tmp0_;
#line 2645 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2646 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->open_with_apps;
#line 2646 "../src/View/AbstractDirectoryView.vala"
	l = _tmp0_;
#line 2648 "../src/View/AbstractDirectoryView.vala"
	while (TRUE) {
#line 14208 "AbstractDirectoryView.c"
		GList* _tmp1_;
		GList* _tmp2_;
		gconstpointer _tmp3_;
		GList* _tmp10_;
		GList* _tmp11_;
#line 2648 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = l;
#line 2648 "../src/View/AbstractDirectoryView.vala"
		if (!(_tmp1_ != NULL)) {
#line 2648 "../src/View/AbstractDirectoryView.vala"
			break;
#line 14220 "AbstractDirectoryView.c"
		}
#line 2649 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = l;
#line 2649 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_->data;
#line 2649 "../src/View/AbstractDirectoryView.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE ((GAppInfo*) _tmp3_, g_app_info_get_type ())) {
#line 14228 "AbstractDirectoryView.c"
			GList* _tmp4_;
			gconstpointer _tmp5_;
#line 2650 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = l;
#line 2650 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = _tmp4_->data;
#line 2650 "../src/View/AbstractDirectoryView.vala"
			if (files_abstract_directory_view_app_is_this_app (self, (GAppInfo*) _tmp5_)) {
#line 14237 "AbstractDirectoryView.c"
				GList* _tmp6_;
#line 2651 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = l;
#line 2651 "../src/View/AbstractDirectoryView.vala"
				self->priv->open_with_apps = g_list_delete_link (self->priv->open_with_apps, _tmp6_);
#line 2652 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14245 "AbstractDirectoryView.c"
			}
		} else {
			GList* _tmp7_;
			GList* _tmp8_;
			GList* _tmp9_;
#line 2655 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = l;
#line 2655 "../src/View/AbstractDirectoryView.vala"
			self->priv->open_with_apps = g_list_delete_link (self->priv->open_with_apps, _tmp7_);
#line 2656 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = self->priv->open_with_apps;
#line 2656 "../src/View/AbstractDirectoryView.vala"
			l = _tmp8_;
#line 2657 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = l;
#line 2657 "../src/View/AbstractDirectoryView.vala"
			if (_tmp9_ == NULL) {
#line 2658 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14265 "AbstractDirectoryView.c"
			}
		}
#line 2662 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = l;
#line 2662 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_->next;
#line 2662 "../src/View/AbstractDirectoryView.vala"
		l = _tmp11_;
#line 14274 "AbstractDirectoryView.c"
	}
}

static gboolean
files_abstract_directory_view_app_is_this_app (FilesAbstractDirectoryView* self,
                                               GAppInfo* ai)
{
	gchar* exec_name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean result;
#line 2666 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2666 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (ai != NULL, FALSE);
#line 2667 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_app_info_get_executable (ai);
#line 2667 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 2667 "../src/View/AbstractDirectoryView.vala"
	exec_name = _tmp1_;
#line 2669 "../src/View/AbstractDirectoryView.vala"
	result = g_strcmp0 (exec_name, APP_NAME) == 0;
#line 2669 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (exec_name);
#line 2669 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 14302 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_filter_default_app_from_open_with_apps (FilesAbstractDirectoryView* self)
{
	GAppInfo* _tmp0_;
	gchar* id1 = NULL;
	gchar* id2 = NULL;
	GAppInfo* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
#line 2672 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2673 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->default_app;
#line 2673 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 2674 "../src/View/AbstractDirectoryView.vala"
		return;
#line 14323 "AbstractDirectoryView.c"
	}
#line 2678 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->default_app;
#line 2678 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_app_info_get_id (_tmp1_);
#line 2678 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 2678 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (id2);
#line 2678 "../src/View/AbstractDirectoryView.vala"
	id2 = _tmp3_;
#line 2680 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = id2;
#line 2680 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_ != NULL) {
#line 14339 "AbstractDirectoryView.c"
		GList* l = NULL;
		GList* _tmp5_;
#line 2681 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->priv->open_with_apps;
#line 2681 "../src/View/AbstractDirectoryView.vala"
		l = _tmp5_;
#line 2683 "../src/View/AbstractDirectoryView.vala"
		while (TRUE) {
#line 14348 "AbstractDirectoryView.c"
			gboolean _tmp6_ = FALSE;
			GList* _tmp7_;
			GList* _tmp10_;
			gconstpointer _tmp11_;
			const gchar* _tmp12_;
			gchar* _tmp13_;
			gboolean _tmp14_ = FALSE;
			const gchar* _tmp15_;
			GList* _tmp19_;
			GList* _tmp20_;
#line 2683 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = l;
#line 2683 "../src/View/AbstractDirectoryView.vala"
			if (_tmp7_ != NULL) {
#line 14363 "AbstractDirectoryView.c"
				GList* _tmp8_;
				gconstpointer _tmp9_;
#line 2683 "../src/View/AbstractDirectoryView.vala"
				_tmp8_ = l;
#line 2683 "../src/View/AbstractDirectoryView.vala"
				_tmp9_ = _tmp8_->data;
#line 2683 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = G_TYPE_CHECK_INSTANCE_TYPE ((GAppInfo*) _tmp9_, g_app_info_get_type ());
#line 14372 "AbstractDirectoryView.c"
			} else {
#line 2683 "../src/View/AbstractDirectoryView.vala"
				_tmp6_ = FALSE;
#line 14376 "AbstractDirectoryView.c"
			}
#line 2683 "../src/View/AbstractDirectoryView.vala"
			if (!_tmp6_) {
#line 2683 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14382 "AbstractDirectoryView.c"
			}
#line 2684 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = l;
#line 2684 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = _tmp10_->data;
#line 2684 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = g_app_info_get_id ((GAppInfo*) _tmp11_);
#line 2684 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = g_strdup (_tmp12_);
#line 2684 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (id1);
#line 2684 "../src/View/AbstractDirectoryView.vala"
			id1 = _tmp13_;
#line 2686 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = id1;
#line 2686 "../src/View/AbstractDirectoryView.vala"
			if (_tmp15_ != NULL) {
#line 14400 "AbstractDirectoryView.c"
				const gchar* _tmp16_;
				const gchar* _tmp17_;
#line 2686 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = id1;
#line 2686 "../src/View/AbstractDirectoryView.vala"
				_tmp17_ = id2;
#line 2686 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = g_strcmp0 (_tmp16_, _tmp17_) == 0;
#line 14409 "AbstractDirectoryView.c"
			} else {
#line 2686 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = FALSE;
#line 14413 "AbstractDirectoryView.c"
			}
#line 2686 "../src/View/AbstractDirectoryView.vala"
			if (_tmp14_) {
#line 14417 "AbstractDirectoryView.c"
				GList* _tmp18_;
#line 2687 "../src/View/AbstractDirectoryView.vala"
				_tmp18_ = l;
#line 2687 "../src/View/AbstractDirectoryView.vala"
				self->priv->open_with_apps = g_list_delete_link (self->priv->open_with_apps, _tmp18_);
#line 2688 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14425 "AbstractDirectoryView.c"
			}
#line 2691 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = l;
#line 2691 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = _tmp19_->next;
#line 2691 "../src/View/AbstractDirectoryView.vala"
			l = _tmp20_;
#line 14433 "AbstractDirectoryView.c"
		}
	}
#line 2672 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (id2);
#line 2672 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (id1);
#line 14440 "AbstractDirectoryView.c"
}

/** Menu action functions */
static void
__lambda116_ (FilesAbstractDirectoryView* self,
              GObject* obj,
              GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 2708 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 14452 "AbstractDirectoryView.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
#line 2710 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = marlin_file_operations_new_file_from_template_finish (res, &_inner_error0_);
#line 2710 "../src/View/AbstractDirectoryView.vala"
		file = _tmp0_;
#line 2710 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14462 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 2711 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_create_file_done (file, self);
#line 2709 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 14469 "AbstractDirectoryView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
#line 2709 "../src/View/AbstractDirectoryView.vala"
		e = _inner_error0_;
#line 2709 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 2713 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = e;
#line 2713 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_->message;
#line 2713 "../src/View/AbstractDirectoryView.vala"
		g_critical ("AbstractDirectoryView.vala:2713: %s", _tmp2_);
#line 2709 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (e);
#line 14489 "AbstractDirectoryView.c"
	}
	__finally0:
#line 2709 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2709 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2709 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 2709 "../src/View/AbstractDirectoryView.vala"
		return;
#line 14500 "AbstractDirectoryView.c"
	}
}

static void
___lambda116__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
#line 2702 "../src/View/AbstractDirectoryView.vala"
	__lambda116_ ((FilesAbstractDirectoryView*) self, source_object, res);
#line 2702 "../src/View/AbstractDirectoryView.vala"
	g_object_unref (self);
#line 14513 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_create_from_template (FilesAbstractDirectoryView* self,
                                                    GFile* template)
{
	FilesViewSlot* _tmp0_;
	FilesDirectory* _tmp1_;
	FilesDirectory* _tmp2_;
	gchar* new_name = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	FilesViewSlot* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
#line 2698 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2698 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (template != NULL);
#line 2700 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->slot;
#line 2700 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp0_);
#line 2700 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 2700 "../src/View/AbstractDirectoryView.vala"
	files_directory_block_monitor (_tmp2_);
#line 2701 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = g_file_get_basename (template);
#line 2701 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 2701 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = g_strdup_printf (_ ("Untitled %s"), _tmp4_);
#line 2701 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _tmp5_;
#line 2701 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp4_);
#line 2701 "../src/View/AbstractDirectoryView.vala"
	new_name = _tmp6_;
#line 2702 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->slot;
#line 2702 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = files_abstract_slot_get_location ((FilesAbstractSlot*) _tmp7_);
#line 2702 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _tmp8_;
#line 2702 "../src/View/AbstractDirectoryView.vala"
	marlin_file_operations_new_file_from_template ((GtkWidget*) self, _tmp9_, new_name, template, NULL, ___lambda116__gasync_ready_callback, g_object_ref (self));
#line 2698 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (new_name);
#line 14565 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_open_files_with (FilesAbstractDirectoryView* self,
                                               GAppInfo* app,
                                               GList* files)
{
#line 2718 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2718 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (app != NULL);
#line 2719 "../src/View/AbstractDirectoryView.vala"
	files_mime_actions_open_multiple_gof_files_request (files, (GtkWidget*) self, app);
#line 14579 "AbstractDirectoryView.c"
}

/** Thumbnail and color tag handling */
static gboolean
__lambda77_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 2748 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->thumbnail_source_id > ((guint) 0)) {
#line 2749 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 2749 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 14593 "AbstractDirectoryView.c"
	}
#line 2752 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_thaw_child_notify (self);
#line 2753 "../src/View/AbstractDirectoryView.vala"
	self->priv->freeze_source_id = (guint) 0;
#line 2754 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 2754 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 14603 "AbstractDirectoryView.c"
}

static gboolean
___lambda77__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda77_ ((FilesAbstractDirectoryView*) self);
#line 2747 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 14613 "AbstractDirectoryView.c"
}

static GtkTreePath*
_vala_GtkTreePath_copy (GtkTreePath* self)
{
#line 2771 "../src/View/AbstractDirectoryView.vala"
	return g_boxed_copy (gtk_tree_path_get_type (), self);
#line 14621 "AbstractDirectoryView.c"
}

static gpointer
__vala_GtkTreePath_copy0 (gpointer self)
{
#line 2771 "../src/View/AbstractDirectoryView.vala"
	return self ? _vala_GtkTreePath_copy (self) : NULL;
#line 14629 "AbstractDirectoryView.c"
}

static gboolean
__lambda78_ (FilesAbstractDirectoryView* self)
{
	GtkTreePath* start_path = NULL;
	GtkTreePath* end_path = NULL;
	GtkTreePath* path = NULL;
	GtkTreePath* sp = NULL;
	GtkTreePath* ep = NULL;
	GtkTreeIter iter = {0};
	gboolean valid_iter = FALSE;
	FilesFile* file = NULL;
	GList* visible_files = NULL;
	guint actually_visible = 0U;
	GtkTreePath* _tmp0_ = NULL;
	GtkTreePath* _tmp1_ = NULL;
	gboolean _tmp2_;
	gboolean _tmp37_ = FALSE;
	gboolean result;
#line 2768 "../src/View/AbstractDirectoryView.vala"
	visible_files = NULL;
#line 2769 "../src/View/AbstractDirectoryView.vala"
	actually_visible = (guint) 0;
#line 2770 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_abstract_directory_view_get_visible_range (self, &_tmp0_, &_tmp1_);
#line 2770 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (start_path);
#line 2770 "../src/View/AbstractDirectoryView.vala"
	start_path = _tmp0_;
#line 2770 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (end_path);
#line 2770 "../src/View/AbstractDirectoryView.vala"
	end_path = _tmp1_;
#line 2770 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 14666 "AbstractDirectoryView.c"
		GtkTreePath* _tmp3_;
		GtkTreePath* _tmp4_;
		GtkTreePath* _tmp5_;
		GtkTreePath* _tmp6_;
		gint count = 0;
		FilesListModel* _tmp12_;
		GtkTreePath* _tmp13_;
		GtkTreeIter _tmp14_ = {0};
		gboolean _tmp15_;
#line 2771 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = start_path;
#line 2771 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = __vala_GtkTreePath_copy0 (_tmp3_);
#line 2771 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (sp);
#line 2771 "../src/View/AbstractDirectoryView.vala"
		sp = _tmp4_;
#line 2772 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = end_path;
#line 2772 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = __vala_GtkTreePath_copy0 (_tmp5_);
#line 2772 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (ep);
#line 2772 "../src/View/AbstractDirectoryView.vala"
		ep = _tmp6_;
#line 2777 "../src/View/AbstractDirectoryView.vala"
		count = 50;
#line 2778 "../src/View/AbstractDirectoryView.vala"
		while (TRUE) {
#line 14696 "AbstractDirectoryView.c"
			gboolean _tmp7_ = FALSE;
			GtkTreePath* _tmp8_;
			gint _tmp9_;
#line 2778 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = start_path;
#line 2778 "../src/View/AbstractDirectoryView.vala"
			if (gtk_tree_path_prev (_tmp8_)) {
#line 2778 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = count > 0;
#line 14706 "AbstractDirectoryView.c"
			} else {
#line 2778 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = FALSE;
#line 14710 "AbstractDirectoryView.c"
			}
#line 2778 "../src/View/AbstractDirectoryView.vala"
			if (!_tmp7_) {
#line 2778 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14716 "AbstractDirectoryView.c"
			}
#line 2779 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = count;
#line 2779 "../src/View/AbstractDirectoryView.vala"
			count = _tmp9_ - 1;
#line 14722 "AbstractDirectoryView.c"
		}
#line 2782 "../src/View/AbstractDirectoryView.vala"
		count = 50;
#line 2783 "../src/View/AbstractDirectoryView.vala"
		while (TRUE) {
#line 14728 "AbstractDirectoryView.c"
			GtkTreePath* _tmp10_;
			gint _tmp11_;
#line 2783 "../src/View/AbstractDirectoryView.vala"
			if (!(count > 0)) {
#line 2783 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14735 "AbstractDirectoryView.c"
			}
#line 2784 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = end_path;
#line 2784 "../src/View/AbstractDirectoryView.vala"
			gtk_tree_path_next (_tmp10_);
#line 2785 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = count;
#line 2785 "../src/View/AbstractDirectoryView.vala"
			count = _tmp11_ - 1;
#line 14745 "AbstractDirectoryView.c"
		}
#line 2789 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = self->model;
#line 2789 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = start_path;
#line 2789 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = gtk_tree_model_get_iter ((GtkTreeModel*) _tmp12_, &_tmp14_, _tmp13_);
#line 2789 "../src/View/AbstractDirectoryView.vala"
		iter = _tmp14_;
#line 2789 "../src/View/AbstractDirectoryView.vala"
		valid_iter = _tmp15_;
#line 2790 "../src/View/AbstractDirectoryView.vala"
		while (TRUE) {
#line 14759 "AbstractDirectoryView.c"
			gboolean _tmp16_ = FALSE;
			FilesListModel* _tmp17_;
			GtkTreeIter _tmp18_;
			FilesFile* _tmp19_;
			FilesListModel* _tmp20_;
			GtkTreeIter _tmp21_;
			GtkTreePath* _tmp22_;
			FilesFile* _tmp23_;
			GtkTreePath* _tmp34_;
			GtkTreePath* _tmp35_;
#line 2790 "../src/View/AbstractDirectoryView.vala"
			if (valid_iter) {
#line 2790 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = self->priv->thumbnail_source_id > ((guint) 0);
#line 14774 "AbstractDirectoryView.c"
			} else {
#line 2790 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = FALSE;
#line 14778 "AbstractDirectoryView.c"
			}
#line 2790 "../src/View/AbstractDirectoryView.vala"
			if (!_tmp16_) {
#line 2790 "../src/View/AbstractDirectoryView.vala"
				break;
#line 14784 "AbstractDirectoryView.c"
			}
#line 2791 "../src/View/AbstractDirectoryView.vala"
			_tmp17_ = self->model;
#line 2791 "../src/View/AbstractDirectoryView.vala"
			_tmp18_ = iter;
#line 2791 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = files_list_model_file_for_iter (_tmp17_, &_tmp18_);
#line 2791 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (file);
#line 2791 "../src/View/AbstractDirectoryView.vala"
			file = _tmp19_;
#line 2792 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = self->model;
#line 2792 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = iter;
#line 2792 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp20_, &_tmp21_);
#line 2792 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (path);
#line 2792 "../src/View/AbstractDirectoryView.vala"
			path = _tmp22_;
#line 2793 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = file;
#line 2793 "../src/View/AbstractDirectoryView.vala"
			if (_tmp23_ != NULL) {
#line 14810 "AbstractDirectoryView.c"
				FilesFile* _tmp24_;
				FilesFile* _tmp25_;
#line 2794 "../src/View/AbstractDirectoryView.vala"
				_tmp24_ = file;
#line 2794 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_update_thumbnail_info_and_plugins (self, _tmp24_);
#line 2796 "../src/View/AbstractDirectoryView.vala"
				_tmp25_ = file;
#line 2796 "../src/View/AbstractDirectoryView.vala"
				if (_tmp25_->thumbstate == ((guint) FILES_FILE_THUMB_STATE_UNKNOWN)) {
#line 14821 "AbstractDirectoryView.c"
					FilesFile* _tmp26_;
					FilesFile* _tmp27_;
					gboolean _tmp28_ = FALSE;
					GtkTreePath* _tmp29_;
					GtkTreePath* _tmp30_;
#line 2797 "../src/View/AbstractDirectoryView.vala"
					_tmp26_ = file;
#line 2797 "../src/View/AbstractDirectoryView.vala"
					_tmp27_ = _g_object_ref0 (_tmp26_);
#line 2797 "../src/View/AbstractDirectoryView.vala"
					visible_files = g_list_prepend (visible_files, _tmp27_);
#line 2798 "../src/View/AbstractDirectoryView.vala"
					_tmp29_ = path;
#line 2798 "../src/View/AbstractDirectoryView.vala"
					_tmp30_ = sp;
#line 2798 "../src/View/AbstractDirectoryView.vala"
					if (gtk_tree_path_compare (_tmp29_, _tmp30_) >= 0) {
#line 14839 "AbstractDirectoryView.c"
						GtkTreePath* _tmp31_;
						GtkTreePath* _tmp32_;
#line 2798 "../src/View/AbstractDirectoryView.vala"
						_tmp31_ = path;
#line 2798 "../src/View/AbstractDirectoryView.vala"
						_tmp32_ = ep;
#line 2798 "../src/View/AbstractDirectoryView.vala"
						_tmp28_ = gtk_tree_path_compare (_tmp31_, _tmp32_) <= 0;
#line 14848 "AbstractDirectoryView.c"
					} else {
#line 2798 "../src/View/AbstractDirectoryView.vala"
						_tmp28_ = FALSE;
#line 14852 "AbstractDirectoryView.c"
					}
#line 2798 "../src/View/AbstractDirectoryView.vala"
					if (_tmp28_) {
#line 14856 "AbstractDirectoryView.c"
						guint _tmp33_;
#line 2799 "../src/View/AbstractDirectoryView.vala"
						_tmp33_ = actually_visible;
#line 2799 "../src/View/AbstractDirectoryView.vala"
						actually_visible = _tmp33_ + 1;
#line 14862 "AbstractDirectoryView.c"
					}
				}
			}
#line 2804 "../src/View/AbstractDirectoryView.vala"
			_tmp34_ = path;
#line 2804 "../src/View/AbstractDirectoryView.vala"
			_tmp35_ = end_path;
#line 2804 "../src/View/AbstractDirectoryView.vala"
			if (gtk_tree_path_compare (_tmp34_, _tmp35_) != 0) {
#line 14872 "AbstractDirectoryView.c"
				gboolean _tmp36_;
#line 2805 "../src/View/AbstractDirectoryView.vala"
				_tmp36_ = files_abstract_directory_view_get_next_visible_iter (self, &iter, TRUE);
#line 2805 "../src/View/AbstractDirectoryView.vala"
				valid_iter = _tmp36_;
#line 14878 "AbstractDirectoryView.c"
			} else {
#line 2807 "../src/View/AbstractDirectoryView.vala"
				valid_iter = FALSE;
#line 14882 "AbstractDirectoryView.c"
			}
		}
	}
#line 2818 "../src/View/AbstractDirectoryView.vala"
	if (actually_visible > ((guint) 0)) {
#line 2818 "../src/View/AbstractDirectoryView.vala"
		_tmp37_ = self->priv->thumbnail_source_id > ((guint) 0);
#line 14890 "AbstractDirectoryView.c"
	} else {
#line 2818 "../src/View/AbstractDirectoryView.vala"
		_tmp37_ = FALSE;
#line 14894 "AbstractDirectoryView.c"
	}
#line 2818 "../src/View/AbstractDirectoryView.vala"
	if (_tmp37_) {
#line 14898 "AbstractDirectoryView.c"
		FilesThumbnailer* _tmp38_;
		GList* _tmp39_;
		gint _tmp40_ = 0;
#line 2819 "../src/View/AbstractDirectoryView.vala"
		_tmp38_ = self->priv->thumbnailer;
#line 2819 "../src/View/AbstractDirectoryView.vala"
		_tmp39_ = visible_files;
#line 2819 "../src/View/AbstractDirectoryView.vala"
		files_thumbnailer_queue_files (_tmp38_, _tmp39_, &_tmp40_, self->large_thumbnails);
#line 2819 "../src/View/AbstractDirectoryView.vala"
		self->priv->thumbnail_request = _tmp40_;
#line 14910 "AbstractDirectoryView.c"
	} else {
#line 2821 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_draw_when_idle (self);
#line 14914 "AbstractDirectoryView.c"
	}
#line 2824 "../src/View/AbstractDirectoryView.vala"
	self->priv->thumbnail_source_id = (guint) 0;
#line 2826 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 2826 "../src/View/AbstractDirectoryView.vala"
	(visible_files == NULL) ? NULL : (visible_files = (_g_list_free__g_object_unref0_ (visible_files), NULL));
#line 2826 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 2826 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (ep);
#line 2826 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (sp);
#line 2826 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 2826 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (end_path);
#line 2826 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (start_path);
#line 2826 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 14936 "AbstractDirectoryView.c"
}

static gboolean
___lambda78__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda78_ ((FilesAbstractDirectoryView*) self);
#line 2760 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 14946 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_schedule_thumbnail_color_tag_timeout (FilesAbstractDirectoryView* self)
{
	gboolean _tmp0_ = FALSE;
	FilesViewSlot* _tmp1_;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	guint delay = 0U;
	FilesViewSlot* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	guint _tmp18_;
#line 2724 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2730 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->slot;
#line 2730 "../src/View/AbstractDirectoryView.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, FILES_TYPE_ABSTRACT_SLOT)) {
#line 14967 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp2_;
		FilesDirectory* _tmp3_;
		FilesDirectory* _tmp4_;
#line 2730 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->slot;
#line 2730 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp2_);
#line 2730 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = _tmp3_;
#line 2730 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp4_ != NULL;
#line 14979 "AbstractDirectoryView.c"
	} else {
#line 2730 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FALSE;
#line 14983 "AbstractDirectoryView.c"
	}
#line 2730 "../src/View/AbstractDirectoryView.vala"
	_vala_assert (_tmp0_, "slot is Files.AbstractSlot && slot.directory != null");
#line 2733 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->thumbnail_source_id != ((guint) 0)) {
#line 2733 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = TRUE;
#line 14991 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp7_;
		FilesDirectory* _tmp8_;
		FilesDirectory* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 2734 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = self->slot;
#line 2734 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp7_);
#line 2734 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = _tmp8_;
#line 2734 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = files_directory_get_can_open_files (_tmp9_);
#line 2734 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = _tmp10_;
#line 2734 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = !_tmp11_;
#line 15010 "AbstractDirectoryView.c"
	}
#line 2733 "../src/View/AbstractDirectoryView.vala"
	if (_tmp6_) {
#line 2733 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = TRUE;
#line 15016 "AbstractDirectoryView.c"
	} else {
		FilesViewSlot* _tmp12_;
		FilesDirectory* _tmp13_;
		FilesDirectory* _tmp14_;
#line 2735 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = self->slot;
#line 2735 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp12_);
#line 2735 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = _tmp13_;
#line 2735 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = files_directory_is_loading (_tmp14_);
#line 15029 "AbstractDirectoryView.c"
	}
#line 2733 "../src/View/AbstractDirectoryView.vala"
	if (_tmp5_) {
#line 2737 "../src/View/AbstractDirectoryView.vala"
		return;
#line 15035 "AbstractDirectoryView.c"
	}
#line 2741 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->thumbnail_source_id);
#line 2745 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->freeze_source_id);
#line 2746 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_freeze_child_notify (self);
#line 2747 "../src/View/AbstractDirectoryView.vala"
	self->priv->freeze_source_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda77__gsource_func, g_object_ref (self), g_object_unref);
#line 2759 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = self->slot;
#line 2759 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = files_view_slot_get_displayed_files_count (_tmp15_);
#line 2759 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = _tmp16_;
#line 2759 "../src/View/AbstractDirectoryView.vala"
	delay = MIN ((guint) (50 + (_tmp17_ / 10)), (guint) 500);
#line 2760 "../src/View/AbstractDirectoryView.vala"
	_tmp18_ = delay;
#line 2760 "../src/View/AbstractDirectoryView.vala"
	self->priv->thumbnail_source_id = g_timeout_add_full (G_PRIORITY_DEFAULT, _tmp18_, ___lambda78__gsource_func, g_object_ref (self), g_object_unref);
#line 15057 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_update_thumbnail_info_and_plugins (FilesAbstractDirectoryView* self,
                                                                 FilesFile* file)
{
	gboolean _tmp0_ = FALSE;
#line 2832 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2832 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 2833 "../src/View/AbstractDirectoryView.vala"
	if (file != NULL) {
#line 2833 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = !file->is_gone;
#line 15073 "AbstractDirectoryView.c"
	} else {
#line 2833 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FALSE;
#line 15077 "AbstractDirectoryView.c"
	}
#line 2833 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 15081 "AbstractDirectoryView.c"
		gboolean _tmp1_ = FALSE;
		gboolean _tmp2_ = FALSE;
		FilesViewSlot* _tmp3_;
		FilesDirectory* _tmp4_;
		FilesDirectory* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		FilesPluginManager* _tmp16_;
#line 2835 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = self->slot;
#line 2835 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp3_);
#line 2835 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = _tmp4_;
#line 2835 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = files_directory_get_is_network (_tmp5_);
#line 2835 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp6_;
#line 2835 "../src/View/AbstractDirectoryView.vala"
		if (_tmp7_) {
#line 15102 "AbstractDirectoryView.c"
			gboolean _tmp8_;
#line 2835 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = self->priv->_show_remote_thumbnails;
#line 2835 "../src/View/AbstractDirectoryView.vala"
			_tmp2_ = _tmp8_;
#line 15108 "AbstractDirectoryView.c"
		} else {
#line 2835 "../src/View/AbstractDirectoryView.vala"
			_tmp2_ = FALSE;
#line 15112 "AbstractDirectoryView.c"
		}
#line 2835 "../src/View/AbstractDirectoryView.vala"
		if (_tmp2_) {
#line 2835 "../src/View/AbstractDirectoryView.vala"
			_tmp1_ = TRUE;
#line 15118 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp9_ = FALSE;
			FilesViewSlot* _tmp10_;
			FilesDirectory* _tmp11_;
			FilesDirectory* _tmp12_;
			gboolean _tmp13_;
			gboolean _tmp14_;
#line 2836 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = self->slot;
#line 2836 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp10_);
#line 2836 "../src/View/AbstractDirectoryView.vala"
			_tmp12_ = _tmp11_;
#line 2836 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = files_directory_get_is_network (_tmp12_);
#line 2836 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = _tmp13_;
#line 2836 "../src/View/AbstractDirectoryView.vala"
			if (!_tmp14_) {
#line 15138 "AbstractDirectoryView.c"
				gboolean _tmp15_;
#line 2836 "../src/View/AbstractDirectoryView.vala"
				_tmp15_ = self->priv->_show_local_thumbnails;
#line 2836 "../src/View/AbstractDirectoryView.vala"
				_tmp9_ = _tmp15_;
#line 15144 "AbstractDirectoryView.c"
			} else {
#line 2836 "../src/View/AbstractDirectoryView.vala"
				_tmp9_ = FALSE;
#line 15148 "AbstractDirectoryView.c"
			}
#line 2836 "../src/View/AbstractDirectoryView.vala"
			_tmp1_ = _tmp9_;
#line 15152 "AbstractDirectoryView.c"
		}
#line 2835 "../src/View/AbstractDirectoryView.vala"
		if (_tmp1_) {
#line 2838 "../src/View/AbstractDirectoryView.vala"
			files_file_query_thumbnail_update (file);
#line 15158 "AbstractDirectoryView.c"
		}
#line 2841 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = plugins;
#line 2841 "../src/View/AbstractDirectoryView.vala"
		if (_tmp16_ != NULL) {
#line 15164 "AbstractDirectoryView.c"
			FilesPluginManager* _tmp17_;
#line 2842 "../src/View/AbstractDirectoryView.vala"
			_tmp17_ = plugins;
#line 2842 "../src/View/AbstractDirectoryView.vala"
			files_plugin_manager_update_file_info (_tmp17_, file);
#line 15170 "AbstractDirectoryView.c"
		}
	}
}

static gboolean
__lambda79_ (FilesAbstractDirectoryView* self)
{
	GtkWidget* _tmp0_;
	gboolean result;
#line 2855 "../src/View/AbstractDirectoryView.vala"
	self->priv->draw_timeout_id = (guint) 0;
#line 2856 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->view;
#line 2856 "../src/View/AbstractDirectoryView.vala"
	gtk_widget_queue_draw (_tmp0_);
#line 2857 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 2857 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 15190 "AbstractDirectoryView.c"
}

static gboolean
___lambda79__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda79_ ((FilesAbstractDirectoryView*) self);
#line 2854 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 15200 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_draw_when_idle (FilesAbstractDirectoryView* self)
{
#line 2849 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2850 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->draw_timeout_id > ((guint) 0)) {
#line 2851 "../src/View/AbstractDirectoryView.vala"
		return;
#line 15212 "AbstractDirectoryView.c"
	}
#line 2854 "../src/View/AbstractDirectoryView.vala"
	self->priv->draw_timeout_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 100, ___lambda79__gsource_func, g_object_ref (self), g_object_unref);
#line 15216 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_block_model (FilesAbstractDirectoryView* self)
{
	FilesListModel* _tmp0_;
	guint _tmp1_;
#line 2861 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2862 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 2862 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("row-deleted", gtk_tree_model_get_type (), &_tmp1_, NULL, FALSE);
#line 2862 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched ((GtkTreeModel*) _tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _files_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted, self);
#line 15232 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_unblock_model (FilesAbstractDirectoryView* self)
{
	FilesListModel* _tmp0_;
#line 2865 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2866 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 2866 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object ((GtkTreeModel*) _tmp0_, "row-deleted", (GCallback) _files_abstract_directory_view_on_row_deleted_gtk_tree_model_row_deleted, self, 0);
#line 15245 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_drag_timeout_button_release_gtk_widget_button_release_event (GtkWidget* _sender,
                                                                                               GdkEventButton* event,
                                                                                               gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_drag_timeout_button_release ((FilesAbstractDirectoryView*) self, event);
#line 2871 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 15257 "AbstractDirectoryView.c"
}

static gboolean
_files_abstract_directory_view_on_drag_timeout_motion_notify_gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                                                             GdkEventMotion* event,
                                                                                             gpointer self)
{
	gboolean result;
	result = files_abstract_directory_view_on_drag_timeout_motion_notify ((FilesAbstractDirectoryView*) self, event);
#line 2872 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 15269 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_connect_drag_timeout_motion_and_release_events (FilesAbstractDirectoryView* self)
{
	GtkWidget* real_view = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
#line 2869 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2870 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
#line 2870 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2870 "../src/View/AbstractDirectoryView.vala"
	real_view = _tmp1_;
#line 2871 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (real_view, "button-release-event", (GCallback) _files_abstract_directory_view_on_drag_timeout_button_release_gtk_widget_button_release_event, self, 0);
#line 2872 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (real_view, "motion-notify-event", (GCallback) _files_abstract_directory_view_on_drag_timeout_motion_notify_gtk_widget_motion_notify_event, self, 0);
#line 2869 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (real_view);
#line 15292 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_disconnect_drag_timeout_motion_and_release_events (FilesAbstractDirectoryView* self)
{
	GtkWidget* real_view = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	guint _tmp3_;
	GtkWidget* _tmp4_;
	guint _tmp5_;
#line 2875 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2876 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->drag_timer_id == ((guint) 0)) {
#line 2877 "../src/View/AbstractDirectoryView.vala"
		return;
#line 15311 "AbstractDirectoryView.c"
	}
#line 2880 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
#line 2880 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2880 "../src/View/AbstractDirectoryView.vala"
	real_view = _tmp1_;
#line 2881 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = real_view;
#line 2881 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("button-release-event", gtk_widget_get_type (), &_tmp3_, NULL, FALSE);
#line 2881 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _files_abstract_directory_view_on_drag_timeout_button_release_gtk_widget_button_release_event, self);
#line 2882 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = real_view;
#line 2882 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("motion-notify-event", gtk_widget_get_type (), &_tmp5_, NULL, FALSE);
#line 2882 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _files_abstract_directory_view_on_drag_timeout_motion_notify_gtk_widget_motion_notify_event, self);
#line 2875 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (real_view);
#line 15333 "AbstractDirectoryView.c"
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
#line 2885 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 2885 "../src/View/AbstractDirectoryView.vala"
	return _data30_;
#line 15343 "AbstractDirectoryView.c"
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 2885 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 15353 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 2885 "../src/View/AbstractDirectoryView.vala"
		self = _data30_->self;
#line 2885 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data30_->context);
#line 2885 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 2885 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block30Data, _data30_);
#line 15363 "AbstractDirectoryView.c"
	}
}

static gboolean
__lambda127_ (Block30Data* _data30_)
{
	FilesAbstractDirectoryView* self;
	GtkWidget* widget = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	gboolean result;
#line 2888 "../src/View/AbstractDirectoryView.vala"
	self = _data30_->self;
#line 2889 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
#line 2889 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 2889 "../src/View/AbstractDirectoryView.vala"
	widget = _tmp1_;
#line 2890 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = widget;
#line 2890 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_ != NULL) {
#line 15388 "AbstractDirectoryView.c"
		GdkDevice* pointer = NULL;
		GdkDevice* _tmp3_;
		GdkDevice* _tmp4_;
		GdkWindow* window = NULL;
		GtkWidget* _tmp5_;
		GdkWindow* _tmp6_;
		GdkWindow* _tmp7_;
		gint x = 0;
		gint y = 0;
		gint w = 0;
		gint h = 0;
		GdkWindow* _tmp8_;
		GdkDevice* _tmp9_;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		GdkWindow* _tmp12_;
		gint _tmp13_ = 0;
		gint _tmp14_ = 0;
		GtkAdjustment* _tmp15_;
		GtkAdjustment* _tmp16_;
#line 2891 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = gdk_drag_context_get_device (_data30_->context);
#line 2891 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 2891 "../src/View/AbstractDirectoryView.vala"
		pointer = _tmp4_;
#line 2892 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = widget;
#line 2892 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = gtk_widget_get_window (_tmp5_);
#line 2892 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _g_object_ref0 (_tmp6_);
#line 2892 "../src/View/AbstractDirectoryView.vala"
		window = _tmp7_;
#line 2895 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = window;
#line 2895 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = pointer;
#line 2895 "../src/View/AbstractDirectoryView.vala"
		gdk_window_get_device_position (_tmp8_, _tmp9_, &_tmp10_, &_tmp11_, NULL);
#line 2895 "../src/View/AbstractDirectoryView.vala"
		x = _tmp10_;
#line 2895 "../src/View/AbstractDirectoryView.vala"
		y = _tmp11_;
#line 2896 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = window;
#line 2896 "../src/View/AbstractDirectoryView.vala"
		gdk_window_get_geometry (_tmp12_, NULL, NULL, &_tmp13_, &_tmp14_);
#line 2896 "../src/View/AbstractDirectoryView.vala"
		w = _tmp13_;
#line 2896 "../src/View/AbstractDirectoryView.vala"
		h = _tmp14_;
#line 2898 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = gtk_scrolled_window_get_vadjustment ((GtkScrolledWindow*) self);
#line 2898 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_scroll_if_near_edge (self, y, h, 20, _tmp15_);
#line 2899 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = gtk_scrolled_window_get_hadjustment ((GtkScrolledWindow*) self);
#line 2899 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_scroll_if_near_edge (self, x, w, 20, _tmp16_);
#line 2900 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 2900 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (window);
#line 2900 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (pointer);
#line 2900 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (widget);
#line 2900 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 15459 "AbstractDirectoryView.c"
	} else {
#line 2902 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_REMOVE;
#line 2902 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (widget);
#line 2902 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 15467 "AbstractDirectoryView.c"
	}
}

static gboolean
___lambda127__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda127_ (self);
#line 2886 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 15478 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_start_drag_scroll_timer (FilesAbstractDirectoryView* self,
                                                       GdkDragContext* context)
{
	Block30Data* _data30_;
	GdkDragContext* _tmp0_;
#line 2885 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2885 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (context != NULL);
#line 2885 "../src/View/AbstractDirectoryView.vala"
	_data30_ = g_slice_new0 (Block30Data);
#line 2885 "../src/View/AbstractDirectoryView.vala"
	_data30_->_ref_count_ = 1;
#line 2885 "../src/View/AbstractDirectoryView.vala"
	_data30_->self = g_object_ref (self);
#line 2885 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (context);
#line 2885 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data30_->context);
#line 2885 "../src/View/AbstractDirectoryView.vala"
	_data30_->context = _tmp0_;
#line 2886 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_scroll_timer_id = g_timeout_add_full (G_PRIORITY_LOW, (guint) 50, ___lambda127__gsource_func, block30_data_ref (_data30_), block30_data_unref);
#line 2885 "../src/View/AbstractDirectoryView.vala"
	block30_data_unref (_data30_);
#line 2885 "../src/View/AbstractDirectoryView.vala"
	_data30_ = NULL;
#line 15509 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_scroll_if_near_edge (FilesAbstractDirectoryView* self,
                                                   gint pos,
                                                   gint dim,
                                                   gint threshold,
                                                   GtkAdjustment* adj)
{
	gint band = 0;
	gint offset = 0;
#line 2907 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2907 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (adj != NULL);
#line 2909 "../src/View/AbstractDirectoryView.vala"
	band = 2 * threshold;
#line 2910 "../src/View/AbstractDirectoryView.vala"
	offset = pos - band;
#line 2911 "../src/View/AbstractDirectoryView.vala"
	if (offset > 0) {
#line 2912 "../src/View/AbstractDirectoryView.vala"
		offset = MAX (band - (dim - pos), 0);
#line 15533 "AbstractDirectoryView.c"
	}
#line 2915 "../src/View/AbstractDirectoryView.vala"
	if (offset != 0) {
#line 15537 "AbstractDirectoryView.c"
		gdouble val = 0.0;
		gdouble lower = 0.0;
		gdouble upper = 0.0;
		gdouble page = 0.0;
#line 2917 "../src/View/AbstractDirectoryView.vala"
		val = gtk_adjustment_get_value (adj);
#line 2918 "../src/View/AbstractDirectoryView.vala"
		lower = gtk_adjustment_get_lower (adj);
#line 2919 "../src/View/AbstractDirectoryView.vala"
		upper = gtk_adjustment_get_upper (adj);
#line 2920 "../src/View/AbstractDirectoryView.vala"
		page = gtk_adjustment_get_page_size (adj);
#line 2922 "../src/View/AbstractDirectoryView.vala"
		val = CLAMP (val + (2 * offset), lower, upper - page);
#line 2923 "../src/View/AbstractDirectoryView.vala"
		gtk_adjustment_set_value (adj, val);
#line 15554 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_remove_marlin_icon_info_cache (FilesAbstractDirectoryView* self,
                                                             FilesFile* file)
{
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 2927 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2927 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 2928 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_file_get_thumbnail_path (file);
#line 2928 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 2928 "../src/View/AbstractDirectoryView.vala"
	path = _tmp1_;
#line 2930 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = path;
#line 2930 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_ != NULL) {
#line 15580 "AbstractDirectoryView.c"
		FilesIconSize s = 0;
		{
			gint z = 0;
#line 2933 "../src/View/AbstractDirectoryView.vala"
			z = (gint) FILES_ZOOM_LEVEL_SMALLEST;
#line 15586 "AbstractDirectoryView.c"
			{
				gboolean _tmp3_ = FALSE;
#line 2933 "../src/View/AbstractDirectoryView.vala"
				_tmp3_ = TRUE;
#line 2933 "../src/View/AbstractDirectoryView.vala"
				while (TRUE) {
#line 15593 "AbstractDirectoryView.c"
					const gchar* _tmp5_;
#line 2933 "../src/View/AbstractDirectoryView.vala"
					if (!_tmp3_) {
#line 15597 "AbstractDirectoryView.c"
						gint _tmp4_;
#line 2935 "../src/View/AbstractDirectoryView.vala"
						_tmp4_ = z;
#line 2935 "../src/View/AbstractDirectoryView.vala"
						z = _tmp4_ + 1;
#line 15603 "AbstractDirectoryView.c"
					}
#line 2933 "../src/View/AbstractDirectoryView.vala"
					_tmp3_ = FALSE;
#line 2934 "../src/View/AbstractDirectoryView.vala"
					if (!(z <= ((gint) FILES_ZOOM_LEVEL_LARGEST))) {
#line 2934 "../src/View/AbstractDirectoryView.vala"
						break;
#line 15611 "AbstractDirectoryView.c"
					}
#line 2937 "../src/View/AbstractDirectoryView.vala"
					s = files_zoom_level_to_icon_size ((FilesZoomLevel) z);
#line 2938 "../src/View/AbstractDirectoryView.vala"
					_tmp5_ = path;
#line 2938 "../src/View/AbstractDirectoryView.vala"
					files_icon_info_remove_cache (_tmp5_, (gint) s, gtk_widget_get_scale_factor ((GtkWidget*) self));
#line 15619 "AbstractDirectoryView.c"
				}
			}
		}
	}
#line 2927 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (path);
#line 15626 "AbstractDirectoryView.c"
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
#line 2946 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data31_->_ref_count_);
#line 2946 "../src/View/AbstractDirectoryView.vala"
	return _data31_;
#line 15636 "AbstractDirectoryView.c"
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
#line 2946 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
#line 15646 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 2946 "../src/View/AbstractDirectoryView.vala"
		self = _data31_->self;
#line 2946 "../src/View/AbstractDirectoryView.vala"
		(_data31_->action_files == NULL) ? NULL : (_data31_->action_files = (_g_list_free__g_object_unref0_ (_data31_->action_files), NULL));
#line 2946 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 2946 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block31Data, _data31_);
#line 15656 "AbstractDirectoryView.c"
	}
}

static void
____lambda39_ (Block31Data* _data31_,
               FilesFile* file)
{
	FilesAbstractDirectoryView* self;
	FilesFile* goffile = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	FilesFile* _tmp2_;
	FilesFile* _tmp3_;
	FilesFile* _tmp4_;
#line 2953 "../src/View/AbstractDirectoryView.vala"
	self = _data31_->self;
#line 2953 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 2954 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_file_get_display_target_uri (file);
#line 2954 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 2954 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_file_get_by_uri (_tmp1_);
#line 2954 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 2954 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_tmp1_);
#line 2954 "../src/View/AbstractDirectoryView.vala"
	goffile = _tmp3_;
#line 2955 "../src/View/AbstractDirectoryView.vala"
	files_file_query_update (goffile);
#line 2956 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _g_object_ref0 (goffile);
#line 2956 "../src/View/AbstractDirectoryView.vala"
	_data31_->action_files = g_list_append (_data31_->action_files, _tmp4_);
#line 2953 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (goffile);
#line 15695 "AbstractDirectoryView.c"
}

static void
_____lambda39__gfunc (gconstpointer data,
                      gpointer self)
{
#line 2953 "../src/View/AbstractDirectoryView.vala"
	____lambda39_ (self, (FilesFile*) data);
#line 15704 "AbstractDirectoryView.c"
}

static GList*
files_abstract_directory_view_get_files_for_action (FilesAbstractDirectoryView* self)
{
	Block31Data* _data31_;
	GList* _tmp0_;
	GList* _tmp11_;
	GList* result;
#line 2946 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 2946 "../src/View/AbstractDirectoryView.vala"
	_data31_ = g_slice_new0 (Block31Data);
#line 2946 "../src/View/AbstractDirectoryView.vala"
	_data31_->_ref_count_ = 1;
#line 2946 "../src/View/AbstractDirectoryView.vala"
	_data31_->self = g_object_ref (self);
#line 2947 "../src/View/AbstractDirectoryView.vala"
	_data31_->action_files = NULL;
#line 2948 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 2950 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->selected_files;
#line 2950 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_ == NULL) {
#line 15730 "AbstractDirectoryView.c"
		FilesViewSlot* _tmp1_;
		FilesDirectory* _tmp2_;
		FilesDirectory* _tmp3_;
		FilesFile* _tmp4_;
		FilesFile* _tmp5_;
		FilesFile* _tmp6_;
#line 2951 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->slot;
#line 2951 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp1_);
#line 2951 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 2951 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = files_directory_get_file (_tmp3_);
#line 2951 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = _tmp4_;
#line 2951 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _g_object_ref0 (_tmp5_);
#line 2951 "../src/View/AbstractDirectoryView.vala"
		_data31_->action_files = g_list_prepend (_data31_->action_files, _tmp6_);
#line 15751 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp7_;
#line 2952 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = self->priv->_in_recent;
#line 2952 "../src/View/AbstractDirectoryView.vala"
		if (_tmp7_) {
#line 15758 "AbstractDirectoryView.c"
			GList* _tmp8_;
#line 2953 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = self->selected_files;
#line 2953 "../src/View/AbstractDirectoryView.vala"
			g_list_foreach (_tmp8_, _____lambda39__gfunc, _data31_);
#line 15764 "AbstractDirectoryView.c"
		} else {
			GList* _tmp9_;
			GList* _tmp10_;
#line 2959 "../src/View/AbstractDirectoryView.vala"
			_tmp9_ = self->selected_files;
#line 2959 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = g_list_copy_deep (_tmp9_, (GCopyFunc) g_object_ref, NULL);
#line 2959 "../src/View/AbstractDirectoryView.vala"
			(_data31_->action_files == NULL) ? NULL : (_data31_->action_files = (_g_list_free__g_object_unref0_ (_data31_->action_files), NULL));
#line 2959 "../src/View/AbstractDirectoryView.vala"
			_data31_->action_files = _tmp10_;
#line 15776 "AbstractDirectoryView.c"
		}
	}
#line 2962 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = _data31_->action_files;
#line 2962 "../src/View/AbstractDirectoryView.vala"
	_data31_->action_files = NULL;
#line 2962 "../src/View/AbstractDirectoryView.vala"
	result = _tmp11_;
#line 2962 "../src/View/AbstractDirectoryView.vala"
	block31_data_unref (_data31_);
#line 2962 "../src/View/AbstractDirectoryView.vala"
	_data31_ = NULL;
#line 2962 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 15791 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_view_items_activated (FilesAbstractDirectoryView* self)
{
	GList* _tmp0_;
#line 2965 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2966 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_files (self);
#line 2966 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_DEFAULT, _tmp0_);
#line 15804 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_view_selection_changed (FilesAbstractDirectoryView* self)
{
	gboolean _tmp0_ = FALSE;
	GList* _tmp1_;
#line 2969 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 2970 "../src/View/AbstractDirectoryView.vala"
	self->priv->selected_files_invalid = TRUE;
#line 2971 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->selected_files;
#line 2971 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ == NULL) {
#line 2971 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 15822 "AbstractDirectoryView.c"
	} else {
		GList* _tmp2_;
		GList* _tmp3_;
#line 2971 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->selected_files;
#line 2971 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_->next;
#line 2971 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp3_ == NULL;
#line 15832 "AbstractDirectoryView.c"
	}
#line 2971 "../src/View/AbstractDirectoryView.vala"
	self->one_or_less = _tmp0_;
#line 15836 "AbstractDirectoryView.c"
}

/** Keyboard event handling **/
static gboolean
__lambda98_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 3231 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 3232 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 3232 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 15850 "AbstractDirectoryView.c"
}

static gboolean
___lambda98__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda98_ ((FilesAbstractDirectoryView*) self);
#line 3230 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 15860 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_on_view_key_press_event (FilesAbstractDirectoryView* self,
                                                            GdkEventKey* event)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GdkModifierType consumed_mods = 0U;
	GdkModifierType state = 0U;
	guint keyval = 0U;
	GdkModifierType _tmp2_ = 0U;
	guint _tmp3_;
	GdkModifierType _tmp4_ = 0U;
	GdkModifierType mods = 0U;
	gboolean no_mods = FALSE;
	gboolean shift_pressed = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean only_shift_pressed = FALSE;
	gboolean control_pressed = FALSE;
	gboolean alt_pressed = FALSE;
	gboolean other_mod_pressed = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean only_control_pressed = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean only_alt_pressed = FALSE;
	gboolean in_trash = FALSE;
	FilesViewSlot* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	gboolean in_recent = FALSE;
	FilesViewSlot* _tmp11_;
	GFile* _tmp12_;
	GFile* _tmp13_;
	gboolean res = FALSE;
	gboolean result;
#line 2975 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 2976 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_is_frozen (self);
#line 2976 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 2976 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 2977 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 2977 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 15909 "AbstractDirectoryView.c"
	}
#line 2980 "../src/View/AbstractDirectoryView.vala"
	if (event->is_modifier == ((guint) 1)) {
#line 2981 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 2981 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 15917 "AbstractDirectoryView.c"
	}
#line 2984 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_hover (self);
#line 2987 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = key_utils_map_key (event, &_tmp2_);
#line 2987 "../src/View/AbstractDirectoryView.vala"
	consumed_mods = _tmp2_;
#line 2987 "../src/View/AbstractDirectoryView.vala"
	keyval = _tmp3_;
#line 2988 "../src/View/AbstractDirectoryView.vala"
	gdk_event_get_state ((GdkEvent*) event, &_tmp4_);
#line 2988 "../src/View/AbstractDirectoryView.vala"
	state = _tmp4_;
#line 2990 "../src/View/AbstractDirectoryView.vala"
	mods = (state & (~consumed_mods)) & gtk_accelerator_get_default_mod_mask ();
#line 2991 "../src/View/AbstractDirectoryView.vala"
	no_mods = mods == 0;
#line 2992 "../src/View/AbstractDirectoryView.vala"
	shift_pressed = (mods & GDK_SHIFT_MASK) != 0;
#line 2993 "../src/View/AbstractDirectoryView.vala"
	if (shift_pressed) {
#line 2993 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = (mods & (~GDK_SHIFT_MASK)) == 0;
#line 15941 "AbstractDirectoryView.c"
	} else {
#line 2993 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = FALSE;
#line 15945 "AbstractDirectoryView.c"
	}
#line 2993 "../src/View/AbstractDirectoryView.vala"
	only_shift_pressed = _tmp5_;
#line 2994 "../src/View/AbstractDirectoryView.vala"
	control_pressed = (mods & GDK_CONTROL_MASK) != 0;
#line 2995 "../src/View/AbstractDirectoryView.vala"
	alt_pressed = (mods & GDK_MOD1_MASK) != 0;
#line 2996 "../src/View/AbstractDirectoryView.vala"
	other_mod_pressed = ((mods & (~GDK_SHIFT_MASK)) & (~GDK_CONTROL_MASK)) != 0;
#line 2997 "../src/View/AbstractDirectoryView.vala"
	if (control_pressed) {
#line 2997 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = !other_mod_pressed;
#line 15959 "AbstractDirectoryView.c"
	} else {
#line 2997 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = FALSE;
#line 15963 "AbstractDirectoryView.c"
	}
#line 2997 "../src/View/AbstractDirectoryView.vala"
	only_control_pressed = _tmp6_;
#line 2998 "../src/View/AbstractDirectoryView.vala"
	if (alt_pressed) {
#line 2998 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = (mods & (~GDK_MOD1_MASK)) == 0;
#line 15971 "AbstractDirectoryView.c"
	} else {
#line 2998 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = FALSE;
#line 15975 "AbstractDirectoryView.c"
	}
#line 2998 "../src/View/AbstractDirectoryView.vala"
	only_alt_pressed = _tmp7_;
#line 2999 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = self->slot;
#line 2999 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = files_abstract_slot_get_location ((FilesAbstractSlot*) _tmp8_);
#line 2999 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = _tmp9_;
#line 2999 "../src/View/AbstractDirectoryView.vala"
	in_trash = g_file_has_uri_scheme (_tmp10_, "trash");
#line 3000 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = self->slot;
#line 3000 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = files_abstract_slot_get_location ((FilesAbstractSlot*) _tmp11_);
#line 3000 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = _tmp12_;
#line 3000 "../src/View/AbstractDirectoryView.vala"
	in_recent = g_file_has_uri_scheme (_tmp13_, "recent");
#line 3001 "../src/View/AbstractDirectoryView.vala"
	res = FALSE;
#line 3003 "../src/View/AbstractDirectoryView.vala"
	switch (keyval) {
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_F10:
#line 16001 "AbstractDirectoryView.c"
		{
#line 3005 "../src/View/AbstractDirectoryView.vala"
			if (only_control_pressed) {
#line 3006 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_show_context_menu (self, (GdkEvent*) event);
#line 3007 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 16009 "AbstractDirectoryView.c"
			}
#line 3010 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16013 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_F2:
#line 16017 "AbstractDirectoryView.c"
		{
			gboolean _tmp14_ = FALSE;
#line 3013 "../src/View/AbstractDirectoryView.vala"
			if (no_mods) {
#line 16022 "AbstractDirectoryView.c"
				GSimpleActionGroup* _tmp15_;
#line 3013 "../src/View/AbstractDirectoryView.vala"
				_tmp15_ = self->priv->selection_actions;
#line 3013 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = g_action_group_get_action_enabled ((GActionGroup*) _tmp15_, "rename");
#line 16028 "AbstractDirectoryView.c"
			} else {
#line 3013 "../src/View/AbstractDirectoryView.vala"
				_tmp14_ = FALSE;
#line 16032 "AbstractDirectoryView.c"
			}
#line 3013 "../src/View/AbstractDirectoryView.vala"
			if (_tmp14_) {
#line 3014 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_rename_selection (self);
#line 3015 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 16040 "AbstractDirectoryView.c"
			}
#line 3018 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16044 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Delete:
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_KP_Delete:
#line 16050 "AbstractDirectoryView.c"
		{
#line 3022 "../src/View/AbstractDirectoryView.vala"
			if (!self->is_writable) {
#line 16054 "AbstractDirectoryView.c"
				FilesViewWindow* _tmp16_;
				GraniteMessageDialog* _tmp17_;
				GraniteMessageDialog* _tmp18_;
#line 3023 "../src/View/AbstractDirectoryView.vala"
				_tmp16_ = self->window;
#line 3023 "../src/View/AbstractDirectoryView.vala"
				_tmp17_ = pf_dialogs_show_warning_dialog (_ ("Cannot remove files from here"), _ ("You do not have permission to change this location"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp16_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp16_) : NULL);
#line 3023 "../src/View/AbstractDirectoryView.vala"
				_tmp18_ = _tmp17_;
#line 3023 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp18_);
#line 16066 "AbstractDirectoryView.c"
			} else {
				gboolean _tmp19_;
#line 3026 "../src/View/AbstractDirectoryView.vala"
				_tmp19_ = self->priv->_renaming;
#line 3026 "../src/View/AbstractDirectoryView.vala"
				if (!_tmp19_) {
#line 16073 "AbstractDirectoryView.c"
					gboolean _tmp20_ = FALSE;
					gboolean _tmp21_ = FALSE;
#line 3027 "../src/View/AbstractDirectoryView.vala"
					if (in_trash) {
#line 3027 "../src/View/AbstractDirectoryView.vala"
						_tmp21_ = TRUE;
#line 16080 "AbstractDirectoryView.c"
					} else {
#line 3027 "../src/View/AbstractDirectoryView.vala"
						_tmp21_ = files_is_admin ();
#line 16084 "AbstractDirectoryView.c"
					}
#line 3027 "../src/View/AbstractDirectoryView.vala"
					if (_tmp21_) {
#line 3027 "../src/View/AbstractDirectoryView.vala"
						_tmp20_ = TRUE;
#line 16090 "AbstractDirectoryView.c"
					} else {
#line 3027 "../src/View/AbstractDirectoryView.vala"
						_tmp20_ = only_shift_pressed;
#line 16094 "AbstractDirectoryView.c"
					}
#line 3027 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_trash_or_delete_selected_files (self, _tmp20_);
#line 3028 "../src/View/AbstractDirectoryView.vala"
					res = TRUE;
#line 16100 "AbstractDirectoryView.c"
				}
			}
#line 3031 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16105 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_space:
#line 16109 "AbstractDirectoryView.c"
		{
			gboolean _tmp22_ = FALSE;
#line 3034 "../src/View/AbstractDirectoryView.vala"
			if (files_abstract_directory_view_view_has_focus (self)) {
#line 3034 "../src/View/AbstractDirectoryView.vala"
				_tmp22_ = !in_trash;
#line 16116 "AbstractDirectoryView.c"
			} else {
#line 3034 "../src/View/AbstractDirectoryView.vala"
				_tmp22_ = FALSE;
#line 16120 "AbstractDirectoryView.c"
			}
#line 3034 "../src/View/AbstractDirectoryView.vala"
			if (_tmp22_) {
#line 16124 "AbstractDirectoryView.c"
				GList* _tmp23_;
#line 3035 "../src/View/AbstractDirectoryView.vala"
				_tmp23_ = files_abstract_directory_view_get_selected_files (self);
#line 3035 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_NEW_TAB, _tmp23_);
#line 3036 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 16132 "AbstractDirectoryView.c"
			}
#line 3039 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16136 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Return:
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_KP_Enter:
#line 16142 "AbstractDirectoryView.c"
		{
#line 3043 "../src/View/AbstractDirectoryView.vala"
			if (in_trash) {
#line 3044 "../src/View/AbstractDirectoryView.vala"
				break;
#line 16148 "AbstractDirectoryView.c"
			} else {
#line 3045 "../src/View/AbstractDirectoryView.vala"
				if (in_recent) {
#line 16152 "AbstractDirectoryView.c"
					GList* _tmp24_;
#line 3046 "../src/View/AbstractDirectoryView.vala"
					_tmp24_ = files_abstract_directory_view_get_selected_files (self);
#line 3046 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_DEFAULT, _tmp24_);
#line 16158 "AbstractDirectoryView.c"
				} else {
#line 3047 "../src/View/AbstractDirectoryView.vala"
					if (only_shift_pressed) {
#line 16162 "AbstractDirectoryView.c"
						GList* _tmp25_;
#line 3048 "../src/View/AbstractDirectoryView.vala"
						_tmp25_ = files_abstract_directory_view_get_selected_files (self);
#line 3048 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_NEW_TAB, _tmp25_);
#line 16168 "AbstractDirectoryView.c"
					} else {
						gboolean _tmp26_ = FALSE;
						gboolean _tmp27_ = FALSE;
#line 3049 "../src/View/AbstractDirectoryView.vala"
						if (shift_pressed) {
#line 3049 "../src/View/AbstractDirectoryView.vala"
							_tmp27_ = control_pressed;
#line 16176 "AbstractDirectoryView.c"
						} else {
#line 3049 "../src/View/AbstractDirectoryView.vala"
							_tmp27_ = FALSE;
#line 16180 "AbstractDirectoryView.c"
						}
#line 3049 "../src/View/AbstractDirectoryView.vala"
						if (_tmp27_) {
#line 3049 "../src/View/AbstractDirectoryView.vala"
							_tmp26_ = !alt_pressed;
#line 16186 "AbstractDirectoryView.c"
						} else {
#line 3049 "../src/View/AbstractDirectoryView.vala"
							_tmp26_ = FALSE;
#line 16190 "AbstractDirectoryView.c"
						}
#line 3049 "../src/View/AbstractDirectoryView.vala"
						if (_tmp26_) {
#line 16194 "AbstractDirectoryView.c"
							GList* _tmp28_;
#line 3050 "../src/View/AbstractDirectoryView.vala"
							_tmp28_ = files_abstract_directory_view_get_selected_files (self);
#line 3050 "../src/View/AbstractDirectoryView.vala"
							files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_NEW_WINDOW, _tmp28_);
#line 16200 "AbstractDirectoryView.c"
						} else {
#line 3051 "../src/View/AbstractDirectoryView.vala"
							if (only_alt_pressed) {
#line 16204 "AbstractDirectoryView.c"
								GSimpleActionGroup* _tmp29_;
#line 3052 "../src/View/AbstractDirectoryView.vala"
								_tmp29_ = self->priv->common_actions;
#line 3052 "../src/View/AbstractDirectoryView.vala"
								g_action_group_activate_action ((GActionGroup*) _tmp29_, "properties", NULL);
#line 16210 "AbstractDirectoryView.c"
							} else {
#line 3053 "../src/View/AbstractDirectoryView.vala"
								if (no_mods) {
#line 16214 "AbstractDirectoryView.c"
									GList* _tmp30_;
#line 3054 "../src/View/AbstractDirectoryView.vala"
									_tmp30_ = files_abstract_directory_view_get_selected_files (self);
#line 3054 "../src/View/AbstractDirectoryView.vala"
									files_abstract_directory_view_activate_selected_items (self, FILES_OPEN_FLAG_DEFAULT, _tmp30_);
#line 16220 "AbstractDirectoryView.c"
								} else {
#line 3056 "../src/View/AbstractDirectoryView.vala"
									break;
#line 16224 "AbstractDirectoryView.c"
								}
							}
						}
					}
				}
			}
#line 3059 "../src/View/AbstractDirectoryView.vala"
			res = TRUE;
#line 3060 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16235 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_minus:
#line 16239 "AbstractDirectoryView.c"
		{
			gboolean _tmp31_ = FALSE;
#line 3063 "../src/View/AbstractDirectoryView.vala"
			if (alt_pressed) {
#line 3063 "../src/View/AbstractDirectoryView.vala"
				_tmp31_ = control_pressed;
#line 16246 "AbstractDirectoryView.c"
			} else {
#line 3063 "../src/View/AbstractDirectoryView.vala"
				_tmp31_ = FALSE;
#line 16250 "AbstractDirectoryView.c"
			}
#line 3063 "../src/View/AbstractDirectoryView.vala"
			if (_tmp31_) {
#line 16254 "AbstractDirectoryView.c"
				GtkTreePath* path = NULL;
				GtkTreePath* _tmp32_;
				gboolean _tmp33_ = FALSE;
				GtkTreePath* _tmp34_;
#line 3064 "../src/View/AbstractDirectoryView.vala"
				_tmp32_ = files_abstract_directory_view_get_path_at_cursor (self);
#line 3064 "../src/View/AbstractDirectoryView.vala"
				path = _tmp32_;
#line 3065 "../src/View/AbstractDirectoryView.vala"
				_tmp34_ = path;
#line 3065 "../src/View/AbstractDirectoryView.vala"
				if (_tmp34_ != NULL) {
#line 16267 "AbstractDirectoryView.c"
					GtkTreePath* _tmp35_;
#line 3065 "../src/View/AbstractDirectoryView.vala"
					_tmp35_ = path;
#line 3065 "../src/View/AbstractDirectoryView.vala"
					_tmp33_ = files_abstract_directory_view_path_is_selected (self, _tmp35_);
#line 16273 "AbstractDirectoryView.c"
				} else {
#line 3065 "../src/View/AbstractDirectoryView.vala"
					_tmp33_ = FALSE;
#line 16277 "AbstractDirectoryView.c"
				}
#line 3065 "../src/View/AbstractDirectoryView.vala"
				if (_tmp33_) {
#line 16281 "AbstractDirectoryView.c"
					GtkTreePath* _tmp36_;
#line 3066 "../src/View/AbstractDirectoryView.vala"
					_tmp36_ = path;
#line 3066 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_unselect_path (self, _tmp36_);
#line 16287 "AbstractDirectoryView.c"
				}
#line 3069 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 3063 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (path);
#line 16293 "AbstractDirectoryView.c"
			}
#line 3072 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16297 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_plus:
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_equal:
#line 16303 "AbstractDirectoryView.c"
		{
			gboolean _tmp37_ = FALSE;
#line 3076 "../src/View/AbstractDirectoryView.vala"
			if (alt_pressed) {
#line 3076 "../src/View/AbstractDirectoryView.vala"
				_tmp37_ = control_pressed;
#line 16310 "AbstractDirectoryView.c"
			} else {
#line 3076 "../src/View/AbstractDirectoryView.vala"
				_tmp37_ = FALSE;
#line 16314 "AbstractDirectoryView.c"
			}
#line 3076 "../src/View/AbstractDirectoryView.vala"
			if (_tmp37_) {
#line 16318 "AbstractDirectoryView.c"
				GtkTreePath* path = NULL;
				GtkTreePath* _tmp38_;
				gboolean _tmp39_ = FALSE;
				GtkTreePath* _tmp40_;
#line 3077 "../src/View/AbstractDirectoryView.vala"
				_tmp38_ = files_abstract_directory_view_get_path_at_cursor (self);
#line 3077 "../src/View/AbstractDirectoryView.vala"
				path = _tmp38_;
#line 3078 "../src/View/AbstractDirectoryView.vala"
				_tmp40_ = path;
#line 3078 "../src/View/AbstractDirectoryView.vala"
				if (_tmp40_ != NULL) {
#line 16331 "AbstractDirectoryView.c"
					GtkTreePath* _tmp41_;
#line 3078 "../src/View/AbstractDirectoryView.vala"
					_tmp41_ = path;
#line 3078 "../src/View/AbstractDirectoryView.vala"
					_tmp39_ = !files_abstract_directory_view_path_is_selected (self, _tmp41_);
#line 16337 "AbstractDirectoryView.c"
				} else {
#line 3078 "../src/View/AbstractDirectoryView.vala"
					_tmp39_ = FALSE;
#line 16341 "AbstractDirectoryView.c"
				}
#line 3078 "../src/View/AbstractDirectoryView.vala"
				if (_tmp39_) {
#line 16345 "AbstractDirectoryView.c"
					GtkTreePath* _tmp42_;
#line 3079 "../src/View/AbstractDirectoryView.vala"
					_tmp42_ = path;
#line 3079 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_select_path (self, _tmp42_, FALSE);
#line 16351 "AbstractDirectoryView.c"
				}
#line 3082 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 3076 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (path);
#line 16357 "AbstractDirectoryView.c"
			}
#line 3085 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16361 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Escape:
#line 16365 "AbstractDirectoryView.c"
		{
#line 3088 "../src/View/AbstractDirectoryView.vala"
			if (no_mods) {
#line 3089 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_unselect_all (self);
#line 16371 "AbstractDirectoryView.c"
			}
#line 3092 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16375 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Menu:
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_MenuKB:
#line 16381 "AbstractDirectoryView.c"
		{
#line 3096 "../src/View/AbstractDirectoryView.vala"
			if (no_mods) {
#line 3097 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_show_context_menu (self, (GdkEvent*) event);
#line 3098 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 16389 "AbstractDirectoryView.c"
			}
#line 3101 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16393 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_N:
#line 16397 "AbstractDirectoryView.c"
		{
#line 3104 "../src/View/AbstractDirectoryView.vala"
			if (control_pressed) {
#line 3105 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_new_empty_folder (self);
#line 3106 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 16405 "AbstractDirectoryView.c"
			}
#line 3109 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16409 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Up:
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Down:
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Left:
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Right:
#line 16419 "AbstractDirectoryView.c"
		{
			GList* selection = NULL;
			GList* _tmp43_;
			gboolean _tmp44_ = FALSE;
#line 3115 "../src/View/AbstractDirectoryView.vala"
			_tmp43_ = files_abstract_directory_view_get_selected_files (self);
#line 3115 "../src/View/AbstractDirectoryView.vala"
			selection = _tmp43_;
#line 3116 "../src/View/AbstractDirectoryView.vala"
			if (only_alt_pressed) {
#line 3116 "../src/View/AbstractDirectoryView.vala"
				_tmp44_ = keyval == GDK_KEY_Down;
#line 16432 "AbstractDirectoryView.c"
			} else {
#line 3116 "../src/View/AbstractDirectoryView.vala"
				_tmp44_ = FALSE;
#line 16436 "AbstractDirectoryView.c"
			}
#line 3116 "../src/View/AbstractDirectoryView.vala"
			if (_tmp44_) {
#line 16440 "AbstractDirectoryView.c"
				gboolean _tmp45_ = FALSE;
				gboolean _tmp46_ = FALSE;
				GList* _tmp47_;
#line 3119 "../src/View/AbstractDirectoryView.vala"
				_tmp47_ = selection;
#line 3119 "../src/View/AbstractDirectoryView.vala"
				if (_tmp47_ != NULL) {
#line 16448 "AbstractDirectoryView.c"
					GList* _tmp48_;
					GList* _tmp49_;
					GList* _tmp50_;
#line 3120 "../src/View/AbstractDirectoryView.vala"
					_tmp48_ = selection;
#line 3120 "../src/View/AbstractDirectoryView.vala"
					_tmp49_ = g_list_first (_tmp48_);
#line 3120 "../src/View/AbstractDirectoryView.vala"
					_tmp50_ = _tmp49_->next;
#line 3120 "../src/View/AbstractDirectoryView.vala"
					_tmp46_ = _tmp50_ == NULL;
#line 16460 "AbstractDirectoryView.c"
				} else {
#line 3119 "../src/View/AbstractDirectoryView.vala"
					_tmp46_ = FALSE;
#line 16464 "AbstractDirectoryView.c"
				}
#line 3119 "../src/View/AbstractDirectoryView.vala"
				if (_tmp46_) {
#line 16468 "AbstractDirectoryView.c"
					GList* _tmp51_;
					gconstpointer _tmp52_;
#line 3121 "../src/View/AbstractDirectoryView.vala"
					_tmp51_ = selection;
#line 3121 "../src/View/AbstractDirectoryView.vala"
					_tmp52_ = _tmp51_->data;
#line 3121 "../src/View/AbstractDirectoryView.vala"
					_tmp45_ = files_file_is_folder ((FilesFile*) _tmp52_);
#line 16477 "AbstractDirectoryView.c"
				} else {
#line 3119 "../src/View/AbstractDirectoryView.vala"
					_tmp45_ = FALSE;
#line 16481 "AbstractDirectoryView.c"
				}
#line 3119 "../src/View/AbstractDirectoryView.vala"
				if (_tmp45_) {
#line 16485 "AbstractDirectoryView.c"
					GList* _tmp53_;
					gconstpointer _tmp54_;
					GFile* _tmp55_;
					GFile* _tmp56_;
#line 3123 "../src/View/AbstractDirectoryView.vala"
					_tmp53_ = selection;
#line 3123 "../src/View/AbstractDirectoryView.vala"
					_tmp54_ = _tmp53_->data;
#line 3123 "../src/View/AbstractDirectoryView.vala"
					_tmp55_ = files_file_get_location ((FilesFile*) _tmp54_);
#line 3123 "../src/View/AbstractDirectoryView.vala"
					_tmp56_ = _tmp55_;
#line 3123 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_load_location (self, _tmp56_);
#line 3124 "../src/View/AbstractDirectoryView.vala"
					res = TRUE;
#line 16502 "AbstractDirectoryView.c"
				}
#line 3127 "../src/View/AbstractDirectoryView.vala"
				break;
#line 16506 "AbstractDirectoryView.c"
			}
#line 3130 "../src/View/AbstractDirectoryView.vala"
			res = files_abstract_directory_view_move_cursor (self, keyval, only_shift_pressed, control_pressed);
#line 3131 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16512 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_Home:
#line 16516 "AbstractDirectoryView.c"
		{
			gboolean _tmp57_ = FALSE;
#line 3134 "../src/View/AbstractDirectoryView.vala"
			if (only_shift_pressed) {
#line 16521 "AbstractDirectoryView.c"
				GtkTreePath* _tmp58_;
				GtkTreePath* _tmp59_;
#line 3135 "../src/View/AbstractDirectoryView.vala"
				_tmp58_ = gtk_tree_path_new_from_indices (0, -1);
#line 3135 "../src/View/AbstractDirectoryView.vala"
				_tmp59_ = _tmp58_;
#line 3135 "../src/View/AbstractDirectoryView.vala"
				_tmp57_ = files_abstract_directory_view_handle_multi_select (self, _tmp59_);
#line 3135 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (_tmp59_);
#line 16532 "AbstractDirectoryView.c"
			} else {
#line 3134 "../src/View/AbstractDirectoryView.vala"
				_tmp57_ = FALSE;
#line 16536 "AbstractDirectoryView.c"
			}
#line 3134 "../src/View/AbstractDirectoryView.vala"
			res = _tmp57_;
#line 3137 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16542 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_End:
#line 16546 "AbstractDirectoryView.c"
		{
			gboolean _tmp60_ = FALSE;
#line 3140 "../src/View/AbstractDirectoryView.vala"
			if (only_shift_pressed) {
#line 16551 "AbstractDirectoryView.c"
				FilesListModel* _tmp61_;
				GtkTreePath* _tmp62_;
				GtkTreePath* _tmp63_;
#line 3141 "../src/View/AbstractDirectoryView.vala"
				_tmp61_ = self->model;
#line 3141 "../src/View/AbstractDirectoryView.vala"
				_tmp62_ = gtk_tree_path_new_from_indices (files_list_model_get_length (_tmp61_), -1);
#line 3141 "../src/View/AbstractDirectoryView.vala"
				_tmp63_ = _tmp62_;
#line 3141 "../src/View/AbstractDirectoryView.vala"
				_tmp60_ = files_abstract_directory_view_handle_multi_select (self, _tmp63_);
#line 3141 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (_tmp63_);
#line 16565 "AbstractDirectoryView.c"
			} else {
#line 3140 "../src/View/AbstractDirectoryView.vala"
				_tmp60_ = FALSE;
#line 16569 "AbstractDirectoryView.c"
			}
#line 3140 "../src/View/AbstractDirectoryView.vala"
			res = _tmp60_;
#line 3143 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16575 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_c:
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_C:
#line 16581 "AbstractDirectoryView.c"
		{
#line 3147 "../src/View/AbstractDirectoryView.vala"
			if (only_control_pressed) {
#line 16585 "AbstractDirectoryView.c"
				gboolean caps_on = FALSE;
				GdkDisplay* _tmp64_;
				GdkKeymap* _tmp65_;
				gboolean cap_c = FALSE;
#line 3149 "../src/View/AbstractDirectoryView.vala"
				_tmp64_ = gtk_widget_get_display ((GtkWidget*) self);
#line 3149 "../src/View/AbstractDirectoryView.vala"
				_tmp65_ = gdk_keymap_get_for_display (_tmp64_);
#line 3149 "../src/View/AbstractDirectoryView.vala"
				caps_on = gdk_keymap_get_caps_lock_state (_tmp65_);
#line 3150 "../src/View/AbstractDirectoryView.vala"
				cap_c = keyval == GDK_KEY_C;
#line 3152 "../src/View/AbstractDirectoryView.vala"
				if (caps_on != cap_c) {
#line 16600 "AbstractDirectoryView.c"
					GSimpleActionGroup* _tmp66_;
#line 3153 "../src/View/AbstractDirectoryView.vala"
					_tmp66_ = self->priv->common_actions;
#line 3153 "../src/View/AbstractDirectoryView.vala"
					g_action_group_activate_action ((GActionGroup*) _tmp66_, "copy-link", NULL);
#line 16606 "AbstractDirectoryView.c"
				} else {
#line 3156 "../src/View/AbstractDirectoryView.vala"
					if (in_trash) {
#line 16610 "AbstractDirectoryView.c"
						FilesViewWindow* _tmp67_;
						GraniteMessageDialog* _tmp68_;
						GraniteMessageDialog* _tmp69_;
						GSimpleActionGroup* _tmp70_;
#line 3157 "../src/View/AbstractDirectoryView.vala"
						_tmp67_ = self->window;
#line 3157 "../src/View/AbstractDirectoryView.vala"
						_tmp68_ = pf_dialogs_show_warning_dialog (_ ("Cannot copy files that are in the trash"), _ ("Cutting the selection instead"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp67_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp67_) : NULL);
#line 3157 "../src/View/AbstractDirectoryView.vala"
						_tmp69_ = _tmp68_;
#line 3157 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (_tmp69_);
#line 3161 "../src/View/AbstractDirectoryView.vala"
						_tmp70_ = self->priv->selection_actions;
#line 3161 "../src/View/AbstractDirectoryView.vala"
						g_action_group_activate_action ((GActionGroup*) _tmp70_, "cut", NULL);
#line 16627 "AbstractDirectoryView.c"
					} else {
						GSimpleActionGroup* _tmp71_;
#line 3163 "../src/View/AbstractDirectoryView.vala"
						_tmp71_ = self->priv->common_actions;
#line 3163 "../src/View/AbstractDirectoryView.vala"
						g_action_group_activate_action ((GActionGroup*) _tmp71_, "copy", NULL);
#line 16634 "AbstractDirectoryView.c"
					}
				}
#line 3167 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 16639 "AbstractDirectoryView.c"
			}
#line 3170 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16643 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_v:
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_V:
#line 16649 "AbstractDirectoryView.c"
		{
#line 3174 "../src/View/AbstractDirectoryView.vala"
			if (only_control_pressed) {
#line 3175 "../src/View/AbstractDirectoryView.vala"
				if (shift_pressed) {
#line 16655 "AbstractDirectoryView.c"
					gboolean _tmp72_ = FALSE;
#line 3176 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_update_selected_files_and_menu (self);
#line 3177 "../src/View/AbstractDirectoryView.vala"
					if (!in_recent) {
#line 3177 "../src/View/AbstractDirectoryView.vala"
						_tmp72_ = self->is_writable;
#line 16663 "AbstractDirectoryView.c"
					} else {
#line 3177 "../src/View/AbstractDirectoryView.vala"
						_tmp72_ = FALSE;
#line 16667 "AbstractDirectoryView.c"
					}
#line 3177 "../src/View/AbstractDirectoryView.vala"
					if (_tmp72_) {
#line 16671 "AbstractDirectoryView.c"
						gboolean _tmp73_ = FALSE;
						GList* _tmp74_;
						GList* _tmp75_;
#line 3178 "../src/View/AbstractDirectoryView.vala"
						_tmp74_ = self->selected_files;
#line 3178 "../src/View/AbstractDirectoryView.vala"
						_tmp75_ = g_list_first (_tmp74_);
#line 3178 "../src/View/AbstractDirectoryView.vala"
						if (_tmp75_ != NULL) {
#line 16681 "AbstractDirectoryView.c"
							GList* _tmp76_;
							GList* _tmp77_;
							GList* _tmp78_;
#line 3178 "../src/View/AbstractDirectoryView.vala"
							_tmp76_ = self->selected_files;
#line 3178 "../src/View/AbstractDirectoryView.vala"
							_tmp77_ = g_list_first (_tmp76_);
#line 3178 "../src/View/AbstractDirectoryView.vala"
							_tmp78_ = _tmp77_->next;
#line 3178 "../src/View/AbstractDirectoryView.vala"
							_tmp73_ = _tmp78_ != NULL;
#line 16693 "AbstractDirectoryView.c"
						} else {
#line 3178 "../src/View/AbstractDirectoryView.vala"
							_tmp73_ = FALSE;
#line 16697 "AbstractDirectoryView.c"
						}
#line 3178 "../src/View/AbstractDirectoryView.vala"
						if (_tmp73_) {
#line 3180 "../src/View/AbstractDirectoryView.vala"
							gdk_beep ();
#line 3181 "../src/View/AbstractDirectoryView.vala"
							g_warning ("AbstractDirectoryView.vala:3181: Cannot paste into a multiple selectio" \
"n");
#line 16705 "AbstractDirectoryView.c"
						} else {
							GSimpleActionGroup* _tmp79_;
							GSimpleActionGroup* _tmp80_;
#line 3184 "../src/View/AbstractDirectoryView.vala"
							_tmp79_ = self->priv->common_actions;
#line 3184 "../src/View/AbstractDirectoryView.vala"
							files_abstract_directory_view_action_set_enabled (self, _tmp79_, "paste-into", TRUE);
#line 3185 "../src/View/AbstractDirectoryView.vala"
							_tmp80_ = self->priv->common_actions;
#line 3185 "../src/View/AbstractDirectoryView.vala"
							g_action_group_activate_action ((GActionGroup*) _tmp80_, "paste-into", NULL);
#line 16717 "AbstractDirectoryView.c"
						}
					} else {
						FilesViewWindow* _tmp81_;
						GraniteMessageDialog* _tmp82_;
						GraniteMessageDialog* _tmp83_;
#line 3188 "../src/View/AbstractDirectoryView.vala"
						_tmp81_ = self->window;
#line 3188 "../src/View/AbstractDirectoryView.vala"
						_tmp82_ = pf_dialogs_show_warning_dialog (_ ("Cannot paste files here"), _ ("You do not have permission to change this location"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp81_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp81_) : NULL);
#line 3188 "../src/View/AbstractDirectoryView.vala"
						_tmp83_ = _tmp82_;
#line 3188 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (_tmp83_);
#line 16731 "AbstractDirectoryView.c"
					}
#line 3193 "../src/View/AbstractDirectoryView.vala"
					res = TRUE;
#line 16735 "AbstractDirectoryView.c"
				} else {
					gboolean _tmp84_ = FALSE;
#line 3195 "../src/View/AbstractDirectoryView.vala"
					if (!in_recent) {
#line 3195 "../src/View/AbstractDirectoryView.vala"
						_tmp84_ = self->is_writable;
#line 16742 "AbstractDirectoryView.c"
					} else {
#line 3195 "../src/View/AbstractDirectoryView.vala"
						_tmp84_ = FALSE;
#line 16746 "AbstractDirectoryView.c"
					}
#line 3195 "../src/View/AbstractDirectoryView.vala"
					if (_tmp84_) {
#line 16750 "AbstractDirectoryView.c"
						GSimpleActionGroup* _tmp85_;
						GSimpleActionGroup* _tmp86_;
#line 3196 "../src/View/AbstractDirectoryView.vala"
						_tmp85_ = self->priv->common_actions;
#line 3196 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_action_set_enabled (self, _tmp85_, "paste", TRUE);
#line 3197 "../src/View/AbstractDirectoryView.vala"
						_tmp86_ = self->priv->common_actions;
#line 3197 "../src/View/AbstractDirectoryView.vala"
						g_action_group_activate_action ((GActionGroup*) _tmp86_, "paste", NULL);
#line 16761 "AbstractDirectoryView.c"
					} else {
						FilesViewWindow* _tmp87_;
						GraniteMessageDialog* _tmp88_;
						GraniteMessageDialog* _tmp89_;
#line 3199 "../src/View/AbstractDirectoryView.vala"
						_tmp87_ = self->window;
#line 3199 "../src/View/AbstractDirectoryView.vala"
						_tmp88_ = pf_dialogs_show_warning_dialog (_ ("Cannot paste files here"), _ ("You do not have permission to change this location"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp87_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp87_) : NULL);
#line 3199 "../src/View/AbstractDirectoryView.vala"
						_tmp89_ = _tmp88_;
#line 3199 "../src/View/AbstractDirectoryView.vala"
						_g_object_unref0 (_tmp89_);
#line 16774 "AbstractDirectoryView.c"
					}
#line 3204 "../src/View/AbstractDirectoryView.vala"
					res = TRUE;
#line 16778 "AbstractDirectoryView.c"
				}
			}
#line 3208 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16783 "AbstractDirectoryView.c"
		}
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_x:
#line 3003 "../src/View/AbstractDirectoryView.vala"
		case GDK_KEY_X:
#line 16789 "AbstractDirectoryView.c"
		{
#line 3212 "../src/View/AbstractDirectoryView.vala"
			if (only_control_pressed) {
#line 3213 "../src/View/AbstractDirectoryView.vala"
				if (self->is_writable) {
#line 16795 "AbstractDirectoryView.c"
					GSimpleActionGroup* _tmp90_;
#line 3214 "../src/View/AbstractDirectoryView.vala"
					_tmp90_ = self->priv->selection_actions;
#line 3214 "../src/View/AbstractDirectoryView.vala"
					g_action_group_activate_action ((GActionGroup*) _tmp90_, "cut", NULL);
#line 16801 "AbstractDirectoryView.c"
				} else {
					FilesViewWindow* _tmp91_;
					GraniteMessageDialog* _tmp92_;
					GraniteMessageDialog* _tmp93_;
#line 3216 "../src/View/AbstractDirectoryView.vala"
					_tmp91_ = self->window;
#line 3216 "../src/View/AbstractDirectoryView.vala"
					_tmp92_ = pf_dialogs_show_warning_dialog (_ ("Cannot remove files from here"), _ ("You do not have permission to change this location"), G_TYPE_CHECK_INSTANCE_TYPE (_tmp91_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp91_) : NULL);
#line 3216 "../src/View/AbstractDirectoryView.vala"
					_tmp93_ = _tmp92_;
#line 3216 "../src/View/AbstractDirectoryView.vala"
					_g_object_unref0 (_tmp93_);
#line 16814 "AbstractDirectoryView.c"
				}
#line 3221 "../src/View/AbstractDirectoryView.vala"
				res = TRUE;
#line 16818 "AbstractDirectoryView.c"
			}
#line 3224 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16822 "AbstractDirectoryView.c"
		}
		default:
		{
#line 3227 "../src/View/AbstractDirectoryView.vala"
			break;
#line 16828 "AbstractDirectoryView.c"
		}
	}
#line 3230 "../src/View/AbstractDirectoryView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda98__gsource_func, g_object_ref (self), g_object_unref);
#line 3235 "../src/View/AbstractDirectoryView.vala"
	result = res;
#line 3235 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 16837 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_on_view_key_press_event (FilesAbstractDirectoryView* self,
                                                       GdkEventKey* event)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 2975 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 2975 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 2975 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->on_view_key_press_event) {
#line 2975 "../src/View/AbstractDirectoryView.vala"
		return _klass_->on_view_key_press_event (self, event);
#line 16853 "AbstractDirectoryView.c"
	}
#line 2975 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 16857 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_on_motion_notify_event (FilesAbstractDirectoryView* self,
                                                      GdkEventMotion* event)
{
	GtkTreePath* path = NULL;
	FilesFile* file = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GtkTreePath* _tmp4_ = NULL;
	guint _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	GtkTreePath* _tmp9_;
	gboolean result;
#line 3238 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3238 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 3239 "../src/View/AbstractDirectoryView.vala"
	path = NULL;
#line 3240 "../src/View/AbstractDirectoryView.vala"
	file = NULL;
#line 3242 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->_renaming;
#line 3242 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 3242 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 16889 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp2_;
		gboolean _tmp3_;
#line 3242 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = files_abstract_directory_view_get_is_frozen (self);
#line 3242 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp2_;
#line 3242 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _tmp3_;
#line 16899 "AbstractDirectoryView.c"
	}
#line 3242 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 3243 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 3243 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 3243 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (path);
#line 3243 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 16911 "AbstractDirectoryView.c"
	}
#line 3246 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = files_abstract_directory_view_get_event_position_info (self, (GdkEventButton*) event, &_tmp4_, FALSE);
#line 3246 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 3246 "../src/View/AbstractDirectoryView.vala"
	path = _tmp4_;
#line 3246 "../src/View/AbstractDirectoryView.vala"
	self->click_zone = _tmp5_;
#line 3248 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = path;
#line 3248 "../src/View/AbstractDirectoryView.vala"
	if (_tmp9_ != NULL) {
#line 16925 "AbstractDirectoryView.c"
		GtkTreePath* _tmp10_;
#line 3248 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->priv->hover_path;
#line 3248 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = _tmp10_ == NULL;
#line 16931 "AbstractDirectoryView.c"
	} else {
#line 3248 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = FALSE;
#line 16935 "AbstractDirectoryView.c"
	}
#line 3248 "../src/View/AbstractDirectoryView.vala"
	if (_tmp8_) {
#line 3248 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = TRUE;
#line 16941 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp11_ = FALSE;
		GtkTreePath* _tmp12_;
#line 3249 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = path;
#line 3249 "../src/View/AbstractDirectoryView.vala"
		if (_tmp12_ == NULL) {
#line 16949 "AbstractDirectoryView.c"
			GtkTreePath* _tmp13_;
#line 3249 "../src/View/AbstractDirectoryView.vala"
			_tmp13_ = self->priv->hover_path;
#line 3249 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = _tmp13_ != NULL;
#line 16955 "AbstractDirectoryView.c"
		} else {
#line 3249 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = FALSE;
#line 16959 "AbstractDirectoryView.c"
		}
#line 3249 "../src/View/AbstractDirectoryView.vala"
		_tmp7_ = _tmp11_;
#line 16963 "AbstractDirectoryView.c"
	}
#line 3248 "../src/View/AbstractDirectoryView.vala"
	if (_tmp7_) {
#line 3248 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = TRUE;
#line 16969 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp14_ = FALSE;
		gboolean _tmp15_ = FALSE;
		GtkTreePath* _tmp16_;
#line 3250 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = path;
#line 3250 "../src/View/AbstractDirectoryView.vala"
		if (_tmp16_ != NULL) {
#line 16978 "AbstractDirectoryView.c"
			GtkTreePath* _tmp17_;
#line 3250 "../src/View/AbstractDirectoryView.vala"
			_tmp17_ = self->priv->hover_path;
#line 3250 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = _tmp17_ != NULL;
#line 16984 "AbstractDirectoryView.c"
		} else {
#line 3250 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = FALSE;
#line 16988 "AbstractDirectoryView.c"
		}
#line 3250 "../src/View/AbstractDirectoryView.vala"
		if (_tmp15_) {
#line 16992 "AbstractDirectoryView.c"
			GtkTreePath* _tmp18_;
			GtkTreePath* _tmp19_;
#line 3250 "../src/View/AbstractDirectoryView.vala"
			_tmp18_ = path;
#line 3250 "../src/View/AbstractDirectoryView.vala"
			_tmp19_ = self->priv->hover_path;
#line 3250 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = gtk_tree_path_compare (_tmp18_, _tmp19_) != 0;
#line 17001 "AbstractDirectoryView.c"
		} else {
#line 3250 "../src/View/AbstractDirectoryView.vala"
			_tmp14_ = FALSE;
#line 17005 "AbstractDirectoryView.c"
		}
#line 3250 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp14_;
#line 17009 "AbstractDirectoryView.c"
	}
#line 3248 "../src/View/AbstractDirectoryView.vala"
	if (_tmp6_) {
#line 17013 "AbstractDirectoryView.c"
		gboolean _tmp20_ = FALSE;
		FilesViewSlot* _tmp21_;
		FilesDirectory* _tmp22_;
		FilesDirectory* _tmp23_;
		gboolean _tmp24_;
		gboolean _tmp25_;
#line 3252 "../src/View/AbstractDirectoryView.vala"
		self->on_directory = FALSE;
#line 3254 "../src/View/AbstractDirectoryView.vala"
		_tmp21_ = self->slot;
#line 3254 "../src/View/AbstractDirectoryView.vala"
		_tmp22_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp21_);
#line 3254 "../src/View/AbstractDirectoryView.vala"
		_tmp23_ = _tmp22_;
#line 3254 "../src/View/AbstractDirectoryView.vala"
		_tmp24_ = files_directory_get_is_local (_tmp23_);
#line 3254 "../src/View/AbstractDirectoryView.vala"
		_tmp25_ = _tmp24_;
#line 3254 "../src/View/AbstractDirectoryView.vala"
		if (_tmp25_) {
#line 3254 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = TRUE;
#line 17036 "AbstractDirectoryView.c"
		} else {
			GNetworkMonitor* _tmp26_;
#line 3254 "../src/View/AbstractDirectoryView.vala"
			_tmp26_ = g_network_monitor_get_default ();
#line 3254 "../src/View/AbstractDirectoryView.vala"
			_tmp20_ = g_network_monitor_get_network_available (_tmp26_);
#line 17043 "AbstractDirectoryView.c"
		}
#line 3254 "../src/View/AbstractDirectoryView.vala"
		if (_tmp20_) {
#line 17047 "AbstractDirectoryView.c"
			FilesFile* target_file = NULL;
			FilesFile* _tmp27_ = NULL;
			GtkTreePath* _tmp28_;
			FilesFile* _tmp32_;
			gboolean _tmp33_ = FALSE;
			FilesFile* _tmp34_;
			FilesFile* _tmp47_;
			GtkTreePath* _tmp49_;
			GtkTreePath* _tmp50_;
#line 3257 "../src/View/AbstractDirectoryView.vala"
			_tmp28_ = path;
#line 3257 "../src/View/AbstractDirectoryView.vala"
			if (_tmp28_ != NULL) {
#line 17061 "AbstractDirectoryView.c"
				FilesListModel* _tmp29_;
				GtkTreePath* _tmp30_;
				FilesFile* _tmp31_;
#line 3257 "../src/View/AbstractDirectoryView.vala"
				_tmp29_ = self->model;
#line 3257 "../src/View/AbstractDirectoryView.vala"
				_tmp30_ = path;
#line 3257 "../src/View/AbstractDirectoryView.vala"
				_tmp31_ = files_list_model_file_for_path (_tmp29_, _tmp30_);
#line 3257 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp27_);
#line 3257 "../src/View/AbstractDirectoryView.vala"
				_tmp27_ = _tmp31_;
#line 17075 "AbstractDirectoryView.c"
			} else {
#line 3257 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (_tmp27_);
#line 3257 "../src/View/AbstractDirectoryView.vala"
				_tmp27_ = NULL;
#line 17081 "AbstractDirectoryView.c"
			}
#line 3257 "../src/View/AbstractDirectoryView.vala"
			_tmp32_ = _g_object_ref0 (_tmp27_);
#line 3257 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (file);
#line 3257 "../src/View/AbstractDirectoryView.vala"
			file = _tmp32_;
#line 3260 "../src/View/AbstractDirectoryView.vala"
			_tmp34_ = file;
#line 3260 "../src/View/AbstractDirectoryView.vala"
			if (_tmp34_ != NULL) {
#line 17093 "AbstractDirectoryView.c"
				FilesViewSlot* _tmp35_;
				FilesDirectory* _tmp36_;
				FilesDirectory* _tmp37_;
				gboolean _tmp38_;
				gboolean _tmp39_;
#line 3260 "../src/View/AbstractDirectoryView.vala"
				_tmp35_ = self->slot;
#line 3260 "../src/View/AbstractDirectoryView.vala"
				_tmp36_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp35_);
#line 3260 "../src/View/AbstractDirectoryView.vala"
				_tmp37_ = _tmp36_;
#line 3260 "../src/View/AbstractDirectoryView.vala"
				_tmp38_ = files_directory_get_is_recent (_tmp37_);
#line 3260 "../src/View/AbstractDirectoryView.vala"
				_tmp39_ = _tmp38_;
#line 3260 "../src/View/AbstractDirectoryView.vala"
				_tmp33_ = _tmp39_;
#line 17111 "AbstractDirectoryView.c"
			} else {
#line 3260 "../src/View/AbstractDirectoryView.vala"
				_tmp33_ = FALSE;
#line 17115 "AbstractDirectoryView.c"
			}
#line 3260 "../src/View/AbstractDirectoryView.vala"
			if (_tmp33_) {
#line 17119 "AbstractDirectoryView.c"
				FilesFile* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				FilesFile* _tmp43_;
				FilesFile* _tmp44_;
#line 3261 "../src/View/AbstractDirectoryView.vala"
				_tmp40_ = file;
#line 3261 "../src/View/AbstractDirectoryView.vala"
				_tmp41_ = files_file_get_display_target_uri (_tmp40_);
#line 3261 "../src/View/AbstractDirectoryView.vala"
				_tmp42_ = _tmp41_;
#line 3261 "../src/View/AbstractDirectoryView.vala"
				_tmp43_ = files_file_get_by_uri (_tmp42_);
#line 3261 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (target_file);
#line 3261 "../src/View/AbstractDirectoryView.vala"
				target_file = _tmp43_;
#line 3261 "../src/View/AbstractDirectoryView.vala"
				_g_free0 (_tmp42_);
#line 3262 "../src/View/AbstractDirectoryView.vala"
				_tmp44_ = target_file;
#line 3262 "../src/View/AbstractDirectoryView.vala"
				files_file_ensure_query_info (_tmp44_);
#line 17143 "AbstractDirectoryView.c"
			} else {
				FilesFile* _tmp45_;
				FilesFile* _tmp46_;
#line 3264 "../src/View/AbstractDirectoryView.vala"
				_tmp45_ = file;
#line 3264 "../src/View/AbstractDirectoryView.vala"
				_tmp46_ = _g_object_ref0 (_tmp45_);
#line 3264 "../src/View/AbstractDirectoryView.vala"
				_g_object_unref0 (target_file);
#line 3264 "../src/View/AbstractDirectoryView.vala"
				target_file = _tmp46_;
#line 17155 "AbstractDirectoryView.c"
			}
#line 3267 "../src/View/AbstractDirectoryView.vala"
			_tmp47_ = target_file;
#line 3267 "../src/View/AbstractDirectoryView.vala"
			if (_tmp47_ != NULL) {
#line 17161 "AbstractDirectoryView.c"
				FilesFile* _tmp48_;
#line 3268 "../src/View/AbstractDirectoryView.vala"
				_tmp48_ = target_file;
#line 3268 "../src/View/AbstractDirectoryView.vala"
				self->on_directory = _tmp48_->is_directory;
#line 17167 "AbstractDirectoryView.c"
			}
#line 3271 "../src/View/AbstractDirectoryView.vala"
			_tmp49_ = path;
#line 3271 "../src/View/AbstractDirectoryView.vala"
			_tmp50_ = __vala_GtkTreePath_copy0 (_tmp49_);
#line 3271 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (self->priv->hover_path);
#line 3271 "../src/View/AbstractDirectoryView.vala"
			self->priv->hover_path = _tmp50_;
#line 3254 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp27_);
#line 3254 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (target_file);
#line 17181 "AbstractDirectoryView.c"
		}
	}
#line 3275 "../src/View/AbstractDirectoryView.vala"
	if (self->click_zone != self->previous_click_zone) {
#line 17186 "AbstractDirectoryView.c"
		GdkWindow* win = NULL;
		GtkWidget* _tmp51_;
		GdkWindow* _tmp52_;
		GdkWindow* _tmp53_;
		GdkWindow* _tmp54_;
		GdkCursor* _tmp55_;
#line 3276 "../src/View/AbstractDirectoryView.vala"
		_tmp51_ = self->priv->view;
#line 3276 "../src/View/AbstractDirectoryView.vala"
		_tmp52_ = gtk_widget_get_window (_tmp51_);
#line 3276 "../src/View/AbstractDirectoryView.vala"
		_tmp53_ = _g_object_ref0 (_tmp52_);
#line 3276 "../src/View/AbstractDirectoryView.vala"
		win = _tmp53_;
#line 3277 "../src/View/AbstractDirectoryView.vala"
		_tmp54_ = win;
#line 3277 "../src/View/AbstractDirectoryView.vala"
		_tmp55_ = self->priv->selectable_cursor;
#line 3277 "../src/View/AbstractDirectoryView.vala"
		gdk_window_set_cursor (_tmp54_, _tmp55_);
#line 3279 "../src/View/AbstractDirectoryView.vala"
		switch (self->click_zone) {
#line 3279 "../src/View/AbstractDirectoryView.vala"
			case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON:
#line 3279 "../src/View/AbstractDirectoryView.vala"
			case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME:
#line 17213 "AbstractDirectoryView.c"
			{
				gboolean _tmp56_ = FALSE;
				gboolean _tmp57_ = FALSE;
#line 3282 "../src/View/AbstractDirectoryView.vala"
				if (self->on_directory) {
#line 3282 "../src/View/AbstractDirectoryView.vala"
					_tmp57_ = self->one_or_less;
#line 17221 "AbstractDirectoryView.c"
				} else {
#line 3282 "../src/View/AbstractDirectoryView.vala"
					_tmp57_ = FALSE;
#line 17225 "AbstractDirectoryView.c"
				}
#line 3282 "../src/View/AbstractDirectoryView.vala"
				if (_tmp57_) {
#line 17229 "AbstractDirectoryView.c"
					gboolean _tmp58_;
#line 3282 "../src/View/AbstractDirectoryView.vala"
					_tmp58_ = self->priv->_singleclick_select;
#line 3282 "../src/View/AbstractDirectoryView.vala"
					_tmp56_ = !_tmp58_;
#line 17235 "AbstractDirectoryView.c"
				} else {
#line 3282 "../src/View/AbstractDirectoryView.vala"
					_tmp56_ = FALSE;
#line 17239 "AbstractDirectoryView.c"
				}
#line 3282 "../src/View/AbstractDirectoryView.vala"
				if (_tmp56_) {
#line 17243 "AbstractDirectoryView.c"
					GdkWindow* _tmp59_;
					GdkCursor* _tmp60_;
#line 3283 "../src/View/AbstractDirectoryView.vala"
					_tmp59_ = win;
#line 3283 "../src/View/AbstractDirectoryView.vala"
					_tmp60_ = self->priv->activatable_cursor;
#line 3283 "../src/View/AbstractDirectoryView.vala"
					gdk_window_set_cursor (_tmp59_, _tmp60_);
#line 17252 "AbstractDirectoryView.c"
				}
#line 3286 "../src/View/AbstractDirectoryView.vala"
				break;
#line 17256 "AbstractDirectoryView.c"
			}
			default:
			{
#line 3289 "../src/View/AbstractDirectoryView.vala"
				break;
#line 17262 "AbstractDirectoryView.c"
			}
		}
#line 3292 "../src/View/AbstractDirectoryView.vala"
		self->previous_click_zone = self->click_zone;
#line 3275 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (win);
#line 17269 "AbstractDirectoryView.c"
	}
#line 3295 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3295 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file);
#line 3295 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 3295 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 17279 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_on_leave_notify_event (FilesAbstractDirectoryView* self,
                                                     GdkEventCrossing* event)
{
	gboolean result;
#line 3298 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3298 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 3299 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->priv->hover_path);
#line 3299 "../src/View/AbstractDirectoryView.vala"
	self->priv->hover_path = NULL;
#line 3300 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3300 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 17299 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_on_scroll_event (FilesAbstractDirectoryView* self,
                                                    GdkEventScroll* event)
{
	GdkScrollDirection direction = 0;
	GdkScrollDirection _tmp0_ = 0;
	GdkModifierType state = 0U;
	GdkModifierType _tmp1_ = 0U;
	gboolean result;
#line 3303 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 3305 "../src/View/AbstractDirectoryView.vala"
	gdk_event_get_scroll_direction ((GdkEvent*) event, &_tmp0_);
#line 3305 "../src/View/AbstractDirectoryView.vala"
	direction = _tmp0_;
#line 3307 "../src/View/AbstractDirectoryView.vala"
	gdk_event_get_state ((GdkEvent*) event, &_tmp1_);
#line 3307 "../src/View/AbstractDirectoryView.vala"
	state = _tmp1_;
#line 3308 "../src/View/AbstractDirectoryView.vala"
	if ((state & GDK_CONTROL_MASK) == 0) {
#line 17323 "AbstractDirectoryView.c"
		gdouble increment = 0.0;
#line 3309 "../src/View/AbstractDirectoryView.vala"
		increment = 0.0;
#line 3311 "../src/View/AbstractDirectoryView.vala"
		switch (direction) {
#line 3311 "../src/View/AbstractDirectoryView.vala"
			case GDK_SCROLL_LEFT:
#line 17331 "AbstractDirectoryView.c"
			{
#line 3313 "../src/View/AbstractDirectoryView.vala"
				increment = 5.0;
#line 3314 "../src/View/AbstractDirectoryView.vala"
				break;
#line 17337 "AbstractDirectoryView.c"
			}
#line 3311 "../src/View/AbstractDirectoryView.vala"
			case GDK_SCROLL_RIGHT:
#line 17341 "AbstractDirectoryView.c"
			{
#line 3317 "../src/View/AbstractDirectoryView.vala"
				increment = -5.0;
#line 3318 "../src/View/AbstractDirectoryView.vala"
				break;
#line 17347 "AbstractDirectoryView.c"
			}
#line 3311 "../src/View/AbstractDirectoryView.vala"
			case GDK_SCROLL_SMOOTH:
#line 17351 "AbstractDirectoryView.c"
			{
				gdouble delta_x = 0.0;
				gdouble _tmp2_ = 0.0;
#line 3322 "../src/View/AbstractDirectoryView.vala"
				gdk_event_get_scroll_deltas ((GdkEvent*) event, &_tmp2_, NULL);
#line 3322 "../src/View/AbstractDirectoryView.vala"
				delta_x = _tmp2_;
#line 3323 "../src/View/AbstractDirectoryView.vala"
				increment = delta_x * 10.0;
#line 3324 "../src/View/AbstractDirectoryView.vala"
				break;
#line 17363 "AbstractDirectoryView.c"
			}
			default:
			{
#line 3327 "../src/View/AbstractDirectoryView.vala"
				break;
#line 17369 "AbstractDirectoryView.c"
			}
		}
	}
#line 3331 "../src/View/AbstractDirectoryView.vala"
	result = files_abstract_directory_view_handle_scroll_event (self, event);
#line 3331 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 17377 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_on_scroll_event (FilesAbstractDirectoryView* self,
                                               GdkEventScroll* event)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3303 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3303 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3303 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->on_scroll_event) {
#line 3303 "../src/View/AbstractDirectoryView.vala"
		return _klass_->on_scroll_event (self, event);
#line 17393 "AbstractDirectoryView.c"
	}
#line 3303 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 17397 "AbstractDirectoryView.c"
}

/** name renderer signals */
static GtkTreeIter*
_vala_GtkTreeIter_copy (GtkTreeIter* self)
{
#line 3341 "../src/View/AbstractDirectoryView.vala"
	return g_boxed_copy (gtk_tree_iter_get_type (), self);
#line 17406 "AbstractDirectoryView.c"
}

static gpointer
__vala_GtkTreeIter_copy0 (gpointer self)
{
#line 3341 "../src/View/AbstractDirectoryView.vala"
	return self ? _vala_GtkTreeIter_copy (self) : NULL;
#line 17414 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_name_editing_started (FilesAbstractDirectoryView* self,
                                                       GtkCellEditable* editable,
                                                       const gchar* path_string)
{
	FilesAbstractEditableLabel* editable_widget = NULL;
	FilesAbstractEditableLabel* _tmp0_;
	FilesAbstractEditableLabel* _tmp1_;
#line 3335 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3335 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (path_string != NULL);
#line 3336 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (FILES_IS_ABSTRACT_EDITABLE_LABEL (editable) ? ((FilesAbstractEditableLabel*) editable) : NULL);
#line 3336 "../src/View/AbstractDirectoryView.vala"
	editable_widget = _tmp0_;
#line 3337 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = editable_widget;
#line 3337 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ != NULL) {
#line 17437 "AbstractDirectoryView.c"
		FilesAbstractEditableLabel* _tmp2_;
		gchar* _tmp3_;
		GtkTreePath* path = NULL;
		GtkTreePath* _tmp4_;
		GtkTreeIter* iter = NULL;
		FilesListModel* _tmp5_;
		GtkTreePath* _tmp6_;
		GtkTreeIter _tmp7_ = {0};
		GtkTreeIter _tmp8_;
		GtkTreeIter* _tmp9_;
		FilesFile* file = NULL;
		FilesListModel* _tmp10_;
		GtkTreeIter* _tmp11_;
		GtkTreeIter _tmp12_;
		FilesFile* _tmp13_ = NULL;
		gint start_offset = 0;
		gint end_offset = 0;
		FilesFile* _tmp14_;
		FilesAbstractEditableLabel* _tmp18_;
#line 3338 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = editable_widget;
#line 3338 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_abstract_editable_label_get_chars (_tmp2_, 0, -1);
#line 3338 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (self->original_name);
#line 3338 "../src/View/AbstractDirectoryView.vala"
		self->original_name = _tmp3_;
#line 3339 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = gtk_tree_path_new_from_string (path_string);
#line 3339 "../src/View/AbstractDirectoryView.vala"
		path = _tmp4_;
#line 3340 "../src/View/AbstractDirectoryView.vala"
		iter = NULL;
#line 3341 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->model;
#line 3341 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = path;
#line 3341 "../src/View/AbstractDirectoryView.vala"
		gtk_tree_model_get_iter ((GtkTreeModel*) _tmp5_, &_tmp7_, _tmp6_);
#line 3341 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreeIter_free0 (iter);
#line 3341 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = _tmp7_;
#line 3341 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = __vala_GtkTreeIter_copy0 (&_tmp8_);
#line 3341 "../src/View/AbstractDirectoryView.vala"
		iter = _tmp9_;
#line 3342 "../src/View/AbstractDirectoryView.vala"
		file = NULL;
#line 3343 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->model;
#line 3343 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = iter;
#line 3343 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = *_tmp11_;
#line 3343 "../src/View/AbstractDirectoryView.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp10_, &_tmp12_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &_tmp13_, -1);
#line 3343 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 3343 "../src/View/AbstractDirectoryView.vala"
		file = _tmp13_;
#line 3344 "../src/View/AbstractDirectoryView.vala"
		start_offset = 0;
#line 3344 "../src/View/AbstractDirectoryView.vala"
		end_offset = -1;
#line 3346 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = file;
#line 3346 "../src/View/AbstractDirectoryView.vala"
		if (!files_file_is_folder (_tmp14_)) {
#line 17507 "AbstractDirectoryView.c"
			const gchar* _tmp15_;
			gint _tmp16_ = 0;
			gint _tmp17_ = 0;
#line 3347 "../src/View/AbstractDirectoryView.vala"
			_tmp15_ = self->original_name;
#line 3347 "../src/View/AbstractDirectoryView.vala"
			files_file_utils_get_rename_region (_tmp15_, &_tmp16_, &_tmp17_, FALSE);
#line 3347 "../src/View/AbstractDirectoryView.vala"
			start_offset = _tmp16_;
#line 3347 "../src/View/AbstractDirectoryView.vala"
			end_offset = _tmp17_;
#line 17519 "AbstractDirectoryView.c"
		}
#line 3349 "../src/View/AbstractDirectoryView.vala"
		_tmp18_ = editable_widget;
#line 3349 "../src/View/AbstractDirectoryView.vala"
		files_abstract_editable_label_select_region (_tmp18_, start_offset, end_offset);
#line 3337 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 3337 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreeIter_free0 (iter);
#line 3337 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (path);
#line 17531 "AbstractDirectoryView.c"
	} else {
#line 3351 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:3351: Editable widget is null");
#line 3352 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_on_name_editing_canceled (self);
#line 17537 "AbstractDirectoryView.c"
	}
#line 3335 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (editable_widget);
#line 17541 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_name_editing_canceled (FilesAbstractDirectoryView* self)
{
	FilesTextRenderer* _tmp0_;
	gchar* _tmp1_;
#line 3356 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3357 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_is_frozen (self, FALSE);
#line 3358 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_renaming (self, FALSE);
#line 3359 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->name_renderer;
#line 3359 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkCellRendererText*) _tmp0_, "editable", FALSE, NULL);
#line 3360 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_strdup ("");
#line 3360 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (self->proposed_name);
#line 3360 "../src/View/AbstractDirectoryView.vala"
	self->proposed_name = _tmp1_;
#line 3362 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_menu_actions (self);
#line 3363 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_grab_focus (self);
#line 17569 "AbstractDirectoryView.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1370 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1371 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1371 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1372 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1373 "glib-2.0.vapi"
	result = _result_;
#line 1373 "glib-2.0.vapi"
	return result;
#line 17590 "AbstractDirectoryView.c"
}

static void
____lambda101_ (FilesAbstractDirectoryView* self,
                GObject* obj,
                GAsyncResult* res)
{
	GError* _inner_error0_ = NULL;
#line 3394 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 17601 "AbstractDirectoryView.c"
	{
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 3396 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = files_abstract_directory_view_set_file_display_name_finish (self, res, &_inner_error0_);
#line 3396 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = _tmp0_;
#line 3396 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_tmp1_);
#line 3396 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17613 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 3395 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 17622 "AbstractDirectoryView.c"
	}
	__finally0:
#line 3395 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3395 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3395 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 3395 "../src/View/AbstractDirectoryView.vala"
		return;
#line 17633 "AbstractDirectoryView.c"
	}
#line 3399 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_name_editing_canceled (self);
#line 17637 "AbstractDirectoryView.c"
}

static void
_____lambda101__gasync_ready_callback (GObject* source_object,
                                       GAsyncResult* res,
                                       gpointer self)
{
#line 3394 "../src/View/AbstractDirectoryView.vala"
	____lambda101_ ((FilesAbstractDirectoryView*) self, source_object, res);
#line 3394 "../src/View/AbstractDirectoryView.vala"
	g_object_unref (self);
#line 17649 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_name_edited (FilesAbstractDirectoryView* self,
                                              const gchar* path_string,
                                              const gchar* _new_name)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gchar* new_name = NULL;
	gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
#line 3366 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3366 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (path_string != NULL);
#line 3368 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->_renaming;
#line 3368 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp1_) {
#line 3368 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 17675 "AbstractDirectoryView.c"
	} else {
#line 3368 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _new_name == NULL;
#line 17679 "AbstractDirectoryView.c"
	}
#line 3368 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 3369 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_on_name_editing_canceled (self);
#line 3370 "../src/View/AbstractDirectoryView.vala"
		return;
#line 17687 "AbstractDirectoryView.c"
	}
#line 3373 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = string_strip (_new_name);
#line 3373 "../src/View/AbstractDirectoryView.vala"
	new_name = _tmp2_;
#line 3374 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = new_name;
#line 3374 "../src/View/AbstractDirectoryView.vala"
	if (g_strcmp0 (_tmp4_, "") == 0) {
#line 3374 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = TRUE;
#line 17699 "AbstractDirectoryView.c"
	} else {
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 3374 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->proposed_name;
#line 3374 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = new_name;
#line 3374 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = g_strcmp0 (_tmp5_, _tmp6_) == 0;
#line 17709 "AbstractDirectoryView.c"
	}
#line 3374 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 3375 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:3375: Blank name or name unchanged");
#line 3376 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_on_name_editing_canceled (self);
#line 3377 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (new_name);
#line 3377 "../src/View/AbstractDirectoryView.vala"
		return;
#line 17721 "AbstractDirectoryView.c"
	}
#line 3380 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = g_strdup ("");
#line 3380 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (self->proposed_name);
#line 3380 "../src/View/AbstractDirectoryView.vala"
	self->proposed_name = _tmp7_;
#line 3381 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = new_name;
#line 3381 "../src/View/AbstractDirectoryView.vala"
	if (g_strcmp0 (_tmp8_, "") != 0) {
#line 17733 "AbstractDirectoryView.c"
		GtkTreePath* path = NULL;
		GtkTreePath* _tmp9_;
		GtkTreeIter* iter = NULL;
		FilesListModel* _tmp10_;
		GtkTreePath* _tmp11_;
		GtkTreeIter _tmp12_ = {0};
		GtkTreeIter _tmp13_;
		GtkTreeIter* _tmp14_;
		FilesFile* file = NULL;
		FilesListModel* _tmp15_;
		GtkTreeIter* _tmp16_;
		GtkTreeIter _tmp17_;
		FilesFile* _tmp18_ = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
#line 3382 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = gtk_tree_path_new_from_string (path_string);
#line 3382 "../src/View/AbstractDirectoryView.vala"
		path = _tmp9_;
#line 3383 "../src/View/AbstractDirectoryView.vala"
		iter = NULL;
#line 3384 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->model;
#line 3384 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = path;
#line 3384 "../src/View/AbstractDirectoryView.vala"
		gtk_tree_model_get_iter ((GtkTreeModel*) _tmp10_, &_tmp12_, _tmp11_);
#line 3384 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreeIter_free0 (iter);
#line 3384 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = _tmp12_;
#line 3384 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = __vala_GtkTreeIter_copy0 (&_tmp13_);
#line 3384 "../src/View/AbstractDirectoryView.vala"
		iter = _tmp14_;
#line 3386 "../src/View/AbstractDirectoryView.vala"
		file = NULL;
#line 3387 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = self->model;
#line 3387 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = iter;
#line 3387 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = *_tmp16_;
#line 3387 "../src/View/AbstractDirectoryView.vala"
		gtk_tree_model_get ((GtkTreeModel*) _tmp15_, &_tmp17_, FILES_LIST_MODEL_COLUMN_ID_FILE_COLUMN, &_tmp18_, -1);
#line 3387 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 3387 "../src/View/AbstractDirectoryView.vala"
		file = _tmp18_;
#line 3392 "../src/View/AbstractDirectoryView.vala"
		_tmp19_ = new_name;
#line 3392 "../src/View/AbstractDirectoryView.vala"
		_tmp20_ = self->original_name;
#line 3392 "../src/View/AbstractDirectoryView.vala"
		if (g_strcmp0 (_tmp19_, _tmp20_) != 0) {
#line 17789 "AbstractDirectoryView.c"
			const gchar* _tmp21_;
			gchar* _tmp22_;
			FilesFile* _tmp23_;
			GFile* _tmp24_;
			GFile* _tmp25_;
			const gchar* _tmp26_;
#line 3393 "../src/View/AbstractDirectoryView.vala"
			_tmp21_ = new_name;
#line 3393 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = g_strdup (_tmp21_);
#line 3393 "../src/View/AbstractDirectoryView.vala"
			_g_free0 (self->proposed_name);
#line 3393 "../src/View/AbstractDirectoryView.vala"
			self->proposed_name = _tmp22_;
#line 3394 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = file;
#line 3394 "../src/View/AbstractDirectoryView.vala"
			_tmp24_ = files_file_get_location (_tmp23_);
#line 3394 "../src/View/AbstractDirectoryView.vala"
			_tmp25_ = _tmp24_;
#line 3394 "../src/View/AbstractDirectoryView.vala"
			_tmp26_ = new_name;
#line 3394 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_set_file_display_name (self, _tmp25_, _tmp26_, NULL, _____lambda101__gasync_ready_callback, g_object_ref (self));
#line 17814 "AbstractDirectoryView.c"
		} else {
#line 3402 "../src/View/AbstractDirectoryView.vala"
			g_warning ("AbstractDirectoryView.vala:3402: Name unchanged");
#line 3403 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_on_name_editing_canceled (self);
#line 17820 "AbstractDirectoryView.c"
		}
#line 3381 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (file);
#line 3381 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreeIter_free0 (iter);
#line 3381 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (path);
#line 17828 "AbstractDirectoryView.c"
	} else {
#line 3406 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:3406: No new name");
#line 3407 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_on_name_editing_canceled (self);
#line 17834 "AbstractDirectoryView.c"
	}
#line 3366 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (new_name);
#line 17838 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_file_display_name_data_free (gpointer _data)
{
	FilesAbstractDirectoryViewSetFileDisplayNameData* _data_;
	_data_ = _data;
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data_->old_location);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_data_->new_name);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data_->cancellable);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data_->result);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data_->self);
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_slice_free (FilesAbstractDirectoryViewSetFileDisplayNameData, _data_);
#line 17858 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_file_display_name (FilesAbstractDirectoryView* self,
                                                     GFile* old_location,
                                                     const gchar* new_name,
                                                     GCancellable* cancellable,
                                                     GAsyncReadyCallback _callback_,
                                                     gpointer _user_data_)
{
	FilesAbstractDirectoryViewSetFileDisplayNameData* _data_;
	FilesAbstractDirectoryView* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (old_location != NULL);
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (new_name != NULL);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_ = g_slice_new0 (FilesAbstractDirectoryViewSetFileDisplayNameData);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_task_set_task_data (_data_->_async_result, _data_, files_abstract_directory_view_set_file_display_name_data_free);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_->self = _tmp0_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (old_location);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data_->old_location);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_->old_location = _tmp1_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = g_strdup (new_name);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (_data_->new_name);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_->new_name = _tmp2_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data_->cancellable);
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_->cancellable = _tmp3_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_file_display_name_co (_data_);
#line 17910 "AbstractDirectoryView.c"
}

GFile*
files_abstract_directory_view_set_file_display_name_finish (FilesAbstractDirectoryView* self,
                                                            GAsyncResult* _res_,
                                                            GError** error)
{
	GFile* result;
	FilesAbstractDirectoryViewSetFileDisplayNameData* _data_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 29 "../src/View/AbstractDirectoryView.vala"
	if (NULL == _data_) {
#line 29 "../src/View/AbstractDirectoryView.vala"
		return NULL;
#line 17926 "AbstractDirectoryView.c"
	}
#line 29 "../src/View/AbstractDirectoryView.vala"
	result = _data_->result;
#line 29 "../src/View/AbstractDirectoryView.vala"
	_data_->result = NULL;
#line 29 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 17934 "AbstractDirectoryView.c"
}

static void
_files_abstract_directory_view_after_renamed_file_added_files_directory_file_added (FilesDirectory* _sender,
                                                                                    FilesFile* file,
                                                                                    gboolean is_internal,
                                                                                    gpointer self)
{
#line 3417 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_after_renamed_file_added ((FilesAbstractDirectoryView*) self, file);
#line 17945 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_file_display_name_ready (GObject* source_object,
                                                           GAsyncResult* _res_,
                                                           gpointer _user_data_)
{
	FilesAbstractDirectoryViewSetFileDisplayNameData* _data_;
#line 3419 "../src/View/AbstractDirectoryView.vala"
	_data_ = _user_data_;
#line 3419 "../src/View/AbstractDirectoryView.vala"
	_data_->_source_object_ = source_object;
#line 3419 "../src/View/AbstractDirectoryView.vala"
	_data_->_res_ = _res_;
#line 3419 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_file_display_name_co (_data_);
#line 17962 "AbstractDirectoryView.c"
}

static gpointer
_g_error_copy0 (gpointer self)
{
#line 3421 "../src/View/AbstractDirectoryView.vala"
	return self ? g_error_copy (self) : NULL;
#line 17970 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_set_file_display_name_co (FilesAbstractDirectoryViewSetFileDisplayNameData* _data_)
{
#line 3413 "../src/View/AbstractDirectoryView.vala"
	switch (_data_->_state_) {
#line 3413 "../src/View/AbstractDirectoryView.vala"
		case 0:
#line 17980 "AbstractDirectoryView.c"
		goto _state_0;
#line 3413 "../src/View/AbstractDirectoryView.vala"
		case 1:
#line 17984 "AbstractDirectoryView.c"
		goto _state_1;
		default:
#line 3413 "../src/View/AbstractDirectoryView.vala"
		g_assert_not_reached ();
#line 17989 "AbstractDirectoryView.c"
	}
	_state_0:
#line 3417 "../src/View/AbstractDirectoryView.vala"
	_data_->_tmp0_ = _data_->self->slot;
#line 3417 "../src/View/AbstractDirectoryView.vala"
	_data_->_tmp1_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _data_->_tmp0_);
#line 3417 "../src/View/AbstractDirectoryView.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 3417 "../src/View/AbstractDirectoryView.vala"
	g_signal_connect_object (_data_->_tmp2_, "file-added", (GCallback) _files_abstract_directory_view_after_renamed_file_added_files_directory_file_added, _data_->self, G_CONNECT_AFTER);
#line 18000 "AbstractDirectoryView.c"
	{
#line 3419 "../src/View/AbstractDirectoryView.vala"
		_data_->_state_ = 1;
#line 3419 "../src/View/AbstractDirectoryView.vala"
		files_file_utils_set_file_display_name (_data_->old_location, _data_->new_name, _data_->cancellable, files_abstract_directory_view_set_file_display_name_ready, _data_);
#line 3419 "../src/View/AbstractDirectoryView.vala"
		return FALSE;
#line 18008 "AbstractDirectoryView.c"
		_state_1:
#line 3419 "../src/View/AbstractDirectoryView.vala"
		_data_->_tmp4_ = files_file_utils_set_file_display_name_finish (_data_->_res_, &_data_->_inner_error0_);
#line 3419 "../src/View/AbstractDirectoryView.vala"
		_data_->_tmp3_ = _data_->_tmp4_;
#line 3419 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 18016 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 3419 "../src/View/AbstractDirectoryView.vala"
		_data_->_tmp5_ = _data_->_tmp3_;
#line 3419 "../src/View/AbstractDirectoryView.vala"
		_data_->_tmp3_ = NULL;
#line 3419 "../src/View/AbstractDirectoryView.vala"
		_data_->result = _data_->_tmp5_;
#line 3419 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data_->_tmp3_);
#line 3419 "../src/View/AbstractDirectoryView.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 3419 "../src/View/AbstractDirectoryView.vala"
		if (_data_->_state_ != 0) {
#line 3419 "../src/View/AbstractDirectoryView.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 3419 "../src/View/AbstractDirectoryView.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 18035 "AbstractDirectoryView.c"
			}
		}
#line 3419 "../src/View/AbstractDirectoryView.vala"
		g_object_unref (_data_->_async_result);
#line 3419 "../src/View/AbstractDirectoryView.vala"
		return FALSE;
#line 18042 "AbstractDirectoryView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 3418 "../src/View/AbstractDirectoryView.vala"
		_data_->e = _data_->_inner_error0_;
#line 3418 "../src/View/AbstractDirectoryView.vala"
		_data_->_inner_error0_ = NULL;
#line 3421 "../src/View/AbstractDirectoryView.vala"
		_data_->_tmp6_ = _data_->e;
#line 3421 "../src/View/AbstractDirectoryView.vala"
		_data_->_tmp7_ = _g_error_copy0 (_data_->_tmp6_);
#line 3421 "../src/View/AbstractDirectoryView.vala"
		_data_->_inner_error0_ = _data_->_tmp7_;
#line 3421 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (_data_->e);
#line 18059 "AbstractDirectoryView.c"
		goto __finally0;
	}
	__finally0:
#line 3418 "../src/View/AbstractDirectoryView.vala"
	g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 3418 "../src/View/AbstractDirectoryView.vala"
	g_object_unref (_data_->_async_result);
#line 3418 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 18069 "AbstractDirectoryView.c"
}

static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
#line 3425 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data32_->_ref_count_);
#line 3425 "../src/View/AbstractDirectoryView.vala"
	return _data32_;
#line 18079 "AbstractDirectoryView.c"
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
#line 3425 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
#line 18089 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 3425 "../src/View/AbstractDirectoryView.vala"
		self = _data32_->self;
#line 3425 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data32_->new_file);
#line 3425 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 3425 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block32Data, _data32_);
#line 18099 "AbstractDirectoryView.c"
	}
}

static gboolean
___lambda100_ (Block32Data* _data32_)
{
	FilesAbstractDirectoryView* self;
	FilesListModel* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean result;
#line 3430 "../src/View/AbstractDirectoryView.vala"
	self = _data32_->self;
#line 3431 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 3431 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_list_model_get_sort_pending (_tmp0_);
#line 3431 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 3431 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 3432 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 3432 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 18125 "AbstractDirectoryView.c"
	} else {
#line 3434 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_select_and_scroll_to_gof_file (self, _data32_->new_file);
#line 3435 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_REMOVE;
#line 3435 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 18133 "AbstractDirectoryView.c"
	}
}

static gboolean
____lambda100__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda100_ (self);
#line 3430 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 18144 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_after_renamed_file_added (FilesAbstractDirectoryView* self,
                                                        FilesFile* new_file)
{
	Block32Data* _data32_;
	FilesFile* _tmp0_;
	FilesViewSlot* _tmp1_;
	FilesDirectory* _tmp2_;
	FilesDirectory* _tmp3_;
	guint _tmp4_;
#line 3425 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3425 "../src/View/AbstractDirectoryView.vala"
	_data32_ = g_slice_new0 (Block32Data);
#line 3425 "../src/View/AbstractDirectoryView.vala"
	_data32_->_ref_count_ = 1;
#line 3425 "../src/View/AbstractDirectoryView.vala"
	_data32_->self = g_object_ref (self);
#line 3425 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = _g_object_ref0 (new_file);
#line 3425 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_data32_->new_file);
#line 3425 "../src/View/AbstractDirectoryView.vala"
	_data32_->new_file = _tmp0_;
#line 3426 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->slot;
#line 3426 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp1_);
#line 3426 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 3426 "../src/View/AbstractDirectoryView.vala"
	g_signal_parse_name ("file-added", FILES_TYPE_DIRECTORY, &_tmp4_, NULL, FALSE);
#line 3426 "../src/View/AbstractDirectoryView.vala"
	g_signal_handlers_disconnect_matched (_tmp3_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _files_abstract_directory_view_after_renamed_file_added_files_directory_file_added, self);
#line 3428 "../src/View/AbstractDirectoryView.vala"
	if (_data32_->new_file != NULL) {
#line 3429 "../src/View/AbstractDirectoryView.vala"
		self->priv->selected_files_invalid = TRUE;
#line 3430 "../src/View/AbstractDirectoryView.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda100__gsource_func, block32_data_ref (_data32_), block32_data_unref);
#line 18187 "AbstractDirectoryView.c"
	}
#line 3425 "../src/View/AbstractDirectoryView.vala"
	block32_data_unref (_data32_);
#line 3425 "../src/View/AbstractDirectoryView.vala"
	_data32_ = NULL;
#line 18193 "AbstractDirectoryView.c"
}

static PangoRectangle*
_pango_rectangle_dup (PangoRectangle* self)
{
	PangoRectangle* dup;
#line 3456 "../src/View/AbstractDirectoryView.vala"
	dup = g_new0 (PangoRectangle, 1);
#line 3456 "../src/View/AbstractDirectoryView.vala"
	memcpy (dup, self, sizeof (PangoRectangle));
#line 3456 "../src/View/AbstractDirectoryView.vala"
	return dup;
#line 18206 "AbstractDirectoryView.c"
}

static gpointer
__pango_rectangle_dup0 (gpointer self)
{
#line 3456 "../src/View/AbstractDirectoryView.vala"
	return self ? _pango_rectangle_dup (self) : NULL;
#line 18214 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_on_view_draw (FilesAbstractDirectoryView* self,
                                                 cairo_t* cr)
{
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	FilesViewSlot* _tmp2_;
	FilesDirectory* _tmp3_;
	FilesDirectory* _tmp4_;
	gboolean result;
#line 3441 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (cr != NULL, FALSE);
#line 3444 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 3444 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 3444 "../src/View/AbstractDirectoryView.vala"
	style_context = _tmp1_;
#line 3445 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->slot;
#line 3445 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp2_);
#line 3445 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_;
#line 3445 "../src/View/AbstractDirectoryView.vala"
	if (files_directory_is_empty (_tmp4_)) {
#line 18244 "AbstractDirectoryView.c"
		PangoLayout* layout = NULL;
		PangoLayout* _tmp5_;
		GtkStyleContext* _tmp6_;
		PangoLayout* _tmp9_;
		FilesViewSlot* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		PangoRectangle* extents = NULL;
		PangoLayout* _tmp13_;
		PangoRectangle _tmp14_ = {0};
		PangoRectangle _tmp15_;
		PangoRectangle* _tmp16_;
		gdouble width = 0.0;
		PangoRectangle* _tmp17_;
		gdouble height = 0.0;
		PangoRectangle* _tmp18_;
		gdouble x = 0.0;
		gdouble y = 0.0;
		GtkStyleContext* _tmp19_;
		PangoLayout* _tmp20_;
#line 3446 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = gtk_widget_create_pango_layout ((GtkWidget*) self, NULL);
#line 3446 "../src/View/AbstractDirectoryView.vala"
		layout = _tmp5_;
#line 3448 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = style_context;
#line 3448 "../src/View/AbstractDirectoryView.vala"
		if (!gtk_style_context_has_class (_tmp6_, GRANITE_STYLE_CLASS_H2_LABEL)) {
#line 18273 "AbstractDirectoryView.c"
			GtkStyleContext* _tmp7_;
			GtkStyleContext* _tmp8_;
#line 3449 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = style_context;
#line 3449 "../src/View/AbstractDirectoryView.vala"
			gtk_style_context_add_class (_tmp7_, GRANITE_STYLE_CLASS_H2_LABEL);
#line 3450 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = style_context;
#line 3450 "../src/View/AbstractDirectoryView.vala"
			gtk_style_context_add_class (_tmp8_, GTK_STYLE_CLASS_VIEW);
#line 18284 "AbstractDirectoryView.c"
		}
#line 3453 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = layout;
#line 3453 "../src/View/AbstractDirectoryView.vala"
		_tmp10_ = self->slot;
#line 3453 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = files_view_slot_get_empty_message (_tmp10_);
#line 3453 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = _tmp11_;
#line 3453 "../src/View/AbstractDirectoryView.vala"
		pango_layout_set_markup (_tmp9_, _tmp12_, -1);
#line 3453 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (_tmp12_);
#line 3455 "../src/View/AbstractDirectoryView.vala"
		extents = NULL;
#line 3456 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = layout;
#line 3456 "../src/View/AbstractDirectoryView.vala"
		pango_layout_get_extents (_tmp13_, NULL, &_tmp14_);
#line 3456 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (extents);
#line 3456 "../src/View/AbstractDirectoryView.vala"
		_tmp15_ = _tmp14_;
#line 3456 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = __pango_rectangle_dup0 (&_tmp15_);
#line 3456 "../src/View/AbstractDirectoryView.vala"
		extents = _tmp16_;
#line 3458 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = extents;
#line 3458 "../src/View/AbstractDirectoryView.vala"
		width = pango_units_to_double ((*_tmp17_).width);
#line 3459 "../src/View/AbstractDirectoryView.vala"
		_tmp18_ = extents;
#line 3459 "../src/View/AbstractDirectoryView.vala"
		height = pango_units_to_double ((*_tmp18_).height);
#line 3461 "../src/View/AbstractDirectoryView.vala"
		x = (((gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self)) / 2) - (width / 2);
#line 3462 "../src/View/AbstractDirectoryView.vala"
		y = (((gdouble) gtk_widget_get_allocated_height ((GtkWidget*) self)) / 2) - (height / 2);
#line 3463 "../src/View/AbstractDirectoryView.vala"
		_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 3463 "../src/View/AbstractDirectoryView.vala"
		_tmp20_ = layout;
#line 3463 "../src/View/AbstractDirectoryView.vala"
		gtk_render_layout (_tmp19_, cr, x, y, _tmp20_);
#line 3465 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 3465 "../src/View/AbstractDirectoryView.vala"
		_g_free0 (extents);
#line 3465 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (layout);
#line 3465 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (style_context);
#line 3465 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 18340 "AbstractDirectoryView.c"
	} else {
		GtkStyleContext* _tmp21_;
#line 3466 "../src/View/AbstractDirectoryView.vala"
		_tmp21_ = style_context;
#line 3466 "../src/View/AbstractDirectoryView.vala"
		if (gtk_style_context_has_class (_tmp21_, GRANITE_STYLE_CLASS_H2_LABEL)) {
#line 18347 "AbstractDirectoryView.c"
			GtkStyleContext* _tmp22_;
			GtkStyleContext* _tmp23_;
#line 3467 "../src/View/AbstractDirectoryView.vala"
			_tmp22_ = style_context;
#line 3467 "../src/View/AbstractDirectoryView.vala"
			gtk_style_context_remove_class (_tmp22_, GRANITE_STYLE_CLASS_H2_LABEL);
#line 3468 "../src/View/AbstractDirectoryView.vala"
			_tmp23_ = style_context;
#line 3468 "../src/View/AbstractDirectoryView.vala"
			gtk_style_context_remove_class (_tmp23_, GTK_STYLE_CLASS_VIEW);
#line 18358 "AbstractDirectoryView.c"
		}
	}
#line 3471 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3471 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (style_context);
#line 3471 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 18367 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_on_view_draw (FilesAbstractDirectoryView* self,
                                            cairo_t* cr)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3441 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3441 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3441 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->on_view_draw) {
#line 3441 "../src/View/AbstractDirectoryView.vala"
		return _klass_->on_view_draw (self, cr);
#line 18383 "AbstractDirectoryView.c"
	}
#line 3441 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 18387 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_handle_primary_button_click (FilesAbstractDirectoryView* self,
                                                                GdkEventButton* event,
                                                                GtkTreePath* path)
{
	gboolean result;
#line 3474 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 3475 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 3475 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 18402 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_handle_primary_button_click (FilesAbstractDirectoryView* self,
                                                           GdkEventButton* event,
                                                           GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3474 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3474 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3474 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->handle_primary_button_click) {
#line 3474 "../src/View/AbstractDirectoryView.vala"
		return _klass_->handle_primary_button_click (self, event, path);
#line 18419 "AbstractDirectoryView.c"
	}
#line 3474 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 18423 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_handle_secondary_button_click (FilesAbstractDirectoryView* self,
                                                                  GdkEventButton* event)
{
	gboolean result;
#line 3478 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 3479 "../src/View/AbstractDirectoryView.vala"
	self->should_scroll = FALSE;
#line 3480 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 3480 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 18439 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_handle_secondary_button_click (FilesAbstractDirectoryView* self,
                                                             GdkEventButton* event)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3478 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3478 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3478 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->handle_secondary_button_click) {
#line 3478 "../src/View/AbstractDirectoryView.vala"
		return _klass_->handle_secondary_button_click (self, event);
#line 18455 "AbstractDirectoryView.c"
	}
#line 3478 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 18459 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_block_drag_and_drop (FilesAbstractDirectoryView* self)
{
#line 3483 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3484 "../src/View/AbstractDirectoryView.vala"
	if (!self->dnd_disabled) {
#line 18469 "AbstractDirectoryView.c"
		GtkWidget* _tmp0_;
		gconstpointer _tmp1_;
		GtkWidget* _tmp2_;
		void* _tmp3_;
#line 3485 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = self->priv->view;
#line 3485 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = g_object_get_data ((GObject*) _tmp0_, "gtk-site-data");
#line 3485 "../src/View/AbstractDirectoryView.vala"
		self->priv->drag_data = _tmp1_;
#line 3486 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->priv->view;
#line 3486 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = self->priv->drag_data;
#line 3486 "../src/View/AbstractDirectoryView.vala"
		g_signal_handlers_block_matched (_tmp2_, G_SIGNAL_MATCH_DATA, (guint) 0, (GQuark) 0, NULL, NULL, _tmp3_);
#line 3487 "../src/View/AbstractDirectoryView.vala"
		self->dnd_disabled = TRUE;
#line 18488 "AbstractDirectoryView.c"
	}
}

void
files_abstract_directory_view_unblock_drag_and_drop (FilesAbstractDirectoryView* self)
{
#line 3491 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3492 "../src/View/AbstractDirectoryView.vala"
	if (self->dnd_disabled) {
#line 18499 "AbstractDirectoryView.c"
		GtkWidget* _tmp0_;
		void* _tmp1_;
#line 3493 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = self->priv->view;
#line 3493 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->priv->drag_data;
#line 3493 "../src/View/AbstractDirectoryView.vala"
		g_signal_handlers_unblock_matched (_tmp0_, G_SIGNAL_MATCH_DATA, (guint) 0, (GQuark) 0, NULL, NULL, _tmp1_);
#line 3494 "../src/View/AbstractDirectoryView.vala"
		self->dnd_disabled = FALSE;
#line 18510 "AbstractDirectoryView.c"
	}
}

static gboolean
files_abstract_directory_view_real_on_view_button_press_event (FilesAbstractDirectoryView* self,
                                                               GdkEventButton* event)
{
	gboolean _tmp0_;
	GdkEventType type = 0;
	gboolean _tmp2_ = FALSE;
	GtkTreePath* path = NULL;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	guint button = 0U;
	guint _tmp5_ = 0U;
	GtkTreePath* _tmp6_ = NULL;
	guint _tmp7_;
	GtkTreePath* _tmp8_;
	GtkTreePath* _tmp9_;
	GdkModifierType state = 0U;
	GdkModifierType _tmp10_ = 0U;
	GdkModifierType mods = 0U;
	gboolean no_mods = FALSE;
	gboolean control_pressed = FALSE;
	gboolean shift_pressed = FALSE;
	gboolean other_mod_pressed = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean only_control_pressed = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean only_shift_pressed = FALSE;
	gboolean _tmp14_ = FALSE;
	GtkTreePath* _tmp15_;
	gboolean path_selected = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean on_blank = FALSE;
	gboolean double_click_event = FALSE;
	gboolean _result_ = FALSE;
	gboolean result;
#line 3498 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 3499 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->priv->_renaming;
#line 3499 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 18556 "AbstractDirectoryView.c"
		FilesTextRenderer* _tmp1_;
#line 3501 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = self->name_renderer;
#line 3501 "../src/View/AbstractDirectoryView.vala"
		files_text_renderer_end_editing (_tmp1_, FALSE);
#line 18562 "AbstractDirectoryView.c"
	}
#line 3504 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_hover (self);
#line 3509 "../src/View/AbstractDirectoryView.vala"
	type = gdk_event_get_event_type ((GdkEvent*) event);
#line 3510 "../src/View/AbstractDirectoryView.vala"
	if (self->dnd_disabled) {
#line 3510 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = type == GDK_BUTTON_PRESS;
#line 18572 "AbstractDirectoryView.c"
	} else {
#line 3510 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = FALSE;
#line 18576 "AbstractDirectoryView.c"
	}
#line 3510 "../src/View/AbstractDirectoryView.vala"
	if (_tmp2_) {
#line 3511 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 3511 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 18584 "AbstractDirectoryView.c"
	}
#line 3514 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_grab_focus (self);
#line 3516 "../src/View/AbstractDirectoryView.vala"
	path = NULL;
#line 3518 "../src/View/AbstractDirectoryView.vala"
	gdk_event_get_coords ((GdkEvent*) event, &_tmp3_, &_tmp4_);
#line 3518 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_x = _tmp3_;
#line 3518 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_y = _tmp4_;
#line 3520 "../src/View/AbstractDirectoryView.vala"
	gdk_event_get_button ((GdkEvent*) event, &_tmp5_);
#line 3520 "../src/View/AbstractDirectoryView.vala"
	button = _tmp5_;
#line 3522 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = files_abstract_directory_view_get_event_position_info (self, event, &_tmp6_, button == ((guint) GDK_BUTTON_PRIMARY));
#line 3522 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 3522 "../src/View/AbstractDirectoryView.vala"
	path = _tmp6_;
#line 3522 "../src/View/AbstractDirectoryView.vala"
	self->click_zone = _tmp7_;
#line 3523 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = path;
#line 3523 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = __vala_GtkTreePath_copy0 (_tmp8_);
#line 3523 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->click_path);
#line 3523 "../src/View/AbstractDirectoryView.vala"
	self->click_path = _tmp9_;
#line 3526 "../src/View/AbstractDirectoryView.vala"
	gdk_event_get_state ((GdkEvent*) event, &_tmp10_);
#line 3526 "../src/View/AbstractDirectoryView.vala"
	state = _tmp10_;
#line 3527 "../src/View/AbstractDirectoryView.vala"
	mods = state & gtk_accelerator_get_default_mod_mask ();
#line 3528 "../src/View/AbstractDirectoryView.vala"
	no_mods = mods == 0;
#line 3529 "../src/View/AbstractDirectoryView.vala"
	control_pressed = (mods & GDK_CONTROL_MASK) != 0;
#line 3530 "../src/View/AbstractDirectoryView.vala"
	shift_pressed = (mods & GDK_SHIFT_MASK) != 0;
#line 3531 "../src/View/AbstractDirectoryView.vala"
	other_mod_pressed = ((mods & (~GDK_SHIFT_MASK)) & (~GDK_CONTROL_MASK)) != 0;
#line 3532 "../src/View/AbstractDirectoryView.vala"
	if (control_pressed) {
#line 3532 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = !other_mod_pressed;
#line 18634 "AbstractDirectoryView.c"
	} else {
#line 3532 "../src/View/AbstractDirectoryView.vala"
		_tmp11_ = FALSE;
#line 18638 "AbstractDirectoryView.c"
	}
#line 3532 "../src/View/AbstractDirectoryView.vala"
	only_control_pressed = _tmp11_;
#line 3533 "../src/View/AbstractDirectoryView.vala"
	if (shift_pressed) {
#line 3533 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = !control_pressed;
#line 18646 "AbstractDirectoryView.c"
	} else {
#line 3533 "../src/View/AbstractDirectoryView.vala"
		_tmp13_ = FALSE;
#line 18650 "AbstractDirectoryView.c"
	}
#line 3533 "../src/View/AbstractDirectoryView.vala"
	if (_tmp13_) {
#line 3533 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = !other_mod_pressed;
#line 18656 "AbstractDirectoryView.c"
	} else {
#line 3533 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = FALSE;
#line 18660 "AbstractDirectoryView.c"
	}
#line 3533 "../src/View/AbstractDirectoryView.vala"
	only_shift_pressed = _tmp12_;
#line 3534 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = path;
#line 3534 "../src/View/AbstractDirectoryView.vala"
	if (_tmp15_ != NULL) {
#line 18668 "AbstractDirectoryView.c"
		GtkTreePath* _tmp16_;
#line 3534 "../src/View/AbstractDirectoryView.vala"
		_tmp16_ = path;
#line 3534 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = files_abstract_directory_view_path_is_selected (self, _tmp16_);
#line 18674 "AbstractDirectoryView.c"
	} else {
#line 3534 "../src/View/AbstractDirectoryView.vala"
		_tmp14_ = FALSE;
#line 18678 "AbstractDirectoryView.c"
	}
#line 3534 "../src/View/AbstractDirectoryView.vala"
	path_selected = _tmp14_;
#line 3535 "../src/View/AbstractDirectoryView.vala"
	if (self->click_zone == ((guint) FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH)) {
#line 3535 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = TRUE;
#line 18686 "AbstractDirectoryView.c"
	} else {
#line 3535 "../src/View/AbstractDirectoryView.vala"
		_tmp17_ = self->click_zone == ((guint) FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH);
#line 18690 "AbstractDirectoryView.c"
	}
#line 3535 "../src/View/AbstractDirectoryView.vala"
	on_blank = _tmp17_;
#line 3536 "../src/View/AbstractDirectoryView.vala"
	double_click_event = type == GDK_2BUTTON_PRESS;
#line 3540 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_block_drag_and_drop (self);
#line 3542 "../src/View/AbstractDirectoryView.vala"
	if (!files_abstract_directory_view_will_handle_button_press (self, no_mods, only_control_pressed, only_shift_pressed)) {
#line 3543 "../src/View/AbstractDirectoryView.vala"
		result = FALSE;
#line 3543 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (path);
#line 3543 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 18706 "AbstractDirectoryView.c"
	}
#line 3546 "../src/View/AbstractDirectoryView.vala"
	_result_ = FALSE;
#line 3547 "../src/View/AbstractDirectoryView.vala"
	self->should_activate = FALSE;
#line 3548 "../src/View/AbstractDirectoryView.vala"
	self->should_deselect = FALSE;
#line 3549 "../src/View/AbstractDirectoryView.vala"
	self->should_select = FALSE;
#line 3550 "../src/View/AbstractDirectoryView.vala"
	self->should_scroll = TRUE;
#line 3553 "../src/View/AbstractDirectoryView.vala"
	switch (button) {
#line 3553 "../src/View/AbstractDirectoryView.vala"
		case GDK_BUTTON_PRIMARY:
#line 18722 "AbstractDirectoryView.c"
		{
#line 3555 "../src/View/AbstractDirectoryView.vala"
			switch (self->click_zone) {
#line 3555 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH:
#line 3555 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID:
#line 18730 "AbstractDirectoryView.c"
				{
#line 3560 "../src/View/AbstractDirectoryView.vala"
					if (no_mods) {
#line 3561 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_unselect_all (self);
#line 18736 "AbstractDirectoryView.c"
					}
#line 3564 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18740 "AbstractDirectoryView.c"
				}
#line 3555 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH:
#line 3555 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON:
#line 3555 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME:
#line 18748 "AbstractDirectoryView.c"
				{
					gboolean _tmp18_ = FALSE;
					gboolean _tmp19_ = FALSE;
					gboolean _tmp24_ = FALSE;
#line 3571 "../src/View/AbstractDirectoryView.vala"
					if (only_control_pressed) {
#line 3571 "../src/View/AbstractDirectoryView.vala"
						_tmp18_ = path_selected;
#line 18757 "AbstractDirectoryView.c"
					} else {
#line 3571 "../src/View/AbstractDirectoryView.vala"
						_tmp18_ = FALSE;
#line 18761 "AbstractDirectoryView.c"
					}
#line 3571 "../src/View/AbstractDirectoryView.vala"
					self->should_deselect = _tmp18_;
#line 3575 "../src/View/AbstractDirectoryView.vala"
					if (no_mods) {
#line 3575 "../src/View/AbstractDirectoryView.vala"
						_tmp19_ = self->one_or_less;
#line 18769 "AbstractDirectoryView.c"
					} else {
#line 3575 "../src/View/AbstractDirectoryView.vala"
						_tmp19_ = FALSE;
#line 18773 "AbstractDirectoryView.c"
					}
#line 3575 "../src/View/AbstractDirectoryView.vala"
					if (_tmp19_) {
#line 18777 "AbstractDirectoryView.c"
						gboolean _tmp20_ = FALSE;
						gboolean _tmp21_ = FALSE;
						gboolean _tmp22_ = FALSE;
#line 3576 "../src/View/AbstractDirectoryView.vala"
						if (self->on_directory) {
#line 3576 "../src/View/AbstractDirectoryView.vala"
							_tmp22_ = !on_blank;
#line 18785 "AbstractDirectoryView.c"
						} else {
#line 3576 "../src/View/AbstractDirectoryView.vala"
							_tmp22_ = FALSE;
#line 18789 "AbstractDirectoryView.c"
						}
#line 3576 "../src/View/AbstractDirectoryView.vala"
						if (_tmp22_) {
#line 18793 "AbstractDirectoryView.c"
							gboolean _tmp23_;
#line 3576 "../src/View/AbstractDirectoryView.vala"
							_tmp23_ = self->priv->_singleclick_select;
#line 3576 "../src/View/AbstractDirectoryView.vala"
							_tmp21_ = !_tmp23_;
#line 18799 "AbstractDirectoryView.c"
						} else {
#line 3576 "../src/View/AbstractDirectoryView.vala"
							_tmp21_ = FALSE;
#line 18803 "AbstractDirectoryView.c"
						}
#line 3576 "../src/View/AbstractDirectoryView.vala"
						if (_tmp21_) {
#line 3576 "../src/View/AbstractDirectoryView.vala"
							_tmp20_ = TRUE;
#line 18809 "AbstractDirectoryView.c"
						} else {
#line 3576 "../src/View/AbstractDirectoryView.vala"
							_tmp20_ = double_click_event;
#line 18813 "AbstractDirectoryView.c"
						}
#line 3576 "../src/View/AbstractDirectoryView.vala"
						self->should_activate = _tmp20_;
#line 18817 "AbstractDirectoryView.c"
					}
#line 3582 "../src/View/AbstractDirectoryView.vala"
					if (!no_mods) {
#line 3582 "../src/View/AbstractDirectoryView.vala"
						_tmp24_ = TRUE;
#line 18823 "AbstractDirectoryView.c"
					} else {
						gboolean _tmp25_ = FALSE;
#line 3582 "../src/View/AbstractDirectoryView.vala"
						if (on_blank) {
#line 3582 "../src/View/AbstractDirectoryView.vala"
							_tmp25_ = !path_selected;
#line 18830 "AbstractDirectoryView.c"
						} else {
#line 3582 "../src/View/AbstractDirectoryView.vala"
							_tmp25_ = FALSE;
#line 18834 "AbstractDirectoryView.c"
						}
#line 3582 "../src/View/AbstractDirectoryView.vala"
						_tmp24_ = _tmp25_;
#line 18838 "AbstractDirectoryView.c"
					}
#line 3582 "../src/View/AbstractDirectoryView.vala"
					if (_tmp24_) {
#line 18842 "AbstractDirectoryView.c"
						gboolean _tmp26_ = FALSE;
#line 3583 "../src/View/AbstractDirectoryView.vala"
						if (only_shift_pressed) {
#line 18846 "AbstractDirectoryView.c"
							GtkTreePath* _tmp27_;
#line 3583 "../src/View/AbstractDirectoryView.vala"
							_tmp27_ = path;
#line 3583 "../src/View/AbstractDirectoryView.vala"
							_tmp26_ = files_abstract_directory_view_handle_multi_select (self, _tmp27_);
#line 18852 "AbstractDirectoryView.c"
						} else {
#line 3583 "../src/View/AbstractDirectoryView.vala"
							_tmp26_ = FALSE;
#line 18856 "AbstractDirectoryView.c"
						}
#line 3583 "../src/View/AbstractDirectoryView.vala"
						_result_ = _tmp26_;
#line 3586 "../src/View/AbstractDirectoryView.vala"
						self->should_select = TRUE;
#line 18862 "AbstractDirectoryView.c"
					} else {
						gboolean _tmp28_ = FALSE;
						GtkTreePath* _tmp29_;
						GtkTreePath* _tmp30_;
#line 3588 "../src/View/AbstractDirectoryView.vala"
						if (no_mods) {
#line 3588 "../src/View/AbstractDirectoryView.vala"
							_tmp28_ = !path_selected;
#line 18871 "AbstractDirectoryView.c"
						} else {
#line 3588 "../src/View/AbstractDirectoryView.vala"
							_tmp28_ = FALSE;
#line 18875 "AbstractDirectoryView.c"
						}
#line 3588 "../src/View/AbstractDirectoryView.vala"
						if (_tmp28_) {
#line 3589 "../src/View/AbstractDirectoryView.vala"
							files_abstract_directory_view_unselect_all (self);
#line 18881 "AbstractDirectoryView.c"
						}
#line 3592 "../src/View/AbstractDirectoryView.vala"
						_tmp29_ = path;
#line 3592 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_select_path (self, _tmp29_, TRUE);
#line 3593 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_unblock_drag_and_drop (self);
#line 3594 "../src/View/AbstractDirectoryView.vala"
						_tmp30_ = path;
#line 3594 "../src/View/AbstractDirectoryView.vala"
						_result_ = files_abstract_directory_view_handle_primary_button_click (self, event, _tmp30_);
#line 18893 "AbstractDirectoryView.c"
					}
#line 3597 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_update_selected_files_and_menu (self);
#line 3598 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18899 "AbstractDirectoryView.c"
				}
#line 3555 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER:
#line 18903 "AbstractDirectoryView.c"
				{
					gboolean _tmp31_ = FALSE;
#line 3601 "../src/View/AbstractDirectoryView.vala"
					if (only_control_pressed) {
#line 3601 "../src/View/AbstractDirectoryView.vala"
						_tmp31_ = TRUE;
#line 18910 "AbstractDirectoryView.c"
					} else {
#line 3601 "../src/View/AbstractDirectoryView.vala"
						_tmp31_ = only_shift_pressed;
#line 18914 "AbstractDirectoryView.c"
					}
#line 3601 "../src/View/AbstractDirectoryView.vala"
					if (_tmp31_) {
#line 18918 "AbstractDirectoryView.c"
						gboolean _tmp32_ = FALSE;
#line 3602 "../src/View/AbstractDirectoryView.vala"
						if (only_shift_pressed) {
#line 18922 "AbstractDirectoryView.c"
							GtkTreePath* _tmp33_;
#line 3602 "../src/View/AbstractDirectoryView.vala"
							_tmp33_ = path;
#line 3602 "../src/View/AbstractDirectoryView.vala"
							_tmp32_ = files_abstract_directory_view_handle_multi_select (self, _tmp33_);
#line 18928 "AbstractDirectoryView.c"
						} else {
#line 3602 "../src/View/AbstractDirectoryView.vala"
							_tmp32_ = FALSE;
#line 18932 "AbstractDirectoryView.c"
						}
#line 3602 "../src/View/AbstractDirectoryView.vala"
						_result_ = _tmp32_;
#line 18936 "AbstractDirectoryView.c"
					} else {
#line 3604 "../src/View/AbstractDirectoryView.vala"
						if (path_selected) {
#line 3606 "../src/View/AbstractDirectoryView.vala"
							self->should_deselect = TRUE;
#line 18942 "AbstractDirectoryView.c"
						} else {
							GtkTreePath* _tmp34_;
#line 3608 "../src/View/AbstractDirectoryView.vala"
							_tmp34_ = path;
#line 3608 "../src/View/AbstractDirectoryView.vala"
							files_abstract_directory_view_select_path (self, _tmp34_, TRUE);
#line 18949 "AbstractDirectoryView.c"
						}
#line 3611 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_unblock_drag_and_drop (self);
#line 3612 "../src/View/AbstractDirectoryView.vala"
						_result_ = TRUE;
#line 18955 "AbstractDirectoryView.c"
					}
#line 3614 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18959 "AbstractDirectoryView.c"
				}
#line 3555 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_EXPANDER:
#line 18963 "AbstractDirectoryView.c"
				{
					GtkTreePath* _tmp35_;
#line 3619 "../src/View/AbstractDirectoryView.vala"
					_tmp35_ = path;
#line 3619 "../src/View/AbstractDirectoryView.vala"
					_result_ = files_abstract_directory_view_expand_collapse (self, _tmp35_);
#line 3620 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18972 "AbstractDirectoryView.c"
				}
				default:
				{
#line 3623 "../src/View/AbstractDirectoryView.vala"
					break;
#line 18978 "AbstractDirectoryView.c"
				}
			}
#line 3626 "../src/View/AbstractDirectoryView.vala"
			break;
#line 18983 "AbstractDirectoryView.c"
		}
#line 3553 "../src/View/AbstractDirectoryView.vala"
		case GDK_BUTTON_MIDDLE:
#line 18987 "AbstractDirectoryView.c"
		{
			GtkTreePath* _tmp36_;
#line 3629 "../src/View/AbstractDirectoryView.vala"
			_tmp36_ = path;
#line 3629 "../src/View/AbstractDirectoryView.vala"
			if (!files_abstract_directory_view_path_is_selected (self, _tmp36_)) {
#line 18994 "AbstractDirectoryView.c"
				GtkTreePath* _tmp37_;
#line 3630 "../src/View/AbstractDirectoryView.vala"
				_tmp37_ = path;
#line 3630 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_select_path (self, _tmp37_, TRUE);
#line 19000 "AbstractDirectoryView.c"
			}
#line 3633 "../src/View/AbstractDirectoryView.vala"
			self->should_activate = TRUE;
#line 3634 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_unblock_drag_and_drop (self);
#line 3635 "../src/View/AbstractDirectoryView.vala"
			_result_ = TRUE;
#line 3637 "../src/View/AbstractDirectoryView.vala"
			break;
#line 19010 "AbstractDirectoryView.c"
		}
#line 3553 "../src/View/AbstractDirectoryView.vala"
		case GDK_BUTTON_SECONDARY:
#line 19014 "AbstractDirectoryView.c"
		{
#line 3640 "../src/View/AbstractDirectoryView.vala"
			switch (self->click_zone) {
#line 3640 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_NO_PATH:
#line 3640 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_INVALID:
#line 19022 "AbstractDirectoryView.c"
				{
#line 3643 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_unselect_all (self);
#line 3644 "../src/View/AbstractDirectoryView.vala"
					break;
#line 19028 "AbstractDirectoryView.c"
				}
#line 3640 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_BLANK_PATH:
#line 19032 "AbstractDirectoryView.c"
				{
					gboolean _tmp38_ = FALSE;
#line 3647 "../src/View/AbstractDirectoryView.vala"
					if (!path_selected) {
#line 3647 "../src/View/AbstractDirectoryView.vala"
						_tmp38_ = no_mods;
#line 19039 "AbstractDirectoryView.c"
					} else {
#line 3647 "../src/View/AbstractDirectoryView.vala"
						_tmp38_ = FALSE;
#line 19043 "AbstractDirectoryView.c"
					}
#line 3647 "../src/View/AbstractDirectoryView.vala"
					if (_tmp38_) {
#line 3648 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_unselect_all (self);
#line 19049 "AbstractDirectoryView.c"
					}
#line 3651 "../src/View/AbstractDirectoryView.vala"
					break;
#line 19053 "AbstractDirectoryView.c"
				}
#line 3640 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_NAME:
#line 3640 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON:
#line 3640 "../src/View/AbstractDirectoryView.vala"
				case FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_HELPER:
#line 19061 "AbstractDirectoryView.c"
				{
					gboolean _tmp39_ = FALSE;
					GtkTreePath* _tmp40_;
#line 3656 "../src/View/AbstractDirectoryView.vala"
					if (!path_selected) {
#line 3656 "../src/View/AbstractDirectoryView.vala"
						_tmp39_ = no_mods;
#line 19069 "AbstractDirectoryView.c"
					} else {
#line 3656 "../src/View/AbstractDirectoryView.vala"
						_tmp39_ = FALSE;
#line 19073 "AbstractDirectoryView.c"
					}
#line 3656 "../src/View/AbstractDirectoryView.vala"
					if (_tmp39_) {
#line 3657 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_unselect_all (self);
#line 19079 "AbstractDirectoryView.c"
					}
#line 3660 "../src/View/AbstractDirectoryView.vala"
					_tmp40_ = path;
#line 3660 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_select_path (self, _tmp40_, FALSE);
#line 3661 "../src/View/AbstractDirectoryView.vala"
					break;
#line 19087 "AbstractDirectoryView.c"
				}
				default:
				{
#line 3664 "../src/View/AbstractDirectoryView.vala"
					break;
#line 19093 "AbstractDirectoryView.c"
				}
			}
#line 3668 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_update_selected_files_and_menu (self);
#line 3669 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_unblock_drag_and_drop (self);
#line 3670 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_start_drag_timer (self, (GdkEvent*) event);
#line 3672 "../src/View/AbstractDirectoryView.vala"
			_result_ = files_abstract_directory_view_handle_secondary_button_click (self, event);
#line 3673 "../src/View/AbstractDirectoryView.vala"
			break;
#line 19106 "AbstractDirectoryView.c"
		}
		default:
		{
#line 3676 "../src/View/AbstractDirectoryView.vala"
			_result_ = files_abstract_directory_view_handle_default_button_click (self, event);
#line 3677 "../src/View/AbstractDirectoryView.vala"
			break;
#line 19114 "AbstractDirectoryView.c"
		}
	}
#line 3680 "../src/View/AbstractDirectoryView.vala"
	result = _result_;
#line 3680 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (path);
#line 3680 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19123 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_on_view_button_press_event (FilesAbstractDirectoryView* self,
                                                          GdkEventButton* event)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3498 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3498 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3498 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->on_view_button_press_event) {
#line 3498 "../src/View/AbstractDirectoryView.vala"
		return _klass_->on_view_button_press_event (self, event);
#line 19139 "AbstractDirectoryView.c"
	}
#line 3498 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 19143 "AbstractDirectoryView.c"
}

static Block33Data*
block33_data_ref (Block33Data* _data33_)
{
#line 3683 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data33_->_ref_count_);
#line 3683 "../src/View/AbstractDirectoryView.vala"
	return _data33_;
#line 19153 "AbstractDirectoryView.c"
}

static void
block33_data_unref (void * _userdata_)
{
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
#line 3683 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
#line 19163 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 3683 "../src/View/AbstractDirectoryView.vala"
		self = _data33_->self;
#line 3683 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 3683 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block33Data, _data33_);
#line 19171 "AbstractDirectoryView.c"
	}
}

static gboolean
____lambda129_ (Block33Data* _data33_)
{
	FilesAbstractDirectoryView* self;
	FilesOpenFlag _tmp0_ = 0;
	FilesOpenFlag flag = 0;
	GList* _tmp1_;
	gboolean result;
#line 3704 "../src/View/AbstractDirectoryView.vala"
	self = _data33_->self;
#line 3705 "../src/View/AbstractDirectoryView.vala"
	if (_data33_->button == ((guint) GDK_BUTTON_MIDDLE)) {
#line 3705 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FILES_OPEN_FLAG_NEW_TAB;
#line 19189 "AbstractDirectoryView.c"
	} else {
#line 3705 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FILES_OPEN_FLAG_DEFAULT;
#line 19193 "AbstractDirectoryView.c"
	}
#line 3705 "../src/View/AbstractDirectoryView.vala"
	flag = _tmp0_;
#line 3706 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_selected_files (self);
#line 3706 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_activate_selected_items (self, flag, _tmp1_);
#line 3707 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 3707 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19205 "AbstractDirectoryView.c"
}

static gboolean
_____lambda129__gsource_func (gpointer self)
{
	gboolean result;
	result = ____lambda129_ (self);
#line 3704 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19215 "AbstractDirectoryView.c"
}

static gboolean
__lambda130_ (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 3721 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 3722 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 3722 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19228 "AbstractDirectoryView.c"
}

static gboolean
___lambda130__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda130_ ((FilesAbstractDirectoryView*) self);
#line 3720 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19238 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_on_view_button_release_event (FilesAbstractDirectoryView* self,
                                                                 GdkEventButton* event)
{
	Block33Data* _data33_;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	FilesViewSlot* _tmp2_;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	guint _tmp5_ = 0U;
	GtkWidget* _tmp6_;
	gboolean result;
#line 3683 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 3683 "../src/View/AbstractDirectoryView.vala"
	_data33_ = g_slice_new0 (Block33Data);
#line 3683 "../src/View/AbstractDirectoryView.vala"
	_data33_->_ref_count_ = 1;
#line 3683 "../src/View/AbstractDirectoryView.vala"
	_data33_->self = g_object_ref (self);
#line 3684 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unblock_drag_and_drop (self);
#line 3689 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->_renaming;
#line 3689 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 3689 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 19272 "AbstractDirectoryView.c"
	} else {
#line 3689 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = !files_abstract_directory_view_view_has_focus (self);
#line 19276 "AbstractDirectoryView.c"
	}
#line 3689 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 3690 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 3690 "../src/View/AbstractDirectoryView.vala"
		block33_data_unref (_data33_);
#line 3690 "../src/View/AbstractDirectoryView.vala"
		_data33_ = NULL;
#line 3690 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 19288 "AbstractDirectoryView.c"
	}
#line 3693 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->slot;
#line 3693 "../src/View/AbstractDirectoryView.vala"
	g_signal_emit_by_name ((FilesAbstractSlot*) _tmp2_, "active", self->should_scroll, TRUE);
#line 3698 "../src/View/AbstractDirectoryView.vala"
	gdk_event_get_coords ((GdkEvent*) event, &_tmp3_, &_tmp4_);
#line 3698 "../src/View/AbstractDirectoryView.vala"
	x = _tmp3_;
#line 3698 "../src/View/AbstractDirectoryView.vala"
	y = _tmp4_;
#line 3699 "../src/View/AbstractDirectoryView.vala"
	gdk_event_get_button ((GdkEvent*) event, &_tmp5_);
#line 3699 "../src/View/AbstractDirectoryView.vala"
	_data33_->button = _tmp5_;
#line 3701 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = gtk_bin_get_child ((GtkBin*) self);
#line 3701 "../src/View/AbstractDirectoryView.vala"
	if (!gtk_drag_check_threshold (_tmp6_, (gint) self->priv->drag_x, (gint) self->priv->drag_y, (gint) x, (gint) y)) {
#line 3702 "../src/View/AbstractDirectoryView.vala"
		if (self->should_activate) {
#line 3704 "../src/View/AbstractDirectoryView.vala"
			g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _____lambda129__gsource_func, block33_data_ref (_data33_), block33_data_unref);
#line 19312 "AbstractDirectoryView.c"
		} else {
			gboolean _tmp7_ = FALSE;
#line 3709 "../src/View/AbstractDirectoryView.vala"
			if (self->should_deselect) {
#line 19317 "AbstractDirectoryView.c"
				GtkTreePath* _tmp8_;
#line 3709 "../src/View/AbstractDirectoryView.vala"
				_tmp8_ = self->click_path;
#line 3709 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = _tmp8_ != NULL;
#line 19323 "AbstractDirectoryView.c"
			} else {
#line 3709 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = FALSE;
#line 19327 "AbstractDirectoryView.c"
			}
#line 3709 "../src/View/AbstractDirectoryView.vala"
			if (_tmp7_) {
#line 19331 "AbstractDirectoryView.c"
				GtkTreePath* _tmp9_;
#line 3710 "../src/View/AbstractDirectoryView.vala"
				_tmp9_ = self->click_path;
#line 3710 "../src/View/AbstractDirectoryView.vala"
				files_abstract_directory_view_unselect_path (self, _tmp9_);
#line 19337 "AbstractDirectoryView.c"
			} else {
				gboolean _tmp10_ = FALSE;
#line 3711 "../src/View/AbstractDirectoryView.vala"
				if (self->should_select) {
#line 19342 "AbstractDirectoryView.c"
					GtkTreePath* _tmp11_;
#line 3711 "../src/View/AbstractDirectoryView.vala"
					_tmp11_ = self->click_path;
#line 3711 "../src/View/AbstractDirectoryView.vala"
					_tmp10_ = _tmp11_ != NULL;
#line 19348 "AbstractDirectoryView.c"
				} else {
#line 3711 "../src/View/AbstractDirectoryView.vala"
					_tmp10_ = FALSE;
#line 19352 "AbstractDirectoryView.c"
				}
#line 3711 "../src/View/AbstractDirectoryView.vala"
				if (_tmp10_) {
#line 19356 "AbstractDirectoryView.c"
					GtkTreePath* _tmp12_;
#line 3712 "../src/View/AbstractDirectoryView.vala"
					_tmp12_ = self->click_path;
#line 3712 "../src/View/AbstractDirectoryView.vala"
					files_abstract_directory_view_select_path (self, _tmp12_, FALSE);
#line 19362 "AbstractDirectoryView.c"
				} else {
#line 3713 "../src/View/AbstractDirectoryView.vala"
					if (_data33_->button == ((guint) GDK_BUTTON_SECONDARY)) {
#line 3714 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_show_context_menu (self, (GdkEvent*) event);
#line 19368 "AbstractDirectoryView.c"
					}
				}
			}
		}
	}
#line 3720 "../src/View/AbstractDirectoryView.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda130__gsource_func, g_object_ref (self), g_object_unref);
#line 3725 "../src/View/AbstractDirectoryView.vala"
	self->should_activate = FALSE;
#line 3726 "../src/View/AbstractDirectoryView.vala"
	self->should_deselect = FALSE;
#line 3727 "../src/View/AbstractDirectoryView.vala"
	self->should_select = FALSE;
#line 3728 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->click_path);
#line 3728 "../src/View/AbstractDirectoryView.vala"
	self->click_path = NULL;
#line 3729 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3729 "../src/View/AbstractDirectoryView.vala"
	block33_data_unref (_data33_);
#line 3729 "../src/View/AbstractDirectoryView.vala"
	_data33_ = NULL;
#line 3729 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19394 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_on_view_button_release_event (FilesAbstractDirectoryView* self,
                                                            GdkEventButton* event)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3683 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3683 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3683 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->on_view_button_release_event) {
#line 3683 "../src/View/AbstractDirectoryView.vala"
		return _klass_->on_view_button_release_event (self, event);
#line 19410 "AbstractDirectoryView.c"
	}
#line 3683 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 19414 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_change_zoom_level (FilesAbstractDirectoryView* self)
{
	FilesIconRenderer* _tmp0_;
	FilesZoomLevel _tmp1_;
	FilesZoomLevel _tmp2_;
	FilesTextRenderer* _tmp3_;
	FilesZoomLevel _tmp4_;
	FilesZoomLevel _tmp5_;
	GtkWidget* _tmp6_;
#line 3733 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->icon_renderer;
#line 3733 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = files_abstract_directory_view_get_zoom_level (self);
#line 3733 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_;
#line 3733 "../src/View/AbstractDirectoryView.vala"
	files_icon_renderer_set_zoom_level (_tmp0_, _tmp2_);
#line 3734 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->name_renderer;
#line 3734 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = files_abstract_directory_view_get_zoom_level (self);
#line 3734 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = _tmp4_;
#line 3734 "../src/View/AbstractDirectoryView.vala"
	files_text_renderer_set_zoom_level (_tmp3_, _tmp5_);
#line 3735 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = self->priv->view;
#line 3735 "../src/View/AbstractDirectoryView.vala"
	g_signal_emit_by_name (_tmp6_, "style-updated");
#line 19447 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_change_zoom_level (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3732 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3732 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3732 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->change_zoom_level) {
#line 3732 "../src/View/AbstractDirectoryView.vala"
		_klass_->change_zoom_level (self);
#line 19462 "AbstractDirectoryView.c"
	}
}

static Block34Data*
block34_data_ref (Block34Data* _data34_)
{
#line 3738 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data34_->_ref_count_);
#line 3738 "../src/View/AbstractDirectoryView.vala"
	return _data34_;
#line 19473 "AbstractDirectoryView.c"
}

static void
block34_data_unref (void * _userdata_)
{
	Block34Data* _data34_;
	_data34_ = (Block34Data*) _userdata_;
#line 3738 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data34_->_ref_count_)) {
#line 19483 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 3738 "../src/View/AbstractDirectoryView.vala"
		self = _data34_->self;
#line 3738 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (_data34_->start_path);
#line 3738 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (_data34_->path);
#line 3738 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 3738 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block34Data, _data34_);
#line 19495 "AbstractDirectoryView.c"
	}
}

static gboolean
__lambda88_ (Block34Data* _data34_)
{
	FilesAbstractDirectoryView* self;
	GtkTreePath* start = NULL;
	GtkTreePath* end = NULL;
	GtkTreePath* _tmp0_ = NULL;
	GtkTreePath* _tmp1_ = NULL;
	guint _tmp2_;
	gboolean _tmp3_ = FALSE;
	GtkTreePath* _tmp4_;
	FilesTextRenderer* _tmp10_;
	GtkTreePath* _tmp11_;
	FilesTextRenderer* _tmp12_;
	gboolean result;
#line 3762 "../src/View/AbstractDirectoryView.vala"
	self = _data34_->self;
#line 3766 "../src/View/AbstractDirectoryView.vala"
	start = NULL;
#line 3767 "../src/View/AbstractDirectoryView.vala"
	end = NULL;
#line 3768 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_get_visible_range (self, &_tmp0_, &_tmp1_);
#line 3768 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (start);
#line 3768 "../src/View/AbstractDirectoryView.vala"
	start = _tmp0_;
#line 3768 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (end);
#line 3768 "../src/View/AbstractDirectoryView.vala"
	end = _tmp1_;
#line 3769 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _data34_->count;
#line 3769 "../src/View/AbstractDirectoryView.vala"
	_data34_->count = _tmp2_ + 1;
#line 3771 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _data34_->start_path;
#line 3771 "../src/View/AbstractDirectoryView.vala"
	if (_tmp4_ == NULL) {
#line 3771 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = TRUE;
#line 19540 "AbstractDirectoryView.c"
	} else {
		gboolean _tmp5_ = FALSE;
#line 3771 "../src/View/AbstractDirectoryView.vala"
		if (_data34_->count < ((guint) 20)) {
#line 19545 "AbstractDirectoryView.c"
			GtkTreePath* _tmp6_;
			GtkTreePath* _tmp7_;
#line 3771 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = start;
#line 3771 "../src/View/AbstractDirectoryView.vala"
			_tmp7_ = _data34_->start_path;
#line 3771 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = gtk_tree_path_compare (_tmp6_, _tmp7_) != 0;
#line 19554 "AbstractDirectoryView.c"
		} else {
#line 3771 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = FALSE;
#line 19558 "AbstractDirectoryView.c"
		}
#line 3771 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = _tmp5_;
#line 19562 "AbstractDirectoryView.c"
	}
#line 3771 "../src/View/AbstractDirectoryView.vala"
	if (_tmp3_) {
#line 19566 "AbstractDirectoryView.c"
		GtkTreePath* _tmp8_;
		GtkTreePath* _tmp9_;
#line 3772 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = start;
#line 3772 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = __vala_GtkTreePath_copy0 (_tmp8_);
#line 3772 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (_data34_->start_path);
#line 3772 "../src/View/AbstractDirectoryView.vala"
		_data34_->start_path = _tmp9_;
#line 3773 "../src/View/AbstractDirectoryView.vala"
		_data34_->ok_next_time = FALSE;
#line 3774 "../src/View/AbstractDirectoryView.vala"
		result = G_SOURCE_CONTINUE;
#line 3774 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (end);
#line 3774 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreePath_free0 (start);
#line 3774 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 19587 "AbstractDirectoryView.c"
	} else {
#line 3775 "../src/View/AbstractDirectoryView.vala"
		if (!_data34_->ok_next_time) {
#line 3776 "../src/View/AbstractDirectoryView.vala"
			_data34_->ok_next_time = TRUE;
#line 3777 "../src/View/AbstractDirectoryView.vala"
			result = G_SOURCE_CONTINUE;
#line 3777 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (end);
#line 3777 "../src/View/AbstractDirectoryView.vala"
			__vala_GtkTreePath_free0 (start);
#line 3777 "../src/View/AbstractDirectoryView.vala"
			return result;
#line 19601 "AbstractDirectoryView.c"
		}
	}
#line 3781 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = self->name_renderer;
#line 3781 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkCellRendererText*) _tmp10_, "editable", TRUE, NULL);
#line 3782 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = _data34_->path;
#line 3782 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = self->name_renderer;
#line 3782 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_cursor_on_cell (self, _tmp11_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, gtk_cell_renderer_get_type ()) ? ((GtkCellRenderer*) _tmp12_) : NULL, TRUE, FALSE);
#line 3783 "../src/View/AbstractDirectoryView.vala"
	result = G_SOURCE_REMOVE;
#line 3783 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (end);
#line 3783 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (start);
#line 3783 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19622 "AbstractDirectoryView.c"
}

static gboolean
___lambda88__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda88_ (self);
#line 3762 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 19632 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_start_renaming_file (FilesAbstractDirectoryView* self,
                                                   FilesFile* file)
{
	Block34Data* _data34_;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkTreeIter* iter = NULL;
	FilesListModel* _tmp2_;
	GtkTreeIter* _tmp3_ = NULL;
	gboolean _tmp4_;
	FilesListModel* _tmp5_;
	GtkTreeIter* _tmp6_;
	GtkTreeIter _tmp7_;
	GtkTreePath* _tmp8_;
	GtkTreePath* _tmp9_;
	FilesTextRenderer* _tmp10_;
#line 3738 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3738 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (file != NULL);
#line 3738 "../src/View/AbstractDirectoryView.vala"
	_data34_ = g_slice_new0 (Block34Data);
#line 3738 "../src/View/AbstractDirectoryView.vala"
	_data34_->_ref_count_ = 1;
#line 3738 "../src/View/AbstractDirectoryView.vala"
	_data34_->self = g_object_ref (self);
#line 3739 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_is_frozen (self);
#line 3739 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 3739 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 3740 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:3740: Trying to rename when frozen");
#line 3741 "../src/View/AbstractDirectoryView.vala"
		block34_data_unref (_data34_);
#line 3741 "../src/View/AbstractDirectoryView.vala"
		_data34_ = NULL;
#line 3741 "../src/View/AbstractDirectoryView.vala"
		return;
#line 19676 "AbstractDirectoryView.c"
	}
#line 3743 "../src/View/AbstractDirectoryView.vala"
	iter = NULL;
#line 3744 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = self->model;
#line 3744 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = files_list_model_get_first_iter_for_file (_tmp2_, file, &_tmp3_);
#line 3744 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 3744 "../src/View/AbstractDirectoryView.vala"
	iter = _tmp3_;
#line 3744 "../src/View/AbstractDirectoryView.vala"
	if (!_tmp4_) {
#line 3745 "../src/View/AbstractDirectoryView.vala"
		g_critical ("AbstractDirectoryView.vala:3745: Failed to find rename file in model");
#line 3746 "../src/View/AbstractDirectoryView.vala"
		__vala_GtkTreeIter_free0 (iter);
#line 3746 "../src/View/AbstractDirectoryView.vala"
		block34_data_unref (_data34_);
#line 3746 "../src/View/AbstractDirectoryView.vala"
		_data34_ = NULL;
#line 3746 "../src/View/AbstractDirectoryView.vala"
		return;
#line 19700 "AbstractDirectoryView.c"
	}
#line 3750 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_renaming (self, TRUE);
#line 3751 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_menu_actions (self);
#line 3752 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_is_frozen (self, TRUE);
#line 3753 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = self->model;
#line 3753 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = iter;
#line 3753 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = *_tmp6_;
#line 3753 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = gtk_tree_model_get_path ((GtkTreeModel*) _tmp5_, &_tmp7_);
#line 3753 "../src/View/AbstractDirectoryView.vala"
	_data34_->path = _tmp8_;
#line 3755 "../src/View/AbstractDirectoryView.vala"
	_data34_->count = (guint) 0;
#line 3756 "../src/View/AbstractDirectoryView.vala"
	_data34_->ok_next_time = FALSE;
#line 3757 "../src/View/AbstractDirectoryView.vala"
	_data34_->start_path = NULL;
#line 3761 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _data34_->path;
#line 3761 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = self->name_renderer;
#line 3761 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_cursor_on_cell (self, _tmp9_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, gtk_cell_renderer_get_type ()) ? ((GtkCellRenderer*) _tmp10_) : NULL, FALSE, FALSE);
#line 3762 "../src/View/AbstractDirectoryView.vala"
	g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 50, ___lambda88__gsource_func, block34_data_ref (_data34_), block34_data_unref);
#line 3738 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreeIter_free0 (iter);
#line 3738 "../src/View/AbstractDirectoryView.vala"
	block34_data_unref (_data34_);
#line 3738 "../src/View/AbstractDirectoryView.vala"
	_data34_ = NULL;
#line 19738 "AbstractDirectoryView.c"
}

static Block35Data*
block35_data_ref (Block35Data* _data35_)
{
#line 3788 "../src/View/AbstractDirectoryView.vala"
	g_atomic_int_inc (&_data35_->_ref_count_);
#line 3788 "../src/View/AbstractDirectoryView.vala"
	return _data35_;
#line 19748 "AbstractDirectoryView.c"
}

static void
block35_data_unref (void * _userdata_)
{
	Block35Data* _data35_;
	_data35_ = (Block35Data*) _userdata_;
#line 3788 "../src/View/AbstractDirectoryView.vala"
	if (g_atomic_int_dec_and_test (&_data35_->_ref_count_)) {
#line 19758 "AbstractDirectoryView.c"
		FilesAbstractDirectoryView* self;
#line 3788 "../src/View/AbstractDirectoryView.vala"
		self = _data35_->self;
#line 3788 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (_data35_->dir);
#line 3788 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (self);
#line 3788 "../src/View/AbstractDirectoryView.vala"
		g_slice_free (Block35Data, _data35_);
#line 19768 "AbstractDirectoryView.c"
	}
}

static void
___lambda124_ (Block35Data* _data35_,
               GObject* obj,
               GAsyncResult* res)
{
	FilesAbstractDirectoryView* self;
	GError* _inner_error0_ = NULL;
#line 3823 "../src/View/AbstractDirectoryView.vala"
	self = _data35_->self;
#line 3823 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (res != NULL);
#line 19783 "AbstractDirectoryView.c"
	{
		GFileInfo* inf = NULL;
		FilesDirectory* _tmp0_;
		GFile* _tmp1_;
		GFile* _tmp2_;
		GFileInfo* _tmp3_ = NULL;
#line 3826 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = _data35_->dir;
#line 3826 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = files_directory_get_location (_tmp0_);
#line 3826 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = _tmp1_;
#line 3826 "../src/View/AbstractDirectoryView.vala"
		g_file_set_attributes_finish (_tmp2_, res, &_tmp3_, &_inner_error0_);
#line 3826 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (inf);
#line 3826 "../src/View/AbstractDirectoryView.vala"
		inf = _tmp3_;
#line 3826 "../src/View/AbstractDirectoryView.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3826 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (inf);
#line 19806 "AbstractDirectoryView.c"
			goto __catch0_g_error;
		}
#line 3824 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (inf);
#line 19811 "AbstractDirectoryView.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 3824 "../src/View/AbstractDirectoryView.vala"
		e = _inner_error0_;
#line 3824 "../src/View/AbstractDirectoryView.vala"
		_inner_error0_ = NULL;
#line 3828 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = e;
#line 3828 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = _tmp4_->message;
#line 3828 "../src/View/AbstractDirectoryView.vala"
		g_warning ("AbstractDirectoryView.vala:3828: Could not set file attributes: %s", _tmp5_);
#line 3824 "../src/View/AbstractDirectoryView.vala"
		_g_error_free0 (e);
#line 19831 "AbstractDirectoryView.c"
	}
	__finally0:
#line 3824 "../src/View/AbstractDirectoryView.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3824 "../src/View/AbstractDirectoryView.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 3824 "../src/View/AbstractDirectoryView.vala"
		g_clear_error (&_inner_error0_);
#line 3824 "../src/View/AbstractDirectoryView.vala"
		return;
#line 19842 "AbstractDirectoryView.c"
	}
}

static void
____lambda124__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
#line 3819 "../src/View/AbstractDirectoryView.vala"
	___lambda124_ (self, source_object, res);
#line 3819 "../src/View/AbstractDirectoryView.vala"
	block35_data_unref (self);
#line 19855 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_on_sort_column_changed (FilesAbstractDirectoryView* self)
{
	Block35Data* _data35_;
	gint sort_column_id = 0;
	GtkSortType sort_order = 0;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	GFileInfo* info = NULL;
	GFileInfo* _tmp6_;
	FilesViewSlot* _tmp7_;
	FilesDirectory* _tmp8_;
	FilesDirectory* _tmp9_;
	FilesDirectory* _tmp10_;
	const gchar* sort_col_s = NULL;
	const gchar* _tmp11_;
	const gchar* _tmp12_ = NULL;
	const gchar* sort_order_s = NULL;
	GFileInfo* _tmp13_;
	const gchar* _tmp14_;
	GFileInfo* _tmp15_;
	const gchar* _tmp16_;
	FilesDirectory* _tmp17_;
	FilesFile* _tmp18_;
	FilesFile* _tmp19_;
	GFileInfo* _tmp20_;
	const gchar* _tmp21_;
	FilesDirectory* _tmp22_;
	FilesFile* _tmp23_;
	FilesFile* _tmp24_;
	GFileInfo* _tmp25_;
	const gchar* _tmp26_;
	FilesDirectory* _tmp27_;
	FilesFile* _tmp28_;
	FilesFile* _tmp29_;
	FilesDirectory* _tmp30_;
	FilesFile* _tmp31_;
	FilesFile* _tmp32_;
#line 3788 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3788 "../src/View/AbstractDirectoryView.vala"
	_data35_ = g_slice_new0 (Block35Data);
#line 3788 "../src/View/AbstractDirectoryView.vala"
	_data35_->_ref_count_ = 1;
#line 3788 "../src/View/AbstractDirectoryView.vala"
	_data35_->self = g_object_ref (self);
#line 3789 "../src/View/AbstractDirectoryView.vala"
	sort_column_id = 0;
#line 3790 "../src/View/AbstractDirectoryView.vala"
	sort_order = 0;
#line 3793 "../src/View/AbstractDirectoryView.vala"
	if (files_is_admin ()) {
#line 3794 "../src/View/AbstractDirectoryView.vala"
		block35_data_unref (_data35_);
#line 3794 "../src/View/AbstractDirectoryView.vala"
		_data35_ = NULL;
#line 3794 "../src/View/AbstractDirectoryView.vala"
		return;
#line 19916 "AbstractDirectoryView.c"
	}
#line 3801 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->priv->_tree_frozen;
#line 3801 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_) {
#line 3801 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = TRUE;
#line 19924 "AbstractDirectoryView.c"
	} else {
		FilesListModel* _tmp2_;
		gint _tmp3_ = 0;
		GtkSortType _tmp4_ = 0;
		gboolean _tmp5_;
#line 3801 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->model;
#line 3801 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = gtk_tree_sortable_get_sort_column_id ((GtkTreeSortable*) _tmp2_, &_tmp3_, &_tmp4_);
#line 3801 "../src/View/AbstractDirectoryView.vala"
		sort_column_id = _tmp3_;
#line 3801 "../src/View/AbstractDirectoryView.vala"
		sort_order = _tmp4_;
#line 3801 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = !_tmp5_;
#line 19940 "AbstractDirectoryView.c"
	}
#line 3801 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 3802 "../src/View/AbstractDirectoryView.vala"
		block35_data_unref (_data35_);
#line 3802 "../src/View/AbstractDirectoryView.vala"
		_data35_ = NULL;
#line 3802 "../src/View/AbstractDirectoryView.vala"
		return;
#line 19950 "AbstractDirectoryView.c"
	}
#line 3805 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = g_file_info_new ();
#line 3805 "../src/View/AbstractDirectoryView.vala"
	info = _tmp6_;
#line 3806 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->slot;
#line 3806 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = files_abstract_slot_get_directory ((FilesAbstractSlot*) _tmp7_);
#line 3806 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = _tmp8_;
#line 3806 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 3806 "../src/View/AbstractDirectoryView.vala"
	_data35_->dir = _tmp10_;
#line 3807 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = files_list_model_column_id_to_string ((FilesListModelColumnID) sort_column_id);
#line 3807 "../src/View/AbstractDirectoryView.vala"
	sort_col_s = _tmp11_;
#line 3808 "../src/View/AbstractDirectoryView.vala"
	if (sort_order == GTK_SORT_DESCENDING) {
#line 3808 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = "true";
#line 19974 "AbstractDirectoryView.c"
	} else {
#line 3808 "../src/View/AbstractDirectoryView.vala"
		_tmp12_ = "false";
#line 19978 "AbstractDirectoryView.c"
	}
#line 3808 "../src/View/AbstractDirectoryView.vala"
	sort_order_s = _tmp12_;
#line 3809 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = info;
#line 3809 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = sort_col_s;
#line 3809 "../src/View/AbstractDirectoryView.vala"
	g_file_info_set_attribute_string (_tmp13_, "metadata::marlin-sort-column-id", _tmp14_);
#line 3810 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = info;
#line 3810 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = sort_order_s;
#line 3810 "../src/View/AbstractDirectoryView.vala"
	g_file_info_set_attribute_string (_tmp15_, "metadata::marlin-sort-reversed", _tmp16_);
#line 3813 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = _data35_->dir;
#line 3813 "../src/View/AbstractDirectoryView.vala"
	_tmp18_ = files_directory_get_file (_tmp17_);
#line 3813 "../src/View/AbstractDirectoryView.vala"
	_tmp19_ = _tmp18_;
#line 3813 "../src/View/AbstractDirectoryView.vala"
	_tmp20_ = _tmp19_->info;
#line 3813 "../src/View/AbstractDirectoryView.vala"
	_tmp21_ = sort_col_s;
#line 3813 "../src/View/AbstractDirectoryView.vala"
	g_file_info_set_attribute_string (_tmp20_, "metadata::marlin-sort-column-id", _tmp21_);
#line 3814 "../src/View/AbstractDirectoryView.vala"
	_tmp22_ = _data35_->dir;
#line 3814 "../src/View/AbstractDirectoryView.vala"
	_tmp23_ = files_directory_get_file (_tmp22_);
#line 3814 "../src/View/AbstractDirectoryView.vala"
	_tmp24_ = _tmp23_;
#line 3814 "../src/View/AbstractDirectoryView.vala"
	_tmp25_ = _tmp24_->info;
#line 3814 "../src/View/AbstractDirectoryView.vala"
	_tmp26_ = sort_order_s;
#line 3814 "../src/View/AbstractDirectoryView.vala"
	g_file_info_set_attribute_string (_tmp25_, "metadata::marlin-sort-reversed", _tmp26_);
#line 3815 "../src/View/AbstractDirectoryView.vala"
	_tmp27_ = _data35_->dir;
#line 3815 "../src/View/AbstractDirectoryView.vala"
	_tmp28_ = files_directory_get_file (_tmp27_);
#line 3815 "../src/View/AbstractDirectoryView.vala"
	_tmp29_ = _tmp28_;
#line 3815 "../src/View/AbstractDirectoryView.vala"
	_tmp29_->sort_column_id = sort_column_id;
#line 3816 "../src/View/AbstractDirectoryView.vala"
	_tmp30_ = _data35_->dir;
#line 3816 "../src/View/AbstractDirectoryView.vala"
	_tmp31_ = files_directory_get_file (_tmp30_);
#line 3816 "../src/View/AbstractDirectoryView.vala"
	_tmp32_ = _tmp31_;
#line 3816 "../src/View/AbstractDirectoryView.vala"
	_tmp32_->sort_order = sort_order;
#line 3818 "../src/View/AbstractDirectoryView.vala"
	if (!files_is_admin ()) {
#line 20036 "AbstractDirectoryView.c"
		FilesDirectory* _tmp33_;
		GFile* _tmp34_;
		GFile* _tmp35_;
		GFileInfo* _tmp36_;
#line 3819 "../src/View/AbstractDirectoryView.vala"
		_tmp33_ = _data35_->dir;
#line 3819 "../src/View/AbstractDirectoryView.vala"
		_tmp34_ = files_directory_get_location (_tmp33_);
#line 3819 "../src/View/AbstractDirectoryView.vala"
		_tmp35_ = _tmp34_;
#line 3819 "../src/View/AbstractDirectoryView.vala"
		_tmp36_ = info;
#line 3819 "../src/View/AbstractDirectoryView.vala"
		g_file_set_attributes_async (_tmp35_, _tmp36_, G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, NULL, ____lambda124__gasync_ready_callback, block35_data_ref (_data35_));
#line 20051 "AbstractDirectoryView.c"
	}
#line 3788 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (info);
#line 3788 "../src/View/AbstractDirectoryView.vala"
	block35_data_unref (_data35_);
#line 3788 "../src/View/AbstractDirectoryView.vala"
	_data35_ = NULL;
#line 20059 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_cancel_timeout (FilesAbstractDirectoryView* self,
                                              guint* id)
{
#line 3834 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3835 "../src/View/AbstractDirectoryView.vala"
	if ((*id) > ((guint) 0)) {
#line 3836 "../src/View/AbstractDirectoryView.vala"
		g_source_remove (*id);
#line 3837 "../src/View/AbstractDirectoryView.vala"
		*id = (guint) 0;
#line 20074 "AbstractDirectoryView.c"
	}
}

void
files_abstract_directory_view_update_selected_files_and_menu (FilesAbstractDirectoryView* self)
{
	gboolean _tmp6_ = FALSE;
	GList* _tmp7_;
#line 3841 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3842 "../src/View/AbstractDirectoryView.vala"
	if (self->priv->selected_files_invalid) {
#line 20087 "AbstractDirectoryView.c"
		guint selected_count = 0U;
		GList* _tmp0_ = NULL;
		guint _tmp1_;
		FilesViewSlot* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		GList* _tmp5_;
#line 3843 "../src/View/AbstractDirectoryView.vala"
		(self->selected_files == NULL) ? NULL : (self->selected_files = (_g_list_free__g_object_unref0_ (self->selected_files), NULL));
#line 3843 "../src/View/AbstractDirectoryView.vala"
		self->selected_files = NULL;
#line 3845 "../src/View/AbstractDirectoryView.vala"
		_tmp1_ = files_abstract_directory_view_get_selected_files_from_model (self, &_tmp0_);
#line 3845 "../src/View/AbstractDirectoryView.vala"
		(self->selected_files == NULL) ? NULL : (self->selected_files = (_g_list_free__g_object_unref0_ (self->selected_files), NULL));
#line 3845 "../src/View/AbstractDirectoryView.vala"
		self->selected_files = _tmp0_;
#line 3845 "../src/View/AbstractDirectoryView.vala"
		selected_count = _tmp1_;
#line 3846 "../src/View/AbstractDirectoryView.vala"
		_tmp2_ = self->slot;
#line 3846 "../src/View/AbstractDirectoryView.vala"
		_tmp3_ = files_view_slot_get_displayed_files_count (_tmp2_);
#line 3846 "../src/View/AbstractDirectoryView.vala"
		_tmp4_ = _tmp3_;
#line 3846 "../src/View/AbstractDirectoryView.vala"
		self->priv->all_selected = selected_count == ((guint) _tmp4_);
#line 3847 "../src/View/AbstractDirectoryView.vala"
		self->selected_files = g_list_reverse (self->selected_files);
#line 3848 "../src/View/AbstractDirectoryView.vala"
		self->priv->selected_files_invalid = FALSE;
#line 3849 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_update_menu_actions (self);
#line 3850 "../src/View/AbstractDirectoryView.vala"
		_tmp5_ = self->selected_files;
#line 3850 "../src/View/AbstractDirectoryView.vala"
		g_signal_emit (self, files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_SELECTION_CHANGED_SIGNAL], 0, _tmp5_);
#line 20125 "AbstractDirectoryView.c"
	}
#line 3853 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = self->selected_files;
#line 3853 "../src/View/AbstractDirectoryView.vala"
	if (_tmp7_ == NULL) {
#line 3853 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = TRUE;
#line 20133 "AbstractDirectoryView.c"
	} else {
		GList* _tmp8_;
		GList* _tmp9_;
#line 3853 "../src/View/AbstractDirectoryView.vala"
		_tmp8_ = self->selected_files;
#line 3853 "../src/View/AbstractDirectoryView.vala"
		_tmp9_ = _tmp8_->next;
#line 3853 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = _tmp9_ == NULL;
#line 20143 "AbstractDirectoryView.c"
	}
#line 3853 "../src/View/AbstractDirectoryView.vala"
	self->one_or_less = _tmp6_;
#line 20147 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_expand_collapse (FilesAbstractDirectoryView* self,
                                                    GtkTreePath* path)
{
	gboolean result;
#line 3857 "../src/View/AbstractDirectoryView.vala"
	result = TRUE;
#line 3857 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20159 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_expand_collapse (FilesAbstractDirectoryView* self,
                                               GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3856 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3856 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3856 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->expand_collapse) {
#line 3856 "../src/View/AbstractDirectoryView.vala"
		return _klass_->expand_collapse (self, path);
#line 20175 "AbstractDirectoryView.c"
	}
#line 3856 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 20179 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_handle_default_button_click (FilesAbstractDirectoryView* self,
                                                                GdkEventButton* event)
{
	gboolean result;
#line 3860 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 3862 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3862 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20193 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_handle_default_button_click (FilesAbstractDirectoryView* self,
                                                           GdkEventButton* event)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3860 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3860 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3860 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->handle_default_button_click) {
#line 3860 "../src/View/AbstractDirectoryView.vala"
		return _klass_->handle_default_button_click (self, event);
#line 20209 "AbstractDirectoryView.c"
	}
#line 3860 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 20213 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_get_next_visible_iter (FilesAbstractDirectoryView* self,
                                                          GtkTreeIter* iter,
                                                          gboolean recurse)
{
	FilesListModel* _tmp0_;
	gboolean _tmp1_;
	gboolean result;
#line 3865 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (iter != NULL, FALSE);
#line 3866 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = self->model;
#line 3866 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = gtk_tree_model_iter_next ((GtkTreeModel*) _tmp0_, iter);
#line 3866 "../src/View/AbstractDirectoryView.vala"
	result = _tmp1_;
#line 3866 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20234 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_get_next_visible_iter (FilesAbstractDirectoryView* self,
                                                     GtkTreeIter* iter,
                                                     gboolean recurse)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3865 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3865 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3865 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_next_visible_iter) {
#line 3865 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_next_visible_iter (self, iter, recurse);
#line 20251 "AbstractDirectoryView.c"
	}
#line 3865 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 20255 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_cancel (FilesAbstractDirectoryView* self)
{
#line 3870 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_grab_focus (self);
#line 3871 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_hover (self);
#line 3872 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_thumbnailing (self);
#line 3873 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_drag_timer (self);
#line 3874 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->drag_scroll_timer_id);
#line 3875 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->add_remove_file_timeout_id);
#line 3876 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->set_cursor_timeout_id);
#line 3877 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel_timeout (self, &self->priv->draw_timeout_id);
#line 20277 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_cancel (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3869 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3869 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3869 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->cancel) {
#line 3869 "../src/View/AbstractDirectoryView.vala"
		_klass_->cancel (self);
#line 20292 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_cancel_hover (FilesAbstractDirectoryView* self)
{
#line 3881 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3882 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->priv->hover_path);
#line 3882 "../src/View/AbstractDirectoryView.vala"
	self->priv->hover_path = NULL;
#line 20305 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_close (FilesAbstractDirectoryView* self)
{
#line 3885 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3886 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_set_is_frozen (self, TRUE);
#line 3887 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_cancel (self);
#line 3888 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_unselect_all (self);
#line 20319 "AbstractDirectoryView.c"
}

static void
__vala_GtkTreePath_free0_ (gpointer var)
{
#line 3894 "../src/View/AbstractDirectoryView.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL));
#line 20327 "AbstractDirectoryView.c"
}

static inline void
_g_list_free___vala_GtkTreePath_free0_ (GList* self)
{
#line 3894 "../src/View/AbstractDirectoryView.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreePath_free0_);
#line 20335 "AbstractDirectoryView.c"
}

static GtkTreeRowReference*
_vala_GtkTreeRowReference_copy (GtkTreeRowReference* self)
{
#line 3901 "../src/View/AbstractDirectoryView.vala"
	return g_boxed_copy (gtk_tree_row_reference_get_type (), self);
#line 20343 "AbstractDirectoryView.c"
}

static gpointer
__vala_GtkTreeRowReference_copy0 (gpointer self)
{
#line 3901 "../src/View/AbstractDirectoryView.vala"
	return self ? _vala_GtkTreeRowReference_copy (self) : NULL;
#line 20351 "AbstractDirectoryView.c"
}

static void
_vala_GtkTreeRowReference_free (GtkTreeRowReference* self)
{
#line 3901 "../src/View/AbstractDirectoryView.vala"
	g_boxed_free (gtk_tree_row_reference_get_type (), self);
#line 20359 "AbstractDirectoryView.c"
}

static void
__vala_GtkTreeRowReference_free0_ (gpointer var)
{
#line 3891 "../src/View/AbstractDirectoryView.vala"
	(var == NULL) ? NULL : (var = (_vala_GtkTreeRowReference_free (var), NULL));
#line 20367 "AbstractDirectoryView.c"
}

static inline void
_g_list_free___vala_GtkTreeRowReference_free0_ (GList* self)
{
#line 3891 "../src/View/AbstractDirectoryView.vala"
	g_list_free_full (self, (GDestroyNotify) __vala_GtkTreeRowReference_free0_);
#line 20375 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_invert_selection (FilesAbstractDirectoryView* self)
{
	GList* selected_row_refs = NULL;
	GList* _tmp0_;
	GList* _tmp5_;
#line 3891 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3892 "../src/View/AbstractDirectoryView.vala"
	selected_row_refs = NULL;
#line 3894 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_selected_paths (self);
#line 20390 "AbstractDirectoryView.c"
	{
		GList* p_collection = NULL;
		GList* p_it = NULL;
#line 3894 "../src/View/AbstractDirectoryView.vala"
		p_collection = _tmp0_;
#line 3894 "../src/View/AbstractDirectoryView.vala"
		for (p_it = p_collection; p_it != NULL; p_it = p_it->next) {
#line 20398 "AbstractDirectoryView.c"
			GtkTreePath* _tmp1_;
			GtkTreePath* p = NULL;
#line 3894 "../src/View/AbstractDirectoryView.vala"
			_tmp1_ = __vala_GtkTreePath_copy0 ((GtkTreePath*) p_it->data);
#line 3894 "../src/View/AbstractDirectoryView.vala"
			p = _tmp1_;
#line 20405 "AbstractDirectoryView.c"
			{
				FilesListModel* _tmp2_;
				GtkTreePath* _tmp3_;
				GtkTreeRowReference* _tmp4_;
#line 3895 "../src/View/AbstractDirectoryView.vala"
				_tmp2_ = self->model;
#line 3895 "../src/View/AbstractDirectoryView.vala"
				_tmp3_ = p;
#line 3895 "../src/View/AbstractDirectoryView.vala"
				_tmp4_ = gtk_tree_row_reference_new ((GtkTreeModel*) _tmp2_, _tmp3_);
#line 3895 "../src/View/AbstractDirectoryView.vala"
				selected_row_refs = g_list_prepend (selected_row_refs, _tmp4_);
#line 3894 "../src/View/AbstractDirectoryView.vala"
				__vala_GtkTreePath_free0 (p);
#line 20420 "AbstractDirectoryView.c"
			}
		}
#line 3894 "../src/View/AbstractDirectoryView.vala"
		(p_collection == NULL) ? NULL : (p_collection = (_g_list_free___vala_GtkTreePath_free0_ (p_collection), NULL));
#line 20425 "AbstractDirectoryView.c"
	}
#line 3898 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_select_all (self);
#line 3900 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = selected_row_refs;
#line 3900 "../src/View/AbstractDirectoryView.vala"
	if (_tmp5_ != NULL) {
#line 20433 "AbstractDirectoryView.c"
		GList* _tmp6_;
#line 3901 "../src/View/AbstractDirectoryView.vala"
		_tmp6_ = selected_row_refs;
#line 20437 "AbstractDirectoryView.c"
		{
			GList* r_collection = NULL;
			GList* r_it = NULL;
#line 3901 "../src/View/AbstractDirectoryView.vala"
			r_collection = _tmp6_;
#line 3901 "../src/View/AbstractDirectoryView.vala"
			for (r_it = r_collection; r_it != NULL; r_it = r_it->next) {
#line 20445 "AbstractDirectoryView.c"
				GtkTreeRowReference* _tmp7_;
				GtkTreeRowReference* r = NULL;
#line 3901 "../src/View/AbstractDirectoryView.vala"
				_tmp7_ = __vala_GtkTreeRowReference_copy0 ((GtkTreeRowReference*) r_it->data);
#line 3901 "../src/View/AbstractDirectoryView.vala"
				r = _tmp7_;
#line 20452 "AbstractDirectoryView.c"
				{
					GtkTreePath* p = NULL;
					GtkTreeRowReference* _tmp8_;
					GtkTreePath* _tmp9_;
					GtkTreePath* _tmp10_;
#line 3902 "../src/View/AbstractDirectoryView.vala"
					_tmp8_ = r;
#line 3902 "../src/View/AbstractDirectoryView.vala"
					_tmp9_ = gtk_tree_row_reference_get_path (_tmp8_);
#line 3902 "../src/View/AbstractDirectoryView.vala"
					p = _tmp9_;
#line 3903 "../src/View/AbstractDirectoryView.vala"
					_tmp10_ = p;
#line 3903 "../src/View/AbstractDirectoryView.vala"
					if (_tmp10_ != NULL) {
#line 20468 "AbstractDirectoryView.c"
						GtkTreePath* _tmp11_;
#line 3904 "../src/View/AbstractDirectoryView.vala"
						_tmp11_ = p;
#line 3904 "../src/View/AbstractDirectoryView.vala"
						files_abstract_directory_view_unselect_path (self, _tmp11_);
#line 20474 "AbstractDirectoryView.c"
					}
#line 3901 "../src/View/AbstractDirectoryView.vala"
					__vala_GtkTreePath_free0 (p);
#line 3901 "../src/View/AbstractDirectoryView.vala"
					__vala_GtkTreeRowReference_free0 (r);
#line 20480 "AbstractDirectoryView.c"
				}
			}
		}
	}
#line 3891 "../src/View/AbstractDirectoryView.vala"
	(selected_row_refs == NULL) ? NULL : (selected_row_refs = (_g_list_free___vala_GtkTreeRowReference_free0_ (selected_row_refs), NULL));
#line 20487 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_select_all (FilesAbstractDirectoryView* self)
{
#line 3910 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3911 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_tree_select_all (self);
#line 3912 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 20499 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_unselect_all (FilesAbstractDirectoryView* self)
{
#line 3915 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3916 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_tree_unselect_all (self);
#line 3917 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 20511 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_unselect_others (FilesAbstractDirectoryView* self)
{
#line 3920 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3921 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_tree_unselect_others (self);
#line 3922 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_update_selected_files_and_menu (self);
#line 20523 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_highlight_path (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path)
{
}

void
files_abstract_directory_view_highlight_path (FilesAbstractDirectoryView* self,
                                              GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3925 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3925 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3925 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->highlight_path) {
#line 3925 "../src/View/AbstractDirectoryView.vala"
		_klass_->highlight_path (self, path);
#line 20545 "AbstractDirectoryView.c"
	}
}

static GtkTreePath*
files_abstract_directory_view_real_up (FilesAbstractDirectoryView* self,
                                       GtkTreePath* path)
{
	GtkTreePath* _tmp0_;
	GtkTreePath* result;
#line 3926 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 3926 "../src/View/AbstractDirectoryView.vala"
	gtk_tree_path_up (path);
#line 3926 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = __vala_GtkTreePath_copy0 (path);
#line 3926 "../src/View/AbstractDirectoryView.vala"
	result = _tmp0_;
#line 3926 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20565 "AbstractDirectoryView.c"
}

GtkTreePath*
files_abstract_directory_view_up (FilesAbstractDirectoryView* self,
                                  GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3926 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3926 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3926 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->up) {
#line 3926 "../src/View/AbstractDirectoryView.vala"
		return _klass_->up (self, path);
#line 20581 "AbstractDirectoryView.c"
	}
#line 3926 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20585 "AbstractDirectoryView.c"
}

static GtkTreePath*
files_abstract_directory_view_real_down (FilesAbstractDirectoryView* self,
                                         GtkTreePath* path)
{
	GtkTreePath* _tmp0_;
	GtkTreePath* result;
#line 3927 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 3927 "../src/View/AbstractDirectoryView.vala"
	gtk_tree_path_down (path);
#line 3927 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = __vala_GtkTreePath_copy0 (path);
#line 3927 "../src/View/AbstractDirectoryView.vala"
	result = _tmp0_;
#line 3927 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20604 "AbstractDirectoryView.c"
}

GtkTreePath*
files_abstract_directory_view_down (FilesAbstractDirectoryView* self,
                                    GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3927 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3927 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3927 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->down) {
#line 3927 "../src/View/AbstractDirectoryView.vala"
		return _klass_->down (self, path);
#line 20620 "AbstractDirectoryView.c"
	}
#line 3927 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20624 "AbstractDirectoryView.c"
}

/** Abstract methods - must be overridden*/
static GList*
files_abstract_directory_view_real_get_selected_paths (FilesAbstractDirectoryView* self)
{
#line 3930 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_get_selected_paths'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3930 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20635 "AbstractDirectoryView.c"
}

GList*
files_abstract_directory_view_get_selected_paths (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3930 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3930 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3930 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_selected_paths) {
#line 3930 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_selected_paths (self);
#line 20650 "AbstractDirectoryView.c"
	}
#line 3930 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20654 "AbstractDirectoryView.c"
}

static GtkTreePath*
files_abstract_directory_view_real_get_path_at_pos (FilesAbstractDirectoryView* self,
                                                    gint x,
                                                    gint win)
{
#line 3931 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_get_path_at_pos'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3931 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20666 "AbstractDirectoryView.c"
}

GtkTreePath*
files_abstract_directory_view_get_path_at_pos (FilesAbstractDirectoryView* self,
                                               gint x,
                                               gint win)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3931 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3931 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3931 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_path_at_pos) {
#line 3931 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_path_at_pos (self, x, win);
#line 20683 "AbstractDirectoryView.c"
	}
#line 3931 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20687 "AbstractDirectoryView.c"
}

static GtkTreePath*
files_abstract_directory_view_real_get_path_at_cursor (FilesAbstractDirectoryView* self)
{
#line 3932 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_get_path_at_cursor'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3932 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20697 "AbstractDirectoryView.c"
}

GtkTreePath*
files_abstract_directory_view_get_path_at_cursor (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3932 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3932 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3932 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_path_at_cursor) {
#line 3932 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_path_at_cursor (self);
#line 20712 "AbstractDirectoryView.c"
	}
#line 3932 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 20716 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_tree_select_all (FilesAbstractDirectoryView* self)
{
#line 3933 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_tree_select_all'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3933 "../src/View/AbstractDirectoryView.vala"
	return;
#line 20726 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_tree_select_all (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3933 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3933 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3933 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->tree_select_all) {
#line 3933 "../src/View/AbstractDirectoryView.vala"
		_klass_->tree_select_all (self);
#line 20741 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_tree_unselect_all (FilesAbstractDirectoryView* self)
{
#line 3934 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_tree_unselect_all'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3934 "../src/View/AbstractDirectoryView.vala"
	return;
#line 20752 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_tree_unselect_all (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3934 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3934 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3934 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->tree_unselect_all) {
#line 3934 "../src/View/AbstractDirectoryView.vala"
		_klass_->tree_unselect_all (self);
#line 20767 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_tree_unselect_others (FilesAbstractDirectoryView* self)
{
}

void
files_abstract_directory_view_tree_unselect_others (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3935 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3935 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3935 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->tree_unselect_others) {
#line 3935 "../src/View/AbstractDirectoryView.vala"
		_klass_->tree_unselect_others (self);
#line 20788 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_select_path (FilesAbstractDirectoryView* self,
                                                GtkTreePath* path,
                                                gboolean cursor_follows)
{
#line 3936 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_select_path'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3936 "../src/View/AbstractDirectoryView.vala"
	return;
#line 20801 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_select_path (FilesAbstractDirectoryView* self,
                                           GtkTreePath* path,
                                           gboolean cursor_follows)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3936 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3936 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3936 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->select_path) {
#line 3936 "../src/View/AbstractDirectoryView.vala"
		_klass_->select_path (self, path, cursor_follows);
#line 20818 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_unselect_path (FilesAbstractDirectoryView* self,
                                                  GtkTreePath* path)
{
#line 3937 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_unselect_path'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3937 "../src/View/AbstractDirectoryView.vala"
	return;
#line 20830 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_unselect_path (FilesAbstractDirectoryView* self,
                                             GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3937 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3937 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3937 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->unselect_path) {
#line 3937 "../src/View/AbstractDirectoryView.vala"
		_klass_->unselect_path (self, path);
#line 20846 "AbstractDirectoryView.c"
	}
}

static gboolean
files_abstract_directory_view_real_path_is_selected (FilesAbstractDirectoryView* self,
                                                     GtkTreePath* path)
{
	gboolean _tmp0_ = FALSE;
#line 3938 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_path_is_selected'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3938 "../src/View/AbstractDirectoryView.vala"
	return _tmp0_;
#line 20859 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_path_is_selected (FilesAbstractDirectoryView* self,
                                                GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3938 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3938 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3938 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->path_is_selected) {
#line 3938 "../src/View/AbstractDirectoryView.vala"
		return _klass_->path_is_selected (self, path);
#line 20875 "AbstractDirectoryView.c"
	}
#line 3938 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 20879 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_get_visible_range (FilesAbstractDirectoryView* self,
                                                      GtkTreePath** start_path,
                                                      GtkTreePath** end_path)
{
	gboolean _tmp0_ = FALSE;
#line 3939 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_get_visible_range'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3939 "../src/View/AbstractDirectoryView.vala"
	return _tmp0_;
#line 20892 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_get_visible_range (FilesAbstractDirectoryView* self,
                                                 GtkTreePath** start_path,
                                                 GtkTreePath** end_path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3939 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3939 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3939 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_visible_range) {
#line 3939 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_visible_range (self, start_path, end_path);
#line 20909 "AbstractDirectoryView.c"
	}
#line 3939 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 20913 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_set_cursor (FilesAbstractDirectoryView* self,
                                               GtkTreePath* path,
                                               gboolean start_editing,
                                               gboolean select,
                                               gboolean scroll_to_top)
{
#line 3940 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_set_cursor'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3940 "../src/View/AbstractDirectoryView.vala"
	return;
#line 20927 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_cursor (FilesAbstractDirectoryView* self,
                                          GtkTreePath* path,
                                          gboolean start_editing,
                                          gboolean select,
                                          gboolean scroll_to_top)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3940 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3940 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3940 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->set_cursor) {
#line 3940 "../src/View/AbstractDirectoryView.vala"
		_klass_->set_cursor (self, path, start_editing, select, scroll_to_top);
#line 20946 "AbstractDirectoryView.c"
	}
}

static gboolean
files_abstract_directory_view_real_move_cursor (FilesAbstractDirectoryView* self,
                                                guint keyval,
                                                gboolean only_shift_pressed,
                                                gboolean control_pressed)
{
	gboolean result;
#line 3947 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3947 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 20961 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_move_cursor (FilesAbstractDirectoryView* self,
                                           guint keyval,
                                           gboolean only_shift_pressed,
                                           gboolean control_pressed)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3946 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3946 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3946 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->move_cursor) {
#line 3946 "../src/View/AbstractDirectoryView.vala"
		return _klass_->move_cursor (self, keyval, only_shift_pressed, control_pressed);
#line 20979 "AbstractDirectoryView.c"
	}
#line 3946 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 20983 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_will_handle_button_press (FilesAbstractDirectoryView* self,
                                                             gboolean no_mods,
                                                             gboolean only_control_pressed,
                                                             gboolean only_shift_pressed)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 3952 "../src/View/AbstractDirectoryView.vala"
	if (!no_mods) {
#line 3952 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = !only_control_pressed;
#line 20998 "AbstractDirectoryView.c"
	} else {
#line 3952 "../src/View/AbstractDirectoryView.vala"
		_tmp0_ = FALSE;
#line 21002 "AbstractDirectoryView.c"
	}
#line 3952 "../src/View/AbstractDirectoryView.vala"
	if (_tmp0_) {
#line 3953 "../src/View/AbstractDirectoryView.vala"
		result = FALSE;
#line 3953 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 21010 "AbstractDirectoryView.c"
	} else {
#line 3955 "../src/View/AbstractDirectoryView.vala"
		result = TRUE;
#line 3955 "../src/View/AbstractDirectoryView.vala"
		return result;
#line 21016 "AbstractDirectoryView.c"
	}
}

gboolean
files_abstract_directory_view_will_handle_button_press (FilesAbstractDirectoryView* self,
                                                        gboolean no_mods,
                                                        gboolean only_control_pressed,
                                                        gboolean only_shift_pressed)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3950 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3950 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3950 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->will_handle_button_press) {
#line 3950 "../src/View/AbstractDirectoryView.vala"
		return _klass_->will_handle_button_press (self, no_mods, only_control_pressed, only_shift_pressed);
#line 21035 "AbstractDirectoryView.c"
	}
#line 3950 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 21039 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_is_on_icon (FilesAbstractDirectoryView* self,
                                          gint x,
                                          gint y,
                                          gboolean* on_helper)
{
	GdkRectangle pointer_rect = {0};
	GdkRectangle _tmp0_ = {0};
	gboolean on_icon = FALSE;
	FilesIconRenderer* _tmp1_;
	GdkRectangle _tmp2_;
	FilesIconRenderer* _tmp3_;
	GdkRectangle _tmp4_;
	gboolean result;
#line 3959 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3961 "../src/View/AbstractDirectoryView.vala"
	_tmp0_.x = x - 2;
#line 3961 "../src/View/AbstractDirectoryView.vala"
	_tmp0_.y = y - 2;
#line 3961 "../src/View/AbstractDirectoryView.vala"
	_tmp0_.width = 4;
#line 3961 "../src/View/AbstractDirectoryView.vala"
	_tmp0_.height = 4;
#line 3961 "../src/View/AbstractDirectoryView.vala"
	pointer_rect = _tmp0_;
#line 3962 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = self->icon_renderer;
#line 3962 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = _tmp1_->hover_rect;
#line 3962 "../src/View/AbstractDirectoryView.vala"
	on_icon = gdk_rectangle_intersect (&pointer_rect, &_tmp2_, NULL);
#line 3963 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = self->icon_renderer;
#line 3963 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = _tmp3_->hover_helper_rect;
#line 3963 "../src/View/AbstractDirectoryView.vala"
	*on_helper = gdk_rectangle_intersect (&pointer_rect, &_tmp4_, NULL);
#line 3964 "../src/View/AbstractDirectoryView.vala"
	result = on_icon;
#line 3964 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21084 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_handle_multi_select (FilesAbstractDirectoryView* self,
                                                        GtkTreePath* path)
{
	gboolean result;
#line 3969 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 3969 "../src/View/AbstractDirectoryView.vala"
	result = FALSE;
#line 3969 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21098 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_handle_multi_select (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3969 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3969 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3969 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->handle_multi_select) {
#line 3969 "../src/View/AbstractDirectoryView.vala"
		return _klass_->handle_multi_select (self, path);
#line 21114 "AbstractDirectoryView.c"
	}
#line 3969 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 21118 "AbstractDirectoryView.c"
}

static GtkWidget*
files_abstract_directory_view_real_create_view (FilesAbstractDirectoryView* self)
{
#line 3971 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_create_view'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3971 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 21128 "AbstractDirectoryView.c"
}

GtkWidget*
files_abstract_directory_view_create_view (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3971 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3971 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3971 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->create_view) {
#line 3971 "../src/View/AbstractDirectoryView.vala"
		return _klass_->create_view (self);
#line 21143 "AbstractDirectoryView.c"
	}
#line 3971 "../src/View/AbstractDirectoryView.vala"
	return NULL;
#line 21147 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_set_up_zoom_level (FilesAbstractDirectoryView* self)
{
#line 3972 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_set_up_zoom_level'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3972 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21157 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_up_zoom_level (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3972 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3972 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3972 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->set_up_zoom_level) {
#line 3972 "../src/View/AbstractDirectoryView.vala"
		_klass_->set_up_zoom_level (self);
#line 21172 "AbstractDirectoryView.c"
	}
}

static FilesZoomLevel
files_abstract_directory_view_real_get_normal_zoom_level (FilesAbstractDirectoryView* self)
{
#line 3973 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_get_normal_zoom_level'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3973 "../src/View/AbstractDirectoryView.vala"
	return 0;
#line 21183 "AbstractDirectoryView.c"
}

FilesZoomLevel
files_abstract_directory_view_get_normal_zoom_level (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3973 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 3973 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3973 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_normal_zoom_level) {
#line 3973 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_normal_zoom_level (self);
#line 21198 "AbstractDirectoryView.c"
	}
#line 3973 "../src/View/AbstractDirectoryView.vala"
	return 0;
#line 21202 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_real_view_has_focus (FilesAbstractDirectoryView* self)
{
	gboolean _tmp0_ = FALSE;
#line 3974 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_view_has_focus'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3974 "../src/View/AbstractDirectoryView.vala"
	return _tmp0_;
#line 21213 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_view_has_focus (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3974 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 3974 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3974 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->view_has_focus) {
#line 3974 "../src/View/AbstractDirectoryView.vala"
		return _klass_->view_has_focus (self);
#line 21228 "AbstractDirectoryView.c"
	}
#line 3974 "../src/View/AbstractDirectoryView.vala"
	return FALSE;
#line 21232 "AbstractDirectoryView.c"
}

static guint
files_abstract_directory_view_real_get_selected_files_from_model (FilesAbstractDirectoryView* self,
                                                                  GList** selected_files)
{
	guint _tmp0_ = 0U;
#line 3975 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_get_selected_files_from_model'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3975 "../src/View/AbstractDirectoryView.vala"
	return _tmp0_;
#line 21244 "AbstractDirectoryView.c"
}

guint
files_abstract_directory_view_get_selected_files_from_model (FilesAbstractDirectoryView* self,
                                                             GList** selected_files)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3975 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 3975 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3975 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_selected_files_from_model) {
#line 3975 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_selected_files_from_model (self, selected_files);
#line 21260 "AbstractDirectoryView.c"
	}
#line 3975 "../src/View/AbstractDirectoryView.vala"
	return 0U;
#line 21264 "AbstractDirectoryView.c"
}

static guint
files_abstract_directory_view_real_get_event_position_info (FilesAbstractDirectoryView* self,
                                                            GdkEventButton* event,
                                                            GtkTreePath** path,
                                                            gboolean rubberband)
{
	guint _tmp0_ = 0U;
#line 3976 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_get_event_position_info'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3976 "../src/View/AbstractDirectoryView.vala"
	return _tmp0_;
#line 21278 "AbstractDirectoryView.c"
}

guint
files_abstract_directory_view_get_event_position_info (FilesAbstractDirectoryView* self,
                                                       GdkEventButton* event,
                                                       GtkTreePath** path,
                                                       gboolean rubberband)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3976 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 3976 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3976 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->get_event_position_info) {
#line 3976 "../src/View/AbstractDirectoryView.vala"
		return _klass_->get_event_position_info (self, event, path, rubberband);
#line 21296 "AbstractDirectoryView.c"
	}
#line 3976 "../src/View/AbstractDirectoryView.vala"
	return 0U;
#line 21300 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_real_scroll_to_cell (FilesAbstractDirectoryView* self,
                                                   GtkTreePath* path,
                                                   gboolean scroll_to_top)
{
#line 3980 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_scroll_to_cell'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3980 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21312 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_scroll_to_cell (FilesAbstractDirectoryView* self,
                                              GtkTreePath* path,
                                              gboolean scroll_to_top)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3980 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3980 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3980 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->scroll_to_cell) {
#line 3980 "../src/View/AbstractDirectoryView.vala"
		_klass_->scroll_to_cell (self, path, scroll_to_top);
#line 21329 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_set_cursor_on_cell (FilesAbstractDirectoryView* self,
                                                       GtkTreePath* path,
                                                       GtkCellRenderer* renderer,
                                                       gboolean start_editing,
                                                       gboolean scroll_to_top)
{
#line 3982 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_set_cursor_on_cell'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3982 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21344 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_cursor_on_cell (FilesAbstractDirectoryView* self,
                                                  GtkTreePath* path,
                                                  GtkCellRenderer* renderer,
                                                  gboolean start_editing,
                                                  gboolean scroll_to_top)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3982 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3982 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3982 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->set_cursor_on_cell) {
#line 3982 "../src/View/AbstractDirectoryView.vala"
		_klass_->set_cursor_on_cell (self, path, renderer, start_editing, scroll_to_top);
#line 21363 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_freeze_tree (FilesAbstractDirectoryView* self)
{
#line 3986 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_freeze_tree'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3986 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21374 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_freeze_tree (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3986 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3986 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3986 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->freeze_tree) {
#line 3986 "../src/View/AbstractDirectoryView.vala"
		_klass_->freeze_tree (self);
#line 21389 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_thaw_tree (FilesAbstractDirectoryView* self)
{
#line 3987 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_thaw_tree'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3987 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21400 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_thaw_tree (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3987 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3987 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3987 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->thaw_tree) {
#line 3987 "../src/View/AbstractDirectoryView.vala"
		_klass_->thaw_tree (self);
#line 21415 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_freeze_child_notify (FilesAbstractDirectoryView* self)
{
#line 3988 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_freeze_child_notify'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3988 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21426 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_freeze_child_notify (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3988 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3988 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3988 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->freeze_child_notify) {
#line 3988 "../src/View/AbstractDirectoryView.vala"
		_klass_->freeze_child_notify (self);
#line 21441 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_thaw_child_notify (FilesAbstractDirectoryView* self)
{
#line 3989 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_thaw_child_notify'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3989 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21452 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_thaw_child_notify (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3989 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3989 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3989 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->thaw_child_notify) {
#line 3989 "../src/View/AbstractDirectoryView.vala"
		_klass_->thaw_child_notify (self);
#line 21467 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_connect_tree_signals (FilesAbstractDirectoryView* self)
{
#line 3990 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_connect_tree_signals'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3990 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21478 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_connect_tree_signals (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3990 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3990 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3990 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->connect_tree_signals) {
#line 3990 "../src/View/AbstractDirectoryView.vala"
		_klass_->connect_tree_signals (self);
#line 21493 "AbstractDirectoryView.c"
	}
}

static void
files_abstract_directory_view_real_disconnect_tree_signals (FilesAbstractDirectoryView* self)
{
#line 3991 "../src/View/AbstractDirectoryView.vala"
	g_critical ("Type `%s' does not implement abstract method `files_abstract_directory_view_disconnect_tree_signals'", g_type_name (G_TYPE_FROM_INSTANCE (self)));
#line 3991 "../src/View/AbstractDirectoryView.vala"
	return;
#line 21504 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_disconnect_tree_signals (FilesAbstractDirectoryView* self)
{
	FilesAbstractDirectoryViewClass* _klass_;
#line 3991 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 3991 "../src/View/AbstractDirectoryView.vala"
	_klass_ = FILES_ABSTRACT_DIRECTORY_VIEW_GET_CLASS (self);
#line 3991 "../src/View/AbstractDirectoryView.vala"
	if (_klass_->disconnect_tree_signals) {
#line 3991 "../src/View/AbstractDirectoryView.vala"
		_klass_->disconnect_tree_signals (self);
#line 21519 "AbstractDirectoryView.c"
	}
}

FilesZoomLevel
files_abstract_directory_view_get_zoom_level (FilesAbstractDirectoryView* self)
{
	FilesZoomLevel result;
#line 101 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 102 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_zoom_level;
#line 102 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21533 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_zoom_level (FilesAbstractDirectoryView* self,
                                              FilesZoomLevel value)
{
#line 105 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/View/AbstractDirectoryView.vala"
	if (value > self->maximum_zoom) {
#line 107 "../src/View/AbstractDirectoryView.vala"
		self->priv->_zoom_level = self->maximum_zoom;
#line 21546 "AbstractDirectoryView.c"
	} else {
#line 108 "../src/View/AbstractDirectoryView.vala"
		if (value < self->minimum_zoom) {
#line 109 "../src/View/AbstractDirectoryView.vala"
			self->priv->_zoom_level = self->minimum_zoom;
#line 21552 "AbstractDirectoryView.c"
		} else {
#line 111 "../src/View/AbstractDirectoryView.vala"
			self->priv->_zoom_level = value;
#line 21556 "AbstractDirectoryView.c"
		}
	}
#line 114 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_on_zoom_level_changed (self, value);
#line 105 "../src/View/AbstractDirectoryView.vala"
	g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY]);
#line 21563 "AbstractDirectoryView.c"
}

gint
files_abstract_directory_view_get_icon_size (FilesAbstractDirectoryView* self)
{
	gint result;
#line 119 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 120 "../src/View/AbstractDirectoryView.vala"
	result = (gint) files_zoom_level_to_icon_size (self->priv->_zoom_level);
#line 120 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21576 "AbstractDirectoryView.c"
}

static gboolean
files_abstract_directory_view_get_drop_highlight (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 147 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 148 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_drop_highlight;
#line 148 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21589 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_drop_highlight (FilesAbstractDirectoryView* self,
                                                  gboolean value)
{
#line 151 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 152 "../src/View/AbstractDirectoryView.vala"
	if (value != self->priv->_drop_highlight) {
#line 153 "../src/View/AbstractDirectoryView.vala"
		if (value) {
#line 154 "../src/View/AbstractDirectoryView.vala"
			gtk_drag_highlight ((GtkWidget*) self);
#line 21604 "AbstractDirectoryView.c"
		} else {
#line 156 "../src/View/AbstractDirectoryView.vala"
			gtk_drag_unhighlight ((GtkWidget*) self);
#line 21608 "AbstractDirectoryView.c"
		}
	}
#line 160 "../src/View/AbstractDirectoryView.vala"
	self->priv->_drop_highlight = value;
#line 21613 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_get_singleclick_select (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 196 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 196 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_singleclick_select;
#line 196 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21626 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_singleclick_select (FilesAbstractDirectoryView* self,
                                                      gboolean value)
{
	gboolean old_value;
#line 196 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 196 "../src/View/AbstractDirectoryView.vala"
	old_value = files_abstract_directory_view_get_singleclick_select (self);
#line 196 "../src/View/AbstractDirectoryView.vala"
	if (old_value != value) {
#line 196 "../src/View/AbstractDirectoryView.vala"
		self->priv->_singleclick_select = value;
#line 196 "../src/View/AbstractDirectoryView.vala"
		g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_SINGLECLICK_SELECT_PROPERTY]);
#line 21644 "AbstractDirectoryView.c"
	}
}

gboolean
files_abstract_directory_view_get_renaming (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 220 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 220 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_renaming;
#line 220 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21658 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_renaming (FilesAbstractDirectoryView* self,
                                            gboolean value)
{
	gboolean old_value;
#line 220 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 220 "../src/View/AbstractDirectoryView.vala"
	old_value = files_abstract_directory_view_get_renaming (self);
#line 220 "../src/View/AbstractDirectoryView.vala"
	if (old_value != value) {
#line 220 "../src/View/AbstractDirectoryView.vala"
		self->priv->_renaming = value;
#line 220 "../src/View/AbstractDirectoryView.vala"
		g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY]);
#line 21676 "AbstractDirectoryView.c"
	}
}

gboolean
files_abstract_directory_view_get_is_frozen (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 249 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 250 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_is_frozen;
#line 250 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21690 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_is_frozen (FilesAbstractDirectoryView* self,
                                             gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 224 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 225 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_abstract_directory_view_get_is_frozen (self);
#line 225 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = _tmp0_;
#line 225 "../src/View/AbstractDirectoryView.vala"
	if (_tmp1_ != value) {
#line 226 "../src/View/AbstractDirectoryView.vala"
		self->priv->_is_frozen = value;
#line 227 "../src/View/AbstractDirectoryView.vala"
		if (value) {
#line 21711 "AbstractDirectoryView.c"
			GSimpleActionGroup* _tmp2_;
			GSimpleActionGroup* _tmp3_;
			GSimpleActionGroup* _tmp4_;
			GSimpleActionGroup* _tmp5_;
			FilesClipboardManager* _tmp6_;
			guint _tmp7_;
			GtkWidget* _tmp8_;
			guint _tmp9_;
#line 228 "../src/View/AbstractDirectoryView.vala"
			_tmp2_ = self->priv->selection_actions;
#line 228 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_action_set_enabled (self, _tmp2_, "cut", FALSE);
#line 229 "../src/View/AbstractDirectoryView.vala"
			_tmp3_ = self->priv->common_actions;
#line 229 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_action_set_enabled (self, _tmp3_, "copy", FALSE);
#line 230 "../src/View/AbstractDirectoryView.vala"
			_tmp4_ = self->priv->common_actions;
#line 230 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_action_set_enabled (self, _tmp4_, "paste-into", FALSE);
#line 231 "../src/View/AbstractDirectoryView.vala"
			_tmp5_ = self->priv->common_actions;
#line 231 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_action_set_enabled (self, _tmp5_, "paste", FALSE);
#line 236 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_disconnect_tree_signals (self);
#line 237 "../src/View/AbstractDirectoryView.vala"
			_tmp6_ = self->priv->clipboard;
#line 237 "../src/View/AbstractDirectoryView.vala"
			g_signal_parse_name ("changed", FILES_TYPE_CLIPBOARD_MANAGER, &_tmp7_, NULL, FALSE);
#line 237 "../src/View/AbstractDirectoryView.vala"
			g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _files_abstract_directory_view_on_clipboard_changed_files_clipboard_manager_changed, self);
#line 238 "../src/View/AbstractDirectoryView.vala"
			_tmp8_ = self->priv->view;
#line 238 "../src/View/AbstractDirectoryView.vala"
			g_signal_parse_name ("key-press-event", gtk_widget_get_type (), &_tmp9_, NULL, FALSE);
#line 238 "../src/View/AbstractDirectoryView.vala"
			g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _files_abstract_directory_view_on_view_key_press_event_gtk_widget_key_press_event, self);
#line 21750 "AbstractDirectoryView.c"
		} else {
			GtkWidget* _tmp10_;
			FilesClipboardManager* _tmp11_;
#line 240 "../src/View/AbstractDirectoryView.vala"
			_tmp10_ = self->priv->view;
#line 240 "../src/View/AbstractDirectoryView.vala"
			g_signal_connect_object (_tmp10_, "key-press-event", (GCallback) _files_abstract_directory_view_on_view_key_press_event_gtk_widget_key_press_event, self, 0);
#line 241 "../src/View/AbstractDirectoryView.vala"
			_tmp11_ = self->priv->clipboard;
#line 241 "../src/View/AbstractDirectoryView.vala"
			g_signal_connect_object (_tmp11_, "changed", (GCallback) _files_abstract_directory_view_on_clipboard_changed_files_clipboard_manager_changed, self, 0);
#line 242 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_connect_tree_signals (self);
#line 244 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_update_menu_actions (self);
#line 21766 "AbstractDirectoryView.c"
		}
	}
#line 224 "../src/View/AbstractDirectoryView.vala"
	g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY]);
#line 21771 "AbstractDirectoryView.c"
}

gboolean
files_abstract_directory_view_get_in_recent (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 254 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 254 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_in_recent;
#line 254 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21784 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_set_in_recent (FilesAbstractDirectoryView* self,
                                             gboolean value)
{
	gboolean old_value;
#line 254 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 254 "../src/View/AbstractDirectoryView.vala"
	old_value = files_abstract_directory_view_get_in_recent (self);
#line 254 "../src/View/AbstractDirectoryView.vala"
	if (old_value != value) {
#line 254 "../src/View/AbstractDirectoryView.vala"
		self->priv->_in_recent = value;
#line 254 "../src/View/AbstractDirectoryView.vala"
		g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY]);
#line 21802 "AbstractDirectoryView.c"
	}
}

gboolean
files_abstract_directory_view_get_tree_frozen (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 256 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 256 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_tree_frozen;
#line 256 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21816 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_tree_frozen (FilesAbstractDirectoryView* self,
                                               gboolean value)
{
	gboolean old_value;
#line 256 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 256 "../src/View/AbstractDirectoryView.vala"
	old_value = files_abstract_directory_view_get_tree_frozen (self);
#line 256 "../src/View/AbstractDirectoryView.vala"
	if (old_value != value) {
#line 256 "../src/View/AbstractDirectoryView.vala"
		self->priv->_tree_frozen = value;
#line 256 "../src/View/AbstractDirectoryView.vala"
		g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY]);
#line 21834 "AbstractDirectoryView.c"
	}
}

gboolean
files_abstract_directory_view_get_show_remote_thumbnails (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 262 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 262 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_show_remote_thumbnails;
#line 262 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21848 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_show_remote_thumbnails (FilesAbstractDirectoryView* self,
                                                          gboolean value)
{
	gboolean old_value;
#line 262 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 262 "../src/View/AbstractDirectoryView.vala"
	old_value = files_abstract_directory_view_get_show_remote_thumbnails (self);
#line 262 "../src/View/AbstractDirectoryView.vala"
	if (old_value != value) {
#line 262 "../src/View/AbstractDirectoryView.vala"
		self->priv->_show_remote_thumbnails = value;
#line 262 "../src/View/AbstractDirectoryView.vala"
		g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_SHOW_REMOTE_THUMBNAILS_PROPERTY]);
#line 21866 "AbstractDirectoryView.c"
	}
}

gboolean
files_abstract_directory_view_get_show_local_thumbnails (FilesAbstractDirectoryView* self)
{
	gboolean result;
#line 263 "../src/View/AbstractDirectoryView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 263 "../src/View/AbstractDirectoryView.vala"
	result = self->priv->_show_local_thumbnails;
#line 263 "../src/View/AbstractDirectoryView.vala"
	return result;
#line 21880 "AbstractDirectoryView.c"
}

void
files_abstract_directory_view_set_show_local_thumbnails (FilesAbstractDirectoryView* self,
                                                         gboolean value)
{
	gboolean old_value;
#line 263 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (self != NULL);
#line 263 "../src/View/AbstractDirectoryView.vala"
	old_value = files_abstract_directory_view_get_show_local_thumbnails (self);
#line 263 "../src/View/AbstractDirectoryView.vala"
	if (old_value != value) {
#line 263 "../src/View/AbstractDirectoryView.vala"
		self->priv->_show_local_thumbnails = value;
#line 263 "../src/View/AbstractDirectoryView.vala"
		g_object_notify_by_pspec ((GObject *) self, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_SHOW_LOCAL_THUMBNAILS_PROPERTY]);
#line 21898 "AbstractDirectoryView.c"
	}
}

static void
g_cclosure_user_marshal_VOID__OBJECT_ENUM_BOOLEAN (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_ENUM_BOOLEAN) (gpointer data1, gpointer arg_1, gint arg_2, gboolean arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_ENUM_BOOLEAN callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_return_if_fail (n_param_values == 4);
#line 29 "../src/View/AbstractDirectoryView.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 29 "../src/View/AbstractDirectoryView.vala"
		data1 = closure->data;
#line 29 "../src/View/AbstractDirectoryView.vala"
		data2 = param_values->data[0].v_pointer;
#line 21924 "AbstractDirectoryView.c"
	} else {
#line 29 "../src/View/AbstractDirectoryView.vala"
		data1 = param_values->data[0].v_pointer;
#line 29 "../src/View/AbstractDirectoryView.vala"
		data2 = closure->data;
#line 21930 "AbstractDirectoryView.c"
	}
#line 29 "../src/View/AbstractDirectoryView.vala"
	callback = (GMarshalFunc_VOID__OBJECT_ENUM_BOOLEAN) (marshal_data ? marshal_data : cc->callback);
#line 29 "../src/View/AbstractDirectoryView.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_enum (param_values + 2), g_value_get_boolean (param_values + 3), data2);
#line 21936 "AbstractDirectoryView.c"
}

static FilesAbstractDirectoryViewSortSubMenuItem*
files_abstract_directory_view_sort_sub_menu_item_construct (GType object_type)
{
	FilesAbstractDirectoryViewSortSubMenuItem * self = NULL;
#line 2355 "../src/View/AbstractDirectoryView.vala"
	self = (FilesAbstractDirectoryViewSortSubMenuItem*) g_object_new (object_type, NULL);
#line 2355 "../src/View/AbstractDirectoryView.vala"
	return self;
#line 21947 "AbstractDirectoryView.c"
}

static FilesAbstractDirectoryViewSortSubMenuItem*
files_abstract_directory_view_sort_sub_menu_item_new (void)
{
#line 2355 "../src/View/AbstractDirectoryView.vala"
	return files_abstract_directory_view_sort_sub_menu_item_construct (FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM);
#line 21955 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new9 (const gchar* value)
{
#line 2359 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 21963 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new10 (const gchar* value)
{
#line 2364 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 21971 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new11 (const gchar* value)
{
#line 2369 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 21979 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new12 (const gchar* value)
{
#line 2374 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 21987 "AbstractDirectoryView.c"
}

static GObject *
files_abstract_directory_view_sort_sub_menu_item_constructor (GType type,
                                                              guint n_construct_properties,
                                                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FilesAbstractDirectoryViewSortSubMenuItem * self;
	GtkCheckMenuItem* name_radioitem = NULL;
	GtkCheckMenuItem* _tmp0_;
	GtkCheckMenuItem* _tmp1_;
	GtkCheckMenuItem* _tmp2_;
	GVariant* _tmp3_;
	GtkCheckMenuItem* _tmp4_;
	GtkCheckMenuItem* size_radioitem = NULL;
	GtkCheckMenuItem* _tmp5_;
	GtkCheckMenuItem* _tmp6_;
	GtkCheckMenuItem* _tmp7_;
	GVariant* _tmp8_;
	GtkCheckMenuItem* _tmp9_;
	GtkCheckMenuItem* type_radioitem = NULL;
	GtkCheckMenuItem* _tmp10_;
	GtkCheckMenuItem* _tmp11_;
	GtkCheckMenuItem* _tmp12_;
	GVariant* _tmp13_;
	GtkCheckMenuItem* _tmp14_;
	GtkCheckMenuItem* date_radioitem = NULL;
	GtkCheckMenuItem* _tmp15_;
	GtkCheckMenuItem* _tmp16_;
	GtkCheckMenuItem* _tmp17_;
	GVariant* _tmp18_;
	GtkCheckMenuItem* _tmp19_;
	GtkCheckMenuItem* reversed_checkitem = NULL;
	GtkCheckMenuItem* _tmp20_;
	GtkCheckMenuItem* _tmp21_;
	GtkCheckMenuItem* folders_first_checkitem = NULL;
	GtkCheckMenuItem* _tmp22_;
	GtkCheckMenuItem* _tmp23_;
	GtkMenu* _tmp24_;
	GtkMenu* _tmp25_;
	GtkMenu* _tmp26_;
	GtkMenu* _tmp27_;
	GtkCheckMenuItem* _tmp28_;
	GtkMenu* _tmp29_;
	GtkMenu* _tmp30_;
	GtkCheckMenuItem* _tmp31_;
	GtkMenu* _tmp32_;
	GtkMenu* _tmp33_;
	GtkCheckMenuItem* _tmp34_;
	GtkMenu* _tmp35_;
	GtkMenu* _tmp36_;
	GtkCheckMenuItem* _tmp37_;
	GtkMenu* _tmp38_;
	GtkMenu* _tmp39_;
	GtkSeparatorMenuItem* _tmp40_;
	GtkSeparatorMenuItem* _tmp41_;
	GtkMenu* _tmp42_;
	GtkMenu* _tmp43_;
	GtkCheckMenuItem* _tmp44_;
	GtkMenu* _tmp45_;
	GtkMenu* _tmp46_;
	GtkCheckMenuItem* _tmp47_;
#line 2356 "../src/View/AbstractDirectoryView.vala"
	parent_class = G_OBJECT_CLASS (files_abstract_directory_view_sort_sub_menu_item_parent_class);
#line 2356 "../src/View/AbstractDirectoryView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 2356 "../src/View/AbstractDirectoryView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_SORT_SUB_MENU_ITEM, FilesAbstractDirectoryViewSortSubMenuItem);
#line 2357 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Name"));
#line 2357 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp0_);
#line 2357 "../src/View/AbstractDirectoryView.vala"
	name_radioitem = _tmp0_;
#line 2358 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = name_radioitem;
#line 2358 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp1_, "background.sort-by");
#line 2359 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = name_radioitem;
#line 2359 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _variant_new9 ("name");
#line 2359 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkActionable*) _tmp2_, "action-target", _tmp3_, NULL);
#line 2359 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp3_);
#line 2360 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = name_radioitem;
#line 2360 "../src/View/AbstractDirectoryView.vala"
	gtk_check_menu_item_set_draw_as_radio (_tmp4_, TRUE);
#line 2362 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Size"));
#line 2362 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp5_);
#line 2362 "../src/View/AbstractDirectoryView.vala"
	size_radioitem = _tmp5_;
#line 2363 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = size_radioitem;
#line 2363 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp6_, "background.sort-by");
#line 2364 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = size_radioitem;
#line 2364 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = _variant_new10 ("size");
#line 2364 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkActionable*) _tmp7_, "action-target", _tmp8_, NULL);
#line 2364 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp8_);
#line 2365 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = size_radioitem;
#line 2365 "../src/View/AbstractDirectoryView.vala"
	gtk_check_menu_item_set_draw_as_radio (_tmp9_, TRUE);
#line 2367 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Type"));
#line 2367 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp10_);
#line 2367 "../src/View/AbstractDirectoryView.vala"
	type_radioitem = _tmp10_;
#line 2368 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = type_radioitem;
#line 2368 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp11_, "background.sort-by");
#line 2369 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = type_radioitem;
#line 2369 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = _variant_new11 ("type");
#line 2369 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkActionable*) _tmp12_, "action-target", _tmp13_, NULL);
#line 2369 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp13_);
#line 2370 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = type_radioitem;
#line 2370 "../src/View/AbstractDirectoryView.vala"
	gtk_check_menu_item_set_draw_as_radio (_tmp14_, TRUE);
#line 2372 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Date"));
#line 2372 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp15_);
#line 2372 "../src/View/AbstractDirectoryView.vala"
	date_radioitem = _tmp15_;
#line 2373 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = date_radioitem;
#line 2373 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp16_, "background.sort-by");
#line 2374 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = date_radioitem;
#line 2374 "../src/View/AbstractDirectoryView.vala"
	_tmp18_ = _variant_new12 ("modified");
#line 2374 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkActionable*) _tmp17_, "action-target", _tmp18_, NULL);
#line 2374 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp18_);
#line 2375 "../src/View/AbstractDirectoryView.vala"
	_tmp19_ = date_radioitem;
#line 2375 "../src/View/AbstractDirectoryView.vala"
	gtk_check_menu_item_set_draw_as_radio (_tmp19_, TRUE);
#line 2377 "../src/View/AbstractDirectoryView.vala"
	_tmp20_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Reversed Order"));
#line 2377 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp20_);
#line 2377 "../src/View/AbstractDirectoryView.vala"
	reversed_checkitem = _tmp20_;
#line 2378 "../src/View/AbstractDirectoryView.vala"
	_tmp21_ = reversed_checkitem;
#line 2378 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp21_, "background.reverse");
#line 2380 "../src/View/AbstractDirectoryView.vala"
	_tmp22_ = (GtkCheckMenuItem*) gtk_check_menu_item_new_with_label (_ ("Folders Before Files"));
#line 2380 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp22_);
#line 2380 "../src/View/AbstractDirectoryView.vala"
	folders_first_checkitem = _tmp22_;
#line 2381 "../src/View/AbstractDirectoryView.vala"
	_tmp23_ = folders_first_checkitem;
#line 2381 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp23_, "background.folders-first");
#line 2383 "../src/View/AbstractDirectoryView.vala"
	_tmp24_ = (GtkMenu*) gtk_menu_new ();
#line 2383 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp24_);
#line 2383 "../src/View/AbstractDirectoryView.vala"
	_tmp25_ = _tmp24_;
#line 2383 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_item_set_submenu ((GtkMenuItem*) self, _tmp25_);
#line 2383 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp25_);
#line 2384 "../src/View/AbstractDirectoryView.vala"
	_tmp26_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2384 "../src/View/AbstractDirectoryView.vala"
	_tmp27_ = _tmp26_;
#line 2384 "../src/View/AbstractDirectoryView.vala"
	_tmp28_ = name_radioitem;
#line 2384 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
#line 2385 "../src/View/AbstractDirectoryView.vala"
	_tmp29_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2385 "../src/View/AbstractDirectoryView.vala"
	_tmp30_ = _tmp29_;
#line 2385 "../src/View/AbstractDirectoryView.vala"
	_tmp31_ = size_radioitem;
#line 2385 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
#line 2386 "../src/View/AbstractDirectoryView.vala"
	_tmp32_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2386 "../src/View/AbstractDirectoryView.vala"
	_tmp33_ = _tmp32_;
#line 2386 "../src/View/AbstractDirectoryView.vala"
	_tmp34_ = type_radioitem;
#line 2386 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp33_, (GtkWidget*) _tmp34_);
#line 2387 "../src/View/AbstractDirectoryView.vala"
	_tmp35_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2387 "../src/View/AbstractDirectoryView.vala"
	_tmp36_ = _tmp35_;
#line 2387 "../src/View/AbstractDirectoryView.vala"
	_tmp37_ = date_radioitem;
#line 2387 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp36_, (GtkWidget*) _tmp37_);
#line 2388 "../src/View/AbstractDirectoryView.vala"
	_tmp38_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2388 "../src/View/AbstractDirectoryView.vala"
	_tmp39_ = _tmp38_;
#line 2388 "../src/View/AbstractDirectoryView.vala"
	_tmp40_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2388 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp40_);
#line 2388 "../src/View/AbstractDirectoryView.vala"
	_tmp41_ = _tmp40_;
#line 2388 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp39_, (GtkWidget*) _tmp41_);
#line 2388 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp41_);
#line 2389 "../src/View/AbstractDirectoryView.vala"
	_tmp42_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2389 "../src/View/AbstractDirectoryView.vala"
	_tmp43_ = _tmp42_;
#line 2389 "../src/View/AbstractDirectoryView.vala"
	_tmp44_ = reversed_checkitem;
#line 2389 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp43_, (GtkWidget*) _tmp44_);
#line 2390 "../src/View/AbstractDirectoryView.vala"
	_tmp45_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2390 "../src/View/AbstractDirectoryView.vala"
	_tmp46_ = _tmp45_;
#line 2390 "../src/View/AbstractDirectoryView.vala"
	_tmp47_ = folders_first_checkitem;
#line 2390 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp46_, (GtkWidget*) _tmp47_);
#line 2392 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_item_set_label ((GtkMenuItem*) self, _ ("Sort by"));
#line 2356 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (folders_first_checkitem);
#line 2356 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (reversed_checkitem);
#line 2356 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (date_radioitem);
#line 2356 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (type_radioitem);
#line 2356 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (size_radioitem);
#line 2356 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (name_radioitem);
#line 2356 "../src/View/AbstractDirectoryView.vala"
	return obj;
#line 22254 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_sort_sub_menu_item_class_init (FilesAbstractDirectoryViewSortSubMenuItemClass * klass,
                                                             gpointer klass_data)
{
#line 2355 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_sort_sub_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 2355 "../src/View/AbstractDirectoryView.vala"
	G_OBJECT_CLASS (klass)->constructor = files_abstract_directory_view_sort_sub_menu_item_constructor;
#line 22265 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_sort_sub_menu_item_instance_init (FilesAbstractDirectoryViewSortSubMenuItem * self,
                                                                gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
files_abstract_directory_view_sort_sub_menu_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesAbstractDirectoryViewSortSubMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) files_abstract_directory_view_sort_sub_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesAbstractDirectoryViewSortSubMenuItem), 0, (GInstanceInitFunc) files_abstract_directory_view_sort_sub_menu_item_instance_init, NULL };
	GType files_abstract_directory_view_sort_sub_menu_item_type_id;
	files_abstract_directory_view_sort_sub_menu_item_type_id = g_type_register_static (gtk_menu_item_get_type (), "FilesAbstractDirectoryViewSortSubMenuItem", &g_define_type_info, 0);
	return files_abstract_directory_view_sort_sub_menu_item_type_id;
}

static GType
files_abstract_directory_view_sort_sub_menu_item_get_type (void)
{
	static volatile gsize files_abstract_directory_view_sort_sub_menu_item_type_id__once = 0;
	if (g_once_init_enter (&files_abstract_directory_view_sort_sub_menu_item_type_id__once)) {
		GType files_abstract_directory_view_sort_sub_menu_item_type_id;
		files_abstract_directory_view_sort_sub_menu_item_type_id = files_abstract_directory_view_sort_sub_menu_item_get_type_once ();
		g_once_init_leave (&files_abstract_directory_view_sort_sub_menu_item_type_id__once, files_abstract_directory_view_sort_sub_menu_item_type_id);
	}
	return files_abstract_directory_view_sort_sub_menu_item_type_id__once;
}

static FilesAbstractDirectoryViewNewSubMenuItem*
files_abstract_directory_view_new_sub_menu_item_construct (GType object_type)
{
	FilesAbstractDirectoryViewNewSubMenuItem * self = NULL;
#line 2396 "../src/View/AbstractDirectoryView.vala"
	self = (FilesAbstractDirectoryViewNewSubMenuItem*) g_object_new (object_type, NULL);
#line 2396 "../src/View/AbstractDirectoryView.vala"
	return self;
#line 22303 "AbstractDirectoryView.c"
}

static FilesAbstractDirectoryViewNewSubMenuItem*
files_abstract_directory_view_new_sub_menu_item_new (void)
{
#line 2396 "../src/View/AbstractDirectoryView.vala"
	return files_abstract_directory_view_new_sub_menu_item_construct (FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM);
#line 22311 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new13 (const gchar* value)
{
#line 2404 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 22319 "AbstractDirectoryView.c"
}

static GVariant*
_variant_new14 (const gchar* value)
{
#line 2408 "../src/View/AbstractDirectoryView.vala"
	return g_variant_ref_sink (g_variant_new_string (value));
#line 22327 "AbstractDirectoryView.c"
}

static GObject *
files_abstract_directory_view_new_sub_menu_item_constructor (GType type,
                                                             guint n_construct_properties,
                                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FilesAbstractDirectoryViewNewSubMenuItem * self;
	GtkMenuItem* folder_menuitem = NULL;
	GtkMenuItem* _tmp0_;
	GtkMenuItem* _tmp1_;
	GraniteAccelLabel* _tmp2_;
	GraniteAccelLabel* _tmp3_;
	GtkMenuItem* _tmp4_;
	GtkMenuItem* _tmp5_;
	GVariant* _tmp6_;
	GtkMenuItem* file_menuitem = NULL;
	GtkMenuItem* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	GVariant* _tmp10_;
	GtkMenu* _tmp11_;
	GtkMenu* _tmp12_;
	GtkMenu* _tmp13_;
	GtkMenu* _tmp14_;
	GtkMenuItem* _tmp15_;
	GtkMenu* _tmp16_;
	GtkMenu* _tmp17_;
	GtkMenuItem* _tmp18_;
	const gchar* template_path = NULL;
	const gchar* _tmp19_;
	const gchar* _tmp20_;
#line 2397 "../src/View/AbstractDirectoryView.vala"
	parent_class = G_OBJECT_CLASS (files_abstract_directory_view_new_sub_menu_item_parent_class);
#line 2397 "../src/View/AbstractDirectoryView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 2397 "../src/View/AbstractDirectoryView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_ABSTRACT_DIRECTORY_VIEW_TYPE_NEW_SUB_MENU_ITEM, FilesAbstractDirectoryViewNewSubMenuItem);
#line 2398 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = (GtkMenuItem*) gtk_menu_item_new ();
#line 2398 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp0_);
#line 2398 "../src/View/AbstractDirectoryView.vala"
	folder_menuitem = _tmp0_;
#line 2399 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = folder_menuitem;
#line 2399 "../src/View/AbstractDirectoryView.vala"
	_tmp2_ = granite_accel_label_new (_ ("Folder"), "<Ctrl><Shift>n");
#line 2399 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp2_);
#line 2399 "../src/View/AbstractDirectoryView.vala"
	_tmp3_ = _tmp2_;
#line 2399 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp1_, (GtkWidget*) _tmp3_);
#line 2399 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp3_);
#line 2403 "../src/View/AbstractDirectoryView.vala"
	_tmp4_ = folder_menuitem;
#line 2403 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp4_, "background.new");
#line 2404 "../src/View/AbstractDirectoryView.vala"
	_tmp5_ = folder_menuitem;
#line 2404 "../src/View/AbstractDirectoryView.vala"
	_tmp6_ = _variant_new13 ("FOLDER");
#line 2404 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkActionable*) _tmp5_, "action-target", _tmp6_, NULL);
#line 2404 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp6_);
#line 2406 "../src/View/AbstractDirectoryView.vala"
	_tmp7_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Empty File"));
#line 2406 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp7_);
#line 2406 "../src/View/AbstractDirectoryView.vala"
	file_menuitem = _tmp7_;
#line 2407 "../src/View/AbstractDirectoryView.vala"
	_tmp8_ = file_menuitem;
#line 2407 "../src/View/AbstractDirectoryView.vala"
	gtk_actionable_set_action_name ((GtkActionable*) _tmp8_, "background.new");
#line 2408 "../src/View/AbstractDirectoryView.vala"
	_tmp9_ = file_menuitem;
#line 2408 "../src/View/AbstractDirectoryView.vala"
	_tmp10_ = _variant_new14 ("FILE");
#line 2408 "../src/View/AbstractDirectoryView.vala"
	g_object_set ((GtkActionable*) _tmp9_, "action-target", _tmp10_, NULL);
#line 2408 "../src/View/AbstractDirectoryView.vala"
	_g_variant_unref0 (_tmp10_);
#line 2410 "../src/View/AbstractDirectoryView.vala"
	_tmp11_ = (GtkMenu*) gtk_menu_new ();
#line 2410 "../src/View/AbstractDirectoryView.vala"
	g_object_ref_sink (_tmp11_);
#line 2410 "../src/View/AbstractDirectoryView.vala"
	_tmp12_ = _tmp11_;
#line 2410 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_item_set_submenu ((GtkMenuItem*) self, _tmp12_);
#line 2410 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (_tmp12_);
#line 2411 "../src/View/AbstractDirectoryView.vala"
	_tmp13_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2411 "../src/View/AbstractDirectoryView.vala"
	_tmp14_ = _tmp13_;
#line 2411 "../src/View/AbstractDirectoryView.vala"
	_tmp15_ = folder_menuitem;
#line 2411 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp15_);
#line 2412 "../src/View/AbstractDirectoryView.vala"
	_tmp16_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2412 "../src/View/AbstractDirectoryView.vala"
	_tmp17_ = _tmp16_;
#line 2412 "../src/View/AbstractDirectoryView.vala"
	_tmp18_ = file_menuitem;
#line 2412 "../src/View/AbstractDirectoryView.vala"
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 2415 "../src/View/AbstractDirectoryView.vala"
	(files_abstract_directory_view_templates == NULL) ? NULL : (files_abstract_directory_view_templates = (_g_list_free__g_object_unref0_ (files_abstract_directory_view_templates), NULL));
#line 2415 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_templates = NULL;
#line 2416 "../src/View/AbstractDirectoryView.vala"
	_tmp19_ = g_get_user_special_dir (G_USER_DIRECTORY_TEMPLATES);
#line 2416 "../src/View/AbstractDirectoryView.vala"
	template_path = _tmp19_;
#line 2417 "../src/View/AbstractDirectoryView.vala"
	_tmp20_ = template_path;
#line 2417 "../src/View/AbstractDirectoryView.vala"
	if (_tmp20_ != NULL) {
#line 22454 "AbstractDirectoryView.c"
		GFile* template_folder = NULL;
		const gchar* _tmp21_;
		GFile* _tmp22_;
		GFile* _tmp23_;
		GList* _tmp24_;
#line 2418 "../src/View/AbstractDirectoryView.vala"
		_tmp21_ = template_path;
#line 2418 "../src/View/AbstractDirectoryView.vala"
		_tmp22_ = g_file_new_for_path (_tmp21_);
#line 2418 "../src/View/AbstractDirectoryView.vala"
		template_folder = _tmp22_;
#line 2419 "../src/View/AbstractDirectoryView.vala"
		_tmp23_ = template_folder;
#line 2419 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_load_templates_from_folder (_tmp23_);
#line 2421 "../src/View/AbstractDirectoryView.vala"
		_tmp24_ = files_abstract_directory_view_templates;
#line 2421 "../src/View/AbstractDirectoryView.vala"
		if (g_list_length (_tmp24_) > ((guint) 0)) {
#line 22474 "AbstractDirectoryView.c"
			GtkMenu* _tmp25_;
			GtkMenu* _tmp26_;
			GtkSeparatorMenuItem* _tmp27_;
			GtkSeparatorMenuItem* _tmp28_;
			GtkMenu* active_submenu = NULL;
			GtkMenu* _tmp29_;
			GtkMenu* _tmp30_;
			GtkMenu* _tmp31_;
			gint index = 0;
			GList* _tmp32_;
#line 2422 "../src/View/AbstractDirectoryView.vala"
			_tmp25_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2422 "../src/View/AbstractDirectoryView.vala"
			_tmp26_ = _tmp25_;
#line 2422 "../src/View/AbstractDirectoryView.vala"
			_tmp27_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 2422 "../src/View/AbstractDirectoryView.vala"
			g_object_ref_sink (_tmp27_);
#line 2422 "../src/View/AbstractDirectoryView.vala"
			_tmp28_ = _tmp27_;
#line 2422 "../src/View/AbstractDirectoryView.vala"
			gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp28_);
#line 2422 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (_tmp28_);
#line 2425 "../src/View/AbstractDirectoryView.vala"
			files_abstract_directory_view_templates = g_list_reverse (files_abstract_directory_view_templates);
#line 2427 "../src/View/AbstractDirectoryView.vala"
			_tmp29_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2427 "../src/View/AbstractDirectoryView.vala"
			_tmp30_ = _tmp29_;
#line 2427 "../src/View/AbstractDirectoryView.vala"
			_tmp31_ = _g_object_ref0 (_tmp30_);
#line 2427 "../src/View/AbstractDirectoryView.vala"
			active_submenu = _tmp31_;
#line 2428 "../src/View/AbstractDirectoryView.vala"
			index = 0;
#line 2429 "../src/View/AbstractDirectoryView.vala"
			_tmp32_ = files_abstract_directory_view_templates;
#line 22513 "AbstractDirectoryView.c"
			{
				GList* template_collection = NULL;
				GList* template_it = NULL;
#line 2429 "../src/View/AbstractDirectoryView.vala"
				template_collection = _tmp32_;
#line 2429 "../src/View/AbstractDirectoryView.vala"
				for (template_it = template_collection; template_it != NULL; template_it = template_it->next) {
#line 22521 "AbstractDirectoryView.c"
					GFile* template = NULL;
#line 2429 "../src/View/AbstractDirectoryView.vala"
					template = (GFile*) template_it->data;
#line 22525 "AbstractDirectoryView.c"
					{
						gchar* label = NULL;
						GFile* _tmp33_;
						gchar* _tmp34_;
						GFileType ftype = 0;
						GFile* _tmp35_;
						gint _tmp58_;
#line 2430 "../src/View/AbstractDirectoryView.vala"
						_tmp33_ = template;
#line 2430 "../src/View/AbstractDirectoryView.vala"
						_tmp34_ = g_file_get_basename (_tmp33_);
#line 2430 "../src/View/AbstractDirectoryView.vala"
						label = _tmp34_;
#line 2431 "../src/View/AbstractDirectoryView.vala"
						_tmp35_ = template;
#line 2431 "../src/View/AbstractDirectoryView.vala"
						ftype = g_file_query_file_type (_tmp35_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL);
#line 2432 "../src/View/AbstractDirectoryView.vala"
						if (ftype == G_FILE_TYPE_DIRECTORY) {
#line 22545 "AbstractDirectoryView.c"
							GFile* _tmp36_;
							GFile* _tmp37_;
#line 2433 "../src/View/AbstractDirectoryView.vala"
							_tmp36_ = template;
#line 2433 "../src/View/AbstractDirectoryView.vala"
							_tmp37_ = template_folder;
#line 2433 "../src/View/AbstractDirectoryView.vala"
							if (_tmp36_ == _tmp37_) {
#line 22554 "AbstractDirectoryView.c"
								GtkMenu* _tmp38_;
								GtkMenu* _tmp39_;
								GtkMenu* _tmp40_;
#line 2434 "../src/View/AbstractDirectoryView.vala"
								_tmp38_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2434 "../src/View/AbstractDirectoryView.vala"
								_tmp39_ = _tmp38_;
#line 2434 "../src/View/AbstractDirectoryView.vala"
								_tmp40_ = _g_object_ref0 (_tmp39_);
#line 2434 "../src/View/AbstractDirectoryView.vala"
								_g_object_unref0 (active_submenu);
#line 2434 "../src/View/AbstractDirectoryView.vala"
								active_submenu = _tmp40_;
#line 22568 "AbstractDirectoryView.c"
							} else {
								GtkMenu* _tmp41_;
								GtkMenuItem* submenu_item = NULL;
								const gchar* _tmp42_;
								GtkMenuItem* _tmp43_;
								GtkMenuItem* _tmp44_;
								GtkMenu* _tmp45_;
								GtkMenu* _tmp46_;
								GtkMenu* _tmp47_;
								GtkMenuItem* _tmp48_;
#line 2436 "../src/View/AbstractDirectoryView.vala"
								_tmp41_ = (GtkMenu*) gtk_menu_new ();
#line 2436 "../src/View/AbstractDirectoryView.vala"
								g_object_ref_sink (_tmp41_);
#line 2436 "../src/View/AbstractDirectoryView.vala"
								_g_object_unref0 (active_submenu);
#line 2436 "../src/View/AbstractDirectoryView.vala"
								active_submenu = _tmp41_;
#line 2438 "../src/View/AbstractDirectoryView.vala"
								_tmp42_ = label;
#line 2438 "../src/View/AbstractDirectoryView.vala"
								_tmp43_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp42_);
#line 2438 "../src/View/AbstractDirectoryView.vala"
								g_object_ref_sink (_tmp43_);
#line 2438 "../src/View/AbstractDirectoryView.vala"
								submenu_item = _tmp43_;
#line 2439 "../src/View/AbstractDirectoryView.vala"
								_tmp44_ = submenu_item;
#line 2439 "../src/View/AbstractDirectoryView.vala"
								_tmp45_ = active_submenu;
#line 2439 "../src/View/AbstractDirectoryView.vala"
								gtk_menu_item_set_submenu (_tmp44_, _tmp45_);
#line 2441 "../src/View/AbstractDirectoryView.vala"
								_tmp46_ = gtk_menu_item_get_submenu ((GtkMenuItem*) self);
#line 2441 "../src/View/AbstractDirectoryView.vala"
								_tmp47_ = _tmp46_;
#line 2441 "../src/View/AbstractDirectoryView.vala"
								_tmp48_ = submenu_item;
#line 2441 "../src/View/AbstractDirectoryView.vala"
								gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
#line 2433 "../src/View/AbstractDirectoryView.vala"
								_g_object_unref0 (submenu_item);
#line 22611 "AbstractDirectoryView.c"
							}
						} else {
							GtkMenuItem* template_menuitem = NULL;
							const gchar* _tmp49_;
							GtkMenuItem* _tmp50_;
							GtkMenuItem* _tmp51_;
							gchar* _tmp52_;
							gchar* _tmp53_;
							gchar* _tmp54_;
							gchar* _tmp55_;
							GtkMenu* _tmp56_;
							GtkMenuItem* _tmp57_;
#line 2444 "../src/View/AbstractDirectoryView.vala"
							_tmp49_ = label;
#line 2444 "../src/View/AbstractDirectoryView.vala"
							_tmp50_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp49_);
#line 2444 "../src/View/AbstractDirectoryView.vala"
							g_object_ref_sink (_tmp50_);
#line 2444 "../src/View/AbstractDirectoryView.vala"
							template_menuitem = _tmp50_;
#line 2445 "../src/View/AbstractDirectoryView.vala"
							_tmp51_ = template_menuitem;
#line 2445 "../src/View/AbstractDirectoryView.vala"
							_tmp52_ = g_strdup_printf ("%i", index);
#line 2445 "../src/View/AbstractDirectoryView.vala"
							_tmp53_ = _tmp52_;
#line 2445 "../src/View/AbstractDirectoryView.vala"
							_tmp54_ = g_strconcat ("background.create-from::", _tmp53_, NULL);
#line 2445 "../src/View/AbstractDirectoryView.vala"
							_tmp55_ = _tmp54_;
#line 2445 "../src/View/AbstractDirectoryView.vala"
							gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp51_, _tmp55_);
#line 2445 "../src/View/AbstractDirectoryView.vala"
							_g_free0 (_tmp55_);
#line 2445 "../src/View/AbstractDirectoryView.vala"
							_g_free0 (_tmp53_);
#line 2448 "../src/View/AbstractDirectoryView.vala"
							_tmp56_ = active_submenu;
#line 2448 "../src/View/AbstractDirectoryView.vala"
							_tmp57_ = template_menuitem;
#line 2448 "../src/View/AbstractDirectoryView.vala"
							gtk_container_add ((GtkContainer*) _tmp56_, (GtkWidget*) _tmp57_);
#line 2432 "../src/View/AbstractDirectoryView.vala"
							_g_object_unref0 (template_menuitem);
#line 22656 "AbstractDirectoryView.c"
						}
#line 2452 "../src/View/AbstractDirectoryView.vala"
						_tmp58_ = index;
#line 2452 "../src/View/AbstractDirectoryView.vala"
						index = _tmp58_ + 1;
#line 2429 "../src/View/AbstractDirectoryView.vala"
						_g_free0 (label);
#line 22664 "AbstractDirectoryView.c"
					}
				}
			}
#line 2421 "../src/View/AbstractDirectoryView.vala"
			_g_object_unref0 (active_submenu);
#line 22670 "AbstractDirectoryView.c"
		}
#line 2417 "../src/View/AbstractDirectoryView.vala"
		_g_object_unref0 (template_folder);
#line 22674 "AbstractDirectoryView.c"
	}
#line 2457 "../src/View/AbstractDirectoryView.vala"
	gtk_menu_item_set_label ((GtkMenuItem*) self, _ ("New"));
#line 2397 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (file_menuitem);
#line 2397 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (folder_menuitem);
#line 2397 "../src/View/AbstractDirectoryView.vala"
	return obj;
#line 22684 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_new_sub_menu_item_class_init (FilesAbstractDirectoryViewNewSubMenuItemClass * klass,
                                                            gpointer klass_data)
{
#line 2396 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_new_sub_menu_item_parent_class = g_type_class_peek_parent (klass);
#line 2396 "../src/View/AbstractDirectoryView.vala"
	G_OBJECT_CLASS (klass)->constructor = files_abstract_directory_view_new_sub_menu_item_constructor;
#line 22695 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_new_sub_menu_item_instance_init (FilesAbstractDirectoryViewNewSubMenuItem * self,
                                                               gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
files_abstract_directory_view_new_sub_menu_item_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesAbstractDirectoryViewNewSubMenuItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) files_abstract_directory_view_new_sub_menu_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesAbstractDirectoryViewNewSubMenuItem), 0, (GInstanceInitFunc) files_abstract_directory_view_new_sub_menu_item_instance_init, NULL };
	GType files_abstract_directory_view_new_sub_menu_item_type_id;
	files_abstract_directory_view_new_sub_menu_item_type_id = g_type_register_static (gtk_menu_item_get_type (), "FilesAbstractDirectoryViewNewSubMenuItem", &g_define_type_info, 0);
	return files_abstract_directory_view_new_sub_menu_item_type_id;
}

static GType
files_abstract_directory_view_new_sub_menu_item_get_type (void)
{
	static volatile gsize files_abstract_directory_view_new_sub_menu_item_type_id__once = 0;
	if (g_once_init_enter (&files_abstract_directory_view_new_sub_menu_item_type_id__once)) {
		GType files_abstract_directory_view_new_sub_menu_item_type_id;
		files_abstract_directory_view_new_sub_menu_item_type_id = files_abstract_directory_view_new_sub_menu_item_get_type_once ();
		g_once_init_leave (&files_abstract_directory_view_new_sub_menu_item_type_id__once, files_abstract_directory_view_new_sub_menu_item_type_id);
	}
	return files_abstract_directory_view_new_sub_menu_item_type_id__once;
}

static void
files_abstract_directory_view_class_init (FilesAbstractDirectoryViewClass * klass,
                                          gpointer klass_data)
{
	FilesDndHandler* _tmp0_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_parent_class = g_type_class_peek_parent (klass);
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_type_class_adjust_private_offset (klass, &FilesAbstractDirectoryView_private_offset);
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->set_up_name_renderer = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_set_up_name_renderer;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->on_row_deleted = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_on_row_deleted;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->on_view_key_press_event = (gboolean (*) (FilesAbstractDirectoryView*, GdkEventKey*)) files_abstract_directory_view_real_on_view_key_press_event;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->on_scroll_event = (gboolean (*) (FilesAbstractDirectoryView*, GdkEventScroll*)) files_abstract_directory_view_real_on_scroll_event;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->on_view_draw = (gboolean (*) (FilesAbstractDirectoryView*, cairo_t*)) files_abstract_directory_view_real_on_view_draw;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->handle_primary_button_click = (gboolean (*) (FilesAbstractDirectoryView*, GdkEventButton*, GtkTreePath*)) files_abstract_directory_view_real_handle_primary_button_click;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->handle_secondary_button_click = (gboolean (*) (FilesAbstractDirectoryView*, GdkEventButton*)) files_abstract_directory_view_real_handle_secondary_button_click;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->on_view_button_press_event = (gboolean (*) (FilesAbstractDirectoryView*, GdkEventButton*)) files_abstract_directory_view_real_on_view_button_press_event;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->on_view_button_release_event = (gboolean (*) (FilesAbstractDirectoryView*, GdkEventButton*)) files_abstract_directory_view_real_on_view_button_release_event;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->change_zoom_level = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_change_zoom_level;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->expand_collapse = (gboolean (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_expand_collapse;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->handle_default_button_click = (gboolean (*) (FilesAbstractDirectoryView*, GdkEventButton*)) files_abstract_directory_view_real_handle_default_button_click;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_next_visible_iter = (gboolean (*) (FilesAbstractDirectoryView*, GtkTreeIter*, gboolean)) files_abstract_directory_view_real_get_next_visible_iter;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->cancel = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_cancel;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->highlight_path = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_highlight_path;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->up = (GtkTreePath* (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_up;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->down = (GtkTreePath* (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_down;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_selected_paths = (GList* (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_get_selected_paths;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_path_at_pos = (GtkTreePath* (*) (FilesAbstractDirectoryView*, gint, gint)) files_abstract_directory_view_real_get_path_at_pos;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_path_at_cursor = (GtkTreePath* (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_get_path_at_cursor;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->tree_select_all = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_tree_select_all;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->tree_unselect_all = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_tree_unselect_all;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->tree_unselect_others = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_tree_unselect_others;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->select_path = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*, gboolean)) files_abstract_directory_view_real_select_path;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->unselect_path = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_unselect_path;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->path_is_selected = (gboolean (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_path_is_selected;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_visible_range = (gboolean (*) (FilesAbstractDirectoryView*, GtkTreePath**, GtkTreePath**)) files_abstract_directory_view_real_get_visible_range;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->set_cursor = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*, gboolean, gboolean, gboolean)) files_abstract_directory_view_real_set_cursor;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->move_cursor = (gboolean (*) (FilesAbstractDirectoryView*, guint, gboolean, gboolean)) files_abstract_directory_view_real_move_cursor;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->will_handle_button_press = (gboolean (*) (FilesAbstractDirectoryView*, gboolean, gboolean, gboolean)) files_abstract_directory_view_real_will_handle_button_press;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->handle_multi_select = (gboolean (*) (FilesAbstractDirectoryView*, GtkTreePath*)) files_abstract_directory_view_real_handle_multi_select;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->create_view = (GtkWidget* (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_create_view;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->set_up_zoom_level = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_set_up_zoom_level;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_normal_zoom_level = (FilesZoomLevel (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_get_normal_zoom_level;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->view_has_focus = (gboolean (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_view_has_focus;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_selected_files_from_model = (guint (*) (FilesAbstractDirectoryView*, GList**)) files_abstract_directory_view_real_get_selected_files_from_model;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->get_event_position_info = (guint (*) (FilesAbstractDirectoryView*, GdkEventButton*, GtkTreePath**, gboolean)) files_abstract_directory_view_real_get_event_position_info;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->scroll_to_cell = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*, gboolean)) files_abstract_directory_view_real_scroll_to_cell;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->set_cursor_on_cell = (void (*) (FilesAbstractDirectoryView*, GtkTreePath*, GtkCellRenderer*, gboolean, gboolean)) files_abstract_directory_view_real_set_cursor_on_cell;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->freeze_tree = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_freeze_tree;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->thaw_tree = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_thaw_tree;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->freeze_child_notify = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_freeze_child_notify;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->thaw_child_notify = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_thaw_child_notify;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->connect_tree_signals = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_connect_tree_signals;
#line 29 "../src/View/AbstractDirectoryView.vala"
	((FilesAbstractDirectoryViewClass *) klass)->disconnect_tree_signals = (void (*) (FilesAbstractDirectoryView*)) files_abstract_directory_view_real_disconnect_tree_signals;
#line 29 "../src/View/AbstractDirectoryView.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_files_abstract_directory_view_get_property;
#line 29 "../src/View/AbstractDirectoryView.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_files_abstract_directory_view_set_property;
#line 29 "../src/View/AbstractDirectoryView.vala"
	G_OBJECT_CLASS (klass)->finalize = files_abstract_directory_view_finalize;
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY] = g_param_spec_enum ("zoom-level", "zoom-level", "zoom-level", FILES_TYPE_ZOOM_LEVEL, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_ICON_SIZE_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_ICON_SIZE_PROPERTY] = g_param_spec_int ("icon-size", "icon-size", "icon-size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_SINGLECLICK_SELECT_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_SINGLECLICK_SELECT_PROPERTY] = g_param_spec_boolean ("singleclick-select", "singleclick-select", "singleclick-select", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY] = g_param_spec_boolean ("renaming", "renaming", "renaming", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY] = g_param_spec_boolean ("is-frozen", "is-frozen", "is-frozen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY] = g_param_spec_boolean ("in-recent", "in-recent", "in-recent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY] = g_param_spec_boolean ("tree-frozen", "tree-frozen", "tree-frozen", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_SHOW_REMOTE_THUMBNAILS_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_SHOW_REMOTE_THUMBNAILS_PROPERTY] = g_param_spec_boolean ("show-remote-thumbnails", "show-remote-thumbnails", "show-remote-thumbnails", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILES_ABSTRACT_DIRECTORY_VIEW_SHOW_LOCAL_THUMBNAILS_PROPERTY, files_abstract_directory_view_properties[FILES_ABSTRACT_DIRECTORY_VIEW_SHOW_LOCAL_THUMBNAILS_PROPERTY] = g_param_spec_boolean ("show-local-thumbnails", "show-local-thumbnails", "show-local-thumbnails", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 29 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_PATH_CHANGE_REQUEST_SIGNAL] = g_signal_new ("path-change-request", FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ENUM_BOOLEAN, G_TYPE_NONE, 3, g_file_get_type (), FILES_TYPE_OPEN_FLAG, G_TYPE_BOOLEAN);
#line 29 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_signals[FILES_ABSTRACT_DIRECTORY_VIEW_SELECTION_CHANGED_SIGNAL] = g_signal_new ("selection-changed", FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__POINTER, G_TYPE_NONE, 1, G_TYPE_POINTER);
#line 273 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = files_dnd_handler_new ();
#line 273 "../src/View/AbstractDirectoryView.vala"
	files_abstract_directory_view_dnd_handler = _tmp0_;
#line 22856 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_instance_init (FilesAbstractDirectoryView * self,
                                             gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/View/AbstractDirectoryView.vala"
	self->priv = files_abstract_directory_view_get_instance_private (self);
#line 99 "../src/View/AbstractDirectoryView.vala"
	self->priv->_zoom_level = FILES_ZOOM_LEVEL_NORMAL;
#line 124 "../src/View/AbstractDirectoryView.vala"
	self->minimum_zoom = FILES_ZOOM_LEVEL_SMALLEST;
#line 125 "../src/View/AbstractDirectoryView.vala"
	self->maximum_zoom = FILES_ZOOM_LEVEL_LARGEST;
#line 126 "../src/View/AbstractDirectoryView.vala"
	self->large_thumbnails = FALSE;
#line 129 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_x = (gdouble) 0;
#line 130 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_y = (gdouble) 0;
#line 132 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_timer_id = (guint) 0;
#line 133 "../src/View/AbstractDirectoryView.vala"
	self->source_drag_file_list = NULL;
#line 134 "../src/View/AbstractDirectoryView.vala"
	self->current_target_type = GDK_NONE;
#line 137 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_scroll_timer_id = (guint) 0;
#line 138 "../src/View/AbstractDirectoryView.vala"
	self->priv->drag_enter_timer_id = (guint) 0;
#line 139 "../src/View/AbstractDirectoryView.vala"
	self->priv->destination_data_ready = FALSE;
#line 140 "../src/View/AbstractDirectoryView.vala"
	self->priv->drop_occurred = FALSE;
#line 141 "../src/View/AbstractDirectoryView.vala"
	self->priv->drop_target_file = NULL;
#line 142 "../src/View/AbstractDirectoryView.vala"
	self->priv->destination_drop_file_list = NULL;
#line 143 "../src/View/AbstractDirectoryView.vala"
	self->priv->current_suggested_action = GDK_ACTION_DEFAULT;
#line 144 "../src/View/AbstractDirectoryView.vala"
	self->priv->current_actions = GDK_ACTION_DEFAULT;
#line 165 "../src/View/AbstractDirectoryView.vala"
	self->dnd_disabled = FALSE;
#line 169 "../src/View/AbstractDirectoryView.vala"
	self->priv->thumbnail_request = -1;
#line 170 "../src/View/AbstractDirectoryView.vala"
	self->priv->thumbnail_source_id = (guint) 0;
#line 171 "../src/View/AbstractDirectoryView.vala"
	self->priv->freeze_source_id = (guint) 0;
#line 172 "../src/View/AbstractDirectoryView.vala"
	self->priv->thumbnailer = NULL;
#line 175 "../src/View/AbstractDirectoryView.vala"
	self->priv->add_remove_file_timeout_id = (guint) 0;
#line 176 "../src/View/AbstractDirectoryView.vala"
	self->priv->signal_free_space_change = FALSE;
#line 179 "../src/View/AbstractDirectoryView.vala"
	self->name_renderer = NULL;
#line 180 "../src/View/AbstractDirectoryView.vala"
	_tmp0_ = g_strdup ("");
#line 180 "../src/View/AbstractDirectoryView.vala"
	self->original_name = _tmp0_;
#line 181 "../src/View/AbstractDirectoryView.vala"
	_tmp1_ = g_strdup ("");
#line 181 "../src/View/AbstractDirectoryView.vala"
	self->proposed_name = _tmp1_;
#line 184 "../src/View/AbstractDirectoryView.vala"
	self->priv->total_delta_y = 0.0;
#line 190 "../src/View/AbstractDirectoryView.vala"
	self->right_margin_unselects_all = FALSE;
#line 191 "../src/View/AbstractDirectoryView.vala"
	self->on_directory = FALSE;
#line 192 "../src/View/AbstractDirectoryView.vala"
	self->one_or_less = TRUE;
#line 193 "../src/View/AbstractDirectoryView.vala"
	self->should_activate = FALSE;
#line 194 "../src/View/AbstractDirectoryView.vala"
	self->should_scroll = TRUE;
#line 195 "../src/View/AbstractDirectoryView.vala"
	self->should_deselect = FALSE;
#line 197 "../src/View/AbstractDirectoryView.vala"
	self->should_select = FALSE;
#line 198 "../src/View/AbstractDirectoryView.vala"
	self->click_path = NULL;
#line 199 "../src/View/AbstractDirectoryView.vala"
	self->click_zone = (guint) FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON;
#line 200 "../src/View/AbstractDirectoryView.vala"
	self->previous_click_zone = (guint) FILES_ABSTRACT_DIRECTORY_VIEW_CLICK_ZONE_ICON;
#line 212 "../src/View/AbstractDirectoryView.vala"
	self->selected_files = NULL;
#line 213 "../src/View/AbstractDirectoryView.vala"
	self->priv->selected_files_invalid = TRUE;
#line 218 "../src/View/AbstractDirectoryView.vala"
	self->priv->hover_path = NULL;
#line 220 "../src/View/AbstractDirectoryView.vala"
	self->priv->_renaming = FALSE;
#line 222 "../src/View/AbstractDirectoryView.vala"
	self->priv->_is_frozen = FALSE;
#line 254 "../src/View/AbstractDirectoryView.vala"
	self->priv->_in_recent = FALSE;
#line 256 "../src/View/AbstractDirectoryView.vala"
	self->priv->_tree_frozen = FALSE;
#line 257 "../src/View/AbstractDirectoryView.vala"
	self->priv->in_trash = FALSE;
#line 258 "../src/View/AbstractDirectoryView.vala"
	self->priv->in_network_root = FALSE;
#line 259 "../src/View/AbstractDirectoryView.vala"
	self->is_writable = FALSE;
#line 262 "../src/View/AbstractDirectoryView.vala"
	self->priv->_show_remote_thumbnails = TRUE;
#line 263 "../src/View/AbstractDirectoryView.vala"
	self->priv->_show_local_thumbnails = FALSE;
#line 265 "../src/View/AbstractDirectoryView.vala"
	self->priv->all_selected = FALSE;
#line 433 "../src/View/AbstractDirectoryView.vala"
	self->priv->set_cursor_timeout_id = (guint) 0;
#line 452 "../src/View/AbstractDirectoryView.vala"
	self->priv->select_source_handler = (gulong) 0;
#line 2848 "../src/View/AbstractDirectoryView.vala"
	self->priv->draw_timeout_id = (guint) 0;
#line 22979 "AbstractDirectoryView.c"
}

static void
files_abstract_directory_view_finalize (GObject * obj)
{
	FilesAbstractDirectoryView * self;
#line 29 "../src/View/AbstractDirectoryView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, FilesAbstractDirectoryView);
#line 342 "../src/View/AbstractDirectoryView.vala"
	g_debug ("AbstractDirectoryView.vala:342: ADV destruct");
#line 95 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->common_actions);
#line 96 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->selection_actions);
#line 97 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->background_actions);
#line 133 "../src/View/AbstractDirectoryView.vala"
	(self->source_drag_file_list == NULL) ? NULL : (self->source_drag_file_list = (_g_list_free__g_object_unref0_ (self->source_drag_file_list), NULL));
#line 141 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->drop_target_file);
#line 142 "../src/View/AbstractDirectoryView.vala"
	(self->priv->destination_drop_file_list == NULL) ? NULL : (self->priv->destination_drop_file_list = (_g_list_free__g_object_unref0_ (self->priv->destination_drop_file_list), NULL));
#line 172 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->thumbnailer);
#line 179 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->name_renderer);
#line 180 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (self->original_name);
#line 181 "../src/View/AbstractDirectoryView.vala"
	_g_free0 (self->proposed_name);
#line 187 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->priv->deleted_path);
#line 198 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->click_path);
#line 203 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->editable_cursor);
#line 204 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->activatable_cursor);
#line 205 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->selectable_cursor);
#line 207 "../src/View/AbstractDirectoryView.vala"
	(self->priv->open_with_apps == NULL) ? NULL : (self->priv->open_with_apps = (_g_list_free__g_object_unref0_ (self->priv->open_with_apps), NULL));
#line 212 "../src/View/AbstractDirectoryView.vala"
	(self->selected_files == NULL) ? NULL : (self->selected_files = (_g_list_free__g_object_unref0_ (self->selected_files), NULL));
#line 217 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->default_app);
#line 218 "../src/View/AbstractDirectoryView.vala"
	__vala_GtkTreePath_free0 (self->priv->hover_path);
#line 267 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->priv->view);
#line 269 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->model);
#line 270 "../src/View/AbstractDirectoryView.vala"
	_g_object_unref0 (self->icon_renderer);
#line 29 "../src/View/AbstractDirectoryView.vala"
	G_OBJECT_CLASS (files_abstract_directory_view_parent_class)->finalize (obj);
#line 23036 "AbstractDirectoryView.c"
}

 G_GNUC_NO_INLINE static GType
files_abstract_directory_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FilesAbstractDirectoryViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) files_abstract_directory_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FilesAbstractDirectoryView), 0, (GInstanceInitFunc) files_abstract_directory_view_instance_init, NULL };
	GType files_abstract_directory_view_type_id;
	files_abstract_directory_view_type_id = g_type_register_static (gtk_scrolled_window_get_type (), "FilesAbstractDirectoryView", &g_define_type_info, G_TYPE_FLAG_ABSTRACT);
	FilesAbstractDirectoryView_private_offset = g_type_add_instance_private (files_abstract_directory_view_type_id, sizeof (FilesAbstractDirectoryViewPrivate));
	return files_abstract_directory_view_type_id;
}

GType
files_abstract_directory_view_get_type (void)
{
	static volatile gsize files_abstract_directory_view_type_id__once = 0;
	if (g_once_init_enter (&files_abstract_directory_view_type_id__once)) {
		GType files_abstract_directory_view_type_id;
		files_abstract_directory_view_type_id = files_abstract_directory_view_get_type_once ();
		g_once_init_leave (&files_abstract_directory_view_type_id__once, files_abstract_directory_view_type_id);
	}
	return files_abstract_directory_view_type_id__once;
}

static void
_vala_files_abstract_directory_view_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec)
{
	FilesAbstractDirectoryView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, FilesAbstractDirectoryView);
#line 29 "../src/View/AbstractDirectoryView.vala"
	switch (property_id) {
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_enum (value, files_abstract_directory_view_get_zoom_level (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_ICON_SIZE_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_int (value, files_abstract_directory_view_get_icon_size (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_SINGLECLICK_SELECT_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_boolean (value, files_abstract_directory_view_get_singleclick_select (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_boolean (value, files_abstract_directory_view_get_renaming (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_boolean (value, files_abstract_directory_view_get_is_frozen (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_boolean (value, files_abstract_directory_view_get_in_recent (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_boolean (value, files_abstract_directory_view_get_tree_frozen (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_SHOW_REMOTE_THUMBNAILS_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_boolean (value, files_abstract_directory_view_get_show_remote_thumbnails (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_SHOW_LOCAL_THUMBNAILS_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		g_value_set_boolean (value, files_abstract_directory_view_get_show_local_thumbnails (self));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 23125 "AbstractDirectoryView.c"
		default:
#line 29 "../src/View/AbstractDirectoryView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 23131 "AbstractDirectoryView.c"
	}
}

static void
_vala_files_abstract_directory_view_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec)
{
	FilesAbstractDirectoryView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FILES_TYPE_ABSTRACT_DIRECTORY_VIEW, FilesAbstractDirectoryView);
#line 29 "../src/View/AbstractDirectoryView.vala"
	switch (property_id) {
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_ZOOM_LEVEL_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_zoom_level (self, g_value_get_enum (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_SINGLECLICK_SELECT_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_singleclick_select (self, g_value_get_boolean (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_RENAMING_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_renaming (self, g_value_get_boolean (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_IS_FROZEN_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_is_frozen (self, g_value_get_boolean (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_IN_RECENT_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_in_recent (self, g_value_get_boolean (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_TREE_FROZEN_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_tree_frozen (self, g_value_get_boolean (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_SHOW_REMOTE_THUMBNAILS_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_show_remote_thumbnails (self, g_value_get_boolean (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 29 "../src/View/AbstractDirectoryView.vala"
		case FILES_ABSTRACT_DIRECTORY_VIEW_SHOW_LOCAL_THUMBNAILS_PROPERTY:
#line 29 "../src/View/AbstractDirectoryView.vala"
		files_abstract_directory_view_set_show_local_thumbnails (self, g_value_get_boolean (value));
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 23193 "AbstractDirectoryView.c"
		default:
#line 29 "../src/View/AbstractDirectoryView.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "../src/View/AbstractDirectoryView.vala"
		break;
#line 23199 "AbstractDirectoryView.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

